
#ifndef DHNETSDK_H
#define DHNETSDK_H


#if (defined(WIN32) || defined(WIN64))
#include <windows.h>
#ifdef NETSDK_EXPORTS

#ifndef CLIENT_API
#define CLIENT_API  __declspec(dllexport)
#endif

#else

#ifndef CLIENT_API
#define CLIENT_API  __declspec(dllimport)
#endif

#endif

#define CALLBACK __stdcall
#define CALL_METHOD  __stdcall  //__cdecl

#define INT64    __int64

#ifndef LLONG
#ifdef WIN64
#define LLONG INT64
#else 
#define LLONG LONG
#endif
#endif

#ifndef LDWORD
#ifdef WIN64
#define LDWORD INT64
#else 
#define LDWORD DWORD
#endif
#endif

#else    //non-windows

#define CLIENT_API    extern "C"
#define CALL_METHOD 
#define CALLBACK

#ifndef INTERNAL_COMPILE
#define RELEASE_HEADER //ͷļ
#endif
 
#ifdef RELEASE_HEADER

#define WORD        unsigned short
#define DWORD       unsigned int
#define LONG        int
#define LPDWORD     DWORD*
#ifdef __OBJC__
#include "objc/objc.h"
#else
#define BOOL        int
#endif
#ifndef TRUE
#define TRUE        1
#endif
#ifndef FALSE
#define FALSE       0
#endif
#define BYTE        unsigned char
#define UINT        unsigned int
#define HDC         void*
#define HWND        void*
#define LPVOID      void*
#ifndef NULL
#define NULL        0
#endif
#define LLONG       long
#define INT64       long long
#define LDWORD      long 

#ifndef MAX_PATH
#define MAX_PATH    260
#endif

#ifndef DEF_RECT
typedef struct  tagRECT
{
    LONG left;
    LONG top;
    LONG right;
    LONG bottom;
} RECT;
#define DEF_RECT
#endif

#else    //ڲ

#include "../Platform/osIndependent.h"
#endif // RELEASE_HEADER

#endif // linux

#ifndef LDWORD
#if (defined(WIN32) || defined(WIN64))
#ifdef WIN64
#define LDWORD __int64
#else //WIN32 
#define LDWORD DWORD
#endif
#else    //linux
#define LDWORD long 
#endif
#endif

#ifdef __cplusplus
extern "C" {
#endif

/************************************************************************
 ** 
 ***********************************************************************/
#define DH_SERIALNO_LEN                   48               // 豸кַ
#define DH_MAX_DISKNUM                    256              // Ӳ̸
#define DH_MAX_SDCARDNUM                  32               // SD
#define DH_MAX_BURNING_DEV_NUM            32               // ¼豸
#define DH_BURNING_DEV_NAMELEN            32               // ¼豸󳤶
#define DH_MAX_LINK                       6                
#define DH_MAX_CHANNUM                    16               // ͨ
#define DH_MAX_DECODER_CHANNUM            64               // ͨ
#define DH_MAX_ALARMIN                    128              // 󱨾
#define DH_MAX_ALARMOUT                   64               // 󱨾
#define DH_MAX_RIGHT_NUM                  100              // ûȨ޸
#define DH_MAX_GROUP_NUM                  20               // û
#define DH_MAX_USER_NUM                   200              // û
#define DH_RIGHT_NAME_LENGTH              32               // Ȩ
#define DH_USER_NAME_LENGTH               8                // û
#define DH_USER_PSW_LENGTH                8                // û볤
#define DH_MEMO_LENGTH                    32               // ע
#define DH_MAX_STRING_LEN                 128              
#define MAX_STRING_LINE_LEN               6                // 
#define MAX_PER_STRING_LEN                20               // ÿ󳤶
#define DH_MAX_MAIL_NAME_LEN              64               // µʼṹֵ֧û
#define DH_MAX_MAIL_PSW_LEN               64               // µʼṹֵ֧볤
#define DH_SPEEDLIMIT_TYPE_LEN            32               // ַ
#define DH_VEHICLE_TYPE_LEN               32               // ԶϢַ
#define DH_VEHICLE_INFO_LEN               32               // ԶϢַ
#define DH_VEHICLE_DRIVERNO_LEN           32               // ԶϢ˾ַ
#define DH_MAX_CROSSING_NUM               128              // λ
#define DH_MAX_CROSSING_ID                32               // ·к󳤶
#define DH_MAX_CARD_INFO_LEN              256              // Ϣ󳤶
#define DH_MAX_CHANNUM_EX                 32               // ͨչ  
#define DH_MAX_SAERCH_IP_NUM              256              // IP
#define DH_MAX_HARDDISK_TYPE_LEN          32               // Ӳͺ󳤶
#define DH_MAX_HARDDISK_SERIAL_LEN        32               // Ӳк󳤶
#define DH_MAX_SIM_LEN                    16               // SIMֵ󳤶
#define DH_MAX_SIM_NUM                    10               // SIM
#define DH_MAX_VERSION_LEN                32               // 汾󳤶
#define DH_MAX_MDN_LEN                    36               // MDNֵ󳤶
#define DH_MAX_NETINTERFACE_NUM           64               // ֵ֧
#define DH_EVENT_NAME_LEN                 128              // ¼Ƴ
#define DH_STORAGE_NAME_LEN               128              // 洢豸Ƴ
#define DH_MAX_CARPORTLIGHT_NUM           4                // λƸ
#define DH_STATION_NAME_LEN               32               // վվƳ   
#define PTZ_PRESET_NAME_LEN               64               // ̨ԤõƳ
#define DH_MAX_GUARD_DETECT_ID_COUNT	  64			   // ĸͤID
    
#define DH_MAX_VERSION_STR                64               // 汾ַ󳤶

#define DH_COMMON_STRING_16               16               // ַͨ16
#define DH_COMMON_STRING_32               32               // ַͨ32
#define DH_COMMON_STRING_64               64               // ַͨ64
#define DH_COMMON_STRING_128              128              // ַͨ128
#define DH_COMMON_STRING_256              256              // ַͨ256
#define DH_COMMON_STRING_512              512              // ַͨ512
#define DH_COMMON_STRING_1024             1024             // ַͨ1024

#define DH_MAX_ACCESS_NAME_LEN            64               // ŽƳ
#define DH_MAX_EXALARMCHANNEL_NAME_LEN    128              // չģ鱨ͨƳ
#define DH_MAX_ALARM_SUBSYSTEM_NUM        8                // 󱨾ϵͳ
#define DH_MAX_BELL_NUM                   4                // 󾯺Ÿ
#define DH_MAX_KEYBOARD_NUM               256              // 
#define MAX_GOURP_NUM                     128              //
// Զýṹس                 
#define DH_MAX_MAIL_ADDR_LEN              128              // ʼ()ַ󳤶
#define DH_MAX_MAIL_SUBJECT_LEN           64               // ʼ󳤶
#define DH_MAX_IPADDR_LEN                 16               // IPַַ
#define DH_MAX_IPADDR_LEN_EX              40               // չIPַַ, ֧IPV6#define DH_MACADDR_LEN                    40               // MACַַ
#define DH_MACADDR_LEN                    40               // MACַַ
#define DH_MAX_URL_LEN                    128              // URLַ
#define DH_MAX_DEV_ID_LEN                 48               // 󳤶
#define DH_MAX_HOST_NAMELEN               64               // ȣ
#define DH_MAX_HOST_PSWLEN                32               // 볤
#define DH_MAX_NAME_LEN                   16               // ַͨ
#define DH_MAX_ETHERNET_NUM               2                // ̫
#define DH_MAX_ETHERNET_NUM_EX            10               // չ̫
#define DH_DEV_SERIALNO_LEN               48               // кַ
#define DH_DEV_TYPE_LEN                   32               // 豸ַ
#define DH_N_WEEKS                        7                // һܵ    
#define DH_N_TSECT                        6                // ͨʱθ
#define DH_N_REC_TSECT                    6                // ¼ʱθ
#define DH_N_COL_TSECT                    2                // ɫʱθ    
#define DH_CHAN_NAME_LEN                  32               // ͨȣDVR DSPƣ32ֽ        
#define DH_N_ENCODE_AUX                   3                // չ    
#define DH_N_TALK                         1                // Խͨ
#define DH_N_COVERS                       1                // ڵ    
#define DH_N_CHANNEL                      16               // ͨ    
#define DH_N_ALARM_TSECT                  2                // ʾʱθ
#define DH_MAX_ALARMOUT_NUM               16               // ڸ
#define DH_MAX_AUDIO_IN_NUM               16               // Ƶڸ
#define DH_MAX_VIDEO_IN_NUM               16               // Ƶڸ
#define DH_MAX_ALARM_IN_NUM               16               // ڸ
#define DH_MAX_DISK_NUM                   16               // Ӳ̸ޣݶΪ16
#define DH_MAX_DECODER_NUM                16               // (485)    
#define DH_MAX_232FUNCS                   10               // 232ڹܸ
#define DH_MAX_232_NUM                    2                // 232ڸ
#define DH_MAX_232_NUM_EX                 16               // չø          
#define DH_MAX_DECPRO_LIST_SIZE           100              // Эб
#define DH_FTP_MAXDIRLEN                  240              // FTPļĿ¼󳤶
#define DH_MATRIX_MAXOUT                  16               // 
#define DH_TOUR_GROUP_NUM                 6                // 
#define DH_MAX_DDNS_NUM                   10               // 豸ֵ֧ddns
#define DH_MAX_SERVER_TYPE_LEN            32               // ddnsַͣ
#define DH_MAX_DOMAIN_NAME_LEN            256              // ddnsַ
#define DH_MAX_DDNS_ALIAS_LEN             32               // ddnsַ
#define DH_MAX_DEFAULT_DOMAIN_LEN         60               // ddnsĬַ     
#define DH_MOTION_ROW                     32               // ̬
#define DH_MOTION_COL                     32               // ̬
#define DH_STATIC_ROW                     32               // ̬
#define DH_STATIC_COL                     32               // ̬
#define DH_FTP_USERNAME_LEN               64               // FTPãû󳤶
#define DH_FTP_PASSWORD_LEN               64               // FTPã󳤶
#define DH_TIME_SECTION                   2                // FTPãÿʱθ
#define DH_FTP_MAX_PATH                   240              // FTPãļ·󳤶
#define DH_FTP_MAX_SUB_PATH               128              // FTPãļ·󳤶
#define DH_INTERVIDEO_UCOM_CHANID         32               // ƽ̨ãUͨͨID
#define DH_INTERVIDEO_UCOM_DEVID          32               // ƽ̨ãUͨ豸ID
#define DH_INTERVIDEO_UCOM_REGPSW         16               // ƽ̨ãUͨע
#define DH_INTERVIDEO_UCOM_USERNAME       32               // ƽ̨ãUͨû
#define DH_INTERVIDEO_UCOM_USERPSW        32               // ƽ̨ãUͨ
#define DH_INTERVIDEO_NSS_IP              32               // ƽ̨ãάIP
#define DH_INTERVIDEO_NSS_SERIAL          32               // ƽ̨ãάserial
#define DH_INTERVIDEO_NSS_USER            32               // ƽ̨ãάuser
#define DH_INTERVIDEO_NSS_PWD             50               // ƽ̨ãάpassword
#define DH_MAX_VIDEO_COVER_NUM            16               // ڵ
#define DH_MAX_WATERMAKE_DATA             4096             // ˮӡͼƬ󳤶
#define DH_MAX_WATERMAKE_LETTER           128              // ˮӡ󳤶
#define DH_MAX_WLANDEVICE_NUM             10               // 豸
#define DH_MAX_WLANDEVICE_NUM_EX          32               // 豸
#define DH_MAX_ALARM_NAME                 64               // ַ
#define DH_MAX_REGISTER_SERVER_NUM        10               // ע
#define DH_SNIFFER_FRAMEID_NUM            6                // 6FRAME ID ѡ
#define DH_SNIFFER_CONTENT_NUM            4                // ÿFRAMEӦ4ץ
#define DH_SNIFFER_CONTENT_NUM_EX         8                // ÿFRAMEӦ8ץ
#define DH_SNIFFER_PROTOCOL_SIZE          20               // Эֳ
#define DH_MAX_PROTOCOL_NAME_LENGTH       20               
#define DH_SNIFFER_GROUP_NUM              4                // 4ץ
#define MAX_PATH_STOR                     240              // ԶĿ¼ĳ
#define DH_ALARM_OCCUR_TIME_LEN           40               // µıϴʱĳ
#define DH_VIDEO_OSD_NAME_NUM             64               // ӵƳȣĿǰ֧32Ӣģ16
#define DH_VIDEO_CUSTOM_OSD_NUM           8                // ֵ֧ԶӵĿʱͨ
#define DH_CONTROL_AUTO_REGISTER_NUM      100              // ֶ֧עĸ
#define DH_MMS_RECEIVER_NUM               100              // ֶ֧Žߵĸ
#define DH_MMS_SMSACTIVATION_NUM          100              // ֶ֧ŷߵĸ
#define DH_MMS_DIALINACTIVATION_NUM       100              // ֲ֧ŷߵĸ
#define DH_MAX_ALARMOUT_NUM_EX            32               // ڸչ
#define DH_MAX_VIDEO_IN_NUM_EX            32               // Ƶڸչ
#define DH_MAX_ALARM_IN_NUM_EX            32               // ڸ
#define DH_MAX_IPADDR_OR_DOMAIN_LEN       64               // IPַַ
#define DH_MAX_CALLID                     32               // ID
#define DH_MAX_OBJECT_LIST                16               // ܷ豸⵽ID    
#define DH_MAX_RULE_LIST                  16               // ܷ豸
#define DH_MAX_POLYGON_NUM                16               // 󶥵
#define DH_MAX_DETECT_LINE_NUM            20               // 󶥵
#define DH_MAX_DETECT_REGION_NUM          20               // 󶥵
#define DH_MAX_TRACK_LINE_NUM             20               // ˶켣󶥵
#define DH_MAX_CANDIDATE_NUM              50               // ʶƥ
#define DH_MAX_PERSON_IMAGE_NUM           48               // ÿԱӦͼƬ
#define DH_MAX_FENCE_LINE_NUM             2                // Χ
#define MAX_SMART_VALUE_NUM               30               // smartϢ
#define DH_MACHINE_NAME_NUM               64               // Ƴ
#define DH_INTERVIDEO_AMP_DEVICESERIAL    48               // ƽ̨ã 豸кַ
#define DH_INTERVIDEO_AMP_DEVICENAME      16               // ƽ̨ã 豸ַ
#define DH_INTERVIDEO_AMP_USER            32               // ƽ̨ã עûַ
#define DH_INTERVIDEO_AMP_PWD             32               // ƽ̨ã עַ
#define MAX_SUBMODULE_NUM                 32               // ģϢ
#define DH_MAX_CARWAY_NUM                 8                // ͨץģ󳵵
#define DH_MAX_SNAP_SIGNAL_NUM            3                // һץ
#define DH_MAX_CARD_NUM                   128              // ŵ
#define DH_MAX_CARDINFO_LEN               32               // ÿַ
#define DH_MAX_CONTROLER_NUM              64               // ֿ֧Ŀ
#define DH_MAX_LIGHT_NUM                  32               // Ƶ
#define DH_MAX_SNMP_COMMON_LEN            64               // snmp дݳ
#define DH_MAX_DDNS_STATE_LEN             128              // DDNS ״̬Ϣ
#define DH_MAX_PHONE_NO_LEN               16               // 绰볤
#define DH_MAX_MSGTYPE_LEN                32               // ͻϢͳ
#define DH_MAX_MSG_LEN                    256              // ͶϢ
#define DH_MAX_DRIVINGDIRECTION           256              // ʻַ
#define DH_MAX_GRAB_INTERVAL_NUM          4                // ͼƬץĸ
#define DH_MAX_FLASH_NUM                  5                // ֧Ƹ
#define DH_MAX_LANE_NUM                   8                // Ƶ豸ÿͨӦ
#define DH_MAX_ISCSI_PATH_NUM             64               // ISCSIԶĿ¼
#define DH_MAX_WIRELESS_CHN_NUM           256              // ·ŵ
#define DH_PROTOCOL3_BASE                 100              // Э汾
#define DH_PROTOCOL3_SUPPORT              11               // ֻ֧3Э
#define DH_MAX_CHANMASK                   64               // ֵͨ
#define DH_MAX_STAFF_NUM                  20               // ŨƵϢб
#define DH_MAX_CALIBRATEBOX_NUM           10               // ŨƵϢб궨
#define DH_MAX_EXCLUDEREGION_NUM          10               // ŨƵϢų
#define DH_MAX_POLYLINE_NUM               20               // ŨƵϢб
#define DH_MAX_COLOR_NUM                  16               // ɫĿ
#define MAX_OBJFILTER_NUM                 16               // 
#define DH_MAX_SYNOPSIS_STATE_NAME        64               // ƵŨ״ַ̬
#define DH_MAX_SYNOPSIS_QUERY_FILE_COUNT  10               // ƵŨԭʼļ·ʱļ
#define DH_MAX_SSID_LEN                   36               // SSID
#define DH_MAX_APPIN_LEN                  16               // PIN볤
#define DH_NETINTERFACE_NAME_LEN          260              // Ƴ
#define DH_NETINTERFACE_TYPE_LEN          260              // ͳ
#define DH_MAX_CONNECT_STATUS_LEN         260              // ״ַ̬
#define DH_MAX_MODE_LEN                   64               // 3Gֵ֧ģʽ
#define DH_MAX_MODE_NUM                   64               // 3Gֵ֧ģʽ
#define DH_MAX_COMPRESSION_TYPES_NUM      16               // Ƶʽ
#define DH_MAX_CAPTURE_SIZE_NUM           64               // Ƶֱʸ
#define DH_NODE_NAME_LEN                  64               // ֯ṹڵƳ
#define MAX_CALIBPOINTS_NUM               256              // ֧궨
#define DH_MAX_ATTR_NUM                   32               // ʾԪ
#define DH_MAX_CLOUDCONNECT_STATE_LEN     128              // ע״̬Ϣ
#define DH_MAX_IPADDR_EX_LEN              128              // չIPַ󳤶
#define DH_MAX_PLATE_NUMBER_LEN           32               // ַ   
#define DH_MAX_AUTHORITY_LIST_NUM         16               // Ȩб   
#define DH_MAX_CITY_NAME_LEN              64               // 󳤶
#define DH_MAX_PROVINCE_NAME_LEN          64               // ʡ󳤶
#define DH_MAX_PERSON_ID_LEN              32               // Աid󳤶
#define MAX_FACE_AREA_NUM                 8                //  
#define MAX_FACE_DB_NUM                   8                // ݿ
#define MAX_EVENT_NAME                    128              // ¼
#define DH_MAX_ETH_NAME                   64               // 
#define DH_MAX_PERSON_NAME_LEN            64               // Ա󳤶
#define DH_N_SCHEDULE_TSECT               8                // ʱԪظ    
#define DH_MAX_URL_NUM                    8                // URL
#define DH_MAX_LOWER_MITRIX_NUM           16               // λ
#define DH_MAX_BURN_CHANNEL_NUM           32               // ¼ͨ
#define DH_MAX_NET_STRORAGE_BLOCK_NUM     64               // Զ̴洢
#define DH_MAX_CASE_PERSON_NUM            32               // Ա
#define DH_MAX_MULTIPLAYBACK_CHANNEL_NUM  64               // ͨԤطͨ
#define DH_MAX_MULTIPLAYBACK_SPLIT_NUM    32               // ͨԤطŷָģʽ
#define DH_MAX_AUDIO_ENCODE_TYPE          64               // ͸
#define MAX_LOG_PATH_LEN                  260              // ־·󳤶
#define MAX_CARD_RECORD_FIELD_NUM         16               // ¼
#define DH_BATTERY_NUM_MAX                16               //     
#define DH_POWER_NUM_MAX                  16               // Դ        
#define DH_MAX_AUDIO_PATH                 260              // Ƶļ·
#define DH_MAX_DOORNAME_LEN               128              // ŽƳ    
#define DH_MAX_CARDPWD_LEN                64               // ŽƳ    
#define NET_MAX_FISHEYE_MOUNTMODE_NUM     4                // ۰װģʽ
#define NET_MAX_FISHEYE_CALIBRATEMODE_NUM 16               // ۽ģʽ
#define NET_MAX_FISHEYE_EPTZCMD_NUM       64               // ۵̨   
#define POINT_NUM_IN_PAIR                 2                // 궨еĵ
#define MAX_POINT_PAIR_NUM                128              // 궨
#define CHANNEL_NUM_IN_POINT_GROUP        2                // 궨еƵͨ
#define MAX_POINT_GROUP_NUM               32               // 궨, ÿͨƴҪһ궨
#define MAX_LANE_INFO_NUM                 32               // 󳵵Ϣ
#define MAX_LANE_DIRECTION_NUM            8                // 
#define DH_MAX_MONITORWALL_NUM            32               // ǽ
#define DH_MAX_OPTIONAL_URL_NUM           8                // url


// ѯͣӦCLIENT_QueryDevStateӿ
#define DH_DEVSTATE_COMM_ALARM            0x0001           // ѯͨ״̬(ⲿƵʧ̬)
#define DH_DEVSTATE_SHELTER_ALARM         0x0002           // ѯڵ״̬
#define DH_DEVSTATE_RECORDING             0x0003           // ѯ¼״̬
#define DH_DEVSTATE_DISK                  0x0004           // ѯӲϢ
#define DH_DEVSTATE_RESOURCE              0x0005           // ѯϵͳԴ״̬
#define DH_DEVSTATE_BITRATE               0x0006           // ѯͨ
#define DH_DEVSTATE_CONN                  0x0007           // ѯ豸״̬
#define DH_DEVSTATE_PROTOCAL_VER          0x0008           // ѯЭ汾ţpBuf = int*
#define DH_DEVSTATE_TALK_ECTYPE           0x0009           // ѯ豸ֵ֧ԽʽбṹDHDEV_TALKFORMAT_LIST
#define DH_DEVSTATE_SD_CARD               0x000A           // ѯSDϢ(IPCƷ)
#define DH_DEVSTATE_BURNING_DEV           0x000B           // ѯ¼Ϣ
#define DH_DEVSTATE_BURNING_PROGRESS      0x000C           // ѯ¼
#define DH_DEVSTATE_PLATFORM              0x000D           // ѯ豸ֵ֧Ľƽ̨
#define DH_DEVSTATE_CAMERA                0x000E           // ѯͷϢ(IPCƷ)pBuf = DHDEV_CAMERA_INFO *жṹ
#define DH_DEVSTATE_SOFTWARE              0x000F           // ѯ豸汾Ϣ
#define DH_DEVSTATE_LANGUAGE              0x0010           // ѯ豸ֵ֧
#define DH_DEVSTATE_DSP                   0x0011           // ѯDSP(ӦṹDHDEV_DSP_ENCODECAP)
#define DH_DEVSTATE_OEM                   0x0012           // ѯOEMϢ
#define DH_DEVSTATE_NET                   0x0013           // ѯ״̬Ϣ
#define DH_DEVSTATE_TYPE                  0x0014           // ѯ豸
#define DH_DEVSTATE_SNAP                  0x0015           // ѯ(IPCƷ)
#define DH_DEVSTATE_RECORD_TIME           0x0016           // ѯ¼ʱ¼ʱ
#define DH_DEVSTATE_NET_RSSI              0x0017           // ѯźǿȣṹDHDEV_WIRELESS_RSS_INFO
#define DH_DEVSTATE_BURNING_ATTACH        0x0018           // ѯ¼ѡ
#define DH_DEVSTATE_BACKUP_DEV            0x0019           // ѯ豸б
#define DH_DEVSTATE_BACKUP_DEV_INFO       0x001a           // ѯ豸ϸϢ
#define DH_DEVSTATE_BACKUP_FEEDBACK       0x001b           // ݽȷ
#define DH_DEVSTATE_ATM_QUERY_TRADE       0x001c           // ѯATM
#define DH_DEVSTATE_SIP                   0x001d           // ѯsip״̬
#define DH_DEVSTATE_VICHILE_STATE         0x001e           // ѯwifi״̬
#define DH_DEVSTATE_TEST_EMAIL            0x001f           // ѯʼǷɹ
#define DH_DEVSTATE_SMART_HARD_DISK       0x0020           // ѯӲsmartϢ
#define DH_DEVSTATE_TEST_SNAPPICTURE      0x0021           // ѯץͼǷɹ
#define DH_DEVSTATE_STATIC_ALARM          0x0022           // ѯ̬״̬
#define DH_DEVSTATE_SUBMODULE_INFO        0x0023           // ѯ豸ģϢ
#define DH_DEVSTATE_DISKDAMAGE            0x0024           // ѯӲ̻ 
#define DH_DEVSTATE_IPC                   0x0025           // ѯ豸ֵ֧IPC, ṹDH_DEV_IPC_INFO
#define DH_DEVSTATE_ALARM_ARM_DISARM      0x0026           // ѯ״̬
#define DH_DEVSTATE_ACC_POWEROFF_ALARM    0x0027           // ѯACCϵ籨״̬(һDWORD, 1ʾϵ磬0ʾͨ)
#define DH_DEVSTATE_TEST_FTP_SERVER       0x0028           // FTP
#define DH_DEVSTATE_3GFLOW_EXCEED         0x0029           // ѯ3Gֵ״̬,(ṹDHDEV_3GFLOW_EXCEED_STATE_INFO)
#define DH_DEVSTATE_3GFLOW_INFO           0x002a           // ѯ3GϢ,ṹDH_DEV_3GFLOW_INFO
#define DH_DEVSTATE_VIHICLE_INFO_UPLOAD   0x002b           // ԶϢϴ(ṹALARM_VEHICLE_INFO_UPLOAD)
#define DH_DEVSTATE_SPEED_LIMIT           0x002c           // ѯٱ״̬(ṹALARM_SPEED_LIMIT)
#define DH_DEVSTATE_DSP_EX                0x002d           // ѯDSPչ(ӦṹDHDEV_DSP_ENCODECAP_EX)
#define DH_DEVSTATE_3GMODULE_INFO         0x002e           // ѯ3GģϢ(ӦṹDH_DEV_3GMODULE_INFO)
#define DH_DEVSTATE_MULTI_DDNS            0x002f           // ѯDDNS״̬Ϣ(ӦṹDH_DEV_MULTI_DDNS_INFO)
#define DH_DEVSTATE_CONFIG_URL            0x0030           // ѯ豸URLϢ(ӦṹDH_DEV_URL_INFO)
#define DH_DEVSTATE_HARDKEY               0x0031           // ѯHardKey״̬ӦṹDHDEV_HARDKEY_STATE)
#define DH_DEVSTATE_ISCSI_PATH            0x0032           // ѯISCSI·б(ӦṹDHDEV_ISCSI_PATHLIST)
#define DH_DEVSTATE_DLPREVIEW_SLIPT_CAP   0x0033           // ѯ豸Ԥֵ֧ķָģʽ(ӦṹDEVICE_LOCALPREVIEW_SLIPT_CAP)
#define DH_DEVSTATE_WIFI_ROUTE_CAP        0x0034           // ѯ·Ϣ(ӦṹDHDEV_WIFI_ROUTE_CAP)
#define DH_DEVSTATE_ONLINE                0x0035           // ѯ豸״̬(һDWORD, 1ʾ, 0ʾ)
#define DH_DEVSTATE_PTZ_LOCATION          0x0036           // ѯ̨״̬Ϣ(ӦṹDH_PTZ_LOCATION_INFO)
#define DH_DEVSTATE_MONITOR_INFO          0x0037           // ظϢ(ӦṹDHDEV_MONITOR_INFO)
#define DH_DEVSTATE_SUBDEVICE             0x0300           // ѯ豸(Դ, ȵ)״̬(ӦṹCFG_DEVICESTATUS_INFO)
#define DH_DEVSTATE_RAID_INFO             0x0038           // ѯRAID״̬(ӦṹALARM_RAID_INFO)  
#define DH_DEVSTATE_TEST_DDNSDOMAIN       0x0039           // DDNSǷ
#define DH_DEVSTATE_VIRTUALCAMERA         0x003a           // ѯͷ״̬(ӦDHDEV_VIRTUALCAMERA_STATE_INFO)
#define DH_DEVSTATE_TRAFFICWORKSTATE      0x003b           // ȡ豸Ƶ/Ȧģʽ״̬(ӦDHDEV_TRAFFICWORKSTATE_INFO)
#define DH_DEVSTATE_ALARM_CAMERA_MOVE     0x003c           // ȡλ¼״̬(ӦALARM_CAMERA_MOVE_INFO)
#define DH_DEVSTATE_ALARM                 0x003e           // ȡⲿ״̬(Ӧ NET_CLIENT_ALARM_STATE) 
#define DH_DEVSTATE_VIDEOLOST             0x003f           // ȡƵʧ״̬(Ӧ NET_CLIENT_VIDEOLOST_STATE) 
#define DH_DEVSTATE_MOTIONDETECT          0x0040           // ȡ̬ⱨ״̬(Ӧ NET_CLIENT_MOTIONDETECT_STATE)
#define DH_DEVSTATE_DETAILEDMOTION        0x0041           // ȡϸĶ̬ⱨ״̬(Ӧ NET_CLIENT_DETAILEDMOTION_STATE)
#define DH_DEVSTATE_VEHICLE_INFO          0x0042           // ȡӲϢ(Ӧ DHDEV_VEHICLE_INFO)
#define DH_DEVSTATE_VIDEOBLIND            0x0043           // ȡƵڵ״̬(Ӧ NET_CLIENT_VIDEOBLIND_STATE)
#define DH_DEVSTATE_3GSTATE_INFO          0x0044           // ѯ3GģϢ(ӦṹDHDEV_VEHICLE_3GMODULE)
#define DH_DEVSTATE_NETINTERFACE          0x0045           // ѯӿϢ(Ӧ DHDEV_NETINTERFACE_INFO)
#define DH_DEVSTATE_PICINPIC_CHN          0x0046           // ѯлͨ(ӦDWORD)
#define DH_DEVSTATE_COMPOSITE_CHN         0x0047           // ѯںͨϢ(ӦDH_COMPOSITE_CHANNEL)
#define DH_DEVSTATE_WHOLE_RECORDING       0x0048           // ѯ豸¼״̬(ӦBOOL), ֻҪһͨ¼񣬼Ϊ豸״̬Ϊ¼
#define DH_DEVSTATE_WHOLE_ENCODING        0x0049           // ѯ豸״̬(ӦBOOL), ֻҪһͨڱ룬Ϊ豸״̬Ϊ
#define DH_DEVSTATE_DISK_RECORDE_TIME     0x004a           // ѯ豸Ӳ¼ʱϢ(pBuf = DEV_DISK_RECORD_TIME*жṹ)
#define DH_DEVSTATE_BURNER_DOOR           0x004b           // Ƿѵ¼(Ӧṹ NET_DEVSTATE_BURNERDOOR)
#define DH_DEVSTATE_GET_DATA_CHECK        0x004c           // ѯУ(Ӧ NET_DEVSTATE_DATA_CHECK)
#define DH_DEVSTATE_ALARM_IN_CHANNEL      0x004f           // ѯͨϢ(ӦNET_ALARM_IN_CHANNEL)
#define DH_DEVSTATE_ALARM_CHN_COUNT       0x0050           // ѯͨ(ӦNET_ALARM_CHANNEL_COUNT)
#define DH_DEVSTATE_PTZ_VIEW_RANGE        0x0051           // ѯ̨״̬(ӦDH_OUT_PTZ_VIEW_RANGE_STATUS)
#define DH_DEVSTATE_DEV_CHN_COUNT         0x0052           // ѯ豸ͨϢ(ӦNET_DEV_CHN_COUNT_INFO)
#define DH_DEVSTATE_RTSP_URL              0x0053           // ѯ豸ֵ֧RTSP URLбṹDEV_RTSPURL_LIST
#define DH_DEVSTATE_LIMIT_LOGIN_TIME      0x0054           // ѯ豸¼߳ʱʱ,һBTYE,λӣ ,0ʾ,ʾƵķ
#define DH_DEVSTATE_GET_COMM_COUNT        0x0055           // ȡ ṹNET_GET_COMM_COUNT
#define DH_DEVSTATE_RECORDING_DETAIL      0x0056           // ѯ¼״̬ϸϢ(pBuf = NET_RECORD_STATE_DETAIL*)
#define DH_DEVSTATE_PTZ_PRESET_LIST       0x0057           // ȡǰ̨Ԥõб(ӦṹNET_PTZ_PRESET_LIST)
#define DH_DEVSTATE_EXTERNAL_DEVICE       0x0058           // 豸Ϣ(pBuf = NET_EXTERNAL_DEVICE*)
#define DH_DEVSTATE_GET_UPGRADE_STATE     0x0059           // ȡ豸״̬(ӦṹDHDEV_UPGRADE_STATE_INFO)
#define DH_DEVSTATE_MULTIPLAYBACK_SPLIT_CAP 0x005a         // ȡͨԤָ( Ӧṹ NET_MULTIPLAYBACK_SPLIT_CAP )
#define DH_DEVSTATE_BURN_SESSION_NUM      0x005b           // ȡ¼Ự(pBuf = int*)
#define DH_DEVSTATE_PROTECTIVE_CAPSULE    0X005c           // ѯ״̬(ӦṹALARM_PROTECTIVE_CAPSULE_INFO)


#define DH_DEVSTATE_POWER_STATE           0x0152           // ѯԴ״̬(ӦṹDH_POWER_STATUS)
#define DH_DEVSTATE_ALL_ALARM_CHANNELS_STATE  0x153        // ѯͨ״̬(Ӧṹ NET_CLIENT_ALARM_CHANNELS_STATE)
#define DH_DEVSTATE_ALARMKEYBOARD_COUNT   0x0154           // ѯӵı(ӦṹNET_ALARMKEYBOARD_COUNT)
#define DH_DEVSTATE_EXALARMCHANNELS       0x0155           // ѯչģͨӳϵ(Ӧṹ NET_EXALARMCHANNELS)
#define DH_DEVSTATE_GET_BYPASS            0x0156           // ѯͨ·״̬(Ӧṹ NET_DEVSTATE_GET_BYPASS)
#define DH_DEVSTATE_ACTIVATEDDEFENCEAREA  0x0157           // ȡķϢ(Ӧṹ NET_ACTIVATEDDEFENCEAREA)
#define DH_DEVSTATE_DEV_RECORDSET         0x0158           // ѯ豸¼Ϣ(ӦNET_CTRL_RECORDSET_PARAM)
#define DH_DEVSTATE_DOOR_STATE            0x0159           // ѯŽ״̬(ӦNET_DOOR_STATUS_INFO)
#define DH_DEVSTATE_ANALOGALARM_CHANNELS  0x1560           // ģͨӳϵ(ӦNET_ANALOGALARM_CHANNELS)
#define DH_DEVSTATE_GET_SENSORLIST        0x1561           // ȡ豸ֵ֧Ĵб(Ӧ NET_SENSOR_LIST)
#define DH_DEVSTATE_ALARM_CHANNELS        0x1562           // ѯģͨӳϵ(Ӧṹ NET_ALARM_CHANNELS)
                                                           // 豸ֲ֧ѯչģͨ,øùܲѯչͨ߼ͨţرͨʹ
#define DH_DEVSTATE_GET_ALARM_SUBSYSTEM_ACTIVATESTATUS	0x1563	// ȡǰϵͳ״̬( Ӧ NET_GET_ALARM_SUBSYSTEM_ACTIVATE_STATUES)
#define DH_DEVSTATE_AIRCONDITION_STATE    0x1564           // ȡյ״̬(Ӧ NET_GET_AIRCONDITION_STATE)
#define DH_DEVSTATE_ALARMSUBSYSTEM_STATE  0x1565           // ȡϵͳ״̬(ӦNET_ALARM_SUBSYSTEM_STATE)
#define DH_DEVSTATE_ALARM_FAULT_STATE     0x1566           // ȡ״̬(Ӧ NET_ALARM_FAULT_STATE_INFO)
#define DH_DEVSTATE_DEFENCE_STATE         0x1567           // ȡ״̬(Ӧ NET_DEFENCE_STATE_INFO, ·״̬仯¼ر¼źԴ¼״̬𣬲ܻã豸ʹ)
#define DH_DEVSTATE_CLUSTER_STATE         0x1568           // ȡȺ״̬(Ӧ NET_CLUSTER_STATE_INFO)
#define DH_DEVSTATE_SCADA_POINT_LIST      0x1569           // ȡλ·Ϣ(Ӧ NET_SCADA_POINT_LIST_INFO)
#define DH_DEVSTATE_SCADA_INFO            0x156a           // ȡλϢ(Ӧ NET_SCADA_INFO)
#define DH_DEVSTATE_SCADA_CAPS            0X156b           // ȡSCADA(Ӧ NET_SCADA_CAPS)
#define DH_DEVSTATE_GET_CODEID_COUNT      0x156c           // ȡɹ(Ӧ NET_GET_CODEID_COUNT)
#define DH_DEVSTATE_GET_CODEID_LIST       0x156d           // ѯϢ(Ӧ NET_GET_CODEID_LIST)
#define DH_DEVSTATE_ANALOGALARM_DATA      0x156e           // ѯģͨ(Ӧ NET_GET_ANALOGALARM_DATA)

//////////////////////////////////////////////////////////////////////////

// ƺݲɼ豸豸
typedef enum tagEM_NET_SCADA_DEV_TYPE
{
    EM_NET_SCADA_DEV_TYPE_UNKNOWN = 0,                         // δ֪
    EM_NET_SCADA_DEV_TYPE_ALL,                                 // 豸
    EM_NET_SCADA_DEV_TYPE_UPS,                                 // UPS
} EM_NET_SCADA_DEV_TYPE;

// ƺݲɼ豸ĵλ·Ϣ, ѯ
typedef struct tagNET_IN_SCADA_POINT_LIST_INFO 
{
    DWORD                           dwSize;
    char                            szDevType[DH_COMMON_STRING_64]; // 豸
}NET_IN_SCADA_POINT_LIST_INFO;

#define MAX_SCADA_POINT_LIST_INDEX          8               // SCADADev±, ͨ

// λ·Ϣ
typedef struct tagNET_SCADA_POINT_LIST
{
    DWORD                           dwSize;
    int                             nIndexValidNum;         // Ч±
    int                             nIndex[MAX_SCADA_POINT_LIST_INDEX];// SCADADev±ֵ, 0ʼ
    char                            szPath[DH_COMMON_STRING_256];// ·
}NET_SCADA_POINT_LIST;

#define MAX_SCADA_POINT_LIST_INFO_NUM       256               // λ·

// ƺݲɼ豸ĵλ·Ϣ, ѯ
typedef struct tagNET_OUT_SCADA_POINT_LIST_INFO 
{
    DWORD                           dwSize;
    int                             nList;                  // Чλ·Ϣ
    NET_SCADA_POINT_LIST            stuList[MAX_SCADA_POINT_LIST_INFO_NUM];// λ·Ϣ
}NET_OUT_SCADA_POINT_LIST_INFO;

// ƺݲɼ豸ĵλϢ, (Ӧ DH_DEVSTATE_SCADA_POINT_LIST )
typedef struct tagNET_SCADA_POINT_LIST_INFO 
{
    DWORD                           dwSize;
    NET_IN_SCADA_POINT_LIST_INFO    stuIn;                  // ѯ
    NET_OUT_SCADA_POINT_LIST_INFO   stuOut;                 // ѯ
}NET_SCADA_POINT_LIST_INFO;

//////////////////////////////////////////////////////////////////////////

// λ
typedef enum tagEM_NET_SCADA_POINT_TYPE
{
    EM_NET_SCADA_POINT_TYPE_UNKNOWN = 0,                       // δ֪
    EM_NET_SCADA_POINT_TYPE_ALL,                               // 
    EM_NET_SCADA_POINT_TYPE_YC,                                // ң
    EM_NET_SCADA_POINT_TYPE_YX,                                // ң
} EM_NET_SCADA_POINT_TYPE;

// SCADAλѯ
typedef struct tagNET_IN_SCADA_INFO 
{
    DWORD                   dwSize;
    EM_NET_SCADA_POINT_TYPE emPointType;                    // ѯĵλ
}NET_IN_SCADA_INFO;

#define MAX_SCADA_YX_NUM                128                 // ңŸ
#define MAX_SCADA_YC_NUM                128                 // ң
#define MAX_SCADA_POINT_INFO_NUM        8                   // 

// Ϣ
typedef struct tagNET_SCADA_POINT_INFO 
{
    DWORD                   dwSize;
    char                    szDevName[DH_COMMON_STRING_64];// 豸
    int                     nYX;                            // ЧңŸ
    unsigned int            anYX[MAX_SCADA_YX_NUM];         // ңϢ
    int                     nYC;                            // Чң
    float                   afYC[MAX_SCADA_YC_NUM];         // ңϢ
}NET_SCADA_POINT_INFO;

// SCADAλѯ
typedef struct tagNET_OUT_SCADA_INFO 
{
    DWORD                   dwSize;
    int                     nPointInfoNum;                  // Ч
    NET_SCADA_POINT_INFO    stuPointInfo[MAX_SCADA_POINT_INFO_NUM];// Ϣ
}NET_OUT_SCADA_INFO;

// ƺݲɼ豸ļλϢ(Ӧ DH_DEVSTATE_SCADA_INFO )
typedef struct tagNET_SCADA_INFO
{
    DWORD                   dwSize;
    NET_IN_SCADA_INFO       stuIn;                          // ѯ
    NET_OUT_SCADA_INFO      stuOut;                         // ѯ
}NET_SCADA_INFO;

// SCADA
typedef enum tagEM_NET_SCADA_CAPS_TYPE
{
    EM_NET_SCADA_CAPS_TYPE_UNKNOWN,
    EM_NET_SCADA_CAPS_TYPE_ALL,                                // 
    EM_NET_SCADA_CAPS_TYPE_DEV,                                // DevInfo
} EM_NET_SCADA_CAPS_TYPE;

// ƺݲɼ豸Ϣѯ
typedef struct tagNET_IN_SCADA_CAPS
{
    DWORD                   dwSize;
    EM_NET_SCADA_CAPS_TYPE  emType;                         // ѯ
} NET_IN_SCADA_CAPS;

#define MAX_NET_SCADA_CAPS_TYPE (16)
#define MAX_NET_SCADA_CAPS_NAME (16)

// ƺݲɼ豸Ϣ
typedef struct tagNET_OUT_SCADA_CAPS_ITEM
{
    DWORD                   dwSize;
    char                    szDevType[DH_COMMON_STRING_32];    // 豸
    int                     nValidName;                         // Ч豸Ƹ
    char                    szDevName[MAX_NET_SCADA_CAPS_NAME][DH_COMMON_STRING_32];// 豸, Ψһʾ豸
} NET_OUT_SCADA_CAPS_ITEM;

// ƺݲɼ豸Ϣѯ
typedef struct tagNET_OUT_SCADA_CAPS
{
    DWORD                   dwSize;
    int                     nValidType;                         // Ч豸͸
    NET_OUT_SCADA_CAPS_ITEM stuItems[MAX_NET_SCADA_CAPS_TYPE];  // 16
} NET_OUT_SCADA_CAPS;

// ƺݲɼ豸Ϣ(Ӧ DH_DEVSTATE_SCADA_CAPS )
typedef struct tagNET_SCADA_CAPS
{
    DWORD                   dwSize;
    NET_IN_SCADA_CAPS       stuIn;                          // ѯ
    NET_OUT_SCADA_CAPS      stuOut;                         // ѯ
} NET_SCADA_CAPS;

//////////////////////////////////////////////////////////////////////////

// յģʽ
typedef enum __EM_AIRCONDITION_MODE
{
    AIRCONDITION_MODE_UNKNOWN = 0,
    AIRCONDITION_MODE_AUTO,             // Զ
    AIRCONDITION_MODE_HOT,              // 
    AIRCONDITION_MODE_COLD,             // 
    AIRCONDITION_MODE_WET,              // ʪ
    AIRCONDITION_MODE_WIND,             // ͨ
} EM_AIRCONDITION_MODE;

// յͷģʽ
typedef enum __EM_AIRCONDITION_WINDMODE
{
    AIRCONDITION_WINDMODE_UNKNOWN = 0,
    AIRCONDITION_WINDMODE_STOP,            // ֹͣ
    AIRCONDITION_WINDMODE_AUTO,            // Զ
    AIRCONDITION_WINDMODE_HIGH,            // 
    AIRCONDITION_WINDMODE_MIDDLE,          // 
    AIRCONDITION_WINDMODE_LOW,             // 
} EM_AIRCONDITION_WINDMODE;

// յ״̬Ϣ
typedef struct tagNET_AIRCONDITION_STATE_INFO
{
    DWORD                       dwSize;
    BOOL                        bIsOnline;                      // Ƿ
    BOOL                        bIsON;                          // Ƿ
    int                         nTemperature;                   // յ趨¶
    EM_AIRCONDITION_MODE        emAirconditionMode;             // յģʽ
    EM_AIRCONDITION_WINDMODE    emAirconditionWindMode;         // յͷģʽ
    float                       fActualTemperature;             // ʵ¶
}NET_AIRCONDITION_STATE_INFO;

// ȡյ״̬(ӦDH_DEVSTATE_AIRCONDITION_STATE)
typedef struct tagNET_GET_AIRCONDITION_STATE
{
    DWORD                       dwSize;
    char                        szDeviceID[DH_MAX_DEV_ID_LEN];  // 豸Ωһʶ
    NET_AIRCONDITION_STATE_INFO stuAirConditionState;           // յ״̬Ϣ
}NET_GET_AIRCONDITION_STATE;

// ͨϢ
typedef struct tagNET_ALARM_CHANNEL_INFO 
{
    DWORD                       dwSize;
    int                         nSlot;                          // ַ, 0ʾͨ, 1ʾڵһϵչͨ, 23...Դ
    int                         nChannel;                       // Ǳرͨչģϵͨ, 0ʼ
    char                        szName[DH_COMMON_STRING_128];   // ͨ
}NET_ALARM_CHANNEL_INFO;

// (Զ)ͨ߼ͨӳϵ
typedef struct tagNET_ALARM_CHANNELS 
{
    DWORD                       dwSize;
    int                         nMaxAlarmChannels;              // ͨ
    int                         nRetAlarmChannels;              // صͨ
    NET_ALARM_CHANNEL_INFO*     pstuChannelInfo;                // ͨϢûڴ
}NET_ALARM_CHANNELS;

// ϵͳ״̬
typedef enum __EM_ALARM_SUBSYSTEM_STATE_TYPE
{
    ALARM_SUBSYSTEM_STATE_UNKNOWN = 0,
	ALARM_SUBSYSTEM_STATE_ACTIVE,               // Ѽ
	ALARM_SUBSYSTEM_STATE_INACTIVE,             // δ
	ALARM_SUBSYSTEM_STATE_UNDISTRIBUTED,        // δ
}EM_ALARM_SUBSYSTEM_STATE_TYPE;

// ϵͳ״̬, CLIENT_QueryDevStateӦDH_DEVSTATE_ALARMSUBSYSTEM_STATE
typedef struct tagNET_ALARM_SUBSYSTEM_STATE
{
    DWORD          dwSize;
	int            nMaxAlarmSubSystem;                                  // Чϵͳ
	EM_ALARM_SUBSYSTEM_STATE_TYPE  emState[DH_MAX_ALARM_SUBSYSTEM_NUM]; // ϵͳ״̬Ϣ
}NET_ALARM_SUBSYSTEM_STATE;


// 
typedef enum __EM_ALARM_FAULT_STATE_TYPE
{
    EM_ALARM_FAULT_STATE_ALL = 0,                       // 
    EM_ALARM_FAULT_STATE_CONNECTFAULT,                  // ӹ
    EM_ALARM_FAULT_STATE_BELLFAULT,                     // Ź
    EM_ALARM_FAULT_STATE_KBFAULT,                       // ̹
    EM_ALARM_FAULT_STATE_KBTAMPER,                      // ̷
    EM_ALARM_FAULT_STATE_SENSORSHORTOUT,                // ·
    EM_ALARM_FAULT_STATE_SENSORTAMPER,                  // 
}EM_ALARM_FAULT_STATE_TYPE;

// ״̬, 
typedef struct tagNET_IN_ALARM_FAULT_STATE
{
    DWORD           dwSize;
    EM_ALARM_FAULT_STATE_TYPE   emType;                 // ѯ
}NET_IN_ALARM_FAULT_STATE;

// ״̬, 
typedef struct tagNET_OUT_ALARM_FAULT_STATE
{
    DWORD           dwSize;
    int             nConnectFaultState;                 // 0: δ֪, 1: , 2:
    int             nBell;                              // Ч 
    int             anBellState[DH_MAX_BELL_NUM];       // Ź״̬Ϣ 0: δ֪, 1: , 2:
    int             nFaultKeyboard;                     // ̹Ч
    int             anFaultKeyboard[DH_MAX_KEYBOARD_NUM];// ̹Ϣ 0: δ֪, 1: , 2:
    int             nTamperKeyboard;                    // Ч 
    int             anTamperKeyboard[DH_MAX_KEYBOARD_NUM];// ̷Ϣ 0: δ֪, 1: , 2:
    int             nShortOutSensor;                    // Ч·
    int             anShortOutSensor[DH_MAX_ALARMIN];   // ·Ϣ 0: δ֪, 1: , 2:
    int             nTamperSensor;                      // Ч
    int             anTamperSensor[DH_MAX_ALARMIN];     // Ϣ 0: δ֪, 1: , 2:
}NET_OUT_ALARM_FAULT_STATE;

// ״̬, CLIENT_QueryDevStateӦDH_DEVSTATE_ALARM_FAULT_STATE
typedef struct tagNET_ALARM_FAULT_STATE_INFO
{
    DWORD           dwSize;
    NET_IN_ALARM_FAULT_STATE    stuIn;                  // 
    NET_OUT_ALARM_FAULT_STATE   stuOut;                 // 
}NET_ALARM_FAULT_STATE_INFO;

// ״̬
typedef enum __EM_DEFENCE_STATE_TYPE
{
    EM_DEFENCE_STATE_UNKNOWN = 0,
    EM_DEFENCE_STATE_BYPASS,                                // ·
    EM_DEFENCE_STATE_OPEN,                                  // , ָ·
    EM_DEFENCE_STATE_CLOSE,                                 // ر
    EM_DEFENCE_STATE_ALARMING,                              // , ָ·
}EM_DEFENCE_STATE_TYPE;

// ״̬Ϣ
typedef struct tagNET_IN_DEFENCE_STATE_INFO 
{
    DWORD           dwSize;
    int             nDefenceNum;                            // Ч, -1ʾѯз
    int             anDefence[DH_MAX_ALARMIN];              // ѯķ
}NET_IN_DEFENCE_STATE_INFO;

// ״̬Ϣ
typedef struct tagNET_OUT_DEFENCE_STATE_INFO
{
    DWORD           dwSize;
    int             nDefenceNum;                            // Ч
    EM_DEFENCE_STATE_TYPE  anDefenceState[DH_MAX_ALARMIN];  // ״̬Ϣ
}NET_OUT_DEFENCE_STATE_INFO;

// ״̬Ϣ, CLIENT_QueryDevStateӦDH_DEVSTATE_DEFENCE_STATE
typedef struct tagNET_DEFENCE_STATE_INFO 
{
    DWORD           dwSize;
    NET_IN_DEFENCE_STATE_INFO   stuIn;                      // 
    NET_OUT_DEFENCE_STATE_INFO  stuOut;                     // 
}NET_DEFENCE_STATE_INFO;


// ѯͣӦCLIENT_QueryRemotDevStateӿ
#define DH_DEVSTATE_ALARM_REMOTE          0x1000           // ȡԶ豸ⲿ(Ӧ ALARM_REMOTE_ALARM_INFO)
#define DH_DEVSTATE_ALARM_FRONTDISCONNECT 0x1001           // ȡǰIPC(ӦṹALARM_FRONTDISCONNET_INFO)

// ͣӦCLIENT_GetDevConfigCLIENT_SetDevConfigӿ
#define DH_DEV_DEVICECFG                  0x0001           // 豸
#define DH_DEV_NETCFG                     0x0002           // 
#define DH_DEV_CHANNELCFG                 0x0003           // ͼͨ
#define DH_DEV_PREVIEWCFG                 0x0004           // Ԥ
#define DH_DEV_RECORDCFG                  0x0005           // ¼
#define DH_DEV_COMMCFG                    0x0006           // 
#define DH_DEV_ALARMCFG                   0x0007           // 
#define DH_DEV_TIMECFG                    0x0008           // DVRʱ
#define DH_DEV_TALKCFG                    0x0009           // Խ
#define DH_DEV_AUTOMTCFG                  0x000A           // Զά        
#define DH_DEV_VEDIO_MARTIX               0x000B           // Ʋ    
#define DH_DEV_MULTI_DDNS                 0x000C           // ddns
#define DH_DEV_SNAP_CFG                   0x000D           // ץͼ
#define DH_DEV_WEB_URL_CFG                0x000E           // HTTP·
#define DH_DEV_FTP_PROTO_CFG              0x000F           // FTPϴ
#define DH_DEV_INTERVIDEO_CFG             0x0010           // ƽ̨ãʱchannelƽ̨ͣ
                                                           // channel=4 أchannel=10άchannel=11Uͨchannel=51
#define DH_DEV_VIDEO_COVER                0x0011           // ڵ
#define DH_DEV_TRANS_STRATEGY             0x0012           // ã\
#define DH_DEV_DOWNLOAD_STRATEGY          0x0013           // ¼زã\ͨ
#define DH_DEV_WATERMAKE_CFG              0x0014           // ͼˮӡ
#define DH_DEV_WLAN_CFG                   0x0015           // 
#define DH_DEV_WLAN_DEVICE_CFG            0x0016           // 豸
#define DH_DEV_REGISTER_CFG               0x0017           // ע
#define DH_DEV_CAMERA_CFG                 0x0018           // ͷ
#define DH_DEV_INFRARED_CFG               0x0019           // ⱨ
#define DH_DEV_SNIFFER_CFG                0x001A           // Snifferץ
#define DH_DEV_MAIL_CFG                   0x001B           // ʼ
#define DH_DEV_DNS_CFG                    0x001C           // DNS
#define DH_DEV_NTP_CFG                    0x001D           // NTP
#define DH_DEV_AUDIO_DETECT_CFG           0x001E           // Ƶ
#define DH_DEV_STORAGE_STATION_CFG        0x001F           // 洢λ
#define DH_DEV_PTZ_OPT_CFG                0x0020           // ̨(ѾϳʹCLIENT_GetPtzOptAttrȡ̨)
#define DH_DEV_DST_CFG                    0x0021           // ʱ
#define DH_DEV_ALARM_CENTER_CFG           0x0022           // 
#define DH_DEV_VIDEO_OSD_CFG              0x0023           // ƵOSD
#define DH_DEV_CDMAGPRS_CFG               0x0024           // CDMA\GPRS

#define DH_DEV_IPFILTER_CFG               0x0025           // IP
#define DH_DEV_TALK_ENCODE_CFG            0x0026           // Խ
#define DH_DEV_RECORD_PACKET_CFG          0X0027           // ¼
#define DH_DEV_MMS_CFG                    0X0028           // MMS 
#define DH_DEV_SMSACTIVATION_CFG          0X0029           // ż
#define DH_DEV_DIALINACTIVATION_CFG       0X002A           // ż
#define DH_DEV_SNIFFER_CFG_EX             0x0030           // ץ
#define DH_DEV_DOWNLOAD_RATE_CFG          0x0031           // ٶ
#define DH_DEV_PANORAMA_SWITCH_CFG        0x0032           // ȫл
#define DH_DEV_LOST_FOCUS_CFG             0x0033           // ʧȥ㱨
#define DH_DEV_ALARM_DECODE_CFG           0x0034           // 
#define DH_DEV_VIDEOOUT_CFG               0x0035           // Ƶ
#define DH_DEV_POINT_CFG                  0x0036           // ԤƵʹ
#define DH_DEV_IP_COLLISION_CFG           0x0037           // Ipͻⱨ
#define DH_DEV_OSD_ENABLE_CFG             0x0038           // OSDʹ
#define DH_DEV_LOCALALARM_CFG             0x0039           // ر(ṹDH_ALARMIN_CFG_EX)
#define DH_DEV_NETALARM_CFG               0x003A           // 籨(ṹDH_ALARMIN_CFG_EX)
#define DH_DEV_MOTIONALARM_CFG            0x003B           // 챨(ṹDH_MOTION_DETECT_CFG_EX)
#define DH_DEV_VIDEOLOSTALARM_CFG         0x003C           // Ƶʧ(ṹDH_VIDEO_LOST_CFG_EX)
#define DH_DEV_BLINDALARM_CFG             0x003D           // Ƶڵ(ṹDH_BLIND_CFG_EX)
#define DH_DEV_DISKALARM_CFG              0x003E           // Ӳ̱(ṹDH_DISK_ALARM_CFG_EX)
#define DH_DEV_NETBROKENALARM_CFG         0x003F           // жϱ(ṹDH_NETBROKEN_ALARM_CFG_EX)
#define DH_DEV_ENCODER_CFG                0x0040           // ͨǰ˱ϢDVRʹãṹDEV_ENCODER_CFG
#define DH_DEV_TV_ADJUST_CFG              0x0041           // TVãchannelTV(0ʼ)ͽṹ壩
#define DH_DEV_ABOUT_VEHICLE_CFG          0x0042           // ãʹ
#define DH_DEV_ATM_OVERLAY_ABILITY        0x0043           // ȡatm֧Ϣ
#define DH_DEV_ATM_OVERLAY_CFG            0x0044           // atmãatm
#define DH_DEV_DECODER_TOUR_CFG           0x0045           // Ѳ
#define DH_DEV_SIP_CFG                    0x0046           // SIP
#define DH_DEV_VICHILE_WIFI_AP_CFG        0x0047           // wifi ap
#define DH_DEV_STATICALARM_CFG            0x0048           // ̬ 
#define DH_DEV_DECODE_POLICY_CFG          0x0049           // 豸Ľ(ṹDHDEV_DECODEPOLICY_CFGchannelΪͨ0ʼ) 
#define DH_DEV_MACHINE_CFG                0x004A           // ص(ṹDHDEV_MACHINE_CFG)
#define DH_DEV_MAC_COLLISION_CFG          0x004B           // MACͻ(ṹALARM_MAC_COLLISION_CFG)
#define DH_DEV_RTSP_CFG                   0x004C           // RTSP(ӦṹDHDEV_RTSP_CFG)
#define DH_DEV_232_COM_CARD_CFG           0x004E           // 232ڿź¼(ӦṹCOM_CARD_SIGNAL_LINK_CFG)
#define DH_DEV_485_COM_CARD_CFG           0x004F           // 485ڿź¼(ӦṹCOM_CARD_SIGNAL_LINK_CFG)
#define DH_DEV_FTP_PROTO_CFG_EX           0x0050           // FTPϴչ(ӦṹDHDEV_FTP_PROTO_CFG_EX)
#define DH_DEV_SYSLOG_REMOTE_SERVER       0x0051           // SYSLOG Զ̷(ӦṹDHDEV_SYSLOG_REMOTE_SERVER)
#define DH_DEV_COMMCFG_EX                 0x0052           // չ(ӦṹDHDEV_COMM_CFG_EX)            
#define DH_DEV_NETCARD_CFG                0x0053           // Ϣ(ӦṹDHDEV_NETCARD_CFG)
#define DH_DEV_BACKUP_VIDEO_FORMAT        0x0054           // Ƶݸʽ(ӦṹDHDEV_BACKUP_VIDEO_FORMAT)
#define DH_DEV_STREAM_ENCRYPT_CFG         0x0055           // (ӦṹDHEDV_STREAM_ENCRYPT)
#define DH_DEV_IPFILTER_CFG_EX            0x0056           // IPչ(ӦṹDHDEV_IPIFILTER_CFG_EX)
#define DH_DEV_CUSTOM_CFG                 0x0057           // ûԶ(ӦṹDHDEV_CUSTOM_CFG)
#define DH_DEV_WLAN_DEVICE_CFG_EX         0x0058           // 豸չ(ӦṹDHDEV_WLAN_DEVICE_LIST_EX)
#define DH_DEV_ACC_POWEROFF_CFG           0x0059           // ACC¼(ӦṹDHDEV_ACC_POWEROFF_CFG)
#define DH_DEV_EXPLOSION_PROOF_CFG        0x005a           // б¼(ӦṹDHDEV_EXPLOSION_PROOF_CFG)
#define DH_DEV_NETCFG_EX                  0x005b           // չ(ӦṹDHDEV_NET_CFG_EX)
#define DH_DEV_LIGHTCONTROL_CFG           0x005c           // ƹ(ӦṹDHDEV_LIGHTCONTROL_CFG)
#define DH_DEV_3GFLOW_CFG                 0x005d           // 3GϢ(ӦṹDHDEV_3GFLOW_INFO_CFG)
#define DH_DEV_IPV6_CFG                   0x005e           // IPv6(ӦṹDHDEV_IPV6_CFG)
#define DH_DEV_SNMP_CFG                   0X005f           // Snmp(ӦṹDHDEV_NET_SNMP_CFG), ɺҪ豸
#define DH_DEV_SNAP_CONTROL_CFG           0x0060           // ץͼ(ӦṹDHDEV_SNAP_CONTROL_CFG)
#define DH_DEV_GPS_MODE_CFG               0X0061           // GPSλģʽ(ӦṹDHDEV_GPS_MODE_CFG)
#define DH_DEV_SNAP_UPLOAD_CFG            0X0062           // ͼƬϴϢ(Ӧṹ DHDEV_SNAP_UPLOAD_CFG)
#define DH_DEV_SPEED_LIMIT_CFG            0x0063           // Ϣ(ӦṹDHDEV_SPEED_LIMIT_CFG)
#define DH_DEV_ISCSI_CFG                  0x0064           // iSCSI(ӦṹDHDEV_ISCSI_CFG), ɺҪ豸
#define DH_DEV_WIRELESS_ROUTING_CFG       0x0065           // ·(ӦṹDHDEV_WIRELESS_ROUTING_CFG)
#define DH_DEV_ENCLOSURE_CFG              0x0066           // Χ(ӦṹDHDEV_ENCLOSURE_CFG)
#define DH_DEV_ENCLOSURE_VERSION_CFG      0x0067           // Χ汾(ӦṹDHDEV_ENCLOSURE_VERSION_CFG)
#define DH_DEV_RIAD_EVENT_CFG             0x0068           // Raid¼(ӦṹDHDEV_RAID_EVENT_CFG)
#define DH_DEV_FIRE_ALARM_CFG             0x0069           // 𾯱(ӦṹDHDEV_FIRE_ALARM_CFG)
#define DH_DEV_LOCALALARM_NAME_CFG        0x006a           // Ʊ(ӦName1&&name2&&name3...ʽַ)
#define DH_DEV_URGENCY_RECORD_CFG         0x0070           // 洢(ӦṹDHDEV_URGENCY_RECORD_CFG)
#define DH_DEV_ELEVATOR_ATTRI_CFG         0x0071           // в(ӦṹDHDEV_ELEVATOR_ATTRI_CFG)
#define DH_DEV_ATM_OVERLAY_CFG_EX         0x0072           // atmãatm,ִ֧32ͨ豸(ӦṹDHDEV_ATM_OVERLAY_CONFIG_EX)
#define DH_DEV_MACFILTER_CFG              0x0073           // MAC(ӦṹDHDEV_MACFILTER_CFG)
#define DH_DEV_MACIPFILTER_CFG            0x0074           // MAC,IP(Ҫip,macһһӦ)(ӦṹDHDEV_MACIPFILTER_CFG)
#define DH_DEV_STREAM_ENCRYPT_TIME_CFG    0x0075           // (ܼƻ)(ӦṹDHEDV_STREAM_ENCRYPT)
#define DH_DEV_LIMIT_BIT_RATE_CFG         0x0076           // (Ӧṹ DHDEV_LIMIT_BIT_RATE) 
#define DH_DEV_SNAP_CFG_EX                0x0077           // ץͼչ(Ӧṹ DHDEV_SNAP_CFG_EX)
#define DH_DEV_DECODER_URL_CFG            0x0078           // url(ӦṹDHDEV_DECODER_URL_CFG)
#define DH_DEV_TOUR_ENABLE_CFG            0x0079           // Ѳʹ(ӦṹDHDEV_TOUR_ENABLE_CFG)
#define DH_DEV_VICHILE_WIFI_AP_CFG_EX     0x007a           // wifi apչ(ӦṹDHDEV_VEHICLE_WIFI_AP_CFG_EX)
#define DH_DEV_ENCODER_CFG_EX             0x007b           // ͨǰ˱Ϣչ(ӦṹDEV_ENCODER_CFG_EX)
#define DH_DEV_USER_END_CFG               1000             

// ͣӦCLIENT_StartListenӿ
#define DH_COMM_ALARM                     0x1100           // 汨(ⲿƵʧ̬)
#define DH_SHELTER_ALARM                  0x1101           // Ƶڵ
#define DH_DISK_FULL_ALARM                0x1102           // Ӳ
#define DH_DISK_ERROR_ALARM               0x1103           // Ӳ̹ϱ
#define DH_SOUND_DETECT_ALARM             0x1104           // Ƶⱨ
#define DH_ALARM_DECODER_ALARM            0x1105           // 

// չͣӦCLIENT_StartListenExӿ
#define DH_ALARM_ALARM_EX                 0x2101           // ⲿ
#define DH_MOTION_ALARM_EX                0x2102           // ̬ⱨ
#define DH_VIDEOLOST_ALARM_EX             0x2103           // Ƶʧ
#define DH_SHELTER_ALARM_EX               0x2104           // Ƶڵ
#define DH_SOUND_DETECT_ALARM_EX          0x2105           // Ƶⱨ
#define DH_DISKFULL_ALARM_EX              0x2106           // Ӳ
#define DH_DISKERROR_ALARM_EX             0x2107           // Ӳ̱
#define DH_ENCODER_ALARM_EX               0x210A           // 
#define DH_URGENCY_ALARM_EX               0x210B           // 
#define DH_WIRELESS_ALARM_EX              0x210C           // ߱
#define DH_NEW_SOUND_DETECT_ALARM_EX      0x210D           // ƵⱨϢĽṹDH_NEW_SOUND_ALARM_STATE
#define DH_ALARM_DECODER_ALARM_EX         0x210E           // 
#define DH_DECODER_DECODE_ABILITY         0x210F           // 
#define DH_FDDI_DECODER_ABILITY           0x2110           // ˱״̬
#define DH_PANORAMA_SWITCH_ALARM_EX       0x2111           // л
#define DH_LOSTFOCUS_ALARM_EX             0x2112           // ʧȥ㱨
#define DH_OEMSTATE_EX                    0x2113           // oemͣ״̬
#define DH_DSP_ALARM_EX                   0x2114           // DSP
#define DH_ATMPOS_BROKEN_EX               0x2115           // atmposϿ 0ӶϿ 1
#define DH_RECORD_CHANGED_EX              0x2116           // ¼״̬仯
#define DH_CONFIG_CHANGED_EX              0x2117           // ÷仯
#define DH_DEVICE_REBOOT_EX               0x2118           // 豸
#define DH_WINGDING_ALARM_EX              0x2119           // Ȧ/ϱ
#define DH_TRAF_CONGESTION_ALARM_EX       0x211A           // ͨ(쳣ֹͣŶ)
#define DH_TRAF_EXCEPTION_ALARM_EX        0x211B           // ͨ쳣(ͨ0쳣)
#define DH_EQUIPMENT_FILL_ALARM_EX        0x211C           // 豸ϱ
#define DH_ALARM_ARM_DISARM_STATE         0x211D           // ״̬
#define DH_ALARM_ACC_POWEROFF             0x211E           // ACCϵ籨
#define DH_ALARM_3GFLOW_EXCEED            0x211F           // 3Gֵ(ϢĽṹṹDHDEV_3GFLOW_EXCEED_STATE_INFO)
#define DH_ALARM_SPEED_LIMIT              0x2120           // ٱ
#define DH_ALARM_VEHICLE_INFO_UPLOAD      0x2121           // ԶϢϴ 
#define DH_STATIC_ALARM_EX                0x2122           // ̬ⱨ
#define DH_PTZ_LOCATION_EX                0x2123           // ̨λϢ
#define DH_ALARM_CARD_RECORD_UPLOAD       0x2124           // ¼Ϣϴ(Ӧṹ ALARM_CARD_RECORD_INFO_UPLOAD)
#define DH_ALARM_ATM_INFO_UPLOAD          0x2125           // ATMϢϴ(Ӧṹ ALARM_ATM_INFO_UPLOAD)
#define DH_ALARM_ENCLOSURE                0x2126           // Χ(ӦṹALARM_ENCLOSURE_INFO)
#define DH_ALARM_SIP_STATE                0x2127           // SIP״̬(ӦṹALARM_SIP_STATE)
#define DH_ALARM_RAID_STATE               0x2128           // RAID쳣(ӦṹALARM_RAID_INFO)
#define DH_ALARM_CROSSING_SPEED_LIMIT     0x2129           // ·ٱ(ӦṹALARM_SPEED_LIMIT)
#define DH_ALARM_OVER_LOADING             0x212A           // ر(ӦṹALARM_OVER_LOADING)
#define DH_ALARM_HARD_BRAKING             0x212B           // ɲ(ӦALARM_HARD_BRAKING)
#define DH_ALARM_SMOKE_SENSOR             0x212C           // ̸б(ӦṹALARM_SMOKE_SENSOR)
#define DH_ALARM_TRAFFIC_LIGHT_FAULT      0x212D           // ͨƹϱ(ӦṹALARM_TRAFFIC_LIGHT_FAULT) 
#define DH_ALARM_TRAFFIC_FLUX_STAT        0x212E           // ͨͳƱ(ӦṹALARM_TRAFFIC_FLUX_LANE_INFO)
#define DH_ALARM_CAMERA_MOVE              0x212F           // λ¼(ӦṹALARM_CAMERA_MOVE_INFO)
#define DH_ALARM_DETAILEDMOTION           0x2130           // ϸ챨ϱϢ(ӦṹALARM_DETAILEDMOTION_CHNL_INFO)
#define DH_ALARM_STORAGE_FAILURE          0x2131           // 洢쳣(ӦṹALARM_STORAGE_FAILURE)
#define DH_ALARM_FRONTDISCONNECT          0x2132           // ǰIPC(ӦṹALARM_FRONTDISCONNET_INFO)
#define DH_ALARM_ALARM_EX_REMOTE          0x2133           // Զⲿ(Ӧṹ ALARM_REMOTE_ALARM_INFO)
#define DH_ALARM_BATTERYLOWPOWER          0x2134           // صͱ(ӦṹALARM_BATTERYLOWPOWER_INFO)
#define DH_ALARM_TEMPERATURE              0x2135           // ¶ȹ߱(ӦṹALARM_TEMPERATURE_INFO)
#define DH_ALARM_TIREDDRIVE               0x2136           // ƣͼʻ(ӦṹALARM_TIREDDRIVE_INFO)
#define DH_ALARM_LOST_RECORD              0x2137           // ¼¼(ӦṹALARM_LOST_RECORD)
#define DH_ALARM_HIGH_CPU                 0x2138           // CPUռʹ¼(ӦṹALARM_HIGH_CPU)
#define DH_ALARM_LOST_NETPACKET           0x2139           // 緢ݶ¼(ӦṹALARM_LOST_NETPACKET)
#define DH_ALARM_HIGH_MEMORY              0x213A           // ڴռʹ¼(ӦṹALARM_HIGH_MEMORY)
#define DH_LONG_TIME_NO_OPERATION         0x213B           // WEBûʱ޲¼չϢ
#define DH_BLACKLIST_SNAP                 0x213C           // ץ¼(ӦṹDH_BLACKLIST_SNAP_INFO)         
#define DH_ALARM_DISK                     0x213E           // Ӳ̱(ӦALARM_DISK_INFO)
#define DH_ALARM_FILE_SYSTEM              0x213F           // ļϵͳ(ӦALARM_FILE_SYSTEM_INFO)
#define DH_ALARM_IVS                      0x2140           // ܱ¼(ӦṹALARM_IVS_INFO)
#define DH_ALARM_GOODS_WEIGHT_UPLOAD      0x2141           // Ϣϱ(ӦALARM_GOODS_WEIGHT_UPLOAD_INFO)
#define DH_ALARM_GOODS_WEIGHT             0x2142           // Ϣ(ӦALARM_GOODS_WEIGHT_INFO)
#define DH_GPS_STATUS                     0x2143           // GPSλϢ(Ӧ NET_GPS_STATUS_INFO)
#define DH_ALARM_DISKBURNED_FULL          0x2144           // Ӳ̿¼(Ӧ ALARM_DISKBURNED_FULL_INFO)
#define DH_ALARM_STORAGE_LOW_SPACE        0x2145           // 洢¼(ӦALARM_STORAGE_LOW_SPACE_INFO)
#define DH_ALARM_DISK_FLUX                0x2160           // Ӳ쳣¼(ӦALARM_DISK_FLUX)
#define DH_ALARM_NET_FLUX                 0x2161           // 쳣¼(ӦALARM_NET_FLUX)
#define DH_ALARM_FAN_SPEED                0x2162           // ת쳣¼(ӦALARM_FAN_SPEED)
#define DH_ALARM_STORAGE_FAILURE_EX       0x2163           // 洢󱨾(ӦṹALARM_STORAGE_FAILURE_EX)
#define DH_ALARM_RECORD_FAILED            0x2164           // ¼쳣(ӦṹALARM_RECORD_FAILED_INFO)
#define DH_ALARM_STORAGE_BREAK_DOWN       0x2165           // 洢¼(ӦṹALARM_STORAGE_BREAK_DOWN_INFO)
#define DH_ALARM_VIDEO_ININVALID          0x2166           // ƵͨʧЧ¼õƵͨ豸ALARM_VIDEO_ININVALID_INFO
#define DH_ALARM_VEHICLE_TURNOVER         0x2167           // ෭¼(ӦṹALARM_VEHICEL_TURNOVER_EVENT_INFO)
#define DH_ALARM_VEHICLE_COLLISION        0x2168           // ײ¼(ӦṹALARM_VEHICEL_COLLISION_EVENT_INFO)
#define DH_ALARM_VEHICLE_CONFIRM          0x2169           // ϴϢ¼(ӦṹALARM_VEHICEL_CONFIRM_INFO)
#define DH_ALARM_VEHICLE_LARGE_ANGLE      0x2170           // ͷǶŤת¼(ӦṹALARM_VEHICEL_LARGE_ANGLE)
#define DH_ALARM_TALKING_INVITE           0x2171           // 豸ԷԽ¼(ӦṹALARM_TALKING_INVITE_INFO)
#define DH_ALARM_ALARM_EX2                0x2175           // ر¼(ӦṹALARM_ALARM_INFO_EX2DH_ALARM_ALARM_EX)
#define DH_ALARM_VIDEO_TIMING             0x2176           // Ƶʱ¼(ӦṹALARM_VIDEO_TIMING)
#define DH_ALARM_COMM_PORT                0x2177           // ¼(ӦṹALARM_COMM_PORT_EVENT_INFO)
#define DH_ALARM_AUDIO_ANOMALY            0x2178           // Ƶ쳣¼(ӦṹALARM_AUDIO_ANOMALY)
#define DH_ALARM_AUDIO_MUTATION           0x2179           // ǿͻ¼(ӦṹALARM_AUDIO_MUTATION)
#define DH_EVENT_TYREINFO                 0x2180           // ̥Ϣϱ¼(ӦṹEVENT_TYRE_INFO)
#define DH_ALARM_POWER_ABNORMAL           0X2181           // Դ쳣(ӦṹALARM_POWER_ABNORMAL_INFO)
#define DH_EVENT_REGISTER_OFF             0x2182           // 豸¼(Ӧṹ EVENT_REGISTER_OFF_INFO)
#define DH_ALARM_NO_DISK                  0x2183           // Ӳ̱(ӦṹALARM_NO_DISK_INFO)
#define DH_ALARM_FALLING                  0x2184           // ¼(ӦṹALARM_FALLING_INFO)
#define DH_ALARM_PROTECTIVE_CAPSULE       0x2185           // ¼(ӦṹALARM_PROTECTIVE_CAPSULE_INFO)
#define DH_ALARM_NO_RESPONSE              0x2186           // δӦ𾯱(ӦṹALARM_NO_RESPONSE_INFO)
#define DH_ALARM_CONFIG_ENABLE_CHANGE     0X2187           // ʹܸıϱ¼(Ӧṹ ALARM_CONFIG_ENABLE_CHANGE_INFO)

#define DH_ALARM_STORAGE_NOT_EXIST        0x3167           // 洢鲻¼(ӦṹALARM_STORAGE_NOT_EXIST_INFO)
#define DH_ALARM_NET_ABORT                0x3169           // ¼(ӦṹALARM_NETABORT_INFO)
#define DH_ALARM_IP_CONFLICT              0x3170           // IPͻ¼(ӦṹALARM_IP_CONFLICT_INFO)
#define DH_ALARM_MAC_CONFLICT             0x3171           // MACͻ¼(ӦṹALARM_MAC_CONFLICT_INFO)
#define DH_ALARM_POWERFAULT               0x3172           // Դ¼(ӦṹALARM_POWERFAULT_INFO)
#define DH_ALARM_CHASSISINTRUDED          0x3173           // ()¼(ӦṹALARM_CHASSISINTRUDED_INFO)
#define DH_ALARM_ALARMEXTENDED            0x3174           // չ¼(Ӧṹ ALARM_ALARMEXTENDED_INFO)
#define DH_ALARM_ARMMODE_CHANGE_EVENT     0x3175           // ״̬仯¼(ӦṹALARM_ARMMODE_CHANGE_INFO)
#define DH_ALARM_BYPASSMODE_CHANGE_EVENT  0x3176           // ·״̬仯¼(ӦṹALARM_BYPASSMODE_CHANGE_INFO)
#define DH_ALARM_ACCESS_CTL_NOT_CLOSE     0x3177           // Žδ¼(ӦṹALARM_ACCESS_CTL_NOT_CLOSE_INFO)
#define DH_ALARM_ACCESS_CTL_BREAK_IN      0x3178           // ¼(ӦṹALARM_ACCESS_CTL_BREAK_IN_INFO)
#define DH_ALARM_ACCESS_CTL_REPEAT_ENTER  0x3179           // ¼(ӦṹALARM_ACCESS_CTL_REPEAT_ENTER_INFO)
#define DH_ALARM_ACCESS_CTL_DURESS        0x3180           // вȿˢ¼(ӦṹALARM_ACCESS_CTL_DURESS_INFO)
#define DH_ALARM_ACCESS_CTL_EVENT         0x3181           // Ž¼(ӦṹALARM_ACCESS_CTL_EVENT_INFO)
#define DH_URGENCY_ALARM_EX2              0x3182           // EX2(DH_URGENCY_ALARM_EX,ӦṹALARM_URGENCY_ALARM_EX2, ΪĽ¼, һ㴦ⲿͨѶ
#define DH_ALARM_INPUT_SOURCE_SIGNAL      0x3183           // Դź¼(ֻҪͻ¼, ۷ǰģʽ޷, ӦALARM_INPUT_SOURCE_SIGNAL_INFO)
#define DH_ALARM_ANALOGALARM_EVENT        0x3184           // ģͨ¼(ӦṹALARM_ANALOGALARM_EVENT_INFO)
#define DH_ALARM_ACCESS_CTL_STATUS        0x3185           // Ž״̬¼(ӦṹALARM_ACCESS_CTL_STATUS_INFO)
#define DH_ALARM_ACCESS_SNAP              0x3186           // Žץͼ¼(ӦṹALARM_ACCESS_SNAP_INFO)
#define DH_ALARM_ALARMCLEAR               0x3187           // ¼(ӦṹALARM_ALARMCLEAR_INFO)
#define DH_ALARM_CIDEVENT                 0x3188           // CID¼(ӦṹALARM_CIDEVENT_INFO)
#define DH_ALARM_TALKING_HANGUP           0x3189           // 豸Ҷ϶Խ¼(ӦṹALARM_TALKING_HANGUP_INFO)
#define DH_ALARM_BANKCARDINSERT           0x318a           // п忨¼(ӦṹALARM_BANKCARDINSERT_INFO)
#define DH_ALARM_RCEMERGENCY_CALL         0x318b           // б¼(Ӧṹ ALARM_RCEMERGENCY_CALL_INFO)
#define DH_ALARM_OPENDOORGROUP            0x318c           // Ͽ¼(ӦṹALARM_OPEN_DOOR_GROUP_INFO)
#define DH_ALARM_FINGER_PRINT             0x318d           // ȡָ¼(ӦṹALARM_CAPTURE_FINGER_PRINT_INFO)
#define DH_ALARM_CARD_RECORD              0x318e           // ¼¼(Ӧṹ ALARM_CARD_RECORD_INFO)
#define DH_ALARM_SUBSYSTEM_STATE_CHANGE   0x318f           // ϵͳ״̬ı¼(ӦṹALARM_SUBSYSTEM_STATE_CHANGE_INFO)
#define DH_ALARM_BATTERYPOWER_EVENT       0x3190           // صʱ֪ͨ¼(ӦṹALARM_BATTERYPOWER_INFO)
#define DH_ALARM_BELLSTATUS_EVENT         0x3191           // ״̬¼(ӦṹALARM_BELLSTATUS_INFO)
#define DH_ALARM_DEFENCE_STATE_CHANGE_EVENT 0x3192         // ״̬仯¼(ӦṹALARM_DEFENCE_STATUS_CHANGE_INFO), 
                                                           // 󣬺Ͳ仯¼·״̬仯¼е״̬岻ͬ
                                                           // ״̬ͨCLIENT_QueryDevState()ӿڵDH_DEVSTATE_DEFENCE_STATEȡ


#define DH_ALARM_TICKET_STATISTIC         0x3193           // ƱͳϢ¼(Ӧṹ ALARM_TICKET_STATISTIC)
#define DH_ALARM_LOGIN_FAILIUR            0x3194           // ½ʧ¼(ӦṹALARM_LOGIN_FAILIUR_INFO)
#define DH_ALARM_MODULE_LOST              0x3195           // չģ¼(Ӧṹ ALARM_MODULE_LOST_INFO)
#define DH_ALARM_PSTN_BREAK_LINE          0x3196           // PSTN¼(ӦṹALARM_PSTN_BREAK_LINE_INFO)
#define DH_ALARM_ANALOG_PULSE             0x3197           // ģ¼(˲ʱ¼), ضʱŴ(ӦṹALARM_ANALOGPULSE_INFO)
#define DH_ALARM_MISSION_CONFIRM          0x3198           // ȷ¼(Ӧṹ ALARM_MISSION_CONFIRM_INFO)
#define DH_ALARM_DEVICE_MSG_NOTIFY        0x3199           // 豸ƽ̨֪ͨ¼(Ӧṹ ALARM_DEVICE_MSG_NOTIFY_INFO)
#define DH_ALARM_VEHICLE_STANDING_OVER_TIME 0x319A         // ͣʱ(Ӧṹ ALARM_VEHICLE_STANDING_OVER_TIME_INFO)
#define DH_ALARM_ENCLOSURE_ALARM          0x319B           // Χ¼(Ӧṹ ALARM_ENCLOSURE_ALARM_INFO)
#define DH_ALARM_GUARD_DETECT			  0x319C		   // ͤ¼,¼ͤеһʱϱstart¼ͤһ뿪ʱϱstop ¼(ӦṹALARM_GUARD_DETECT_INFO)
#define DH_ALARM_GUARD_INFO_UPDATE		  0x319D		   // ͤϢ¼ֻҪͤԱϱ(ӦṹALARM_GUARD_UPDATE_INFO)  
#define DH_ALARM_NODE_ACTIVE              0x319e           // ڵ㼤¼(ӦṹALARM_NODE_ACTIVE_INFO)
#define DH_ALARM_VIDEO_STATIC             0x319F           // Ƶ̬¼(Ӧṹ ALARM_VIDEO_STATIC_INFO)
#define DH_ALARM_REGISTER_REONLINE        0x31a0           // ע豸µ½¼(ӦṹALARM_REGISTER_REONLINE_INFO)
#define DH_ALARM_ISCSI_STATUS             0x31a1           // ISCSI澯¼(Ӧṹ ALARM_ISCSI_STATUS_INFO)
#define DH_ALARM_SCADA_DEV_ALARM          0x31a2           // ɼ豸¼(Ӧṹ ALARM_SCADA_DEV_INFO)
#define DH_ALARM_AUXILIARY_DEV_STATE      0x31a3           // 豸״̬(ӦṹALARM_AUXILIARY_DEV_STATE)
#define DH_ALARM_PARKING_CARD             0x31a4           // ͣˢ¼(ӦṹALARM_PARKING_CARD)
#define DH_ALARM_PROFILE_ALARM_TRANSMIT   0x31a5           // ¼(ӦṹALARM_PROFILE_ALARM_TRANSMIT_INFO)
#define DH_ALARM_VEHICLE_ACC              0x31a6           // ACC¼(Ӧṹ ALARM_VEHICLE_ACC_INFO)

// ¼
#define DH_CONFIG_RESULT_EVENT_EX         0x3000           // ޸õķ룻ؽṹDEV_SET_RESULT
#define DH_REBOOT_EVENT_EX                0x3001           // 豸¼δǰ޸ĵòЧ
#define DH_AUTO_TALK_START_EX             0x3002           // 豸뿪ʼԽ
#define DH_AUTO_TALK_STOP_EX              0x3003           // 豸ֹͣԽ
#define DH_CONFIG_CHANGE_EX               0x3004           // 豸÷ı
#define DH_IPSEARCH_EVENT_EX              0x3005           // IP¼, ַʽ:DevName::Manufacturer::MAC::IP::Port::DevType::POEPort::SubMask::GateWay&&DevName::Manufacturer::MAC::IP::Port::DevType::POEPort::SubMask::GateWay &&
#define DH_AUTO_RECONNECT_FAILD           0x3006           // Զʧ¼
#define DH_REALPLAY_FAILD_EVENT           0x3007           // ʧ¼,ؽṹDEV_PLAY_RESULT
#define DH_PLAYBACK_FAILD_EVENT           0x3008           // طʧ¼,ؽṹDEV_PLAY_RESULT   
#define DH_IVS_TRAFFIC_REALFLOWINFO       0x3009           // ͨʵʱϢ¼ALARM_IVS_TRAFFIC_REALFLOW_INFO
#define DH_DEVICE_ABORT_EVENT             0x300a           // ͻ˱߳, Ӧṹ DEV_CLIENT_ABORT_INFO
#define DH_TALK_FAILD_EVENT               0x300b           // Խʧ, Ӧṹ DEV_TALK_RESULT

// ϴܵıͣӦCLIENT_StartServiceӿڡNEW_ALARM_UPLOADṹ.
#define DH_UPLOAD_ALARM                     0x4000           // ⲿ            
#define DH_UPLOAD_MOTION_ALARM              0x4001           // ̬ⱨ
#define DH_UPLOAD_VIDEOLOST_ALARM           0x4002           // Ƶʧ
#define DH_UPLOAD_SHELTER_ALARM             0x4003           // Ƶڵ
#define DH_UPLOAD_SOUND_DETECT_ALARM        0x4004           // Ƶⱨ
#define DH_UPLOAD_DISKFULL_ALARM            0x4005           // Ӳ
#define DH_UPLOAD_DISKERROR_ALARM           0x4006           // Ӳ̱
#define DH_UPLOAD_ENCODER_ALARM             0x4007           // 
#define DH_UPLOAD_DECODER_ALARM             0x400B           // 
#define DH_UPLOAD_EVENT                     0x400C           // ʱϴ
#define DH_UPLOAD_IVS                       0x400D           // ܱ, ӦṹALARM_UPLOAD_IVS_INFO
#define DH_UPLOAD_SMOKESENSOR_ALARM         0x400E           // ̸б, ӦṹALARM_UPLOAD_SMOKESENSOR_INFO
#define DH_UPLOAD_ALARM_EX                  0x400F           // ⲿչӦṹ ALARM_UPLOAD_ALARMEX_INFO 
#define DH_UPLOAD_REMOTE_LOGIN_FAILD_ALARM  0x4010           // Զ̵¼ʧܱ, Ӧṹ ALARM_UPLOAD_LOGIN_FAILED_INFO

// Bus״̬Ӧ¼ϱ(CLIENT_AttachBusState)
#define DH_ALARM_BUS_DRIVER_CHECK         0X0001           // ˾ǩ¼(Ӧṹ ALARM_BUS_DRIVER_CHECK_INFO)
#define DH_ALARM_BUS_IMPORT_SITE          0x0002           // վ¼(Ӧṹ ALARM_BUS_IMPORT_SITE_INFO)
#define DH_ALARM_BUS_EXPORT_SITE          0x0003           // վ¼(Ӧṹ ALARM_BUS_EXPORT_SITE_INFO)
#define DH_ALARM_BUS_ABNORMAL             0x0004           // 쳣¼(Ӧṹ ALARM_BUS_ABNORMAL_INFO)
#define DH_ALARM_BUS_DOOR_OPEN            0x0005           // Ŵ¼(Ӧṹ ALARM_VEHICLE_DOOR_OPEN_INFO)
#define DH_ALARM_BUS_CUR_MILEAGE          0x0006           // ǰ¼(Ӧṹ ALARM_BUS_CUR_MILEAGE_INFO)
#define DH_ALARM_BUS_CUR_OIL              0x0007           // ǰͺ¼(Ӧṹ ALARM_BUS_CUR_OIL_INFO)
#define DH_ALARM_BUS_LOW_OIL              0x0008           // ¼(Ӧṹ ALARM_BUS_LOW_OIL_INFO)

// 첽ӿڻص
#define RESPONSE_DECODER_CTRL_TV          0x00000001       // ӦCLIENT_CtrlDecTVScreenӿ
#define RESPONSE_DECODER_SWITCH_TV        0x00000002       // ӦCLIENT_SwitchDecTVEncoderӿ
#define RESPONSE_DECODER_PLAYBACK         0x00000003       // ӦCLIENT_DecTVPlaybackӿ

#define RESPONSE_EXCHANGE_DATA            0X00000004       // ӦCLIENT_ExchangeDataӿ
#define RESPONSE_ASYN_QUERY_RECORDFILE    0X00000005       // ӦCLIENT_StartQueryRecordFileӿ

// CLIENT_FileTransmitӿڴļ
#define DH_DEV_UPGRADEFILETRANS_START     0x0000           // ʼļϴ(Ӧṹ DHDEV_UPGRADE_FILE_INFO)
#define DH_DEV_UPGRADEFILETRANS_SEND      0x0001           // ļ  
#define DH_DEV_UPGRADEFILETRANS_STOP      0x0002           // ֹͣļ
#define DH_DEV_BLACKWHITETRANS_START      0x0003           // ʼͺڰ(ӦṹDHDEV_BLACKWHITE_LIST_INFO)
#define DH_DEV_BLACKWHITETRANS_SEND       0x0004           // ͺڰ
#define DH_DEV_BLACKWHITETRANS_STOP       0x0005           // ֹͣͺڰ 
#define DH_DEV_BLACKWHITE_LOAD            0x0006           // غڰ(ӦṹDHDEV_LOAD_BLACKWHITE_LIST_INFO)
#define DH_DEV_BLACKWHITE_LOAD_STOP       0x0007           // ֹͣغڰ
#define DH_DEV_FILETRANS_STOP             0x002B           // ֹͣļϴ
#define DH_DEV_FILETRANS_BURN             0x002C           // ¼ļϴ


// ֱбֱ롢
#define DH_CAPTURE_SIZE_D1                0x00000001
#define DH_CAPTURE_SIZE_HD1               0x00000002
#define DH_CAPTURE_SIZE_BCIF              0x00000004
#define DH_CAPTURE_SIZE_CIF               0x00000008
#define DH_CAPTURE_SIZE_QCIF              0x00000010    
#define DH_CAPTURE_SIZE_VGA               0x00000020    
#define DH_CAPTURE_SIZE_QVGA              0x00000040
#define DH_CAPTURE_SIZE_SVCD              0x00000080
#define DH_CAPTURE_SIZE_QQVGA             0x00000100
#define DH_CAPTURE_SIZE_SVGA              0x00000200
#define DH_CAPTURE_SIZE_XVGA              0x00000400
#define DH_CAPTURE_SIZE_WXGA              0x00000800
#define DH_CAPTURE_SIZE_SXGA              0x00001000
#define DH_CAPTURE_SIZE_WSXGA             0x00002000   
#define DH_CAPTURE_SIZE_UXGA              0x00004000
#define DH_CAPTURE_SIZE_WUXGA             0x00008000
#define DH_CAPTURE_SIZE_LFT               0x00010000
#define DH_CAPTURE_SIZE_720               0x00020000
#define DH_CAPTURE_SIZE_1080              0x00040000
#define DH_CAPTURE_SIZE_1_3M              0x00080000
#define DH_CAPTURE_SIZE_2M                0x00100000
#define DH_CAPTURE_SIZE_5M                0x00200000
#define DH_CAPTURE_SIZE_3M                0x00400000                
#define DH_CAPTURE_SIZE_5_0M              0x00800000
#define DH_CPTRUTE_SIZE_1_2M              0x01000000    
#define DH_CPTRUTE_SIZE_1408_1024         0x02000000    
#define DH_CPTRUTE_SIZE_8M                0x04000000    
#define DH_CPTRUTE_SIZE_2560_1920         0x08000000
#define DH_CAPTURE_SIZE_960H              0x10000000
#define DH_CAPTURE_SIZE_960_720           0x20000000

// ģʽбģʽ롢
#define DH_CAPTURE_COMP_DIVX_MPEG4        0x00000001
#define DH_CAPTURE_COMP_MS_MPEG4          0x00000002
#define DH_CAPTURE_COMP_MPEG2             0x00000004
#define DH_CAPTURE_COMP_MPEG1             0x00000008
#define DH_CAPTURE_COMP_H263              0x00000010
#define DH_CAPTURE_COMP_MJPG              0x00000020
#define DH_CAPTURE_COMP_FCC_MPEG4         0x00000040
#define DH_CAPTURE_COMP_H264              0x00000080

// 뱨롢
#define DH_ALARM_UPLOAD                   0x00000001
#define DH_ALARM_RECORD                   0x00000002
#define DH_ALARM_PTZ                      0x00000004
#define DH_ALARM_MAIL                     0x00000008
#define DH_ALARM_TOUR                     0x00000010
#define DH_ALARM_TIP                      0x00000020
#define DH_ALARM_OUT                      0x00000040
#define DH_ALARM_FTP_UL                   0x00000080
#define DH_ALARM_BEEP                     0x00000100
#define DH_ALARM_VOICE                    0x00000200
#define DH_ALARM_SNAP                     0x00000400

// "ָĬ"룬ɽ롢
#define DH_RESTORE_COMMON                 0x00000001       // ͨ
#define DH_RESTORE_CODING                 0x00000002       // 
#define DH_RESTORE_VIDEO                  0x00000004       // ¼
#define DH_RESTORE_COMM                   0x00000008       // 
#define DH_RESTORE_NETWORK                0x00000010       // 
#define DH_RESTORE_ALARM                  0x00000020       // 
#define DH_RESTORE_VIDEODETECT            0x00000040       // Ƶ
#define DH_RESTORE_PTZ                    0x00000080       // ̨
#define DH_RESTORE_OUTPUTMODE             0x00000100       // ģʽ
#define DH_RESTORE_CHANNELNAME            0x00000200       // ͨ
#define DH_RESTORE_VIDEOINOPTIONS         0x00000400       // ͷ
#define DH_RESTORE_CPS                    0x00000800       // ܽͨ
#define DH_RESTORE_INTELLIGENT            0x00001000       // Ƶ
#define DH_RESTORE_REMOTEDEVICE           0x00002000       // Զ豸
#define DH_RESTORE_DECODERVIDEOOUT        0x00004000       // Ѳ
#define DH_RESTORE_LINKMODE               0x00008000       // ģʽ
#define DH_RESTORE_COMPOSITE              0x00010000       // ں    
#define DH_RESTORE_ALL                    0x80000000       // ȫ

// ̨б--ĸֽ
#define PTZ_DIRECTION                     0x00000001       // 
#define PTZ_ZOOM                          0x00000002       // 䱶
#define PTZ_FOCUS                         0x00000004       // ۽
#define PTZ_IRIS                          0x00000008       // Ȧ
#define PTZ_ALARM                         0x00000010       // 
#define PTZ_LIGHT                         0x00000020       // ƹ
#define PTZ_SETPRESET                     0x00000040       // Ԥõ
#define PTZ_CLEARPRESET                   0x00000080       // Ԥõ
#define PTZ_GOTOPRESET                    0x00000100       // תԤõ
#define PTZ_AUTOPANON                     0x00000200       // ˮƽʼ
#define PTZ_AUTOPANOFF                    0x00000400       // ˮƽ
#define PTZ_SETLIMIT                      0x00000800       // ñ߽
#define PTZ_AUTOSCANON                    0x00001000       // Զɨ迪ʼ
#define PTZ_AUTOSCANOFF                   0x00002000       // Զɨ迪ֹͣ
#define PTZ_ADDTOUR                       0x00004000       // Ѳ
#define PTZ_DELETETOUR                    0x00008000       // ɾѲ
#define PTZ_STARTTOUR                     0x00010000       // ʼѲ
#define PTZ_STOPTOUR                      0x00020000       // Ѳ
#define PTZ_CLEARTOUR                     0x00040000       // ɾѲ
#define PTZ_SETPATTERN                    0x00080000       // ģʽ
#define PTZ_STARTPATTERN                  0x00100000       // ʼģʽ
#define PTZ_STOPPATTERN                   0x00200000       // ֹͣģʽ
#define PTZ_CLEARPATTERN                  0x00400000       // ģʽ
#define PTZ_POSITION                      0x00800000       // ٶλ
#define PTZ_AUX                           0x01000000       // 
#define PTZ_MENU                          0x02000000       // ˵
#define PTZ_EXIT                          0x04000000       // ˳˵
#define PTZ_ENTER                         0x08000000       // ȷ
#define PTZ_ESC                           0x10000000       // ȡ
#define PTZ_MENUUPDOWN                    0x20000000       // ˵²
#define PTZ_MENULEFTRIGHT                 0x40000000       // ˵Ҳ
#define PTZ_OPT_NUM                       0x80000000       // ĸ

// ĸֽ
#define PTZ_DEV                           0x00000001       // ̨
#define PTZ_MATRIX                        0x00000002       // 

// ץͼƵ
#define CODETYPE_MPEG4                    0
#define CODETYPE_H264                     1
#define CODETYPE_JPG                      2

// б
#define DH_CAPTURE_BRC_CBR                0
#define DH_CAPTURE_BRC_VBR                1
//#define DH_CAPTURE_BRC_MBR              2

// ֡붨
#define FRAME_TYPE_MOTION                       0x00000001       // ֡

// ܷ¼
#define EVENT_IVS_ALL                           0x00000001        // ¼
#define EVENT_IVS_CROSSLINEDETECTION            0x00000002        // ¼
#define EVENT_IVS_CROSSREGIONDETECTION          0x00000003        // ¼
#define EVENT_IVS_PASTEDETECTION                0x00000004        // ¼
#define EVENT_IVS_LEFTDETECTION                 0x00000005        // Ʒ¼
#define EVENT_IVS_STAYDETECTION                 0x00000006        // ͣ¼
#define EVENT_IVS_WANDERDETECTION               0x00000007        // ǻ¼
#define EVENT_IVS_PRESERVATION                  0x00000008        // Ʒȫ¼
#define EVENT_IVS_MOVEDETECTION                 0x00000009        // ƶ¼
#define EVENT_IVS_TAILDETECTION                 0x0000000A        // β¼
#define EVENT_IVS_RIOTERDETECTION               0x0000000B        // ¼
#define EVENT_IVS_FIREDETECTION                 0x0000000C        // ¼
#define EVENT_IVS_SMOKEDETECTION                0x0000000D        // ¼
#define EVENT_IVS_FIGHTDETECTION                0x0000000E        // Ź¼
#define EVENT_IVS_FLOWSTAT                      0x0000000F        // ͳ¼
#define EVENT_IVS_NUMBERSTAT                    0x00000010        // ͳ¼
#define EVENT_IVS_CAMERACOVERDDETECTION         0x00000011        // ͷ¼
#define EVENT_IVS_CAMERAMOVEDDETECTION          0x00000012        // ͷƶ¼
#define EVENT_IVS_VIDEOABNORMALDETECTION        0x00000013        // Ƶ쳣¼
#define EVENT_IVS_VIDEOBADDETECTION             0x00000014        // Ƶ¼
#define EVENT_IVS_TRAFFICCONTROL                0x00000015        // ͨ¼
#define EVENT_IVS_TRAFFICACCIDENT               0x00000016        // ͨ¹¼
#define EVENT_IVS_TRAFFICJUNCTION               0x00000017        // ͨ·¼----Ϲ
#define EVENT_IVS_TRAFFICGATE                   0x00000018        // ͨ¼----Ϲ
#define EVENT_TRAFFICSNAPSHOT                   0x00000019        // ͨץ¼
#define EVENT_IVS_FACEDETECT                    0x0000001A        // ¼ 
#define EVENT_IVS_TRAFFICJAM                    0x0000001B        // ͨӵ¼
#define EVENT_IVS_TRAFFIC_RUNREDLIGHT           0x00000100        // ͨΥ-¼
#define EVENT_IVS_TRAFFIC_OVERLINE              0x00000101        // ͨΥ-ѹ¼
#define EVENT_IVS_TRAFFIC_RETROGRADE            0x00000102        // ͨΥ-¼
#define EVENT_IVS_TRAFFIC_TURNLEFT              0x00000103        // ͨΥ-Υת
#define EVENT_IVS_TRAFFIC_TURNRIGHT             0x00000104        // ͨΥ-Υת
#define EVENT_IVS_TRAFFIC_UTURN                 0x00000105        // ͨΥ-Υµͷ
#define EVENT_IVS_TRAFFIC_OVERSPEED             0x00000106        // ͨΥ-
#define EVENT_IVS_TRAFFIC_UNDERSPEED            0x00000107        // ͨΥ-
#define EVENT_IVS_TRAFFIC_PARKING               0x00000108        // ͨΥ-Υͣ
#define EVENT_IVS_TRAFFIC_WRONGROUTE            0x00000109        // ͨΥ-ʻ
#define EVENT_IVS_TRAFFIC_CROSSLANE             0x0000010A        // ͨΥ-Υ±
#define EVENT_IVS_TRAFFIC_OVERYELLOWLINE        0x0000010B        // ͨΥ-ѹ 
#define EVENT_IVS_TRAFFIC_DRIVINGONSHOULDER     0x0000010C        // ͨΥ-·ʻ¼   
#define EVENT_IVS_TRAFFIC_YELLOWPLATEINLANE     0x0000010E        // ͨΥ-Ƴռ¼
#define EVENT_IVS_TRAFFIC_PEDESTRAINPRIORITY    0x0000010F        // ͨΥ-¼
#define EVENT_IVS_CROSSFENCEDETECTION           0x0000011F        // ԽΧ¼
#define EVENT_IVS_ELECTROSPARKDETECTION         0X00000110        // ¼
#define EVENT_IVS_TRAFFIC_NOPASSING             0x00000111        // ͨΥ-ֹͨ¼
#define EVENT_IVS_ABNORMALRUNDETECTION          0x00000112        // 쳣¼
#define EVENT_IVS_RETROGRADEDETECTION           0x00000113        // Ա¼
#define EVENT_IVS_INREGIONDETECTION             0x00000114        // ڼ¼
#define EVENT_IVS_TAKENAWAYDETECTION            0x00000115        // Ʒ¼
#define EVENT_IVS_PARKINGDETECTION              0x00000116        // Ƿͣ¼
#define EVENT_IVS_FACERECOGNITION               0x00000117        // ʶ¼
#define EVENT_IVS_TRAFFIC_MANUALSNAP            0x00000118        // ֶͨץ¼
#define EVENT_IVS_TRAFFIC_FLOWSTATE             0x00000119        // ͨͳ¼
#define EVENT_IVS_TRAFFIC_STAY                  0x0000011A        // ͨ¼
#define EVENT_IVS_TRAFFIC_VEHICLEINROUTE        0x0000011B        // гռ¼
#define EVENT_ALARM_MOTIONDETECT                0x0000011C        // Ƶƶ¼
#define EVENT_ALARM_LOCALALARM                  0x0000011D        // ⲿ¼
#define EVENT_IVS_PRISONERRISEDETECTION         0x0000011E        // ¼
#define EVENT_IVS_TRAFFIC_TOLLGATE              0x00000120        // ͨΥ-¼----¹
#define EVENT_IVS_DENSITYDETECTION              0x00000121        // Աܼȼ
#define EVENT_IVS_VIDEODIAGNOSIS                0x00000122        // ƵϽ¼
#define EVENT_IVS_QUEUEDETECTION                0x00000123        // ŶӼⱨ¼
#define EVENT_IVS_TRAFFIC_VEHICLEINBUSROUTE     0x00000124        // ռù¼
#define EVENT_IVS_TRAFFIC_BACKING               0x00000125        // Υµ¼
#define EVENT_IVS_AUDIO_ABNORMALDETECTION       0x00000126        // 쳣
#define EVENT_IVS_TRAFFIC_RUNYELLOWLIGHT        0x00000127        // ͨΥ-Ƶ¼
#define EVENT_IVS_CLIMBDETECTION                0x00000128        // ʸ߼¼
#define EVENT_IVS_LEAVEDETECTION                0x00000129        // ڼ¼
#define EVENT_IVS_TRAFFIC_PARKINGONYELLOWBOX    0x0000012A        // ץ¼
#define EVENT_IVS_TRAFFIC_PARKINGSPACEPARKING   0x0000012B        // λг¼
#define EVENT_IVS_TRAFFIC_PARKINGSPACENOPARKING 0x0000012C        // λ޳¼    
#define EVENT_IVS_TRAFFIC_PEDESTRAIN            0x0000012D        // ͨ¼
#define EVENT_IVS_TRAFFIC_THROW                 0x0000012E        // ͨƷ¼
#define EVENT_IVS_TRAFFIC_IDLE                  0x0000012F        // ͨ¼
#define EVENT_ALARM_VEHICLEACC                  0x00000130        // ACCϵ籨¼
#define EVENT_ALARM_VEHICLE_TURNOVER            0x00000131        // ෭¼
#define EVENT_ALARM_VEHICLE_COLLISION           0x00000132        // ײ¼
#define EVENT_ALARM_VEHICLE_LARGE_ANGLE         0x00000133        // ͷǶŤת¼
#define EVENT_IVS_TRAFFIC_PARKINGSPACEOVERLINE  0x00000134        // λѹ¼
#define EVENT_IVS_MULTISCENESWITCH              0x00000135        // ೡл¼
#define EVENT_IVS_TRAFFIC_RESTRICTED_PLATE      0X00000136        // ޳¼
#define EVENT_IVS_TRAFFIC_OVERSTOPLINE          0X00000137        // ѹֹͣ¼
#define EVENT_IVS_TRAFFIC_WITHOUT_SAFEBELT      0x00000138        // ͨδϵȫ¼
#define EVENT_IVS_TRAFFIC_DRIVER_SMOKING        0x00000139        // ʻԱ¼
#define EVENT_IVS_TRAFFIC_DRIVER_CALLING        0x0000013A        // ʻԱ绰¼
#define EVENT_IVS_OBJECT_DETECTION              0x00000141        // ¼
#define EVENT_ALARM_ANALOGALARM                 0x00000150        // ģͨı¼(ӦDEV_EVENT_ALARM_ANALOGALRM_INFO)
#define EVENT_IVS_CROSSLINEDETECTION_EX			0x00000151		  // չ¼
#define EVENT_ALARM_COMMON                      0x00000152        // ͨ¼
#define EVENT_ALARM_VIDEOBLIND                  0x00000153        // Ƶڵ¼
#define EVENT_ALARM_VIDEOLOSS                   0x00000154        // Ƶʧ¼

#define EVENT_IVS_TRAFFIC_ALL                   0x000001FF        // trafficͷ¼Ŀǰָ
                                                                  // EVENT_IVS_TRAFFICCONTROL -> EVENT_TRAFFICSNAPSHOT
                                                                  // EVENT_IVS_TRAFFIC_RUNREDLIGHT -> EVENT_IVS_TRAFFIC_UNDERSPEED
#define EVENT_IVS_VIDEOANALYSE                  0x00000200        // ܷ¼ 

//ͳ¼ʹú
#define FLOWSTAT_ADDR_NAME                      16                //еص

//ԽӿCLIENT_OperateTrafficListַȶ
#define DH_TARFFIC_NAME_LEN                     16                
#define DH_CREATE_TIME_LEN                      32
#define DH_AUTHORITY_NUM                        16


// ʹţӦCLIENT_GetLastErrorӿڵķֵ
#define _EC(x)                                  (0x80000000|x)
#define NET_NOERROR                             0                 // ûд
#define NET_ERROR                               -1                // δ֪
#define NET_SYSTEM_ERROR                        _EC(1)            // Windowsϵͳ
#define NET_NETWORK_ERROR                       _EC(2)            // 󣬿Ϊ糬ʱ
#define NET_DEV_VER_NOMATCH                     _EC(3)            // 豸Э鲻ƥ
#define NET_INVALID_HANDLE                      _EC(4)            // Ч
#define NET_OPEN_CHANNEL_ERROR                  _EC(5)            // ͨʧ
#define NET_CLOSE_CHANNEL_ERROR                 _EC(6)            // رͨʧ
#define NET_ILLEGAL_PARAM                       _EC(7)            // ûϷ
#define NET_SDK_INIT_ERROR                      _EC(8)            // SDKʼ
#define NET_SDK_UNINIT_ERROR                    _EC(9)            // SDK
#define NET_RENDER_OPEN_ERROR                   _EC(10)           // renderԴ
#define NET_DEC_OPEN_ERROR                      _EC(11)           // 򿪽
#define NET_DEC_CLOSE_ERROR                     _EC(12)           // رս
#define NET_MULTIPLAY_NOCHANNEL                 _EC(13)           // ໭Ԥм⵽ͨΪ0
#define NET_TALK_INIT_ERROR                     _EC(14)           // ¼ʼʧ
#define NET_TALK_NOT_INIT                       _EC(15)           // ¼δʼ
#define NET_TALK_SENDDATA_ERROR                 _EC(16)           // Ƶݳ
#define NET_REAL_ALREADY_SAVING                 _EC(17)           // ʵʱѾڱ״̬
#define NET_NOT_SAVING                          _EC(18)           // δʵʱ
#define NET_OPEN_FILE_ERROR                     _EC(19)           // ļ
#define NET_PTZ_SET_TIMER_ERROR                 _EC(20)           // ̨ƶʱʧ
#define NET_RETURN_DATA_ERROR                   _EC(21)           // ԷݵУ
#define NET_INSUFFICIENT_BUFFER                 _EC(22)           // û㹻Ļ
#define NET_NOT_SUPPORTED                       _EC(23)           // ǰSDKδָ֧ù
#define NET_NO_RECORD_FOUND                     _EC(24)           // ѯ¼
#define NET_NOT_AUTHORIZED                      _EC(25)           // ޲Ȩ
#define NET_NOT_NOW                             _EC(26)           // ʱ޷ִ
#define NET_NO_TALK_CHANNEL                     _EC(27)           // δֶԽͨ
#define NET_NO_AUDIO                            _EC(28)           // δƵ
#define NET_NO_INIT                             _EC(29)           // SDKδʼ
#define NET_DOWNLOAD_END                        _EC(30)           // ѽ
#define NET_EMPTY_LIST                          _EC(31)           // ѯΪ
#define NET_ERROR_GETCFG_SYSATTR                _EC(32)           // ȡϵͳʧ
#define NET_ERROR_GETCFG_SERIAL                 _EC(33)           // ȡкʧ
#define NET_ERROR_GETCFG_GENERAL                _EC(34)           // ȡʧ
#define NET_ERROR_GETCFG_DSPCAP                 _EC(35)           // ȡDSPʧ
#define NET_ERROR_GETCFG_NETCFG                 _EC(36)           // ȡʧ
#define NET_ERROR_GETCFG_CHANNAME               _EC(37)           // ȡͨʧ
#define NET_ERROR_GETCFG_VIDEO                  _EC(38)           // ȡƵʧ
#define NET_ERROR_GETCFG_RECORD                 _EC(39)           // ȡ¼ʧ
#define NET_ERROR_GETCFG_PRONAME                _EC(40)           // ȡЭʧ
#define NET_ERROR_GETCFG_FUNCNAME               _EC(41)           // ȡ232ڹʧ
#define NET_ERROR_GETCFG_485DECODER             _EC(42)           // ȡʧ
#define NET_ERROR_GETCFG_232COM                 _EC(43)           // ȡ232ʧ
#define NET_ERROR_GETCFG_ALARMIN                _EC(44)           // ȡⲿʧ
#define NET_ERROR_GETCFG_ALARMDET               _EC(45)           // ȡ̬ⱨʧ
#define NET_ERROR_GETCFG_SYSTIME                _EC(46)           // ȡ豸ʱʧ
#define NET_ERROR_GETCFG_PREVIEW                _EC(47)           // ȡԤʧ
#define NET_ERROR_GETCFG_AUTOMT                 _EC(48)           // ȡԶάʧ
#define NET_ERROR_GETCFG_VIDEOMTRX              _EC(49)           // ȡƵʧ
#define NET_ERROR_GETCFG_COVER                  _EC(50)           // ȡڵʧ
#define NET_ERROR_GETCFG_WATERMAKE              _EC(51)           // ȡͼˮӡʧ
#define NET_ERROR_GETCFG_MULTICAST              _EC(52)           // ȡʧλã鲥˿ڰͨ
#define NET_ERROR_SETCFG_GENERAL                _EC(55)           // ޸ĳʧ
#define NET_ERROR_SETCFG_NETCFG                 _EC(56)           // ޸ʧ
#define NET_ERROR_SETCFG_CHANNAME               _EC(57)           // ޸ͨʧ
#define NET_ERROR_SETCFG_VIDEO                  _EC(58)           // ޸Ƶʧ
#define NET_ERROR_SETCFG_RECORD                 _EC(59)           // ޸¼ʧ
#define NET_ERROR_SETCFG_485DECODER             _EC(60)           // ޸Ľʧ
#define NET_ERROR_SETCFG_232COM                 _EC(61)           // ޸232ʧ
#define NET_ERROR_SETCFG_ALARMIN                _EC(62)           // ޸ⲿ뱨ʧ
#define NET_ERROR_SETCFG_ALARMDET               _EC(63)           // ޸Ķ̬ⱨʧ
#define NET_ERROR_SETCFG_SYSTIME                _EC(64)           // ޸豸ʱʧ
#define NET_ERROR_SETCFG_PREVIEW                _EC(65)           // ޸Ԥʧ
#define NET_ERROR_SETCFG_AUTOMT                 _EC(66)           // ޸Զάʧ
#define NET_ERROR_SETCFG_VIDEOMTRX              _EC(67)           // ޸Ƶʧ
#define NET_ERROR_SETCFG_COVER                  _EC(68)           // ޸ڵʧ
#define NET_ERROR_SETCFG_WATERMAKE              _EC(69)           // ޸ͼˮӡʧ
#define NET_ERROR_SETCFG_WLAN                   _EC(70)           // ޸Ϣʧ
#define NET_ERROR_SETCFG_WLANDEV                _EC(71)           // ѡ豸ʧ
#define NET_ERROR_SETCFG_REGISTER               _EC(72)           // ޸עʧ
#define NET_ERROR_SETCFG_CAMERA                 _EC(73)           // ޸ͷʧ
#define NET_ERROR_SETCFG_INFRARED               _EC(74)           // ޸ĺⱨʧ
#define NET_ERROR_SETCFG_SOUNDALARM             _EC(75)           // ޸Ƶʧ
#define NET_ERROR_SETCFG_STORAGE                _EC(76)           // ޸Ĵ洢λʧ
#define NET_AUDIOENCODE_NOTINIT                 _EC(77)           // Ƶӿûгɹʼ
#define NET_DATA_TOOLONGH                       _EC(78)           // ݹ
#define NET_UNSUPPORTED                         _EC(79)           // 豸ָ֧ò
#define NET_DEVICE_BUSY                         _EC(80)           // 豸Դ
#define NET_SERVER_STARTED                      _EC(81)           // Ѿ
#define NET_SERVER_STOPPED                      _EC(82)           // δɹ
#define NET_LISTER_INCORRECT_SERIAL             _EC(83)           // к
#define NET_QUERY_DISKINFO_FAILED               _EC(84)           // ȡӲϢʧ
#define NET_ERROR_GETCFG_SESSION                _EC(85)           // ȡSessionϢ
#define NET_USER_FLASEPWD_TRYTIME               _EC(86)           // 󳬹ƴ
#define NET_LOGIN_ERROR_PASSWORD                _EC(100)          // 벻ȷ
#define NET_LOGIN_ERROR_USER                    _EC(101)          // ʻ
#define NET_LOGIN_ERROR_TIMEOUT                 _EC(102)          // ȴ¼سʱ
#define NET_LOGIN_ERROR_RELOGGIN                _EC(103)          // ʺѵ¼
#define NET_LOGIN_ERROR_LOCKED                  _EC(104)          // ʺѱ
#define NET_LOGIN_ERROR_BLACKLIST               _EC(105)          // ʺѱΪ
#define NET_LOGIN_ERROR_BUSY                    _EC(106)          // Դ㣬ϵͳæ
#define NET_LOGIN_ERROR_CONNECT                 _EC(107)          // ¼豸ʱ粢
#define NET_LOGIN_ERROR_NETWORK                 _EC(108)          // ʧ
#define NET_LOGIN_ERROR_SUBCONNECT              _EC(109)          // ¼豸ɹ޷Ƶͨ״
#define NET_LOGIN_ERROR_MAXCONNECT              _EC(110)          // 
#define NET_LOGIN_ERROR_PROTOCOL3_ONLY          _EC(111)          // ֻ֧3Э
#define NET_LOGIN_ERROR_UKEY_LOST               _EC(112)          // δUܻUϢ
#define NET_LOGIN_ERROR_NO_AUTHORIZED           _EC(113)          // ͻIPַûе¼Ȩ  
#define NET_RENDER_SOUND_ON_ERROR               _EC(120)          // RenderƵ
#define NET_RENDER_SOUND_OFF_ERROR              _EC(121)          // RenderرƵ
#define NET_RENDER_SET_VOLUME_ERROR             _EC(122)          // Render
#define NET_RENDER_ADJUST_ERROR                 _EC(123)          // Renderû
#define NET_RENDER_PAUSE_ERROR                  _EC(124)          // Renderͣų
#define NET_RENDER_SNAP_ERROR                   _EC(125)          // Renderץͼ
#define NET_RENDER_STEP_ERROR                   _EC(126)          // Renderⲽ
#define NET_RENDER_FRAMERATE_ERROR              _EC(127)          // Render֡ʳ
#define NET_RENDER_DISPLAYREGION_ERROR          _EC(128)          // Renderʾ
#define NET_GROUP_EXIST                         _EC(140)          // Ѵ
#define NET_GROUP_NOEXIST                       _EC(141)          // 
#define NET_GROUP_RIGHTOVER                     _EC(142)          // Ȩ޳ȨбΧ
#define NET_GROUP_HAVEUSER                      _EC(143)          // ûɾ
#define NET_GROUP_RIGHTUSE                      _EC(144)          // ĳȨޱûʹãܳ
#define NET_GROUP_SAMENAME                      _EC(145)          // ͬظ
#define NET_USER_EXIST                          _EC(146)          // ûѴ
#define NET_USER_NOEXIST                        _EC(147)          // û
#define NET_USER_RIGHTOVER                      _EC(148)          // ûȨ޳Ȩ
#define NET_USER_PWD                            _EC(149)          // ʺţ޸
#define NET_USER_FLASEPWD                       _EC(150)          // 벻ȷ
#define NET_USER_NOMATCHING                     _EC(151)          // 벻ƥ
#define NET_USER_INUSE                          _EC(152)          // ˺ʹ
#define NET_ERROR_GETCFG_ETHERNET               _EC(300)          // ȡʧ
#define NET_ERROR_GETCFG_WLAN                   _EC(301)          // ȡϢʧ
#define NET_ERROR_GETCFG_WLANDEV                _EC(302)          // ȡ豸ʧ
#define NET_ERROR_GETCFG_REGISTER               _EC(303)          // ȡעʧ
#define NET_ERROR_GETCFG_CAMERA                 _EC(304)          // ȡͷʧ
#define NET_ERROR_GETCFG_INFRARED               _EC(305)          // ȡⱨʧ
#define NET_ERROR_GETCFG_SOUNDALARM             _EC(306)          // ȡƵʧ
#define NET_ERROR_GETCFG_STORAGE                _EC(307)          // ȡ洢λʧ
#define NET_ERROR_GETCFG_MAIL                   _EC(308)          // ȡʼʧ
#define NET_CONFIG_DEVBUSY                      _EC(309)          // ʱ޷
#define NET_CONFIG_DATAILLEGAL                  _EC(310)          // ݲϷ
#define NET_ERROR_GETCFG_DST                    _EC(311)          // ȡʱʧ
#define NET_ERROR_SETCFG_DST                    _EC(312)          // ʱʧ
#define NET_ERROR_GETCFG_VIDEO_OSD              _EC(313)          // ȡƵOSDʧ
#define NET_ERROR_SETCFG_VIDEO_OSD              _EC(314)          // ƵOSDʧ
#define NET_ERROR_GETCFG_GPRSCDMA               _EC(315)          // ȡCDMA\GPRSʧ
#define NET_ERROR_SETCFG_GPRSCDMA               _EC(316)          // CDMA\GPRSʧ
#define NET_ERROR_GETCFG_IPFILTER               _EC(317)          // ȡIPʧ
#define NET_ERROR_SETCFG_IPFILTER               _EC(318)          // IPʧ
#define NET_ERROR_GETCFG_TALKENCODE             _EC(319)          // ȡԽʧ
#define NET_ERROR_SETCFG_TALKENCODE             _EC(320)          // Խʧ
#define NET_ERROR_GETCFG_RECORDLEN              _EC(321)          // ȡ¼ʧ
#define NET_ERROR_SETCFG_RECORDLEN              _EC(322)          // ¼ʧ
#define NET_DONT_SUPPORT_SUBAREA                _EC(323)          // ֧Ӳ̷
#define NET_ERROR_GET_AUTOREGSERVER             _EC(324)          // ȡ豸עϢʧ
#define NET_ERROR_CONTROL_AUTOREGISTER          _EC(325)          // עضע
#define NET_ERROR_DISCONNECT_AUTOREGISTER       _EC(326)          // Ͽע
#define NET_ERROR_GETCFG_MMS                    _EC(327)          // ȡmmsʧ
#define NET_ERROR_SETCFG_MMS                    _EC(328)          // mmsʧ
#define NET_ERROR_GETCFG_SMSACTIVATION          _EC(329)          // ȡżʧ
#define NET_ERROR_SETCFG_SMSACTIVATION          _EC(330)          // öżʧ
#define NET_ERROR_GETCFG_DIALINACTIVATION       _EC(331)          // ȡżʧ
#define NET_ERROR_SETCFG_DIALINACTIVATION       _EC(332)          // òżʧ
#define NET_ERROR_GETCFG_VIDEOOUT               _EC(333)          // ѯƵʧ
#define NET_ERROR_SETCFG_VIDEOOUT               _EC(334)          // Ƶʧ
#define NET_ERROR_GETCFG_OSDENABLE              _EC(335)          // ȡosdʹʧ
#define NET_ERROR_SETCFG_OSDENABLE              _EC(336)          // osdʹʧ
#define NET_ERROR_SETCFG_ENCODERINFO            _EC(337)          // ͨǰ˱ʧ
#define NET_ERROR_GETCFG_TVADJUST               _EC(338)          // ȡTVʧ
#define NET_ERROR_SETCFG_TVADJUST               _EC(339)          // TVʧ
#define NET_ERROR_CONNECT_FAILED                _EC(340)          // ʧ
#define NET_ERROR_SETCFG_BURNFILE               _EC(341)          // ¼ļϴʧ
#define NET_ERROR_SNIFFER_GETCFG                _EC(342)          // ȡץϢʧ
#define NET_ERROR_SNIFFER_SETCFG                _EC(343)          // ץϢʧ
#define NET_ERROR_DOWNLOADRATE_GETCFG           _EC(344)          // ѯϢʧ
#define NET_ERROR_DOWNLOADRATE_SETCFG           _EC(345)          // Ϣʧ
#define NET_ERROR_SEARCH_TRANSCOM               _EC(346)          // ѯڲʧ
#define NET_ERROR_GETCFG_POINT                  _EC(347)          // ȡԤƵϢ
#define NET_ERROR_SETCFG_POINT                  _EC(348)          // ԤƵϢ
#define NET_SDK_LOGOUT_ERROR                    _EC(349)          // SDKûǳ豸
#define NET_ERROR_GET_VEHICLE_CFG               _EC(350)          // ȡʧ
#define NET_ERROR_SET_VEHICLE_CFG               _EC(351)          // óʧ
#define NET_ERROR_GET_ATM_OVERLAY_CFG           _EC(352)          // ȡatmʧ
#define NET_ERROR_SET_ATM_OVERLAY_CFG           _EC(353)          // atmʧ
#define NET_ERROR_GET_ATM_OVERLAY_ABILITY       _EC(354)          // ȡatmʧ
#define NET_ERROR_GET_DECODER_TOUR_CFG          _EC(355)          // ȡѲʧ
#define NET_ERROR_SET_DECODER_TOUR_CFG          _EC(356)          // ýѲʧ
#define NET_ERROR_CTRL_DECODER_TOUR             _EC(357)          // ƽѲʧ
#define NET_GROUP_OVERSUPPORTNUM                _EC(358)          // 豸֧ûĿ
#define NET_USER_OVERSUPPORTNUM                 _EC(359)          // 豸֧ûĿ
#define NET_ERROR_GET_SIP_CFG                   _EC(368)          // ȡSIPʧ
#define NET_ERROR_SET_SIP_CFG                   _EC(369)          // SIPʧ
#define NET_ERROR_GET_SIP_ABILITY               _EC(370)          // ȡSIPʧ
#define NET_ERROR_GET_WIFI_AP_CFG               _EC(371)          // ȡWIFI apʧ
#define NET_ERROR_SET_WIFI_AP_CFG               _EC(372)          // WIFI apʧ
#define NET_ERROR_GET_DECODE_POLICY             _EC(373)          // ȡʧ
#define NET_ERROR_SET_DECODE_POLICY             _EC(374)          // ýʧ
#define NET_ERROR_TALK_REJECT                   _EC(375)          // ܾԽ
#define NET_ERROR_TALK_OPENED                   _EC(376)          // Խͻ˴
#define NET_ERROR_TALK_RESOURCE_CONFLICIT       _EC(377)          // Դͻ
#define NET_ERROR_TALK_UNSUPPORTED_ENCODE       _EC(378)          // ֵ֧ʽ
#define NET_ERROR_TALK_RIGHTLESS                _EC(379)          // Ȩ
#define NET_ERROR_TALK_FAILED                   _EC(380)          // Խʧ
#define NET_ERROR_GET_MACHINE_CFG               _EC(381)          // ȡʧ
#define NET_ERROR_SET_MACHINE_CFG               _EC(382)          // ûʧ
#define NET_ERROR_GET_DATA_FAILED               _EC(383)          // 豸޷ȡǰ
#define NET_ERROR_MAC_VALIDATE_FAILED           _EC(384)          // MACַ֤ʧ 
#define NET_ERROR_GET_INSTANCE                  _EC(385)          // ȡʵʧ
#define NET_ERROR_JSON_REQUEST                  _EC(386)          // ɵjasonַ
#define NET_ERROR_JSON_RESPONSE                 _EC(387)          // Ӧjasonַ
#define NET_ERROR_VERSION_HIGHER                _EC(388)          // Э汾ڵǰʹõİ汾
#define NET_SPARE_NO_CAPACITY                   _EC(389)          // ȱʧ, 
#define NET_ERROR_SOURCE_IN_USE                 _EC(390)          // ʾԴռ
#define NET_ERROR_REAVE                         _EC(391)          // ߼ûռͼûԴ
#define NET_ERROR_NETFORBID                     _EC(392)          // ֹ 
#define NET_ERROR_GETCFG_MACFILTER              _EC(393)          // ȡMACʧ
#define NET_ERROR_SETCFG_MACFILTER              _EC(394)          // MACʧ
#define NET_ERROR_GETCFG_IPMACFILTER            _EC(395)          // ȡIP/MACʧ
#define NET_ERROR_SETCFG_IPMACFILTER            _EC(396)          // IP/MACʧ
#define NET_ERROR_OPERATION_OVERTIME            _EC(397)          // ǰʱ 
#define NET_ERROR_SENIOR_VALIDATE_FAILED        _EC(398)          // ߼Уʧ 
#define NET_ERROR_DEVICE_ID_NOT_EXIST           _EC(399)          // 豸ID
#define NET_ERROR_UNSUPPORTED                   _EC(400)          // ֵ֧ǰ
#define NET_ERROR_PROXY_DLLLOAD                 _EC(401)          // ʧ
#define NET_ERROR_PROXY_ILLEGAL_PARAM           _EC(402)          // ûϷ
#define NET_ERROR_PROXY_INVALID_HANDLE          _EC(403)          // Ч
#define NET_ERROR_PROXY_LOGIN_DEVICE_ERROR      _EC(404)          // ǰ豸ʧ
#define NET_ERROR_PROXY_START_SERVER_ERROR      _EC(405)          // ʧ
#define NET_ERROR_SPEAK_FAILED                  _EC(406)          // 󺰻ʧ
#define NET_ERROR_NOT_SUPPORT_F6                _EC(407)          // 豸ִ֧F6ӿڵ
#define NET_ERROR_CD_UNREADY                    _EC(408)          // δ
#define NET_ERROR_DIR_NOT_EXIST                 _EC(409)          // Ŀ¼
#define NET_ERROR_UNSUPPORTED_SPLIT_MODE        _EC(410)          // 豸ֵ֧ķָģʽ
#define NET_ERROR_OPEN_WND_PARAM                _EC(411)          // Ϸ
#define NET_ERROR_LIMITED_WND_COUNT             _EC(412)          // 
#define NET_ERROR_UNMATCHED_REQUEST             _EC(413)          // 뵱ǰģʽƥ
#define NET_RENDER_ENABLELARGEPICADJUSTMENT_ERROR _EC(414)        // RenderøͼڲԳ
#define NET_ERROR_UPGRADE_FAILED                _EC(415)          // 豸ʧ
#define NET_ERROR_NO_TARGET_DEVICE              _EC(416)          // ҲĿ豸
#define NET_ERROR_NO_VERIFY_DEVICE              _EC(417)          // Ҳ֤豸
#define NET_ERROR_CASCADE_RIGHTLESS             _EC(418)          // ޼Ȩ
#define NET_ERROR_LOW_PRIORITY                  _EC(419)          // ȼ
#define NET_ERROR_REMOTE_REQUEST_TIMEOUT        _EC(420)          // Զ豸ʱ
#define NET_ERROR_LIMITED_INPUT_SOURCE          _EC(421)          // Դ·
#define NET_ERROR_SET_LOG_PRINT_INFO            _EC(422)          // ־ӡʧ
#define NET_ERROR_PARAM_DWSIZE_ERROR            _EC(423)          // εdwsizeֶγ
#define NET_ERROR_LIMITED_MONITORWALL_COUNT     _EC(424)          // ǽ

#define NET_ERROR_VISITE_FILE                   _EC(510)          // ļʧ
#define NET_ERROR_DEVICE_STATUS_BUSY            _EC(511)          // 豸æ


/************************************************************************
 ** öٶ
 ***********************************************************************/
//ȡϢ CLIENT_QueryNetStat  ӿʹ
typedef enum tagEM_NET_QUERY_TYPE
{
    NET_APP_DATA_STAT ,     // ȡЭջͳ,(ṹNET_IN_NETAPP_NET_DATA_STAT,ṹNET_OUT_NETAPP_NET_DATA_STAT)
    NET_APP_LINK_STAT ,     // ȡ·״̬,(ṹNET_IN_NETAPP_LINK_STATUS,ṹNET_OUT_NETAPP_LINK_STATUS)
}EM_NET_QUERY_TYPE;

// ץͼ CLIENT_CapturePictureEx ӿʹ
typedef enum tagNET_CAPTURE_FORMATS
{
    NET_CAPTURE_BMP,
    NET_CAPTURE_JPEG,       // 100%JPEG
    NET_CAPTURE_JPEG_70,    // 70%JPEG
    NET_CAPTURE_JPEG_50,
    NET_CAPTURE_JPEG_30,
}NET_CAPTURE_FORMATS;

// 豸
typedef enum tagNET_DEVICE_TYPE 
{
    NET_PRODUCT_NONE = 0,
    NET_DVR_NONREALTIME_MACE,     // ʵʱMACE
    NET_DVR_NONREALTIME,          // ʵʱ
    NET_NVS_MPEG1,                // Ƶ
    NET_DVR_MPEG1_2,              // MPEG1·¼
    NET_DVR_MPEG1_8,              // MPEG1·¼
    NET_DVR_MPEG4_8,              // MPEG4·¼
    NET_DVR_MPEG4_16,             // MPEG4ʮ·¼
    NET_DVR_MPEG4_SX2,            // LBϵ¼
    NET_DVR_MEPG4_ST2,            // GBϵ¼
    NET_DVR_MEPG4_SH2,            // HBϵ¼
    NET_DVR_MPEG4_GBE,            // GBEϵ¼
    NET_DVR_MPEG4_NVSII,          // IIƵ
    NET_DVR_STD_NEW,              // ±׼Э
    NET_DVR_DDNS,                 // DDNS
    NET_DVR_ATM,                  // ATM
    NET_NB_SERIAL,                // ʵʱNBϵл
    NET_LN_SERIAL,                // LNϵвƷ
    NET_BAV_SERIAL,               // BAVϵвƷ
    NET_SDIP_SERIAL,              // SDIPϵвƷ
    NET_IPC_SERIAL,               // IPCϵвƷ
    NET_NVS_B,                    // NVS Bϵ
    NET_NVS_C,                    // NVS Hϵ
    NET_NVS_S,                    // NVS Sϵ
    NET_NVS_E,                    // NVS Eϵ
    NET_DVR_NEW_PROTOCOL,         // QueryDevStateвѯ豸,ַʽ
    NET_NVD_SERIAL,               // 
    NET_DVR_N5,                   // N5
    NET_DVR_MIX_DVR,              // DVR
    NET_SVR_SERIAL,               // SVRϵ
    NET_SVR_BS,                   // SVR-BS
    NET_NVR_SERIAL,               // NVRϵ
    NET_DVR_N51,                  // N51
    NET_ITSE_SERIAL,              // ITSE ܷ
    NET_ITC_SERIAL,               // ܽͨ豸
    NET_HWS_SERIAL,               // ״HWS
    NET_PVR_SERIAL,               // ЯʽƵ¼
    NET_IVS_SERIAL,               // IVSƵϵУ
    NET_IVS_B,                    // ͨƵ
    NET_IVS_F,                    // ʶ
    NET_IVS_V,                    // ƵϷ
    NET_MATRIX_SERIAL,            // 
    NET_DVR_N52,                  // N52
    NET_DVR_N56,                  // N56
    NET_ESS_SERIAL,               // ESS
    NET_IVS_PC,                   // ͳƷ
    NET_PC_NVR,                   // pc-nvr
    NET_DSCON,                    // 
    NET_EVS,                      // Ƶ洢
    NET_EIVS,                     // ǶʽܷƵϵͳ
    NET_DVR_N6,                   // DVR-N6
    NET_UDS,                      // ܽ
    NET_AF6016,                   // б
    NET_AS5008,                   // Ƶ籨
    NET_AH2008,                   // 籨
    NET_A_SERIAL,                 // ϵ
    NET_BSC_SERIAL,               // ŽϵвƷ
    NET_NVS_SERIAL,               // NVSϵвƷ
    NET_VTO_SERIAL,               // VTOϵвƷ
    NET_VTNC_SERIAL,              // VTNCϵвƷ
}NET_DEVICE_TYPE ;

// 
typedef enum __LANGUAGE_TYPE
{
    DH_LANGUAGE_ENGLISH,                // Ӣ    
    DH_LANGUAGE_CHINESE_SIMPLIFIED,     //     
    DH_LANGUAGE_CHINESE_TRADITIONAL,    //     
    DH_LANGUAGE_ITALIAN,                //     
    DH_LANGUAGE_SPANISH,                // 
    DH_LANGUAGE_JAPANESE,               // İ    
    DH_LANGUAGE_RUSSIAN,                // İ        
    DH_LANGUAGE_FRENCH,                 // İ        
    DH_LANGUAGE_GERMAN,                 // İ        
    DH_LANGUAGE_PORTUGUESE,             //     
    DH_LANGUAGE_TURKEY,                 //     
    DH_LANGUAGE_POLISH,                 //     
    DH_LANGUAGE_ROMANIAN,               //     
    DH_LANGUAGE_HUNGARIAN,              //     
    DH_LANGUAGE_FINNISH,                //     
    DH_LANGUAGE_ESTONIAN,               // ɳ    
    DH_LANGUAGE_KOREAN,                 //     
    DH_LANGUAGE_FARSI,                  // ˹     
    DH_LANGUAGE_DANSK,                  // 
    DH_LANGUAGE_CZECHISH,               // ݿ
    DH_LANGUAGE_BULGARIA,               // 
    DH_LANGUAGE_SLOVAKIAN,              // ˹工
    DH_LANGUAGE_SLOVENIA,               // ˹
    DH_LANGUAGE_CROATIAN,               // ޵
    DH_LANGUAGE_DUTCH,                  // 
    DH_LANGUAGE_GREEK,                  // ϣ
    DH_LANGUAGE_UKRAINIAN,              // ڿ
    DH_LANGUAGE_SWEDISH,                // 
    DH_LANGUAGE_SERBIAN,                // ά
    DH_LANGUAGE_VIETNAMESE,             // Խ
    DH_LANGUAGE_LITHUANIAN,             // 
    DH_LANGUAGE_FILIPINO,               // ɱ
    DH_LANGUAGE_ARABIC,                 // 
    DH_LANGUAGE_CATALAN,                // ̩
    DH_LANGUAGE_LATVIAN,                // ά
    DH_LANGUAGE_THAI,                   // ̩
    DH_LANGUAGE_HEBREW,                 // ϣ
    DH_LANGUAGE_Bosnian,                // ˹
} DH_LANGUAGE_TYPE;

// 
typedef enum __EM_UPGRADE_TYPE
{
    DH_UPGRADE_BIOS_TYPE = 1,           // BIOS
    DH_UPGRADE_WEB_TYPE,                // WEB
    DH_UPGRADE_BOOT_YPE,                // BOOT
    DH_UPGRADE_CHARACTER_TYPE,          // ֿ
    DH_UPGRADE_LOGO_TYPE,               // LOGO
    DH_UPGRADE_EXE_TYPE,                // EXE粥
    DH_UPGRADE_DEVCONSTINFO_TYPE,       // 豸Ϣ(磺ӲIDMACк)
    DH_UPGRADE_PERIPHERAL_TYPE,         // Ƭ(糵287оƬ)
    DH_UPGRADE_GEOINFO_TYPE,            // ϢλоƬ
    DH_UPGRADE_MENU,                    // ˵豸ͼƬ
    DH_UPGRADE_ROUTE,                   // ·ļ繫·
    DH_UPGRADE_ROUTE_STATE_AUTO,        // վƵ·׵ıվƵ
    DH_UPGRADE_SCREEN,                  // 繫
} EM_UPGRADE_TYPE;

// ¼(ʱ̬⡢)
typedef enum __REC_TYPE
{
    DH_REC_TYPE_TIM = 0,
    DH_REC_TYPE_MTD,
    DH_REC_TYPE_ALM,
    DH_REC_TYPE_NUM,
} REC_TYPE;

//  
typedef enum __GPRSCDMA_NETWORK_TYPE
{
    DH_TYPE_AUTOSEL = 0,                        // Զѡ
    DH_TYPE_TD_SCDMA,                           // TD-SCDMA 
    DH_TYPE_WCDMA,                              // WCDMA
    DH_TYPE_CDMA_1x,                            // CDMA 1.x
    DH_TYPE_EDGE,                               // GPRS
    DH_TYPE_EVDO,                               // EVDO
    DH_TYPE_WIFI,                               // 
} EM_GPRSCDMA_NETWORK_TYPE;

// ӿͣӦCLIENT_SetSubconnCallBackӿ
typedef enum __EM_INTERFACE_TYPE
{
    DH_INTERFACE_OTHER = 0x00000000,            // δ֪ӿ
    DH_INTERFACE_REALPLAY,                      // ʵʱӽӿ
    DH_INTERFACE_PREVIEW,                       // ໭Ԥӿ
    DH_INTERFACE_PLAYBACK,                      // طŽӿ
    DH_INTERFACE_DOWNLOAD,                      // ؽӿ
    DH_INTERFACE_REALLOADPIC,                   // ͼƬӿ
} EM_INTERFACE_TYPE;

// ƵӶϿ¼
typedef enum _EM_REALPLAY_DISCONNECT_EVENT_TYPE
{
    DISCONNECT_EVENT_REAVE,                     // ʾ߼ûռͼûԴ
    DISCONNECT_EVENT_NETFORBID,                 // ֹ
    DISCONNECT_EVENT_SUBCONNECT,                // ̬ӶϿ
}EM_REALPLAY_DISCONNECT_EVENT_TYPE;

// ¼ļļǩ
typedef enum __EM_EVENT_FILETAG
{
    DH_ATMBEFOREPASTE = 1,                      // ATMǰ
    DH_ATMAFTERPASTE,                           // ATM
}EM_EVENT_FILETAG;

// IPC
typedef enum __EM_IPC_TYPE
{
    DH_IPC_PRIVATE,                                 // ˽
    DH_IPC_AEBELL,                                  // 籴
    DH_IPC_PANASONIC,                               // 
    DH_IPC_SONY,                                    // 
    DH_IPC_DYNACOLOR,                               // Dynacolor
    DH_IPC_TCWS = 5,                                // 
    DH_IPC_SAMSUNG,                                 // 
    DH_IPC_YOKO,                                    // YOKO
    DH_IPC_AXIS,                                    // Ѷ
    DH_IPC_SANYO,                                   //        
    DH_IPC_BOSH = 10,                               // Bosch
    DH_IPC_PECLO,                                   // Peclo
    DH_IPC_PROVIDEO,                                // Provideo
    DH_IPC_ACTI,                                    // ACTi
    DH_IPC_VIVOTEK,                                 // Vivotek
    DH_IPC_ARECONT = 15,                            // Arecont
    DH_IPC_PRIVATEEH,                               // PrivateEH    
    DH_IPC_IMATEK,                                  // IMatek
    DH_IPC_SHANY,                                   // Shany
    DH_IPC_VIDEOTREC,                               // ӯ
    DH_IPC_URA = 20,                                // Ura
    DH_IPC_BITICINO,                                // Bticino 
    DH_IPC_ONVIF,                                   // OnvifЭ
    DH_IPC_SHEPHERD,                                // Ӱ
    DH_IPC_YAAN,                                    // ǰ
    DH_IPC_AIRPOINT = 25,                           // Airpop
    DH_IPC_TYCO,                                    // TYCO
    DH_IPC_XUNMEI,                                  // Ѷ
    DH_IPC_HIKVISION,                               // 
    DH_IPC_LG,                                      // LG
    DH_IPC_AOQIMAN = 30,                            // 
    DH_IPC_BAOKANG,                                 //     
    DH_IPC_WATCHNET,                                // Watchnet
    DH_IPC_XVISION,                                 // Xvision
    DH_IPC_FUSITSU,                                 // ʿͨ
    DH_IPC_CANON = 35,                              // Canon
    DH_IPC_GE,                                      // GE
    DH_IPC_Basler,                                  // ˹
    DH_IPC_Patro,                                   // 
    DH_IPC_CPKNC,                                   // CPPLUS Kϵ
    DH_IPC_CPRNC = 40,                              // CPPLUS Rϵ
    DH_IPC_CPUNC,                                   // CPPLUS Uϵ
    DH_IPC_CPPLUS,                                  // CPPLUS IPC
    DH_IPC_XunmeiS,                                 // Ѷs,ʵЭΪOnvif
    DH_IPC_GDDW,                                    // 㶫
    DH_IPC_PSIA = 45,                               // PSIA
    DH_IPC_GB2818,                                  // GB2818    
    DH_IPC_GDYX,                                    // GDYX
    DH_IPC_OTHER,                                   // ûԶ
    DH_IPC_CPUNR,                                   // CPPLUS NVR
    DH_IPC_CPUAR = 50,                              // CPPLUS DVR
    DH_IPC_AIRLIVE,                                 // Airlive    
    DH_IPC_NPE,                                     // NPE    
    DH_IPC_AXVIEW,                                  // AXVIEW
    DH_IPC_DFWL,                                    // 
    DH_IPC_HYUNDAI = 56,                            // HYUNDAI DVR
    DH_IPC_APHD,                                    // ջ
    DH_IPC_WELLTRANS ,                              // ΢
    DH_IPC_CDJF,                                    // ɶѷ
    DH_IPC_JVC = 60,                                // JVC
    DH_IPC_INFINOVA,                                // Ӣ
    DH_IPC_ADT,                                     // ADT
    DH_IPC_SIVIDI,                                  // ϴ
    DH_IPC_CPUNP,                                   // CPPLUS 
    DH_IPC_HX = 65,                                 // 
    DH_IPC_TJGS,                                    // 
    DH_IPC_MULTICAST,                               // 鲥
}EM_IPC_TYPE;

// H264 뼶
typedef enum __EM_H264_PROFILE_RANK
{
    DH_PROFILE_BASELINE = 1,                       // ṩI/P֧֡progressive(ɨ)CAVLC
    DH_PROFILE_MAIN,                               // ṩI/P/B֧֡progressivinterlacedṩCAVLCCABAC
    DH_PROFILE_EXTENDED,                           // ṩI/P/B/SP/SI֧֡progressive(ɨ)CAVLC
    DH_PROFILE_HIGH,                               // FRExtMain_Profile8x8 intra prediction(8x8 ֡Ԥ), custom 
                                                   // quant(Զ), lossless video coding(Ƶ), yuvʽ
}EM_H264_PROFILE_RANK;

typedef enum __EM_DISK_TYPE
{
    DH_DISK_READ_WRITE,                         // д
    DH_DISK_READ_ONLY,                          // ֻ
    DH_DISK_BACKUP,                             // ý
    DH_DISK_REDUNDANT,                          // 
    DH_DISK_SNAPSHOT,                           // 
}EM_DISK_TYPE;

// 㷨ģʽ
typedef enum  __EM_ENCRYPT_ALOG_WORKMODE
{
    ENCRYPT_ALOG_WORKMODE_ECB,                  // ECBģʽ
    ENCRYPT_ALOG_WORKMODE_CBC,                  // CBCģʽ
    ENCRYPT_ALOG_WORKMODE_CFB,                  // CFBģʽ
    ENCRYPT_ALOG_WORKMODE_OFB,                  // OFBģʽ
}EM_ENCRYPT_ALOG_WORKMODE;

typedef enum __EM_MOBILE_PPP_STATE
{
    MOBILE_PPP_UP = 0,                          // Ѿ
    MOBILE_PPP_DOWN,                            // pppӶϿ        
    MOBILE_PPP_CONNECTING,                      // ڴ        
    MOBILE_PPP_CLOSEING,                        // ڹرPPP
} EM_MOBILE_PPP_STATE;

typedef enum __EM_3GMOBILE_STATE
{
    MOBILE_MODULE_OFF,                          // ʾ3gģر           
    MOBILE_MODULE_STARTING,                     // ʾ3gģ    
    MOBILE_MODULE_WORKING,                      // ʾ3gģڹ
}EM_3GMOBILE_STATE;

typedef enum tagEM_LOGIN_SPAC_CAP_TYPE
{
    EM_LOGIN_SPEC_CAP_TCP               = 0,    // TCP½, ĬϷʽ
    EM_LOGIN_SPEC_CAP_ANY               = 1,    // ½
    EM_LOGIN_SPEC_CAP_SERVER_CONN       = 2,    // עĵ
    EM_LOGIN_SPEC_CAP_MULTICAST         = 3,    // 鲥½, ĬϷʽ
    EM_LOGIN_SPEC_CAP_UDP               = 4,    // UDPʽµĵ
    EM_LOGIN_SPEC_CAP_MAIN_CONN_ONLY    = 6,    // ֻµĵ
    EM_LOGIN_SPEC_CAP_SSL               = 7,    // SSLܷʽ½
    EM_LOGIN_SPEC_CAP_CD_JF             = 8,    // ɶѷ½
    EM_LOGIN_SPEC_CAP_INTELLIGENT_BOX   = 9,    // ¼ܺԶ豸
    EM_LOGIN_SPEC_CAP_NO_CONFIG         = 10,   // ¼豸ȡò
    EM_LOGIN_SPEC_CAP_U_LOGIN           = 11,   // U豸ĵ
    EM_LOGIN_SPEC_CAP_LDAP              = 12,   // LDAPʽ¼
    EM_LOGIN_SPEC_CAP_AD                = 13,   // ADActiveDirectory¼ʽ
    EM_LOGIN_SPEC_CAP_RADIUS            = 14,   // Radius ¼ʽ 
    EM_LOGIN_SPEC_CAP_SOCKET_5          = 15,   // Socks5½ʽ
    EM_LOGIN_SPEC_CAP_CLOUD             = 16,   // Ƶ½ʽ
    EM_LOGIN_SPEC_CAP_AUTH_TWICE        = 17,   // μȨ½ʽ
    EM_LOGIN_SPEC_CAP_TS                = 18,   // TSͻ˵½ʽ
    EM_LOGIN_SPEC_CAP_P2P               = 19,   // ΪP2P½ʽ
    EM_LOGIN_SPEC_CAP_MOBILE            = 20,   // ֻͻ˵½
    EM_LOGIN_SPEC_CAP_INVALID                   // Чĵ½ʽ


}EM_LOGIN_SPAC_CAP_TYPE;

//////////////////////////////////////////////////////////////////

// ԤͣӦCLIENT_RealPlayExӿ
typedef enum _RealPlayType
{
    DH_RType_Realplay = 0,                      // ʵʱԤ
    DH_RType_Multiplay,                         // ໭Ԥ
    DH_RType_Realplay_0,                        // ʵʱ-ͬDH_RType_Realplay
    DH_RType_Realplay_1,                        // ʵʱ-1
    DH_RType_Realplay_2,                        // ʵʱ-2
    DH_RType_Realplay_3,                        // ʵʱ-3    
    DH_RType_Multiplay_1,                       // ໭Ԥ1
    DH_RType_Multiplay_4,                       // ໭Ԥ4
    DH_RType_Multiplay_8,                       // ໭Ԥ8
    DH_RType_Multiplay_9,                       // ໭Ԥ9
    DH_RType_Multiplay_16,                      // ໭Ԥ16
    DH_RType_Multiplay_6,                       // ໭Ԥ6
    DH_RType_Multiplay_12,                      // ໭Ԥ12
    DH_RType_Multiplay_25,                      // ໭Ԥ25
    DH_RType_Multiplay_36,                      // ໭Ԥ36
} DH_RealPlayType;

/////////////////////////////////̨/////////////////////////////////

// ̨ͨ
typedef enum _PTZ_ControlType
{

    DH_PTZ_UP_CONTROL = 0,                      // 
    DH_PTZ_DOWN_CONTROL,                        // 
    DH_PTZ_LEFT_CONTROL,                        // 
    DH_PTZ_RIGHT_CONTROL,                       // 
    DH_PTZ_ZOOM_ADD_CONTROL,                    // 䱶+
    DH_PTZ_ZOOM_DEC_CONTROL,                    // 䱶-
    DH_PTZ_FOCUS_ADD_CONTROL,                   // +
    DH_PTZ_FOCUS_DEC_CONTROL,                   // -
    DH_PTZ_APERTURE_ADD_CONTROL,                // Ȧ+
    DH_PTZ_APERTURE_DEC_CONTROL,                // Ȧ-
    DH_PTZ_POINT_MOVE_CONTROL,                  // תԤõ
    DH_PTZ_POINT_SET_CONTROL,                   // 
    DH_PTZ_POINT_DEL_CONTROL,                   // ɾ
    DH_PTZ_POINT_LOOP_CONTROL,                  // Ѳ
    DH_PTZ_LAMP_CONTROL                         // ƹˢ
} DH_PTZ_ControlType;

// ̨չ
typedef enum _EXTPTZ_ControlType
{
    DH_EXTPTZ_LEFTTOP = 0x20,                   // 
    DH_EXTPTZ_RIGHTTOP,                         // 
    DH_EXTPTZ_LEFTDOWN,                         // 
    DH_EXTPTZ_RIGHTDOWN,                        // 
    DH_EXTPTZ_ADDTOLOOP,                        // Ԥõ㵽Ѳ Ѳ· Ԥõֵ
    DH_EXTPTZ_DELFROMLOOP,                      // ɾѲԤõ Ѳ· Ԥõֵ
    DH_EXTPTZ_CLOSELOOP,                        // Ѳ Ѳ·
    DH_EXTPTZ_STARTPANCRUISE,                   // ʼˮƽת
    DH_EXTPTZ_STOPPANCRUISE,                    // ֹͣˮƽת
    DH_EXTPTZ_SETLEFTBORDER,                    // ߽
    DH_EXTPTZ_SETRIGHTBORDER,                   // ұ߽
    DH_EXTPTZ_STARTLINESCAN,                    // ʼɨ
    DH_EXTPTZ_CLOSELINESCAN,                    // ֹͣɨ
    DH_EXTPTZ_SETMODESTART,                     // ģʽʼ    ģʽ·
    DH_EXTPTZ_SETMODESTOP,                      // ģʽ    ģʽ·
    DH_EXTPTZ_RUNMODE,                          // ģʽ    ģʽ·
    DH_EXTPTZ_STOPMODE,                         // ֹͣģʽ    ģʽ·
    DH_EXTPTZ_DELETEMODE,                       // ģʽ    ģʽ·
    DH_EXTPTZ_REVERSECOMM,                      // ת
    DH_EXTPTZ_FASTGOTO,                         // ٶλ ˮƽ(8192) ֱ(8192) 䱶(4)
    DH_EXTPTZ_AUXIOPEN,                         // ؿ 
    DH_EXTPTZ_AUXICLOSE,                        // ع 
    DH_EXTPTZ_OPENMENU = 0x36,                  // ˵
    DH_EXTPTZ_CLOSEMENU,                        // رղ˵
    DH_EXTPTZ_MENUOK,                           // ˵ȷ
    DH_EXTPTZ_MENUCANCEL,                       // ˵ȡ
    DH_EXTPTZ_MENUUP,                           // ˵
    DH_EXTPTZ_MENUDOWN,                         // ˵
    DH_EXTPTZ_MENULEFT,                         // ˵
    DH_EXTPTZ_MENURIGHT,                        // ˵
    DH_EXTPTZ_ALARMHANDLE = 0x40,               // ̨ parm1ͨparm21-Ԥõ2-ɨ3-Ѳparm3ֵԤõ
    DH_EXTPTZ_MATRIXSWITCH = 0x41,              // л parm1(Ƶ)parm2Ƶţparm3
    DH_EXTPTZ_LIGHTCONTROL,                     // ƹ
    DH_EXTPTZ_EXACTGOTO,                        // άȷλ parm1ˮƽǶ(0~3600)parm2ֱ(0~900)parm3䱶(1~128)
    DH_EXTPTZ_RESETZERO,                        // άλλ
    DH_EXTPTZ_MOVE_ABSOLUTELY,                  // ƶparam4ӦṹPTZ_CONTROL_ABSOLUTELY
    DH_EXTPTZ_MOVE_CONTINUOUSLY,                // ƶparam4ӦṹPTZ_CONTROL_CONTINUOUSLY
    DH_EXTPTZ_GOTOPRESET,                       // ̨һٶתԤλ㣬parm4ӦṹPTZ_CONTROL_GOTOPRESET
    DH_EXTPTZ_SET_VIEW_RANGE = 0x49,            // ÿ(param4Ӧṹ PTZ_VIEW_RANGE_INFO)
    DH_EXTPTZ_FOCUS_ABSOLUTELY = 0x4A,          // Ծ۽(param4ӦṹPTZ_FOCUS_ABSOLUTELY)
    DH_EXTPTZ_HORSECTORSCAN = 0x4B,             // ˮƽɨ(param4ӦPTZ_CONTROL_SECTORSCAN,param1param2param3Ч)
    DH_EXTPTZ_VERSECTORSCAN = 0x4C,             // ֱɨ(param4ӦPTZ_CONTROL_SECTORSCAN,param1param2param3Ч)
    DH_EXTPTZ_SET_ABS_ZOOMFOCUS = 0x4D,         // 趨Խࡢ۽ֵ,param1Ϊ,Χ:[0,255],param2Ϊ۽,Χ:[0,255],param3param4Ч
    DH_EXTPTZ_SET_FISHEYE_EPTZ = 0x4E,          // ۵̨param4Ӧṹ PTZ_CONTROL_SET_FISHEYE_EPTZ  

    DH_EXTPTZ_UP_TELE = 0x70,                   //  + TELE param1=ٶ(1-8)ͬ
    DH_EXTPTZ_DOWN_TELE,                        //  + TELE
    DH_EXTPTZ_LEFT_TELE,                        //  + TELE
    DH_EXTPTZ_RIGHT_TELE,                       //  + TELE
    DH_EXTPTZ_LEFTUP_TELE,                      //  + TELE
    DH_EXTPTZ_LEFTDOWN_TELE,                    //  + TELE
    DH_EXTPTZ_TIGHTUP_TELE,                     //  + TELE
    DH_EXTPTZ_RIGHTDOWN_TELE,                   //  + TELE
    DH_EXTPTZ_UP_WIDE,                          //  + WIDE param1=ٶ(1-8)ͬ
    DH_EXTPTZ_DOWN_WIDE,                        //  + WIDE
    DH_EXTPTZ_LEFT_WIDE,                        //  + WIDE
    DH_EXTPTZ_RIGHT_WIDE,                       //  + WIDE
    DH_EXTPTZ_LEFTUP_WIDE,                      //  + WIDE
    DH_EXTPTZ_LEFTDOWN_WIDE,                    //  + WIDE
    DH_EXTPTZ_TIGHTUP_WIDE,                     //  + WIDE
    DH_EXTPTZ_RIGHTDOWN_WIDE,                   //  + WIDE
    DH_EXTPTZ_TOTAL,                            // ֵ
} DH_EXTPTZ_ControlType;

// ۵̨
typedef enum tagNET_FISHEYE_EPTZ_CMD
{
    NET_FISHEYE_EPTZ_CMD_UNKOWN,                    // δ֪
    NET_FISHEYE_EPTZ_CMD_ZOOMIN,                    // ŴdwParam1ʾΧ18
    NET_FISHEYE_EPTZ_CMD_ZOOMOUT,                   // СdwParam1ʾΧ18
    NET_FISHEYE_EPTZ_CMD_UP,                        // ƶdwParam1ʾΧ18
    NET_FISHEYE_EPTZ_CMD_DOWN,                      // ƶdwParam1ʾΧ18
    NET_FISHEYE_EPTZ_CMD_LEFT,                      // ƶdwParam1ʾΧ18
    NET_FISHEYE_EPTZ_CMD_RIGHT,                     // ƶdwParam1ʾΧ18
    NET_FISHEYE_EPTZ_CMD_ROTATECLOCK,               // Զ˳ʱתdwParam1ʾΧ18
    NET_FISHEYE_EPTZ_CMD_ROTATEANTICLOCK,           // ԶʱתdwParam1ʾΧ18
    NET_FISHEYE_EPTZ_CMD_STOP,                      // ֹԶת
    NET_FISHEYE_EPTZ_CMD_TAPVIEW,                   // ʾָλ,㼴dwParam1ʾeptz̨Ľ꣬ڽͼеĺ꣬ȡֵͼĿ
    // dwParam2ʾeptz̨Ľ꣬ڽͼе꣬ȡֵͼĸ
    NET_FISHEYE_EPTZ_CMD_SHOEREGION,                // ѡŴwParam1ʾѡĵĺ꣬
    // dwParam2ʾѡĵ꣬dwParam3ʾѡεĿ
    // dwParam4ʾѡεĸ
}NET_FISHEYE_EPTZ_CMD;

// ۽ģʽ
typedef enum tagNET_CALIBRATE_MODE
{
    NET_FISHEYE_CALIBRATE_MODE_UNKOWN,                      // δ֪ģʽ 
    NET_FISHEYE_CALIBRATE_MODE_ORIGIAL,                     // ԭʼͼģʽ
    NET_FISHEYE_CALIBRATE_MODE_CONFIG,                      // ģ
    NET_FISHEYE_CALIBRATE_MODE_PANORAMA,                    // ȫģʽ
    NET_FISHEYE_CALIBRATE_MODE_DOUBLEPANORAMA,              // ˫ȫģʽ
    NET_FISHEYE_CALIBRATE_MODE_ORIGIALPLUSTHREEEPTZREGION,  // 1+3ģʽһԭʼͼ3EPtzͼ
    NET_FISHEYE_CALIBRATE_MODE_SINGLE,                      // EPtzģʽֻһEPtz棩
    NET_FISHEYE_CALIBRATE_MODE_FOUREPTZREGION,              // 4ģʽ4EPtzƻ棩
    NET_FISHEYE_CALIBRATE_MODE_NORMAL,                      // ͨģʽ
}NET_FISHEYE_CALIBRATE_MODE;

typedef enum tagNET_FISHEYE_TYPE
{
    NET_FISHEYE_UNKOWN =0   ,               //δ֪
    NET_FISHEYE_CHIP        ,               //֧豸۽
    NET_FISHEYE_PLUGIN      ,               //ֿ֧ؼ۽
    NET_FISHEYE_CHIP_PLUGIN ,               //߶֧
}NET_FISHEYE_TYPE;

// ۰װģʽ
typedef enum tagNET_FISHEYE_MOUNT_MODE
{
    NET_FISHEYE_MOUNT_MODE_UNKOWN,                          // δ֪ģʽ                  
    NET_FISHEYE_MOUNT_MODE_CEIL,                            // װģʽ 
    NET_FISHEYE_MOUNT_MODE_WALL,                            // װģʽ  
    NET_FISHEYE_MOUNT_MODE_FLOOR,                           // װģʽ  
}NET_FISHEYE_MOUNT_MODE;
/////////////////////////////////־/////////////////////////////////

// ־ѯ
typedef enum _DH_LOG_QUERY_TYPE
{
    DHLOG_ALL = 0,                              // ־
    DHLOG_SYSTEM,                               // ϵͳ־
    DHLOG_CONFIG,                               // ־
    DHLOG_STORAGE,                              // 洢
    DHLOG_ALARM,                                // ־
    DHLOG_RECORD,                               // ¼
    DHLOG_ACCOUNT,                              // ʺ
    DHLOG_CLEAR,                                // ־
    DHLOG_PLAYBACK,                             // ط
    DHLOG_MANAGER                               // ǰ˹
} DH_LOG_QUERY_TYPE;

// ־
typedef enum _DH_LOG_TYPE
{
    DH_LOG_REBOOT = 0x0000,                     // 豸
    DH_LOG_SHUT,                                // 豸ػ
    DH_LOG_REPORTSTOP,
    DH_LOG_REPORTSTART,
    DH_LOG_UPGRADE = 0x0004,                    // 豸
    DH_LOG_SYSTIME_UPDATE = 0x0005,             // ϵͳʱ
    DH_LOG_GPS_TIME_UPDATE = 0x0006,            // GPSʱ
    DH_LOG_AUDIO_TALKBACK,                      // Խ truefalseر    
    DH_LOG_COMM_ADAPTER,                        // ͸䣬 truefalseر    
    DH_LOG_NET_TIMING,                          // Уʱ
    DH_LOG_CONFSAVE = 0x0100,                   // 
    DH_LOG_CONFLOAD,                            // ȡ
    DH_LOG_FSERROR = 0x0200,                    // ļϵͳ
    DH_LOG_HDD_WERR,                            // Ӳд
    DH_LOG_HDD_RERR,                            // Ӳ̶
    DH_LOG_HDD_TYPE,                            // Ӳ
    DH_LOG_HDD_FORMAT,                          // ʽӲ
    DH_LOG_HDD_NOSPACE,                         // ǰ̿ռ䲻
    DH_LOG_HDD_TYPE_RW,                         // ӲΪд
    DH_LOG_HDD_TYPE_RO,                         // ӲΪֻ    
    DH_LOG_HDD_TYPE_RE,                         // ӲΪ
    DH_LOG_HDD_TYPE_SS,                         // ӲΪ
    DH_LOG_HDD_NONE,                            // Ӳ̼¼
    DH_LOG_HDD_NOWORKHDD,                       // ޹(ûжд)
    DH_LOG_HDD_TYPE_BK,                         // ӲΪ
    DH_LOG_HDD_TYPE_REVERSE,                    // ӲΪ
    DH_LOG_HDD_START_INFO = 0x200 +14,          // ¼ʱӲϢ
    DH_LOG_HDD_WORKING_DISK,                    // ¼̺Ĺ̺
    DH_LOG_HDD_OTHER_ERROR,                     // ¼Ӳ
    DH_LOG_HDD_SLIGHT_ERR,                      // Ӳ̴΢
    DH_LOG_HDD_SERIOUS_ERR,                     // Ӳ̴
    DH_LOG_HDD_NOSPACE_END,                     // ǰ̿ռ䲻㱨
    DH_LOG_HDD_TYPE_RAID_CONTROL,               // Raid
    DH_LOG_HDD_TEMPERATURE_HIGH,                // ¶ȹ
    DH_LOG_HDD_TEMPERATURE_LOW,                 // ¶ȹ
    DH_LOG_HDD_ESATA_REMOVE,                    // ƳeSATA
    DH_LOG_ALM_IN = 0x0300,                     // ⲿ뱨ʼ
    DH_LOG_NETALM_IN,                           // 籨
    DH_LOG_ALM_END = 0x0302,                    // ⲿ뱨ֹͣ
    DH_LOG_LOSS_IN,                             // Ƶʧʼ
    DH_LOG_LOSS_END,                            // Ƶʧ
    DH_LOG_MOTION_IN,                           // ̬ⱨʼ
    DH_LOG_MOTION_END,                          // ̬ⱨ
    DH_LOG_ALM_BOSHI,                           // 
    DH_LOG_NET_ABORT = 0x0308,                  // Ͽ
    DH_LOG_NET_ABORT_RESUME,                    // ָ
    DH_LOG_CODER_BREAKDOWN,                     // 
    DH_LOG_CODER_BREAKDOWN_RESUME,              // ϻָ
    DH_LOG_BLIND_IN,                            // Ƶڵ
    DH_LOG_BLIND_END,                           // Ƶڵָ
    DH_LOG_ALM_TEMP_HIGH,                       // ¶ȹ
    DH_LOG_ALM_VOLTAGE_LOW,                     // ѹ
    DH_LOG_ALM_BATTERY_LOW,                     // 
    DH_LOG_ALM_ACC_BREAK,                       // ACCϵ
    DH_LOG_ALM_ACC_RES,
    DH_LOG_GPS_SIGNAL_LOST,                     // GPSź
    DH_LOG_GPS_SIGNAL_RESUME,                   // GPSźŻָ
    DH_LOG_3G_SIGNAL_LOST,                      // 3Gź
    DH_LOG_3G_SIGNAL_RESUME,                    // 3GźŻָ
    DH_LOG_ALM_IPC_IN,                          // IPCⲿ
    DH_LOG_ALM_IPC_END,                         // IPCⲿָ
    DH_LOG_ALM_DIS_IN,                          // 
    DH_LOG_ALM_DIS_END,                         // ָ
    DH_LOG_INFRAREDALM_IN = 0x03a0,             // ߱ʼ
    DH_LOG_INFRAREDALM_END,                     // ߱
    DH_LOG_IPCONFLICT,                          // IPͻ
    DH_LOG_IPCONFLICT_RESUME,                   // IPָ
    DH_LOG_SDPLUG_IN,                           // SD(DH_LOG_ITEMеreservedֵΪ3ʾU̲)
    DH_LOG_SDPLUG_OUT,                          // SDγ(DH_LOG_ITEMеreservedֵΪ3ʾṴγ)
    DH_LOG_NET_PORT_BIND_FAILED,                // ˿ڰʧ
    DH_LOG_HDD_BEEP_RESET,                      // Ӳ̴󱨾
    DH_LOG_MAC_CONFLICT,                        // MACͻ
    DH_LOG_MAC_CONFLICT_RESUME,                 // MACͻָ
    DH_LOG_ALARM_OUT,                           // ״̬
    DH_LOG_ALM_RAID_STAT_EVENT,                 // RAID״̬仯¼ 
    DH_LOG_ABLAZE_ON,                           // 𾯱̸л¶
    DH_LOG_ABLAZE_OFF,                          // 𾯱 ָ
    DH_LOG_INTELLI_ALARM_PLUSE,                 // ͱ
    DH_LOG_INTELLI_ALARM_IN,                    // ܱʼ
    DH_LOG_INTELLI_ALARM_END,                   // ܱ
    DH_LOG_3G_SIGNAL_SCAN,                      // 3Gźż
    DH_LOG_GPS_SIGNAL_SCAN,                     // GPSźż
    DH_LOG_AUTOMATIC_RECORD = 0x0400,           // Զ¼
    DH_LOG_MANUAL_RECORD = 0x0401,              // ֶ¼
    DH_LOG_CLOSED_RECORD,                       // ֹͣ¼
    DH_LOG_LOGIN = 0x0500,                      // ¼
    DH_LOG_LOGOUT,                              // ע
    DH_LOG_ADD_USER,                            // û
    DH_LOG_DELETE_USER,                         // ɾû
    DH_LOG_MODIFY_USER,                         // ޸û
    DH_LOG_ADD_GROUP,                           // û
    DH_LOG_DELETE_GROUP,                        // ɾû
    DH_LOG_MODIFY_GROUP,                        // ޸û
    DH_LOG_NET_LOGIN = 0x0508,                  // û¼
    DH_LOG_MODIFY_PASSWORD,                     // ޸
    DH_LOG_CLEAR = 0x0600,                      // ־
    DH_LOG_SEARCHLOG,                           // ѯ־
    DH_LOG_SEARCH = 0x0700,                     // ¼ѯ
    DH_LOG_DOWNLOAD,                            // ¼
    DH_LOG_PLAYBACK,                            // ¼ط
    DH_LOG_BACKUP,                              // ¼ļ
    DH_LOG_BACKUPERROR,                         // ¼ļʧ
    DH_LOG_BACK_UPRT,                           // ʵʱݣ̿¼
    DH_LOG_BACKUPCLONE,                         // ̸ơ
    DH_LOG_DISK_CHANGED,                        // ֶ
    DH_LOG_IMAGEPLAYBACK,                       // ͼƬط
    DH_LOG_LOCKFILE,                            // ¼
    DH_LOG_UNLOCKFILE,                          // ¼
    DH_LOG_ATMPOS,                              // ATMŵ־
	DH_PLAY_PAUSE,								// ͣط
	DH_PLAY_START,								// 
	LOG_PLAY_STOP,								// ֹͣط
	LOG_PLAY_BACK,								// 
	LOG_PLAY_FAST,								// 
	LOG_PLAY_SLOW,								// 
	LOG_SMART_SEARCH,							// ܼ
	LOG_RECORD_SNAP,							// ¼ץͼ
	LOG_ADD_TAG,								// ӱǩ
	LOG_DEL_TAG,								// ɾǩ
	LOG_USB_IN,									// USB豸
	LOG_USB_OUT,								// USB豸Ͽ
	LOG_BACKUP_FILE,							// ļ
	LOG_BACKUP_LOG,								// ־
	LOG_BACKUP_CONFIG,							// ñ

    DH_LOG_TIME_UPDATE  = 0x0800,               // ʱͬ
    DH_LOG_REMOTE_STATE = 0x0850,               // Զ־ 
    DH_LOG_USER_DEFINE = 0x0900,
    DH_LOG_TYPE_NR = 10,
} DH_LOG_TYPE;

// չ־ͣӦCLIENT_QueryLogExӿڣ(int nType = 1reserved = &nType)
typedef enum _DH_NEWLOG_TYPE
{
    DH_NEWLOG_REBOOT = 0x0000,                     // 豸
    DH_NEWLOG_SHUT,                                // 豸ػ
    DH_NEWLOG_REPORTSTOP,
    DH_NEWLOG_REPORTSTART,
    DH_NEWLOG_UPGRADE = 0x0004,                    // 豸
    DH_NEWLOG_SYSTIME_UPDATE = 0x0005,             // ϵͳʱ
    DH_NEWLOG_GPS_TIME_UPDATE = 0x0006,            // GPSʱ

    DH_NEWLOG_AUDIO_TALKBACK,                      // Խ truefalseر    
    DH_NEWLOG_COMM_ADAPTER,                        // ͸䣬 truefalseر    
    DH_NEWLOG_NET_TIMING,                          // Уʱ

    DH_NEWLOG_CONFSAVE = 0x0100,                   // 
    DH_NEWLOG_CONFLOAD,                            // ȡ
    DH_NEWLOG_FSERROR = 0x0200,                    // ļϵͳ
    DH_NEWLOG_HDD_WERR,                            // Ӳд
    DH_NEWLOG_HDD_RERR,                            // Ӳ̶
    DH_NEWLOG_HDD_TYPE,                            // Ӳ
    DH_NEWLOG_HDD_FORMAT,                          // ʽӲ
    DH_NEWLOG_HDD_NOSPACE,                         // ǰ̿ռ䲻
    DH_NEWLOG_HDD_TYPE_RW,                         // ӲΪд
    DH_NEWLOG_HDD_TYPE_RO,                         // ӲΪֻ    
    DH_NEWLOG_HDD_TYPE_RE,                         // ӲΪ
    DH_NEWLOG_HDD_TYPE_SS,                         // ӲΪ
    DH_NEWLOG_HDD_NONE,                            // Ӳ̼¼־
    DH_NEWLOG_HDD_NOWORKHDD,                       // ޹(ûжд)
    DH_NEWLOG_HDD_TYPE_BK,                         // ӲΪ
    DH_NEWLOG_HDD_TYPE_REVERSE,                    // ӲΪ
    DH_NEWLOG_HDD_START_INFO = 0x200 +14,          // ¼ʱӲϢ
    DH_NEWLOG_HDD_WORKING_DISK,                    // ¼̺Ĺ̺
    DH_NEWLOG_HDD_OTHER_ERROR,                     // ¼Ӳ
    DH_NEWLOG_HDD_SLIGHT_ERR,                      // Ӳ̴΢
    DH_NEWLOG_HDD_SERIOUS_ERR,                     // Ӳ̴
    DH_NEWLOG_HDD_NOSPACE_END,                     // ǰ̿ռ䲻㱨

    DH_NEWLOG_HDD_TYPE_RAID_CONTROL,               // Raid
    DH_NEWLOG_HDD_TEMPERATURE_HIGH,                // ¶ȹ
    DH_NEWLOG_HDD_TEMPERATURE_LOW,                 // ¶ȹ
    DH_NEWLOG_HDD_ESATA_REMOVE,                    // ƳeSATA

    DH_NEWLOG_ALM_IN = 0x0300,                     // ⲿ뱨ʼ
    DH_NEWLOG_NETALM_IN,                           // 籨
    DH_NEWLOG_ALM_END = 0x0302,                    // ⲿ뱨ֹͣ
    DH_NEWLOG_LOSS_IN,                             // Ƶʧʼ
    DH_NEWLOG_LOSS_END,                            // Ƶʧ
    DH_NEWLOG_MOTION_IN,                           // ̬ⱨʼ
    DH_NEWLOG_MOTION_END,                          // ̬ⱨ
    DH_NEWLOG_ALM_BOSHI,                           // 
    DH_NEWLOG_NET_ABORT = 0x0308,                  // Ͽ
    DH_NEWLOG_NET_ABORT_RESUME,                    // ָ
    DH_NEWLOG_CODER_BREAKDOWN,                     // 
    DH_NEWLOG_CODER_BREAKDOWN_RESUME,              // ϻָ
    DH_NEWLOG_BLIND_IN,                            // Ƶڵ
    DH_NEWLOG_BLIND_END,                           // Ƶڵָ
    DH_NEWLOG_ALM_TEMP_HIGH,                       // ¶ȹ
    DH_NEWLOG_ALM_VOLTAGE_LOW,                     // ѹ
    DH_NEWLOG_ALM_BATTERY_LOW,                     // 
    DH_NEWLOG_ALM_ACC_BREAK,                       // ACCϵ
    DH_NEWLOG_ALM_ACC_RES,
    DH_NEWLOG_GPS_SIGNAL_LOST,                     // GPSź
    DH_NEWLOG_GPS_SIGNAL_RESUME,                   // GPSźŻָ
    DH_NEWLOG_3G_SIGNAL_LOST,                      // 3Gź
    DH_NEWLOG_3G_SIGNAL_RESUME,                    // 3GźŻָ

    DH_NEWLOG_ALM_IPC_IN,                          // IPCⲿ
    DH_NEWLOG_ALM_IPC_END,                         // IPCⲿָ
    DH_NEWLOG_ALM_DIS_IN,                          // 
    DH_NEWLOG_ALM_DIS_END,                         // ָ

    DH_NEWLOG_INFRAREDALM_IN = 0x03a0,             // ߱ʼ
    DH_NEWLOG_INFRAREDALM_END,                     // ߱
    DH_NEWLOG_IPCONFLICT,                          // IPͻ
    DH_NEWLOG_IPCONFLICT_RESUME,                   // IPָ
    DH_NEWLOG_SDPLUG_IN,                           // SD
    DH_NEWLOG_SDPLUG_OUT,                          // SDγ
    DH_NEWLOG_NET_PORT_BIND_FAILED,                // ˿ڰʧ
    DH_NEWLOG_HDD_BEEP_RESET,                      // Ӳ̴󱨾
    DH_NEWLOG_MAC_CONFLICT,                        // MACͻ
    DH_NEWLOG_MAC_CONFLICT_RESUME,                 // MACͻָ
    DH_NEWLOG_ALARM_OUT,                           // ״̬
    DH_NEWLOG_ALM_RAID_STAT_EVENT,                 // RAID״̬仯¼ 
    DH_NEWLOG_ABLAZE_ON,                           // 𾯱̸л¶
    DH_NEWLOG_ABLAZE_OFF,                          // 𾯱 ָ
    DH_NEWLOG_INTELLI_ALARM_PLUSE,                 // ͱ
    DH_NEWLOG_INTELLI_ALARM_IN,                    // ܱʼ
    DH_NEWLOG_INTELLI_ALARM_END,                   // ܱ
    DH_NEWLOG_3G_SIGNAL_SCAN,                      // 3Gźż
    DH_NEWLOG_GPS_SIGNAL_SCAN,                     // GPSźż
    DH_NEWLOG_AUTOMATIC_RECORD = 0x0400,           // Զ¼
    DH_NEWLOG_MANUAL_RECORD,                       // ֶ¼
    DH_NEWLOG_CLOSED_RECORD,                       // ֹͣ¼
    DH_NEWLOG_LOGIN = 0x0500,                      // ¼
    DH_NEWLOG_LOGOUT,                              // ע
    DH_NEWLOG_ADD_USER,                            // û
    DH_NEWLOG_DELETE_USER,                         // ɾû
    DH_NEWLOG_MODIFY_USER,                         // ޸û
    DH_NEWLOG_ADD_GROUP,                           // û
    DH_NEWLOG_DELETE_GROUP,                        // ɾû
    DH_NEWLOG_MODIFY_GROUP,                        // ޸û
    DH_NEWLOG_NET_LOGIN = 0x0508,                  // û¼
    DH_NEWLOG_CLEAR = 0x0600,                      // ־
    DH_NEWLOG_SEARCHLOG,                           // ѯ־
    DH_NEWLOG_SEARCH = 0x0700,                     // ¼ѯ
    DH_NEWLOG_DOWNLOAD,                            // ¼
    DH_NEWLOG_PLAYBACK,                            // ¼ط
    DH_NEWLOG_BACKUP,                              // ¼ļ
    DH_NEWLOG_BACKUPERROR,                         // ¼ļʧ

    DH_NEWLOG_BACK_UPRT,                           // ʵʱݣ̿¼
    DH_NEWLOG_BACKUPCLONE,                         // ̸ơ
    DH_NEWLOG_DISK_CHANGED,                        // ֶ
    DH_NEWLOG_IMAGEPLAYBACK,                       // ͼƬط
    DH_NEWLOG_LOCKFILE,                            // ¼
    DH_NEWLOG_UNLOCKFILE,                          // ¼
    DH_NEWLOG_ATMPOS,                              // ATMŵ־

    DH_NEWLOG_TIME_UPDATE  = 0x0800,               // ʱ
    DH_NEWLOG_REMOTE_STATE = 0x0850,               // Զ־ 

    DH_NEWLOG_USER_DEFINE = 0x0900,
    DH_NEWLOG_TYPE_NR = 10,        
} DH_NEWLOG_TYPE;

///////////////////////////////Խ///////////////////////////////

// 
typedef enum __TALK_CODING_TYPE 
{
    DH_TALK_DEFAULT = 0,                        // ͷPCM
    DH_TALK_PCM = 1,                            // ͷPCM
    DH_TALK_G711a,                              // G711a
    DH_TALK_AMR,                                // AMR
    DH_TALK_G711u,                              // G711u
    DH_TALK_G726,                               // G726
    DH_TALK_G723_53,                            // G723_53
    DH_TALK_G723_63,                            // G723_63
    DH_TALK_AAC,                                // AAC
    DH_TALK_OGG,                                // OGG
    DH_TALK_ADPCM = 21,                         // ADPCM
    DH_TALK_MP3   = 22,                            // MP3
} DH_TALK_CODING_TYPE;

// ¼ļ
typedef enum __NET_RECORD_TYPE
{
    NET_RECORD_TYPE_ALL,                        // ¼
    NET_RECORD_TYPE_NORMAL,                     // ͨ¼
    NET_RECORD_TYPE_ALARM,                      // ⲿ¼
    NET_RECORD_TYPE_MOTION,                     // 챨¼
}NET_RECORD_TYPE;

// Խʽ
typedef enum __EM_USEDEV_MODE
{
    DH_TALK_CLIENT_MODE,                        // ÿͻ˷ʽԽ
    DH_TALK_SERVER_MODE,                        // ÷ʽԽ
    DH_TALK_ENCODE_TYPE,                        // Խʽ(ӦDHDEV_TALKDECODE_INFO)
    DH_ALARM_LISTEN_MODE,                       // ñķʽ
    DH_CONFIG_AUTHORITY_MODE,                   // ͨȨ޽ù
    DH_TALK_TALK_CHANNEL,                       // öԽͨ(0~MaxChannel-1)
    DH_RECORD_STREAM_TYPE,                      // ôѯʱطŵ¼(0-,1-,2-)  
    DH_TALK_SPEAK_PARAM,                        // ԽӦṹ NET_SPEAK_PARAM
    DH_RECORD_TYPE,                             // ðʱ¼طżص¼ļ(NET_RECORD_TYPE)
    DH_TALK_MODE3,                              // 豸Խ, ӦṹNET_TALK_EX
    DH_PLAYBACK_REALTIME_MODE ,                 // ʵʱطŹ(0-رգ1)
} EM_USEDEV_MODE;


typedef enum __EM_TALK_DATA_TYPE
{ 
    NET_TALK_DATA_LOCAL_AUDIO = 0,              // ¼ɼƵ
    NET_TALK_DATA_RECV_AUDIO,                   // յ豸Ƶ
    NET_TALK_DATA_RESPOND,                      // ԽӦ
    NET_TALK_DATA_RECV_VIDEO,                   // յ豸Ƶ
}EM_TALK_DATA_TYPE;

typedef struct tagNET_TALK_VIDEO_FORMAT
{
    DWORD               dwSize;
    DWORD               dwCompression;          // Ƶѹʽ
    int                 nFrequency;             // ƵƵ
}NET_TALK_VIDEO_FORMAT;
// 豸ԽӦCLIENT_SetDeviceMode()DH_TALK_MODE3
typedef struct tagNET_TALK_EX
{
    DWORD               dwSize;
    int                 nChannel;                               // ͨ
    int                 nAudioPort;                             // Ƶ˿
    int                 nWaitTime;                              // ȴʱ, λms,Ϊ0ʹĬֵ
    HWND                hVideoWnd;                              // ӶԽƵʾ
    NET_TALK_VIDEO_FORMAT stuVideoFmt;                          // Ƶʽ
    char                szMulticastAddr[DH_MAX_IPADDR_LEN_EX];  // 鲥ַ
    WORD                wMulticastLocalPort;                    // 鲥ض˿
    WORD                wMulticastRemotePort;                   // 鲥Զ̶˿
}NET_TALK_EX;

// AMR
typedef enum __EM_ARM_ENCODE_MODE
{
    DH_TALK_AMR_AMR475 = 1,                     // AMR475
    DH_TALK_AMR_AMR515,                         // AMR515
    DH_TALK_AMR_AMR59,                          // AMR59
    DH_TALK_AMR_AMR67,                          // AMR67
    DH_TALK_AMR_AMR74,                          // AMR74
    DH_TALK_AMR_AMR795,                         // AMR795
    DH_TALK_AMR_AMR102,                         // AMR102
    DH_TALK_AMR_AMR122,                         // AMR122
} EM_ARM_ENCODE_MODE;

typedef struct __NET_SPEAK_PARAM
{
    DWORD           dwSize;                     // ṹС
    int             nMode;                      // 0ԽĬģʽ1ӺлԽҪ
    int             nSpeakerChannel;            // ͨţʱЧ
} NET_SPEAK_PARAM;

//////////////////////////////////////////////////////////////////

// ͣӦCLIENT_ControlDeviceӿ
typedef enum _CtrlType
{
    DH_CTRL_REBOOT = 0,                            // 豸    
    DH_CTRL_SHUTDOWN,                              // ر豸
    DH_CTRL_DISK,                                  // Ӳ̹
    DH_KEYBOARD_POWER = 3,                         // 
    DH_KEYBOARD_ENTER,
    DH_KEYBOARD_ESC,
    DH_KEYBOARD_UP,
    DH_KEYBOARD_DOWN,
    DH_KEYBOARD_LEFT,
    DH_KEYBOARD_RIGHT,
    DH_KEYBOARD_BTN0,
    DH_KEYBOARD_BTN1,
    DH_KEYBOARD_BTN2,
    DH_KEYBOARD_BTN3,
    DH_KEYBOARD_BTN4,
    DH_KEYBOARD_BTN5,
    DH_KEYBOARD_BTN6,
    DH_KEYBOARD_BTN7,
    DH_KEYBOARD_BTN8,
    DH_KEYBOARD_BTN9,
    DH_KEYBOARD_BTN10,
    DH_KEYBOARD_BTN11,
    DH_KEYBOARD_BTN12,
    DH_KEYBOARD_BTN13,
    DH_KEYBOARD_BTN14,
    DH_KEYBOARD_BTN15,
    DH_KEYBOARD_BTN16,
    DH_KEYBOARD_SPLIT,
    DH_KEYBOARD_ONE,
    DH_KEYBOARD_NINE,
    DH_KEYBOARD_ADDR,
    DH_KEYBOARD_INFO,
    DH_KEYBOARD_REC,
    DH_KEYBOARD_FN1,
    DH_KEYBOARD_FN2,
    DH_KEYBOARD_PLAY,
    DH_KEYBOARD_STOP,
    DH_KEYBOARD_SLOW,
    DH_KEYBOARD_FAST,
    DH_KEYBOARD_PREW,
    DH_KEYBOARD_NEXT,
    DH_KEYBOARD_JMPDOWN,
    DH_KEYBOARD_JMPUP,
    DH_KEYBOARD_10PLUS,
    DH_KEYBOARD_SHIFT,
    DH_KEYBOARD_BACK,               
    DH_KEYBOARD_LOGIN ,                            // ̹
    DH_KEYBOARD_CHNNEL ,                           // лƵͨ
    DH_TRIGGER_ALARM_IN = 100,                     // 
    DH_TRIGGER_ALARM_OUT,                          // 
    DH_CTRL_MATRIX,                                // 
    DH_CTRL_SDCARD,                                // SD(IPCƷ)ͬӲ̿
    DH_BURNING_START,                              // ¼ƣʼ¼
    DH_BURNING_STOP,                               // ¼ƣ¼
    DH_BURNING_ADDPWD,                             // ¼ƣ('\0'Ϊβַ󳤶8λ)
    DH_BURNING_ADDHEAD,                            // ¼ƣƬͷ('\0'Ϊβַ󳤶1024ֽڣַ֧Узָ'\n')
    DH_BURNING_ADDSIGN,                            // ¼ƣӴ㵽¼Ϣ()
    DH_BURNING_ADDCURSTOMINFO,                     // ¼ƣԶ('\0'Ϊβַ󳤶1024ֽڣַ֧Узָ'\n')
    DH_CTRL_RESTOREDEFAULT,                        // ָ豸Ĭ
    DH_CTRL_CAPTURE_START,                         // 豸ץͼ
    DH_CTRL_CLEARLOG,                              // ־
    DH_TRIGGER_ALARM_WIRELESS = 200,               // ߱(IPCƷ)
    DH_MARK_IMPORTANT_RECORD,                      // ʶҪ¼ļ
    DH_CTRL_DISK_SUBAREA,                          // Ӳ̷    
    DH_BURNING_ATTACH,                             // ¼ƣ¼.
    DH_BURNING_PAUSE,                              // ¼ͣ
    DH_BURNING_CONTINUE,                           // ¼
    DH_BURNING_POSTPONE,                           // ¼˳
    DH_CTRL_OEMCTRL,                               // ͣ
    DH_BACKUP_START,                               // 豸ݿʼ
    DH_BACKUP_STOP,                                // 豸ֹͣ
    DH_VIHICLE_WIFI_ADD,                           // ֶWIFI
    DH_VIHICLE_WIFI_DEC,                           // ֶɾWIFI
    DH_BUZZER_START,                               // ƿʼ
    DH_BUZZER_STOP,                                // ƽ
    DH_REJECT_USER,                                // ޳û
    DH_SHIELD_USER,                                // û
    DH_RAINBRUSH,                                  // ܽͨ, ˢ 
    DH_MANUAL_SNAP,                                // ܽͨ, ֶץ (ӦṹMANUAL_SNAP_PARAMETER)
    DH_MANUAL_NTP_TIMEADJUST,                      // ֶNTPУʱ
    DH_NAVIGATION_SMS,                             // ϢͶϢ
    DH_CTRL_ROUTE_CROSSING,                        // ·ߵλϢ
    DH_BACKUP_FORMAT,                              // ʽ豸
    DH_DEVICE_LOCALPREVIEW_SLIPT,                  // 豸˱Ԥָ(ӦṹDEVICE_LOCALPREVIEW_SLIPT_PARAMETER)    
    DH_CTRL_INIT_RAID,                             // RAIDʼ
    DH_CTRL_RAID,                                  // RAID
    DH_CTRL_SAPREDISK,                             // ȱ̲
    DH_WIFI_CONNECT,                               // ֶWIFI(ӦṹWIFI_CONNECT)
    DH_WIFI_DISCONNECT,                            // ֶϿWIFI(ӦṹWIFI_CONNECT)
    DH_CTRL_ARMED,                                 // 
    DH_CTRL_IP_MODIFY,                             // ޸ǰIP(ӦṹDHCTRL_IPMODIFY_PARAM)                     
    DH_CTRL_WIFI_BY_WPS,                           // wpswifi(ӦṹDHCTRL_CONNECT_WIFI_BYWPS)
    DH_CTRL_FORMAT_PATITION,                       // ʽ(ӦṹDH_FORMAT_PATITION)
    DH_CTRL_EJECT_STORAGE,                         // ֶж豸(ӦṹDH_EJECT_STORAGE_DEVICE)
    DH_CTRL_LOAD_STORAGE,                          // ֶװ豸(ӦṹDH_LOAD_STORAGE_DEVICE)
    DH_CTRL_CLOSE_BURNER,                          // رտ¼(Ӧṹ NET_CTRL_BURNERDOOR) һҪ6
    DH_CTRL_EJECT_BURNER,                          // ¼(Ӧṹ NET_CTRL_BURNERDOOR) һҪ4
    DH_CTRL_CLEAR_ALARM,                           // (Ӧṹ NET_CTRL_CLEAR_ALARM)
    DH_CTRL_MONITORWALL_TVINFO,                    // ǽϢʾ(Ӧṹ NET_CTRL_MONITORWALL_TVINFO)
    DH_CTRL_START_VIDEO_ANALYSE,                   // ʼƵܷ(Ӧṹ NET_CTRL_START_VIDEO_ANALYSE)
    DH_CTRL_STOP_VIDEO_ANALYSE,                    // ֹͣƵܷ(Ӧṹ NET_CTRL_STOP_VIDEO_ANALYSE)
    DH_CTRL_UPGRADE_DEVICE,                        // 豸,豸,Ҫļ
    DH_CTRL_MULTIPLAYBACK_CHANNALES,               // лͨԤطŵͨ(Ӧṹ NET_CTRL_MULTIPLAYBACK_CHANNALES)
    DH_CTRL_SEQPOWER_OPEN,                         // Դʱ򿪿(Ӧ NET_CTRL_SEQPOWER_PARAM)
    DH_CTRL_SEQPOWER_CLOSE,                        // Դʱرտ(Ӧ NET_CTRL_SEQPOWER_PARAM)
    DH_CTRL_SEQPOWER_OPEN_ALL,                     // Դʱ򿪿(Ӧ NET_CTRL_SEQPOWER_PARAM)
    DH_CTRL_SEQPOWER_CLOSE_ALL,                    // Դʱرտ(Ӧ NET_CTRL_SEQPOWER_PARAM)
    DH_CTRL_PROJECTOR_RISE,                        // ͶӰ(Ӧ NET_CTRL_PROJECTOR_PARAM)
    DH_CTRL_PROJECTOR_FALL,                        // ͶӰ½(Ӧ NET_CTRL_PROJECTOR_PARAM)
    DH_CTRL_PROJECTOR_STOP,                        // ͶӰֹͣ(Ӧ NET_CTRL_PROJECTOR_PARAM)
    DH_CTRL_INFRARED_KEY,                          // ⰴ(Ӧ NET_CTRL_INFRARED_KEY_PARAM)
    DH_CTRL_START_PLAYAUDIO,                       // 豸ʼƵļ(Ӧṹ NET_CTRL_START_PLAYAUDIO)
    DH_CTRL_STOP_PLAYAUDIO,                        // 豸ֹͣƵļ
    DH_CTRL_START_ALARMBELL,                       // (Ӧṹ NET_CTRL_ALARMBELL)
    DH_CTRL_STOP_ALARMBELL,                        // رվ(Ӧṹ NET_CTRL_ALARMBELL)
    DH_CTRL_ACCESS_OPEN,                           // Ž-(Ӧṹ NET_CTRL_ACCESS_OPEN)
    DH_CTRL_SET_BYPASS,                            // ·(Ӧṹ NET_CTRL_SET_BYPASS)
    DH_CTRL_RECORDSET_INSERT,                      // Ӽ¼ü¼(ӦNET_CTRL_RECORDSET_INSERT_PARAM)
    DH_CTRL_RECORDSET_UPDATE,                      // ĳ¼ŵļ¼(ӦNET_CTRL_RECORDSET_PARAM)
    DH_CTRL_RECORDSET_REMOVE,                      // ݼ¼ɾĳ¼(ӦNET_CTRL_RECORDSET_PARAM)
    DH_CTRL_RECORDSET_CLEAR,                       // м¼Ϣ(ӦNET_CTRL_RECORDSET_PARAM)
    DH_CTRL_ACCESS_CLOSE,                          // Ž-(Ӧṹ NET_CTRL_ACCESS_CLOSE)
    DH_CTRL_ALARM_SUBSYSTEM_ACTIVE_SET,            // ϵͳ(ӦṹNET_CTRL_ALARM_SUBSYSTEM_SETACTIVE)
    DH_CTRL_FORBID_OPEN_STROBE,                    // ֹ豸˿բ(Ӧṹ NET_CTRL_FORBID_OPEN_STROBE)
    DH_CTRL_OPEN_STROBE,                           // բ(Ӧṹ NET_CTRL_OPEN_STROBE)
    DH_CTRL_TALKING_REFUSE,                        // Խܾ(Ӧṹ NET_CTRL_TALKING_REFUSE)
    DH_CTRL_ARMED_EX,                              // (Ӧṹ CTRL_ARM_DISARM_PARAM_EX), CTRL_ARM_DISARM_PARAM 
    DH_CTRL_NET_KEYBOARD = 400,                    // ̿(Ӧṹ DHCTRL_NET_KEYBOARD)
    DH_CTRL_AIRCONDITION_OPEN,                     // 򿪿յ(Ӧṹ NET_CTRL_OPEN_AIRCONDITION)
    DH_CTRL_AIRCONDITION_CLOSE,                    // رտյ(Ӧṹ NET_CTRL_CLOSE_AIRCONDITION)
    DH_CTRL_AIRCONDITION_SET_TEMPERATURE,          // 趨յ¶(Ӧṹ NET_CTRL_SET_TEMPERATURE)
    DH_CTRL_AIRCONDITION_ADJUST_TEMPERATURE,       // ڿյ¶(Ӧṹ NET_CTRL_ADJUST_TEMPERATURE)
    DH_CTRL_AIRCONDITION_SETMODE,                  // ÿյģʽ(Ӧṹ NET_CTRL_ADJUST_TEMPERATURE)
    DH_CTRL_AIRCONDITION_SETWINDMODE,              // ÿյͷģʽ(Ӧṹ NET_CTRL_AIRCONDITION_SETMODE)
    DH_CTRL_RESTOREDEFAULT_EX ,                    // ָ豸ĬЭ(ӦṹNET_CTRL_RESTORE_DEFAULT)
                                                   // ָʹøö٣ӿʧܣ
                                                   // CLIENT_GetLastErrorNET_UNSUPPORTED,ٳʹDH_CTRL_RESTOREDEFAULTָ
    DH_CTRL_NOTIFY_EVENT,                          // 豸¼(Ӧṹ NET_NOTIFY_EVENT_DATA)
    DH_CTRL_SILENT_ALARM_SET,                      // 
	DH_CTRL_START_PLAYAUDIOEX,                     // 豸ʼ(Ӧṹ NET_CTRL_START_PLAYAUDIOEX)
    DH_CTRL_STOP_PLAYAUDIOEX,                      // 豸ֹͣ
    DH_CTRL_CLOSE_STROBE,                          // رյբ(Ӧṹ NET_CTRL_CLOSE_STROBE)
	DH_CTRL_SET_ORDER_STATE,                       // óλԤ״̬(Ӧṹ NET_CTRL_SET_ORDER_STATE)
	DH_CTRL_RECORDSET_INSERTEX,                    // Ӽ¼ü¼(ӦNET_CTRL_RECORDSET_INSERT_PARAM)
    DH_CTRL_RECORDSET_UPDATEEX,                    // ĳ¼ŵļ¼(ӦNET_CTRL_RECORDSET_PARAM)
    DH_CTRL_CAPTURE_FINGER_PRINT,                  // ָƲɼ(Ӧṹ NET_CTRL_CAPTURE_FINGER_PRINT)
	DH_CTRL_ECK_LED_SET,                           // ͣڿLED(Ӧṹ NET_CTRL_ECK_LED_SET_PARAM)
    DH_CTRL_ECK_IC_CARD_IMPORT,                    // ͣϵͳڻICϢ(Ӧṹ NET_CTRL_ECK_IC_CARD_IMPORT_PARAM)
    DH_CTRL_ECK_SYNC_IC_CARD,                      // ͣϵͳڻICϢָͬյָ豸ɾԭICϢ(Ӧṹ NET_CTRL_ECK_SYNC_IC_CARD_PARAM)
    DH_CTRL_LOWRATEWPAN_REMOVE,                    // ɾָ豸(Ӧṹ NET_CTRL_LOWRATEWPAN_REMOVE)
    DH_CTRL_LOWRATEWPAN_MODIFY,                    // ޸豸Ϣ(Ӧṹ NET_CTRL_LOWRATEWPAN_MODIFY)
} CtrlType;

// ָĬЭ
typedef struct tagNET_CTRL_RESTORE_DEFAULT
{
    DWORD               dwSize;
    const char*         szCfgNames;                     // '&&'Ϊ,μdhconfigsdk.hCLIENT_GetNewDevConfigCLIENT_SetNewDevConfigӿڵ
}NET_CTRL_RESTORE_DEFAULT;

// 򿪿յ(ӦDH_CTRL_AIRCONDITION_OPEN)
typedef struct tagNET_CTRL_OPEN_AIRCONDITION
{
    DWORD               dwSize;
    char                szDeviceID[DH_MAX_DEV_ID_LEN];  // 豸Ωһʶ
} NET_CTRL_OPEN_AIRCONDITION;

// رտյ(ӦDH_CTRL_AIRCONDITION_CLOSE)
typedef struct tagNET_CTRL_CLOSE_AIRCONDITION
{
    DWORD               dwSize;
    char                szDeviceID[DH_MAX_DEV_ID_LEN];  // 豸Ωһʶ
} NET_CTRL_CLOSE_AIRCONDITION;

// ÿյ¶Ȳ(ӦDH_CTRL_AIRCONDITION_SET_TEMPERATURE)
typedef struct tagNET_CTRL_SET_TEMPERATURE
{
    DWORD               dwSize;
    char                szDeviceID[DH_MAX_DEV_ID_LEN];  // 豸Ωһʶ
    int                 nTemperature;                   // ¶ֵ(λ϶)
} NET_CTRL_SET_TEMPERATURE;

// ڿյ¶Ȳ(ӦDH_CTRL_AIRCONDITION_ADJUST_TEMPERATURE)
typedef struct tagNET_CTRL_ADJUST_TEMPERATURE
{
    DWORD               dwSize;
    char                szDeviceID[DH_MAX_DEV_ID_LEN];  // 豸Ωһʶ
    int                 nTemperatureScale;              // õֵ, -1ʾ¶µһ(λ϶)
} NET_CTRL_ADJUST_TEMPERATURE;

// ÿյģʽ(ӦDH_CTRL_AIRCONDITION_SETMODE)
typedef struct tagNET_CTRL_AIRCONDITION_SETMODE
{
    DWORD                   dwSize;
    char                    szDeviceID[DH_MAX_DEV_ID_LEN];  // 豸Ωһʶ
    EM_AIRCONDITION_MODE    emAirconditionMode;             // յģʽ
    int                     nTemperature;                   // õֵ(λ϶)
} NET_CTRL_AIRCONDITION_SETMODE;

// ÿյͷģʽ(ӦDH_CTRL_AIRCONDITION_SETWINDMODE)
typedef struct tagNET_CTRL_AIRCONDITION_SETWINDMODE
{
    DWORD                       dwSize;
    char                        szDeviceID[DH_MAX_DEV_ID_LEN];  // 豸Ωһʶ
    EM_AIRCONDITION_WINDMODE    emAirconditionWindMode;         // յͷģʽ
} NET_CTRL_AIRCONDITION_SETWINDMODE;

// IOӦCLIENT_QueryIOControlStateӿ
typedef enum _IOTYPE
{
    DH_ALARMINPUT = 1,                             // Ʊ
    DH_ALARMOUTPUT = 2,                            // Ʊ
    DH_DECODER_ALARMOUT = 3,                       // Ʊ
    DH_WIRELESS_ALARMOUT = 5,                      // ߱
    DH_ALARM_TRIGGER_MODE = 7,                     // ʽֶ,Զ,رգʹTRIGGER_MODE_CONTROLṹ
} DH_IOTYPE;

//////////////////////////////////////////////////////////////////

// ֱö٣DH_DSP_ENCODECAPʹ
typedef enum _CAPTURE_SIZE
{
    CAPTURE_SIZE_D1,                               // 704*576(PAL)  704*480(NTSC)
    CAPTURE_SIZE_HD1,                              // 352*576(PAL)  352*480(NTSC)
    CAPTURE_SIZE_BCIF,                             // 704*288(PAL)  704*240(NTSC)
    CAPTURE_SIZE_CIF,                              // 352*288(PAL)  352*240(NTSC)
    CAPTURE_SIZE_QCIF,                             // 176*144(PAL)  176*120(NTSC)
    CAPTURE_SIZE_VGA,                              // 640*480
    CAPTURE_SIZE_QVGA,                             // 320*240
    CAPTURE_SIZE_SVCD,                             // 480*480
    CAPTURE_SIZE_QQVGA,                            // 160*128
    CAPTURE_SIZE_SVGA,                             // 800*592
    CAPTURE_SIZE_XVGA,                             // 1024*768
    CAPTURE_SIZE_WXGA,                             // 1280*800
    CAPTURE_SIZE_SXGA,                             // 1280*1024  
    CAPTURE_SIZE_WSXGA,                            // 1600*1024  
    CAPTURE_SIZE_UXGA,                             // 1600*1200
    CAPTURE_SIZE_WUXGA,                            // 1920*1200
    CAPTURE_SIZE_LTF,                              // 240*192
    CAPTURE_SIZE_720,                              // 1280*720
    CAPTURE_SIZE_1080,                             // 1920*1080
    CAPTURE_SIZE_1_3M,                             // 1280*960
    CAPTURE_SIZE_2M,                               // 1872*1408
    CAPTURE_SIZE_5M,                               // 3744*1408
    CAPTURE_SIZE_3M,                               // 2048*1536
    CAPTURE_SIZE_5_0M,                             // 2432*2050
    CPTRUTE_SIZE_1_2M,                             // 1216*1024
    CPTRUTE_SIZE_1408_1024,                        // 1408*1024
    CPTRUTE_SIZE_8M,                               // 3296*2472
    CPTRUTE_SIZE_2560_1920,                        // 2560*1920(5M)
    CAPTURE_SIZE_960H,                             // 960*576(PAL) 960*480(NTSC)
    CAPTURE_SIZE_960_720,                          // 960*720
    CAPTURE_SIZE_NHD,                              // 640*360
    CAPTURE_SIZE_QNHD,                             // 320*180
    CAPTURE_SIZE_QQNHD,                            // 160*90
    CAPTURE_SIZE_960_540,                          // 960*540
    CAPTURE_SIZE_640_352,                          // 640*352
    CAPTURE_SIZE_640_400,                          // 640*400
    CAPTURE_SIZE_320_192,                          // 320*192    
    CAPTURE_SIZE_320_176,                          // 320*176
    CAPTURE_SIZE_NR=255  
} CAPTURE_SIZE;

// ļͣCLIENT_ExportConfigFileӿʹ
typedef enum __DH_CONFIG_FILE_TYPE
{
    DH_CONFIGFILE_ALL = 0,                         // ȫļ
    DH_CONFIGFILE_LOCAL,                           // ļ
    DH_CONFIGFILE_NETWORK,                         // ļ
    DH_CONFIGFILE_USER,                            // ûļ
} DH_CONFIG_FILE_TYPE;

// NTP
typedef enum __DH_TIME_ZONE_TYPE
{
    DH_TIME_ZONE_0,                                // {0, 0*3600,"GMT+00:00"}
    DH_TIME_ZONE_1,                                // {1, 1*3600,"GMT+01:00"}
    DH_TIME_ZONE_2,                                // {2, 2*3600,"GMT+02:00"}
    DH_TIME_ZONE_3,                                // {3, 3*3600,"GMT+03:00"}
    DH_TIME_ZONE_4,                                // {4, 3*3600+1800,"GMT+03:30"}
    DH_TIME_ZONE_5,                                // {5, 4*3600,"GMT+04:00"}
    DH_TIME_ZONE_6,                                // {6, 4*3600+1800,"GMT+04:30"}
    DH_TIME_ZONE_7,                                // {7, 5*3600,"GMT+05:00"}
    DH_TIME_ZONE_8,                                // {8, 5*3600+1800,"GMT+05:30"}
    DH_TIME_ZONE_9,                                // {9, 5*3600+1800+900,"GMT+05:45"}
    DH_TIME_ZONE_10,                               // {10, 6*3600,"GMT+06:00"}
    DH_TIME_ZONE_11,                               // {11, 6*3600+1800,"GMT+06:30"}
    DH_TIME_ZONE_12,                               // {12, 7*3600,"GMT+07:00"}
    DH_TIME_ZONE_13,                               // {13, 8*3600,"GMT+08:00"}
    DH_TIME_ZONE_14,                               // {14, 9*3600,"GMT+09:00"}
    DH_TIME_ZONE_15,                               // {15, 9*3600+1800,"GMT+09:30"}
    DH_TIME_ZONE_16,                               // {16, 10*3600,"GMT+10:00"}
    DH_TIME_ZONE_17,                               // {17, 11*3600,"GMT+11:00"}
    DH_TIME_ZONE_18,                               // {18, 12*3600,"GMT+12:00"}
    DH_TIME_ZONE_19,                               // {19, 13*3600,"GMT+13:00"}
    DH_TIME_ZONE_20,                               // {20, -1*3600,"GMT-01:00"}
    DH_TIME_ZONE_21,                               // {21, -2*3600,"GMT-02:00"}
    DH_TIME_ZONE_22,                               // {22, -3*3600,"GMT-03:00"}
    DH_TIME_ZONE_23,                               // {23, -3*3600-1800,"GMT-03:30"}
    DH_TIME_ZONE_24,                               // {24, -4*3600,"GMT-04:00"}
    DH_TIME_ZONE_25,                               // {25, -5*3600,"GMT-05:00"}
    DH_TIME_ZONE_26,                               // {26, -6*3600,"GMT-06:00"}
    DH_TIME_ZONE_27,                               // {27, -7*3600,"GMT-07:00"}
    DH_TIME_ZONE_28,                               // {28, -8*3600,"GMT-08:00"}
    DH_TIME_ZONE_29,                               // {29, -9*3600,"GMT-09:00"}
    DH_TIME_ZONE_30,                               // {30, -10*3600,"GMT-10:00"}
    DH_TIME_ZONE_31,                               // {31, -11*3600,"GMT-11:00"}
    DH_TIME_ZONE_32,                               // {32, -12*3600,"GMT-12:00"}
} DH_TIME_ZONE_TYPE;

typedef enum _SNAP_TYPE
{
    SNAP_TYP_TIMING = 0,
    SNAP_TYP_ALARM,
    SNAP_TYP_NUM,
} SNAP_TYPE;

typedef enum _CONNECT_STATE
{
    CONNECT_STATE_UNCONNECT  = 0,
    CONNECT_STATE_CONNECTING,
    CONNECT_STATE_CONNECTED,
    CONNECT_STATE_ERROR = 255,
} CONNECT_STATE;

// ץģʽ
typedef enum tagDH_TRAFFIC_SNAP_MODE
{    
    DH_TRAFFIC_SNAP_MODE_COIL = 1,                       // Ȧץ
    DH_TRAFFIC_SNAP_MODE_COIL_PICANALYSIS,               // Ȧץ, ͼƬ
    DH_TRAFFIC_SNAP_MODE_STREAM,                         // Ƶץ
    DH_TRAFFIC_SNAP_MODE_STREAM_IDENTIFY,                // Ƶץ, ʶ
} DH_TRAFFIC_SNAP_MODE;

// λ
typedef enum 
{
    NET_CARPORTLIGHT_TYPE_RED,                           // 
    NET_CARPORTLIGHT_TYPE_GREEN,                         // ̵
}NET_CARPORTLIGHT_TYPE;

// λƷʽ
typedef enum
{
    NET_CARPORTLIGHT_MODE_OFF,                           //  
    NET_CARPORTLIGHT_MODE_ON,                            // 
    NET_CARPORTLIGHT_MODE_GLINT,                         // ˸
}NET_CARPORTLIGHT_MODE;

/////////////////////////////////ܽͨ/////////////////////////////////
//ڰ
typedef enum _EM_OPERATE_TYPE
{
    NET_TRAFFIC_LIST_INSERT,                             // Ӽ¼
    NET_TRAFFIC_LIST_UPDATE,                             // ¼¼
    NET_TRAFFIC_LIST_REMOVE,                             // ɾ¼
    NET_TRAFFIC_LIST_MAX,
}EM_RECORD_OPERATE_TYPE ;

//
typedef enum _EM_NET_PLATE_TYPE
{
    NET_PLATE_TYPE_UNKNOWN,
    NET_PLATE_TYPE_NORMAL,                              // "Normal" ƺ
    NET_PLATE_TYPE_YELLOW,                              // "Yellow" 
    NET_PLATE_TYPE_DOUBLEYELLOW,                        // "DoubleYellow" ˫β
    NET_PLATE_TYPE_POLICE,                              // "Police" 
    NET_PLATE_TYPE_ARMED,                               // "Armed" 侯
    NET_PLATE_TYPE_MILITARY,                            // "Military" Ӻ
    NET_PLATE_TYPE_DOUBLEMILITARY,                      // "DoubleMilitary" ˫
    NET_PLATE_TYPE_SAR,                                 // "SAR" ۰    
    NET_PLATE_TYPE_TRAINNING,                           // "Trainning" 
    NET_PLATE_TYPE_PERSONAL,                            // "Personal" Ժ
    NET_PLATE_TYPE_AGRI,                                // "Agri" ũ
    NET_PLATE_TYPE_EMBASSY,                             // "Embassy" ʹݺ
    NET_PLATE_TYPE_MOTO,                                // "Moto" Ħг
    NET_PLATE_TYPE_TRACTOR,                             // "Tractor" 
    NET_PLATE_TYPE_OFFICIALCAR,                         // "OfficialCar " 
    NET_PLATE_TYPE_PERSONALCAR,                         // "PersonalCar" ˽ҳ
    NET_PLATE_TYPE_WARCAR,                              // "WarCar"  
    NET_PLATE_TYPE_OTHER,                               // "Other" 
}EM_NET_PLATE_TYPE;


//ɫ
typedef enum _EM_NET_PLATE_COLOR_TYPE
{
    NET_PLATE_COLOR_OTHER,                              // ɫ
    NET_PLATE_COLOR_BLUE,                               // ɫ "Blue"
    NET_PLATE_COLOR_YELLOW,                             // ɫ "Yellow"    
    NET_PLATE_COLOR_WHITE,                              // ɫ "White"
    NET_PLATE_COLOR_BLACK,                              // ɫ "Black"
    NET_PLATE_COLOR_YELLOW_BOTTOM_BLACK_TEXT,           // Ƶ׺ "YellowbottomBlackText"
    NET_PLATE_COLOR_BLUE_BOTTOM_WHITE_TEXT,             // װ "BluebottomWhiteText" 
    NET_PLATE_COLOR_BLACK_BOTTOM_WHITE_TEXT,            // ڵװ "BlackBottomWhiteText"
}EM_NET_PLATE_COLOR_TYPE;

//
typedef enum _EM_NET_VEHICLE_TYPE
{
    NET_VEHICLE_TYPE_UNKNOW,                            // δ֪
    NET_VEHICLE_TYPE_MOTOR,                             // "Motor"            
    NET_VEHICLE_TYPE_NON_MOTOR,                         // "Non-Motor"ǻ        
    NET_VEHICLE_TYPE_BUS,                               // "Bus"        
    NET_VEHICLE_TYPE_BICYCLE,                           // "Bicycle" г        
    NET_VEHICLE_TYPE_MOTORCYCLE,                        // "Motorcycle"Ħг        
    NET_VEHICLE_TYPE_UNLICENSEDMOTOR,                   // "UnlicensedMotor": ƻ
    NET_VEHICLE_TYPE_LARGECAR,                          // "LargeCar"  
    NET_VEHICLE_TYPE_MICROCAR,                          // "MicroCar" С
    NET_VEHICLE_TYPE_EMBASSYCAR,                        // "EmbassyCar" ʹ
    NET_VEHICLE_TYPE_MARGINALCAR,                       // "MarginalCar" 
    NET_VEHICLE_TYPE_AREAOUTCAR,                        // "AreaoutCar" 
    NET_VEHICLE_TYPE_FOREIGNCAR,                        // "ForeignCar" ⼮
    NET_VEHICLE_TYPE_DUALTRIWHEELMOTORCYCLE,            // "DualTriWheelMotorcycle"Ħг
    NET_VEHICLE_TYPE_LIGHTMOTORCYCLE,                   // "LightMotorcycle" Ħг
    NET_VEHICLE_TYPE_EMBASSYMOTORCYCLE,                 // "EmbassyMotorcycle "ʹĦг
    NET_VEHICLE_TYPE_MARGINALMOTORCYCLE,                // "MarginalMotorcycle "Ħг
    NET_VEHICLE_TYPE_AREAOUTMOTORCYCLE,                 // "AreaoutMotorcycle "Ħг
    NET_VEHICLE_TYPE_FOREIGNMOTORCYCLE,                 // "ForeignMotorcycle "⼮Ħг
    NET_VEHICLE_TYPE_FARMTRANSMITCAR,                   // "FarmTransmitCar" ũ䳵
    NET_VEHICLE_TYPE_TRACTOR,                           // "Tractor" 
    NET_VEHICLE_TYPE_TRAILER,                           // "Trailer"  ҳ
    NET_VEHICLE_TYPE_COACHCAR,                          // "CoachCar"
    NET_VEHICLE_TYPE_COACHMOTORCYCLE,                   // "CoachMotorcycle "Ħг
    NET_VEHICLE_TYPE_TRIALCAR,                          // "TrialCar" 
    NET_VEHICLE_TYPE_TRIALMOTORCYCLE,                   // "TrialMotorcycle "Ħг
    NET_VEHICLE_TYPE_TEMPORARYENTRYCAR,                 // "TemporaryEntryCar"ʱ뾳
    NET_VEHICLE_TYPE_TEMPORARYENTRYMOTORCYCLE,          // "TemporaryEntryMotorcycle"ʱ뾳Ħг
    NET_VEHICLE_TYPE_TEMPORARYSTEERCAR,                 // "TemporarySteerCar"ʱʻ
    NET_VEHICLE_TYPE_PASSENGERCAR,                      // "PassengerCar" ͳ
    NET_VEHICLE_TYPE_LARGETRUCK,                        // "LargeTruck" 
    NET_VEHICLE_TYPE_MIDTRUCK,                          // "MidTruck" л
    NET_VEHICLE_TYPE_SALOONCAR,                         // "SaloonCar" γ
    NET_VEHICLE_TYPE_MICROBUS,                          // "Microbus"
    NET_VEHICLE_TYPE_MICROTRUCK,                        // "MicroTruck"С
    NET_VEHICLE_TYPE_TRICYCLE,                          // "Tricycle"ֳ
    NET_VEHICLE_TYPE_PASSERBY,                          // "Passerby" 
}EM_NET_VEHICLE_TYPE;


//ɫ
typedef enum _EM_NET_VEHICLE_COLOR_TYPE
{
    NET_VEHICLE_COLOR_OTHER,                            //ɫ    
    NET_VEHICLE_COLOR_WHITE,                            //ɫ "White"
    NET_VEHICLE_COLOR_BLACK,                            //ɫ "Black"
    NET_VEHICLE_COLOR_RED,                              //ɫ "Red"
    NET_VEHICLE_COLOR_YELLOW,                           //ɫ "Yellow"
    NET_VEHICLE_COLOR_GRAY,                             //ɫ "Gray"
    NET_VEHICLE_COLOR_BLUE,                             //ɫ "Blue"
    NET_VEHICLE_COLOR_GREEN,                            //ɫ "Green"
    NET_VEHICLE_COLOR_PINK,                             //ۺɫ "Pink"
    NET_VEHICLE_COLOR_PURPLE,                           //ɫ "Purple"
    NET_VEHICLE_COLOR_BROWN,                            //ɫ "Brown"
}EM_NET_VEHICLE_COLOR_TYPE;

//
typedef enum _EM_NET_TRAFFIC_CAR_CONTROL_TYPE
{
    NET_CAR_CONTROL_OTHER,
    NET_CAR_CONTROL_OVERDUE_NO_CHECK,                   // δ "OverdueNoCheck"
    NET_CAR_CONTROL_BRIGANDAGE_CAR,                     //  "BrigandageCar"
    NET_CAR_CONTROL_BREAKING,                           //  "CausetroubleEscape"
    NET_CAR_CONTROL_CAUSETROUBLE_ESCAPE,                // Υ "Breaking"
}EM_NET_TRAFFIC_CAR_CONTROL_TYPE;

typedef enum _EM_NET_AUTHORITY_TYPE
{
    NET_AUTHORITY_UNKNOW,
    NET_AUTHORITY_OPEN_GATE,                            //բȨ
}EM_NET_AUTHORITY_TYPE;

typedef enum _EM_NET_RECORD_TYPE
{
    NET_RECORD_UNKNOWN,

    NET_RECORD_TRAFFICREDLIST,                          // ͨ˻¼
                                                                // ѯӦ FIND_RECORD_TRAFFICREDLIST_CONDITION ṹ
                                                                // ¼ϢӦ NET_TRAFFIC_LIST_RECORD ṹ
    NET_RECORD_TRAFFICBLACKLIST,                        // ͨ˺ż¼
                                                                // ѯӦ FIND_RECORD_TRAFFICREDLIST_CONDITION ṹ
                                                                // ¼ϢӦ NET_TRAFFIC_LIST_RECORD ṹ
    NET_RECORD_BURN_CASE,                               // ¼¼
                                                                // ѯӦ FIND_RECORD_BURN_CASE_CONDITION ṹ
                                                                // ¼ϢӦ NET_BURN_CASE_INFO ṹ
    NET_RECORD_ACCESSCTLCARD,                           // Ž
                                                                // ѯӦ FIND_RECORD_ACCESSCTLCARD_CONDITION ṹ
                                                                // ¼ϢӦ NET_RECORDSET_ACCESS_CTL_CARD ṹ
    NET_RECORD_ACCESSCTLPWD,                            // Ž
                                                                // ѯӦ FIND_RECORD_ACCESSCTLPWD_CONDITION ṹ
                                                                // ¼ϢӦ NET_RECORDSET_ACCESS_CTL_PWD
    NET_RECORD_ACCESSCTLCARDREC,                        // Ž¼
                                                                // ѯӦ FIND_RECORD_ACCESSCTLCARDREC_CONDITION ṹ
                                                                // ¼ϢӦ 
    NET_RECORD_ACCESSCTLHOLIDAY,                        // ռ¼
                                                                // ѯӦ FIND_RECORD_ACCESSCTLHOLIDAY_CONDITION ṹ
                                                                // ¼ϢӦ 
    NET_RECORD_TRAFFICFLOW_STATE,                       // ѯͨ¼
                                                                // ѯӦ FIND_RECORD_TRAFFICFLOW_CONDITION ṹ
                                                                // ¼ϢӦ NET_RECORD_TRAFFIC_FLOW_STATE ṹ
    NET_RECORD_VIDEOTALKLOG,                            // ͨ¼
                                                                // ѯӦ FIND_RECORD_VIDEO_TALK_LOG_CONDITION ṹ
                                                                // ¼ϢӦ NET_RECORD_VIDEO_TALK_LOG ṹ
    NET_RECORD_REGISTERUSERSTATE,                       // ״̬¼
                                                                // ѯӦ FIND_RECORD_REGISTER_USER_STATE_CONDITION ṹ
                                                                // ¼ϢӦ NET_RECORD_REGISTER_USER_STATE ṹ
    NET_RECORD_VIDEOTALKCONTACT,                        // ϵ˼¼
                                                                // ѯӦ FIND_RECORD_VIDEO_TALK_CONTACT_CONDITION ṹ
                                                                // ¼ϢӦ NET_RECORD_VIDEO_TALK_CONTACT ṹ
}EM_NET_RECORD_TYPE;

// ʱ
typedef enum
{
    NET_TIME_TYPE_ABSLUTE,                                  // ʱ
    NET_TIME_TYPE_RELATIVE,                                 // ʱ䣬Ƶļͷ֡Ϊʱ,ͷ֡ӦUTC(0000-00-00 00:00:00)
}EM_TIME_TYPE;

// ɫ
typedef enum
{
    NET_COLOR_TYPE_RED,                                     // ɫ
    NET_COLOR_TYPE_YELLOW,                                  // ɫ
    NET_COLOR_TYPE_GREEN,                                   // ɫ
    NET_COLOR_TYPE_CYAN,                                    // ɫ
    NET_COLOR_TYPE_BLUE,                                    // ɫ
    NET_COLOR_TYPE_PURPLE,                                  // ɫ
    NET_COLOR_TYPE_BLACK,                                   // ɫ
    NET_COLOR_TYPE_WHITE,                                   // ɫ
    NET_COLOR_TYPE_MAX,
}EM_COLOR_TYPE;

/////////////////////////////////ʶ/////////////////////////////////
// Ա
typedef enum 
{
    PERSON_TYPE_UNKNOWN,
    PERSON_TYPE_NORMAL,                                     // ͨԱ
    PERSON_TYPE_SUSPICION,                                  // Ա
}EM_PERSON_TYPE;

// ֤
typedef enum
{
    CERTIFICATE_TYPE_UNKNOWN,
    CERTIFICATE_TYPE_IC,                                    // ֤
    CERTIFICATE_TYPE_PASSPORT,                              //  
}EM_CERTIFICATE_TYPE;

// ʶݿ
typedef enum
{
    NET_FACERECONGNITIONDB_UNKOWN, 
    NET_FACERECONGNITIONDB_ADD,                         // ԱϢԱѾڣͼƬݺԭݺϲ
    NET_FACERECONGNITIONDB_DELETE,                      // ɾԱϢ
}EM_OPERATE_FACERECONGNITIONDB_TYPE;

// Աģʽ
typedef enum 
{
    NET_FACE_COMPARE_MODE_UNKOWN,
    NET_FACE_COMPARE_MODE_NORMAL,                       // 
    NET_FACE_COMPARE_MODE_AREA,                         // ָ
    NET_FACE_COMPARE_MODE_AUTO,                         // ģʽ㷨Զѡȡ 
}EM_FACE_COMPARE_MODE;

// 
typedef enum
{
    NET_FACE_AREA_TYPE_UNKOWN,
    NET_FACE_AREA_TYPE_EYEBROW,                         // üë
    NET_FACE_AREA_TYPE_EYE,                             // ۾
    NET_FACE_AREA_TYPE_NOSE,                            // 
    NET_FACE_AREA_TYPE_MOUTH,                           // 
    NET_FACE_AREA_TYPE_CHEEK,                           // 
}EM_FACE_AREA_TYPE;

// 
typedef enum
{
    NET_FACE_DB_TYPE_UNKOWN,
    NET_FACE_DB_TYPE_HISTORY,                           // ʷݿ⣬ŵǼϢһûаӦԱϢ
    NET_FACE_DB_TYPE_BLACKLIST,                         // ݿ
    NET_FACE_DB_TYPE_WHITELIST,                         // ݿ
}EM_FACE_DB_TYPE;

// ʶ¼
typedef enum 
{
    NET_FACERECOGNITION_ALARM_TYPE_UNKOWN,
    NET_FACERECOGNITION_ALARM_TYPE_ALL,                // ڰ
    NET_FACERECOGNITION_ALARM_TYPE_BLACKLIST,          // 
    NET_FACERECOGNITION_ALARM_TYPE_WHITELIST,          // 
}EM_FACERECOGNITION_ALARM_TYPE;

// ʶ
typedef enum
{
    EM_FACERECOGNITION_FACE_TYPE_UNKOWN,
    EM_FACERECOGNITION_FACE_TYPE_ALL,                  //    
    EM_FACERECOGNITION_FACE_TYPE_REC_SUCCESS,          // ʶɹ
    EM_FACERECOGNITION_FACE_TYPE_REC_FAIL,             // ʶʧ
}EM_FACERECOGNITION_FACE_TYPE;

// ֡öֵ  
typedef enum __EM_FRAME_TYPE
{
    EM_FRAME_UNKOWN,                                   // δ֪ 
    EM_FRAME_TYPE_MOTION,                              // ֡Ӧ֡Ϣṹ NET_MOTION_FRAM_INFO
}EM_FRAME_TYPE;

/////////////////////////////////̭/////////////////////////////////

// ͣĿǰʹøöٵĽӿ̭벻Ҫʹ
typedef enum _CFG_INDEX
{
    CFG_GENERAL = 0,                                    // ͨ
    CFG_COMM,                                           // 
    CFG_NET,                                            // 
    CFG_RECORD,                                         // ¼
    CFG_CAPTURE,                                        // ͼ
    CFG_PTZ,                                            // ̨
    CFG_DETECT,                                         // ̬
    CFG_ALARM,                                          // 
    CFG_DISPLAY,                                        // ʾ
    CFG_RESERVED,                                       // ʹ
    CFG_TITLE = 10,                                     // ͨ
    CFG_MAIL = 11,                                      // ʼ
    CFG_EXCAPTURE = 12,                                 // Ԥͼ
    CFG_PPPOE = 13,                                     // pppoe
    CFG_DDNS = 14,                                      // DDNS
    CFG_SNIFFER    = 15,                                // Ӳ
    CFG_DSPINFO    = 16,                                // Ϣ
    CFG_COLOR = 126,                                    // ɫϢ
    CFG_ALL,                                            // 
} CFG_INDEX;

/************************************************************************
 ** ṹ嶨
 ***********************************************************************/
//ʾԭʾڵ
typedef struct
{
    double                dleft;                  //ʾԭʾڵ 
    double                dright;                 //ʾԭʾڵ
    double                dtop;                   //ʾԭʾڵ
    double                dbottom;                //ʾԭʾڵ
} DH_DISPLAYRREGION;
// ʱ
typedef struct 
{
    DWORD                dwYear;                  // 
    DWORD                dwMonth;                 // 
    DWORD                dwDay;                   // 
    DWORD                dwHour;                  // ʱ
    DWORD                dwMinute;                // 
    DWORD                dwSecond;                // 
} NET_TIME,*LPNET_TIME;

typedef struct 
{
    DWORD                dwYear;                  // 
    DWORD                dwMonth;                 // 
    DWORD                dwDay;                   // 
    DWORD                dwHour;                  // ʱ
    DWORD                dwMinute;                // 
    DWORD                dwSecond;                // 
    DWORD                dwMillisecond;           // 
    DWORD                dwReserved[2];           // ֶ
} NET_TIME_EX,*LPNET_TIME_EX;

// ־Ϣʱ䶨
typedef struct _DHDEVTIME
{
    DWORD                second:6;                //     1-60        
    DWORD                minute:6;                //     1-60        
    DWORD                hour:5;                  // ʱ    1-24        
    DWORD                day:5;                   //     1-31        
    DWORD                month:4;                 //     1-12        
    DWORD                year:6;                  //     2000-2063    
} DHDEVTIME, *LPDHDEVTIME;

// ص(첽ӿ)
typedef struct __NET_CALLBACK_DATA 
{
    int                  nResultCode;            // 룻0ɹ
    char                 *pBuf;                  // , ûٵģӽӿβδ
    int                  nRetLen;                // ճ
    LLONG                lOperateHandle;         // 
    void*                userdata;               // Ӧû
    char                 reserved[16];
} NET_CALLBACK_DATA, *LPNET_CALLBACK_DATA;

///////////////////////////////ض///////////////////////////////

// صƵ֡֡ṹ
typedef struct _tagVideoFrameParam
{
    BYTE                 encode;                 // 
    BYTE                 frametype;              // I = 0, P = 1, B = 2...
    BYTE                 format;                 // PAL - 0, NTSC - 1
    BYTE                 size;                   // CIF - 0, HD1 - 1, 2CIF - 2, D1 - 3, VGA - 4, QCIF - 5, QVGA - 6 ,
                                                 // SVCD - 7,QQVGA - 8, SVGA - 9, XVGA - 10,WXGA - 11,SXGA - 12,WSXGA - 13,UXGA - 14,WUXGA - 15, LFT - 16, 720 - 17, 1080 - 18
    DWORD                fourcc;                 // H264Ϊ0MPEG4дFOURCC('X','V','I','D');
    DWORD                reserved;               // 
    NET_TIME             struTime;               // ʱϢ
} tagVideoFrameParam;

// صƵ֡֡ṹ
typedef struct _tagCBPCMDataParam
{
    BYTE                channels;                // 
    BYTE                samples;                 //  0 - 8000, 1 - 11025, 2 - 16000, 3 - 22050, 4 - 32000, 5 - 44100, 6 - 48000
    BYTE                depth;                   //  ȡֵ816ȡֱӱʾ
    BYTE                param1;                  // 0 - ָʾ޷ţ1-ָʾз
    DWORD               reserved;                // 
} tagCBPCMDataParam;

// ͨĻӵݽṹ
typedef struct _DH_CHANNEL_OSDSTRING
{
    BOOL                bEnable;                            // ʹ
    DWORD               dwPosition[MAX_STRING_LINE_LEN];    //ַλá1-9ʾСλöӦ
                                                            // 7    8        9
                                                            // 4      5        6
                                                            // 1    2        3
    char                szStrings[MAX_STRING_LINE_LEN][MAX_PER_STRING_LEN];    // ַÿ20ֽ
} DH_CHANNEL_OSDSTRING;

//صYUVݵĲṹ
typedef struct _tagCBYUVDataParam
{
    long                nWidth;                 // ͼĿ
    long                nHeight;                // ͼĸ
    DWORD               reserved[8];            // 
} tagCBYUVDataParam;

///////////////////////////////طض///////////////////////////////

// ¼ļϢ
typedef struct
{

    unsigned int        ch;                         // ͨ
    char                filename[124];              // ļ
    unsigned int        framenum;                   // ļ֡
    unsigned int        size;                       // ļ
    NET_TIME            starttime;                  // ʼʱ
    NET_TIME            endtime;                    // ʱ
    unsigned int        driveno;                    // ̺(¼ͱ¼ͣ0127ʾ¼,64ʾ1128ʾ¼)
    unsigned int        startcluster;               // ʼغ
    BYTE                nRecordFileType;            // ¼ļ  0ͨ¼1¼2ƶ⣻3¼4ͼƬ, 5: ¼
    BYTE                bImportantRecID;            // 0:ͨ¼ 1:Ҫ¼
    BYTE                bHint;                      // ļλ
    BYTE                bRecType;                   // 0-¼ 1-1¼ 2-2 3-3¼
} NET_RECORDFILE_INFO, *LPNET_RECORDFILE_INFO;

// Ũ¼ļϢ
typedef struct tagNET_SynopsisFileInfo
{
    DWORD               dwSize;                     // ýṹС
    char                szFileName[MAX_PATH];       // ļC:\a.dav
    NET_TIME            stuStartTime;               // ʼʱ
    NET_TIME            stuEndTime;                 // ʱ
    unsigned int        nTaskID;                    // ڷıʾļ2ѡ1ʹ
    BYTE                bFileType;                  // 1-ƵŨ¼ļ2-ƵŨԴļ
    BYTE                byMode;                     // ģʽ: 0-ļ, 1-ʱ, 2-ļƫ
    BYTE                bReserved[2];
    unsigned int        nFileLength;                // ļСλ:KB
    unsigned int        nStartFileOffset;           // ʼļƫ, λ: KB
    unsigned int        nEndFileOffset;             // ļƫ, λ: KB
}NET_SYNOPSISFILE_INFO, *LPNET_SYNOPSISFILE_INFO;

// طݻصԭ
typedef int (CALLBACK *fDataCallBack)(LLONG lRealHandle, DWORD dwDataType, BYTE *pBuffer, DWORD dwBufSize, LDWORD dwUser);

typedef struct __NET_MULTI_PLAYBACK_PARAM 
{
    DWORD                      dwSize; 
    int                        nChannels[DH_MAX_MULTIPLAYBACK_CHANNEL_NUM]; // Ԥͨ
    int                        nChannelNum;                             // Ԥͨ 
    int                        nType;                                   // طļͣ0ͨ¼1¼2ƶ⣻3¼4ͼƬ
    NET_TIME                   stStartTime;                             // طſʼʱ
    NET_TIME                   stEndTime;                               // طŽʱ
    int                        nFPS;                                    // ֡,1~25
    int                        nBitRate;                                // ֵ,192~1024
    char                       szResolution[DH_MAX_CAPTURE_SIZE_NUM];   // ֱʣ"D1""HD1""2CIF""CIF""QCIF"   
    int                        nWaitTime;                               // ʱȴʱ 
    HWND                       hWnd;                                    // ƵŴھ
    fDataCallBack              fDownLoadDataCallBack;                   // Ƶݻص
    LDWORD                     dwDataUser;                              // 
}NET_MULTI_PLAYBACK_PARAM;

// ĳµĸǷ¼״̬Ϣ
typedef struct
{
    BYTE        flag[32];           //ĳڵĸǷ¼״̬룬0ʾûУ1ʾС
    BYTE        Reserved[64];       //
}NET_RECORD_STATUS, *LPNET_RECORD_STATUS;

// 첽ѯصԭ,nError = 0ʾѯɹnError = 1ʾڴʧܣnError = 2ʾʱnError = 3ʾ豸У鲻ͨnError = 4 Ͳѯʧ
typedef void (CALLBACK *fQueryRecordFileCallBack)(LLONG lQueryHandle, LPNET_RECORDFILE_INFO pFileinfos, int nFileNum, int nError, void *pReserved, LDWORD dwUser);

// CLIENT_StartQueryRecordFileӿ
typedef struct tagNET_IN_START_QUERY_RECORDFILE
{ 
    DWORD               dwSize;                            // ṹС
    int                 nChannelId;                        // ѯͨ
    int                 nRecordFileType;                   // ѯ¼ 
    int                 nStreamType;                       // ѯ,0-,1-,2-
    NET_TIME            stStartTime;                       // ѯʼʱ
    NET_TIME            stEndTime;                         // ѯʱ
    char*               pchCardid;                         // Ϣ
    int                 nWaitTime;                         // ʱȴʱ䣬λms 
    fQueryRecordFileCallBack cbFunc;                       // ѯص 
    LDWORD              dwUser;                            // ûϢ
}NET_IN_START_QUERY_RECORDFILE;

typedef struct tagNET_OUT_START_QUERY_RECORDFILE
{
    DWORD                dwSize;                           // ṹС
    LLONG                lQueryHandle;                     // ؾ    
}NET_OUT_START_QUERY_RECORDFILE;

typedef struct
{
    unsigned short      left;                        // 0~8192
    unsigned short      right;                       // 0~8192
    unsigned short      top;                         // 0~8192
    unsigned short      bottom;                      // 0~8192
} MotionDetectRect;

// ܻطϢ
typedef struct 
{
    MotionDetectRect    motion_rect;               // ֡
    NET_TIME            stime;                     // طŵĿʼʱ
    NET_TIME            etime;                     // طŵĽʱ
    BYTE                bStart;                    // ʼֹͣ: 1,ʼ,2:ֹͣ
    BYTE                reserved[116];
} IntelligentSearchPlay, *LPIntelligentSearchPlay;

// ¼ʱ
typedef struct  
{
    int                 nChnCount;                  // ͨĿ
    NET_TIME            stuFurthestTime[16];        // ¼ʱ,ЧֵΪǰ0  (nChnCount-1).ĳͨû¼Ļ¼ʱȫΪ0
    DWORD               dwFurthestTimeAllSize;      // ͨ16ʱʹáʾpStuFurthestTimeAllڴС
    NET_TIME*           pStuFurthestTimeAll;        // ͨ16ʱʹá˲ڴҪû,СΪ(ͨ*sizeof(NET_TIME))
    BYTE                bReserved[376];             // ֶ
} NET_FURTHEST_RECORD_TIME;

// CLIENT_FindFramInfo ӿ
typedef struct __NET_IN_FIND_FRAMEINFO_PRAM
{
    DWORD                 dwSize;                   // ṹС 
    BOOL                  abFileName;               // ļǷΪЧĲѯļЧļϢstRecordInfo
    char                  szFileName[MAX_PATH];     // ļ
    NET_RECORDFILE_INFO   stuRecordInfo;            // ļϢ
    DWORD                 dwFramTypeMask;           // ֡룬֡붨塱
}NET_IN_FIND_FRAMEINFO_PRAM;

// CLIENT_FindFramInfo ӿ
typedef struct __NET_OUT_FIND_FRAMEINFO_PRAM
{
    DWORD                 dwSize;               // ṹС 
    LLONG                 lFindHandle;          // ļҾ
}NET_OUT_FIND_FRAMEINFO_PRAM;

// ֡Ϣ
typedef struct __NET_MOTION_FRAME_INFO
{
    DWORD                 dwSize;               // ṹС
    NET_TIME              stuTime;              // ǰ֡ʱ 
    int                   nMotionRow;           // ̬
    int                   nMotionCol;           // ̬
    BYTE                  byRegion[DH_MOTION_ROW][DH_MOTION_COL];// 32*32
}NET_MOTION_FRAME_INFO;

// ļ֡Ϣ
typedef struct __NET_FILE_FRAME_INFO
{
    DWORD                 dwSize;               // ṹС
    int                   nChannelId;           // ͨ
    NET_TIME              stuStartTime;         // ʼʱ
    NET_TIME              stuEndTime;           // ʱ
    WORD                  wRecType;             // 0-¼ 1-1¼ 2-2 3-3¼
    WORD                  wFameType;            // ֡ͣEM_FRAM_TYPE
    void*                 pFramInfo;            // Ӧ֡Ϣռû
}NET_FILE_FRAME_INFO;

// CLIENT_FindNextFramInfo ӿ
typedef struct __NET_IN_FINDNEXT_FRAMEINFO_PRAM
{
    DWORD                 dwSize;               // ṹС  
    int                   nFramCount;           // ѯ֡0ʾѯϲѯ֡Ϣ
}NET_IN_FINDNEXT_FRAMEINFO_PRAM;

// CLIENT_FindNextFramInfo ӿ
typedef struct __NET_OUT_FINDNEXT_FRAMEINFO_PRAM
{
    DWORD                 dwSize;               // ṹС 
    NET_FILE_FRAME_INFO*  pFramInfos;           // ֡Ϣûռ䣬ռСΪ sizeof(NET_FILE_FRAM_INFO) * nMaxFramCount
    int                   nMaxFramCount;        // û֡Ϣ
    int                   nRetFramCount;        // ʵʷص֡Ϣ
}NET_OUT_FINDNEXT_FRAMEINFO_PRAM;

///////////////////////////////ض///////////////////////////////

// ͨϢ
typedef struct
{
    int                  channelcount;
    int                  alarminputcount;
    unsigned char        alarm[16];                // ⲿ
    unsigned char        motiondection[16];        // ̬
    unsigned char        videolost[16];            // Ƶʧ
} NET_CLIENT_STATE;

// ͨϢ
typedef struct
{
    int                  channelcount;
    int                  alarminputcount;
    unsigned char        alarm[32];                // ⲿ
    unsigned char        motiondection[32];        // ̬
    unsigned char        videolost[32];            // Ƶʧ
    BYTE                 bReserved[32];
} NET_CLIENT_STATE_EX;

// ⲿ״̬ϢӦṹ
typedef struct
{
    DWORD                dwSize;
    int                  alarminputcount;
    DWORD                dwAlarmState[DH_MAX_CHANMASK]; //ÿһDWORDλʾ32ͨı״̬, 0-ʾޱ, 1-ʾб
}NET_CLIENT_ALARM_STATE;

// Ƶʧ״̬ϢӦṹ
typedef struct
{
    DWORD                dwSize;
    int                  channelcount;
    DWORD                dwAlarmState[DH_MAX_CHANMASK]; //ÿһDWORDλʾ32ͨı״̬, 0-ʾޱ, 1-ʾб
}NET_CLIENT_VIDEOLOST_STATE;

// ̬ⱨ״̬ϢӦṹ
typedef struct
{
    DWORD                dwSize;
    int                  channelcount;
    DWORD                dwAlarmState[DH_MAX_CHANMASK]; //ÿһDWORDλʾ32ͨı״̬, 0-ʾޱ, 1-ʾб
}NET_CLIENT_MOTIONDETECT_STATE;

// Ƶڵ״̬ϢӦṹ
typedef struct
{
    DWORD                dwSize;
    int                  channelcount;
    DWORD                dwAlarmState[DH_MAX_CHANMASK]; //ÿһDWORDλʾ32ͨı״̬, 0-ʾޱ, 1-ʾб
}NET_CLIENT_VIDEOBLIND_STATE;

// ѯ ̬ⱨ״̬ϸϢӦṹ
typedef struct
{
    DWORD               dwSize;
    int                 nChannelID;                 // ͨ
    BOOL                bAlarm;                     // Ƿ񱨾 TRUE/FALSE
    int                 nLevel;                     // 𣬵λǧ֮Զ췢СС
}NET_CLIENT_DETAILEDMOTION_STATE;

// IO
typedef struct 
{
    unsigned short       index;                    // ˿
    unsigned short       state;                    // ˿״̬
} ALARM_CONTROL;

// ʽ
typedef struct
{
    unsigned short       index;                    // ˿
    unsigned short       mode;                     // ʽ(0ر1ֶ2Զ);õͨsdkĬϽԭá
    BYTE                 bReserved[28];            
} TRIGGER_MODE_CONTROL;

// 
typedef struct 
{
    int                 decoderNo;               // ţ0ʼ
    unsigned short      alarmChn;                // ڣ0ʼ
    unsigned short      alarmState;              // ״̬1򿪣0ر
} DECODER_ALARM_CONTROL;

// Ӧ𱨾¼
typedef struct __ALARM_NO_RESPONSE_INFO
{
    DWORD               dwSize;
    char                szCallID[DH_MAX_CALLID];                             //Call ID
}ALARM_NO_RESPONSE_INFO;

// ϴܵıϢ
typedef struct  
{
    DWORD               dwAlarmType;                            // ͣdwAlarmType = DH_UPLOAD_EVENTʱdwAlarmMaskbAlarmDecoderIndexЧ
    DWORD               dwAlarmMask;                            // Ϣ룬λʾͨ״̬
    char                szGlobalIP[DH_MAX_IPADDR_LEN];          // ͻIPַ
    char                szDomainName[DH_MAX_DOMAIN_NAME_LEN];   // ͻ
    int                 nPort;                                  // ϴʱͻӵĶ˿
    char                szAlarmOccurTime[DH_ALARM_OCCUR_TIME_LEN];    // ʱ
    BYTE                bAlarmDecoderIndex;                     // ʾڼdwAlarmType = DH_UPLOAD_DECODER_ALARM Ч.
    BYTE                bReservedSpace[15];
} NEW_ALARM_UPLOAD;

// ̸б¼
typedef struct __ALARM_UPLOAD_SMOKESENSOR_INFO
{
    DWORD           dwSize;
    char            szGlobalIP[DH_MAX_IPADDR_LEN];               // ͻIPַ
    char            szDomainName[DH_MAX_DOMAIN_NAME_LEN];        // ͻ
    int             nPort;                                       // ϴʱͻӵĶ˿
    char            szAlarmOccurTime[DH_ALARM_OCCUR_TIME_LEN];   // ʱ
    int             nChannel;                                    // ͨ 0ʼ
    BYTE            byHighTemperature;                           // 1:±ʼ0±
    BYTE            bySmoke;                                     // 1:̸бʼ0̸б
}ALARM_UPLOAD_SMOKESENSOR_INFO;

// ܱ¼
typedef struct __ALARM_UPLOAD_IVS_INFO
{
    DWORD           dwSize;
    NET_TIME        stuTime;                                    // ¼ʱ    
    char            szDomainName[DH_MAX_DOMAIN_NAME_LEN];       // ͻ
    int             nChannelID;                                 // ͨţ0ʼ
    char            szType[MAX_PATH];                           // , 
    int             nState;                                     // ״̬0-λ1-λ, 2-ʽ
    char            szRuleName[DH_COMMON_STRING_128];           //   
    char            szIPAddress[DH_MAX_IPADDR_LEN_EX];          // 豸IPַ  
    int             nPort;                                      // 豸˿ں
    char            szMacAddress[DH_MACADDR_LEN];               // 豸macַ
    char            szPicFilePath[MAX_PATH];                    // ͼƬļ·
    int             nPicFileNum;                                // ǰӦͼƬļ
    int             nUploadPicFileNum;                          // ϴFTPͼƬļ
    DWORD           dwChannelMask;                              // ץͼƵͨ룬15ʾ˴αץͼ1,2,3,4ͨ 
} ALARM_UPLOAD_IVS_INFO;

// ⲿչϢ
typedef struct _ALARM_UPLOAD_ALARMEX_INFO
{
    DWORD           dwSize;
    NET_TIME        stuTime;                                    // ¼ʱ    
    char            szDomainName[DH_MAX_DOMAIN_NAME_LEN];       // ͻ
    DWORD           dwAlarmMask;                                // Ϣ룬λʾͨ״̬, 7ʾ1,2,3ͨ
    char            szDevMac[DH_MACADDR_LEN];                   // 豸macַ
    char            szPicFilePath[MAX_PATH];                    // ͼƬļ·
    int             nPicFileNum;                                // ǰӦͼƬļ
    int             nUploadPicFileNum;                          // ϴFTPͼƬļ
    char            szAreaName[DH_COMMON_STRING_128];           // 
    DWORD           dwChannelMask;                              // ץͼƵͨ룬15ʾ˴αץͼ1,2,3,4ͨ 
}ALARM_UPLOAD_ALARMEX_INFO;

typedef enum _EM_LOGIN_FAILED_TYPE
{
    LOGIN_FAILED_UNKNOW = 0 ,
    LOGIN_FAILED_PASSWORD   ,           //벻ȷ
    LOGIN_FAILED_USER       ,           //ʺŲ
    LOGIN_FAILED_TIMEOUT    ,           //ȴ¼سʱ
    LOGIN_FAILED_RELOGGIN   ,           //ʺѾ¼
    LOGIN_FAILED_LOCKED     ,           //ʺѱ
    LOGIN_FAILED_BLACKLIST  ,           //ʺű
    LOGIN_FAILED_ERROR_BUSY ,           //Դ㣬ϵͳæ
    LOGIN_FAILED_VERSION    ,           //汾ԣ޷½ 
}EM_LOGIN_FAILED_TYPE;

//Զ̵¼ʧܱϢ
typedef struct  __ALARM_UPLOAD_LOGIN_FAILED_INFO
{
    DWORD                   dwSize;
    EM_LOGIN_FAILED_TYPE    emFailedType;                       //½ʧ
    char                    szDeviceIP[DH_COMMON_STRING_64];    //豸IP
    DWORD                   nDevicePort;                        //豸˿
}ALARM_UPLOAD_LOGIN_FAILED_INFO;

// ¼״̬仯Ϣ
typedef struct
{
    int                 nChannel;               // ¼ͨ
    char                reserved[12];
} ALARM_RECORDING_CHANGED;

#define NET_MAX_WINDINGID_NUM    8

// Ȧ/
typedef struct __ALARM_WINGDING_INFO
{
    int                 nDriveWayID;            // 
    int                 nWindingID;             // ȦIDֶηϳnWindingIDsΪ׼
    NET_TIME            stuTime;                // ʱ
    int                 nState;                 // 豸״̬0ʾϻָ1ʾ
    DWORD               dwChannel;              // ͨ
    char                reserve[28];
    int                 nWindingIDNum;          // ȦID
    int                 nWindingIDs[NET_MAX_WINDINGID_NUM];// ȦID 
} ALARM_WINGDING_INFO;

// ͨӵ
typedef struct __ALARM_TRAF_CONGESTION_INFO
{
    int                 nDriveWayID;            // 
    int                 nCongestionLevel;       // ͨӵȼ:1,2,3,4,5,6;1
    NET_TIME            stuTime;                // ʱ
    int                 nState;                 // 豸״̬0ʾϻָ1ʾ
    DWORD               dwChannel;              // ͨ
    char                reserve[28];
} ALARM_TRAF_CONGESTION_INFO;

// ͨ쳣
typedef struct __ALARM_TRAF_EXCEPTION_INFO
{
    int                 nDriveWayID;            // 
    NET_TIME            stuTime;                // ʱ
    int                 nState;                 // 豸״̬0ʾϻָ1ʾ
    DWORD               dwChannel;              // ͨ
    char                reserve[28];
} ALARM_TRAF_EXCEPTION_INFO;

// 豸ϱ
typedef struct __ALARM_EQUIPMENT_FILL_INFO
{
    int                 nDriveWayID;            // 
    NET_TIME            stuTime;                // ʱ
    int                 nState;                 // 豸״̬0ʾϻָ1ʾ
    DWORD               dwChannel;              // ͨ
    char                reserve[28];
} ALARM_EQUIPMENT_FILL_INFO;

// ״̬Ϣ
typedef struct __ALARM_ARM_DISARM_STATE_INFO
{
    BYTE                bState;                 // ״̬0ʾ1ʾ2ʾǿƲ
    char                reserve[31];
} ALARM_ARM_DISARM_STATE_INFO;

// 3Gֵ״̬Ϣ 
typedef struct __DHDEV_3GFLOW_EXCEED_STATE_INFO
{
    BYTE                bState;                 // 3Gֵ״̬0ʾδֵ1ʾֵ
    char                reserve[31];
} DHDEV_3GFLOW_EXCEED_STATE_INFO;

// ٱ·ٱ (DH_DEVSTATE_SPEED_LIMIT)
typedef struct __ALARM_SPEED_LIMIT
{
    char                szType[DH_SPEEDLIMIT_TYPE_LEN];     // ٱLowerSpeed, UpperSpeed
    int                 iSpeedLimit;                        //  λKM/H 
    int                 iSpeed;                             // ٶ λKM/H
    char                szCrossingID[DH_MAX_CROSSING_ID];   // ·к
    DWORD               dwLongitude;                        // (λǰ֮ȣΧ0-360)綫120.178274ȱʾΪ300178274
    DWORD               dwLatidude;                         // γ(λǰ֮ȣΧ0-180)籱γ30.183382ȱʾΪ120183382
    DHDEVTIME           stTime;                             // ʱ
    BYTE                bOffline;                           // 0-ʵʱ 1- 
    char                reserve[19];
}ALARM_SPEED_LIMIT;

// ٱ

// ر
typedef struct __ALARM_OVER_LOADING
{
    NET_TIME            stuCurTime;                         // ǰʱ
    DWORD               dwLatidude;                         // γ(λǰ֮ȣΧ0-180)籱γ30.183382ȱʾΪ120183382
    DWORD               dwLongitude;                        // (λǰ֮ȣΧ0-360)綫120.178274ȱʾΪ300178274
    char                szDriverNo[DH_VEHICLE_DRIVERNO_LEN];// ʻԱID
    DWORD               dwCurSpeed;                         // ǰٶ
    BYTE                byReserved[128]; 
}ALARM_OVER_LOADING;

// ɲ
typedef struct __ALARM_HARD_BRAKING
{
    NET_TIME        stuCurTime;                             // ǰʱ
    DWORD           dwLatidude;                             // γ(λǰ֮ȣΧ0-180)籱γ30.183382ȱʾΪ120183382
    DWORD           dwLongitude;                            // (λǰ֮ȣΧ0-360)綫120.178274ȱʾΪ300178274
    char            szDriverNo[DH_VEHICLE_DRIVERNO_LEN];    // ʻԱID
    DWORD           dwCurSpeed;                             // ǰٶ
    BYTE            byReserved[128]; 
}ALARM_HARD_BRAKING;

// ̸б
typedef struct __ALARM_SMOKE_SENSOR
{
    NET_TIME        stuCurTime;             // ǰʱ
    int             nChannel;               // ͨ
    BYTE            byHighTemperature;      // 1:±ʼ0±
    BYTE            bySmoke;                // 1:̸бʼ0̸б
    BYTE            byReservrd[126];
}ALARM_SMOKE_SENSOR;

// ͨƹϱ
typedef struct _LIGHT_INFO
{
    BYTE               byDirection;            // ͨƷ: 1-У2-У3-ֱ, 4-ͷ
    BYTE               byState;                // ͨ״̬: 1-ϣ2-
    BYTE               byReserved[62];         // ֽ 
}LIGHT_INFO;

typedef struct __ALARM_TRAFFIC_LIGHT_FAULT 
{
    NET_TIME           stTime;                 // ʱ
    int                nInfoNumber;            // Ϣ
    LIGHT_INFO         stLightInfo[8];         // ͨƹϢ
    BYTE               byReserved[128];        // ֶ
}ALARM_TRAFFIC_LIGHT_FAULT;

// ͳƱͨϢ
typedef struct __ALARM_TRAFFIC_FLUX_LANE_INFO
{
    NET_TIME            stuCurTime;            // ǰʱ
    int                 nLane;                 // 
    int                 nState;                // ״ֵ̬1-ʾӵ, 2-ʾӵ»ָ, 3-ʾ, 4-ʾж, 5-ʾжϻָ
    int                 nFlow;                 // ֵλ/
    BYTE                byReserved[124];       // 
}ALARM_TRAFFIC_FLUX_LANE_INFO;

// SIP״̬ı䱨()
typedef struct __ALARM_SIP_STATE
{
    int     nChannelID;
    BYTE    byStatus;                         //0:עɹ,1:δע,2:Ч,3:ע,4:ͨ
    BYTE    bReserved[63];                    //
}ALARM_SIP_STATE;

// ԶϢϴ(DH_DEVSTATE_VIHICLE_INFO_UPLOAD)
typedef struct __ALARM_VEHICLE_INFO_UPLOAD
{
    char                szType[DH_VEHICLE_TYPE_LEN];                 // Ϣ: DriverCheck˾ǩǩ
    char                szCheckInfo[DH_VEHICLE_INFO_LEN];            // ǩ룺CheckInǩCheckOut  
    char                szDirverNO[DH_VEHICLE_DRIVERNO_LEN];         // ˾ַ
    DHDEVTIME           stTime;                                      // ʱ
    BYTE                bOffline;                                    // 0-ʵʱ 1- 
    char                reserved[59];                     
}ALARM_VEHICLE_INFO_UPLOAD;
// ԶϢϴ

// ¼Ϣϴ
typedef struct __ALARM_CARD_RECORD_INFO_UPLOAD
{
    int                 nChannel;                           // ͨ
    BOOL                bEnable;                            // Ƿڿ¼
    char                szCardInfo[DH_MAX_CARD_INFO_LEN];   // Ϣ
    NET_TIME            stuTime;                            // ÿЧʼʱ
    BOOL                bPreviewOverlayEn;                  // Ԥʹ
    BYTE                byOverlayPos;                       // λ,1-ϣ2-£3-ϣ4-
    char                reserved[59];
}ALARM_CARD_RECORD_INFO_UPLOAD;



typedef enum __ATMTradeTypes{
    TRADE_TYPE_INC = 0,        //忨INSERTCARD
    TRADE_TYPE_WDC,            //˿WITHDRAWCARD
    TRADE_TYPE_CKT,            //УʱCHECKTIME
    TRADE_TYPE_INQ,            //ѯ
    TRADE_TYPE_CWD,            //ȡ
    TRADE_TYPE_PIN,            //
    TRADE_TYPE_TFR,            //ת
    TRADE_TYPE_DEP,            //
    TRADE_TYPE_NCINQ,          //޿ѯ
    TRADE_TYPE_NCDEP,          //޿
    TRADE_TYPE_OTHERS,         //
    TRADE_TYPE_ALL,            //
}DH_eATMTradeTypes;

typedef struct __ALARM_ATM_INFO_UPLOAD_CHNL
{
    int                 nChannel;                   // ѯĵڼͨATMϢ,Χ0-N-1Nʾͨ
    char                szATMID[32];                // ATMն˺
    char                szCardNo[32];               //     6222421541208230456 
    char                szTradetime[32];            // ʱ    20111118112200ʾ2011-11-18 11:22:00
    DH_eATMTradeTypes   emTradeType;                //     Χ: ATMTradeTypes
    int                 nAmount;                    // ׽    0-4294967296
    BYTE                byRerved[32];               // 
}ALARM_ATM_INFO_UPLOAD_CHNL;

// ATMϢϴ(DH_ALARM_ATM_INFO_UPLOAD)¼Ӧṹ
typedef struct __ALARM_ATM_INFO_UPLOAD
{
    int                           nCnt;
    ALARM_ATM_INFO_UPLOAD_CHNL    m_stAtmInfo[DH_MAX_CHANNUM];
}ALARM_ATM_INFO_UPLOAD;

// λ¼
typedef struct __ALARM_CAMERA_MOVE_INFO
{
    int                         nChannelNum;                        // ͨ
    unsigned char               alarmChannels[DH_MAX_CHANNUM_EX];   // ͨϢ
    BYTE                        byReserved[128];
}ALARM_CAMERA_MOVE_INFO;

// ϸ챨Ϣ
typedef struct __ALARM_DETAILEDMOTION_CHNL_INFO
{
    DWORD              dwSize;
    int                nChannelID;    // ͨ
    BOOL               bAlarm;        // Ƿ񱨾 TRUE/FALSE
    int                nLevel;        // 𣬵λǧ֮Զ췢СС
}ALARM_DETAILEDMOTION_CHNL_INFO;

/// 洢쳣
typedef struct __ALARM_STORAGE_FAILURE
{
    DWORD     dwSize;                                     // ṹС
    UINT      ActionType;                                 // 0ֹͣ 1ʼ
    char      szProtocol[DH_MAX_STRING_LEN];              // ЭͣĿǰֻ֧FTP
    char      szServerAddr[DH_MAX_IPADDR_OR_DOMAIN_LEN];  // IPַ
    DWORD     dwPort;                                     // ˿ں
    NET_TIME  stuTime;                                    // ¼ʱ
    int       nChannel;                                   // ͨ, 1ʼ, 0ʾͨ
}ALARM_STORAGE_FAILURE;

// ǰ˶Ϣ
typedef struct __ALARM_FRONTDISCONNET_INFO
{
    DWORD              dwSize;                           // ṹС
    int                nChannelID;                       // ͨ
    int                nAction;                          // 0:ʼ 1:ֹͣ
    NET_TIME           stuTime;                          // ¼ʱ
    char               szIpAddress[MAX_PATH];            // ǰIPCIPַ
}ALARM_FRONTDISCONNET_INFO;

// صѹͱ
typedef struct __ALARM_BATTERYLOWPOWER_INFO
{
    DWORD             dwSize;                            // ṹС
    int               nAction;                           // 0:ʼ 1:ֹͣ
    int               nBatteryLeft;                      // ʣٷֱȣλ%
    NET_TIME          stTime;                            // ¼ʱ

}ALARM_BATTERYLOWPOWER_INFO;

// ¶ȹ߱
typedef struct __ALARM_TEMPERATURE_INFO
{
    DWORD              dwSize;                           // ṹС
    char               szSensorName[DH_MACHINE_NAME_NUM];// ¶ȴ
    int                nChannelID;                       // ͨ
    int                nAction;                          // 0:ʼ 1:ֹͣ
    float              fTemperature;                     // ǰ¶ֵ, λ϶
    NET_TIME           stTime;                           // ¼ʱ
}ALARM_TEMPERATURE_INFO;

// ƣͼʻ
typedef struct __ALARM_TIREDDRIVE_INFO
{
    DWORD             dwSize;                            // ṹС
    int               nAction;                           // 0:ʼ 1:ֹͣ
    int               nDriveTime;                        // ʻʱ䣬λ
    NET_TIME          stTime;                            // ¼ʱ
}ALARM_TIREDDRIVE_INFO;

// ¼¼
typedef struct __ALARM_LOST_RECORD
{
    DWORD     dwSize;                                     //ṹС
    UINT      ActionType;                                 // 0ֹͣ 1ʼ
    UINT      nChannelID;                                 // ͨţ1ʼ
    UINT      nStreamType;                                // ͣ01122334ץͼ
    NET_TIME  stuTime;                                    // ¼ʱ    
}ALARM_LOST_RECORD;

// CPUռʹ¼ݶ95%
typedef struct __ALARM_HIGH_CPU
{
    DWORD     dwSize;                                     //ṹС
    UINT      ActionType;                                 // 0ֹͣ 1ʼ
    UINT      nUsed;                                      // CPUռʵ1000
    NET_TIME  stuTime;                                    // ¼ʱ    
}ALARM_HIGH_CPU;

// 緢ݶ¼
typedef struct __ALARM_LOST_NETPACKET
{
    DWORD     dwSize;                                     //ṹС
    UINT      ActionType;                                 // 0ֹͣ 1ʼ
    UINT      nChannelID;                                 // ͨţ1ʼ
    UINT      nStreamType;                                // ͣ01122334ץͼ
    char      szRemoteIP[DH_MAX_IPADDR_LEN];              // ͶIPַ
    DWORD     dwRemotePort;                               // Ͷ˵Ķ˿ڵַ
    NET_TIME  stuTime;                                    // ¼ʱ    
}ALARM_LOST_NETPACKET;

// ڴռʹ¼ݶ95%
typedef struct __ALARM_HIGH_MEMORY
{
    DWORD     dwSize;                                     //ṹС
    UINT      ActionType;                                 // 0ֹͣ 1ʼ
    UINT      nUsed;                                      // ڴռʵ1000
    NET_TIME  stuTime;                                    // ¼ʱ    
}ALARM_HIGH_MEMORY;

// ץ¼
typedef struct __DH_BLACKLIST_SNAP_INFO
{
    DWORD     dwSize;
    char      szPlateNumber[32];                          // ƺ
    NET_TIME  stuTime;                                    // ¼ʱ
}DH_BLACKLIST_SNAP_INFO;

// Ӳ쳣¼
typedef struct __ALARM_DISK_FLUX
{
    DWORD                dwSize;    
    DWORD                dwAction;                         // 0-ʼ, 1-ֹͣ
    DWORD                dwDataFlux;                       // ǰ, KB            
    NET_TIME             stuTime;                          // ¼ʱ
} ALARM_DISK_FLUX;

// 쳣¼
typedef struct __ALARM_NET_FLUX
{
    DWORD                dwSize;    
    DWORD                dwAction;                           // 0-ʼ, 1-ֹͣ
    DWORD                dwDataFlux;                         // ǰ, KB
    NET_TIME             stuTime;                            // ¼ʱ
} ALARM_NET_FLUX;

// ת쳣¼
typedef struct __ALARM_FAN_SPEED
{
    DWORD                dwSize;    
    DWORD                dwAction;                            // 0-ʼ, 1-ֹͣ
    DWORD                dwIndex;                             // 
    char                 szName[DH_MACHINE_NAME_NUM];         // 
    NET_TIME             stuTime;                             // ¼ʱ
    DWORD                dwCurrent;                           // ǰת
} ALARM_FAN_SPEED;

// Ӳ̱
typedef struct __ALARM_DISK_INFO 
{
    DWORD                dwSize;
    DWORD                nChannel;                            // Ӳͨ
    DWORD                nHDDNumber;                          // , 0: 1: չ1,  2: չ2 
    DWORD                nHDDState;                           // Ӳ״̬, 0: Unknown, 1: Running, 2: Offline, 3: Warning, 4: Failed
} ALARM_DISK_INFO;

// ļϵͳ澯
typedef struct __ALARM_FILE_SYSTEM_INFO 
{
    DWORD                dwSize;
    char                 szMountDir[MAX_PATH];                // ļϵͳ
    DWORD                nState;                              // ļϵͳ״̬, 0: Unkown, 1: Normal, 2: Error
} ALARM_FILE_SYSTEM_INFO;

// ԶⲿϢ
typedef struct __ALARM_REMOTE_ALARM_INFO
{
    DWORD      dwSize;
    int        nChannelID;                               // ͨţ1ʼ
    int        nState;                                   // ״̬0-λ1-λ
}ALARM_REMOTE_ALARM_INFO;

// ܱ¼
typedef struct __ALARM_IVS_INFO
{
    DWORD      dwSize;
    NET_TIME   stuTime;                                  // ¼ʱ    
    int        nChannelID;                               // ͨţ0ʼ
    char       szType[MAX_PATH];                         // 
    int        nState;                                   // ״̬0-λ1-λ, 2-ʽ
}ALARM_IVS_INFO;

// ػر
typedef struct __ALARM_GOODS_WEIGHT_INFO
{
    DWORD        dwSize;
    int          nAction;                               // 0-ʼ, 1-ֹͣ
    int          nAlarmType;                            // 0-, 1-СС, 2-ر仯ֵ
    DWORD        dwGoodsWeight;                         // ǰ(kg)
    DWORD        dwSelfWeight;                          // (kg)
    DWORD        dwTotalWeight;                         // (kg)
    DWORD        dwStandardWeight;                      // ˶(kg)
    DWORD        dwWeightScale;                         // ر
    DWORD        dwMaxGoodsWeight;                      // (kg)
    DWORD        dwMinGoodsWeight;                      // С(kg)
    DWORD        dwAlarmWeight;                         // ֵ(kg)
    int          nWeightChange;                         // ɼʱڻر仯(kg)
    int          nCheckTime;                            // ֹɼʱ(s)
} ALARM_GOODS_WEIGHT_INFO;

// ػϢϴ
typedef struct __ALARM_GOODS_WEIGHT_UPLOAD_INFO 
{
    DWORD        dwSize;
    DWORD        dwGoodsWeight;                         // ǰ(kg)
    DWORD        dwSelfWeight;                          // (kg)
    DWORD        dwTotalWeight;                         // (kg)
    DWORD        dwStandardWeight;                      // ˶(kg)
    DWORD        dwWeightScale;                         // ر
    char         szCardNO[DH_MAX_CARDINFO_LEN];         // 
} ALARM_GOODS_WEIGHT_UPLOAD_INFO;

// GPS״̬Ϣ
typedef struct _NET_GPS_STATUS_INFO
{
    NET_TIME            revTime;                        // λʱ
    char                DvrSerial[50];                  // 豸к
    double              longitude;                      // (λǰ֮ȣΧ0-360)
    double              latidude;                       // γ(λǰ֮ȣΧ0-180)
    double              height;                         // ߶()
    double              angle;                          // (Ϊԭ㣬˳ʱΪ)
    double              speed;                          // ٶ(λǺspeed/1000*1.852/Сʱ)
    WORD                starCount;                      // λ
    BOOL                antennaState;                   // ״̬(true ãfalse )
    BOOL                orientationState;               // λ״̬(true λfalse λ)
    BOOL                workStae;                       // ״̬(0=δλ1=ǲֶλ2=ֶλ3=ЧPPS6=ڹ 

    int                 nAlarmCount;                    // ıλø
    int                 nAlarmState[128];               // ıλãֵܶ
    BYTE                bOffline;                       // 0-ʵʱ 1- 
    BYTE                byRserved[127];                 // ֽ
} NET_GPS_STATUS_INFO,*LPNET_GPS_STATUS_INFO;

// Ӳ̿¼¼
typedef struct __ALARM_DISKBURNED_FULL_INFO
{
    DWORD       dwSize;
    int         nIndex;                             //̺
}ALARM_DISKBURNED_FULL_INFO;

// 洢¼
typedef struct tagALARM_STORAGE_LOW_SPACE_INFO 
{
    DWORD               dwSize;
    int                 nAction;                            // 0:ʼ 1:ֹͣ
    char                szName[DH_EVENT_NAME_LEN];          // ¼
    char                szDevice[DH_STORAGE_NAME_LEN];      // 洢豸
    char                szGroup[DH_STORAGE_NAME_LEN];       // 洢
    INT64               nTotalSpace;                        // , byte
    INT64               nFreeSpace;                         // ʣ, byte
    int                 nPercent;                           // Ѿʹõİٷֱ
} ALARM_STORAGE_LOW_SPACE_INFO;

// 洢
typedef enum __EM_STORAGE_ERROR
{
    STORAGE_ERROR_NONE,                             // 
    STORAGE_ERROR_PATITION,                         //           
    STORAGE_ERROR_INIT_FS,                          // ʼļϵͳ    
    STORAGE_ERROR_READ_DATA,                        // ʧ
    STORAGE_ERROR_WRITE_DATA,                       // дʧ
    STORAGE_ERROR_RAID_FAILED,                      // RAID
    STORAGE_ERROR_RAID_DEGRADED,                    // RAID
    STORAGE_ERROR_ISCSI_FAILED,                     // iSCSI
} EM_STORAGE_ERROR;

// 洢󱨾
typedef struct __ALARM_STORAGE_FAILURE_EX
{
    DWORD               dwSize;
    int                 nAction;                            // 0:ʼ 1:ֹͣ
    char                szName[DH_EVENT_NAME_LEN];          // ¼
    char                szDevice[DH_STORAGE_NAME_LEN];      // 洢豸
    char                szGroup[DH_STORAGE_NAME_LEN];       // 洢
    char                szPath[MAX_PATH];                   // ·
    EM_STORAGE_ERROR    emError;                            // 
} ALARM_STORAGE_FAILURE_EX;

// ¼쳣
typedef struct __ALARM_RECORD_FAILED_INFO 
{
    DWORD                dwSize;
    int                  nAction;                           // 0:ʼ 1:ֹͣ
    int                  nIndex;                            // ͨ
} ALARM_RECORD_FAILED_INFO;

// 洢¼
typedef struct __ALARM_STORAGE_BREAK_DOWN_INFO 
{
    DWORD                dwSize;
    int                  nAction;                           // 0:ʼ 1:ֹͣ
} ALARM_STORAGE_BREAK_DOWN_INFO;

typedef enum tagEM_NET_UPS_STATUS
{
    EM_NET_UPS_SYS_SIGN=0,              //ϵͳ¶ֵλ. 1:ʾ¶ȸ; 0:ʾ¶
    EM_NET_UPS_SYS_SHUTDOWN,            //ϵͳػ.         1:ʾػ״̬
    EM_NET_UPS_SYS_TEST,                //ϵͳ.       1:ʾ
    EM_NET_UPS_SYS_TYPE,                //UPS .         1:ʾ󱸻 ; 0:ʾ߻
    EM_NET_UPS_SYS_FAULT,               //UPS .         1:ʾUPSڲ ; 0:
    EM_NET_UPS_ELE_SUPPLY,              //·/״̬.    1:AC ; 0:ع
    EM_NET_UPS_VOL_LOW,                 //صѹ.       1:ʾصѹ ; 0:ʾ
    EM_NET_UPS_BYPASS_STATUS,           //е.         1:ʾе ; 0:ʾе
    EM_NET_UPS_MAX = 64,                //
}EM_NET_UPS_STATUS;

typedef struct tagNET_UPS_INFO
{
    DWORD dwSize;
    float fInputVoltage;                        //ѹ    ο ܽͨרõԴͨЭ(V1.2)רö
    float fInputAbnormalVoltage;                //쳣ѹ    
    float fOutputVoltage;                       //ѹ
    float fOutputCurrent;                       //ٷֱ,λ(%)
    float fInputFrequency;                      //Ƶ
    float fVoltage;                             //ѹ
    float fTemp;                                //¶
    BYTE  bStatusInfo[EM_NET_UPS_MAX];          //UPS״̬,μNET_UPS_STATUSö
    char  szVersionInfo[DH_MAX_VERSION_STR];    //汾
}NET_UPS_INFO;

typedef struct tagALARM_COMM_PORT_EVENT_INFO
{
    DWORD           dwSize;
    UINT            nEventAction;       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    NET_UPS_INFO    stUPSInfo;          // UPSϢ
}ALARM_COMM_PORT_EVENT_INFO;

// ƵͨʧЧ¼õƵͨ豸DH_ALARM_VIDEO_ININVALID
typedef struct __ALARM_VIDEO_ININVALID_INFO 
{
    DWORD               dwSize;                         // ṹС
    int                 nChannelID;                     // ͨţ0ʼ
} ALARM_VIDEO_ININVALID_INFO;


// 洢鲻¼Ϣ
typedef struct tagALARM_STORAGE_NOT_EXIST_INFO 
{
    DWORD           dwSize;
    char            szName[DH_EVENT_NAME_LEN];          // ¼
    char            szDevice[DH_STORAGE_NAME_LEN];      // 洢豸
    char            szGroup[DH_STORAGE_NAME_LEN];       // 洢
    NET_TIME        stuTime;                            // ¼ʱ
}ALARM_STORAGE_NOT_EXIST_INFO;

//¼
typedef enum __EM_NETABORT_EVENT_TYPE
{
    EM_NETABORT_EVENT_TYPE_WIRE = 0,                    // ¼
    EM_NETABORT_EVENT_TYPE_WIRELESS,                    // ¼
    EM_NETABORT_EVENT_TYPE_3G,                          // 3G¼
}EM_NETABORT_EVENT_TYPE;

// ¼
typedef struct tagALARM_NETABORT_INFO
{
    DWORD                   dwSize;
    int                     nAction;                    // 0:ʼ 1:ֹͣ
    EM_NETABORT_EVENT_TYPE  emNetAbortType;             // ¼
    NET_TIME                stuTime;                    // ¼ʱ
}ALARM_NETABORT_INFO;

// IPͻ¼
typedef struct tagALARM_IP_CONFLICT_INFO
{
    DWORD            dwSize;
    int              nAction;                        // 0:ʼ 1:ֹͣ
    NET_TIME         stuTime;                        // ¼ʱ
}ALARM_IP_CONFLICT_INFO;


// MACͻ¼
typedef struct tagALARM_MAC_CONFLICT_INFO
{
    DWORD           dwSize;
    int             nAction;                        // 0:ʼ 1:ֹͣ
    NET_TIME        stuTime;                        // ¼ʱ
}ALARM_MAC_CONFLICT_INFO;


// Դ
typedef enum __EM_POWER_TYPE
{
    EM_POWER_TYPE_MAIN = 0,                          // Դ
    EM_POWER_TYPE_BACKUP,                            // õԴ
}EM_POWER_TYPE;

// Դ¼
typedef enum __EM_POWERFAULT_EVENT_TYPE
{
    EM_POWERFAULT_EVENT_LOST = 0                    // Դ
}EM_POWERFAULT_EVENT_TYPE;

// Դ¼
typedef struct tagALARM_POWERFAULT_INFO
{
    DWORD                    dwSize;            
    EM_POWER_TYPE            emPowerType;            // Դ
    EM_POWERFAULT_EVENT_TYPE emPowerFaultEvent;      // Դ¼
    NET_TIME                 stuTime;                // ¼ʱ
    int                      nAction;                // 0:ʼ 1:ֹͣ
}ALARM_POWERFAULT_INFO;

// 𱨾¼
typedef struct tagALARM_CHASSISINTRUDED_INFO
{
    DWORD               dwSize;
    int                 nAction;                // 0:ʼ 1:ֹͣ
    NET_TIME            stuTime;                // ¼ʱ
    int                 nChannelID;             // ͨ
	char				szReaderID[DH_COMMON_STRING_32];// ID
}ALARM_CHASSISINTRUDED_INFO;

// չģ鱨¼
typedef struct tagALARM_ALARMEXTENDED_INFO
{
    DWORD               dwSize;
    int                 nChannelID;             // ͨ
    int                 nAction;                // 0:ʼ 1:ֹͣ
    NET_TIME            stuTime;                // ¼ʱ
}ALARM_ALARMEXTENDED_INFO;


// Խ
typedef enum __EM_TALKING_CALLER
{
    EM_TALKING_CALLER_UNKNOWN = 0,                 // δ֪
    EM_TALKING_CALLER_PLATFORM,                    // ԽΪƽ̨
}EM_TALKING_CALLER;

// ¼DH_ALARM_TALKING_INVITE(豸ԷԽ¼)ӦϢ
typedef struct tagALARM_TALKING_INVITE_INFO
{
    DWORD                dwSize;
    EM_TALKING_CALLER    emCaller;                // 豸ϣĶԽ
    NET_TIME             stuTime;                 // ¼ʱ
}ALARM_TALKING_INVITE_INFO;

// ¼DH_ALARM_TALKING_HANGUPӦϢ
typedef struct tagALARM_TALKING_HANGUP_INFO 
{
    DWORD               dwSize;
    NET_TIME            stuTime;                // ¼ʱ
}ALARM_TALKING_HANGUP_INFO;

// ͤ¼״̬
typedef enum tagEM_GUARD_EVENT_STATE
{
	EM_GUARD_EVENT_STATE_UNKNOWN = 0,	// δ֪״̬
	EM_GUARD_EVNET_STATE_ONGUARD,		// 
	EM_GUARD_EVENT_STATE_OFFGUARD		// 
}EM_GUARD_EVENT_STATE;

// ͤϢ¼,DH_ALARM_GUARD_INFO_UNPDATEõϢ
typedef struct tagALARM_GUARD_UPDATE_INFO
{
	DWORD				 dwSize;
	EM_GUARD_EVENT_STATE emEventState;							// ͤ¼״̬
	int					 nIDCount;								// ¼ԱID
	int					 nIDArray[DH_MAX_GUARD_DETECT_ID_COUNT];// ԱID
	NET_TIME			 stuTime;								// ¼ʱ
}ALARM_GUARD_UPDATE_INFO;

// ͤ¼,DH_ALARM_GUARD_DETECTӦϢ
typedef struct tagALARM_GUARD_DETECT_INFO
{
	DWORD				dwSize;
	int					nAction;								// 0:ʼ 1:ֹͣ
	int					nIndex;									// ͤ±	
	int					nIDCount;								// ¼ԱID
	int					nIDArray[DH_MAX_GUARD_DETECT_ID_COUNT];	// ԱID
	NET_TIME			stuTime;								// ¼ʱ
}ALARM_GUARD_DETECT_INFO;

//п忨¼DH_ALARM_BANKCARDINSERTӦϢ
typedef struct tagALARM_BANKCARDINSERT_INFO 
{
    DWORD               dwSize;
    int                 nAction;                // -1:δ֪ 0:ʼ 1:ֹͣ
}ALARM_BANKCARDINSERT_INFO;

#define MAX_CARD_RECORD_FIELD_NUM 16            // ¼

// ¼¼,stopʱı
typedef enum tagNET_RECORD_SAVEFLAG
{
    NET_RECORD_SAVEFLAG_UNKNOWN = 0,            //δ֪
	NET_RECORD_SAVEFLAG_MARK,                   //¼񡢲
	NET_RECORD_SAVEFLAG_SAVE,                   //¼
}NET_RECORD_SAVEFLAG;

//¼¼ DH_ALARM_CARD_RECORD ӦϢ
typedef struct tagALARM_CARD_RECORD_INFO 
{
    DWORD               dwSize;
    int                 nAction;                // -1:δ֪ 0:ʼ 1:ֹͣ
    int                 nChannelID;             // ͨţ0ʼ
    unsigned int        nFieldCount;            // 
    char                szFields[MAX_CARD_RECORD_FIELD_NUM][DH_COMMON_STRING_256]; // Ϣ
    NET_RECORD_SAVEFLAG emRecordSaveFlag;       // ¼¼stopʱı,ö NET_RECORD_SAVEFLAG
}ALARM_CARD_RECORD_INFO;

// CLIENT_ControlDeviceӿڵ DH_CTRL_NOTIFY_EVNENT (豸¼)
typedef struct tagNET_NOTIFY_EVENT_DATA
{
    DWORD                       dwSize;
    LONG                        lCommand;       // ¼
    void*                       pEventData;     // ¼,lCommandӦĽṹָ
}NET_NOTIFY_EVENT_DATA;

// Ӧʽö
typedef enum tagNET_SENSE_METHOD
{
    NET_SENSE_UNKNOWN = -1,      //δ֪
    NET_SENSE_DOOR=0,            //Ŵ
    NET_SENSE_PASSIVEINFRA,      //
    NET_SENSE_GAS,               //
    NET_SENSE_SMOKING,           //̸
    NET_SENSE_WATER,             //ˮ
    NET_SENSE_ACTIVEFRA,         //
    NET_SENSE_GLASS,             //
    NET_SENSE_EMERGENCYSWITCH,   //
    NET_SENSE_SHOCK,             //
    NET_SENSE_DOUBLEMETHOD,      //˫(+΢)
    NET_SENSE_THREEMETHOD,       //
    NET_SENSE_TEMP,              //¶
    NET_SENSE_HUMIDITY,          //ʪ
    NET_SENSE_WIND,              //
    NET_SENSE_CALLBUTTON,        //аť
    NET_SENSE_GASPRESSURE,       //ѹ
    NET_SENSE_GASCONCENTRATION,  //ȼŨ
    NET_SENSE_GASFLOW,           //
    NET_SENSE_OTHER,             //
    NET_SENSE_OIL,               // ⣬͡͵ȳͼ
    NET_SENSE_MILEAGE,           // 	
    NET_SENSE_URGENCYBUTTON,     //ť
    NET_SENSE_STEAL,             //
    NET_SENSE_PERIMETER,         //ܽ
    NET_SENSE_PREVENTREMOVE,     //
    NET_SENSE_DOORBELL,          //
    NET_SENSE_NUM,               //ö
}NET_SENSE_METHOD;

// ر¼(DH_ALARM_ALARM_EX)
typedef struct tagALARM_ALARM_INFO_EX2
{
    DWORD               dwSize;
    int                 nChannelID;             // ͨ
    int                 nAction;                // 0:ʼ 1:ֹͣ
    NET_TIME            stuTime;                // ¼ʱ
    NET_SENSE_METHOD    emSenseType;            // 
}ALARM_ALARM_INFO_EX2;

// ģʽ
typedef enum tagNET_ALARM_MODE
{    
    NET_ALARM_MODE_UNKNOWN = -1,        // δ֪
    NET_ALARM_MODE_DISARMING,           // 
    NET_ALARM_MODE_ARMING,              // 
    NET_ALARM_MODE_FORCEON,             // ǿƲ
}NET_ALARM_MODE;

// ģʽ
typedef enum tagNET_SCENE_MODE
{
    NET_SCENE_MODE_UNKNOWN,             // δ֪
    NET_SCENE_MODE_OUTDOOR,             // ģʽ
    NET_SCENE_MODE_INDOOR,              // ģʽ
}NET_SCENE_MODE;

// ״̬仯¼Ϣ
typedef struct tagALARM_ARMMODE_CHANGE_INFO
{
    DWORD               dwSize;
    NET_TIME            stuTime;        // ¼ʱ
    NET_ALARM_MODE      bArm;           // 仯״̬
    NET_SCENE_MODE      emSceneMode;    // 龰ģʽ
}ALARM_ARMMODE_CHANGE_INFO;

// 
typedef enum
{
    NET_DEFENCEAREA_TYPE_UNKNOWN,       // δ֪ͷ
    NET_DEFENCEAREA_TYPE_ALARM,         // 
}NET_DEFENCEAREA_TYPE;

// ·״̬
typedef enum
{
    NET_BYPASS_MODE_UNKNOW,             //δ֪״̬
    NET_BYPASS_MODE_BYPASS,             //·
    NET_BYPASS_MODE_NORMAL,             //
    NET_BYPASS_MODE_ISOLATED,           //
}NET_BYPASS_MODE;

// ·״̬仯¼Ϣ
typedef struct tagALARM_BYPASSMODE_CHANGE_INFO
{
    DWORD                   dwSize;
    int                     nChannelID;                 // ͨ
    NET_TIME                stuTime;                    // ¼ʱ
    NET_DEFENCEAREA_TYPE    emDefenceType;              // 
    int                     nIsExtend;                  // ǷΪչ(ͨ), 1:չͨ, 0: չͨ
    NET_BYPASS_MODE         emMode;                     // 仯ģʽ 
}ALARM_BYPASSMODE_CHANGE_INFO;


// ¼(ӦDH_URGENCY_ALARM_EX2, ԭеDH_URGENCY_ALARM_EX͵, ָΪĽ¼, һ㴦ⲿͨѶ)
typedef struct tagALARM_URGENCY_ALARM_EX2 
{
    DWORD           dwSize;
    NET_TIME        stuTime;                     //¼ʱ
    DWORD           nID;                         // ڱʶͬĽ¼
}ALARM_URGENCY_ALARM_EX2;

// Դ¼(ֻҪͻ¼۷ǰģʽ޷)
typedef struct tagALARM_INPUT_SOURCE_SIGNAL_INFO
{
    DWORD           dwSize;
    int             nChannelID;                         // ͨ
    int             nAction;                            // 0:ʼ 1:ֹͣ
    NET_TIME        stuTime;                            // ¼ʱ
}ALARM_INPUT_SOURCE_SIGNAL_INFO;

// ģͨ¼Ϣ(ӦDH_ALARM_ANALOGALARM_EVENT)
typedef struct tagALARM_ANALOGALARM_EVENT_INFO 
{
    DWORD           dwSize;
    int             nChannelID;                         // ͨ
    int             nAction;                            // 0:ʼ 1:ֹͣ
    NET_TIME        stuTime;                            // ¼ʱ
    NET_SENSE_METHOD  emSensorType;                     // 
    char            szName[DH_COMMON_STRING_128];       // ͨ
    int             nIsValid;                           // ǷЧ,-1:δ֪,0:Ч,1:Ч
    int             nStatus;                            // ״̬, -1:δ֪,0:,1:Ч(),
                                                        // 2:ֵ1,3:ֵ2,4:ֵ3,5:ֵ4,
                                                        // 6:ֵ1,7:ֵ2,8:ֵ3,9:ֵ4
    float           fValue;                             // ֵ̽
    NET_TIME        stuCollectTime;                     // ݲɼʱ(UTC)
    NET_GPS_STATUS_INFO stGPSStatus;                    // GPSϢ 
}ALARM_ANALOGALARM_EVENT_INFO;


// Ž״̬
typedef enum tagNET_ACCESS_CTL_STATUS_TYPE
{
    NET_ACCESS_CTL_STATUS_TYPE_UNKNOWN = 0,
    NET_ACCESS_CTL_STATUS_TYPE_OPEN,                    // 
    NET_ACCESS_CTL_STATUS_TYPE_CLOSE,                   // 
}NET_ACCESS_CTL_STATUS_TYPE;

// Ž״̬¼
typedef struct tagALARM_ACCESS_CTL_STATUS_INFO 
{
    DWORD                       dwSize;
    int                         nDoor;                  // ͨ
    NET_TIME                    stuTime;                // ¼ʱ
    NET_ACCESS_CTL_STATUS_TYPE  emStatus;               // Ž״̬
}ALARM_ACCESS_CTL_STATUS_INFO;

// Žץͼ
typedef enum tagNET_ACCESS_SNAP_TYPE
{
    NET_ACCESS_SNAP_TYPE_UNKNOWN = 0,
    NET_ACCESS_SNAP_TYPE_CARD,                          // ˢ
    NET_ACCESS_SNAP_TYPE_PASSWORD,                      // 
}NET_ACCESS_SNAP_TYPE;

// Žץͼ¼
typedef struct tagALARM_ACCESS_SNAP_INFO
{
    DWORD           dwSize;
    NET_ACCESS_SNAP_TYPE emType;                        // 
    char            szCardNO[DH_COMMON_STRING_32];      // , ˢʱЧ
    char            szPassword[DH_COMMON_STRING_64];    // , 뿪ʱЧ    
    char            szFtpUrl[MAX_PATH];                 // ftpϴַ, ͼƬ·
    int             nImageNum;                          // ץͼ
    NET_TIME        stuTime;                            // ¼ʱ
}ALARM_ACCESS_SNAP_INFO;

// ¼
typedef struct tagALARM_ALARMCLEAR_INFO 
{
    DWORD           dwSize;
    int             nChannelID;                         // ͨ
    NET_TIME        stuTime;                            // ¼ʱ
}ALARM_ALARMCLEAR_INFO;

// CID¼
typedef struct tagALARM_CIDEVENT_INFO
{
    DWORD           dwSize;
    NET_TIME        stuTime;                            // ¼ʱ
    char            szCID[DH_COMMON_STRING_32];         // CID룬׼Э ַΪ16ֵַΪ0~F
                                                        // 4λû + 2λʶ + 1λ¼޶ + 3λ¼ + 2λϵͳ + 3λ + 1λУ
}ALARM_CIDEVENT_INFO;

// ¼
typedef enum tagEM_RCEMERGENCY_CALL_TYPE
{
    EM_RCEMERGENCY_CALL_UNKNOWN = 0,
    EM_RCEMERGENCY_CALL_FIRE,                           // 
    EM_RCEMERGENCY_CALL_DURESS,                         // в
    EM_RCEMERGENCY_CALL_ROBBER,                         // ˾
    EM_RCEMERGENCY_CALL_MEDICAL,                        // ҽ
    EM_RCEMERGENCY_CALL_EMERGENCY,                      // 
}EM_RCEMERGENCY_CALL_TYPE;

// ʽ
typedef enum tagEM_RCEMERGENCY_MODE_TYPE
{
    EM_RCEMERGENCY_MODE_UNKNOWN = 0,
    EM_RCEMERGENCY_MODE_KEYBOARD,                       // 
    EM_RCEMERGENCY_MODE_WIRELESS_CONTROL,               // ң
}EM_RCEMERGENCY_MODE_TYPE;

// ¼
typedef struct tagALARM_RCEMERGENCY_CALL_INFO 
{
    DWORD                       dwSize;
    int                         nAction;                // -1:δ֪ 0:ʼ 1:ֹͣ
    EM_RCEMERGENCY_CALL_TYPE    emType;                 // 
    NET_TIME                    stuTime;                // ¼ʱ
    EM_RCEMERGENCY_MODE_TYPE    emMode;                 // ʽ
    DWORD                       dwID;                   // ڱʾͬĽ¼(ֻemModeңʱЧ, ʾңı, 0ʾЧID)
}ALARM_RCEMERGENCY_CALL_INFO;

// Ͽ¼(ӦDH_ALARM_OPENDOORGROUP)
typedef struct tagALARM_OPEN_DOOR_GROUP_INFO
{
    DWORD           dwSize;
    int             nChannelID;                         // ͨ(0ʼ)
    NET_TIME        stuTime;                            // ¼ʱ
}ALARM_OPEN_DOOR_GROUP_INFO;

// ȡָ¼(ӦDH_ALARM_FINGER_PRINT)
typedef struct tagALARM_CAPTURE_FINGER_PRINT_INFO 
{
    DWORD           dwSize;
    int             nChannelID;                         // ͨ(0ʼ)
    NET_TIME        stuTime;                            // ¼ʱ
    char            szReaderID[DH_COMMON_STRING_32];    // ŶID
    int             nPacketLen;                         // ָݰ
    int             nPacketNum;                         // ָݰ
    char*           szFingerPrintInfo;                  // ָ(ܳȼnPacketLen*nPacketNum)
}ALARM_CAPTURE_FINGER_PRINT_INFO;

// ϵͳ״̬
typedef enum __EM_SUBSYSTEM_STATE_TYPE
{
    EM_SUBSYSTEM_STATE_UNKNOWN = 0,                     // δ֪
    EM_SUBSYSTEM_STATE_ACTIVE,                          // Ѽ
    EM_SUBSYSTEM_STATE_INACTIVE,                        // δ
}EM_SUBSYSTEM_STATE_TYPE;

// ϵͳ״̬ı¼
typedef struct tagALARM_SUBSYSTEM_STATE_CHANGE_INFO 
{
    DWORD                   dwSize;
    int                     nChannelID;                 // ϵͳ(0ʼ)
    NET_TIME                stuTime;                    // ¼ʱ
    EM_SUBSYSTEM_STATE_TYPE emState;                    // 仯״̬
}ALARM_SUBSYSTEM_STATE_CHANGE_INFO;

// صʱ֪ͨ¼
typedef struct tagALARM_BATTERYPOWER_INFO
{
    DWORD       dwSize;
    int         nChannel;                                  // 
    NET_TIME    stuTime;                                   // ¼ʱ
    int         nPercent;                                  // صٷֱ
}ALARM_BATTERYPOWER_INFO;

// ״̬¼
typedef struct tagALARM_BELLSTATUS_INFO 
{
    DWORD       dwSize;
    int         nChannel;                                   // ͨ 
    NET_TIME    stuTime;                                    // ¼ʱ
    int         nAction;                                    // 0:ʼ 1:ֹͣ
}ALARM_BELLSTATUS_INFO;

// ״̬仯¼, Ӧ¼DH_ALARM_DEFENCE_STATE_CHANGE_EVENT
typedef struct tagALARM_DEFENCE_STATUS_CHANGE_INFO 
{
    DWORD                   dwSize;
    int                     nChannelID;                     // IDͨ(0ʼ)
    NET_TIME                stuTime;                        // ¼ʱ
    EM_DEFENCE_STATE_TYPE   emStatus;                       // 仯״̬
}ALARM_DEFENCE_STATUS_CHANGE_INFO;

// ½ʧ¼
typedef struct tagALARM_LOGIN_FAILIUR_INFO
{
    DWORD                   dwSize;
    int                     nAction;                        // 0:ʼ 1:ֹͣ
    unsigned int            nSequence;                      // 
    char                    szName[DH_EVENT_NAME_LEN];      // ¼û
    char                    szType[DH_COMMON_STRING_128];   // ¼
    char                    szAddr[DH_MAX_IPADDR_EX_LEN];   // ԴIPַ
    int                     nError;                         // û½ʧܴ
}ALARM_LOGIN_FAILIUR_INFO;

// ƱͳϢ¼ Ӧ¼ DH_ALARM_TICKET_STATISTIC
typedef struct tagALARM_TICKET_STATISTIC
{
    DWORD                   dwSize;
    NET_GPS_STATUS_INFO     stuGPSStatusInfo;               // GPSϢ
    NET_TIME                stuTime;                        // ¼ϱʱ
    int                     nNormalCount;                   // ͨƱ
    int                     nDiscountCount;                 // ŻƱ
    int                     nSubsidyCount;                  // ײƱ
    int                     nDriverCount;                   // ˾Ʊ
    int                     nNormalPrice;                   // ͨƱ۸
    int                     nDiscountPrice;                 // ŻƱ۸
    int                     nSubsidyPrice;                  // ײƱ۸
}ALARM_TICKET_STATISTIC;

#define MAX_ALARMEXT_MODULE_NUM        256                  // չģĿ

// 
typedef enum tagNET_BUS_TYPE
{
    NET_BUS_TYPE_UNKNOWN = 0,
    NET_BUS_TYPE_MBUS,                                      // M-BUS
}NET_BUS_TYPE;

// չģ¼ Ӧ¼ DH_ALARM_MODULE_LOST
typedef struct tagALARM_MODULE_LOST_INFO 
{
    DWORD                   dwSize;
    NET_TIME                stuTime;                        // ¼ϱʱ
    int                     nSequence;                      // չģӵߵ(0ʼ)
    NET_BUS_TYPE            emBusType;                      // 
    int                     nAddr;                          // ߵչģĿ
    int                     anAddr[MAX_ALARMEXT_MODULE_NUM];// ߵչģ(0ʼ)
}ALARM_MODULE_LOST_INFO;

// PSTN¼
typedef struct tagALARM_PSTN_BREAK_LINE_INFO
{
    DWORD                   dwSize;
    int                     nChannelID;                 // 绰(0ʼ)
    int                     nAction;                    // 0:ʼ 1:ֹͣ
    NET_TIME                stuTime;                    // ¼ʱ
}ALARM_PSTN_BREAK_LINE_INFO;

// ģ¼(˲ʱ¼), ضʱ(糬١̡)Ŵ
typedef struct tagALARM_ANALOGPULSE_INFO 
{
    DWORD                   dwSize;
    int                     nChannelID;                     // ģͨ
    NET_TIME                stuEventTime;                   // ¼ʱ
    NET_SENSE_METHOD        emSense;                        // 
    char                    szName[DH_COMMON_STRING_128];   // 
    int                     nStatus;                        // ״̬, -1:δ֪,0:,1:Ч(),
                                                            // 2:ֵ1,3:ֵ2,4:ֵ3,5:ֵ4,
                                                            // 6:ֵ1,7:ֵ2,8:ֵ3,9:ֵ4
    float                   fValue;                         // ֵ
    NET_TIME                stuCollectTime;                 // ɼʱ
    NET_GPS_STATUS_INFO     stuGPSStatusInfo;               // GPSϢ
}ALARM_ANALOGPULSE_INFO;

//Ϣȷ϶
typedef enum tagNET_MISSION_CONFIRM_TYPE
{
    NET_MISSION_CONFIRM_UNKNOWN = 0  ,  //δ֪
    NET_MISSION_CONFIRM_YES ,           //ͬⲢִ
	NET_MISSION_CONFIRM_NO ,            //ִܾ
}NET_MISSION_CONFIRM_TYPE;

// ȷ¼(ӦDH_ALARM_MISSION_CONFIRM)
typedef struct tagALARM_MISSION_CONFIRM_INFO 
{
    DWORD                   dwSize;
    char                    szTitle[DH_COMMON_STRING_256];   // 
    char                    szMissionID[DH_COMMON_STRING_256];// ID
    char                    szComment[DH_COMMON_STRING_256]; // ظ
    NET_GPS_STATUS_INFO     stuGPSStatusInfo;                // GPSϢ
    NET_MISSION_CONFIRM_TYPE emConfirmType;                  //Ϣȷ϶
}ALARM_MISSION_CONFIRM_INFO;

// Ⱥڵ
typedef enum tagNET_CLUSTER_GROUP_TYPE
{
    NET_CLUSTER_GROUP_UNKNOWN,                          // δ֪
    NET_CLUSTER_GROUP_IDLE,                             // 
    NET_CLUSTER_GROUP_MASTER,                           // 
    NET_CLUSTER_GROUP_SLAVE,                            // 
}NET_CLUSTER_GROUP_TYPE;

// ڵ㼤¼, Ӧ¼ DH_ALARM_NODE_ACTIVE
typedef struct tagALARM_NODE_ACTIVE_INFO 
{
    DWORD                   dwSize;
    int                     nChannelID;                 // ȺеĽڵ
    NET_TIME                stuTime;                    // ¼¼
    NET_CLUSTER_GROUP_TYPE  emGroup;                    // ǰڵ
}ALARM_NODE_ACTIVE_INFO;

// Ⱥڵ״̬
typedef struct tagNET_CLUSTER_STATE_INFO 
{
    DWORD                   dwSize;
    NET_CLUSTER_GROUP_TYPE  emGroup;                    // ǰڵ
}NET_CLUSTER_STATE_INFO;

// 豸ģʽ
typedef enum tagEM_ALARM_VIDEO_STATIC_MODE
{
    EM_ALARM_VIDEO_STATIC_MODE_UNKNOWN,                 // δ֪
    EM_ALARM_VIDEO_STATIC_MODE_INDOOR,                  // ģʽ "Indoor"
    EM_ALARM_VIDEO_STATIC_MODE_OUTDOOR,                 // ģʽ "Outdoor"
}EM_ALARM_VIDEO_STATIC_MODE;

// Ƶ̬¼, Ӧ¼ DH_ALARM_VIDEO_STATIC
typedef struct tagALARM_VIDEO_STATIC_INFO 
{
    DWORD                       dwSize;
    DWORD                       dwAction;                       // ¼, 0:Start, 1:Stop
    EM_ALARM_VIDEO_STATIC_MODE  emMode;                         // 豸ģʽ
    int                         nChannelID;                     // Ƶ̬ⱨͨ
}ALARM_VIDEO_STATIC_INFO;

// ע豸µ½¼, Ӧ¼ DH_ALARM_REGISTER_REONLINE
typedef struct tagALARM_REGISTER_REONLINE_INFO
{
    DWORD           dwSize;
}ALARM_REGISTER_REONLINE_INFO;

// ״̬
typedef enum tagEM_ALARM_ISCSI_STATUS
{
    EM_ALARM_ISCSI_STATUS_UNKNOWN,                  // δ֪
    EM_ALARM_ISCSI_STATUS_CONNECTED,                // 
    EM_ALARM_ISCSI_STATUS_NOT_CONNECTED,            // δ
    EM_ALARM_ISCSI_STATUS_CONNECT_FAILED,           // ʧ
    EM_ALARM_ISCSI_STATUS_AUTHENTICATION_FAILED,    // ֤ʧ
    EM_ALARM_ISCSI_STATUS_CONNECT_TIMEOUT,          // ӳʱ
    EM_ALARM_ISCSI_STATUS_NOT_EXIST,                // 豸
}EM_ALARM_ISCSI_STATUS;

// ISCSI澯¼, Ӧ¼ DH_ALARM_ISCSI_STATUS
typedef struct tagALARM_ISCSI_STATUS_INFO
{
    DWORD                   dwSize;
    int                     nIndex;                             // ʾISCSI豸
    char                    szAddress[DH_COMMON_STRING_32];     // ַ
    char                    szName[DH_COMMON_STRING_64];        // Target
    char                    szUserName[DH_COMMON_STRING_64];    // û
    EM_ALARM_ISCSI_STATUS   emStatus;                           // ״̬
}ALARM_ISCSI_STATUS_INFO;

// ɼ豸¼, Ӧ¼ DH_ALARM_SCADA_DEV_ALARM
typedef struct tagALARM_SCADA_DEV_INFO 
{
    DWORD                   dwSize;
    int                     nChannel;                           // ͨ
    NET_TIME                stuTime;                            // ¼ʱ
    char                    szDevName[DH_COMMON_STRING_64];     // 豸
    char                    szDesc[DH_COMMON_STRING_256];       // 
}ALARM_SCADA_DEV_INFO;

// ACC¼, Ӧ¼ DH_ALARM_VEHICLE_ACC
typedef struct tagALARM_VEHICLE_ACC_INFO 
{
    DWORD                   dwSize;
    int                     nACCStatus;                         // ACC״̬, 0:Ч, 1:, 2:ر 
    int                     nAction;                            // ¼, 0:Start, 1:Stop
    NET_GPS_STATUS_INFO     stuGPSStatusInfo;                   // GPSϢ
    int                     nConstantElectricStatus;            // ״̬, 0:δ֪, 1:, 2:Ͽ                            
}ALARM_VEHICLE_ACC_INFO;

//////////////////////////////////////////////////////////////////////////

// ¼(insert)
typedef struct tagNET_CTRL_RECORDSET_IN
{
    DWORD           dwSize;
    EM_NET_RECORD_TYPE emType;                          // ¼Ϣ
    void*           pBuf;                               // ¼Ϣ棬EM_NET_RECORD_TYPEע
    int             nBufLen;                            // ¼ϢС
}NET_CTRL_RECORDSET_INSERT_IN;

// ¼(insert)
typedef struct tagNET_CTRL_RECORDSET_OUT 
{
    DWORD           dwSize;
    int             nRecNo;                             // ¼(insertʱ豸)
}NET_CTRL_RECORDSET_INSERT_OUT;

// ¼(insert)
typedef struct tagNET_CTRL_RECORDSET_INSERT_PARAM 
{
    DWORD                           dwSize;
    NET_CTRL_RECORDSET_INSERT_IN    stuCtrlRecordSetInfo;       // ¼Ϣ(ûд)
    NET_CTRL_RECORDSET_INSERT_OUT   stuCtrlRecordSetResult;     // ¼Ϣ(豸)
}NET_CTRL_RECORDSET_INSERT_PARAM;

// ¼
typedef struct tagNET_CTRL_RECORDSET_PARAM 
{
    DWORD               dwSize;
    EM_NET_RECORD_TYPE  emType;                         // ¼Ϣ
    void*               pBuf;                           // \\ѯʱ,Ϊ¼Ϣ棬EM_NET_RECORD_TYPEע
                                                        // ɾʱ,Ϊ¼(int)
    int                    nBufLen;                     // ¼ϢС
}NET_CTRL_RECORDSET_PARAM;

// ״̬
typedef enum tagNET_ACCESSCTLCARD_STATE
{
    NET_ACCESSCTLCARD_STATE_UNKNOWN = -1,
    NET_ACCESSCTLCARD_STATE_NORMAL = 0,                 // 
    NET_ACCESSCTLCARD_STATE_LOSE   = 0x01,              // ʧ
    NET_ACCESSCTLCARD_STATE_LOGOFF = 0x02,              // ע
    NET_ACCESSCTLCARD_STATE_FREEZE = 0x04,              // 
}NET_ACCESSCTLCARD_STATE;

// 
typedef enum tagNET_ACCESSCTLCARD_TYPE
{
    NET_ACCESSCTLCARD_TYPE_UNKNOWN = -1,
    NET_ACCESSCTLCARD_TYPE_GENERAL,                     // һ㿨
    NET_ACCESSCTLCARD_TYPE_VIP,                         // VIP
    NET_ACCESSCTLCARD_TYPE_GUEST,                       // 
    NET_ACCESSCTLCARD_TYPE_PATROL,                      // Ѳ߿
    NET_ACCESSCTLCARD_TYPE_BLACKLIST,                   // 
    NET_ACCESSCTLCARD_TYPE_CORCE,                       // вȿ
    NET_ACCESSCTLCARD_TYPE_MOTHERCARD = 0xff,           // ĸ
}NET_ACCESSCTLCARD_TYPE;

#define DH_MAX_DOOR_NUM               32                // ȨŽĿ
#define DH_MAX_TIMESECTION_NUM        32                // ЧʱĿ
#define DH_MAX_CARDNAME_LEN           64                // Ž󳤶
#define DH_MAX_CARDNO_LEN             32                // Ž󳤶
#define DH_MAX_USERID_LEN             32                // ŽûID󳤶

// ָ
typedef struct tagNET_ACCESSCTLCARD_FINGERPRINT_PACKET
{
    DWORD   dwSize;	
	int		nLength;		// ݰȣλֽ
	int		nCount;			// 
	char*	pPacketData;	// ָݰݣܳȼΪnLength*nCount
}NET_ACCESSCTLCARD_FINGERPRINT_PACKET;

// Ž¼Ϣ
typedef struct tagNET_RECORDSET_ACCESS_CTL_CARD
{
    DWORD           dwSize;
    int             nRecNo;                                 // ¼ţֻ
    NET_TIME        stuCreateTime;                          // ʱ
    char            szCardNo[DH_MAX_CARDNO_LEN];            // 
    char            szUserID[DH_MAX_USERID_LEN];            // ûID, 豸ݲ֧
    NET_ACCESSCTLCARD_STATE       emStatus;                 // ״̬
    NET_ACCESSCTLCARD_TYPE        emType;                   // 
    char            szPsw[DH_MAX_CARDPWD_LEN];              // 
    int             nDoorNum;                               // ЧĿ;
    int             sznDoors[DH_MAX_DOOR_NUM];              // Ȩ޵ţCFG_CMD_ACCESS_EVENTõ±
    int             nTimeSectionNum;                        // ЧĵĿʱĿ
    int             sznTimeSectionNo[DH_MAX_TIMESECTION_NUM];  // ʱCFG_ACCESS_TIMESCHEDULE_INFO±
    int             nUserTime;                              // ʹôʱЧ
    NET_TIME        stuValidStartTime;                      // ʼЧ, 豸ݲ֧ʱ
    NET_TIME        stuValidEndTime;                        // Ч, 豸ݲ֧ʱ
    BOOL            bIsValid;                               // ǷЧ,TRUEЧ;FALSEЧ
	NET_ACCESSCTLCARD_FINGERPRINT_PACKET stuFingerPrintInfo;// ָϢ 
    BOOL            bFirstEnter;                            // Ƿӵ׿Ȩ
    char            szCardName[DH_MAX_CARDNAME_LEN];        // 
    char            szVTOPosition[DH_COMMON_STRING_64];     // ſڻλ
}NET_RECORDSET_ACCESS_CTL_CARD;

// Ž¼Ϣ
typedef struct tagNET_RECORDSET_ACCESS_CTL_PWD 
{
    DWORD           dwSize;
    int             nRecNo;                                 // ¼ţֻ
    NET_TIME        stuCreateTime;                          // ʱ
    char            szUserID[DH_MAX_USERID_LEN];            // ûID, 豸ݲ֧
    char            szDoorOpenPwd[DH_MAX_CARDPWD_LEN];      // 
    char            szAlarmPwd[DH_MAX_CARDPWD_LEN];         // 
    int             nDoorNum;                               // ЧĵĿ
    int             sznDoors[DH_MAX_DOOR_NUM];              // Ȩ޵ţCFG_CMD_ACCESS_EVENTCFG_ACCESS_EVENT_INFO±
    char            szVTOPosition[DH_COMMON_STRING_64];     // ſڻλ
}NET_RECORDSET_ACCESS_CTL_PWD;


// ŷʽ(Ž,ŵһֹģʽ)
typedef enum tagNET_DOOR_OPEN_METHOD
{
    NET_DOOR_OPEN_METHOD_UNKNOWN = 0,
    NET_DOOR_OPEN_METHOD_PWD_ONLY,                          // ֻ뿪
    NET_DOOR_OPEN_METHOD_CARD,                              // ֻˢ
    NET_DOOR_OPEN_METHOD_PWD_OR_CARD,                       // ˢ
    NET_DOOR_OPEN_METHOD_CARD_FIRST,                        // ˢ뿪
    NET_DOOR_OPEN_METHOD_PWD_FIRST,                         // ˢ
    NET_DOOR_OPEN_METHOD_SECTION,                           // ʱο
}NET_DOOR_OPEN_METHOD;

// ŷʽ(Ž¼,Ž¼,ʵʵĿŷʽ)
typedef enum tagNET_ACCESS_DOOROPEN_METHOD
{
    NET_ACCESS_DOOROPEN_METHOD_UNKNOWN = 0,
    NET_ACCESS_DOOROPEN_METHOD_PWD_ONLY,                    // 뿪
    NET_ACCESS_DOOROPEN_METHOD_CARD,                        // ˢ
    NET_ACCESS_DOOROPEN_METHOD_CARD_FIRST,                  // ˢ뿪
    NET_ACCESS_DOOROPEN_METHOD_PWD_FIRST,                   // ˢ
    NET_ACCESS_DOOROPEN_METHOD_REMOTE,                      // Զ̿ͨڻƽ̨ſڻ
    NET_ACCESS_DOOROPEN_METHOD_BUTTON,                      // ťп
    NET_ACCESS_DOOROPEN_METHOD_FINGERPRINT,                 // ָƿ
    NET_ACCESS_DOOROPEN_METHOD_PWD_CARD_FINGERPRINT,        // +ˢ+ָϿ
    NET_ACCESS_DOOROPEN_METHOD_PWD_FINGERPRINT = 10,        // +ָϿ
    NET_ACCESS_DOOROPEN_METHOD_CARD_FINGERPRINT = 11,       // ˢ+ָϿ
    NET_ACCESS_DOOROPEN_METHOD_PERSONS = 12,                // ˿
}NET_ACCESS_DOOROPEN_METHOD;

// Žˢ¼¼Ϣ
typedef struct tagNET_RECORDSET_ACCESS_CTL_CARDREC
{
    DWORD           dwSize;
    int             nRecNo;                                 // ¼ţֻ
    char            szCardNo[DH_MAX_CARDNO_LEN];            // 
    char            szPwd[DH_MAX_CARDPWD_LEN];              // 
    NET_TIME        stuTime;                                // ˢʱ
    BOOL            bStatus;                                // ˢTRUEʾɹFALSEʾʧ
    NET_ACCESS_DOOROPEN_METHOD    emMethod;                 // ŷʽ
    int             nDoor;                                  // źţCFG_CMD_ACCESS_EVENTCFG_ACCESS_EVENT_INFO±
    char            szUserID[DH_MAX_USERID_LEN];            // ûID
    int             nReaderID;                              // ID
}NET_RECORDSET_ACCESS_CTL_CARDREC;

// ռ¼Ϣ
typedef struct tagNET_RECORDSET_HOLIDAY
{
    DWORD           dwSize;
    int             nRecNo;                                 // ¼ţֻ
    int             nDoorNum;                               // ЧĵĿ    
    int             sznDoors[DH_MAX_DOOR_NUM];              // Ȩ޵ţCFG_CMD_ACCESS_EVENTCFG_ACCESS_EVENT_INFO±
    NET_TIME        stuStartTime;                           // ʼʱ
    NET_TIME        stuEndTime;                             // ʱ
    BOOL            bEnable;                                // ʹ
    char            szHolidayNo[DH_COMMON_STRING_32];       // ڱ
}NET_RECORDSET_HOLIDAY;

// 
typedef enum tagEM_VIDEO_TALK_LOG_CALLTYPE
{
    EM_VIDEO_TALK_LOG_CALLTYPE_UNKNOWN = 0,         // δ֪
    EM_VIDEO_TALK_LOG_CALLTYPE_INCOMING,            // 
    EM_VIDEO_TALK_LOG_CALLTYPE_OUTGOING,            // 
    EM_VIDEO_TALK_LOG_CALLTYPE_MAX,                 //
}EM_VIDEO_TALK_LOG_CALLTYPE;

// ״̬
typedef enum tagEM_VIDEO_TALK_LOG_ENDSTATE
{
    EM_VIDEO_TALK_LOG_ENDSTATE_UNKNOWN = 0,         // δ֪
    EM_VIDEO_TALK_LOG_ENDSTATE_MISSED,              // δ
    EM_VIDEO_TALK_LOG_ENDSTATE_RECEIVED,            // ѽ
    EM_VIDEO_TALK_LOG_ENDSTATE_MAX,                 //
}EM_VIDEO_TALK_LOG_ENDSTATE;

// Է
typedef enum tagEM_VIDEO_TALK_LOG_PEERTYPE
{
    EM_VIDEO_TALK_LOG_PEERTYPE_UNKNOWN = 0,         // δ֪
    EM_VIDEO_TALK_LOG_PEERTYPE_VTO,                 // ſڻ
    EM_VIDEO_TALK_LOG_PEERTYPE_VTH,                 // ڻ
    EM_VIDEO_TALK_LOG_PEERTYPE_VTS,                 // 
}EM_VIDEO_TALK_LOG_PEERTYPE;

// ͨ¼¼Ϣ
typedef struct tagNET_RECORD_VIDEO_TALK_LOG
{
    DWORD                           dwSize;
    int                             nRecNo;                             // ¼ţֻ
    NET_TIME                        stuCreateTime;                      // ʼʱ
    EM_VIDEO_TALK_LOG_CALLTYPE      emCallType;                         // 
    EM_VIDEO_TALK_LOG_ENDSTATE      emEndState;                         // ״̬
    char                            szPeerNumber[DH_COMMON_STRING_64];  // Է	Ƕ̺ţкŻ򳤺
    EM_VIDEO_TALK_LOG_PEERTYPE      emPeerType;                         // Է
    char                            szLocalNumber[DH_COMMON_STRING_64]; // 	Ƕ̺ţкŻ򳤺
    int                             nTalkTime;                          // ͨʱ	λ
    int                             nMessageTime;                       // ʱ	λ
    char                            szPicturePath[DH_COMMON_STRING_128];// 
}NET_RECORD_VIDEO_TALK_LOG;


// Խ״̬
typedef enum tagEM_REGISTER_USER_STATE
{
    EM_REGISTER_USER_STATE_UNKNOWN = 0,         // δ֪
    EM_REGISTER_USER_STATE_IDLE,                // ʼ״̬
    EM_REGISTER_USER_STATE_CALLING,             // ״̬ԷδӦ
    EM_REGISTER_USER_STATE_RINGING,             // ״̬ԷӦûн
    EM_REGISTER_USER_STATE_PREVIEWING,          // Ԥ
    EM_REGISTER_USER_STATE_LEAVINGMESSAGE,      // 
    EM_REGISTER_USER_STATE_TALKING,             // ͨ
    EM_REGISTER_USER_STATE_MAX,                 //
}EM_REGISTER_USER_STATE;

// ״̬¼¼Ϣ
typedef struct tagNET_RECORD_REGISTER_USER_STATE
{
    DWORD                           dwSize;
    int                             nRecNo;                             // ¼ţֻ
    NET_TIME                        stuCreateTime;                      // ʱ
    char                            szUserID[DH_MAX_USERID_LEN];      // ûID
    BOOL                            bOnline;                            // Ƿ
    char                            szAddress[DH_MAX_IPADDR_OR_DOMAIN_LEN];     // ַ
    int                             nPort;                              // ˿ں
    EM_REGISTER_USER_STATE          emVideoTalkState;                   // Խ״̬
    NET_TIME                        stuOnlineTime;                      // ʱ
    NET_TIME                        stuOfflineTime;                     // ʱ
}NET_RECORD_REGISTER_USER_STATE;

// ӶԽģڻʱģʽ
typedef enum tagEM_VIDEO_TALK_CONTACT_VTSLAVEBINDMODE
{
    EM_VIDEO_TALK_CONTACT_VTSLAVEBINDMODE_UNKNOWN,              // δ֪
    EM_VIDEO_TALK_CONTACT_VTSLAVEBINDMODE_SLAVEADDRESS,         // ͨSlaveAddress
    EM_VIDEO_TALK_CONTACT_VTSLAVEBINDMODE_SLAVEID_SLAVEPORT,    // ͨSlaveID+SlavePort
}EM_VIDEO_TALK_CONTACT_VTSLAVEBINDMODE;

// û
typedef enum tagEM_VIDEO_TALK_CONTACT_TYPE
{
    EM_VIDEO_TALK_CONTACT_TYPE_UNKNOWN,             // δ֪
    EM_VIDEO_TALK_CONTACT_TYPE_VTH,                 // "VTH" ڻ
    EM_VIDEO_TALK_CONTACT_TYPE_VTO,                 // "VTO" ſڻ
}EM_VIDEO_TALK_CONTACT_TYPE;

// ע᷽ʽ
typedef enum tagEM_VIDEO_TALK_CONTACT_REGISTER_TYPE
{
    EM_VIDEO_TALK_CONTACT_REGISTER_TYPE_UNKNOWN,                // δ֪
    EM_VIDEO_TALK_CONTACT_REGISTER_TYPE_PUBLIC,                 // "public"
    EM_VIDEO_TALK_CONTACT_REGISTER_TYPE_LOCAL,                  // "local"
}EM_VIDEO_TALK_CONTACT_REGISTER_TYPE;

// ϵ˼¼¼Ϣ
typedef struct tagNET_RECORD_VIDEO_TALK_CONTACT
{
    DWORD                                   dwSize;
    int                                     nRecNo;                                 // ¼ţֻ
    NET_TIME                                stuCreateTime;                          // ʱ
    char                                    szFirstName[DH_COMMON_STRING_32];       // 
    char                                    szFamilyName[DH_COMMON_STRING_32];      // 
    char                                    szVTShortNumber[DH_COMMON_STRING_16];   // ӶԽ̺
    char                                    szVTMiddleNumber[DH_COMMON_STRING_32];  // ӶԽк
    char                                    szVTLongNumber[DH_COMMON_STRING_64];    // ӶԽţVTHģڻк
    char                                    szVTNetAddress[DH_MAX_IPADDR_LEN_EX];   // ӶԽַ
    char                                    szVTOPosition[DH_COMMON_STRING_64];     // ڻſڻλ
    EM_VIDEO_TALK_CONTACT_VTSLAVEBINDMODE   emVTSlaveBindMode;                      // ӶԽģڻʱģʽ
    char                                    szVTSlaveId[DH_COMMON_STRING_32];       // ӶԽģڻʱķַ
    char                                    szVTSlavePort[DH_COMMON_STRING_32];     // ӶԽģڻʱķ˿
    char                                    szVTSlaveAddress[DH_COMMON_STRING_64];  // ӶԽģڻĵַ
    char                                    szNickname[DH_COMMON_STRING_64];        // ǳ
    char                                    szNotes[DH_COMMON_STRING_64];           // ע
    EM_VIDEO_TALK_CONTACT_TYPE              emType;                                 // û
    EM_VIDEO_TALK_CONTACT_REGISTER_TYPE     emRegisterType;                         // ע᷽ʽ
    char                                    szVTHPassword[DH_COMMON_STRING_64];     // ע
    char                                    szVTOBuilding[DH_COMMON_STRING_64];     // 
    char                                    szVTOUnit[DH_COMMON_STRING_64];         // Ԫ
    char                                    szGroupNumber[DH_COMMON_STRING_64];     // Ⱥ
}NET_RECORD_VIDEO_TALK_CONTACT;

// Žδ¼ϸϢ
typedef struct tagALARM_ACCESS_CTL_NOT_CLOSE_INFO 
{
    DWORD           dwSize;
    int             nDoor;                                  // ͨ
    char            szDoorName[DH_MAX_DOORNAME_LEN];        // Ž
    NET_TIME        stuTime;                                // ¼ʱ
    int             nAction;                                // 0:ʼ 1:ֹͣ
}ALARM_ACCESS_CTL_NOT_CLOSE_INFO;

// ¼ϸϢ
typedef struct tagALARM_ACCESS_CTL_BREAK_IN_INFO 
{
    DWORD           dwSize;
    int             nDoor;                                  // ͨ
    char            szDoorName[DH_MAX_DOORNAME_LEN];        // Ž
    NET_TIME        stuTime;                                // ¼ʱ
}ALARM_ACCESS_CTL_BREAK_IN_INFO;


// ¼ϸϢ
typedef struct tagALARM_ACCESS_CTL_REPEAT_ENTER_INFO 
{
    DWORD           dwSize;
    int             nDoor;                                  // ͨ
    char            szDoorName[DH_MAX_DOORNAME_LEN];        // Ž
    NET_TIME        stuTime;                                // ¼ʱ
}ALARM_ACCESS_CTL_REPEAT_ENTER_INFO;


// вȿˢ¼ϸϢ
typedef struct tagALARM_ACCESS_CTL_DURESS_INFO 
{
    DWORD           dwSize;
    int             nDoor;                                  // ͨ
    char            szDoorName[DH_MAX_DOORNAME_LEN];        // Ž
    char            szCardNo[DH_MAX_CARDNO_LEN];            // вȿ
    NET_TIME        stuTime;                                // ¼ʱ
}ALARM_ACCESS_CTL_DURESS_INFO;


// Ž¼
typedef enum tagNET_ACCESS_CTL_EVENT_TYPE
{
    NET_ACCESS_CTL_EVENT_UNKNOWN = 0,
    NET_ACCESS_CTL_EVENT_ENTRY,                             // 
    NET_ACCESS_CTL_EVENT_EXIT,                              // 
}NET_ACCESS_CTL_EVENT_TYPE;


// Ž¼
typedef struct tagALARM_ACCESS_CTL_EVENT_INFO 
{
    DWORD                       dwSize;
    int                         nDoor;                              // ͨ
    char                        szDoorName[DH_MAX_DOORNAME_LEN];    // Ž
    NET_TIME                    stuTime;                            // ¼ʱ
    NET_ACCESS_CTL_EVENT_TYPE   emEventType;                        // Ž¼
    BOOL                        bStatus;                            // ˢTRUEʾɹFALSEʾʧ
    NET_ACCESSCTLCARD_TYPE      emCardType;                         // 
    NET_ACCESS_DOOROPEN_METHOD  emOpenMethod;                       // ŷʽ
    char                        szCardNo[DH_MAX_CARDNO_LEN];        // 
    char                        szPwd[DH_MAX_CARDPWD_LEN];          // 
    char                        szReaderID[DH_COMMON_STRING_32];    // ŶID
    char                        szUserID[DH_COMMON_STRING_64];      // û
    char                        szSnapURL[DH_COMMON_STRING_256];    // ץƬ洢ַ
    int                         nErrorCode;                         // ʧܵԭ,bStatusΪFALSEʱЧ
                                                                    // 0x00 ûд
                                                                    // 0x10 δȨ
                                                                    // 0x11 ʧע
                                                                    // 0x12 ûиȨ
                                                                    // 0x13 ģʽ
                                                                    // 0x14 Чڴ
                                                                    // 0x15 Ǳģʽ
                                                                    // 0x16 вȱδ
                                                                    // 0x17 ų״̬
                                                                    // 0x18 AB״̬
                                                                    // 0x19 Ѳ߿
                                                                    // 0x1A 豸ڴ뱨״̬
                                                                    // 0x20 ʱδ
                                                                    // 0x21 ڿʱδ
                                                                    // 0x30 Ҫ֤׿Ȩ޵ĿƬ
                                                                    // 0x40 Ƭȷ,
                                                                    // 0x41 Ƭȷ,볬ʱ
                                                                    // 0x42 Ƭȷ,ָƴ
                                                                    // 0x43 Ƭȷ,ָƳʱ
                                                                    // 0x44 ָȷ
                                                                    // 0x45 ָȷ볬ʱ
                                                                    // 0x50 Ͽ˳
                                                                    // 0x51 ϿҪ֤
                                                                    // 0x60 ̨֤ͨδȨ
}ALARM_ACCESS_CTL_EVENT_INFO;

///////////////////////// ܽͨ¼[CLIENT_StartListenEx] /////////////////////////////////////

//¼ DH_IVS_TRAFFIC_REALFLOWINFO(ͨʵʱϢ¼)ӦݿϢ
typedef struct tagALARM_IVS_TRAFFIC_REALFLOW_INFO
{
    int                 nChannelID;                     // ͨ
    char                szName[128];                    // ¼
    char                bReserved1[4];                  // ֽڶ
    double              PTS;                            // ʱ(λǺ)
    NET_TIME_EX         UTC;                            // ¼ʱ
    int                 nEventID;                       // ¼ID
    unsigned int        nSequence;                      // 
    BYTE                bEventAction;                   // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[3];
    int                 nLane;                          // Ӧ
    int                 nCount;                         // 
    int                 nSpeed;                         // ٣km/h
    int                 nOverPercent;                   // ƽٰٷֱ
    int                 nMetersUints;                   // ٶȵλ01Ӣ
    BYTE                bReserved[1024];                // ֽ,չ.
}ALARM_IVS_TRAFFIC_REALFLOW_INFO;

// ¼ DH_ALARM_VEHICLE_TURNOVER(෭¼)ӦϢ
typedef struct tagALARM_VEHICEL_TURNOVER_EVENT_INFO
{
    NET_GPS_STATUS_INFO stGPSStatusInfo;                // GPSϢ
    BYTE                bEventAction;                   // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bReserved[1023];                // ֽ,չ.
}ALARM_VEHICEL_TURNOVER_EVENT_INFO;

// ¼DH_ALARM_VEHICLE_COLLISION(ײ¼)ӦϢ
typedef struct tagALARM_VEHICEL_COLLISION_EVENT_INFO
{
    NET_GPS_STATUS_INFO stGPSStatusInfo;                // GPSϢ
    BYTE                bEventAction;                   // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bReserved[1023];                // ֽ,չ.
}ALARM_VEHICEL_COLLISION_EVENT_INFO;

// ¼DH_ALARM_VEHICLE_CONFIRM(ϴϢ¼)ӦϢ
typedef struct tagALARM_VEHICEL_CONFIRM_INFO
{
    DWORD               dwStructSize;                   // ṹС
    NET_GPS_STATUS_INFO stGPSStatusInfo;                // GPSϢ
    BYTE                bEventAction;                   // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byRserved[3];                   // 
    char                szInfo[128];                    // ϴϢ
}ALARM_VEHICEL_CONFIRM_INFO;

//¼DH_EVENT_REGISTER_OFF(豸¼)ӦϢ
typedef struct tagEVENT_REGISTER_OFF_INFO
{
    DWORD               dwStructSize;                   // ṹС
    NET_GPS_STATUS_INFO stGPSStatusInfo;                // GPSϢ
    BYTE                bEventAction;                   // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byRserved[3];                   // 
}EVENT_REGISTER_OFF_INFO;

// ¼DH_ALARM_VIDEO_TIMING(Ƶʱ¼)ӦϢ
typedef struct tagALARM_VIDEO_TIMING
{
    DWORD               dwStructSize;                   // ṹС
    DWORD               dwAction;                       // ¼, 0:Pause, 1:Start, 2:Stop
    DWORD               dwChannelID;                    // Ƶͨ
}ALARM_VIDEO_TIMING;

// ¼DH_ALARM_VEHICLE_LARGE_ANGLE(ͷǶŤת¼)ӦϢ
typedef struct tagALARM_VEHICEL_LARGE_ANGLE
{
    DWORD               dwStructSize;                   // ṹС
    NET_GPS_STATUS_INFO stGPSStatusInfo;                // GPSϢ
    BYTE                bEventAction;                   // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byRserved[3];                   // 
    unsigned int        nSequence;                      // 
}ALARM_VEHICEL_LARGE_ANGLE;

// ¼DH_ALARM_AUDIO_ANOMALY(Ƶ쳣¼)ӦϢ
typedef struct tagALARM_AUDIO_ANOMALY
{
    DWORD               dwStructSize;                   // ṹС
    DWORD               dwAction;                       // ¼, 0:Start, 1:Stop
    DWORD               dwChannelID;                    // Ƶͨ
}ALARM_AUDIO_ANOMALY;

// ¼DH_ALARM_AUDIO_MUTATION(ǿͻ¼)ӦϢ
typedef struct tagALARM_AUDIO_MUTATION
{
    DWORD               dwStructSize;                   // ṹС
    DWORD               dwAction;                       // ¼, 0:Start, 1:Stop
    DWORD               dwChannelID;                    // Ƶͨ
}ALARM_AUDIO_MUTATION;

#define MAX_SENSORID_NUMBER 20                          // 
#define MAX_TYRE_NUM        128                         // ̥
// ̥澯־λӦö
typedef enum tagAlarmTyreFlag
{
    ALARM_TYRE_FLAG_NONE,                               // Ч
    ALARM_TYRE_FLAG_NORMAL,                             // 
    ALARM_TYRE_FLAG_HIGHPRESSURE,                       // ѹ
    ALARM_TYRE_FLAG_LOWERPRESSURE,                      // ѹ
    ALARM_TYRE_FLAG_HIGHTEMP,                           // 
    ALARM_TYRE_FLAG_HIGHTEMP_HIGHPRESSURE,              // ¡ѹ
    ALARM_TYRE_FLAG_HIGHTEMP_LOWERPRESSURE,             // ¡ѹ

    ALARM_TYRE_FLAG_INVALID,                            // Ƿı־λ
}EM_ALARM_TYER_FALG;

// ̥Ϣṹ
typedef struct tagTYRE_INFO_UNIT
{
    DWORD               dwStructSize;                    // ṹС
    DWORD               dwSensorIDNum;                   // 
    DWORD               dwSensorID[MAX_SENSORID_NUMBER]; // IDϢ
    DWORD               dwTyreNum;                       // ̥λ
    DWORD               dwTyrePlace;                     // ̥λڵڼ

    EM_ALARM_TYER_FALG  emAlarmFlag;                     // ̥澯־λ

    int                 nTemp;                           // ¶,λ
    int                 nTempLimit;                      // ¶,λ

    float               fPressure;                       // ѹ,λKpa
    float               fUpperLimit;                     // 澯ѹֵ,λKpa
    float               fLowerLimit;                     // 澯ѹֵ,λKpa
    float               fVoltage;                        // ǰĴѹ,λ V
}TYRE_INFO_UNIT;

// ¼DH_EVENT_TYREINFO(̥Ϣϱ¼)ӦϢ
typedef struct tagEVENT_TYRE_INFO
{
    DWORD               dwStructSize;                   // ṹС
    DWORD               dwAction;                       // ¼, 0:Pause, 1:Stop
    DWORD               dwTyreNum;                      // ̥
    TYRE_INFO_UNIT      *pstuTyre;                      // ̥Ϣ
}EVENT_TYRE_INFO;

/////////////////////////////Խض/////////////////////////////

// ƵʽϢ
typedef struct
{
    BYTE                byFormatTag;                    // ͣ0PCM
    WORD                nChannels;                      // 
    WORD                wBitsPerSample;                 //             
    DWORD               nSamplesPerSec;                 // 
} DH_AUDIO_FORMAT, *LPDH_AUDIO_FORMAT;

/////////////////////////////ûض/////////////////////////////

// ֧û󳤶Ϊ8λ豸ӦCLIENT_QueryUserInfoCLIENT_OperateUserInfoӿ
// ȨϢ
typedef struct _OPR_RIGHT
{
    DWORD               dwID;
    char                name[DH_RIGHT_NAME_LENGTH];
    char                memo[DH_MEMO_LENGTH];
} OPR_RIGHT;

// ûϢ
typedef struct _USER_INFO
{
    DWORD               dwID;
    DWORD               dwGroupID;
    char                name[DH_USER_NAME_LENGTH];
    char                passWord[DH_USER_PSW_LENGTH];
    DWORD               dwRightNum;
    DWORD               rights[DH_MAX_RIGHT_NUM];
    char                memo[DH_MEMO_LENGTH];
    DWORD               dwReusable;                     // Ƿã1ã0
} USER_INFO;

// ûϢ
typedef struct _USER_GROUP_INFO
{
    DWORD               dwID;
    char                name[DH_USER_NAME_LENGTH];
    DWORD               dwRightNum;
    DWORD               rights[DH_MAX_RIGHT_NUM];
    char                memo[DH_MEMO_LENGTH];
} USER_GROUP_INFO;

// ûϢ
typedef struct _USER_MANAGE_INFO
{
    DWORD                dwRightNum;                    // ȨϢ
    OPR_RIGHT            rightList[DH_MAX_RIGHT_NUM];
    DWORD                dwGroupNum;                    // ûϢ
    USER_GROUP_INFO      groupList[DH_MAX_GROUP_NUM];
    DWORD                dwUserNum;                     // ûϢ
    USER_INFO            userList[DH_MAX_USER_NUM];
    DWORD                dwSpecial;                     // û1֧ûã0֧û
} USER_MANAGE_INFO;

// ֧û󳤶Ϊ8λ16λ豸ӦչӿCLIENT_QueryUserInfoExCLIENT_OperateUserInfoEx
#define DH_USER_NAME_LENGTH_EX       16                 // û
#define DH_USER_PSW_LENGTH_EX        16                 // 

// ȨϢ
typedef struct _OPR_RIGHT_EX
{
    DWORD                dwID;
    char                 name[DH_RIGHT_NAME_LENGTH];
    char                 memo[DH_MEMO_LENGTH];
} OPR_RIGHT_EX;

// ûϢ
typedef struct _USER_INFO_EX
{
    DWORD                dwID;
    DWORD                dwGroupID;
    char                 name[DH_USER_NAME_LENGTH_EX];
    char                 passWord[DH_USER_PSW_LENGTH_EX];
    DWORD                dwRightNum;
    DWORD                rights[DH_MAX_RIGHT_NUM];
    char                 memo[DH_MEMO_LENGTH];
    DWORD                dwFouctionMask;                // 룬0x00000001 - ֧û
    BYTE                 byReserve[32];
} USER_INFO_EX;

// ûϢ
typedef struct _USER_GROUP_INFO_EX
{
    DWORD                dwID;
    char                 name[DH_USER_NAME_LENGTH_EX];
    DWORD                dwRightNum;
    DWORD                rights[DH_MAX_RIGHT_NUM];
    char                 memo[DH_MEMO_LENGTH];
} USER_GROUP_INFO_EX;

// ûϢ
typedef struct _USER_MANAGE_INFO_EX
{
    DWORD                dwRightNum;                    // ȨϢ
    OPR_RIGHT_EX         rightList[DH_MAX_RIGHT_NUM];
    DWORD                dwGroupNum;                    // ûϢ
    USER_GROUP_INFO_EX   groupList[DH_MAX_GROUP_NUM];
    DWORD                dwUserNum;                     // ûϢ
    USER_INFO_EX         userList[DH_MAX_USER_NUM];
    DWORD                dwFouctionMask;                // 룻0x00000001 - ֧ûã0x00000002 - ޸ҪУ
    BYTE                 byNameMaxLength;               // ֵ֧û󳤶
    BYTE                 byPSWMaxLength;                // ֵ֧󳤶
    BYTE                 byReserve[254];
} USER_MANAGE_INFO_EX;

// ֧64ͨ豸ӦչӿCLIENT_QueryUserInfoNewCLIENT_OperateUserInfoNew
#define DH_NEW_MAX_RIGHT_NUM        1024
#define DH_NEW_USER_NAME_LENGTH     128                 // û
#define DH_NEW_USER_PSW_LENGTH      128                 // 


// ȨϢ
typedef struct _OPR_RIGHT_NEW
{
    DWORD               dwSize;
    DWORD               dwID;
    char                name[DH_RIGHT_NAME_LENGTH];
    char                memo[DH_MEMO_LENGTH];
} OPR_RIGHT_NEW;

// ûϢ
typedef struct _USER_INFO_NEW
{
    DWORD               dwSize;
    DWORD               dwID;
    DWORD               dwGroupID;
    char                name[DH_NEW_USER_NAME_LENGTH];
    char                passWord[DH_NEW_USER_PSW_LENGTH];
    DWORD               dwRightNum;
    DWORD               rights[DH_NEW_MAX_RIGHT_NUM];
    char                memo[DH_MEMO_LENGTH];
    DWORD               dwFouctionMask;                 // 룬0x00000001 - ֧û
    NET_TIME            stuTime;                        // ޸ʱ
    BYTE                byIsAnonymous;                  // Ƿ¼, 0:¼, 1: ¼
    BYTE                byReserve[7];
} USER_INFO_NEW;

// ûϢ
typedef struct _USER_GROUP_INFO_NEW
{
    DWORD               dwSize;
    DWORD               dwID;
    char                name[DH_USER_NAME_LENGTH_EX];
    DWORD               dwRightNum;
    DWORD               rights[DH_NEW_MAX_RIGHT_NUM];
    char                memo[DH_MEMO_LENGTH];
} USER_GROUP_INFO_NEW;

// ûϢչûӳ
typedef struct _USER_GROUP_INFO_EX2
{
    DWORD               dwSize;
    DWORD               dwID;
    char                name[DH_NEW_USER_NAME_LENGTH];
    DWORD               dwRightNum;
    DWORD               rights[DH_NEW_MAX_RIGHT_NUM];
    char                memo[DH_MEMO_LENGTH];
} USER_GROUP_INFO_EX2;

// ûϢ
typedef struct _USER_MANAGE_INFO_NEW
{
    DWORD               dwSize;
    DWORD               dwRightNum;                         // ȨϢ
    OPR_RIGHT_NEW       rightList[DH_NEW_MAX_RIGHT_NUM];
    DWORD               dwGroupNum;                         // û
    USER_GROUP_INFO_NEW groupList[DH_MAX_GROUP_NUM];        // ûϢ˲,ʹgroupListEx
    DWORD               dwUserNum;                          // ûϢ
    USER_INFO_NEW       userList[DH_MAX_USER_NUM];
    DWORD               dwFouctionMask;                     // 룻0x00000001 - ֧ûã0x00000002 - ޸ҪУ
    BYTE                byNameMaxLength;                    // ֵ֧û󳤶
    BYTE                byPSWMaxLength;                     // ֵ֧󳤶
    BYTE                byReserve[254];
    USER_GROUP_INFO_EX2 groupListEx[DH_MAX_GROUP_NUM];      // ûϢչ
} USER_MANAGE_INFO_NEW;

///////////////////////////////ѯض///////////////////////////////

// 豸֧
typedef struct _DH_LANGUAGE_DEVINFO
{
    DWORD               dwLanguageNum;                      // ֧Ը
    BYTE                byLanguageType[252];                // öֵDH_LANGUAGE_TYPE
} DH_DEV_LANGUAGE_INFO, *LPDH_DEV_LANGUAGE_INFO;

// ѯ豸ֵ֧IPCϢ
typedef struct
{
    int                 nTypeCount;                         // ֵ֧IPC
    BYTE                bSupportTypes[128];                 // öֵEM_IPC_TYPE
}DH_DEV_IPC_INFO;

//3GϢ
typedef struct
{
    int                 nStrategy;                          // ²,0-,1-ʱ
    int                 nUplimit;                           // , ԶӦ, , λMB; ʱ䣬λСʱ
    int                 nUsed;                              // ʹλnUplimitͬ
    BYTE                bReserved[64];                      // ֶ
}DH_DEV_3GFLOW_INFO;

// 3GģϢ
typedef struct
{
    BYTE                byEthNum;                           // 3Gģ
    BYTE                byReserved[255];                    // ֽ
}DH_DEV_3GMODULE_INFO;

typedef struct
{
    DWORD               dwId;                               // ddns id
    char                szState[DH_MAX_DDNS_STATE_LEN];     // ddns ״̬
    BYTE                bReserved[512];                     // ֶ
}DH_DEV_DNS_INFO;
typedef struct
{
    DWORD               dwDdnsServerNum;    
    DH_DEV_DNS_INFO     stDdns[DH_MAX_DDNS_NUM];
}DH_DEV_MULTI_DDNS_INFO;

// 豸URLϢ
typedef struct
{
    char               szURLInfo[512];                      //豸URLϢ, ַ
    BYTE               bReserved[512];
}DH_DEV_URL_INFO;
// ӲϢ
typedef struct
{
    DWORD               dwVolume;                           // Ӳ̵, λMB(Bʾֽ)
    DWORD               dwFreeSpace;                        // Ӳ̵ʣռ, λMB(Bʾֽ)
    BYTE                dwStatus;                           // λֵʾӲͣöEM_DISK_TYPEλֵʾӲ̵״̬0-,1-,2-ϵȣDWORDĸBYTE
    BYTE                bDiskNum;                           // Ӳ̺
    BYTE                bSubareaNum;                        // 
    BYTE                bSignal;                            // ʶ0Ϊ 1ΪԶ
} NET_DEV_DISKSTATE,*LPNET_DEV_DISKSTATE;

// 豸ӲϢ
typedef struct _DH_HARDDISK_STATE
{
    DWORD                dwDiskNum;                         // 
    NET_DEV_DISKSTATE    stDisks[DH_MAX_DISKNUM];           // Ӳ̻Ϣ
} DH_HARDDISK_STATE, *LPDH_HARDDISK_STATE;

typedef DH_HARDDISK_STATE    DH_SDCARD_STATE;             // SDݽṹͬӲϢ

// Ϣ
typedef struct  
{
    DH_TALK_CODING_TYPE encodeType;                         // 
    int                 nAudioBit;                          // λ816
    DWORD               dwSampleRate;                       // ʣ800016000
    int                 nPacketPeriod;                      // , λms
    char                reserved[60];
} DHDEV_TALKDECODE_INFO;

// 豸ֵ֧Խ
typedef struct 
{
    int                     nSupportNum;                    // 
    DHDEV_TALKDECODE_INFO   type[64];                       // 
    char                    reserved[64];
} DHDEV_TALKFORMAT_LIST;

// ̨Ϣ
#define  NAME_MAX_LEN 16
typedef struct 
{
    DWORD               dwHighMask;                 // λ
    DWORD               dwLowMask;                  // λ
    char                szName[NAME_MAX_LEN];       // Э
    WORD                wCamAddrMin;                // ַͨСֵ
    WORD                wCamAddrMax;                // ֵַͨ
    WORD                wMonAddrMin;                // ӵַСֵ
    WORD                wMonAddrMax;                // ӵֵַ
    BYTE                bPresetMin;                 // ԤõСֵ
    BYTE                bPresetMax;                 // Ԥõֵ
    BYTE                bTourMin;                   // ԶѲ·Сֵ
    BYTE                bTourMax;                   // ԶѲ·ֵ
    BYTE                bPatternMin;                // 켣·Сֵ
    BYTE                bPatternMax;                // 켣·ֵ
    BYTE                bTileSpeedMin;              // ֱٶȵСֵ
    BYTE                bTileSpeedMax;              // ֱٶȵֵ
    BYTE                bPanSpeedMin;               // ˮƽٶȵСֵ
    BYTE                bPanSpeedMax;               // ˮƽٶȵֵ
    BYTE                bAuxMin;                    // ܵСֵ
    BYTE                bAuxMax;                    // ֵܵ
    int                 nInternal;                  // ʱ
    char                cType;                      // Э
    BYTE                bReserved_1;                // 
    BYTE                bFuncMask;                  // Э鹦,λʾ,ãʾ֧,һλʾ̨ܣλʱ
    BYTE                bReserved_2;
    char                Reserved[4];
} PTZ_OPT_ATTR;

// ¼Ϣ
typedef struct _NET_DEV_BURNING
{
    DWORD               dwDriverType;               // ¼ͣ0DHFS1DISK2CDRW
    DWORD               dwBusType;                  // ͣ0USB113942IDE, 3: SATA, 4: ESATA
    DWORD               dwTotalSpace;               // (KB)
    DWORD               dwRemainSpace;              // ʣ(KB)
    BYTE                dwDriverName[DH_BURNING_DEV_NAMELEN];    // ¼
} NET_DEV_BURNING, *LPNET_DEV_BURNING;

// 豸¼Ϣ
typedef struct _DH_BURNING_DEVINFO
{
    DWORD               dwDevNum;                           // ¼豸
    NET_DEV_BURNING     stDevs[DH_MAX_BURNING_DEV_NUM];     // ¼豸Ϣ
} DH_BURNING_DEVINFO, *LPDH_BURNING_DEVINFO;

// ¼
typedef struct _DH_BURNING_PROGRESS
{

    BYTE                bBurning;                   // ¼״̬0Կ¼1¼Ͳԣһǹ豸
                                                    // 2δҵ¼3ڿ¼4¼ڷǿ״̬ڱݡ¼ط
    BYTE                bRomType;                   // Ƭͣ0˽ļϵͳ1ƶӲ̻Ụ2
    BYTE                bOperateType;               // ͣ0У1ڱУ2ڿ¼У3ڽй̻ط, 4: ̿¼
    BYTE                bType;                      // ݻ¼״̬0-ֹͣ 1-ʼ 2- 3- 4- 5-ڳʼ 6-ͣ 7-ȴ
    NET_TIME            stTimeStart;                // ʼʱ䡡
    DWORD               dwTimeElapse;               // ѿ¼ʱ()
    DWORD               dwTotalSpace;               // 
    DWORD               dwRemainSpace;              // ʣ
    DWORD               dwBurned;                   // ѿ¼
    WORD                dwStatus;                   // 
    WORD                wChannelMask;               // ڿ¼ͨ
} DH_BURNING_PROGRESS, *LPDH_BURNING_PROGRESS;

// ־ϢӦӿCLIENT_QueryLogӿ
typedef struct _DH_LOG_ITEM
{
    DHDEVTIME           time;                       // 
    unsigned short      type;                       // 
    unsigned char       reserved;                   // 
    unsigned char       data;                       // 
    unsigned char       context[8];                 // 
} DH_LOG_ITEM, *LPDH_LOG_ITEM;

// ־ϢӦչӿCLIENT_QueryLogExreserved(int nType=1;reserved=&nType;)
typedef struct _DH_NEWLOG_ITEM
{
    DHDEVTIME           time;                       // 
    WORD                type;                       // 
    WORD                data;                       // 
    char                szOperator[8];              // û
    BYTE                context[16];                //     
} DH_NEWLOG_ITEM, *LPDH_NEWLOG_ITEM;

// ־ϢӦӿCLIENT_QueryDeviceLogӿ
typedef struct _DH_DEVICE_LOG_ITEM
{
    int                 nLogType;                   // ־
    DHDEVTIME           stuOperateTime;             // 
    char                szOperator[16];             // 
    BYTE                bReserved[3];
    BYTE                bUnionType;                 //  unionṹ,0:szLogContext1:stuOldLog
    union
    {
        char            szLogContext[64];           // ־עϢ
        struct 
        {
            DH_LOG_ITEM     stuLog;                 // ɵ־ṹ
            BYTE            bReserved[48];          // 
        }stuOldLog;
    };
    char                reserved[16];
} DH_DEVICE_LOG_ITEM, *LPDH_DEVICE_LOG_ITEM;

// ־ϢṹӦӿCLIENT_QueryDeviceLogӿ
typedef struct _DH_DEVICE_LOG_ITEM_EX
{
    int                 nLogType;                   // ־
    DHDEVTIME           stuOperateTime;             // 
    char                szOperator[16];             // 
    BYTE                bReserved[3];
    BYTE                bUnionType;                 //  unionṹ,0:szLogContext1:stuOldLog
    union
    {
        char            szLogContext[64];           // ־עϢ
        struct 
        {
            DH_LOG_ITEM     stuLog;                 // ɵ־ṹ
            BYTE            bReserved[48];          // 
        }stuOldLog;
    };
    char                szOperation[32];            // Ĳ
    char                szDetailContext[4*1024];    // ϸ־Ϣ
} DH_DEVICE_LOG_ITEM_EX, *LPDH_DEVICE_LOG_ITEM_EX;

// ¼־ϢӦ־ṹcontext
typedef struct _LOG_ITEM_RECORD
{
    DHDEVTIME           time;                       // ʱ
    BYTE                channel;                    // ͨ
    BYTE                type;                       // ¼
    BYTE                reserved[2];
} LOG_ITEM_RECORD, *LPLOG_ITEM_RECORD;

typedef struct _QUERY_DEVICE_LOG_PARAM
{
    DH_LOG_QUERY_TYPE   emLogType;                  // ѯ־
    NET_TIME            stuStartTime;               // ѯ־Ŀʼʱ
    NET_TIME            stuEndTime;                 // ѯ־Ľʱ
    int                 nStartNum;                  // ʱдӵڼ־ʼѯʼһβѯΪ0
    int                 nEndNum;                    // һβѯеڼ־,־ֵΪ1024
    BYTE                nLogStuType;                // ־ݽṹ,0:ʾDH_DEVICE_LOG_ITEM1:ʾDH_DEVICE_LOG_ITEM_EX
    BYTE                reserved[3];                //  
    unsigned int        nChannelID;                 // ͨ,0:֮ǰʾͨţͨŴ1ʼ; 1:һͨ
    BYTE                bReserved[40];
} QUERY_DEVICE_LOG_PARAM;

// 豸Ӳ¼Ϣ
typedef struct __DEV_DISK_RECORD_INFO 
{
    NET_TIME            stuBeginTime;               // ¼ʱ
    NET_TIME            stuEndTime;                 // ¼ʱ
    char                reserved[128];
} DEV_DISK_RECORD_INFO;

// 豸Ӳ¼ʱϢ
typedef struct __DEV_DISK_RECORD_TIME
{
    NET_TIME            stuStartTime1;              // ¼ʱ1ʼʱ
    NET_TIME            stuEndTime1;                // ¼ʱ1ʱ
    BOOL                bTwoPart;                   // Ƿеڶ
    NET_TIME            stuStartTime2;              // ¼ʱ2ʼʱ
    NET_TIME            stuEndTime2;                // ¼ʱ2ʱ
    BYTE                bDiskNum;                   // Ӳ̺
    BYTE                bSubareaNum;                // 
    BYTE                byReserved[62];             // ֽ  

}DEV_DISK_RECORD_TIME;

///////////////////////////////ض///////////////////////////////
//̿
typedef struct _NKB_PARAM
{
    BYTE                bAddressCode;               // ΪDVR豸ַ,0xFFΪ㲥ַ
    BYTE                bKeyStatus;                 // ״̬ 0/1 0ʾ 1ʾſ
    BYTE                bExtern1;                   // չֽ1
    BYTE                bExtern2;                   // չֽ2
    BYTE                bReserved[60];
}NKB_PARAM;

// Ӳ̲
typedef struct _DISKCTRL_PARAM
{
    DWORD               dwSize;                     // ṹС汾
    int                 nIndex;                     // ΪӲϢṹDH_HARDDISK_STATEstDisks±꣬0ʼ
    int                 ctrlType;                   // ͣ
                                                    // 0 - , 1 - Ϊд, 2 - Ϊֻ
                                                    // 3 - Ϊ, 4 - ָ, 5 - Ϊ̣7 - SDSDЧ
    NET_DEV_DISKSTATE   stuDisk;                    // Ϣ, ڴ˳ܸı䵼±겻׼, ±
} DISKCTRL_PARAM;

typedef struct  
{
    BYTE                bSubareaNum;                // Ԥĸ
    BYTE                bIndex;                     // ΪӲϢṹDH_HARDDISK_STATEstDisks±꣬0ʼ
    BYTE                bSubareaSize[32];           // Сٷֱȣ
    BYTE                bReserved[30];              // 
} DISKCTRL_SUBAREA;

// ״̬
typedef struct _ALARMCTRL_PARAM
{
    DWORD               dwSize;
    int                 nAlarmNo;                   // ͨţ0ʼ
    int                 nAction;                    // 10ֹͣ
} ALARMCTRL_PARAM;

// 
typedef struct _MATRIXCTRL_PARAM
{
    DWORD               dwSize;
    int                 nChannelNo;                 // Ƶţ0ʼ
    int                 nMatrixNo;                  // ţ0ʼ
} MATRIXCTRL_PARAM;

// ¼
typedef struct _BURNING_PARM
{
    int                 channelMask;                // ͨ룬λʾҪ¼ͨ
    BYTE                devMask;                    // ¼룬ݲѯĿ¼бλʾ
    BYTE                bySpicalChannel;            // лͨ(ͨ+31,4ͨ豸,ֵӦΪ35)
    BYTE                byReserved[2];              // ֶ
} BURNNG_PARM;

// ¼
typedef struct _BURNING_PARM_ATTACH
{
    BOOL                bAttachBurn;                // ǷΪ¼0:; 1:
    BYTE                bReserved[12];              // ֶ
} BURNING_PARM_ATTACH;

// ֶץĲ
typedef struct  _MANUAL_SNAP_PARAMETER{
    int                 nChannel;                   // ץͼͨ,0ʼ
    BYTE                bySequence[64];             // ץͼкַ
    BYTE                byReserved[60];             // ֶ
}MANUAL_SNAP_PARAMETER;

// 豸˱Ԥָ
typedef struct _DEVICE_LOCALPREVIEW_SLIPT_PARAMETER
{
    int                 nSliptMode;                 // ָģʽ豸˱Ԥֵ֧ķָģʽ
    int                 nSubSliptNum;               // ǰҪԤӷָ,1ʼ
    BYTE                byReserved[64];             // ֶ
}DEVICE_LOCALPREVIEW_SLIPT_PARAMETER;

// 豸˱Ԥֵ֧ķָģʽ
typedef struct _DEVICE_LOCALPREVIEW_SLIPT_CAP
{
    int                 nModeNumber;
    int                 nSliptMode[36];             // ֵ֧ķָģʽ
    BYTE                byReserved[64];             // ֶ
}DEVICE_LOCALPREVIEW_SLIPT_CAP;

// ·Ϣ
typedef struct  _CROSSING_INFO{
    char                szCrossingID[DH_MAX_CROSSING_ID];   // ·к
    DWORD               dwLatitude;                         // γ(λǰ֮ȣΧ0-180)籱γ30.183382ȱʾΪ120183382)
    DWORD               dwLongitude;                        // (λǰ֮ȣΧ0-360) 綫120.178274ȱʾΪ300178274
    WORD                wSpeedLimit;                        // ·ֵ,λKm/h 0ʾ,ʾֵ
    BYTE                byReserved[22];
}CROSSING_INFO;

// ·ߵλϢ
typedef struct  _ROUTE_CROSSING_INFO{
    BYTE                byCrossingNum;                      // ·ЧΧ1~DH_MAX_CROSSING_NUM
    BYTE                byReserved1;
    WORD                wCrossingRange;                     // λȷΧλm
    CROSSING_INFO       stCrossingInfo[DH_MAX_CROSSING_NUM];// ·Ϣ֧128·
    BYTE                byReserved2[2044];
}ROUTE_CROSSING_INFO;

// raid
typedef struct _CTRL_RAID_INFO
{
    char                szAction[16];                       // AddӣDeleteɾ
    char                szName[16];                         // Raid
    int                 nType;                              //  1:Jbod     2:Raid0      3:Raid1     4:Raid5
    int                 nStatus;                            // ״̬ 0:unknown 1:active2:degraded3:inactive4:recovering
    int                 nCntMem;                            // nMemberЧݸ
    int                 nMember[32];                        // 1,2,3,... ɴͨ,Ǹ
    int                 nCapacity;                          // ,λG
    int                 nRemainSpace;                       // ʣλM
    int                 nTank;                              // չ 0:1:չ12:չ2
    char                reserved[128];
}CTRL_RAID_INFO;

// ȱ
typedef struct _CTRL_SPARE_DISK_INFO
{
    char                szAction[16];                       // EnableʹܣDisableʹ
    char                szScope[16];                        // GlobalȫȱLocalȫȱ
    char                szName[16];                         // ȱ֣ScopeΪGlobalΪȱصƣʾRaid
    unsigned int        nIndex;                             // 
    const char*         pszDevName;                         // 洢豸
    char                reserved[124];
}CTRL_SPARE_DISK_INFO;

typedef struct _CTRL_SPARE_DISK_INFO_A
{
    int                     nCnt;                           // ȱ̵ĸ
    CTRL_SPARE_DISK_INFO    stSpaceDiskInfo[32];
}CTRL_SPARE_DISK_INFO_A;

// 
typedef struct __CTRL_ARM_DISARM_PARAM
{
    BYTE                bState;                             // ״̬0ʾ1ʾ2ʾǿƲ
    char                reserve[3];
    const char*         szDevPwd;                           // û
    NET_SCENE_MODE      emSceneMode;                        // 龰ģʽ
    const char*         szDevID;                            // תĿ豸ID,ΪNULLʾת
    char                reserve1[16];
} CTRL_ARM_DISARM_PARAM;

// չ
typedef struct tagCTRL_ARM_DISARM_PARAM_EX_IN
{
    DWORD               dwSize;
    NET_ALARM_MODE      emState;                            // ״̬
    const char*         szDevPwd;                           // û
    NET_SCENE_MODE      emSceneMode;                        // 龰ģʽ
    const char*         szDevID;                            // תĿ豸ID,ΪNULLʾת
} CTRL_ARM_DISARM_PARAM_EX_IN;

#define ARM_DISARM_ZONE_MAX (256)                           // 

// չ
typedef struct tagCTRL_ARM_DISARM_PARAM_EX_OUT
{
    DWORD               dwSize;
    DWORD               dwSourceNum;                        // бԴ벼ʧܵķ
    int                 nSource[ARM_DISARM_ZONE_MAX];       // бԴʧܵķ, Ŵ0ʼ
    DWORD               dwLinkNum;                          // ʧܵķ
    int                 nLink[ARM_DISARM_ZONE_MAX];         // ʧܵķ, Ŵ0ʼ
} CTRL_ARM_DISARM_PARAM_EX_OUT;

// չ(ӦDH_CTRL_ARMED_EX)
typedef struct tagCTRL_ARM_DISARM_PARAM_EX
{
    DWORD                        dwSize;
    CTRL_ARM_DISARM_PARAM_EX_IN  stuIn;                     // 
    CTRL_ARM_DISARM_PARAM_EX_OUT stuOut;                    // 
} CTRL_ARM_DISARM_PARAM_EX;

typedef struct tagDHCTRL_CONNECT_WIFI_BYWPS_IN
{
    DWORD               dwSize;
    int                 nType;                              // WPS,0:ⰴťʽ; 1:(豸)pin뷽ʽ; 2:(wifiȵ)pin뷽ʽ
    char                szSSID[DH_MAX_SSID_LEN];            // SSIDnTypeΪ12ʱЧ֧32λ
    char                szApPin[DH_MAX_APPIN_LEN];          // APPIN, nTypeΪ2ʱЧPINΪ8λ֣pinǴwifiȵõ
    char                szWLanPin[DH_MAX_APPIN_LEN];        // 豸pin,nTypeΪ1ʱЧ:Ϊʱ豸;Ϊʱʾû趨֧8λ֣pinҪWIFIȵ
}DHCTRL_CONNECT_WIFI_BYWPS_IN;

typedef struct tagDHCTRL_CONNECT_WIFI_BYWPS_OUT
{
    DWORD               dwSize;
    char                szRetWLanPin[DH_MAX_APPIN_LEN];// 豸PIN룬WPSΪ(豸)pin뷽ʽʱЧ
}DHCTRL_CONNECT_WIFI_BYWPS_OUT;

// CLIENT_ControlDeviceӿڵDH_CTRL_WIFI_BY_WPS(WPSWIFI)
typedef struct tagDHCTRL_CONNECT_WIFI_BYWPS
{
    DWORD                dwSize;
    DHCTRL_CONNECT_WIFI_BYWPS_IN     stuWpsInfo;            // Ӳ(ûд)
    DHCTRL_CONNECT_WIFI_BYWPS_OUT    stuWpsResult;          // (豸)
} DHCTRL_CONNECT_WIFI_BYWPS;

// CLIENT_ControlDeviceӿڵ DH_CTRL_CLOSE_BURNER  
typedef struct tagNET_CTRL_BURNERDOOR
{
    DWORD               dwSize;
    const char*         szBurnerName;                       // ƣ硰/dev/sda
    BOOL                bResult;                            // 
    BOOL                bSafeEject;                         // Ƿȫ, TRUE-ǰݱ, FALSE-ֱӵ
}NET_CTRL_BURNERDOOR;

// CLIENT_ControlDeviceӿڵ DH_CTRL_START_PLAYAUDIO 
typedef struct tagNET_CTRL_START_PLAYAUDIO
{
    DWORD               dwSize;
    char                szAudioPath[DH_MAX_AUDIO_PATH];
}NET_CTRL_START_PLAYAUDIO;

// Ԫ
typedef enum tagNET_PLAYAUDIO_TYPE
{
    NET_PLAYAUDIO_TYPE_UNKNOWN = 0,
    NET_PLAYAUDIO_TYPE_PHRASE,                          // ͣнζÿ֣иֵļ֧
    NET_PLAYAUDIO_TYPE_FILE,                            // ָ·ļ(豸·)
    NET_PLAYAUDIO_TYPE_PLATERNUM,                       // ƺ룬ƺʽ
    NET_PLAYAUDIO_TYPE_MONEY,                           // ʽ
    NET_PLAYAUDIO_TYPE_DATE,                            // ڣʽ
    NET_PLAYAUDIO_TYPE_TIME,                            // ʱ䣬ʱʽ
    NET_PLAYAUDIO_TYPE_EMPTY,                           // ͣͣһַʱ
}NET_PLAYAUDIO_TYPE;

// 
typedef struct tagNET_CTRL_PLAYAUDIO_INFO
{
    DWORD               dwSize;
    NET_PLAYAUDIO_TYPE  emPlayAudioType;                // Ԫ,NET_PLAYAUDIO_TYPE
    char                szDetail[DH_COMMON_STRING_128]; // ϸݸϸݣ
                                                        // Phrase:"ӭ"
                                                        // File: "/home/ͣ.pcm"
                                                        // PlateNumbe: "A12345"
                                                        // Money: "80.12Ԫ"
                                                        // Date: "2014410"
                                                        // Time: "110Сʱ205
}NET_CTRL_PLAYAUDIO_INFO;

#define DH_MAX_PLAYAUDIO_COUNT    16  // 󲥱Ŀ
// CLIENT_ControlDeviceӿڵ DH_CTRL_START_PLAYAUDIOEX 
typedef struct tagNET_CTRL_START_PLAYAUDIOEX
{
    DWORD                       dwSize;
    unsigned int                nAudioCount;                            // Ŀ               
    NET_CTRL_PLAYAUDIO_INFO     stuAudioInfos[DH_MAX_PLAYAUDIO_COUNT];  // 
}NET_CTRL_START_PLAYAUDIOEX;

// CLIENT_ControlDeviceӿڵ DH_CTRL_START_ALARMBELLDH_CTRL_STOP_ALARMBELL
typedef struct tagNET_CTRL_ALARMBELL
{
    DWORD               dwSize;
    int                 nChannelID;             // ͨ(0ʼ)            
}NET_CTRL_ALARMBELL;

// CLIENT_ControlDeviceӿڵ DH_CTRL_ACCESS_OPEN 
typedef struct tagNET_CTRL_ACCESS_OPEN
{
    DWORD               dwSize;
    int                 nChannelID;             // ͨ(0ʼ)
}NET_CTRL_ACCESS_OPEN;

// CLIENT_ControlDeviceӿڵ DH_CTRL_ACCESS_CLOSE 
typedef struct tagNET_CTRL_ACCESS_CLOSE
{
    DWORD               dwSize;
    int                 nChannelID;             // ͨ(0ʼ)
}NET_CTRL_ACCESS_CLOSE;

typedef enum tagNET_ALARM_TYPE
{
    NET_ALARM_LOCAL = 0,                        //ı¼(Ӧ DH_ALARM_ALARM_EX2 ¼)
    NET_ALARM_ALARMEXTENDED,                    //չģ鱨¼(Ӧ DH_ALARM_ALARMEXTENDED ¼)
    NET_ALARM_TEMP,                             //¶ȱ¼(Ӧ DH_ALARM_TEMPERATURE ¼)
    NET_ALARM_URGENCY,                          //¼(Ӧ DH_URGENCY_ALARM_EX ¼)
    NET_ALARM_RCEMERGENCYCALL,                  //б¼(Ӧ DH_ALARM_RCEMERGENCY_CALL ¼)
}NET_ALARM_TYPE;

// CLIENT_ControlDeviceӿڵ DH_CTRL_CLEAR_ALARM 
typedef struct tagNET_CTRL_CLEAR_ALARM
{
    DWORD               dwSize;
    int                 nChannelID;             // ͨ
    NET_ALARM_TYPE      emAlarmType;            // ¼(ֵ֧ͽ٣nEventTypeֶ)
    const char*         szDevPwd;               // ½豸,粻ʹü,ֱӸֵΪNULL
    BOOL                bEventType;             // ʾǷnEventTypeֶ, TRUE:nEventTypeemAlarmTypeֶ, FALSE:emAlarmTypeֶ,nEventTypeֶ
    int                 nEventType;             // ¼, ӦfMessCallBackصϵlCommandֶ, CLIENT_StartListenExӿڻ¼
                                                // DH_ALARM_ALARM_EX2ʾر¼
}NET_CTRL_CLEAR_ALARM;

// ǽʾϢƲ
typedef struct tagNET_CTRL_MONITORWALL_TVINFO 
{
    DWORD               dwSize;
    int                 nMonitorWallID;         // ǽID
    BOOL                bDecodeChannel;         // ʾͨϢ
} NET_CTRL_MONITORWALL_TVINFO;

// CLIENT_ControlDeviceӿڵ DH_CTRL_START_VIDEO_ANALYSE 
typedef struct tagNET_CTRL_START_VIDEO_ANALYSE
{
    DWORD               dwSize; 
    int                 nChannelId;             // ͨ  
}NET_CTRL_START_VIDEO_ANALYSE;

// CLIENT_ControlDeviceӿڵ DH_CTRL_STOP_VIDEO_ANALYSE 
typedef struct tagNET_CTRL_STOP_VIDEO_ANALYSE
{
    DWORD               dwSize; 
    int                 nChannelId;             // ͨ  
}NET_CTRL_STOP_VIDEO_ANALYSE;

// CLIENT_ControlDeviceӿڵ DH_CTRL_MULTIPLAYBACK_CHANNALES  
typedef struct tagNET_CTRL_MULTIPLAYBACK_CHANNALES
{
    DWORD               dwSize;
    LLONG               lPlayBackHandle;        // طžCLIENT_MultiPlayBackӿڷֵ
    int                 nChannels[DH_MAX_MULTIPLAYBACK_CHANNEL_NUM];// Ԥͨ
    int                 nChannelNum;            // Ԥͨ 
}NET_CTRL_MULTIPLAYBACK_CHANNALES;

// CLIENT_ControlDeviceӿڵ DH_CTRL_SET_BYPASS 
typedef struct tagNET_CTRL_SET_BYPASS
{
    DWORD               dwSize;
    const char*         szDevPwd;               // 豸
    NET_BYPASS_MODE     emMode;                 // ͨ״̬
    int                 nLocalCount;            // رͨ
    int*                pnLocal;                // رͨ    
    int                 nExtendedCount;         // չģ鱨ͨ
    int*                pnExtended;             // չģ鱨ͨ
}NET_CTRL_SET_BYPASS;

// CLIENT_QueryDevStateӿڵ DH_DEVSTATE_GET_BYPASS 
typedef struct tagNET_DEVSTATE_GET_BYPASS
{
    DWORD               dwSize;
    int                 nLocalCount;            // رͨ
    int*                pnLocal;                // رͨ    
    int                 nExtendedCount;         // չģ鱨ͨ
    int*                pnExtended;             // չģ鱨ͨ
    NET_BYPASS_MODE*    pemLocal;               // رͨ״̬
    NET_BYPASS_MODE*    pemExtended;            // չģ鱨ͨ״̬
}NET_DEVSTATE_GET_BYPASS;

// CLIENT_QueryDevStateӿڵ DH_DEVSTATE_BURNERDOOR 
typedef struct tagNET_DEVSTATE_BURNERDOOR
{
    DWORD               dwSize;
    const char*         szBurnerName;            // ƣ硰/dev/sda
    bool                bEjected;                // ǷѾ
    BYTE                Reserved[3];             // 
}NET_DEVSTATE_BURNERDOOR;

// CLIENT_QueryDevStateӿڵ DH_DEVSTATE_GET_DATA_CHECK 
typedef struct tagNET_DEVSTATE_DATA_CHECK
{
    DWORD               dwSize;                     // ṹС
    const char*         szBurnerName;               // ƣ硰/dev/s",Ƕ̵Ļκһ̶
    char                szState[DH_MAX_STRING_LEN]; // "NotStart":δʼ,"Verifying":У,"Failed":ʧ,"Successed":ɹ
    int                 nPercent;                   // Уٷֱ:0-100stateVerifyingʱЧ
}NET_DEVSTATE_DATA_CHECK;

// CLIENT_ListenServer ӿڻصfServiceCallBackֵ֧
enum { 
    DH_DVR_DISCONNECT=-1,                           // ֤ڼ豸߻ص
    DH_DVR_SERIAL_RETURN=1,                         // 豸עЯк Ӧ char* szDevSerial
    NET_DEV_AUTOREGISTER_RETURN,                    // 豸עЯкź ӦNET_CB_AUTOREGISTER
};
typedef struct tagNET_CB_AUTOREGISTER
{
    DWORD           dwSize;                          // ṹС
    char            szDevSerial[DH_DEV_SERIALNO_LEN];// к
    char            szToken[MAX_PATH];               // 
}NET_CB_AUTOREGISTER;

// עؽṹ
typedef struct tagCLOUDSERVICE_CONNECT_PARAM
{
    DWORD               dwSize;   
    char                szDstIp[DH_MAX_IPADDR_EX_LEN];    // IP
    int                 nDstPort;                         // ˿ں 
    DWORD               dwConnectType;                    // ͣ0ʾӣ1ʾӣ2, 3̬עӣʹ0Xb4עᣩ  
    char                szToken[MAX_PATH];                // ʹԶ豸ͨΨһID
}NET_CLOUDSERVICE_CONNECT_PARAM;

typedef struct tagCLOUDSERVICE_CONNECT_RESULT
{
    DWORD               dwSize;  
    DWORD               dwConnectState;                           // ǰ״̬1ɹ0ʧ
    char                szMessage[DH_MAX_CLOUDCONNECT_STATE_LEN]; // ״̬Ϣ,"Success","Password Error","Network Error","Timeout"
}NET_CLOUDSERVICE_CONNECT_RESULT;
///////////////////////////////ض///////////////////////////////

//-------------------------------豸---------------------------------
// 豸Ϣ
typedef struct
{
    BYTE                sSerialNumber[DH_SERIALNO_LEN];     // к
    BYTE                byAlarmInPortNum;                   // DVR
    BYTE                byAlarmOutPortNum;                  // DVR
    BYTE                byDiskNum;                          // DVRӲ̸
    BYTE                byDVRType;                          // DVRͣöNET_DEVICE_TYPE
    union
    {
        BYTE            byChanNum;                          // DVRͨ½ɹʱЧ
        BYTE            byLeftLogTimes;                     // ½ʧԭΪʱͨ˲֪ͨûʣ½Ϊ0ʱʾ˲Ч
    };
} NET_DEVICEINFO, *LPNET_DEVICEINFO;

// 豸Ϣչ
typedef struct
{
    BYTE                sSerialNumber[DH_SERIALNO_LEN];     // к
    int                 nAlarmInPortNum;                    // DVR
    int                 nAlarmOutPortNum;                   // DVR
    int                 nDiskNum;                           // DVRӲ̸
    int                 nDVRType;                           // DVRͣöNET_DEVICE_TYPE
    int                 nChanNum;                           // DVRͨ
    BYTE                byLimitLoginTime;                   // ߳ʱʱ䣬Ϊ0ʾƵ½0ʾƵķ
    BYTE                byLeftLogTimes;                     // ½ʧԭΪʱͨ˲֪ͨûʣ½Ϊ0ʱʾ˲Ч
    BYTE                bReserved[2];                       // ֽڣֽڶ
    int                 nLockLeftTime;                      // ½ʧܣûʣʱ䣨, -1ʾ豸δøò
    char                Reserved[24];                       // 
} NET_DEVICEINFO_Ex, *LPNET_DEVICEINFO_Ex;

// 豸汾Ϣ16λʾ汾ţ16λʾΰ汾
typedef struct 
{
    DWORD               dwSoftwareVersion;
    DWORD               dwSoftwareBuildDate;
    DWORD               dwDspSoftwareVersion;
    DWORD               dwDspSoftwareBuildDate;
    DWORD               dwPanelVersion;
    DWORD               dwPanelSoftwareBuildDate;
    DWORD               dwHardwareVersion;
    DWORD               dwHardwareDate;
    DWORD               dwWebVersion;
    DWORD               dwWebBuildDate;
} DH_VERSION_INFO, *LPDH_VERSION_INFO;

// 豸汾ϢӦCLIENT_QueryDevStateӿ
typedef struct  
{
    char                szDevSerialNo[DH_DEV_SERIALNO_LEN];         // к
    char                byDevType;                                  // 豸ͣöNET_DEVICE_TYPE
    char                szDevType[DH_DEV_TYPE_LEN];                 // 豸ϸͺţַʽΪ
    int                 nProtocalVer;                               // Э汾
    char                szSoftWareVersion[DH_MAX_URL_LEN];
    DWORD               dwSoftwareBuildDate;
    char                szPeripheralSoftwareVersion[DH_MAX_URL_LEN];// Ƭ汾ϢַʽΪ
    DWORD               dwPeripheralSoftwareBuildDate;
    char                szGeographySoftwareVersion[DH_MAX_URL_LEN]; // ϢλоƬ汾ϢַʽΪ
    DWORD               dwGeographySoftwareBuildDate;
    char                szHardwareVersion[DH_MAX_URL_LEN];
    DWORD               dwHardwareDate;
    char                szWebVersion[DH_MAX_URL_LEN];
    DWORD               dwWebBuildDate;
    char                reserved[256];
} DHDEV_VERSION_INFO;

// DSPӦCLIENT_GetDevConfigӿ
typedef struct 
{
    DWORD               dwVideoStandardMask;        // Ƶʽ룬λʾ豸ֵܹ֧Ƶʽ
    DWORD               dwImageSizeMask;            // ֱ룬λʾ豸ֵܹ֧ķֱ
    DWORD               dwEncodeModeMask;           // ģʽ룬λʾ豸ֵܹ֧ıģʽ    
    DWORD               dwStreamCap;                // λʾ豸ֵ֧Ķý幦ܣ
                                                    // һλʾ֧
                                                    // ڶλʾָ֧1
                                                    // λʾָ֧2
                                                    // λʾ֧jpgץͼ
    DWORD               dwImageSizeMask_Assi[8];    // ʾΪֱʱֵ֧ĸֱ롣
    DWORD               dwMaxEncodePower;           // DSPֵ֧߱ 
    WORD                wMaxSupportChannel;         // ÿDSP֧Ƶͨ 
    WORD                wChannelMaxSetSync;         // DSPÿͨǷͬ0ͬ1ͬ
} DH_DSP_ENCODECAP, *LPDH_DSP_ENCODECAP;

// DSPչͣӦCLIENT_QueryDevStateӿ
typedef struct 
{
    DWORD               dwVideoStandardMask;        // Ƶʽ룬λʾ豸ֵܹ֧Ƶʽ
    DWORD               dwImageSizeMask;            // ֱ룬λʾ豸ֵܹ֧ķֱ
    DWORD               dwEncodeModeMask;           // ģʽ룬λʾ豸ֵܹ֧ıģʽ
    DWORD               dwStreamCap;                // λʾ豸ֵ֧Ķý幦ܣ
                                                    // һλʾ֧
                                                    // ڶλʾָ֧1
                                                    // λʾָ֧2
                                                    // λʾ֧jpgץͼ
    DWORD               dwImageSizeMask_Assi[32];   // ʾΪֱʱֵ֧ĸֱ롣
    DWORD               dwMaxEncodePower;           // DSPֵ֧߱ 
    WORD                wMaxSupportChannel;         // ÿDSP֧Ƶͨ 
    WORD                wChannelMaxSetSync;         // DSPÿͨǷͬ0ͬ1ͬ
    BYTE                bMaxFrameOfImageSize[32];   // ֱͬµɼ֡ʣdwVideoStandardMaskλӦ
    BYTE                bEncodeCap;                 // ־ʱҪòЧ
                                                    // 0ı+ı <= 豸ı
                                                    // 1ı+ı <= 豸ı
                                                    // ı <= ı
                                                    // ķֱ <= ķֱʣ
                                                    // ͸֡ <= ǰƵɼ֡
                                                    // 2N5ļ㷽
                                                    // ķֱ <= ķֱ
                                                    // ѯֵ֧ķֱʺӦ֡
    char                reserved[95];
} DHDEV_DSP_ENCODECAP, *LPDHDEV_DSP_ENCODECAP;

// DSPչӦCLIENT_QueryDevStateӿ
typedef struct 
{
    DWORD               dwVideoStandardMask;        // Ƶʽ룬λʾ豸ֵܹ֧Ƶʽ
    DWORD               dwImageSizeMask;            // ֱ룬λʾ豸ֵܹ֧ķֱ
    DWORD               dwEncodeModeMask;           // ģʽ룬λʾ豸ֵܹ֧ıģʽ
    DWORD               dwStreamCap;                // λʾ豸ֵ֧Ķý幦ܣ
                                                    // һλʾ֧
                                                    // ڶλʾָ֧1
                                                    // λʾָ֧2
                                                    // λʾָ֧3
                                                    // λʾ֧jpgץͼ
    DWORD               dwImageSizeMask_Assi[3][64];// ʾΪֱʱֵ֧ĸֱ, е0,1,2Ԫطֱ1,2,3
    DWORD               dwMaxEncodePower;           // DSPֵ֧߱ 
    WORD                wMaxSupportChannel;         // ÿDSP֧Ƶͨ 
    WORD                wChannelMaxSetSync;         // DSPÿͨǷͬ0ͬ1ͬ
    BYTE                bMaxFrameOfImageSize[32];   // ֱͬµɼ֡ʣdwVideoStandardMaskλӦ
    BYTE                bEncodeCap;                 // ־ʱҪòЧ
                                                    // 0ı+ı <= 豸ı
                                                    // 1ı+ı <= 豸ı
                                                    // ı <= ı
                                                    // ķֱ <= ķֱʣ
                                                    // ͸֡ <= ǰƵɼ֡
                                                    // 2N5ļ㷽
                                                    // ķֱ <= ķֱ
                                                    // ѯֵ֧ķֱʺӦ֡
    BYTE                btReserve1[3];              // ֽڶ

    DWORD               dwExtraStream;              // 0λʾ, λαʾ, һλʾ1,ڶǱʾ2
    DWORD               dwCompression[3];           // ÿһֵʾӦıʽ֧
    
    char                reserved[108];
} DHDEV_DSP_ENCODECAP_EX, *LPDHDEV_DSP_ENCODECAP_EX;

// ϵͳϢ
typedef struct 
{
    DWORD               dwSize;
    /* 豸ֻ */
    DH_VERSION_INFO     stVersion;
    DH_DSP_ENCODECAP    stDspEncodeCap;                     // DSP
    BYTE                szDevSerialNo[DH_DEV_SERIALNO_LEN]; // к
    BYTE                byDevType;                          // 豸ͣöNET_DEVICE_TYPE
    BYTE                szDevType[DH_DEV_TYPE_LEN];         // 豸ϸͺţַʽΪ
    BYTE                byVideoCaptureNum;                  // Ƶ
    BYTE                byAudioCaptureNum;                  // Ƶ
    BYTE                byTalkInChanNum;                    // Խӿ
    BYTE                byTalkOutChanNum;                   // Խӿ
    BYTE                byDecodeChanNum;                    // NSP
    BYTE                byAlarmInNum;                       // 
    BYTE                byAlarmOutNum;                      // 
    BYTE                byNetIONum;                         // 
    BYTE                byUsbIONum;                         // USB
    BYTE                byIdeIONum;                         // IDE
    BYTE                byComIONum;                         // 
    BYTE                byLPTIONum;                         // 
    BYTE                byVgaIONum;                         // NSP
    BYTE                byIdeControlNum;                    // NSP
    BYTE                byIdeControlType;                   // NSP
    BYTE                byCapability;                       // NSPչ
    BYTE                byMatrixOutNum;                     // Ƶ
    /* 豸Ŀд */
    BYTE                byOverWrite;                        // Ӳʽ(ǡֹͣ)
    BYTE                byRecordLen;                        // ¼
    BYTE                byDSTEnable;                        // Ƿʵʱ 1-ʵ 0-ʵ
    WORD                wDevNo;                             // 豸ţң
    BYTE                byVideoStandard;                    // Ƶʽ:0-PAL,1-NTSC
    BYTE                byDateFormat;                       // ڸʽ
    BYTE                byDateSprtr;                        // ڷָ(0"."1"-"2"/")
    BYTE                byTimeFmt;                          // ʱʽ (0-24Сʱ112Сʱ)
    BYTE                byLanguage;                         // öֵDH_LANGUAGE_TYPE
} DHDEV_SYSTEM_ATTR_CFG, *LPDHDEV_SYSTEM_ATTR_CFG;

// ޸豸÷Ϣ
typedef struct
{
    DWORD               dwType;                     // (GetDevConfigSetDevConfig)
    WORD                wResultCode;                // 룻0ɹ1ʧܣ2ݲϷ3ʱ޷ã4ûȨ
    WORD                wRebootSign;                // ־0Ҫ1ҪЧ
    DWORD               dwReserved[2];              //     
} DEV_SET_RESULT;

// ӻطŵĴ󷵻Ϣ
typedef struct
{
    DWORD               dwResultCode;               // 󷵻
                                                    // 1:Ȩޣ2:豸ִ֧˲3:Դ, 4:豸޷ȡǰ
                                                    // 11:ʾ߼ûռͼûԴ, 12:ֹ, 13:̶
                                                    // 14: ໭ԤѴ򿪣Դ㣬ѹطʧ, 15: ѹطŹѴ򿪣ʧ 
    LLONG               lPlayHandle;                // Ӧֵ
    BYTE                byReserved[32];             // ֽ                         

}DEV_PLAY_RESULT;

// ԽĴ󷵻Ϣ
typedef struct
{
    DWORD               dwResultCode;               // 󷵻 CLIENT_GetLastErrorӿڵķֵ
                                                    // NET_ERROR_TALK_REJECT _EC(375) // ܾԽ
                                                    // NET_ERROR_TALK_RESOURCE_CONFLICIT _EC(377) // Դͻ
                                                    // NET_ERROR_TALK_UNSUPPORTED_ENCODE _EC(378) // ֵ֧ʽ
                                                    // NET_ERROR_TALK_RIGHTLESS _EC(379) // Ȩ
    LLONG               lTalkHandle;                // Ӧֵ
    BYTE                byReserved[32];             // ֽ                         
}DEV_TALK_RESULT;

//DST(ʱ)
typedef struct  
{
    int                 nYear;                      // [200 - 2037]
    int                 nMonth;                     // [1 - 12]
    int                 nHour;                      // Сʱ [0 - 23]
    int                 nMinute;                    //  [0 - 59]
    int                 nWeekOrDay;                 // [-1 - 4]0:ʾʹðڼķ
                                                    // 1: ܼ: һ,2: ڶ,3: ,4: ,-1: һ
    union
    {
        int             iWeekDay;                   // [0 - 6](nWeekOrDayܼʱ)0:, 1:һ, 2:ڶ,3:,4:,5:,6:
        int             iDay;                       // [1 - 31] (nWeekOrDayڼ)
    };
    
    DWORD               dwReserved[8];              //     
}DH_DST_POINT;

typedef struct  
{
    DWORD               dwSize;
    int                 nDSTType;                   // ʱλʽ 0:ڶλʽ, 1:ܶλʽ
    DH_DST_POINT        stDSTStart;                 // ʼʱ
    DH_DST_POINT        stDSTEnd;                   // ʱ
    DWORD               dwReserved[16];             //     
}DHDEV_DST_CFG;


// Զά
typedef struct
{
    DWORD               dwSize;
    BYTE                byAutoRebootDay;            // Զ0Ӳ, 1ÿ죬2ÿգ3ÿһ......
    BYTE                byAutoRebootTime;           // 00:0011:00......2323:00
    BYTE                byAutoDeleteFilesTime;      // Զɾļ0Ӳ124H248H372H496H5ONE WEEK6ONE MONTH
    BYTE                reserved[13];               // λ
} DHDEV_AUTOMT_CFG;

// ӲϢ
typedef struct  
{
    DWORD               dwSize;                                     // ṹС,Աʼ
    DWORD               dwVolume;                                   // Ӳ
    DWORD               dwFreeSpace;                                // Ӳ̵ʣռ, λMB(Bʾֽ)
    BYTE                byModle[DH_MAX_HARDDISK_TYPE_LEN];          // Ӳͺ
    BYTE                bySerialNumber[DH_MAX_HARDDISK_SERIAL_LEN]; // Ӳк
}DHDEV_VEHICLE_DISK;

// ص3GģϢ֧DH_MAX_SIM_NUMģ
typedef struct
{
    DWORD               dwSize;                                     // ṹС,Աʼ
    BYTE                szIMSI[DH_MAX_SIM_LEN];                     // SIMֵ460012002778636 ǰ3λΪҴMCC4-6λΪMNC,ΪƶûݱʶMSINܹᳬ15ַ
    BYTE                szMDN[DH_MAX_MDN_LEN];                      // SIMMDNֵ
}DHDEV_VEHICLE_3GMODULE;

// صĻϢ
typedef struct 
{
    DWORD                   dwSize;                                 // ṹС,Աʼ
    DWORD                   dwSoftwareBuildDate;                    // 
    char                    szVersion[DH_MAX_VERSION_LEN];          // 汾
    char                    szDevSerialNo[DH_DEV_SERIALNO_LEN];     // к
    char                    szDevType[DH_DEV_TYPE_LEN];             // 豸ϸͺţַʽΪ
    DWORD                   dwDiskNum;                              // Ӳ̸
    DHDEV_VEHICLE_DISK      stuHarddiskInfo[DH_MAX_DISKNUM];        // ӲϢ
    DWORD                   dw3GModuleNum;                          // 3Gģ
    DHDEV_VEHICLE_3GMODULE  stu3GModuleInfo[DH_MAX_SIM_NUM];        // 3GģϢ
}DHDEV_VEHICLE_INFO;

// ӿڣ֧DH_MAX_NETINTERFACE_NUM
typedef struct tagDHDEV_NETINTERFACE_INFO
{
    int             dwSize;
    BOOL            bValid;                                         // ǷЧ
    BOOL            bVirtual;                                       // Ƿ
    int             nSpeed;                                         // ٶ(Mbps)
    int             nDHCPState;                                     // 0-δʹ, 1-ڻȡ, 2-ȡɹ
    char            szName[DH_NETINTERFACE_NAME_LEN];               // 
    char            szType[DH_NETINTERFACE_TYPE_LEN];               // 
    char            szMAC[DH_MACADDR_LEN];                          // MACַ
    char            szSSID[DH_MAX_SSID_LEN];                        // SSID, ֻЧ(szType == "Wireless")
    char            szConnStatus[DH_MAX_CONNECT_STATUS_LEN];        // Wifi3G״̬"Inexistence" : 粻 "Down"ر "Disconn"δ "Connecting" "Connected" 
    int             nSupportedModeNum;                              // ʵ3Gֵ֧ģʽ
    char            szSupportedModes[DH_MAX_MODE_NUM][DH_MAX_MODE_LEN];// 3Gֵ֧ģʽ    "TD-SCDMA", "WCDMA", "CDMA1x", "EDGE", "EVDO"
} DHDEV_NETINTERFACE_INFO;

//-----------------------------ͼͨ-------------------------------

// ʱνṹ                                                                
typedef struct 
{
    int             bEnable;                        // ʾ¼ʱʱλʾĸʹܣӵλλֱʾ¼󡢱¼ͨ¼󡢶ͱͬʱ¼
    int             iBeginHour;
    int             iBeginMin;
    int             iBeginSec;
    int             iEndHour;
    int             iEndMin;
    int             iEndSec;
} DH_TSECT, *LPDH_TSECT;

// 򣻸߾ఴ8192ı
typedef struct 
{
   long             left;
   long             top;
   long             right;
   long             bottom;
} DH_RECT, *LPDH_RECT;

typedef struct tagNET_RECT
{
    int             nLeft;
    int             nTop;
    int             nRight;
    int             nBottom;
} NET_RECT;

// άռ
typedef struct 
{
   short            nx;
   short            ny;
} DH_POINT, *LPDH_POINT;

// ߶Ϣ
typedef struct
{
    int        nPointNum;                               // 
    DH_POINT   stuPoints[DH_MAX_DETECT_REGION_NUM];     // Ϣ
}DH_POLY_POINTS;

// OSDԽṹ
typedef struct  tagENCODE_WIDGET
{
    DWORD               rgbaFrontground;                // ǰֽڱʾֱΪ졢̡͸
    DWORD               rgbaBackground;                 // ıֽڱʾֱΪ졢̡͸
    DH_RECT             rcRect;                         // λ
    BYTE                bShow;                          // ʾʹ
    BYTE                bExtFuncMask;                   // չʹ  
                                                        // bit0 ʾǷʾڼ0-ʾ 1-ʾ 
    BYTE                byReserved[2];
} DH_ENCODE_WIDGET, *LPDH_ENCODE_WIDGET;

// ͨƵ
typedef struct 
{
    // Ƶ
    BYTE                byVideoEnable;                  // Ƶʹܣ1򿪣0ر
    BYTE                byBitRateControl;               // ƣճ""
    BYTE                byFramesPerSec;                 // ֡
    BYTE                byEncodeMode;                   // ģʽճ"ģʽ"
    BYTE                byImageSize;                    // ֱʣճ"ֱ"
    BYTE                byImageQlty:7;                  // byImageQltyչbyImageQltyΪ0ץͼõImgQltyΪ10/30/50/60/80/100ֵõImgQltyֵΪ1-6֮ǰ1-6Σ//ImgQltyTypeΪ1ImgQltyΧΪ0~100
    BYTE                byImageQltyType:1;       
    WORD                wLimitStream;                   // 
    // Ƶ
    BYTE                byAudioEnable;                  // Ƶʹܣ1򿪣0ر
    BYTE                wFormatTag;                     // Ƶ: 0:G711A,1:PCM,2:G711U,3:AMR,4:AAC
    WORD                nChannels;                      // 
    WORD                wBitsPerSample;                 //     
    BYTE                bAudioOverlay;                  // Ƶʹ
    BYTE                bH264ProfileRank;               // H.264 Profileȼ(ģʽΪH264ʱ˲ֵЧ),öEM_H264_PROFILE_RANK0ǰʾֶЧҪǼ
    DWORD               nSamplesPerSec;                 // 
    BYTE                bIFrameInterval;                // I֡֡I֮֡P֡0-149
    BYTE                bScanMode;                      // NSP
    BYTE                bReserved_3;
    BYTE                bReserved_4;
} DH_VIDEOENC_OPT, *LPDH_VIDEOENC_OPT;

// ɫ
typedef struct 
{
    DH_TSECT            stSect;
    BYTE                byBrightness;                   // ȣ0-100
    BYTE                byContrast;                     // Աȶȣ0-100
    BYTE                bySaturation;                   // Ͷȣ0-100
    BYTE                byHue;                          // ɫȣ0-100
    BYTE                byGainEn;                       // ʹ
    BYTE                byGain;                         // 棻0-100
    BYTE                byGamma;                        // ٤ֵ 0-100
    BYTE                byReserved[1];
} DH_COLOR_CFG, *LPDH_COLOR_CFG;

// ͼͨԽṹ
typedef struct 
{
    WORD                dwSize;
    BYTE                bNoise;
    BYTE                bMode;                          // ()ģʽһ():¼ֱʲ4·D1֡2fps128kbps(ÿСʱ225MB)
                                                        // ģʽ():¼ֱʲ4·CIF֡12fps256kbps(ÿСʱ550MB)
                                                        // ģʽ(Զ)¼ֱʿûԶ壬޶Ϊ4CIF/25fps
    char                szChannelName[DH_CHAN_NAME_LEN];
    DH_VIDEOENC_OPT     stMainVideoEncOpt[DH_REC_TYPE_NUM];
    DH_VIDEOENC_OPT     stAssiVideoEncOpt[DH_N_ENCODE_AUX];        
    DH_COLOR_CFG        stColorCfg[DH_N_COL_TSECT];
    DH_ENCODE_WIDGET    stTimeOSD;
    DH_ENCODE_WIDGET    stChannelOSD;
    DH_ENCODE_WIDGET    stBlindCover[DH_N_COVERS];      // ڵ
    BYTE                byBlindEnable;                  // ڸǿأ0x00ʹڸǣ0x01ڸ豸Ԥ0x10ڸ¼Ԥ0x11ڸ
    BYTE                byBlindMask;                    // ڸ룻һλ豸Ԥڶλ¼(Ԥ) */
    BYTE                bVolume;                        // ֵ(0~100ɵ)
    BYTE                bVolumeEnable;                  // ֵʹ
} DHDEV_CHANNEL_CFG, *LPDHDEV_CHANNEL_CFG;

// Ԥͼ
typedef struct 
{
    DWORD               dwSize;
    DH_VIDEOENC_OPT     stPreView;
    DH_COLOR_CFG        stColorCfg[DH_N_COL_TSECT];
}DHDEV_PREVIEW_CFG;

// ץͼ
typedef struct _config_snap_control
{
    BYTE                bySnapState[32];                // ÿͨӦץͼ 0:Զ(ʾǷץͼú¼); 1:ץͼ; 2:ץͼر
    BYTE                byReserved[480];
}DHDEV_SNAP_CONTROL_CFG;

enum _gps_mode
{
    GPS_OR_GLONASS_MODE,            // GPSGLONASSģʽ(ģ鶨λݴGPSGLONASSлȡԴĸϵͳȷ,ģڲԶᴦ)
    GLONASS_MODE,                   // GLONASSģʽ(ģĶλݴӶ˹GLONASSλϵͳлȡ)
    GPS_MODE,                       // GPSģʽ(ģĶλݴGPSϵͳлȡ) 
};
// DH_DEV_GPS_MODE_CFG ýṹ
typedef struct tagDHDEV_GPS_MODE_CFG
{
    BYTE                byGPSMode;                      // GPSλģʽ
    BYTE                byRev[255];
}DHDEV_GPS_MODE_CFG;

// ͼƬϴϢ DH_DEV_SNAP_UPLOAD_CFG ýṹ
typedef struct tagDHDEV_SNAP_UPLOAD_CFG
{
    int                 nUploadInterval;                //ʱץͼͼƬϴλ
    BYTE                byReserved[252];    
}DHDEV_SNAP_UPLOAD_CFG;


// DHDEV_SPEED_LIMIT_CFG ýṹ
typedef struct tagDHDEV_SPEED_LIMIT_CFG
{
    BYTE                byEnable;                       // ʹ1ʹܣ0ʹܡ
    BYTE                byReserved1;                    // ֶ
    WORD                wMaxSpeed;                      // ٶֵλKM/H 0ʾ,0ʾ
    WORD                wMinSpeed;                      // ٶֵλKM/H 0ʾ,0ʾ
    BYTE                byReserved2[122];               // ֶ
}DHDEV_SPEED_LIMIT_CFG;

// ·
typedef struct
{
    BOOL                bEnable;                        // ʹ
    char                szSSID[36];                     // SSID
    BOOL                bHideSSID;                      // ǷSSID
    char                szIP[DH_MAX_IPADDR_LEN];        // IP
    char                szSubMark[DH_MAX_IPADDR_LEN];   // 
    char                szGateWay[DH_MAX_IPADDR_LEN];   // 
    char                szCountry[32];                  // , DefaultĬϲָбο·Ϣ
    int                 nSafeType;                      // Ȩģʽ: 1-; 2-WEPģʽ; 2-WPA-PSKģʽ; 3-WPA2-PSKģʽ
    int                 nEncryption;                    // ܷʽ: WEPģʽ(1-Զ 2- 3-); WPA-PSKģʽ/WPA2-PSKģʽ(4-TKIP 5-AES)
    char                szKey[32];                      // Կ
    int                 nChannel;                       // ŵ, Чŵбο·Ϣ
    BOOL                bAutoChannelSelect;             // Զѡŵ    
}DHDEV_WIRELESS_ROUTING_CFG;

//----------------------------------------------------------------

// ڻ
typedef struct
{
    BYTE                byDataBit;                      // λ05162738
    BYTE                byStopBit;                      // ֹͣλ01λ11.5λ22λ
    BYTE                byParity;                       // Уλ0У飬1У飻2żУ; 3:־У; 4:У
    BYTE                byBaudRate;                     // ʣ03001600212003240044800
                                                        // 596006192007384008576009115200
} DH_COMM_PROP;

// 485
typedef struct
{ 
    DH_COMM_PROP        struComm;
    BYTE                wProtocol;                      // ЭͣӦ"Эб"±
    BYTE                bPTZType;                       // 0-ݣ̨ 1-Զ̨,ͨѯ(DEV_ENCODER_CFG)
    BYTE                wDecoderAddress;                // ַ0 - 255
    BYTE                byMartixID;                     // 
} DH_485_CFG;

// 232
typedef struct
{
    DH_COMM_PROP        struComm;
    BYTE                byFunction;                     // ڹܣӦ"б"±
    BYTE                byReserved[3];
} DH_RS232_CFG;

// ýṹ
typedef struct
{
    DWORD               dwSize;

    DWORD               dwDecProListNum;                                        // Э
    char                DecProName[DH_MAX_DECPRO_LIST_SIZE][DH_MAX_NAME_LEN];   // Эб
    DH_485_CFG          stDecoder[DH_MAX_DECODER_NUM];                          // ǰ

    DWORD               dw232FuncNameNum;                                       // 232ܸ
    char                s232FuncName[DH_MAX_232FUNCS][DH_MAX_NAME_LEN];         // б
    DH_RS232_CFG        st232[DH_MAX_232_NUM];                                  // 232ڵǰ
} DHDEV_COMM_CFG;

// չýṹ
typedef struct
{
    DWORD               dwSize;
    
    DWORD               dwDecProListNum;                                        // Э
    char                DecProName[DH_MAX_DECPRO_LIST_SIZE][DH_MAX_NAME_LEN];   // Эб
    DH_485_CFG          stDecoder[DH_MAX_DECODER_NUM];                          // ǰ
    
    DWORD               dw232FuncNameNum;                                       // 232ܸ
    char                s232FuncName[DH_MAX_232FUNCS][DH_MAX_NAME_LEN];         // б
    DWORD               dw232ComNum;                                            // 232ڸ   
    DH_RS232_CFG        st232[DH_MAX_232_NUM_EX];                               // 232ڵǰ
} DHDEV_COMM_CFG_EX;

// ״̬
typedef struct
{
    unsigned int        uBeOpened;
    unsigned int        uBaudRate;
    unsigned int        uDataBites;
    unsigned int        uStopBits;
    unsigned int        uParity;
    BYTE                bReserved[32];
} DH_COMM_STATE;

//-------------------------------¼---------------------------------

// ʱ¼
typedef struct 
{
    DWORD               dwSize;
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT];
    BYTE                byPreRecordLen;                     // Ԥ¼ʱ䣬λs0ʾԤ¼
    BYTE                byRedundancyEn;                     // ¼࿪
    BYTE                byRecordType;                       // ¼ͣ0- 1-1 2-2 3-3
    BYTE                byReserved;
} DHDEV_RECORD_CFG, *LPDH_RECORD_CFG;

// NTP
typedef struct  
{
    BOOL                bEnable;                            // Ƿ
    int                 nHostPort;                          // NTPĬ϶˿Ϊ123
    char                szHostIp[32];                       // IP
    char                szDomainName[128];                  // 
    int                 nType;                              // ã0ʾIP1ʾ2ʾIP
    int                 nUpdateInterval;                    // ʱ()
    int                 nTimeZone;                          // DH_TIME_ZONE_TYPE
    char                reserved[128];
} DHDEV_NTP_CFG;

// FTPϴ
typedef struct
{
    struct
    {
        DH_TSECT        struSect;                           // ʱڵġʹܡЧɺ
        BOOL            bMdEn;                              // ϴ̬¼
        BOOL            bAlarmEn;                           // ϴⲿ¼
        BOOL            bTimerEn;                           // ϴͨʱ¼
        DWORD           dwRev[4];
    } struPeriod[DH_TIME_SECTION];
} DH_FTP_UPLOAD_CFG;

typedef struct
{
    DWORD               dwSize;
    BOOL                bEnable;                            // Ƿ
    char                szHostIp[DH_MAX_IPADDR_LEN];        // IP
    WORD                wHostPort;                          // ˿
    char                szDirName[DH_FTP_MAX_PATH];         // FTPĿ¼·
    char                szUserName[DH_FTP_USERNAME_LEN];    // û
    char                szPassword[DH_FTP_PASSWORD_LEN];    // 
    int                 iFileLen;                           // ļ
    int                 iInterval;                          // ļʱ(1~600),λ 
    DH_FTP_UPLOAD_CFG   struUploadCfg[DH_MAX_CHANNUM][DH_N_WEEKS];
    char                protocol;                           // 0-FTP 1-SMB 2-NFS3-ISCSI
    char                NASVer;                             // 洢汾0=ϵFTP(ʾʱ)1=NAS洢(ʱ)
    DWORD               dwFunctionMask;                     // 룬λʾ16λ(洢)αʾFTPSMBNFSISCSI, 16λ(ش洢)ΪDISKU
    BYTE                bDataType;                          // , 0-, 1-Ƶ, 2-ͼƬ
    BYTE                reserved[123];
} DHDEV_FTP_PROTO_CFG;

// FTPϴչ(֧ͨFTP洢·洢ͼƬ)
typedef struct 
{
    int            nMaxPictures;                             // ܴ洢ÿһͨļеͼƬƣ
                                                             // ƾ͸ϵļ,0:ʾƣдΪֹ
    char           szPreChannelName[DH_FTP_MAX_SUB_PATH];    // ͼƬļ
    char           szFTPChannelPath[DH_FTP_MAX_SUB_PATH];    // ftp洢·(洢Ŀ¼)
    char           szRev[128];                               // ֶ
}DHDEV_FTP_CHANNEL_CFG; 


typedef struct 
{ 
    DHDEV_FTP_PROTO_CFG       stuFtpNormalSet;                     // FTPԭйܣչͨ
    DHDEV_FTP_CHANNEL_CFG     stuFtpChannelSet[DH_MAX_CHANNUM];    // FTPչ
    char                      szRev[128];                          // ֶ
}DHDEV_FTP_PROTO_CFG_EX;

//----------------------------------------------------------------

// ̫
typedef struct 
{
    char                sDevIPAddr[DH_MAX_IPADDR_LEN];      // DVR IP ַ
    char                sDevIPMask[DH_MAX_IPADDR_LEN];      // DVR IP ַ
    char                sGatewayIP[DH_MAX_IPADDR_LEN];      // صַ

    /*
     * 110Mbps ȫ˫
     * 210Mbps Ӧ
     * 310Mbps ˫
     * 4100Mbps ȫ˫
     * 5100Mbps Ӧ
     * 6100Mbps ˫
     * 7Ӧ
     */
    // ΪչDWORDĸ
    BYTE                dwNetInterface;                     // NSP
    BYTE                bTranMedia;                         // 0ߣ1
    BYTE                bValid;                             // λʾһλ1Ч 0Чڶλ0DHCPر 1DHCPʹܣλ0֧DHCP 1֧DHCP
    BYTE                bDefaultEth;                        // ǷΪĬϵ 1Ĭ 0Ĭ
    char                byMACAddr[DH_MACADDR_LEN];          // MACַֻ
} DH_ETHERNET; 

// Զ
typedef struct 
{
    BYTE                byEnable;                           // ʹ
    BYTE                byAssistant;                        // ĿǰֻPPPoEã0ţ1ϲ
    WORD                wHostPort;                          // Զ ˿
    char                sHostIPAddr[DH_MAX_IPADDR_LEN];     // Զ IP ַ        
    char                sHostUser[DH_MAX_HOST_NAMELEN];     // Զ û
    char                sHostPassword[DH_MAX_HOST_PSWLEN];  // Զ 
} DH_REMOTE_HOST;

// ʼ
typedef struct 
{
    char                sMailIPAddr[DH_MAX_IPADDR_LEN];     // ʼIPַ
    WORD                wMailPort;                          // ʼ˿
    WORD                wReserved;                          // 
    char                sSenderAddr[DH_MAX_MAIL_ADDR_LEN];  // ͵ַ
    char                sUserName[DH_MAX_NAME_LEN];         // û
    char                sUserPsw[DH_MAX_NAME_LEN];          // û
    char                sDestAddr[DH_MAX_MAIL_ADDR_LEN];    // Ŀĵַ
    char                sCcAddr[DH_MAX_MAIL_ADDR_LEN];      // ͵ַ
    char                sBccAddr[DH_MAX_MAIL_ADDR_LEN];     // ַ
    char                sSubject[DH_MAX_MAIL_SUBJECT_LEN];  // 
} DH_MAIL_CFG;

// ýṹ
typedef struct
{ 
    DWORD               dwSize; 
    char                sDevName[DH_MAX_NAME_LEN];          // 豸
    WORD                wTcpMaxConnectNum;                  // TCP
    WORD                wTcpPort;                           // TCP֡˿
    WORD                wUdpPort;                           // UDP˿
    WORD                wHttpPort;                          // HTTP˿ں
    WORD                wHttpsPort;                         // HTTPS˿ں
    WORD                wSslPort;                           // SSL˿ں
    DH_ETHERNET         stEtherNet[DH_MAX_ETHERNET_NUM];    // ̫
    DH_REMOTE_HOST      struAlarmHost;                      // 
    DH_REMOTE_HOST      struLogHost;                        // ־
    DH_REMOTE_HOST      struSmtpHost;                       // SMTP
    DH_REMOTE_HOST      struMultiCast;                      // ಥ
    DH_REMOTE_HOST      struNfs;                            // NFS
    DH_REMOTE_HOST      struPppoe;                          // PPPoE
    char                sPppoeIP[DH_MAX_IPADDR_LEN];        // PPPoEע᷵صIP
    DH_REMOTE_HOST      struDdns;                           // DDNS
    char                sDdnsHostName[DH_MAX_HOST_NAMELEN]; // DDNS
    DH_REMOTE_HOST      struDns;                            // DNS
    DH_MAIL_CFG         struMail;                           // ʼ
} DHDEV_NET_CFG;

// ̫չ
typedef struct 
{
    char                sDevIPAddr[DH_MAX_IPADDR_LEN];      // DVR IP ַ
    char                sDevIPMask[DH_MAX_IPADDR_LEN];      // DVR IP ַ
    char                sGatewayIP[DH_MAX_IPADDR_LEN];      // صַ

    /*
     * 110Mbps ȫ˫
     * 210Mbps Ӧ
     * 310Mbps ˫
     * 4100Mbps ȫ˫
     * 5100Mbps Ӧ
     * 6100Mbps ˫
     * 7Ӧ
     */
    // ΪչDWORDĸ
    BYTE                dwNetInterface;                     // NSP
    BYTE                bTranMedia;                         // 0ߣ1
    BYTE                bValid;                             // λʾһλ1Ч 0Чڶλ0DHCPر 1DHCPʹܣλ0֧DHCP 1֧DHCP
    BYTE                bDefaultEth;                        // ǷΪĬϵ 1Ĭ 0Ĭ
    char                byMACAddr[DH_MACADDR_LEN];          // MACַֻ
    BYTE                bMode;                              // ģʽ, 0:ģʽ, 1:ؾģʽ, 2:ַģʽ, 3:ݴģʽ
    BYTE                bReserved1[3];                      // ֽڶ
    char                szEthernetName[DH_MAX_NAME_LEN];    // ֻ
    BYTE                bReserved[12];                      // ֽ   
} DH_ETHERNET_EX; 

// չýṹ
typedef struct
{ 
    DWORD               dwSize; 
    char                sDevName[DH_MAX_NAME_LEN];          // 豸
    WORD                wTcpMaxConnectNum;                  // TCP
    WORD                wTcpPort;                           // TCP֡˿
    WORD                wUdpPort;                           // UDP˿
    WORD                wHttpPort;                          // HTTP˿ں
    WORD                wHttpsPort;                         // HTTPS˿ں
    WORD                wSslPort;                           // SSL˿ں
    int                 nEtherNetNum;                       // ̫
    DH_ETHERNET_EX      stEtherNet[DH_MAX_ETHERNET_NUM_EX]; // ̫
    DH_REMOTE_HOST      struAlarmHost;                      // 
    DH_REMOTE_HOST      struLogHost;                        // ־
    DH_REMOTE_HOST      struSmtpHost;                       // SMTP
    DH_REMOTE_HOST      struMultiCast;                      // ಥ
    DH_REMOTE_HOST      struNfs;                            // NFS
    DH_REMOTE_HOST      struPppoe;                          // PPPoE
    char                sPppoeIP[DH_MAX_IPADDR_LEN];        // PPPoEע᷵صIP
    DH_REMOTE_HOST      struDdns;                           // DDNS
    char                sDdnsHostName[DH_MAX_HOST_NAMELEN]; // DDNS
    DH_REMOTE_HOST      struDns;                            // DNS
    DH_MAIL_CFG         struMail;                           // ʼ
    BYTE                bReserved[128];                     // ֽ
} DHDEV_NET_CFG_EX;

// ddnsýṹ
typedef struct
{
    DWORD               dwId;                                           // ddnsid
    BOOL                bEnable;                                        // ʹܣͬһʱֻһddnsʹ״̬
    char                szServerType[DH_MAX_SERVER_TYPE_LEN];           // ͣϣ..
    char                szServerIp[DH_MAX_DOMAIN_NAME_LEN];             // ip
    DWORD               dwServerPort;                                   // ˿
    char                szDomainName[DH_MAX_DOMAIN_NAME_LEN];           // dvrjeckean.3322.org
    char                szUserName[DH_MAX_HOST_NAMELEN];                // û
    char                szUserPsw[DH_MAX_HOST_PSWLEN];                  // 
    char                szAlias[DH_MAX_DDNS_ALIAS_LEN];                 // 
    DWORD               dwAlivePeriod;                                  // DDNS ʱ
    BYTE                ByMode;                                         // ģʽ:0-ֶ,szDomainNameЧ; 1-ĬszDefaultDomainNameЧ
    char                szDefaultDomainName[DH_MAX_DEFAULT_DOMAIN_LEN]; // Ĭ,ֻ
    BYTE                bReserved[3];                                   // ֽڶ
    char                szEmailUserName[DH_MAX_MAIL_NAME_LEN];	        // û
    char                reserved[128];
} DH_DDNS_SERVER_CFG;

typedef struct
{
    DWORD                dwSize;
    DWORD                dwDdnsServerNum;    
    DH_DDNS_SERVER_CFG   struDdnsServer[DH_MAX_DDNS_NUM];    
} DHDEV_MULTI_DDNS_CFG;

// ʼýṹ
typedef struct 
{
    char                sMailIPAddr[DH_MAX_DOMAIN_NAME_LEN];    // ʼַ(IP)
    char                sSubMailIPAddr[DH_MAX_DOMAIN_NAME_LEN];
    WORD                wMailPort;                              // ʼ˿
    WORD                wSubMailPort;
    WORD                wReserved;                              // 
    char                sSenderAddr[DH_MAX_MAIL_ADDR_LEN];      // ͵ַ
    char                sUserName[DH_MAX_MAIL_NAME_LEN];        // û
    char                sUserPsw[DH_MAX_MAIL_NAME_LEN];         // û
    char                sDestAddr[DH_MAX_MAIL_ADDR_LEN];        // Ŀĵַ
    char                sCcAddr[DH_MAX_MAIL_ADDR_LEN];          // ͵ַ
    char                sBccAddr[DH_MAX_MAIL_ADDR_LEN];         // ַ
    char                sSubject[DH_MAX_MAIL_SUBJECT_LEN];      // 
    BYTE                bEnable;                                // ʹ0:false,    1:true
    BYTE                bSSLEnable;                             // SSLʹ
    WORD                wSendInterval;                          // ʱ,[0,3600]
    BYTE                bAnonymous;                             // ѡ[0,1], 0ʾFALSE,1ʾTRUE.
    BYTE                bAttachEnable;                          // ʹ[0,1], 0ʾFALSE,1ʾTRUE.
    char                reserved[154];
} DHDEV_MAIL_CFG;

// DNS
typedef struct  
{
    char                szPrimaryIp[DH_MAX_IPADDR_LEN];
    char                szSecondaryIp[DH_MAX_IPADDR_LEN];
    char                reserved[256];
} DHDEV_DNS_CFG;

// ¼ز
typedef struct
{
    DWORD               dwSize;
    BOOL                bEnable;                                // TRUEأFALSEͨ
}DHDEV_DOWNLOAD_STRATEGY_CFG;

// 紫
typedef struct
{
    DWORD               dwSize;
    BOOL                bEnable;
    int                 iStrategy;                              // 0ȣ1ȣ2Զ
}DHDEV_TRANSFER_STRATEGY_CFG;

// õʱز
typedef struct  
{
    int                 nWaittime;                              // ȴʱʱ(Ϊλ)Ϊ0Ĭ5000ms
    int                 nConnectTime;                           // ӳʱʱ(Ϊλ)Ϊ0Ĭ1500ms
    int                 nConnectTryNum;                         // ӳԴΪ0Ĭ1
    int                 nSubConnectSpaceTime;                   // ֮ĵȴʱ(Ϊλ)Ϊ0Ĭ10ms
    int                 nGetDevInfoTime;                        // ȡ豸Ϣʱʱ䣬Ϊ0Ĭ1000ms
    int                 nConnectBufSize;                        // ÿӽݻС(ֽΪλ)Ϊ0Ĭ250*1024
    int                 nGetConnInfoTime;                       // ȡϢʱʱ(Ϊλ)Ϊ0Ĭ1000ms
    int                 nSearchRecordTime;                      // ʱѯ¼ļĳʱʱ(Ϊλ),Ϊ0ĬΪ3000ms
    int                 nsubDisconnetTime;                      // Ӷߵȴʱ(Ϊλ)Ϊ0ĬΪ60000ms
    BYTE                byNetType;                              // , 0-LAN, 1-WAN
    BYTE                byPlaybackBufSize;                      // طݽջСMΪλΪ0ĬΪ4M
    BYTE                byReserved1[2];                         // 
    int                 nPicBufSize;                            // ʵʱͼƬջСֽΪλΪ0ĬΪ2*1024*1024
    BYTE                bReserved[4];                           // ֶֶ
} NET_PARAM;

// ӦCLIENT_SearchDevicesӿ
typedef struct 
{
    char                szIP[DH_MAX_IPADDR_LEN];                // IP
    int                 nPort;                                  // tcp˿
    char                szSubmask[DH_MAX_IPADDR_LEN];           // 
    char                szGateway[DH_MAX_IPADDR_LEN];           // 
    char                szMac[DH_MACADDR_LEN];                  // MACַ
    char                szDeviceType[DH_DEV_TYPE_LEN];          // 豸
    BYTE                byManuFactory;                          // Ŀ豸,οEM_IPC_TYPE
    BYTE                byIPVersion;                            // 4: IPv4, szXXXΪַʽ;  6:IPv6, szXXXΪ128λ(16ֽ)ֵʽ
    BYTE                bReserved[30];                          // ֽ
} DEVICE_NET_INFO;

// ӦCLIENT_StartSearchDevicesӿ
typedef struct 
{
    int                 iIPVersion;                             // 4 for IPV4, 6 for IPV6
    char                szIP[64];                               // IP IPV4"192.168.0.1" IPV6"2008::1/64"
    int                 nPort;                                  // tcp˿
    char                szSubmask[64];                          //  IPV6
    char                szGateway[64];                          // 
    char                szMac[DH_MACADDR_LEN];                  // MACַ
    char                szDeviceType[DH_DEV_TYPE_LEN];          // 豸
    BYTE                byManuFactory;                          // Ŀ豸,οEM_IPC_TYPE    
    BYTE                byDefinition;                           // 1- 2-
    bool                bDhcpEn;                                // Dhcpʹ״̬, true-, false-
    BYTE                byReserved1;                            // ֽڶ
    char                verifyData[88];                         // У ͨ첽صȡ(޸豸IPʱôϢУ)
    char                szSerialNo[DH_DEV_SERIALNO_LEN];        // к
    char                szDevSoftVersion[DH_MAX_URL_LEN];       // 豸汾    
    char                szDetailType[DH_DEV_TYPE_LEN];          // 豸ͺ
    char                szVendor[DH_MAX_STRING_LEN];            // OEMͻ
    char                szDevName[DH_MACHINE_NAME_NUM];         // 豸
    char                szUserName[DH_USER_NAME_LENGTH_EX];     // ½豸û޸豸IPʱҪд
    char                szPassWord[DH_USER_NAME_LENGTH_EX];     // ½豸루޸豸IPʱҪд
    unsigned short      nHttpPort;                              // HTTP˿ں
    WORD                wVideoInputCh;                          // Ƶͨ
    WORD                wRemoteVideoInputCh;                    // ԶƵͨ
    WORD                wVideoOutputCh;                         // Ƶͨ
    WORD                wAlarmInputCh;                          // ͨ
    WORD                wAlarmOutputCh;                         // ͨ
    char                cReserved[244];
}DEVICE_NET_INFO_EX;

// ӦCLIENT_SearchDevicesByIPsӿ
typedef struct
{
    DWORD               dwSize;                                 // ṹС
    int                 nIpNum;                                 // ǰIP
    char                szIP[DH_MAX_SAERCH_IP_NUM][64];         // IPϢ
}DEVICE_IP_SEARCH_INFO;

// struct SNMPýṹ
typedef struct
{
    BOOL                bEnable;                                // SNMPʹ
    int                 iSNMPPort;                              // SNMP˿
    char                szReadCommon[DH_MAX_SNMP_COMMON_LEN];   // ͬ
    char                szWriteCommon[DH_MAX_SNMP_COMMON_LEN];  // дͬ
    char                szTrapServer[64];                       // trapַ
    int                 iTrapPort;                              // trap˿
    BYTE                bSNMPV1;                                // 豸Ƿְ֧汾1ʽ0ʹܣ1ʹ
    BYTE                bSNMPV2;                                // 豸Ƿְ֧汾2ʽ0ʹܣ1ʹ
    BYTE                bSNMPV3;                                // 豸Ƿְ֧汾3ʽ0ʹܣ1ʹ
    char                szReserve[125];
}DHDEV_NET_SNMP_CFG;

// ISCSIṹ
typedef struct
{
    char                szServerName[32];                       // 
    union
    { 
        BYTE            c[4];
        WORD            s[2];
        DWORD           l;
    }                   stuIP;                                  // IPַ
    int                 nPort;                                  // ˿ں
    char                szUserName[32];                         // û
    char                szPassword[32];                         // 
    BOOL                bAnonymous;                             // Ƿ¼
}DHDEV_ISCSI_SERVER;

// ISCSIýṹ
typedef struct
{
    BOOL                bEnable;                                // ʹ
    DHDEV_ISCSI_SERVER  stuServer;                              // 
    char                szRemotePath[240];                      // ԶĿ¼
    BYTE                reserved[256];
}DHDEV_ISCSI_CFG;

//----------------------------------------------------------------

// ̨
typedef struct 
{
    int                 iType;
    int                 iValue;
} DH_PTZ_LINK, *LPDH_PTZ_LINK;

// ṹ
typedef struct 
{
    /* Ϣʽͬʱִʽ
     * 0x00000001 - ϴ
     * 0x00000002 - ¼
     * 0x00000004 - ̨
     * 0x00000008 - ʼ
     * 0x00000010 - Ѳ
     * 0x00000020 - ʾ
     * 0x00000040 - 
     * 0x00000080 - Ftpϴ
     * 0x00000100 - 
     * 0x00000200 - ʾ
     * 0x00000400 - ץͼ
    */


    DWORD               dwActionMask;                           // ǰֵ֧Ĵʽλʾ 
    DWORD               dwActionFlag;                           // λʾ嶯ҪĲڸԵ 
    BYTE                byRelAlarmOut[DH_MAX_ALARMOUT_NUM];     // ͨΪ1ʾ 
    DWORD               dwDuration;                             // ʱ 
    BYTE                byRecordChannel[DH_MAX_VIDEO_IN_NUM];   // ¼ͨΪ1ʾͨ 
    DWORD               dwRecLatch;                             // ¼ʱ 
    BYTE                bySnap[DH_MAX_VIDEO_IN_NUM];            // ץͼͨ 
    BYTE                byTour[DH_MAX_VIDEO_IN_NUM];            // Ѳͨ 
    DH_PTZ_LINK         struPtzLink[DH_MAX_VIDEO_IN_NUM];       // ̨ 
    DWORD               dwEventLatch;                           // ʼʱʱ䣬sΪλΧ0~15Ĭֵ0 
    BYTE                byRelWIAlarmOut[DH_MAX_ALARMOUT_NUM];   // ͨΪ1ʾ 
    BYTE                bMessageToNet;
    BYTE                bMMSEn;                                 // űʹ
    BYTE                bySnapshotTimes;                        // ŷץͼ 
    BYTE                bMatrixEn;                              // ʹ 
    DWORD               dwMatrix;                               //            
    BYTE                bLog;                                   // ־ʹܣĿǰֻWTN̬ʹ 
    BYTE                bSnapshotPeriod;                        // ץͼ֡ÿ֡ץһͼƬһʱץĵץͼ֡йء0ʾ֡ץ
    BYTE                byEmailType;                            // 0ͼƬ1¼񸽼
    BYTE                byEmailMaxLength;                       // ¼ʱ󳤶ȣλMB
    BYTE                byEmailMaxTime;                         // ¼ʱʱ䳤ȣλ
    BYTE                byReserved[99];   
} DH_MSG_HANDLE;

// ⲿ
typedef struct
{
    BYTE                byAlarmType;                            // ͣ0գ1
    BYTE                byAlarmEn;                              // ʹ
    BYTE                byReserved[2];                        
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT];     //NSP
    DH_MSG_HANDLE       struHandle;                             // ʽ
} DH_ALARMIN_CFG, *LPDHDEV_ALARMIN_CFG; 

// ̬ⱨ
typedef struct 
{
    BYTE                byMotionEn;                             // ̬ⱨʹ
    BYTE                byReserved;
    WORD                wSenseLevel;                            // 
    WORD                wMotionRow;                             // ̬
    WORD                wMotionCol;                             // ̬
    BYTE                byDetected[DH_MOTION_ROW][DH_MOTION_COL]; // 32*32
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT];     //NSP
    DH_MSG_HANDLE       struHandle;                             //ʽ
} DH_MOTION_DETECT_CFG;

// Ƶʧ
typedef struct
{
    BYTE                byAlarmEn;                              // Ƶʧʹ
    BYTE                byReserved[3];
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT];     //NSP
    DH_MSG_HANDLE       struHandle;                             // ʽ
} DH_VIDEO_LOST_CFG;

// ͼڵ
typedef struct
{
    BYTE                byBlindEnable;                          // ʹ
    BYTE                byBlindLevel;                           // 1-6
    BYTE                byReserved[2];
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT];     // NSP
    DH_MSG_HANDLE       struHandle;                             // ʽ
} DH_BLIND_CFG;

// ӲϢ(ڲ)
typedef struct 
{
    BYTE                byNoDiskEn;                             // Ӳʱ
    BYTE                byReserved_1[3];
    DH_TSECT            stNDSect[DH_N_WEEKS][DH_N_REC_TSECT];   // NSP
    DH_MSG_HANDLE       struNDHandle;                           // ʽ
    BYTE                byLowCapEn;                             // Ӳ̵ʱ
    BYTE                byLowerLimit;                           // ֵ0-99
    BYTE                byReserved_2[2];
    DH_TSECT            stLCSect[DH_N_WEEKS][DH_N_REC_TSECT];   // NSP
    DH_MSG_HANDLE       struLCHandle;                           // ʽ
    BYTE                byDiskErrEn;                            // Ӳ̹ϱ
    BYTE                bDiskNum;
    BYTE                byReserved_3[2];
    DH_TSECT            stEDSect[DH_N_WEEKS][DH_N_REC_TSECT];   //NSP
    DH_MSG_HANDLE       struEDHandle;                           // ʽ
} DH_DISK_ALARM_CFG;

typedef struct
{
    BYTE                byEnable;
    BYTE                byReserved[3];
    DH_MSG_HANDLE       struHandle;
} DH_NETBROKEN_ALARM_CFG;

// 
typedef struct
{
    DWORD dwSize;
    DH_ALARMIN_CFG          struLocalAlmIn[DH_MAX_ALARM_IN_NUM];
    DH_ALARMIN_CFG          struNetAlmIn[DH_MAX_ALARM_IN_NUM];
    DH_MOTION_DETECT_CFG    struMotion[DH_MAX_VIDEO_IN_NUM];
    DH_VIDEO_LOST_CFG       struVideoLost[DH_MAX_VIDEO_IN_NUM];
    DH_BLIND_CFG            struBlind[DH_MAX_VIDEO_IN_NUM];
    DH_DISK_ALARM_CFG       struDiskAlarm;
    DH_NETBROKEN_ALARM_CFG  struNetBrokenAlarm;
} DHDEV_ALARM_SCHEDULE;

#define DECODER_OUT_SLOTS_MAX_NUM        16
#define DECODER_IN_SLOTS_MAX_NUM         16

// 
typedef struct  
{
    DWORD               dwAddr;                                     // ַ
    BOOL                bEnable;                                    // ʹ
    DWORD               dwOutSlots[DECODER_OUT_SLOTS_MAX_NUM];      // ֻ֧8.
    int                 nOutSlotNum;                                // dwOutSlotsЧԪظ.
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT];
    DH_MSG_HANDLE       struHandle[DECODER_IN_SLOTS_MAX_NUM];       // ֻ֧8.
    int                 nMsgHandleNum;                              // stuHandleЧԪظ.
    BYTE                bReserved[120];
} DH_ALARMDEC_CFG;

// ϴ
typedef struct  
{
    BYTE                byEnable;                                   // ϴʹ
    BYTE                bReserverd;                                 // 
    WORD                wHostPort;                                  // ˿
    char                sHostIPAddr[DH_MAX_IPADDR_LEN];             // IP
    int                 nByTimeEn;                                  // ʱϴʹܣϴIP
    int                 nUploadDay;                                 /* ϴ    
                                                                       "Never = 0", "Everyday = 1", "Sunday = 2", 
                                                                       "Monday = 3", Tuesday = 4", "Wednesday = 5",
                                                                       "Thursday = 6", "Friday = 7", "Saturday = 8"*/    
    int                 nUploadHour;                                // ϴʱ ,[0~23]
    DWORD               dwReserved[300];                            // չ
} ALARMCENTER_UP_CFG;

// ȫл
typedef struct __DH_PANORAMA_SWITCH_CFG 
{
    BOOL                bEnable;                                    // ʹ
    int                 nReserved[5];                               // 
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT];
    DH_MSG_HANDLE       struHandle;                                 // 
} DH_PANORAMA_SWITCH_CFG;

typedef struct __ALARM_PANORAMA_SWITCH_CFG 
{
    int                    nAlarmChnNum;                            // ͨ
    DH_PANORAMA_SWITCH_CFG stuPanoramaSwitch[DH_MAX_VIDEO_IN_NUM];
} ALARM_PANORAMA_SWITCH_CFG;

// ʧȥ㱨
typedef struct __DH_LOST_FOCUS_CFG
{
    BOOL                bEnable;                                    // ʹ
    int                 nReserved[5];                               // 
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT];
    DH_MSG_HANDLE       struHandle;                                 // 
} DH_LOST_FOCUS_CFG;

typedef struct __ALARM_LOST_FOCUS_CFG 
{
    int                 nAlarmChnNum;                               // ͨ
    DH_LOST_FOCUS_CFG   stuLostFocus[DH_MAX_VIDEO_IN_NUM];
} ALARM_LOST_FOCUS_CFG;

// IPͻⱨ
typedef struct __ALARM_IP_COLLISION_CFG
{
    BOOL                bEnable;                                    // ʹ
    DH_MSG_HANDLE       struHandle;                                 // 
    int                 nReserved[300];                             // 
} ALARM_IP_COLLISION_CFG;

// MACͻ
typedef struct __ALARM_MAC_COLLISION_CFG
{
    BOOL                bEnable;                                    // ʹ
    DH_MSG_HANDLE       struHandle;                                 // 
    int                 nReserved[300];                             // 
} ALARM_MAC_COLLISION_CFG;

// 232ڿźš485ڿź¼
typedef struct __COM_CARD_SIGNAL_INFO
{
    WORD                wCardStartPose;                             // ʼλ
    WORD                wCardLenth;                                 // ų
    char                cStartCharacter[32];                        // ʼ
    char                cEndCharacter[32];                          // 
    BYTE                byReserved[28];                             // ֶ 
}COM_CARD_SIGNAL_INFO;

// 232ڿźš485ڿź(ڴڷĿϢõĿϢ󣬽豸ץͼ)
typedef struct __COM_CARD_SIGNAL_LINK_CFG
{
    COM_CARD_SIGNAL_INFO  struCardInfo;                             // Ϣ
    DH_MSG_HANDLE         struHandle;                               // ¼
    BYTE                  byReserved[24];                           // ֶ

}COM_CARD_SIGNAL_LINK_CFG;

//------------------------------ڵ--------------------------------

// ڵϢ
typedef struct __VIDEO_COVER_ATTR
{
    DH_RECT             rcBlock;                                    // ǵ
    int                 nColor;                                     // ǵɫ
    BYTE                bBlockType;                                 // Ƿʽ0ڿ飬1
    BYTE                bEncode;                                    // 뼶ڵ1Ч0Ч
    BYTE                bPriview;                                   // Ԥڵ 1Ч0Ч
    char                reserved[29];                               // 
} VIDEO_COVER_ATTR;

// ڵ
typedef struct __DHDEV_VIDEOCOVER_CFG 
{
    DWORD               dwSize;
    char                szChannelName[DH_CHAN_NAME_LEN];            // ֻ
    BYTE                bTotalBlocks;                               // ֵ֧ڵ
    BYTE                bCoverCount;                                // õڵ
    VIDEO_COVER_ATTR    CoverBlock[DH_MAX_VIDEO_COVER_NUM];         // ǵ    
    char                reserved[30];                               // 
}DHDEV_VIDEOCOVER_CFG;

// 豸Ľ
typedef struct __DHDEV_DECODEPOLICY_CFG 
{
    int                 nMinTime;                                   // 뻺ʱ䷶Χ(ֻ)Сʱ(λms)
    int                 nMaxTime;                                   // 뻺ʱ䷶Χ(ֻ)󻺳ʱ(λms)
    int                 nDeocdeBufTime;                             // Ŀ豸뻺ʱ(λms)
    char                reserved[128];                              // 
}DHDEV_DECODEPOLICY_CFG;

// ص
typedef struct __DHDEV_MACHINE_CFG 
{
    char                szMachineName[DH_MACHINE_NAME_NUM];         // ƻ
    char                szMachineAddress[DH_MACHINE_NAME_NUM];      // ص
    char                reserved[128];                              // 
}DHDEV_MACHINE_CFG;

////////////////////////////////IPCƷ֧////////////////////////////////

// Ϣ
typedef struct 
{
    int                 nEnable;                    // ʹ
    char                szSSID[36];                 // SSID
    int                 nLinkMode;                  // ģʽ0auto1adhoc2Infrastructure
    int                 nEncryption;                // ܣ0off2WEP64bit3WEP128bit, 4:WPA-PSK-TKIP, 5: WPA-PSK-CCMP
    int                 nKeyType;                   // 0Hex1ASCII
    int                 nKeyID;                     // 
    union
    {
        char            szKeys[4][32];              // 
        char            szWPAKeys[128];             // nEncryptionΪ45ʱʹã128ȣý
    };
    int                 nKeyFlag;
    BYTE                byConnectedFlag;            // 0: , 1:  
    char                reserved[11];
} DHDEV_WLAN_INFO;

// ѡʹĳ豸
typedef struct  
{
    char                szSSID[36];
    int                 nLinkMode;                  // ģʽ0adhoc1Infrastructure
    int                 nEncryption;                // ܣ0off2WEP64bit3WEP128bit
    char                reserved[48];
} DHDEV_WLAN_DEVICE;

// 豸б
typedef struct  
{
    DWORD               dwSize;
    BYTE                bWlanDevCount;              // 豸
    DHDEV_WLAN_DEVICE   lstWlanDev[DH_MAX_WLANDEVICE_NUM];
    char                reserved[255];
} DHDEV_WLAN_DEVICE_LIST;

// 豸չ
typedef struct
{
    char                szSSID[36];                         // 
    char                szMacAddr[18];                      // macַ
    BYTE                byApConnected;                      // Ƿӳɹ 0:ûУ1: ӳɹ
    BYTE                byLinkMode;                         // ģʽ 0:adhoc 1:Infrastructure;
    int                 nRSSIQuality;                       // źǿ(dbm)
    unsigned int        unApMaxBitRate;                     // վ
    BYTE                byAuthMode;                         // ֤ģʽ0:OPEN;1:SHARED;2:WPA;3:WPA-PSK;4:WPA2;5:WPA2-PSK;
                                                            // 6:WPA-NONE(adhocģʽ),
                                                            // 7-11ǻģʽѡκһֶԽ 
                                                            // 7:WPA-PSK | WPA2-PSK; 8:WPA | WPA2; 9:WPA | WPA-PSK;
                                                            // 10:WPA2 | WPA2-PSK; 11:WPA | WPA-PSK |WPA2 |WPA2-PSK //12: UnKnown
    BYTE                byEncrAlgr;                         // ģʽ0:off; 2:WEP64bit; 3:WEP128bit; 4:WEP; 5:TKIP; 6:AES(CCMP)
                                                            // 7: TKIP+AES(ģʽ) 8: UnKnown
    BYTE                byLinkQuality;                      // ǿ 0~100(%)
    BYTE                byReserved[129];                    // Reserved 
}DHDEV_WLAN_DEVICE_EX;

// 豸չб
typedef struct  
{
    DWORD               dwSize;
    BYTE                bWlanDevCount;            // 豸
    DHDEV_WLAN_DEVICE_EX  lstWlanDev[DH_MAX_WLANDEVICE_NUM_EX];
    char                reserved[255];
} DHDEV_WLAN_DEVICE_LIST_EX;

//Ч
typedef struct
{
    int                 nResult;                  // 0ʾóɹ1ʾʧ
    BYTE                reserved[32];
} DHDEV_FUNC_TEST;

// FTPϢ
typedef struct
{
    char                szServerName[32];          // 
    char                szIp[16];                  // IPַ
    int                 nPort;                     // ˿ں
    char                szUserName[32];            // û
    char                szPassword[32];            // 
    BOOL                bAnonymity;                // Ƿ¼
    BYTE                byReserved[256];           // ֽ
}FTP_SERVER_CFG;

// ftpӲ
typedef struct
{
    FTP_SERVER_CFG     stuFtpServerInfo;           // ftpϢûд
    DHDEV_FUNC_TEST    stuTestResult;              // ftp״̬(豸)
    BYTE               byReserved[64];
}DHDEV_FTP_SERVER_TEST;

// DDNSϢ
typedef struct
{

    char                szServerType[DH_MAX_SERVER_TYPE_LEN];   // ͣϣ..
    char                szServerIp[DH_MAX_DOMAIN_NAME_LEN];     // ip
    DWORD               dwServerPort;                           // ˿
    char                szDomainName[DH_MAX_DOMAIN_NAME_LEN];   // dvrjeckean.3322.org
    char                szUserName[DH_MAX_HOST_NAMELEN];        // û
    char                szUserPsw[DH_MAX_HOST_PSWLEN];          // 
    BYTE                byReserved[256];                        // ֽ
}DDNS_DOMAIN_INFO;


// DDNSǷò
typedef struct
{
    DDNS_DOMAIN_INFO   stuDomainInfo;                           // DDNSϢûд
    DHDEV_FUNC_TEST    stuTestResult;                           // Խ
    char               szMemo[128];                             // Խ
    BYTE               byReserved[64];
}DHDEV_DDNS_DOMAIN_TEST;


//ʾӲ̵ĻϢ
typedef struct 
{
    BYTE                byModle[32];                  // ͺ
    BYTE                bySerialNumber[32];           // к
    BYTE                byFirmWare[32];               // ̼
    int                 nAtaVersion;                  // ATAЭ汾
    int                 nSmartNum ;                   // smart Ϣ
    INT64               Sectors;    
    int                 nStatus;                      // ״̬ 0- 1-쳣
    int                 nReserved[33];                // ֽ
} DHDEV_DEVICE_INFO;

//Ӳ̵smartϢܻкܶ಻30
typedef struct
{
    BYTE    byId;               // ID
    BYTE    byCurrent;          // ֵ
    BYTE    byWorst;            // ֵ
    BYTE    byThreshold;        // ֵ
    char    szName[64];         // 
    char    szRaw[8];           // ʵֵ
    int     nPredict;           // ״̬
    char    reserved[128];
} DHDEV_SMART_VALUE;

//ӲsmartϢѯ
typedef struct
{
    BYTE                nDiskNum;                       // Ӳ̺
    BYTE                byRaidNO;                       // Raiḍ0ʾ
    BYTE                byReserved[2];                  // ֽ
    DHDEV_DEVICE_INFO   deviceInfo;
    DHDEV_SMART_VALUE   smartValue[MAX_SMART_VALUE_NUM];
} DHDEV_SMART_HARDDISK;

// ģϢ
typedef struct
{
    char               szModuleName[64];      //  ģ
    char               szHardWareVersion[32]; //  ģӲ汾
    char               szSoftwareVersion[32]; //  ģ汾
    BYTE               reserved[128]; 
} DHDEV_SUBMODELE_VALUE;

// ѯ豸ģϢ
typedef struct
{
    int                    nSubModuleNum;                         //  ģ
    DHDEV_SUBMODELE_VALUE  stuSubmoduleValue[MAX_SUBMODULE_NUM];  //  ģϸϢ
    BYTE                   bReserved[256];
} DHDEV_SUBMODULE_INFO;

// ѯӲ̻
typedef struct
{
    BYTE                bDiskDamageLevel[DH_MAX_DISK_NUM];  //̻ȼ
    BYTE                bReserved[128];
} DHDEV_DISKDAMAGE_INFO;


// syslogԶ̷
typedef struct 
{
    char    szServerIp[DH_MAX_IPADDR_OR_DOMAIN_LEN];    //ַ
    int     nServerPort;                                //˿
    BYTE    bEnable;                                    //ʹ
    BYTE    bReserved[255];                             //ֽ
}DHDEV_SYSLOG_REMOTE_SERVER;

// Ƶ
typedef struct
{
    BYTE    backupVideoFormat;                  // ļ, 0:dav, 1:asf
    BYTE    password[6];                        // 
    BYTE    reversed[505];
}DHDEV_BACKUP_VIDEO_FORMAT;


// ע
typedef struct  
{
    char                szServerIp[32];             // עIP
    int                 nServerPort;                // ˿ں
    BYTE                byReserved[3];              // 
    BYTE                bServerIpExEn;              // עIPչʹ,0-ʾЧ, 1-ʾЧ
    char                szServerIpEx[60];           // עIPչ֧ipv4,ipv6,͵IP
} DHDEV_SERVER_INFO;

typedef struct  
{
    DWORD               dwSize;
    BYTE                bServerNum;                 // ֵ֧ip
    DHDEV_SERVER_INFO   lstServer[DH_MAX_REGISTER_SERVER_NUM];
    BYTE                bEnable;                    // ʹ
    char                szDeviceID[32];             // 豸id
    char                reserved[94];
} DHDEV_REGISTER_SERVER;

// ͷ
typedef struct __DHDEV_CAMERA_INFO
{
    BYTE                bBrightnessEn;              // ȿɵ1ɣ0
    BYTE                bContrastEn;                // Աȶȿɵ
    BYTE                bColorEn;                   // ɫȿɵ
    BYTE                bGainEn;                    // ɵ
    BYTE                bSaturationEn;              // Ͷȿɵ
    BYTE                bBacklightEn;               // ⲹ 0ʾֱ֧ⲹ,1ʾ֧һ,أ2ʾ֧,,ͣ3ʾ֧,,,ͣ
    BYTE                bExposureEn;                // عѡ: 0:ʾ֧ع 1:ʾֻ֧Զع n:عĵȼ(1ʾ֧Զع 2~nʾֵֶ֧عĵȼ)
    BYTE                bColorConvEn;               // Զʺתɵ
    BYTE                bAttrEn;                    // ѡ1ɣ0
    BYTE                bMirrorEn;                  // 1֧֣0֧
    BYTE                bFlipEn;                    // ת1֧֣0֧
    BYTE                iWhiteBalance;              // ƽ 0-ְ֧ƽ⣬1-֧Զƽ⣬2-֧Ԥðƽ⣨龰ģʽ 3-֧Զƽ
    BYTE                iSignalFormatMask;          // źŸʽ룬λӵ͵λֱΪ0-Inside(ڲ) 1- BT656 2-720p 3-1080i  4-1080p  5-1080sF
    BYTE                bRotate90;                  // 90ת 0-֧ 1-֧
    BYTE                bLimitedAutoExposure;       // Ƿִ֧ʱ޵Զع
    BYTE                bCustomManualExposure;      // Ƿ֧ûԶֶعʱ
    BYTE                bFlashAdjustEn;             // Ƿ֧Ƶ
    BYTE                bNightOptions;              // Ƿ֧ҹѡ
    BYTE                iReferenceLevel;            // Ƿֲ֧οƽ
    BYTE                bExternalSyncInput;         // Ƿ֧ⲿͬź룬0-֧֣1-֧
    unsigned short      usMaxExposureTime;          // Զععʱ䣬λ         
    unsigned short      usMinExposureTime;          // ԶعСعʱ䣬λ
    BYTE                bWideDynamicRange;          // ̬Χ,0-ʾ֧,2~nʾķΧֵ
    BYTE                bDoubleShutter;             // ˫0֧,1-֧˫ȫ֡ʣͼƵֻпŲͬ2-֧˫Ű֡ʣͼƵżƽͬ3-֧˫ȫ֡ʺͰ֡
    BYTE                byExposureCompensation;     // 1֧֣ 0 ֧
    BYTE                bRev[109];                  // 
} DHDEV_CAMERA_INFO;

//ҹѡϹ߽ϰʱԶлҹò
typedef struct __DHDEV_NIGHTOPTIONS 
{
    BYTE  bEnable;                                  // 0-л1-л 
                                                    // ճʱ䣬֮ճ֮ǰҹá
                                                    // 00:00:00 ~23:59:59
    BYTE  bSunriseHour;
    BYTE  bSunriseMinute;
    BYTE  bSunriseSecond;
    BYTE  bSunsetHour;
    BYTE  bSunsetMinute;
    BYTE  bSunsetSecond;  
    BYTE  bWhiteBalance ;                           // ƽ 0:Disabled,1:Auto 2:sunny 3:cloudy 4:home 5:office 6:night 7: Custom
    BYTE  bGainRed;                                 // ɫڣƽΪ"Custom"ģʽЧ 0~100
    BYTE  bGainBlue;                                // ɫڣƽΪ"Custom"ģʽЧ 0~100
    BYTE  bGainGreen;                               // ɫڣƽΪ"Custom"ģʽЧ 0~100
    BYTE  bGain;                                    // 0~100
    BYTE  bGainAuto;                                // 0-Զ 1-Զ
    BYTE  bBrightnessThreshold ;                    // ֵ 0~100
    BYTE  ReferenceLevel;                           // ƽοֵ 0~100   
    BYTE  bExposureSpeed;                           // ȡֵΧȡ豸0-Զع 1~n-1-ֶعȼ n-ʱ޵Զع n+1-Զʱֶع (nʾֵ֧عȼ
    float ExposureValue1;                           // Զعʱ޻ֶعԶʱ,Ϊλȡֵ0.1ms~80ms
    float ExposureValue2;                           // Զعʱ,Ϊλȡֵ0.1ms~80ms
    BYTE  bAutoApertureEnable;                      // ԶȦʹ,1,0ر
    BYTE  bWideDynamicRange;                        // ֵ̬     ȡֵΧ
    WORD  wNightSyncValue;                          // ҹλ 0~360
    WORD  wNightSyncValueMillValue;                 // ҹλ0~999(ǧ֮һ),wNightSyncValueϹҹλֵ
    BYTE res[10];                                   // 
} DHDEV_NIGHTOPTIONS;

// ͷ
typedef struct __DHDEV_CAMERA_CFG 
{
    DWORD                dwSize;
    BYTE                bExposure;                  // عģʽȡֵΧȡ豸0-Զع⣬1-عȼ12-عȼ2n-1عȼ nʱ޵Զع n+1Զʱֶع (n==bExposureEn
    BYTE                bBacklight;                 // ⲹⲹȼȡֵΧȡ豸0-رգ1-ⲹǿ12-ⲹǿ2n-󱳹ⲹȼ 
    BYTE                bAutoColor2BW;              // /ҹģʽ3-ʱԶл 2(ڰ)1л0(ɫ)
    BYTE                bMirror;                    // 10
    BYTE                bFlip;                      // ת10
    BYTE                bLensEn;                    // ԶȦ: 1֧֣0 ֧
    BYTE                bLensFunction;              // ԶȦ: 1:ԶȦ0: رԶȦ
    BYTE                bWhiteBalance;              // ƽ 0:Disabled,1:Auto 2:sunny 3:cloudy 4:home 5:office 6:night 7: Custom
    BYTE                bSignalFormat;              // źŸʽ0-Inside(ڲ) 1- BT656 2-720p 3-1080i  4-1080p  5-1080sF
    BYTE                bRotate90;                  // 0-ת1-˳ʱ90㣬2-ʱ90
    BYTE                bReferenceLevel;            // ƽοֵ 0~100  
    BYTE                byReserve;                  // 
    float               ExposureValue1;             // Զعʱ޻ֶعԶʱ,Ϊλȡֵ0.1ms~80ms
    float               ExposureValue2;             // Զعʱ,Ϊλȡֵ0.1ms~80ms    
    DHDEV_NIGHTOPTIONS  stuNightOptions;            // ҹòѡ 
    BYTE                bGainRed;                   // ɫڣƽΪ"Custom"ģʽЧ 0~100
    BYTE                bGainBlue;                  // ɫڣƽΪ"Custom"ģʽЧ 0~100
    BYTE                bGainGreen;                 // ɫڣƽΪ"Custom"ģʽЧ 0~100
    BYTE                bFlashMode;                 // ƹģʽ0-رգ1-ʼգ2-Զ
    BYTE                bFlashValue;                // ƹֵ, 0-0us, 1-64us, 2-128us,...15-960us
    BYTE                bFlashPole;                 // ƴģʽ0-͵ƽ 1-ߵƽ
    BYTE                bExternalSyncPhase;         // ⲿͬź,0-ڲͬ 1-ⲿͬ
    BYTE                bFlashInitValue;            // Ԥֵ  0~100
    WORD                wExternalSyncValue ;        // ͬλ 0~360(С3λЧ)
    WORD                wExternalSyncValueMillValue;//  ͬλ0~999(ǧ֮һ),wExternalSyncValueϹͬλֵ
    BYTE                bWideDynamicRange;          //ֵ̬     ȡֵΧ
    BYTE                byExposureCompensation;     // عⲹֵĬΪ7Χ0~14
    char                bRev[54];                   // 
} DHDEV_CAMERA_CFG;

#define ALARM_MAX_NAME 64
// ()ⱨ
typedef struct
{
    BOOL                bEnable;                            // ʹ
    char                szAlarmName[DH_MAX_ALARM_NAME];     // 
    int                 nAlarmInPattern;                    // 벨
    int                 nAlarmOutPattern;                   // 
    char                szAlarmInAddress[DH_MAX_ALARM_NAME];// ַ
    int                 nSensorType;                        // ⲿ豸ͳ or 
    int                 nDefendEfectTime;                   // ʱʱ䣬ڴʱñЧ
    int                 nDefendAreaType;                    //  
    int                 nAlarmSmoothTime;                   // ƽʱ䣬ڴʱֻһԵһ
    char                reserved[128];
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT];
    DH_MSG_HANDLE       struHandle;                         // ʽ
} DH_INFRARED_INFO;

// ң
typedef struct 
{
    BYTE                address[ALARM_MAX_NAME];        // ңַ
    BYTE                name[ALARM_MAX_NAME];           // ң
    BYTE                reserved[32];                   // ֶ
} DH_WI_CONFIG_ROBOT;

// ߱
typedef struct 
{
    BYTE                address[ALARM_MAX_NAME];        // ַ
    BYTE                name[ALARM_MAX_NAME];           // 
    BYTE                reserved[32];                   // ֶ
} DH_WI_CONFIG_ALARM_OUT;

typedef struct  
{
    DWORD                   dwSize;
    BYTE                    bAlarmInNum;                // ߱
    BYTE                    bAlarmOutNum;               // ߱
    DH_WI_CONFIG_ALARM_OUT  AlarmOutAddr[16];           // ַ
    BYTE                    bRobotNum;                  // ң
    DH_WI_CONFIG_ROBOT      RobotAddr[16];              // ңַ
    DH_INFRARED_INFO        InfraredAlarm[16];
    char                    reserved[256];
} DH_INFRARED_CFG;

// ƵⱨϢ
typedef struct
{
    int                 channel;                        // ͨ
    int                 alarmType;                      // ͣ0Ƶֵͣ1Ƶֵ
    unsigned int        volume;                         // ֵ
    BYTE                byState;                        // Ƶ״̬, 0: Ƶ, 1: Ƶʧ
    char                reserved[255];
} NET_NEW_SOUND_ALARM_STATE;

typedef struct  
{
    int                         channelcount;           // ͨ
    NET_NEW_SOUND_ALARM_STATE   SoundAlarmInfo[DH_MAX_ALARM_IN_NUM];
} DH_NEW_SOUND_ALARM_STATE;

// ץͼԽṹ
typedef struct 
{
    int                 nChannelNum;                // ͨ
    DWORD               dwVideoStandardMask;        // ֱ(λ)鿴öCAPTURE_SIZE                        
    int                 nFramesCount;               // Frequence[128]Ч
    char                Frames[128];                // ֡(ֵ)
                                                    // -25251֡-24241֡-23231֡-22221֡
                                                    // 
                                                    // 0Ч111֡212֡313֡
                                                    // 414֡515֡17117֡18118֡
                                                    // 19119֡20120֡
                                                    // 
                                                    // 25: 125֡
    int                 nSnapModeCount;             // SnapMode[16]Ч
    char                SnapMode[16];               // (ֵ)0ʱץͼ1ֶץͼ
    int                 nPicFormatCount;            // Format[16]Ч
    char                PictureFormat[16];          // (ֵ)0BMPʽ1JPGʽ
    int                 nPicQualityCount;           // Quality[32]Ч
    char                PictureQuality[32];         // ֵ
                                                    // 100ͼ100%80:ͼ80%60:ͼ60%
                                                    // 50:ͼ50%30:ͼ30%10:ͼ10%
    char                nReserved[128];             // 
} DH_QUERY_SNAP_INFO;

typedef struct 
{
    int                 nChannelCount;              // ͨ
    DH_QUERY_SNAP_INFO  stuSnap[DH_MAX_CHANNUM];
} DH_SNAP_ATTR_EN;


/* IP˹ */
#define DH_IPIFILTER_NUM            200             // IP
#define DH_IPIFILTER_NUM_EX         512             // IP

// IPϢ
typedef struct 
{
    DWORD               dwIPNum;                                    // IP
    char                SZIP[DH_IPIFILTER_NUM][DH_MAX_IPADDR_LEN];  // IP
    char                byReserve[32];                              // 
} IPIFILTER_INFO;

// IPýṹ
typedef struct
{
    DWORD               dwSize;
    DWORD               dwEnable;                   // ʹ
    DWORD               dwType;                     // ǰͣ0 1豸ֻʹһЧǰǺ
    IPIFILTER_INFO      BannedIP;                   // 
    IPIFILTER_INFO      TrustIP;                    // 
    char                byReserve[256];             // 
} DHDEV_IPIFILTER_CFG;

// IPϢչ
typedef struct 
{
    DWORD               dwIPNum;                                        // IP
    char                SZIP[DH_IPIFILTER_NUM_EX][DH_MAX_IPADDR_LEN];   // IP
    char                byReserve[32];                                  // 
} IPIFILTER_INFO_EX;

// IPýṹչ
typedef struct
{
    DWORD                dwSize;
    DWORD                dwEnable;                  // ʹ
    DWORD                dwType;                    // ǰͣ0 1豸ֻʹһЧǰǺ
    IPIFILTER_INFO_EX    BannedIP;                  // 
    IPIFILTER_INFO_EX    TrustIP;                   // 
    char                 byReserve[256];            // 
} DHDEV_IPIFILTER_CFG_EX;

/* MAC */
#define DH_MACFILTER_NUM            512             // MAC

// MACϢ
typedef struct 
{
    DWORD                dwSize;                                    // ʹʱóʼΪṹС
    DWORD                dwMacNum;                                  // MAC
    char                 szMac[DH_MACFILTER_NUM][DH_MACADDR_LEN];   // MAC
} MACFILTER_INFO;

// MACýṹ
typedef struct
{
    DWORD                 dwSize;                   // ʹʱóʼΪṹС
    DWORD                 dwEnable;                 // ʹ
    DWORD                 dwType;                   // ǰͣ0 1豸ֻʹһЧǰǺ
    MACFILTER_INFO        stuBannedMac;             // Mac
    MACFILTER_INFO        stuTrustMac;              // Mac
} DHDEV_MACFILTER_CFG;

/* MAC,IP */
#define DH_MACIPFILTER_NUM           512            // MAC,IP

// MACIPϢ
typedef struct
{
    DWORD       dwSize;                             // ʹʱóʼΪṹС
    char        szMac[DH_MACADDR_LEN];              // mac
    char        szIp[DH_MAX_IPADDR_LEN];            // ip
}MACIP_INFO;

// MAC,IPýṹ
typedef struct
{
    DWORD                    dwSize;                                // ʹʱóʼΪṹС
    DWORD                    dwEnable;                              // ʹ
    DWORD                    dwType;                                // ǰͣ0 1豸ֻʹһЧǰǺ
    DWORD                    dwBannedMacIpNum;                      // MAC,IP(MAC,IPһһӦ)
    MACIP_INFO               stuBannedMacIp[DH_MACIPFILTER_NUM];    // Mac,IP
    DWORD                    dwTrustMacIpNum;                       // MAC,IP(MAC,IPһһӦ)
    MACIP_INFO               stuTrustMacIp[DH_MACIPFILTER_NUM];     // Mac,IP
} DHDEV_MACIPFILTER_CFG;

typedef struct
{
    int                nCardNum;                                        // Ч
    char               cardInfo [DH_MAX_CARD_NUM][DH_MAX_CARDINFO_LEN]; // Ϣַ 
    BYTE               byReserve[32];                                   // ֶ
}DHDEV_NETCARD_CFG;

// RTSP 
typedef struct
{
    WORD               wPort;                  // ˿ں
    BYTE               byReserved[62];         // ֶ
}DHDEV_RTSP_CFG;

//----------------------------------
// ԿϢ36ֽ
typedef struct _ENCRYPT_KEY_INFO
{
    BYTE        byEncryptEnable;       //  Ƿ0:, 1:
    BYTE        byReserved[3]; 
    union
    {
        BYTE    byDesKey[8];           // desԿ
        BYTE    by3DesKey[3][8];       // 3desԿ
        BYTE    byAesKey[32];          // aesԿ

    };
}ENCRYPT_KEY_INFO;

// 㷨
typedef struct _ALGO_PARAM_INFO
{
    WORD       wEncryptLenth;       // ԿȣǰΪAES㷨ʱʾԿλ(Ŀǰ֧128192256λ, : wEncryptLenthΪ128ԿϢENCRYPT_KEY_INFObyAesKey[0]~[15])
                                    // ΪDES㷨ʱԿȹ̶Ϊ64λ
                                    // Ϊ3DES㷨ʱʾԿĸ(23Կ)
    BYTE       byAlgoWorkMode ;     // ģʽ,οö EM_ENCRYPT_ALOG_WORKMODE 
    BYTE       reserved[13];        // ֶ
}ALGO_PARAM_INFO;

// Ϣ
typedef struct _DHEDV_STREAM_ENCRYPT
{
    BYTE                    byEncrptAlgoType;           // 㷨ͣ00: AES01:DES02: 3DES
    BYTE                    byReserved1[3];
    ALGO_PARAM_INFO         stuEncrptAlgoparam;         // 㷨
    ENCRYPT_KEY_INFO        stuEncryptKeys[32];         // ͨԿϢ 
    BYTE                    byEncrptPlanEnable;         // ܼƻʹ
    BYTE                    byReserved3[3];
    NET_TIME                stuPreTime;                 // ܼƻĿʼʱ
    BYTE                    reserved2[1360];
}DHEDV_STREAM_ENCRYPT;

// 
typedef struct _DHDEV_BIT_RATE
{
    DWORD                   nExpectCodeRate;          // λkps
    BYTE                    byReserved[64];           // ֽ
}DHDEV_LIMIT_BIT_RATE;

// ûԶ
typedef struct _DHDEV_CUSTOM_CFG
{
    char                   szData[1024];            // ûԶϢ
    char                   reserved[3072];          // ֶ
}DHDEV_CUSTOM_CFG;

/*Խ*/
typedef struct
{
    DWORD               dwSize;
    int                 nCompression;               // ѹʽöֵDH_TALK_CODING_TYPE豸ֵ֧Խѹʽ
    int                 nMode;                      // ģʽöֵΪ0ʱʾѹʽֱ֧ģʽ
                                                    // ѹʽöӦıʽ
                                                    // AMREM_ARM_ENCODE_MODE
    char                 byReserve[256];            // 
} DHDEV_TALK_ENCODE_CFG;

// mobile
// (¼ý/ŷ)MMSýṹ
typedef struct
{
    DWORD               dwSize;
    DWORD               dwEnable;                               // ʹ
    DWORD               dwReceiverNum;                          // Ž߸
    char                SZReceiver[DH_MMS_RECEIVER_NUM][32];    // ŽߣһΪֻ
    BYTE                byType;                                 // Ϣ 0:MMS1:SMS
    char                SZTitle[32];                            // Ϣ
    char                byReserve[223];                         // 
} DHDEV_MMS_CFG;

// (ż)
typedef struct  
{
    DWORD               dwSize;
    DWORD               dwEnable;                               // ʹ
    DWORD               dwSenderNum;                            // ŷ߸
    char                SZSender[DH_MMS_SMSACTIVATION_NUM][32]; // ŷߣһΪֻ
     char               byReserve[256];                         // 
}DHDEV_SMSACTIVATION_CFG;

// (ż)
typedef struct  
{
    DWORD               dwSize;
    DWORD               dwEnable;                               // ʹ
    DWORD               dwCallerNum;                            // ߸
    char                SZCaller[DH_MMS_DIALINACTIVATION_NUM][32];// , һΪֻ
    char                byReserve[256];                         // 
}DHDEV_DIALINACTIVATION_CFG;
// mobile


// źǿȽṹ
typedef struct
{
    DWORD               dwSize;
    DWORD               dwTDSCDMA;                  // TD-SCDMAǿȣΧ0100
    DWORD               dwWCDMA;                    // WCDMAǿȣΧ0100
    DWORD               dwCDMA1x;                   // CDMA1xǿȣΧ0100
    DWORD               dwEDGE;                     // EDGEǿȣΧ0100
    DWORD               dwEVDO;                     // EVDOǿȣΧ0100
    int                 nCurrentType;               // ǰ
                                                    // 0 豸֧һ
                                                    // 1 TD-SCDMA
                                                    // 2 WCDMA
                                                    // 3 CDMA_1x
                                                    // 4 EDGE
                                                    // 5 EVDO
                                                    // 6 TD-LTE
    DWORD               dwTDLTE;                    // TD-LTEǿȣΧ0100
    char                byReserve[248];             // 
} DHDEV_WIRELESS_RSS_INFO;

typedef struct _DHDEV_SIP_CFG
{
    BOOL        bUnregOnBoot;                       //Unregister on Reboot
    char        szAccoutName[64];                   //Account Name
    char        szSIPServer[128];                   //SIP Server
    char        szOutBoundProxy[128];               //Outbound Proxy
    DWORD       dwSIPUsrID;                         //SIP User ID
    DWORD       dwAuthID;                           //Authenticate ID
    char        szAuthPsw[64];                      //Authenticate Password
    char        szSTUNServer[128];                  //STUN Server
    DWORD       dwRegExp;                           //Registration Expiration
    DWORD       dwLocalSIPPort;                     //Local SIP Port
    DWORD       dwLocalRTPPort;                     //Local RTP Port
    BOOL        bEnable;                            // ʹ
    char        szNotifyID[128];                    // ID
    NET_TIME    stuRegTime;                         // עɹʱ䣻ֶֻΣ豸ָ   
    BYTE        bReserved[868];                     //reserved
} DHDEV_SIP_CFG;

typedef struct _DHDEV_SIP_STATE
{
    int         nStatusNum;                         //״̬Ϣܵĸ
    BYTE        byStatus[64];                       //0:עɹ,1:δע,2:Ч,3:ע,4:ͨ
    BYTE        bReserved[64];                      //
}DHDEV_SIP_STATE;

typedef struct _DHDEV_HARDKEY_STATE
{
    BOOL        bState;                             // 0:δHardKey, 1:ѲHardKey
    BYTE        bReserved[64];                      // 
}DHDEV_HARDKEY_STATE;

typedef struct _DHDEV_ISCSI_PATHLIST
{
    int         nCount;
    char        szPaths[DH_MAX_ISCSI_PATH_NUM][MAX_PATH_STOR];    // ԶĿ¼
} DHDEV_ISCSI_PATHLIST;

// ·Ϣ
typedef struct _DHDEV_WIFI_ROUTE_CAP_COUNTRY
{
    char        szCountry[32];                      // 
    int         nValidChnNum;                       // Чͨ
    int         nValideChannels[32];                // Чͨб
    char        reserved[64];                       // 
} DHDEV_WIFI_ROUTE_CAP_COUNTRY;

typedef struct _DHDEV_WIFI_ROUTE_CAP
{
    int         nCountryNum;                        // 
    DHDEV_WIFI_ROUTE_CAP_COUNTRY stuCountry[256];   // ͬҵϢ
    char        reserved[256];                      // 
} DHDEV_WIFI_ROUTE_CAP;

//  ظϢ
typedef struct _MONITOR_INFO
{
    int         nPresetObjectNum;                   // ԤӦĿĿ
    int         nActualObjectNum;                   // ֳʵĿĿ 
    char        reserved[64]; 
}MONITOR_INFO;

typedef struct _DHDEV_MONITOR_INFO
{
    int              nChannelNumber;
    MONITOR_INFO     stMonitorInfo[64];             //  ظϢ
    char             reserved[128];
}DHDEV_MONITOR_INFO;

// ͨԤطŷָ
typedef struct tagNET_MULTIPLAYBACK_SPLIT_CAP
{
    DWORD            dwSize;
    int              nSliptMode[DH_MAX_MULTIPLAYBACK_SPLIT_NUM]; // ֵ֧ķָģʽ  
    int              nModeNumber;       
}NET_MULTIPLAYBACK_SPLIT_CAP;

/***************************** ̨ԤƵ ***********************************/
typedef struct _POINTEANBLE
{
    BYTE             bPoint;                        //ԤƵЧΧ[1,80]ЧΪ0
    BYTE             bEnable;                       //ǷЧ,0Ч1Ч
    BYTE             bReserved[2];
} POINTEANBLE;

typedef struct _POINTCFG
{
    char             szIP[DH_MAX_IPADDR_LEN];       // ip
    int              nPort;                         // ˿    
    POINTEANBLE      stuPointEnable[80];            // ԤƵʹ
    BYTE             bReserved[256];
}POINTCFG;

typedef struct _DHDEV_POINT_CFG
{
    int              nSupportNum;                   // ֻõʱҪظsdkʾֵ֧ԤƵ
    POINTCFG         stuPointCfg[16];               // ά±ʾͨšҪõĵֵǰnSupportNum±档
    BYTE             bReserved[256];                // 
}DHDEV_POINT_CFG;
////////////////////////////////DVR֧////////////////////////////////

// GPSϢ(豸)
typedef struct _GPS_Info
{
    NET_TIME         revTime;                       // λʱ
    char             DvrSerial[50];                 // 豸к
    double           longitude;                     // (λǰ֮ȣΧ0-360)
    double           latidude;                      // γ(λǰ֮ȣΧ0-180)
    double           height;                        // ߶()
    double           angle;                         // (Ϊԭ㣬˳ʱΪ)
    double           speed;                         // ٶ(λǺspeed/1000*1.852/Сʱ)
    WORD             starCount;                     // λ
    BOOL             antennaState;                  // ״̬(true ãfalse )
    BOOL             orientationState;              // λ״̬(true λfalse λ)
} GPS_Info,*LPGPS_Info;

// ״̬Ϣ
typedef struct 
{
    int              nAlarmCount;                   // ı¼
    int              nAlarmState[128];              // ı¼
    BYTE             byRserved[128];                // ֽ
}ALARM_STATE_INFO;

// ץͼṹ
typedef struct _snap_param
{
    unsigned int     Channel;                       // ץͼͨ
    unsigned int     Quality;                       // ʣ1~6
    unsigned int     ImageSize;                     // С0QCIF1CIF2D1
    unsigned int     mode;                          // ץͼģʽ0ʾһ֡1ʾʱ2ʾ
    unsigned int     InterSnap;                     // ʱ䵥λ룻mode=1ʾʱʱʱЧ
    unsigned int     CmdSerial;                     // к
    unsigned int     Reserved[4];
} SNAP_PARAMS, *LPSNAP_PARAMS;

// ץͼ
typedef struct 
{
    DWORD            dwSize;
    BYTE             bTimingEnable;                 // ʱץͼ(ץͼڸ)
    BYTE             bPicIntervalHour;              // ʱץͼʱСʱ
    short            PicTimeInterval;               // ʱץͼʱλΪ,Ŀǰ豸֧ץͼʱΪ30                           
    DH_VIDEOENC_OPT  struSnapEnc[SNAP_TYP_NUM];     // ץͼã֧еķֱʡʡ֡ã֡ǸʾһץͼĴ
} DHDEV_SNAP_CFG;

// ץͼչ
typedef struct 
{
    DWORD            dwSize;
    BYTE             bTimingEnable;                 // ʱץͼ(ץͼڸ)
    BYTE             bPicIntervalHour;              // ʱץͼʱСʱ
    short            PicTimeInterval;               // ʱץͼʱλΪ,Ŀǰ豸֧ץͼʱΪ30                           
    DH_VIDEOENC_OPT  struSnapEnc[SNAP_TYP_NUM];     // ץͼã֧еķֱʡʡ֡ã֡ǸʾһץͼĴ
    DWORD            dwTrigPicIntervalSecond;       // ÿץͼʱʱ λ
    BYTE             byRserved[256];                // ֽ
} DHDEV_SNAP_CFG_EX;


//wifi״̬
typedef struct  
{
    char            szSSID[128];                    //SSID
    BOOL            bEnable;                        //Ƿwifi, 0:ʹ 1:ʹ
    int             nSafeType;                      //У
                                                    //0:OPEN 
                                                    //1:RESTRICTE
                                                    //2:WEP
                                                    //3:WPA
                                                    //4:WPA2
                                                    //5:WPA-PSK
                                                    //6:WPA2-PSK
    int             nEncryprion;                    //ܷʽ
                                                    //0:OPEN
                                                    //1:TKIP
                                                    //2:WEP
                                                    //3:AES
                                                    //4:NONE(У)
                                                    //5:AUTO
                                                    //6:SHARED
    int             nStrength;                      //APվź
    char            szHostIP[128];                  //ַ
    char            szHostNetmask[128];             //
    char            szHostGateway[128];             //
    int             nPriority;                      //ȼ,(1-32)
    int             nEnDHCP;                        //0ʹ; 1ʹ(ɨ赽dhcpĬʹܴ)
    BYTE            bReserved[1016];
} DHDEV_VEHICLE_WIFI_STATE;

typedef struct
{
    char            szSSID[128];                    //SSID
    int             nPriority;                      //ȼ,(1-32)
    int             nSafeType;                      //У
                                                    //0:OPEN 
                                                    //1:RESTRICTE
                                                    //2:WEP
                                                    //3:WPA
                                                    //4:WPA2
                                                    //5:WPA-PSK
                                                    //6:WPA2-PSK
    int             nEncryprion;                    //ܷʽ
                                                    //0:OPEN
                                                    //1:TKIP
                                                    //2:WEP
                                                    //3:AES
                                                    //4:NONE(У)
                                                    //5:AUTO
                                                    //6:SHARED
    char            szKey[128];                     //Կ
    char            szHostIP[128];                  //ַ
    char            szHostNetmask[128];             //
    char            szHostGateway[128];             //
    int             nEnDHCP;                        //0ʹ; 1ʹ(ɨ赽dhcpĬʹܴ)
    BYTE            byKeyIndex;                     //WEPУµԿ,0֧Կ >0:ԿֵΧ1-4
    BYTE            bReserved[1019];
} DHDEV_VEHICLE_WIFI_CONFIG;

typedef struct
{
    char    szSSID[128];                            // SSID   
    BYTE    bReserved[256];                         // ֽ
}WIFI_CONNECT;

// IP޸
typedef struct __DHCTRL_IPMODIFY_PARAM
{
    int             nStructSize;
    char            szRemoteIP[DH_MAX_IPADDR_OR_DOMAIN_LEN];        // ǰ豸IP
    char            szSubmask[DH_MAX_IPADDR_LEN];                   // 
    char            szGateway[DH_MAX_IPADDR_OR_DOMAIN_LEN];         // 
    char            szMac[DH_MACADDR_LEN];                          // MACַ
    char            szDeviceType[DH_DEV_TYPE_LEN];                  // 豸
}DHCTRL_IPMODIFY_PARAM;

typedef struct 
{
    BOOL        bIsScan;                            //0:ɨwifi (ֶӵ), 1ɨ赽wifi
    char        szSSID[128];                        //SSID
    int         nSafeType;                          //У
                                                    //0:OPEN 
                                                    //1:RESTRICTE
                                                    //2:WEP
                                                    //3:WPA
                                                    //4:WPA2
                                                    //5:WPA-PSK
                                                    //6:WPA2-PSK
    int        nEncryprion;                         //ܷʽ
                                                    //0:OPEN
                                                    //1:TKIP
                                                    //2:WEP
                                                    //3:AES
                                                    //4:NONE(У)
                                                    //5:AUTO
                                                    //6:SHARED
    char        szKey[128];                         //Կ
    int         nStrength;                          //APվź
    int         nMaxBitRate;                        //APվ,λ ֻ
    int         nIsCnnted;                          //Ƿӳɹֻ
    int         nIsSaved;                           //ǷѾֻ
    int         nPriority;                          //ȼ,(1-32)
    char        szHostIP[128];                      //ַ
    char        szHostNetmask[128];                 //
    char        szHostGateway[128];                 //
    int         nWifiFreq;                          //Ƶʣͨʶ
    int         nEnDHCP;                            //0ʹ 1ʹ(ɨ赽dhcpĬʹܴ)
    BYTE        byKeyIndex;                         //WEPУµԿ,0֧Կ >0:ԿֵΧ1-4
    BYTE        bReserved[1019];
}DHDEV_VEHICLE_SINGLE_WIFI_AP_CFG;

typedef struct 
{
    BOOL        bEnable;                            //Ƿwifi, 0:ʹ 1:ʹ
    int         nWifiApNum;                         //DHDEV_VEHICLE_WIFI_AP_CFGṹЧ
    DHDEV_VEHICLE_SINGLE_WIFI_AP_CFG struWifiAp[64];//WIFI AP
    int         nReserved[512];                     //
}DHDEV_VEHICLE_WIFI_AP_CFG;

typedef struct  
{    
    BOOL        bEnable;                            //Ƿwifi, 0:ʹ 1:ʹ
    int         nRetWifiApNum;                      //õDHDEV_VEHICLE_WIFI_AP_CFGṹЧ
    int         nMaxWifiApNum;                      //DHDEV_VEHICLE_SINGLE_WIFI_AP_CFG
    DHDEV_VEHICLE_SINGLE_WIFI_AP_CFG* pWifiAp;      //WIFI AP
    int         nReserved[512];                     //
}DHDEV_VEHICLE_WIFI_AP_CFG_EX;

// GPS־Ϣṹ
typedef struct _DH_DEVICE_GPS_LOG_ITEM
{
    DHDEVTIME       stuDevTime;             // 豸ʱ  
    DWORD           dwLatidude;             // γ(λǰ֮ȣΧ0-180)籱γ30.183382ȱʾΪ120183382
    DWORD           dwLongitude;            // (λǰ֮ȣΧ0-360)綫120.178274ȱʾΪ300178274
    DWORD           dwSpeed;                // ٶ,λǺ,speed/1000*1.852/Сʱ
    DWORD           dwHight;                // ߶,
    DWORD           dwAngle;                // 򣬽Ƕ0~360,Ϊԭ㣬˳ʱΪ
    DHDEVTIME       stuGpsTime;             // GPSʱ
    BYTE            bAntStatus;             // GPS״̬,Ϊ0ʾ;Ϊ0ʾ쳣 
    BYTE            bOriStatus;             // λ״̬Ϊ0ʾλɹ
    BYTE            bSatCount;              // 
    BYTE            bGPSStatus;             // GPS״̬,0,δλ 1,޲ֶλϢ 2,ֶλϢ
    DWORD           dwTemp;                 // ¶ֵ(϶),ʵֵ1000,30.0϶ȱʾΪ30000
    DWORD           dwHumidity;             // ʪֵ(%),ʵֵ1000,30.0%ʾΪ30000
    BYTE            bReserved[24];          // ֽ
    
}DH_DEVICE_GPS_LOG_ITEM;

// GPS ־ѯṹ
typedef struct _QUERY_GPS_LOG_PARAM
{
    NET_TIME            stuStartTime;               // ѯ־Ŀʼʱ
    NET_TIME            stuEndTime;                 // ѯ־Ľʱ
    int                 nStartNum;                  // ʱдӵڼ־ʼѯʼһβѯΪ0
    BYTE                bReserved[20];
} QUERY_GPS_LOG_PARAM;

typedef struct _GPS_TEMP_HUMIDITY_INFO
{
    double              dTemperature;               // ¶ֵ(϶),ʵֵ1000,30.0϶ȱʾΪ30000
    double              dHumidity;                  // ʪֵ(%),ʵֵ1000,30.0%ʾΪ30000
    BYTE                bReserved[128];             // ֽ
}GPS_TEMP_HUMIDITY_INFO;

// Χö
typedef enum
{
    ENCLOSURE_LIMITSPEED = 0x01,                    // 
    ENCLOSURE_DRIVEALLOW = 0x02,                    // ʻ
    ENCLOSURE_FORBIDDRIVE = 0x04,                   // ֹ
    ENCLOSURE_LOADGOODS = 0x08,                     // װ
    ENCLOSURE_UPLOADGOODS = 0x10,                   // ж
}ENCLOSURE_TYPE;

typedef enum
{
     ENCLOSURE_ALARM_DRIVEIN ,                      // ʻ
     ENCLOSURE_ALARM_DRIVEOUT,                      // ʻ
     ENCLOSURE_ALARM_OVERSPEED,                     // 
     ENCLOSURE_ALARM_SPEEDCLEAR,                    // ʧ
}ENCLOSURE_ALARM_TYPE;

typedef struct 
{
    DWORD         dwLongitude;                      // (λǰ֮ȣΧ0-360)綫120.178274ȱʾΪ300178274
    DWORD         dwLatidude;                       // γ(λǰ֮ȣΧ0-180)籱γ30.183382ȱʾΪ120183382
}GPS_POINT;

// Χ
typedef struct _DHDEV_ENCLOSURE_CFG
{
    UINT          unType;                              // Χ룬 ENCLOSURE_TYPE 
    BYTE          bRegion[8];                          // ǰλֱҡʡл(0-255)4bytes
    UINT          unId;                                // һһIDʶ
    UINT          unSpeedLimit;                        // ٣λkm/h
    UINT          unPointNum;                          // Χ򶥵
    GPS_POINT     stPoints[128];                       // ΧϢ
    char          szStationName[DH_STATION_NAME_LEN];  // ΧΧĳվվ
    BYTE          reserved[32];                        // 
}DHDEV_ENCLOSURE_CFG;

// Χ汾
typedef struct _DHDEV_ENCLOSURE_VERSION_CFG
{
    UINT          unType;                              // Χ룬LIMITSPEED | DRIVEALLOW
    UINT          unVersion[32];                       // ÿһ汾,ͳһƽ̨豸ϵΧ
    int           nReserved;                           //     
}DHDEV_ENCLOSURE_VERSION_CFG;

// Χ
typedef struct __ALARM_ENCLOSURE_INFO
{
    int           nTypeNumber;                          // ЧΧ͸
    BYTE          bType[16];                            // Χ, ENCLOSURE_TYPE
    int           nAlarmTypeNumber;                     // Ч͸
    BYTE          bAlarmType[16];                       // ͣENCLOSURE_ALARM_TYPE
    char          szDriverId[DH_VEHICLE_DRIVERNO_LEN];  // ˾
    UINT          unEnclosureId;                        // ΧID
    UINT          unLimitSpeed;                         // ٣λkm/h
    UINT          unCurrentSpeed;                       // ǰٶ
    NET_TIME      stAlarmTime;                          // ʱ
    DWORD         dwLongitude;                          // (λǰ֮ȣΧ0-360)綫120.178274ȱʾΪ300178274
    DWORD         dwLatidude;                           // γ(λǰ֮ȣΧ0-180)籱γ30.183382ȱʾΪ120183382
    BYTE          bOffline;                             // 0-ʵʱ 1- 
    BYTE          byReserved[119];                      // ֽ
}ALARM_ENCLOSURE_INFO;

// RAID쳣Ϣ
#define DH_MAX_RAID_NUM  16
typedef struct __RAID_STATE_INFO
{
    char          szName[16];                           // Raid
    BYTE          byType;                               //  1:Jbod     2:Raid0      3:Raid1     4:Raid5
    BYTE          byStatus;                             // ״̬ 0:unknown 1:active2:degraded3:inactive4:recovering
    BYTE          byReserved[2];
    int           nCntMem;                              // nMemberЧݸ
    int           nMember[32];                          // 1,2,3,... ɴͨ,Ǹ
    int           nCapacity;                            // ,λG
    int           nRemainSpace;                         // ʣλM
    int           nTank;                                // չ 0:1:չ12:չ2
    char          reserved[32];
}RAID_STATE_INFO;

typedef struct __ALARM_RAID_INFO
{
    int              nRaidNumber;                       // ϱRAID   
    RAID_STATE_INFO  stuRaidInfo[DH_MAX_RAID_NUM];      // 쳣RAIDϢ
    char             reserved[128];
}ALARM_RAID_INFO;

//////////////////////////////////ATM֧//////////////////////////////////

typedef struct
{
    int           Offset;                               // ־λλƫ
    int           Length;                               // ־λĳ
    char          Key[16];                              // ־λֵ
} DH_SNIFFER_FRAMEID;

typedef struct 
{
    int           Offset;                       // ־λλƫ
    int           Offset2;                      // ĿǰûӦ
    int           Length;                       // ־λĳ
    int           Length2;                      // ĿǰûӦ
    char          Title[12];                    // ֵ
    char          Key[12];                      // ؼֵֵ
} DH_SNIFFER_CONTENT;

// ץ
typedef struct 
{
    DH_SNIFFER_FRAMEID    snifferFrameId;                           // ÿFRAME ID ѡ
    DH_SNIFFER_CONTENT    snifferContent[DH_SNIFFER_CONTENT_NUM];   // ÿFRAMEӦ4ץ
} DH_SNIFFER_FRAME;

// ÿץӦýṹ
typedef struct
{
    char                SnifferSrcIP[DH_MAX_IPADDR_LEN];        // ץԴַ        
    int                 SnifferSrcPort;                         // ץԴ˿
    char                SnifferDestIP[DH_MAX_IPADDR_LEN];       // ץĿַ
    int                 SnifferDestPort;                        // ץĿ˿
    char                reserved[28];                           // ֶ
    DH_SNIFFER_FRAME    snifferFrame[DH_SNIFFER_FRAMEID_NUM];   // 6FRAME ѡ
    int                 displayPosition;                        // ʾλ
    int                 recdChannelMask;                        // ͨ
} DH_ATM_SNIFFER_CFG;

typedef struct  
{
    DWORD               dwSize;
    DH_ATM_SNIFFER_CFG  SnifferConfig[4];
    char                reserved[256];                          // ֶ
} DHDEV_SNIFFER_CFG;

typedef DH_SNIFFER_FRAMEID DH_SNIFFER_FRAMEID_EX;
typedef DH_SNIFFER_CONTENT DH_SNIFFER_CONTENT_EX;

// ץ
typedef struct  
{
    DH_SNIFFER_FRAMEID    snifferFrameId;                               // ÿFRAME ID ѡ
    DH_SNIFFER_CONTENT    snifferContent[DH_SNIFFER_CONTENT_NUM_EX];    // ÿFRAMEӦ8ץ    
} DH_SNIFFER_FRAME_EX;

// ÿץӦýṹ
typedef struct
{
    char                SnifferSrcIP[DH_MAX_IPADDR_LEN];                // ץԴַ        
    int                 SnifferSrcPort;                                 // ץԴ˿
    char                SnifferDestIP[DH_MAX_IPADDR_LEN];               // ץĿַ
    int                 SnifferDestPort;                                // ץĿ˿
    DH_SNIFFER_FRAME_EX snifferFrame[DH_SNIFFER_FRAMEID_NUM];           // 6FRAME ѡ
    int                 displayPosition;                                // ʾλ
    int                 recdChannelMask;                                // ͨ  0  ~ 31 ͨ
    BOOL                bDateScopeEnable;                               // Դʹ
    BOOL                bProtocolEnable;                                // Эʹ
    char                szProtocolName[DH_SNIFFER_PROTOCOL_SIZE];       // Э
    int                 nSnifferMode;                                   // ץʽ0:net,1:232.
    int                 recdChannelMask1;                               // ͨ  32 ~ 63 ͨ
    char                reserved[252];
} DH_ATM_SNIFFER_CFG_EX;

// AtmͲѯؽṹ
#define ATM_MAX_TRADE_TYPE_NAME    64
#define ATM_MAX_TRADE_NUM        1024

typedef struct __DH_ATM_QUERY_TRADE   
{
    int  nTradeTypeNum;                                                     // ʵʽ
    int  nExceptionTypeNum;                                                 // ʵ쳣¼
    char szSupportTradeType[ATM_MAX_TRADE_NUM][ATM_MAX_TRADE_TYPE_NAME];    // ¼
    char szSupportExceptionType[ATM_MAX_TRADE_NUM][ATM_MAX_TRADE_TYPE_NAME];// 쳣¼
} DH_ATM_QUERY_TRADE, *LPDH_ATM_QUERY_TRADE;

/////////////////////////////////֧/////////////////////////////////
#define nEncoderID nDecoderID
#define byEncoderID byDecoderID

// Ϣ
typedef struct __DEV_DECODER_INFO 
{
    char            szDecType[64];                      // 
    int             nMonitorNum;                        // TV
    int             nEncoderNum;                        // ͨ
    BYTE            szSplitMode[16];                    // ֵ֧TVָʽʾ0Ϊβ
    BYTE            bMonitorEnable[16];                 // TVʹ
    BYTE            bTVTipDisplay;                      // ָʾǷ֧TVʾϢ, 0:֧ 1:֧.
    BYTE            reserved1[3];
    BYTE            byLayoutEnable[48];                 // ͨʾϢʹ
    DWORD           dwLayoutEnMask[2];                  // ͨʾϢʹ,ӵλλ֧64ͨ,dwLayoutEnMask[0]ǵ32λ
    char            reserved[4];
} DEV_DECODER_INFO, *LPDEV_DECODER_INFO;

//#define NANJINGDITIE_NVD
#ifndef NANJINGDITIE_NVD
// ӵıϢ
typedef struct __DEV_ENCODER_INFO 
{
    char            szDevIp[DH_MAX_IPADDR_LEN];             // ǰDVRIPַ
    WORD            wDevPort;                               // ǰDVRĶ˿ں
    BYTE            bDevChnEnable;                          // ͨʹ
    BYTE            byDecoderID;                            // Ӧͨ
    char            szDevUser[DH_USER_NAME_LENGTH_EX];      // û
    char            szDevPwd[DH_USER_PSW_LENGTH_EX];        // 
    int             nDevChannel;                            // ͨ
    int             nStreamType;                            // ͣ011; 2:snap; 3: 2
    BYTE            byConnType;                             // -1: auto, 0TCP1UDP2鲥
    BYTE            byWorkMode;                             // 0ֱ1ת
    WORD            wListenPort;                            // ָʾĶ˿ڣתʱЧ
    DWORD           dwProtoType;                            // Э,
                                                            // 0:ǰ
                                                            // 1:󻪶Э
                                                            // 2:ϵͳЭ
                                                            // 3:DSSЭ
                                                            // 4:rtspЭ
    char            szDevName[64];                          // ǰ豸
    BYTE            byVideoInType;                          // ýͨǰƵԴ:0-(SD),1-(HD),ע:豸ָ֧ͨЧ        
    char            szDevIpEx[DH_MAX_IPADDR_OR_DOMAIN_LEN]; // szDevIpչǰDVRIPַ()
    BYTE            bySnapMode;                             // ץͼģʽ(nStreamType==2ʱЧ) 0ʾһ֡,1ʾʱ
    BYTE            byManuFactory;                          // Ŀ豸,οEM_IPC_TYPE
    BYTE            byDeviceType;                           // Ŀ豸豸,0:IPC
    BYTE            byDecodePolicy;                         // Ŀ豸Ľ,0:ǰ
                                                            // 1:ʵʱȼ 2:ʵʱȼ
                                                            // 3:ʵʱȼ 4:Ĭϵȼ
                                                            // 5:ȼ 6:ȼ
                                                            // 7:ȼ
    BYTE            bReserved[3];                           // ֽ
    DWORD           dwHttpPort;                             // Http˿ں,0-65535
    DWORD           dwRtspPort;                             // Rtsp˿ں,0-65535
    char            szChnName[32];                          // Զͨ, ֻжȡƲΪʱſ޸ĸͨ
    char            reserved[4];
} DEV_ENCODER_INFO, *LPDEV_ENCODER_INFO;

#else

// ӵıϢ
typedef struct __DEV_ENCODER_INFO 
{
    char            szDevIp[DH_MAX_IPADDR_LEN];             // ǰDVRIPַ
    WORD            wDevPort;                               // ǰDVRĶ˿ں
    BYTE            bDevChnEnable;                          // ͨʹ
    BYTE            byDecoderID;                            // Ӧͨ
    char            szDevUser[DH_USER_NAME_LENGTH_EX];      // û
    char            szDevPwd[DH_USER_PSW_LENGTH_EX];        // 
    int             nDevChannel;                            // ͨ
    int             nStreamType;                            // ͣ011; 2:snap; 3: 2
    BYTE            byConnType;                             // -1: auto, 0TCP1UDP2鲥
    BYTE            byWorkMode;                             // 0ֱ1ת
    WORD            wListenPort;                            // ָʾĶ˿ڣתʱЧ;byConnTypeΪ鲥ʱΪಥ˿
    DWORD            dwProtoType;                           // Э,
                                                            // 0:ǰ
                                                            // 1:󻪶Э
                                                            // 2:ϵͳЭ
                                                            // 3:DSSЭ
                                                            // 4:rtspЭ
                                                            // 5:׼TS
    char            szDevName[32];                          // ǰ豸
    BYTE            byVideoInType;                          // ýͨǰƵԴ:0-(SD),1-(HD),ע:豸ָ֧ͨЧ        
    char            szDevIpEx[DH_MAX_IPADDR_OR_DOMAIN_LEN]; // szDevIpչǰDVRIPַ()
    BYTE            bySnapMode;                             // ץͼģʽ(nStreamType==2ʱЧ) 0ʾһ֡,1ʾʱ
    BYTE            byManuFactory;                          // Ŀ豸,οEM_IPC_TYPE
    BYTE            byDeviceType;                           // Ŀ豸豸,0:IPC
    BYTE            byDecodePolicy;                         // Ŀ豸Ľ,0:ǰ
                                                            // 1:ʵʱȼ 2:ʵʱȼ
                                                            // 3:ʵʱȼ 4:Ĭϵȼ
                                                            // 5:ȼ 6:ȼ
                                                            // 7:ȼ
    BYTE            bReserved[3];                           // ֽ
    DWORD           dwHttpPort;                             // Http˿ں,0-65535
    DWORD           dwRtspPort;                             // Rtsp˿ں,0-65535
    char            szChnName[32];                          // Զͨ, ֻжȡƲΪʱſ޸ĸͨ
    char            szMcastIP[DH_MAX_IPADDR_LEN];           // ಥIPַ,byConnTypeΪ鲥ʱЧ
    char            reserved[128];
} DEV_ENCODER_INFO, *LPDEV_ENCODER_INFO;

#endif

// rtsp url
typedef struct __DHDEV_DECODER_URL_CFG
{
    DWORD           dwSize;
    char            szMainStreamUrl[MAX_PATH];          // url
    char            szExtraStreamUrl[MAX_PATH];         // url
} DHDEV_DECODER_URL_CFG;

typedef enum tagDH_SPLIT_DISPLAY_TYPE
{
    DH_SPLIT_DISPLAY_TYPE_GENERAL=1,          // ͨʾ
    DH_SPLIT_DISPLAY_TYPE_PIP=2,              // лʾ
} DH_SPLIT_DISPLAY_TYPE;

// CLIENT_CtrlDecTVScreen ӿڲ
typedef struct tagDH_CTRL_DECTV_SCREEN
{
    DWORD           dwSize;                             // ṹС
    int             nSplitType;                         // ָģʽ
    BYTE *          pEncoderChannel;                    // ʾͨ,dwDisplayType=DH_SPLIT_DISPLAY_TYPE_GENERALʱЧ,߷ڴ泤ȲСnSplitTypeĴС
    BYTE            byGroupNo;                          // ͨ,dwDisplayType=DH_SPLIT_DISPLAY_TYPE_PIPʱʾлʾЧ
    char            reserved[3];                        // ֽ
    DWORD           dwDisplayType;                      // ʾͣDH_SPLIT_DISPLAY_TYPEע͸ģʽʾ"PicInPic", ģʽʾݰNVDйDisChnֶξݣûһʱĬΪͨʾ,"General"
}DH_CTRL_DECTV_SCREEN;

// TVϢ
typedef struct __DEV_DECODER_TV 
{
    int                 nID;                            // TV
    BOOL                bEnable;                        // ʹܣر
    int                 nSplitType;                     // ָ
    DEV_ENCODER_INFO    stuDevInfo[16];                 // ϢdwDisplayType=DH_SPLIT_DISPLAY_TYPE_GENERALʱЧ
    BYTE                bySupportSplit[10];             // ֵ֧ķָģʽ
    BYTE                byGroupNo;                      // ͨ,dwDisplayType=DH_SPLIT_DISPLAY_TYPE_PIPʱʾлʾЧ
    char                reserved[1];                    // ֽ
    DWORD               dwDisplayType;                  // ʾͣDH_SPLIT_DISPLAY_TYPEע͸ģʽʾ"PicInPic", ģʽʾݰNVDйDisChnֶξݣûһʱĬΪͨʾ,"General"
} DEV_DECODER_TV, *LPDEV_DECODER_TV;

// Ϣ
typedef struct __DEC_COMBIN_INFO
{
    int             nCombinID;                          // ID
    int             nSplitType;                         // ָ 
    BYTE            bDisChn[16];                        // ʾͨ
    char            reserved[16];
} DEC_COMBIN_INFO, *LPDEC_COMBIN_INFO;

// ѲϢ
#define DEC_COMBIN_NUM             32                   // Ѳϸ
typedef struct __DEC_TOUR_COMBIN 
{
    int             nTourTime;                          // Ѳ()
    int             nCombinNum;                         // ϸ
    BYTE            bCombinID[DEC_COMBIN_NUM];          // ϱ
    char            reserved1[32];
    BYTE            bCombinState[DEC_COMBIN_NUM];       // ʹ״̬0أ1
    char            reserved2[32];
} DEC_TOUR_COMBIN, *LPDEC_TOUR_COMBIN;

// ط
typedef enum __DEC_PLAYBACK_MODE
{
    Dec_By_Device_File = 0,                             // ǰ豸ļʽ
    Dec_By_Device_Time,                                 // ǰ豸ʱ䷽ʽ
} DEC_PLAYBACK_MODE;

// طſ
typedef enum __DEC_CTRL_PLAYBACK_TYPE
{
    Dec_Playback_Seek = 0,                              // ϶
    Dec_Playback_Play,                                  // 
    Dec_Playback_Pause,                                 // ͣ
    Dec_Playback_Stop,                                  // ֹͣ
} DEC_CTRL_PLAYBACK_TYPE;

//Ѳ
typedef enum __DEC_CTRL_TOUR_TYPE
{
    Dec_Tour_Stop = 0,                                  // ֹͣ
    Dec_Tour_Start,                                     // ʼ
    Dec_Tour_Pause,                                     // ͣ
    Dec_Tour_Resume,                                    // ָ
} DEC_CTRL_TOUR_TYPE;

// ļطǰ豸
typedef struct __DEC_PLAYBACK_FILE_PARAM 
{
    char            szDevIp[DH_MAX_IPADDR_LEN];         // ǰDVRIPַ
    WORD            wDevPort;                           // ǰDVRĶ˿ں
    BYTE            bDevChnEnable;                      // ͨʹ
    BYTE            byDecoderID;                        // Ӧͨ
    char            szDevUser[DH_USER_NAME_LENGTH_EX];  // û
    char            szDevPwd[DH_USER_PSW_LENGTH_EX];    // 
    NET_RECORDFILE_INFO stuRecordInfo;                  // ¼ļϢ
    char            reserved[12];
} DEC_PLAYBACK_FILE_PARAM, *LPDEC_PLAYBACK_FILE_PARAM;

// ʱطǰ豸
typedef struct __DEC_PLAYBACK_TIME_PARAM 
{
    char            szDevIp[DH_MAX_IPADDR_LEN];         // ǰDVRIPַ
    WORD            wDevPort;                           // ǰDVRĶ˿ں
    BYTE            bDevChnEnable;                      // ͨʹ
    BYTE            byDecoderID;                        // Ӧͨ
    char            szDevUser[DH_USER_NAME_LENGTH_EX];  // û
    char            szDevPwd[DH_USER_PSW_LENGTH_EX];    // 
    int             nChannelID;
    NET_TIME        startTime;
    NET_TIME        endTime;
    char            reserved[12];
} DEC_PLAYBACK_TIME_PARAM, *LPDEC_PLAYBACK_TIME_PARAM;

// ǰͨ״̬Ϣ(ͨ״̬Ϣ)
typedef struct __DEV_DECCHANNEL_STATE
{
    BYTE            byDecoderID;                        // Ӧͨ
    BYTE            byChnState;                         // ǰͨڲ״̬:0У1ʵʱӣ2ط 3 - Ѳ
    BYTE            byFrame;                            // ǰ֡
    BYTE            byReserved;                         // 
    int             nChannelFLux;                       // ͨ
    int             nDecodeFlux;                        // 
    char            szResolution[16];                   // ǰݷֱ
    char            reserved[256];
} DEV_DECCHANNEL_STATE, *LPDEV_DECCHANNEL_STATE;

// 豸TVϢ
typedef struct __DEV_VIDEOOUT_INFO
{
    DWORD           dwVideoStandardMask;            // NSP,Ƶʽ룬λʾ豸ֵܹ֧Ƶʽ(ݲ֧)
    int             nVideoStandard;                 // NSP,ǰʽ(ݲ֧֣ʹDHDEV_SYSTEM_ATTR_CFGbyVideoStandardʽȡ)
    DWORD           dwImageSizeMask;                // ֱ룬λʾ豸ֵܹ֧ķֱ
    int             nImageSize;                     // ǰķֱ
    char            reserved[256];
}DEV_VIDEOOUT_INFO, *LPDEV_VIDEOOUT_INFO;

// TV
typedef struct __DEV_TVADJUST_CFG
{
    int             nTop;                           // ϲ߾ࣨ0100
    int             nBotton;                        // ²߾ࣨ0100
    int             nLeft;                          // ߾ࣨ0100
    int             nRight;                         // Ҳ߾ࣨ0100
    int             reserved[32];
}DHDEV_TVADJUST_CFG, *LPDHDEV_TVADJUST_CFG;

// Ѳ
typedef struct __DEV_DECODER_TOUR_SINGLE_CFG
{
    char        szIP[128];                          // ǰ豸ip."10.7.5.21". ֧.Ҫ'\0'.
    int         nPort;                              // ǰ豸˿.(0, 65535).
    int         nPlayChn;                           // ǰ豸ͨ[1, 16].
    int         nPlayType;                          // ǰ, 0:; 1:.
    char        szUserName[32];                     // ½ǰ豸û,Ҫ'\0'.
    char        szPassword[32];                     // ½ǰ豸,Ҫ'\0'.
    int         nInterval;                          // Ѳʱ[10, 120],λ.
    DWORD       nManuFactory;                       // Ŀ豸(ö IPC_TYPE)
    UINT        nHttpPport;                         // Ŀ豸Ķ˿(Http˿)
    UINT        nRtspPort;                          // Ŀ豸Ķ˿(Rtsp˿)
    BYTE        byServiceType;                      // , -1: auto, 0TCP1UDP2鲥
    BYTE        bReserved[51];                      // ֽ,չ.
}DHDEV_DECODER_TOUR_SINGLE_CFG;

typedef struct __DEV_DECODER_TOUR_CFG
{
    int                             nCfgNum;        // ýṹĿ. ֧32.֧Ŀͨѯ.
    DHDEV_DECODER_TOUR_SINGLE_CFG   tourCfg[64];    // ѯ,ЧṹɳԱ"nCfgNum"ָ. 32չ.
    BYTE                            bReserved[256]; // ֽ,չ.
}DHDEV_DECODER_TOUR_CFG;

/////////////////////////////////֧/////////////////////////////////
// ӦͼƬļϢ
typedef struct  
{
    DWORD           dwOffSet;                       // ļڶݿеƫλ, λ:ֽ
    DWORD           dwFileLenth;                    // ļС, λ:ֽ
    WORD            wWidth;                         // ͼƬ, λ:
    WORD            wHeight;                        // ͼƬ߶, λ:
    char*           pszFilePath;                    // ļ·
                                                    // ûʹøֶʱҪռп
    BYTE            bReserved[12];                  // 12<--16
}DH_PIC_INFO;

#if (defined(LINUX64) || defined(WIN64))
#else
// չֶмint64, ǿ4ֽڶ
#pragma pack(push)
#pragma pack(4)
#endif
// ƵϢṹ
typedef struct 
{
    int                 nObjectID;                          // ID,ÿIDʾһΨһ
    char                szObjectType[128];                  // 
    int                 nConfidence;                        // Ŷ(0~255)ֵԽʾŶԽ
    int                 nAction;                            // 嶯:1:Appear 2:Move 3:Stay 4:Remove 5:Disappear 6:Split 7:Merge 8:Rename
    DH_RECT             BoundingBox;                        // Χ
    DH_POINT            Center;                             // 
    int                 nPolygonNum;                        // ζ
    DH_POINT            Contour[DH_MAX_POLYGON_NUM];        // Ͼȷ
    DWORD               rgbaMainColor;                      // ʾơҪɫֽڱʾֱΪ졢̡͸,:RGBֵΪ(0,255,0),͸Ϊ0ʱ, ֵΪ0x00ff0000.
    char                szText[128];                        // صĴ0ı糵ƣװŵȵ
                                                            // "ObjectType"Ϊ"Vehicle""Logo"ʱʹLogoVehicleΪ˼ϲƷʾ֧֣꣬
                                                            // "Unknown"δ֪ 
                                                            // "Audi" µ
                                                            // "Honda" 
                                                            // "Buick" 
                                                            // "Volkswagen" 
                                                            // "Toyota" 
                                                            // "BMW" 
                                                            // "Peugeot" 
                                                            // "Ford" 
                                                            // "Mazda" Դ
                                                            // "Nissan" ɣ
                                                            // "Hyundai" ִ
                                                            // "Suzuki" ľ
                                                            // "Citroen" ѩ
                                                            // "Benz" 
                                                            // "BYD" ǵ
                                                            // "Geely" 
                                                            // "Lexus" ׿˹
                                                            // "Chevrolet" ѩ
                                                            // "Chery" 
                                                            // "Kia" 
                                                            // "Charade" 
                                                            // "DF" 
                                                            // "Naveco" ά
                                                            // "SGMW" 
                                                            // "Jinbei" 
                                                            
                                                            // "JAC" 
                                                            // "Emgrand" ۺ
                                                            // "ChangAn" 
                                                            // "Great Wall" 
                                                            // "Skoda" ˹´
                                                            // "BaoJun" 
                                                            // "Subaru" ˹³
                                                            // "LandWind" ½
                                                            // "Luxgen" ǽ
                                                            // "Renault" ŵ
                                                            // "Mitsubishi" 
                                                            // "Roewe" 
                                                            // "Cadillac" 
                                                            // "MG" 
                                                            // "Zotye" ̩
                                                            // "ZhongHua" л
                                                            // "Foton" 
                                                            // "SongHuaJiang" ɻ
                                                            // "Opel" ŷ
                                                            // "HongQi" һ
                                                            // "Fiat" 
                                                            // "Jaguar" ݱ
                                                            // "Volvo" ֶ
                                                            // "Acura" ک
                                                            // "Porsche" ʱ
                                                            
                                                            // "Jeep" 
                                                            // "Bentley" 
                                                            // "Bugatti" ӵ
                                                            // "ChuanQi" 
                                                            // "Daewoo" 
                                                            // "DongNan" 
                                                            // "Ferrari" 
                                                            // "Fudi" 
                                                            // "Huapu" 
                                                            // "HawTai" ̩
                                                            // "JMC" 
                                                            // "JingLong" ͳ
                                                            // "JoyLong" 
                                                            // "Karry" 
                                                            // "Chrysler" ˹
                                                            // "Lamborghini" 
                                                            // "RollsRoyce" ˹˹
                                                            // "Linian" 
                                                            // "LiFan" 
                                                            // "LieBao" Ա
                                                            // "Lincoln" ֿ
                                                            // "LandRover" ·
                                                            // "Lotus" ·˹
                                                            // "Maserati" ɯ
                                                            // "Maybach" ͺ

                                                            // "Mclaren" 
                                                            // "Youngman" ͳ
                                                            // "Tesla" ˹
                                                            // "Rely" 
                                                            // "Lsuzu" ʮ
                                                            // "Yiqi" һ
                                                            // "Infiniti" Ӣ
                                                            // "YuTong" ͨͳ
                                                            // "AnKai" ͳ
                                                            // "Canghe" 
                                                            // "HaiMa" 
                                                            // "Crown" ʹ
                                                            // "HuangHai" ƺ
                                                            // "JinLv" ÿͳ
                                                            // "JinNing" 
                                                            // "KuBo" Ჩ
                                                            // "Europestar" 
                                                            // "MINI" 
                                                            // "Gleagle" ȫӥ
                                                            // "ShiDai" ʱ
                                                            // "ShuangHuan" ˫
                                                            // "TianYe" Ұ
                                                            // "WeiZi" 
                                                            // "Englon" Ӣ
                                                            // "ZhongTong" ͨͳ

                                                            // "Changan" γ
                                                            // "Yuejin" Ծ
                                                            // "Taurus" ţ
                                                            // "Alto" 
                                                            // "Weiwang" 
                                                            // "Chenglong" 
                                                            // "Haige" 
                                                            // "Shaolin" ֿͳ
                                                            // "Beifang" ͳ
                                                            // "Beijing" 
                                                            // "Hafu" 

    char                szObjectSubType[64];                // 𣬸ݲͬͣȡͣ
                                                            // Vehicle Category:"Unknown"  δ֪,"Motor" ,"Non-Motor":ǻ,"Bus": ,"Bicycle" г,"Motorcycle":Ħг,"PassengerCar":ͳ,
                                                            // "LargeTruck":,    "MidTruck":л,"SaloonCar":γ,"Microbus":,"MicroTruck":С,"Tricycle":ֳ,    "Passerby":                                                    
                                                            // Plate Category"Unknown" δ֪,"Normal" ƺ,"Yellow" ,"DoubleYellow" ˫β,"Police" "Armed" 侯,
                                                            // "Military" Ӻ,"DoubleMilitary" ˫,"SAR" ۰,"Trainning" 
                                                            // "Personal" Ժ,"Agri" ũ,"Embassy" ʹݺ,"Moto" Ħг,"Tractor" ,"Other" 
                                                            // HumanFace Category:"Normal" ͨ,"HideEye" ۲ڵ,"HideNose" ڵ,"HideMouth" 첿ڵ
    BYTE                byReserved1[3];
    bool                bPicEnble;                          // ǷӦͼƬļϢ
    DH_PIC_INFO         stPicInfo;                          // ӦͼƬϢ
    bool                bShotFrame;                         // Ƿץŵʶ
    bool                bColor;                             // ɫ(rgbaMainColor)Ƿ
    BYTE                byReserved2;
    BYTE                byTimeType;                         // ʱʾͣEM_TIME_TYPE˵
    NET_TIME_EX         stuCurrentTime;                     // ƵŨǰʱץĻʶʱὫʶ֡һƵ֡jpegͼƬУ֡ԭʼƵеĳʱ䣩
    NET_TIME_EX         stuStartTime;                       // ʼʱ忪ʼʱ
    NET_TIME_EX         stuEndTime;                         // ʱʱ
    DH_RECT             stuOriginalBoundingBox;             // Χ()
    DH_RECT             stuSignBoundingBox;                 // Χ
    DWORD               dwCurrentSequence;                  // ǰ֡ţץʱ֡
    DWORD               dwBeginSequence;                    // ʼ֡ţ忪ʼʱ֡ţ
    DWORD               dwEndSequence;                      // ֡ţʱ֡ţ
    INT64               nBeginFileOffset;                   // ʼʱļƫ, λ: ֽڣ忪ʼʱƵ֡ԭʼƵļļʼƫƣ
    INT64               nEndFileOffset;                     // ʱļƫ, λ: ֽڣʱƵ֡ԭʼƵļļʼƫƣ
    BYTE                byColorSimilar[NET_COLOR_TYPE_MAX]; // ɫƶȣȡֵΧ0-100±ֵĳɫEM_COLOR_TYPE
    BYTE                byUpperBodyColorSimilar[NET_COLOR_TYPE_MAX]; // ϰɫƶ(ΪʱЧ)
    BYTE                byLowerBodyColorSimilar[NET_COLOR_TYPE_MAX]; // °ɫƶ(ΪʱЧ)
    int                 nRelativeID;                        // ID
	char				szSubText[20];						// "ObjectType"Ϊ"Vehicle""Logo"ʱʾµĳһϵµA6Lڳϵ϶࣬SDKʵʱ͸ֶ,豸ʵд
    BYTE                byReserved[2];
} DH_MSG_OBJECT;

// ַ
typedef enum tagEM_MSG_OBJ_PERSON_DIRECTION
{
	EM_MSG_OBJ_PERSON_DIRECTION_UNKOWN,			// δ֪
	EM_MSG_OBJ_PERSON_DIRECTION_LEFT_TO_RIGHT,	// 
	EM_MSG_OBJ_PERSON_DIRECTION_RIGHT_TO_LEFT	// 
}EM_MSG_OBJ_PERSON_DIRECTION;

// ƵϢչṹ
typedef struct tagDH_MSG_OBJECT_EX
{
	DWORD				dwSize;
    int                 nObjectID;                          // ID,ÿIDʾһΨһ
    char                szObjectType[128];                  // 
    int                 nConfidence;                        // Ŷ(0~255)ֵԽʾŶԽ
    int                 nAction;                            // 嶯:1:Appear 2:Move 3:Stay 4:Remove 5:Disappear 6:Split 7:Merge 8:Rename
    DH_RECT             BoundingBox;                        // Χ
    DH_POINT            Center;                             // 
    int                 nPolygonNum;                        // ζ
    DH_POINT            Contour[DH_MAX_POLYGON_NUM];        // Ͼȷ
    DWORD               rgbaMainColor;                      // ʾơҪɫֽڱʾֱΪ졢̡͸,:RGBֵΪ(0,255,0),͸Ϊ0ʱ, ֵΪ0x00ff0000.
    char                szText[128];                        // ͬDH_MSG_OBJECTӦֶ	
    char                szObjectSubType[64];                // 𣬸ݲͬͣȡͣ
															// ͬDH_MSG_OBJECTӦֶ
    BYTE                byReserved1[3];
    bool                bPicEnble;                          // ǷӦͼƬļϢ
    DH_PIC_INFO         stPicInfo;                          // ӦͼƬϢ
    bool                bShotFrame;                         // Ƿץŵʶ
    bool                bColor;                             // ɫ(rgbaMainColor)Ƿ
    BYTE                bLowerBodyColor;                    // °ɫ(rgbaLowerBodyColor)Ƿ
    BYTE                byTimeType;                         // ʱʾͣEM_TIME_TYPE˵
    NET_TIME_EX         stuCurrentTime;                     // ƵŨǰʱץĻʶʱὫʶ֡һƵ֡jpegͼƬУ֡ԭʼƵеĳʱ䣩
    NET_TIME_EX         stuStartTime;                       // ʼʱ忪ʼʱ
    NET_TIME_EX         stuEndTime;                         // ʱʱ
    DH_RECT             stuOriginalBoundingBox;             // Χ()
    DH_RECT             stuSignBoundingBox;                 // Χ
    DWORD               dwCurrentSequence;                  // ǰ֡ţץʱ֡
    DWORD               dwBeginSequence;                    // ʼ֡ţ忪ʼʱ֡ţ
    DWORD               dwEndSequence;                      // ֡ţʱ֡ţ
    INT64               nBeginFileOffset;                   // ʼʱļƫ, λ: ֽڣ忪ʼʱƵ֡ԭʼƵļļʼƫƣ
    INT64               nEndFileOffset;                     // ʱļƫ, λ: ֽڣʱƵ֡ԭʼƵļļʼƫƣ
    BYTE                byColorSimilar[NET_COLOR_TYPE_MAX]; // ɫƶȣȡֵΧ0-100±ֵĳɫEM_COLOR_TYPE
    BYTE                byUpperBodyColorSimilar[NET_COLOR_TYPE_MAX]; // ϰɫƶ(ΪʱЧ)
    BYTE                byLowerBodyColorSimilar[NET_COLOR_TYPE_MAX]; // °ɫƶ(ΪʱЧ)
    int                 nRelativeID;                        // ID
	char				szSubText[20];						// "ObjectType"Ϊ"Vehicle""Logo"ʱʾµĳһϵµA6Lڳϵ϶࣬SDKʵʱ͸ֶ,豸ʵд

	int					nPersonStature;						// Աߣλcm
	EM_MSG_OBJ_PERSON_DIRECTION	emPersonDirection;			// Աַ
    DWORD               rgbaLowerBodyColor;                 // ʹ÷ͬrgbaMainColor,ΪʱЧ	
} DH_MSG_OBJECT_EX;
#if (defined(LINUX64) || defined(WIN64))
#else
#pragma pack(pop)
#endif

// ץϢ
typedef struct
{
    short              snSpeed;                         // ǰٶȣkm/h
    short              snCarLength;                     // ǰ,Ϊλ
    float              fRedTime;                        // ǰʱ,.
    float              fCapTime;                        // ǰץʱ,. 
    BYTE               bSigSequence;                    // ǰץ
    BYTE               bType;                           // ǰץ
                                                        // 0: ״;1: ״;2: ;3:
                                                        // 4: ;5: ;6: ;7: ;8: ȫץĻ߿
    BYTE               bDirection;                      // :01:ת;02:ֱк;03:ת
    BYTE               bLightColor;                     // ǰĺ̵״̬0: ̵, 1: , 2: Ƶ
    BYTE               bSnapFlag[16];                   // 豸ץıʶ
}DH_SIG_CARWAY_INFO;

// Ϣ
typedef struct
{
    BYTE                byRedundance[8];                // ɳץźϢ
    BYTE                bReserved[120];                 // ֶ
}DH_SIG_CARWAY_INFO_EX;

// ÿϢ
typedef struct  
{
    BYTE                bCarWayID;                           // ǰ 
    BYTE                bReserve[2];                         // ֶ
    BYTE                bSigCount;                           // ץĵĸ
    DH_SIG_CARWAY_INFO  stuSigInfo[DH_MAX_SNAP_SIGNAL_NUM];  // ǰϣץĶӦץϢ    
    BYTE                bReserved[12];                       // ֶ
}DH_CARWAY_INFO;

// ¼ӦļϢ
typedef struct  
{
    BYTE               bCount;                               // ǰļļеļ
    BYTE               bIndex;                               // ǰļļеļ(1ʼ)
    BYTE               bFileTag;                             // ļǩ˵öEM_EVENT_FILETAG
    BYTE               bFileType;                            // ļͣ0-ͨ 1-ϳ 2-ͼ
    NET_TIME_EX        stuFileTime;                          // ļʱ
    DWORD              nGroupId;                             // ͬһץļΨһʶ
}DH_EVENT_FILE_INFO;

// ͼƬֱ
typedef struct
{
    unsigned short   snWidth;    // 
    unsigned short   snHight;    // 
}DH_RESOLUTION_INFO;

// ɫRGBA
typedef struct tagDH_COLOR_RGBA
{
    int                 nRed;                       // 
    int                 nGreen;                     // 
    int                 nBlue;                      // 
    int                 nAlpha;                     // ͸
} DH_COLOR_RGBA;

// ԱϢ
typedef struct tagFACERECOGNITION_PERSON_INFO
{
    char                szPersonName[DH_MAX_NAME_LEN];                  // ˲                 
    WORD                wYear;                                          // ꣬Ϊѯʱ˲0ʾ˲Ч
    BYTE                byMonth;                                        // £Ϊѯʱ˲0ʾ˲Ч
    BYTE                byDay;                                          // գΪѯʱ˲0ʾ˲Ч
    char                szID[DH_MAX_PERSON_ID_LEN];                     // ԱΨһʾ(֤룬ţ)
    BYTE                bImportantRank;                                 // ԱҪȼ,1~10ֵԽԽҪΪѯʱ˲0ʾ˲Ч
    BYTE                bySex;                                          // Ա1-У2-ŮΪѯʱ˲0ʾ˲Ч
    WORD                wFacePicNum;                                    // ͼƬ
    DH_PIC_INFO         szFacePicInfo[DH_MAX_PERSON_IMAGE_NUM];         // ǰԱӦͼƬϢ
    BYTE                byType;                                         // Աͣ EM_PERSON_TYPE
    BYTE                byIDType;                                       // ֤ͣ EM_CERTIFICATE_TYPE
    BYTE                bReserved1[2];                                  // ֽڶ  
    char                szProvince[DH_MAX_PROVINCE_NAME_LEN];           // ʡ
    char                szCity[DH_MAX_CITY_NAME_LEN];                   // 
    char                szPersonNameEx[DH_MAX_PERSON_NAME_LEN];         // 16ֽ޷⣬Ӵ˲ 
    BYTE                bReserved[60];
}FACERECOGNITION_PERSON_INFO;

// ѡԱϢ
typedef struct tagCANDIDATE_INFO
{
    FACERECOGNITION_PERSON_INFO  stPersonInfo;            // ԱϢ
    BYTE                         bySimilarity;            // ͲѯͼƬƶ,ٷֱȱʾ1~100
    BYTE                         byRange;                 // ԱݿⷶΧEM_FACE_DB_TYPE
    BYTE                         byReserved1[2];
    NET_TIME                     stTime;                  // byRangeΪʷݿʱЧʾѯԱֵʱ
    char                         szAddress[MAX_PATH];     // byRangeΪʷݿʱЧʾѯԱֵĵص    
    BYTE                         byReserved[128];         // ֽ
}CANDIDATE_INFO;

// TrafficCar ͨϢ
typedef struct tagDEV_EVENT_TRAFFIC_TRAFFICCAR_INFO
{
    char               szPlateNumber[32];                   // ƺ
    char               szPlateType[32];                     //     μVideoAnalyseRuleгͶ
    char               szPlateColor[32];                    // ɫ    "Blue","Yellow", "White","Black"
    char               szVehicleColor[32];                  // ɫ    "White", "Black", "Red", "Yellow", "Gray", "Blue","Green"
    int                nSpeed;                              // ٶ    λKm/H
    char               szEvent[64];                         // ¼    μ¼бEvent Listֻͨ¼
    char               szViolationCode[32];                 // Υ´    TrafficGlobal.ViolationCode
    char               szViolationDesc[64];                 // Υ
    int                nLowerSpeedLimit;                    // ٶ
    int                nUpperSpeedLimit;                    // ٶ
    int                nOverSpeedMargin;                    // ޸ٿֵ    λkm/h 
    int                nUnderSpeedMargin;                   // ޵ٿֵ    λkm/h 
    int                nLane;                               //     μ¼бEvent Listпں·¼
    int                nVehicleSize;                        // С,-1ʾδ֪λ
                                                            // 0λ:"Light-duty", Сͳ
                                                            // 1λ:"Medium", ͳ
                                                            // 2λ:"Oversize", ͳ
                                                            // 3λ:"Minisize", ΢ͳ
                                                            // 4λ:"Largesize", 
    float              fVehicleLength;                      //     λ
    int                nSnapshotMode;                       // ץķʽ    0-δ࣬1-ȫ2-4-ͬץģ8-ץģ16-ͼ
    char               szChannelName[32];                   // ػԶ̵ͨƣǵصϢ    ԴͨChannelTitle.Name 
    char               szMachineName[256];                  // ػԶ豸    ԴͨGeneral.MachineName
    char               szMachineGroup[256];                 // 豸λ    ĬΪգûԽͬ豸Ϊһ飬ڹظ
    char               szRoadwayNo[64];                     // ·
    char               szDrivingDirection[3][DH_MAX_DRIVINGDIRECTION];      // 
                                                                            // "DrivingDirection" : ["Approach", "Ϻ", ""],ʻ
                                                                            // "Approach"-У豸ԽԽ"Leave"-У
                                                                            // 豸ԽԽԶڶ͵ֱк
                                                                            // еص
    char              *szDeviceAddress;                     // 豸ַ,OSDӵͼƬϵ,ԴTrafficSnapshot.DeviceAddress,'\0'
    char               szVehicleSign[32];                   // ʶ,  "Unknown"-δ֪, "Audi"-µ, "Honda"- ...
    DH_SIG_CARWAY_INFO_EX stuSigInfo;                       // ɳץźϢ
    char              *szMachineAddr;                       // 豸ص
    float              fActualShutter;                      // ǰͼƬعʱ䣬λΪ
    BYTE               byActualGain;                        // ǰͼƬ棬ΧΪ0~100
    BYTE               byDirection;                         // 0- 1-򶫱 2- 3- 4- 5- 6- 7- 8-δ֪
    BYTE               byReserved[2];
    char*              szDetailedAddress;                   // ϸַ, ΪszDeviceAddressĲ
    char               szDefendCode[DH_COMMON_STRING_64];   // ͼƬα  
    int                nTrafficBlackListID;                 // ݿ¼ĬID, 0Ч> 0ݼ¼
    DH_COLOR_RGBA      stuRGBA;                             // ɫRGBA
    NET_TIME           stSnapTime;                          // ץʱ
    int                nRecNo;                              // ¼
    BYTE               bReserved[736];                      // ֽ,չ.
}DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO;

// ¼EVENT_IVS_CROSSLINEDETECTION(¼)ӦݿϢ
typedef struct tagDEV_EVENT_CROSSLINE_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_MSG_OBJECT       stuObject;                          // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    DH_POINT            DetectLine[DH_MAX_DETECT_LINE_NUM]; // 
    int                 nDetectLineNum;                     // ߶
    DH_POINT            TrackLine[DH_MAX_TRACK_LINE_NUM];   // ˶켣
    int                 nTrackLineNum;                      // ˶켣
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bDirection;                         // ʾַ, 0-, 1-
    BYTE                byReserved[1];
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON
    int                 nSourceIndex;                       // ¼Դ豸ϵindex,-1ʾЧ,-1ʾЧ
    char                szSourceDevice[MAX_PATH];           // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[608];                     // ֽ,չ.
} DEV_EVENT_CROSSLINE_INFO;

// ¼EVENT_IVS_CROSSLINEDETECTION_EX(¼)ӦݿϢ
typedef struct tagDEV_EVENT_CROSSLINE_INFO_EX 
{
	DWORD				dwSize;
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    float				PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_MSG_OBJECT_EX    stuObject;                          // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    DH_POINT            DetectLine[DH_MAX_DETECT_LINE_NUM]; // 
    int                 nDetectLineNum;                     // ߶
    DH_POINT            TrackLine[DH_MAX_TRACK_LINE_NUM];   // ˶켣
    int                 nTrackLineNum;                      // ˶켣
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bDirection;                         // ʾַ, 0-, 1-
    BYTE                byReserved[1];
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON
    int                 nSourceIndex;                       // ¼Դ豸ϵindex,-1ʾЧ,-1ʾЧ
    char                szSourceDevice[MAX_PATH];           // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ

	int					nMsgObjArrayCount;					// ⵽Ϣ
	DH_MSG_OBJECT_EX*	pMsgObjArray;						// ⵽Ϣָ
} DEV_EVENT_CROSSLINE_INFO_EX;

// ¼EVENT_IVS_CROSSREGIONDETECTION(¼)ӦݿϢ
typedef struct tagDEV_EVENT_CROSSREGION_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved2[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_MSG_OBJECT       stuObject;                          // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM]; // 
    int                 nDetectRegionNum;                   // 򶥵
    DH_POINT            TrackLine[DH_MAX_TRACK_LINE_NUM];   // ˶켣
    int                 nTrackLineNum;                      // ˶켣
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bDirection;                         // ʾַ, 0-, 1-뿪2-֣3-뿪
    BYTE                bActionType;                        // ʾ⶯,0- 1-ʧ 2- 3-Խ
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                       // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];           // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[536];                     // ֽ,չ.
    int                 nObjectNum;                         // ⵽
    DH_MSG_OBJECT       stuObjectIDs[DH_MAX_OBJECT_LIST];   // ⵽
    int                 nTrackNum;                          // 켣(⵽Ӧ)
    DH_POLY_POINTS      stuTrackInfo[DH_MAX_OBJECT_LIST];   // 켣Ϣ(⵽Ӧ)
} DEV_EVENT_CROSSREGION_INFO;

// ¼EVENT_IVS_PASTEDETECTION(¼)ӦݿϢ
typedef struct tagDEV_EVENT_PASTE_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_MSG_OBJECT       stuObject;                          // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    int                 nDetectRegionNum;                   // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM]; // 
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[884];                     // ֽ,չ.

} DEV_EVENT_PASTE_INFO;

// ¼EVENT_IVS_LEFTDETECTION(Ʒ¼)ӦݿϢ
typedef struct tagDEV_EVENT_LEFT_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_MSG_OBJECT       stuObject;                          // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nDetectRegionNum;                   // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM]; // 
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                       // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];           // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[620];                     // ֽ,չ.

} DEV_EVENT_LEFT_INFO;

// ¼EVENT_IVS_PRESERVATION(Ʒȫ¼)ӦݿϢ
typedef struct tagDEV_EVENT_PRESERVATION_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_MSG_OBJECT       stuObject;                          // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nDetectRegionNum;                   // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM]; // 
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                       // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];           // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[620];                     // ֽ,չ.

} DEV_EVENT_PRESERVATION_INFO;

// ¼EVENT_IVS_STAYDETECTION(ͣ¼)ӦݿϢ
typedef struct tagDEV_EVENT_STAY_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_MSG_OBJECT       stuObject;                          // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nDetectRegionNum;                   // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM]; // 
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                       // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];           // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[620];                     // ֽ,չ.

} DEV_EVENT_STAY_INFO;

// ¼EVENT_IVS_WANDERDETECTION(ǻ¼)ӦݿϢ
typedef struct tagDEV_EVENT_WANDER_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];                      // ֽ
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nObjectNum;                         // ⵽
    DH_MSG_OBJECT       stuObjectIDs[DH_MAX_OBJECT_LIST];   // ⵽
    int                 nTrackNum;                          // 켣(⵽Ӧ)
    DH_POLY_POINTS      stuTrackInfo[DH_MAX_OBJECT_LIST];   // 켣Ϣ(⵽Ӧ)
    int                 nDetectRegionNum;                   // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];    // 
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                       // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];           // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[756];                     // ֽ,չ.

} DEV_EVENT_WANDER_INFO;

// ¼EVENT_IVS_MOVEDETECTION(ƶ¼)ӦݿϢ
typedef struct tagDEV_EVENT_MOVE_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_MSG_OBJECT       stuObject;                          // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nDetectRegionNum;                   // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];    // 
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                       // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];           // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    int                 nTrackLineNum;                      // ˶켣                 
    DH_POINT            stuTrackLine[DH_MAX_TRACK_LINE_NUM];// ˶켣      
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[536];                     // ֽ,չ.
} DEV_EVENT_MOVE_INFO;

// ¼EVENT_IVS_TAILDETECTION(β¼)ӦݿϢ
typedef struct tagDEV_EVENT_TAIL_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_MSG_OBJECT       stuObject;                          // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nDetectRegionNum;                   // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];    // 
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                       // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];           // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[620];                     // ֽ,չ.

} DEV_EVENT_TAIL_INFO;

// ¼EVENT_IVS_TAILDETECTION(¼)ӦݿϢ
typedef struct tagDEV_EVENT_RIOTER_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    int                 nObjectNum;                         // ⵽
    DH_MSG_OBJECT       stuObjectIDs[DH_MAX_OBJECT_LIST];   // ⵽б
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];                      // ֽ
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nDetectRegionNum;                   // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];    // 

    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                       // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];           // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[624];                     // ֽ,չ.

} DEV_EVENT_RIOTERL_INFO;

// ¼EVENT_IVS_FIGHTDETECTION(Ź¼)ӦݿϢ
typedef struct tagDEV_EVENT_FIGHT_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    int                 nObjectNum;                         // ⵽
    DH_MSG_OBJECT       stuObjectIDs[DH_MAX_OBJECT_LIST];   // ⵽б
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];                      // ֽ
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nDetectRegionNum;                   // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];    // 
    
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                       // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];           // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[624];                     // ֽ,չ.

} DEV_EVENT_FIGHT_INFO;

// ¼EVENT_IVS_FIREDETECTION(¼)ӦݿϢ
typedef struct tagDEV_EVENT_FIRE_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_MSG_OBJECT       stuObject;                          // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];                      // ֽ
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nDetectRegionNum;                   // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];    // 
    
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                       // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];           // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[620];                     // ֽ,չ.

} DEV_EVENT_FIRE_INFO;

// ¼ EVENT_IVS_FIREDETECTION(¼)ӦݿϢ
typedef struct tagDEV_EVENT_ELECTROSPARK_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_MSG_OBJECT       stuObject;                          // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    BYTE                bReserved[972];                     // ֽ,չ.
    
} DEV_EVENT_ELECTROSPARK_INFO;

// ¼EVENT_IVS_SMOKEDETECTION(¼)ӦݿϢ
typedef struct tagDEV_EVENT_SMOKE_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_MSG_OBJECT       stuObject;                          // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON   
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[968];                     // ֽ,չ.

} DEV_EVENT_SMOKE_INFO;

// ¼EVENT_IVS_FLOWSTAT(ͳ¼)ӦݿϢ
typedef struct tagDEV_EVENT_FLOWSTAT_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    int                 nNumberLeft;                        // ߴԽ˵ĸ
    int                 nNumberRight;                       // ұߴԽ˵ĸ
    int                 nUpperLimit;                        // õ
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON  
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[972];                     // ֽ,չ.

} DEV_EVENT_FLOWSTAT_INFO;

// ¼EVENT_IVS_NUMBERSTAT(ͳ¼)ӦݿϢ
typedef struct tagDEV_EVENT_NUMBERSTAT_INFO 
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved2[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    int                 nNumber;                            // ĸ
    int                 nUpperLimit;                        // õ
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bReserved1[2];                      // ֽڶ
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nEnteredNumber;                     // ʾ߳ڵĸ
    int                 nExitedNumber;                      // ʾ߳ڵĸ
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ
    BYTE                bReserved[960];                     // ֽ,չ.

} DEV_EVENT_NUMBERSTAT_INFO;

// ¼EVENT_IVS_CROSSFENCEDETECTION(ԽΧ¼)ӦݿϢ
typedef struct tagDEV_EVENT_CROSSFENCEDETECTION_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    int                 nUpstairsLinePointNumber;                   // Χϱ߶
    DH_POINT            stuUpstairsLine[DH_MAX_DETECT_LINE_NUM];    // ΧϱϢ
    int                 nDownstairsLinePointNumber;                 // Χ±߶
    DH_POINT            stuDownstairsLine[DH_MAX_DETECT_LINE_NUM];  // Χ±Ϣ  
    int                 nTrackLineNum;                              // ˶켣                 
    DH_POINT            TrackLine[DH_MAX_TRACK_LINE_NUM];           // ˶켣
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bDirection;                                 // ʾַ, 0-, 1-
    BYTE                byReserved[1];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                               // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];                   // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                           // ¼ۼƴ
    BYTE                bReserved[748];                             // ֽ,չ.    
} DEV_EVENT_CROSSFENCEDETECTION_INFO;

// ¼EVENT_IVS_INREGIONDETECTION(ڼ¼)ӦݿϢ
typedef struct tagDEV_EVENT_INREGIONDETECTION_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nObjectNum;                                 // ⵽
    DH_MSG_OBJECT       stuObjectIDs[DH_MAX_OBJECT_LIST];           // ⵽
    int                 nTrackNum;                                  // 켣(⵽Ӧ)
    DH_POLY_POINTS      stuTrackInfo[DH_MAX_OBJECT_LIST];           // 켣Ϣ(⵽Ӧ)
    int                 nDetectRegionNum;                           // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];     // 
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    BYTE                bReserved[1016];                            // ֽ,չ.
    
} DEV_EVENT_INREGIONDETECTION_INFO;

// ¼EVENT_IVS_TAKENAWAYDETECTION(Ʒ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TAKENAWAYDETECTION_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    int                 nDetectRegionNum;                           // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];     // 
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                               // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];                   // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                           // ¼ۼƴ
    BYTE                bReserved[748];                             // ֽ,չ.
    
} DEV_EVENT_TAKENAWAYDETECTION_INFO;

// ¼EVENT_IVS_VIDEOABNORMALDETECTION(Ƶ쳣¼)ӦݿϢ
typedef struct tagDEV_EVENT_VIDEOABNORMALDETECTION_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bType;                                      // 쳣, 0-Ƶʧ, 1-Ƶ, 2-ͷڵ, 3-ͷƶ, 4-, 5-
    BYTE                byReserved[1];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                               // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];                   // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                           // ¼ۼƴ
    BYTE                bReserved[752];                             // ֽ,չ.
    
} DEV_EVENT_VIDEOABNORMALDETECTION_INFO;

// ¼EVENT_IVS_PARKINGDETECTION(Ƿͣ¼)ӦݿϢ
typedef struct tagDEV_EVENT_PARKINGDETECTION_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    int                 nDetectRegionNum;                           // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];     // 
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                               // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];                   // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                           // ¼ۼƴ
    BYTE                bReserved[748];                             // ֽ,չ.
    
} DEV_EVENT_PARKINGDETECTION_INFO;

// ¼EVENT_IVS_ABNORMALRUNDETECTION(쳣¼)ӦݿϢ
typedef struct tagDEV_EVENT_ABNORMALRUNDETECTION 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    double              dbSpeed;                                    // ˶ٶ,km/h
    double              dbTriggerSpeed;                             // ٶ,km/h
    int                 nDetectRegionNum;                           // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];     // 
    int                 nTrackLineNum;                              // ˶켣                 
    DH_POINT            TrackLine[DH_MAX_TRACK_LINE_NUM];           // ˶켣
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bRunType;                                   // 쳣, 0-ٱ, 1-ͻȻ, 2-ͻȻ
    BYTE                byReserved[1];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                               // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];                   // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                           // ¼ۼƴ
    BYTE                bReserved[748];                             // ֽ,չ.
    
} DEV_EVENT_ABNORMALRUNDETECTION_INFO;

// ¼EVENT_IVS_RETROGRADEDETECTION(Ա¼)ӦݿϢ
typedef struct tagDEV_EVENT_RETROGRADEDETECTION_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    int                 nTrackLineNum;                              // ˶켣                 
    DH_POINT            TrackLine[DH_MAX_TRACK_LINE_NUM];           // ˶켣
    int                 nDirectionPointNum;                         // 涨ķ򶥵
    DH_POINT            stuDirections[DH_MAX_DETECT_LINE_NUM];      // 涨ķ
    int                 nDetectRegionNum;                           // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];     // 
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                               // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];                   // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                           // ¼ۼƴ
    BYTE                bReserved[748];                             // ֽ,չ.
    
} DEV_EVENT_RETROGRADEDETECTION_INFO;

// ¼EVENT_IVS_FACERECOGNITION(ʶ)ӦݿϢ
typedef struct tagDEV_EVENT_FACERECOGNITION_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    int                 nEventID;                                   // ¼ID
    NET_TIME_EX         UTC;                                        // ¼ʱ
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    int                 nCandidateNum;                              // ǰƥ䵽ĺѡ
    CANDIDATE_INFO      stuCandidates[DH_MAX_CANDIDATE_NUM];        // ǰƥ䵽ĺѡϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    BYTE                byReserved1[2];                             // 
    BOOL                bGlobalScenePic;                            // ȫͼǷ
    DH_PIC_INFO         stuGlobalScenePicInfo;                      // ȫͼƬϢ
    char                szSnapDevAddress[MAX_PATH];                 // ץĵǰ豸ַ磺·37  
    unsigned int        nOccurrenceCount;                           // ¼ۼƴ
    BYTE                bReserved[724];                             // ֽ,չ.
}DEV_EVENT_FACERECOGNITION_INFO;

// ¼EVENT_IVS_DENSITYDETECTION(Աܶȼ)ӦݿϢ
typedef struct tagDEV_EVENT_DENSITYDETECTTION_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nObjectNum;                                 // ⵽
    DH_MSG_OBJECT       stuObjectIDs[DH_MAX_OBJECT_LIST];           // ⵽б
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];                              // ֽ
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nDetectRegionNum;                           // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];     // 
    
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                               // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];                   // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                           // ¼ۼƴ
    BYTE                bReserved[752];                             // ֽ,չ.
}DEV_EVENT_DENSITYDETECTION_INFO;

// ¼ EVENT_IVS_QUEUEDETECTION(ŶӼⱨ¼)ӦݿϢ
typedef struct tagDEV_EVENT_QUEUEDETECTION_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved2[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bReserved1[2];                              // ֽ,չ.
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DH_POINT            stuDetectLine[2];                           // 
    unsigned int        nOccurrenceCount;                           // ¼ۼƴ
    BYTE                bReserved[1012];                            // ֽ,չ.
}DEV_EVENT_QUEUEDETECTION_INFO;

// ¼EVENT_IVS_TRAFFICCONTROL(ͨ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFICCONTROL_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    BYTE                bReserved[972];                             // ֽ,չ.

} DEV_EVENT_TRAFFICCONTROL_INFO;


// ¼EVENT_IVS_TRAFFICACCIDENT(ͨ¹¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFICACCIDENT_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nObjectNum;                                 // ⵽
    DH_MSG_OBJECT       stuObjectIDs[DH_MAX_OBJECT_LIST];           // ⵽б
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    BYTE                bReserved[976];                             // ֽ,չ.

} DEV_EVENT_TRAFFICACCIDENT_INFO;

#define DH_EVENT_MAX_CARD_NUM       16      // ¼ϱϢƬ
#define DH_EVENT_CARD_LEN           36      // ƬƳ

// ¼ϱЯƬϢ
typedef struct tagEVENT_CARD_INFO
{
    char szCardNumber[DH_EVENT_CARD_LEN];           // Ƭַ
    BYTE bReserved[32];                             // ֽ,չ.
}EVENT_CARD_INFO;

typedef enum tagEM_OPEN_STROBE_STATE
{
    NET_OPEN_STROBE_STATE_UNKOWN,                   // δ֪״̬
    NET_OPEN_STROBE_STATE_CLOSE,                    // բ
    NET_OPEN_STROBE_STATE_AUTO,                     // Զբ    
    NET_OPEN_STROBE_STATE_MANUAL,                   // ֶբ
}EM_OPEN_STROBE_STATE;

typedef enum tagEM_VEHICLE_DIRECTION
{
    NET_VEHICLE_DIRECTION_UNKOWN,                   // δ֪
    NET_VEHICLE_DIRECTION_HEAD,                     // ͷ    
    NET_VEHICLE_DIRECTION_TAIL,                     // β  
}EM_VEHICLE_DIRECTION;

//NTPУʱ״̬
typedef enum  tagEM_NTP_STATUS
{
    NET_NTP_STATUS_UNKNOWN = 0 ,
    NET_NTP_STATUS_DISABLE , 
    NET_NTP_STATUS_SUCCESSFUL , 
    NET_NTP_STATUS_FAILED , 
}EM_NTP_STATUS;

typedef struct tagEVENT_COMM_INFO
{
    EM_NTP_STATUS       emNTPStatus;     //NTPУʱ״̬
    int                 nDriversNum;     //ʻԱϢ
    DH_MSG_OBJECT_EX   *pstDriversInfo;  //ʻԱϢ  
    BYTE                bReserved[2036];
}EVENT_COMM_INFO;

// ¼EVENT_IVS_TRAFFICJUNCTION(ͨ·Ϲ¼/Ƶ羯ϵĽͨϹ¼)ӦݿϢ
// ʷԭҪ¼DEV_EVENT_TRAFFICJUNCTION_INFOEVENT_IVS_TRAFFICGATEҪһԷֹƵ羯Ȧ羯ͬʱƽ̨
// EVENT_IVS_TRAFFIC_TOLLGATEֻ֧¿¼
typedef struct tagDEV_EVENT_TRAFFICJUNCTION_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    BYTE                byMainSeatBelt;                             // ʻϵȫ״̬1-ϵȫ2-δϵȫ
    BYTE                bySlaveSeatBelt;                            // ʻϵȫ״̬1-ϵȫ2-δϵȫ
    BYTE                byVehicleDirection;                         // ǰץĵĳǳͷǳβ EM_VEHICLE_DIRECTION
    BYTE                byOpenStrobeState;                          // բ״̬ EM_OPEN_STROBE_STATE 
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    int                 nLane;                                      // Ӧ
    DWORD               dwBreakingRule;                             // Υ,һλ:; 
                                                                    // ڶλ:涨ʻ;
                                                                    // λ:; λΥµͷ;
                                                                    // λ:ͨ; λ:ͨ쳣
                                                                    // λ:ѹʻ; ĬΪ:ͨ·¼

    NET_TIME_EX         RedLightUTC;                                // ƿʼUTCʱ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    int                 nSpeed;                                     // ʵٶKm/h                 
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byDirection;                                // ·ڷ1-ʾ2-ʾ
    BYTE                byLightState;                               // LightStateʾ̵״̬:0 δ֪,1 ̵,2 ,3 Ƶ
    BYTE                byReserved;                                 // ֽ
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    char                szRecordFile[DH_COMMON_STRING_128];         // Ӧԭʼ¼ļϢ
    BYTE                bReserved[344];                             // ֽ,չ.
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    DWORD               dwRetCardNumber;                            // Ƭ
    EVENT_CARD_INFO     stuCardInfo[DH_EVENT_MAX_CARD_NUM];         // ƬϢ   
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
} DEV_EVENT_TRAFFICJUNCTION_INFO;

// ¼EVENT_IVS_TRAFFICGATE(ͨϹ¼/Ȧ羯ϵĽͨϹ¼)ӦݿϢ
// ʷԭҪ¼DEV_EVENT_TRAFFICJUNCTION_INFOEVENT_IVS_TRAFFICGATEҪһԷֹƵ羯Ȧ羯ͬʱƽ̨
// EVENT_IVS_TRAFFIC_TOLLGATEֻ֧¿¼
typedef struct tagDEV_EVENT_TRAFFICGATE_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    BYTE                byOpenStrobeState;                          // բ״̬EM_OPEN_STROBE_STATE
    char                bReserved1[3];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    int                 nLane;                                      // Ӧ
    int                 nSpeed;                                     // ʵٶKm/h
    int                 nSpeedUpperLimit;                           // ٶ λkm/h
    int                 nSpeedLowerLimit;                           // ٶ λkm/h 
    DWORD               dwBreakingRule;                             // Υ,һλ:; 
                                                                    // ڶλ:ѹʻ; λ:ʻ; 
                                                                    // λǷʻ; λ:;λ:·(¼)
                                                                    // λ: ѹ; ڰλ: гռ; ھλ: ռ;ĬΪ:ͨ¼
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ    
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    BYTE                szManualSnapNo[64];                         // ֶץ                
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼; 
    BYTE                byReserved[3];                              // ֽ
    BYTE                szSnapFlag[16];                             // 豸ץıʶ
    BYTE                bySnapMode;                                 // ץķʽ0-δ 1-ȫ 2- 4-ͬץ 8-ץ 16-ͼ
    BYTE                byOverSpeedPercentage;                      // ٰٷֱ
    BYTE                byUnderSpeedingPercentage;                  // Ƿٰٷֱ
    BYTE                byRedLightMargin;                           // ʱ,λ
    BYTE                byDriveDirection;                           // ʻ0-(豸ԽԽ)1-(豸ԽԽԶ)
    char                szRoadwayNo[32];                            // ·
    char                szViolationCode[16];                        // Υ´
    char                szViolationDesc[128];                       // Υ
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    char                szVehicleType[32];                          // Сͣ"Motor" Ħг "Light-duty" Сͳ "Medium" ͳ "Oversize" ͳ "Huge"  "Other" 
    BYTE                byVehicleLenth;                             // , λ
    BYTE                byLightState;                               // LightStateʾ̵״̬:0 δ֪,1 ̵,2 ,3 Ƶ
    BYTE                byReserved1;                             // ֽ,չ
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nOverSpeedMargin;                           // ޸ٿֵ    λkm/h 
    int                 nUnderSpeedMargin;                          // ޵ٿֵ    λkm/h 
    char                szDrivingDirection[3][DH_MAX_DRIVINGDIRECTION]; //
                                                                    // "DrivingDirection" : ["Approach", "Ϻ", ""],ʻ
                                                                    // "Approach"-У豸ԽԽ"Leave"-У
                                                                    // 豸ԽԽԶڶ͵ֱк
                                                                    // еص㣬UTF-8
    char                szMachineName[256];                         // ػԶ豸
    char                szMachineAddress[256];                      // ص㡢·
    char                szMachineGroup[256];                        // 顢豸λ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_SIG_CARWAY_INFO_EX stuSigInfo;                               // ɳץźϢ
    char                szFilePath[MAX_PATH];                       // ļ·
    NET_TIME_EX         RedLightUTC;                                // ƿʼUTCʱ
    char              * szDeviceAddress;                            // 豸ַ,OSDӵͼƬϵ,ԴTrafficSnapshot.DeviceAddress,'\0'
    float               fActualShutter;                             // ǰͼƬعʱ䣬λΪ
    BYTE                byActualGain;                               // ǰͼƬ棬ΧΪ0~100
    BYTE                byDirection;                                // 0- 1-򶫱 2- 3- 4- 5- 6- 7- 8-δ֪
    BYTE                bReserve;                                   // ֽ, ֽڶ
    BYTE                bRetCardNumber;                             // Ƭ
    EVENT_CARD_INFO     stuCardInfo[DH_EVENT_MAX_CARD_NUM];         // ƬϢ
    char               szDefendCode[DH_COMMON_STRING_64];           // ͼƬα
    int                nTrafficBlackListID;                         // ݿ¼ĬID, 0Ч> 0ݼ¼
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
    BYTE                bReserved[452];                             // ֽ,չ.
} DEV_EVENT_TRAFFICGATE_INFO;

//¼EVENT_TRAFFICSNAPSHOT(ͨץ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFICSNAPSHOT_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    BYTE                bReserv[3];                                 // ֽ 
    BYTE                bCarWayCount;                               // ץĵĳ
    DH_CARWAY_INFO      stuCarWayInfo[DH_MAX_CARWAY_NUM];           // ץĵĳϢ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    BYTE                bReserved[344];                             // ֽ,չ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
} DEV_EVENT_TRAFFICSNAPSHOT_INFO;

//¼EVENT_IVS_TRAFFIC_RUNREDLIGHT(ͨ-¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_RUNREDLIGHT_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // Ϣ
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ 
    int                 nLightState;                                // ̵״̬ 0:δ֪ 1̵ 2: 3:Ƶ
    int                 nSpeed;                                     // ,km/h
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    NET_TIME_EX         stRedLightUTC;                              // ƿʼʱ
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                byRedLightMargin;                           // ʱ,λ
    BYTE                bReserved[975];                             // ֽ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
} DEV_EVENT_TRAFFIC_RUNREDLIGHT_INFO;

//¼EVENT_IVS_TRAFFIC_OVERLINE(ͨ-ѹ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_OVERLINE_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // Ϣ
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    int                 nSpeed;                                     // ʵٶ,Km/h
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                bReserved[1008];                            // ֽ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
} DEV_EVENT_TRAFFIC_OVERLINE_INFO;


//¼EVENT_IVS_TRAFFIC_RETROGRADE(ͨ-¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_RETROGRADE_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // Ϣ
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    int                 nSpeed;                                     // ʵٶ,Km/h
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BOOL                bIsExistAlarmRecord;                        // rue:жӦı¼; false:޶Ӧı¼
    DWORD               dwAlarmRecordSize;                          // ¼С
    char                szAlarmRecordPath[DH_COMMON_STRING_256];    // ¼·
    BYTE                bReserved[656];                             // ֽ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    int                 nDetectNum;                                 // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];     // 
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
} DEV_EVENT_TRAFFIC_RETROGRADE_INFO;

//¼EVENT_IVS_TRAFFIC_TURNLEFT(ͨ-Υת)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_TURNLEFT_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // Ϣ
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    int                 nSpeed;                                     // ʵٶ,Km/h
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ

    BYTE                bReserved[1008];                            // ֽ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
} DEV_EVENT_TRAFFIC_TURNLEFT_INFO;


//¼EVENT_IVS_TRAFFIC_TURNRIGHT(ͨ-Υת)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_TURNRIGHT_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // Ϣ
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    int                 nSpeed;                                     // ʵٶ,Km/h
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ

    BYTE                bReserved[1008];                            // ֽ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
} DEV_EVENT_TRAFFIC_TURNRIGHT_INFO;

//¼EVENT_IVS_TRAFFIC_UTURN(Υµͷ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_UTURN_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    int                 nSpeed;                                     // ʵٶ,Km/h
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    
    BYTE                bReserved[1008];                            // ֽ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
}DEV_EVENT_TRAFFIC_UTURN_INFO;

//¼EVENT_IVS_TRAFFIC_OVERSPEED(ͨ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_OVERSPEED_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    int                 nSpeed;                                     // ʵٶKm/h
    int                 nSpeedUpperLimit;                           // ٶ λkm/h
    int                 nSpeedLowerLimit;                           // ٶ λkm/h 
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;    
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    char                szFilePath[MAX_PATH];                       // ļ·
    BYTE                bReserved[748];                             // ֽ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
}DEV_EVENT_TRAFFIC_OVERSPEED_INFO;

//¼EVENT_IVS_TRAFFIC_UNDERSPEED(ͨǷ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_UNDERSPEED_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved2[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    int                 nSpeed;                                     // ʵٶKm/h
    int                 nSpeedUpperLimit;                           // ٶ λkm/h
    int                 nSpeedLowerLimit;                           // ٶ λkm/h 
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bReserved1[2];                              // 
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nUnderSpeedingPercentage;                   // Ƿٰٷֱ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                bReserved[1004];                            // ֽ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
}DEV_EVENT_TRAFFIC_UNDERSPEED_INFO;

//¼EVENT_IVS_FACEDETECT(¼)ӦݿϢ
typedef struct tagDEV_EVENT_FACEDETECT_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                reserved[2];                                // ֽ
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nDetectRegionNum;                           // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];     // 
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON  
    char                szSnapDevAddress[MAX_PATH];                 // ץĵǰ豸ַ磺·37
    unsigned int        nOccurrenceCount;                           // ¼ۼƴ
    BYTE                bReserved[672];                             // ֽ,չ
} DEV_EVENT_FACEDETECT_INFO;

// ¼EVENT_IVS_TRAFFICJAM(ͨӵ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFICJAM_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ               
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bJamLenght;                                 // ʾӵ³(ܳȰٷֱȣ0-100
    BYTE                reserved;                                   // ֽ
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    NET_TIME_EX         stuStartJamTime;                            // ʼͣʱ
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣(bEventAction=2ʱ˲Ч)
    int                 nAlarmIntervalTime;                         // ʱλ:롣(¼Ϊ¼յһ¼֮ڳʱδյ¼ĺ¼Ϊ¼쳣)
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    int                 nJamRealLength;                             // ʵʵӵ³,λ
    BYTE                bReserved[1008];                            // ֽ,չ.
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ  
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
} DEV_EVENT_TRAFFICJAM_INFO;

// ¼EVENT_IVS_TRAFFIC_PARKING(ͨΥͣ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_PARKING_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    int                 nLane;                                      // Ӧ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ               
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                reserved[2];                                // ֽ
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    NET_TIME_EX         stuStartParkingTime;                        // ʼͣʱ
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣(bEventAction=2ʱ˲Ч)
    int                 nAlarmIntervalTime;                         // ʱλ:롣(¼Ϊ¼յһ¼֮ڳʱδյ¼ĺ¼Ϊ¼쳣)
    int                 nParkingAllowedTime;                        // ͣʱλ롣
    int                 nDetectRegionNum;                           // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];     // 
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BOOL                bIsExistAlarmRecord;                        // rue:жӦı¼; false:޶Ӧı¼
    DWORD               dwAlarmRecordSize;                          // ¼С
    char                szAlarmRecordPath[DH_COMMON_STRING_256];    // ¼·
    char                szFTPPath[DH_COMMON_STRING_256];            // FTP· 
    BYTE                bReserved[404];                             // ֽ,չ.
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
} DEV_EVENT_TRAFFIC_PARKING_INFO;

//¼EVENT_IVS_TRAFFIC_WRONGROUTE(ͨΥ-ʻ)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_WRONGROUTE_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    int                 nLane;                                      // Ӧ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ               
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];           
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nSpeed;                                     // ʵٶȣkm/h
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                bReserved[1012];                            // ֽ,չ.
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
} DEV_EVENT_TRAFFIC_WRONGROUTE_INFO;

//¼EVENT_IVS_TRAFFIC_CROSSLANE(ͨΥ-Υ±)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_CROSSLANE_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    int                 nLane;                                      // Ӧ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ               
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];       
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
     int                nSpeed;                                     // ʵٶȣkm/h
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                bReserved[1008];                            // ֽ,չ.չ.
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stuTrafficCar;                 // ͨϢ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ
} DEV_EVENT_TRAFFIC_CROSSLANE_INFO;

//¼EVENT_IVS_TRAFFIC_OVERYELLOWLINE(ͨΥ-ѹ)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_OVERYELLOWLINE_INFO 
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    int                 nLane;                                      // Ӧ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ               
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];  
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nSpeed;                                     // ʵٶȣkm/h
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BOOL                bIsExistAlarmRecord;                        // rue:жӦı¼; false:޶Ӧı¼
    DWORD               dwAlarmRecordSize;                          // ¼С
    char                szAlarmRecordPath[DH_COMMON_STRING_256];    // ¼·
    BYTE                bReserved[664];                             // ֽ,չ.
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ

    int                 nDetectNum;                                 // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];     //     
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

} DEV_EVENT_TRAFFIC_OVERYELLOWLINE_INFO;

//¼EVENT_IVS_TRAFFIC_DRIVINGONSHOULDER(ͨΥ-·ʻ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_DRIVINGONSHOULDER_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    int                 nLane;                                      // Ӧ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ               
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];      
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nSpeed;                                     // ʵٶȣkm/h
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                bReserved[1008];                            // ֽ,չ.
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

} DEV_EVENT_TRAFFIC_DRIVINGONSHOULDER_INFO;

//¼EVENT_IVS_TRAFFIC_YELLOWPLATEINLANE(ͨΥ-Ƴռ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_YELLOWPLATEINLANE_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    int                 nLane;                                      // Ӧ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ               
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];     
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nSpeed;                                     // ʵٶȣkm/h
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                bReserved[1016];                            // ֽ,չ.
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

} DEV_EVENT_TRAFFIC_YELLOWPLATEINLANE_INFO;

//¼EVENT_IVS_TRAFFIC_NOPASSING(ͨΥ-ֹͨ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_NOPASSING_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[DH_EVENT_NAME_LEN];                  // ¼
    int                 nTriggerType;                               // TriggerType:ͣ01״2Ƶ
    DWORD               PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 UTCMS;                                      // 
    int                 nMark;                                      // ײĴץ֡
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    BYTE                byReserved1[3];
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    int                 nFrameSequence;                             // Ƶ֡
    int                 nSource;                                    // ƵԴַ   
    BYTE                byReserved[1024];                           // ֽ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_TRAFFIC_NOPASSING_INFO;

typedef struct tagDH_TRAFFICFLOWSTAT
{
    char                szMachineAddress[256];                      // ͬDEV_EVENT_TRAFFIC_TRAFFICCAR_INFO.MachineGroup
    char                szMachineName[256];                         // ͬDEV_EVENT_TRAFFIC_TRAFFICCAR_INFO.MachineName
    char                szDrivingDirection[3][32];                  // ʻ"Approach"-У豸ԽԽ"Leave"-У豸ԽԽԶڶ͵ֱкеص㣬UTF-8
    int                 nLane;                                      //  ʹûõĳ
    NET_TIME_EX         UTC;                                        // ͳʱ䣬תUTC
    int                 nPeriod;                                    // ͳڣλ
    int                 nVehicles;                                  // ͨ
    float               fAverageSpeed;                              // ƽ٣λkm/h
    float               fAverageLength;                             // ƽλ
    float               fTimeOccupyRatio;                           // ʱռʣλʱͨĳʱܺռλʱı
    float               fSpaceOccupyRatio;                          // ռռʣٷʼĳܺͳʱڳƽʻ
    float               fSpaceHeadway;                              // ͷ࣬ڳ֮ľ룬λ/
    float               fTimeHeadway;                               // ͷʱ࣬λ/
    float               fDensity;                                   // ܶȣÿĳλ/km
    int                 nOverSpeedVehicles;                         // ٳ
    int                 nUnderSpeedVehicles;                        // ٳ
    int                 nLargeVehicles;                             //   жϱ׼μTrafficSnapshotñ
    int                 nMediumVehicles;                            // ͳ
    int                 nSmallVehicles;                             // С
    int                 nMotoVehicles;                              // Ħг
    int                 nLongVehicles;                              // 
}DH_TRAFFICFLOWSTAT; 

// ¼ TrafficFlowStat Info(ͨͳ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_FLOWSTAT_INFO
{
    char                szName[128];                                // ¼
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLaneCnt;                                   // ͨ
    DH_TRAFFICFLOWSTAT  stTrafficFlowStats[DH_MAX_LANE_NUM];        //ͳƼ¼һ
    char                Reserved[4];                                // ֽڶ
}DEV_EVENT_TRAFFIC_FLOWSTAT_INFO;

//¼EVENT_IVS_TRAFFIC_MANUALSNAP(ֶͨץ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_MANUALSNAP_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    BYTE                szManualSnapNo[64];                         // ֶץ 
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // ⵽ĳϢ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ʾͨݿ¼
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                bReserved[1016];                            // ֽ,չ.
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_TRAFFIC_MANUALSNAP_INFO;

//¼ EVENT_IVS_TRAFFIC_STAY(ͨ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_STAY_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    int                 nLane;                                      // Ӧ
    int                 nSequence;                                  // ץţ3-2-1/01ʾץ0ʾץ쳣
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ʾͨݿ¼
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ               
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved0[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                byReserved[1012];         
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_TRAFFIC_STAY_INFO;

//¼ EVENT_IVS_TRAFFIC_VEHICLEINROUTE(гռ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_VEHICLEINROUTE_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    int                 nLane;                                      // Ӧ
    int                 nSequence;                                  // ץţ3-2-1/01ʾץ0ʾץ쳣
    int                 nSpeed;                                     // 
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ʾͨݿ¼
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ               
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved0[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                byReserved[1016];           
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_TRAFFIC_VEHICLEINROUTE_INFO;

// ¼ EVENT_ALARM_LOCALALARM(ⲿ)EVENT_ALARM_MOTIONALARM(챨))
typedef struct tagDEV_EVENT_ALARM_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                Reserved[4];                                // ֽڶ    
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID                                                                                                                                                                                                                                                                         
}DEV_EVENT_ALARM_INFO;

// ¼ EVENT_ALARM_ANALOGALARM(ģͨ),
typedef struct tagDEV_EVENT_ALARM_ANALOGALRM_INFO 
{
    int                 nChannelID;                                 // (Ƶ)ͨ
    char                szName[DH_COMMON_STRING_128];               // ģͨ
    char                Reserved[4];                                // ֽڶ    
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID 
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ   
    int                 nIndex;                                     // ģͨ
    NET_SENSE_METHOD    emSensor;                                   // 
    int                 nStatus;                                    // ״̬, -1:δ֪,0:,1:Ч(),
                                                                    // 2:ֵ1,3:ֵ2,4:ֵ3,5:ֵ4,
                                                                    // 6:ֵ1,7:ֵ2,8:ֵ3,9:ֵ4
    float               fValue;                                     // ֵ̽
    NET_TIME            stuCollectTime;                             // ݲɼʱ(UTC)
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved2[1023];                          // ֽ,չ
}DEV_EVENT_ALARM_ANALOGALRM_INFO;

//EVENT_ALARM_VEHICLEACC(ACCϵ籨)
typedef struct tagDEV_EVENT_ALARM_VEHICLEACC_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[DH_COMMON_STRING_128];               // ¼
    char                Reserved[4];                                // ֽڶ    
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID      
    NET_GPS_STATUS_INFO stGPSStatusInfo;                            // GPSϢ
    int                 nACCStatus;                                 // ACC״̬    0:Ч() , 1: , 2:ر    
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bConstantElectricStatus;                    // ״̬ , 0:Ч() , 1: , 2:Ͽ                            
    BYTE                bReserved[1022];                            // ֽ,չ.
}DEV_EVENT_ALARM_VEHICLEACC_INFO;


// ¼ EVENT_ALARM_VEHICLE_TURNOVER(෭) , EVENT_ALARM_VEHICLE_COLLISION(ײ)
typedef struct tagDEV_EVENT_VEHICEL_ALARM_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                Reserved[4];                                // ֽڶ    
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID  
    NET_GPS_STATUS_INFO stGPSStatusInfo;                            // GPSϢ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];                              // ֽڶ
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                bReserved[1024];                            // ֽ,չ.
}DEV_EVENT_VEHICEL_ALARM_INFO;

// ¼ EVENT_IVS_PRISONERRISEDETECTION (¼) ӦݿϢ
typedef struct tagDEV_EVENT_PRISONERRISEDETECTION_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    int                 nDetectRegionNum;                           // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];     // 
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    double              dInitialUTC;                                // ¼ʼUTCʱ    UTCΪ¼UTC (1970-1-1 00:00:00)
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                               // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];                   // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                           // ¼ۼƴ
    BYTE                bReserved[748];                             // ֽ,չ.
}DEV_EVENT_PRISONERRISEDETECTION_INFO;

//¼ EVENT_IVS_TRAFFIC_PEDESTRAINPRIORITY(¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_PEDESTRAINPRIORITY_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    int                 nLane;                                      // Ӧ
    double              dInitialUTC;                                // ¼ʼUTCʱ    UTCΪ¼UTC (1970-1-1 00:00:00)
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ʾͨݿ¼
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                bReserved[1024];                            // ֽ,չ.
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_TRAFFIC_PEDESTRAINPRIORITY_INFO;

//¼ EVENT_IVS_TRAFFIC_VEHICLEINBUSROUTE(ռù¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_VEHICLEINBUSROUTE_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    int                 nLane;                                      // Ӧ
    int                 nSequence;                                  // ץţ3-2-1/01ʾץ0ʾץ쳣
    int                 nSpeed;                                     // ٣km/h
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ʾͨݿ¼
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                bReserved[1020];                            // ֽ,չ.
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_TRAFFIC_VEHICLEINBUSROUTE_INFO;

//¼ EVENT_IVS_TRAFFIC_BACKING(Υµ¼)ӦݿϢ
typedef struct tagDEV_EVENT_IVS_TRAFFIC_BACKING_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    int                 nLane;                                      // Ӧ
    int                 nSequence;                                  // ץţ3-2-1/01ʾץ0ʾץ쳣
    int                 nSpeed;                                     // ٣km/h
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ʾͨݿ¼
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                bReserved[1020];                            // ֽ,չ.
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_IVS_TRAFFIC_BACKING_INFO;

//¼EVENT_IVS_AUDIO_ABNORMALDETECTION(쳣)ӦݿϢ
typedef struct tagDEV_EVENT_IVS_AUDIO_ABNORMALDETECTION_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    int                 nDecibel;                                   // ǿ
    int                 nFrequency;                                 // Ƶ
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    BYTE                bReserved[1024];                            // ֽ,չ.
}DEV_EVENT_IVS_AUDIO_ABNORMALDETECTION_INFO;

//¼ EVENT_IVS_TRAFFIC_RUNYELLOWLIGHT(ͨΥ-Ƶ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_RUNYELLOWLIGHT_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // Ϣ
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ 
    int                 nLightState;                                // ̵״̬ 0:δ֪ 1̵ 2: 3:Ƶ
    int                 nSpeed;                                     // ,km/h
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    NET_TIME_EX         stYellowLightUTC;                           // Ƶƿʼʱ
    unsigned int        nYellowLightPeriod;                         // Ƶڼʱ,λ
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
     BYTE               byRedLightMargin;                           // Ƶʱ,λ
    char                szSourceDevice[MAX_PATH];                   // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    BYTE                bReserved[1024];                            // ֽ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

} DEV_EVENT_TRAFFIC_RUNYELLOWLIGHT_INFO;

//¼ EVENT_IVS_LEAVEDETECTION(ڼ¼)ӦݿϢ
typedef struct tagDEV_EVENT_IVS_LEAVE_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    int                 nDetectRegionNum;                           // 򶥵
    DH_POINT            DetectRegion[DH_MAX_DETECT_REGION_NUM];     // 
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;    
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    BYTE                bReserved[1026];                            // ֽ
} DEV_EVENT_IVS_LEAVE_INFO;

//¼ EVENT_IVS_CLIMBDETECTION(ʸ߼¼)ӦݿϢ
typedef struct tagDEV_EVENT_IVS_CLIMB_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    int                 nDetectLineNum;                             // ߶
    DH_POINT            DetectLine[DH_MAX_DETECT_LINE_NUM];         // 
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    unsigned int        nOccurrenceCount;                           // ¼ۼƴ
    BYTE                bReserved[1022];                            // ֽ
}DEV_EVENT_IVS_CLIMB_INFO;

//¼ EVENT_IVS_MULTISCENESWITCH(ೡл¼)ӦݿϢ
typedef struct tagDEV_EVENT_IVS_MULTI_SCENE_SWICH_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[4];                              // ֽڶ
    double              PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;    
    BYTE                bReserved[1027];                            // ֽ
} DEV_EVENT_IVS_MULTI_SCENE_SWICH_INFO;

//¼ EVENT_IVS_TRAFFIC_PARKINGONYELLOWBOX(ץ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_PARKINGONYELLOWBOX_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[128];                                // ¼
    char                bReserved1[8];                              // ֽڶ
    DWORD               PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ

    int                 nInterval1;                                 // ڶź͵һŵʱʱ䣬λ
    int                 nInterval2;                                 // ź͵ڶŵʱʱ䣬λ
    int                 nFollowTime;                                // ʱ䣬һǰһʱСڴֵΪǸ룬ͣΥ

    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    BYTE                bReserved[1024];                            // ֽ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_TRAFFIC_PARKINGONYELLOWBOX_INFO;

//¼ EVENT_IVS_TRAFFIC_PARKINGSPACEPARKING(λг¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_PARKINGSPACEPARKING_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[DH_EVENT_NAME_LEN];                  // ¼
    char                bReserved1[8];                              // ֽڶ
    DWORD               PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣    
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    BYTE                bReserved[1024];                            // ֽ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_TRAFFIC_PARKINGSPACEPARKING_INFO;

//¼ EVENT_IVS_TRAFFIC_PARKINGSPACENOPARKING(λ޳¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_PARKINGSPACENOPARKING_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[DH_EVENT_NAME_LEN];                  // ¼
    char                bReserved1[8];                              // ֽڶ
    DWORD               PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;                 // ͨϢ
    BYTE                bReserved[1024];                            // ֽ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_TRAFFIC_PARKINGSPACENOPARKING_INFO;

// ¼ EVENT_IVS_TRAFFIC_PARKINGSPACEOVERLINE (λѹ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_PARKINGSPACEOVERLINE_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[DH_EVENT_NAME_LEN];                  // ¼
    DWORD               PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    DH_MSG_OBJECT       stuVehicle;                                 // Ϣ
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    
    int                 nSequence;                                  // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    BYTE                byEventAction;                              // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    BYTE                byReserved1[2];
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stuTrafficCar;                // ͨϢ
    BYTE                byReserved[1024];                           // ֽ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_TRAFFIC_PARKINGSPACEOVERLINE_INFO;

//¼ EVENT_IVS_TRAFFIC_PEDESTRAIN(ͨ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_PEDESTRAIN_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[DH_EVENT_NAME_LEN];                  // ¼
    char                bReserved1[8];                              // ֽڶ
    DWORD               PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)0λ:"*",1λ:"Timing",2λ:"Manual",3λ:"Marked",4λ:"Event",5λ:"Mosaic",6λ:"Cutout" 
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bReserved2[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    BYTE                bReserved[1024];                            // ֽ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_TRAFFIC_PEDESTRAIN_INFO;

//¼ EVENT_IVS_TRAFFIC_THROW(ͨƷ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_THROW_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[DH_EVENT_NAME_LEN];                  // ¼
    char                bReserved1[8];                              // ֽڶ
    DWORD               PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)0λ:"*",1λ:"Timing",2λ:"Manual",3λ:"Marked",4λ:"Event",5λ:"Mosaic",6λ:"Cutout" 
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bReserved2[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nLane;                                      // Ӧ
    DH_MSG_OBJECT       stuObject;                                  // ⵽
    BYTE                bReserved[1024];                            // ֽ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_TRAFFIC_THROW_INFO;

//¼ EVENT_IVS_TRAFFIC_IDLE(ͨ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_IDLE_INFO
{
    int                 nChannelID;                                 // ͨ
    char                szName[DH_EVENT_NAME_LEN];                  // ¼
    char                bReserved1[8];                              // ֽڶ
    DWORD               PTS;                                        // ʱ(λǺ)
    NET_TIME_EX         UTC;                                        // ¼ʱ
    int                 nEventID;                                   // ¼ID
    DH_EVENT_FILE_INFO  stuFileInfo;                                // ¼ӦļϢ
    DH_RESOLUTION_INFO  stuResolution;                              // ӦͼƬķֱ
    DWORD               dwSnapFlagMask;                             // ץͼ־(λ)0λ:"*",1λ:"Timing",2λ:"Manual",3λ:"Marked",4λ:"Event",5λ:"Mosaic",6λ:"Cutout" 
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                bReserved2[2];
    BYTE                byImageIndex;                               // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    int                 nLane;                                      // Ӧ
    BYTE                bReserved[1024];                            // ֽ
    EVENT_COMM_INFO     stCommInfo;                                 // Ϣ

}DEV_EVENT_TRAFFIC_IDLE_INFO;

#define MAX_DRIVING_DIR_NUM          16                             //  ʻ

// ʻ
typedef enum tagNET_FLOWSTAT_DIRECTION
{
    DRIVING_DIR_UNKNOW = 0 ,                                        //֮ǰ
    DRIVING_DIR_APPROACH ,                                          //У豸ԽԽ
    DRIVING_DIR_LEAVE ,                                             //У豸ԽԽԶ
}NET_FLOWSTAT_DIRECTION;

// ·
typedef enum tagNET_ROAD_DIRECTION
{
    ROAD_DIR_UNKNOW,             // δ֪  
    ROAD_DIR_TURNLEFT,           // ת 
    ROAD_DIR_TURNRIGHT,          // ת
    ROAD_DIR_STRAIGHT,           // ֱ
    ROAD_DIR_UTURU,              // ͷ
    ROAD_DIR_NUM,    
}NET_ROAD_DIRECTION;

//ͳƳʻϢ 
typedef struct tagNET_TRAFFIC_FLOWSTAT_INFO_DIR
{
    NET_FLOWSTAT_DIRECTION      emDrivingDir;                       //ʻ
    char                        szUpGoing[FLOWSTAT_ADDR_NAME];      //еص 
    char                        szDownGoing[FLOWSTAT_ADDR_NAME];    //еص 
    BYTE                        reserved[32];                       //ֽ
    
}NET_TRAFFIC_FLOWSTAT_INFO_DIR;

//·ӵ״
typedef enum tagNET_TRAFFIC_JAM_STATUS
{
    JAM_STATUS_UNKNOW   =0  ,   //δ֪
    JAM_STATUS_CLEAR        ,   //ͨ
    JAM_STATUS_JAMMED       ,   //ӵ
}NET_TRAFFIC_JAM_STATUS;

typedef struct tagNET_TRAFFIC_FLOW_STATE 
{
    int                             nLane;                          // 
    DWORD                           dwState;                        // ״ֵ̬
                                                                    // 1- 
                                                                    // 2- ָ
                                                                    // 3- 
                                                                    // 4- С
                                                                    // 5- Сָ
    DWORD                           dwFlow;                         // ֵ, λ: 
    DWORD                           dwPeriod;                       // ֵӦͳʱ
    NET_TRAFFIC_FLOWSTAT_INFO_DIR   stTrafficFlowDir;               // Ϣ
    int                             nVehicles;                      // ͨ
    float                           fAverageSpeed;                  // ƽ٣λkm/h
    float                           fAverageLength;                 // ƽλ
    float                           fTimeOccupyRatio;               // ʱռʣλʱͨĳʱܺռλʱı
    float                           fSpaceOccupyRatio;              // ռռʣٷʼĳܺͳʱڳƽʻ
    float                           fSpaceHeadway;                  // ͷ࣬ڳ֮ľ룬λ/
    float                           fTimeHeadway;                   // ͷʱ࣬λ/
    float                           fDensity;                       // ܶȣÿĳλ/km
    int                             nOverSpeedVehicles;             // ٳ
    int                             nUnderSpeedVehicles;            // ٳ
    int                             nLargeVehicles;                 // 󳵽ͨ(9<<12)/λʱ
    int                             nMediumVehicles;                // ͳͨ(6<<9)/λʱ
    int                             nSmallVehicles;                 // Сͨ(4<<6)/λʱ䣬
    int                             nMotoVehicles;                  // Ħнͨ(΢ͳ,<4),/λʱ䣬
    int                             nLongVehicles;                  // ͨ(>=12),/λʱ䣬
    int                             nVolume;                        // ͨ, /λʱ, ĳʱͨ·ͨһĳ1Сʱ, 
    int                             nFlowRate;                      // С,/Сʱ, ͨ·ĳһĳһ·εĵСʱ
    int                             nBackOfQueue;                   // Ŷӳȣλ, źŽͣߵŶӳĩ֮ľ
    int                             nTravelTime;                    // ʱ䣬λ, ͨĳһ·ʱ䡣ͣ
    int                             nDelay;                         // 󣬵λ룬ʻԱ˿ͻ˻ѵĶгʱ
    BYTE                            byDirection[MAX_DRIVING_DIR_NUM]; // NET_ROAD_DIRECTION
    BYTE                            byDirectionNum;                 // ʻ
    BYTE                            reserved1[3];                    // ֽڶ
    NET_TRAFFIC_JAM_STATUS          emJamState;                     // ·ӵ״
    BYTE                            reserved[852];                  // ֽ
}NET_TRAFFIC_FLOW_STATE;

//¼ EVENT_IVS_TRAFFIC_FLOWSTATE(ͨ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_FLOW_STATE
{
    int                     nChannelID;                             // ͨ
    char                    szName[DH_EVENT_NAME_LEN];              // ¼
    char                    bReserved1[8];                          // ֽڶ
    DWORD                   PTS;                                    // ʱ(λǺ)
    NET_TIME_EX             UTC;                                    // ¼ʱ
    int                     nEventID;                               // ¼ID
    int                     nSequence;                              // 
    int                     nStateNum;                              // ״̬
    NET_TRAFFIC_FLOW_STATE  stuStates[DH_MAX_LANE_NUM];             // ״̬, ÿӦһԪ
    BYTE                    bReserved[1024];                        // ֽ
}DEV_EVENT_TRAFFIC_FLOW_STATE;

// mediaļѯ
typedef enum __EM_FILE_QUERY_TYPE
{
    DH_FILE_QUERY_TRAFFICCAR,                           // ͨϢ
    DH_FILE_QUERY_ATM,                                  // ATMϢ
    DH_FILE_QUERY_ATMTXN,                               // ATMϢ 
    DH_FILE_QUERY_FACE,                                 // Ϣ MEDIAFILE_FACERECOGNITION_PARAM  MEDIAFILE_FACERECOGNITION_INFO
    DH_FILE_QUERY_FILE,                                 // ļϢӦ NET_IN_MEDIA_QUERY_FILE  NET_OUT_MEDIAFILE_FILE
    DH_FILE_QUERY_TRAFFICCAR_EX,                        // ͨϢ, չDH_FILE_QUERY_TRAFFICCAR, ֶָ֧
    DH_FILE_QUERY_FACE_DETECTION,                       // ¼Ϣ MEDIAFILE_FACE_DETECTION_PARAM  MEDIAFILE_FACE_DETECTION_INFO
} EM_FILE_QUERY_TYPE;

typedef enum _EM_RECORD_SNAP_FLAG_TYPE
{
    FLAG_TYPE_TIMING ,                  //ʱļ
    FLAG_TYPE_MANUAL ,                  //ֶļ
    FLAG_TYPE_MARKED ,                  //Ҫļ
    FLAG_TYPE_EVENT  ,                  //¼ļ
    FLAG_TYPE_MOSAIC ,                  //ϳͼƬ
    FLAG_TYPE_CUTOUT ,                  //ͼͼƬ
    FLAG_TYPE_LEAVE_WORD ,              //ļ
    FLAG_TYPE_TALKBACK_LOCAL_SIDE ,     //Խطļ
    FLAG_TYPE_TALKBACK_REMOTE_SIDE ,    //ԽԶ̷ļ
    FLAG_TYPE_SYNOPSIS_VIDEO ,          //ŨƵ
    FLAG_TYPE_ORIGINAL_VIDEO ,          //ԭʼƵ
    FLAG_TYPE_PRE_ORIGINAL_VIDEO ,      //ѾԤԭʼƵ
    FLAG_TYPE_BLACK_PLATE ,             //ͼƬ
    FLAG_TYPE_ORIGINAL_PIC ,            //ԭʼͼƬ
    FLAG_TYPE_CARD,                     //¼
    FLAG_TYPE_MAX = 128, 
}EM_RECORD_SNAP_FLAG_TYPE;

// ATM
typedef enum
{
    ATM_TRADE_ALL,                      // 
    ATM_TRADE_ENQUIRY,                  // ѯ
    ATM_TRADE_WITHDRAW,                 // ȡ
    ATM_TRADE_MODIFY_PASSWORD,          // ޸
    ATM_TRADE_TRANSFER,                 // ת
    ATM_TRADE_DEPOSIT,                  // 
    ATM_TRADE_CARDLESS_ENQUIRY,         // ޿ѯ
    ATM_TRADE_CARDLESS_DEPOSIT,         // ޿
    ATM_TRADE_OTHER,                    // 
}EM_ATM_TRADE_TYPE;

// ¼Ϣ
typedef struct
{
    DWORD               dwSize;
    int                 nType;          // , 0-Card, 1-Field
    char                szCardNo[DH_MAX_CARD_INFO_LEN]; // 
    EM_ATM_TRADE_TYPE   emTradeType;    // 
    char                szAmount[DH_COMMON_STRING_64]; // ׽, ַʾ޽
    int                 nError;         // , 0-д, 1-̳, 2-̿
    int                 nFieldCount;    // , ѯʱЧ
    char                szFields[MAX_CARD_RECORD_FIELD_NUM][DH_COMMON_STRING_256];   // Ϣ, ѯʱЧ
}NET_RECORD_CARD_INFO;

#define MAX_IVS_EVENT_NUM    256

// ¼ϢӦ CLIENT_FindFileExӿڵ DH_FILE_QUERY_FILE  ѯ
// Ŀǰ֧ͨ·ѯ
typedef struct  
{
    DWORD               dwSize;                 // ṹС
    char*               szDirs;                 // Ŀ¼б,һοɲѯĿ¼,ΪձʾѯĿ¼Ŀ¼֮Էֺŷָ硰/mnt/dvr/sda0;/mnt/dvr/sda1,szDirs==null "" ʾѯ
    int                 nMediaType;             // ļͣ0:ѯ,1:ѯjpgͼƬ,2:ѯdav
    int                 nChannelID;             // ͨŴ0ʼ-1ʾѯͨ
    NET_TIME            stuStartTime;           // ʼʱ    
    NET_TIME            stuEndTime;             // ʱ
    int                 nEventLists[MAX_IVS_EVENT_NUM]; // ¼б,μܷ¼
    int                 nEventCount;            // ¼
    BYTE                byVideoStream;          // Ƶ 0-δ֪ 1- 2-1 3-2 4-3 
    BYTE                bReserved[3];           // ֽڶ
    EM_RECORD_SNAP_FLAG_TYPE emFalgLists[FLAG_TYPE_MAX]; // ¼ץͼļ־, ñ־ʾѯļ
    int                 nFalgCount;             // ־
    NET_RECORD_CARD_INFO stuCardInfo;           // ¼Ϣ, emFalgLists¼ʱЧ
}NET_IN_MEDIA_QUERY_FILE;

// ¼ϢӦ CLIENT_FindFileExӿڵ DH_FILE_QUERY_FILE  ѯ
typedef struct  
{
    DWORD               dwSize;                 // ṹС
    int                 nChannelID;             // ͨŴ0ʼ-1ʾѯͨ
    NET_TIME            stuStartTime;           // ʼʱ    
    NET_TIME            stuEndTime;             // ʱ
    unsigned int        nFileSize;              // ļ
    BYTE                byFileType;             // ļ 1:jpgͼƬ, 2: dav
    BYTE                byDriveNo;              // ̺
    BYTE                byPartition;            // 
    BYTE                byVideoStream;          // Ƶ 0-δ֪ 1- 2-1 3- 4- 
    unsigned int        nCluster;               // غ
    char                szFilePath[MAX_PATH];   // ļ·
    int                 nEventLists[MAX_IVS_EVENT_NUM]; // ¼б,¼б,μܷ¼
    int                 nEventCount;            //¼
    EM_RECORD_SNAP_FLAG_TYPE emFalgLists[FLAG_TYPE_MAX]; // ¼ץͼļ־ 
    int                 nFalgCount;             //־
}NET_OUT_MEDIA_QUERY_FILE;

// DH_MEDIA_QUERY_TRAFFICCARӦĲѯ
typedef struct  
{
    int                 nChannelID;                     // ͨŴ0ʼ-1ʾѯͨ
    NET_TIME            StartTime;                      // ʼʱ    
    NET_TIME            EndTime;                        // ʱ
    int                 nMediaType;                     // ļͣ0:, 1:jpgͼƬ, 2:davļ
    int                 nEventType;                     // ¼ͣ"ܷ¼", 0:ʾѯ¼˲ʹpEventTypes
    char                szPlateNumber[32];              // ƺ, "\0"ʾѯ⳵ƺ
    int                 nSpeedUpperLimit;               // ѯĳٷΧ; ٶ λ: km/h
    int                 nSpeedLowerLimit;               // ѯĳٷΧ; ٶ λ: km/h 
    BOOL                bSpeedLimit;                    // ǷٶȲѯ; TRUE:ٶȲѯ,nSpeedUpperLimitnSpeedLowerLimitЧ
    DWORD               dwBreakingRule;                 // Υͣ
                                                        // ¼Ϊ EVENT_IVS_TRAFFICGATEʱ
                                                        //        һλ:;  ڶλ:ѹʻ; λ:ʻ; 
                                                        //        λǷʻ; λ:;
                                                        // ¼Ϊ EVENT_IVS_TRAFFICJUNCTION
                                                        //        һλ:;  ڶλ:涨ʻ;  
                                                        //        λ:; λΥµͷ;
                                                        //        λ:ѹʻ;

    char                szPlateType[32];                // ͣ"Unknown" δ֪,"Normal" ƺ,"Yellow" ,"DoubleYellow" ˫β,"Police" "Armed" 侯,
                                                        // "Military" Ӻ,"DoubleMilitary" ˫,"SAR" ۰,"Trainning" 
                                                        // "Personal" Ժ,"Agri" ũ,"Embassy" ʹݺ,"Moto" Ħг,"Tractor" ,"Other" 
    char                szPlateColor[16];               // ɫ, "Blue"ɫ,"Yellow"ɫ, "White"ɫ,"Black"ɫ
    char                szVehicleColor[16];             // ɫ:"White"ɫ, "Black"ɫ, "Red"ɫ, "Yellow"ɫ, "Gray"ɫ, "Blue"ɫ,"Green"ɫ
    char                szVehicleSize[16];              // С:"Light-duty":Сͳ;"Medium":ͳ; "Oversize":ͳ; "Unknown": δ֪
    int                 nGroupID;                       // ¼(ֵ>=0ʱЧ)
    short               byLane;                         // (ֵ>=0ʱʾ峵-1ʾг·ֶ)
    BYTE                byFileFlag;                     // ļ־, 0xFF-ʹnFileFlagEx, 0-ʾ¼, 1-ʱļ, 2-ֶļ, 3-¼ļ, 4-Ҫļ, 5-ϳļ
    BYTE                byRandomAccess;                 // ǷҪڲѯת0-Ҫ1-Ҫ
    int                 nFileFlagEx;                    // ļ־, λʾ: bit0-ʱļ, bit1-ֶļ, bit2-¼ļ, bit3-Ҫļ, bit4-ϳļ, bit5-ͼƬ 0xFFFFFFFF-¼
    int                 nDirection;                     // 򣨳ķ    0- 1- 2- 3- 4- 5- 6- 7- 8-δ֪ -1-з
    char*               szDirs;                         // Ŀ¼б,һοɲѯĿ¼,ΪձʾѯĿ¼Ŀ¼֮Էֺŷָ硰/mnt/dvr/sda0;/mnt/dvr/sda1,szDirs==null "" ʾѯ
    int*                pEventTypes;                    // ѯ¼ָ,¼,"ܷ¼"ΪNULLΪѯ¼û룩
    int                 nEventTypeNum;                  // ¼С
    char*               pszDeviceAddress;               // 豸ַ, NULLʾֶβ
    char*               pszMachineAddress;              // ص, NULLʾֶβ
    char*               pszVehicleSign;                 // ʶ,  "Unknown"-δ֪, "Audi"-µ, "Honda"-... NULLʾֶβ
    int                 bReserved[32];                  // ֶ
} MEDIA_QUERY_TRAFFICCAR_PARAM;

// DH_MEDIA_QUERY_TRAFFICCARѯmediaļϢ
typedef struct
{
    unsigned int        ch;                                 // ͨ
    char                szFilePath[128];                    // ļ·
    unsigned int        size;                               // ļ
    NET_TIME            starttime;                          // ʼʱ
    NET_TIME            endtime;                            // ʱ
    unsigned int        nWorkDirSN;                         // Ŀ¼                                    
    BYTE                nFileType;                          // ļ  1jpgͼƬ
    BYTE                bHint;                              // ļλ
    BYTE                bDriveNo;                           // ̺
    BYTE                bReserved2;
    unsigned int        nCluster;                           // غ
    BYTE                byPictureType;                      // ͼƬ, 0-ͨ, 1-ϳ, 2-ͼ
    BYTE                bReserved[3];                       // ֶ

    //ǽͨϢ
    char                szPlateNumber[32];                  // ƺ
    char                szPlateType[32];                    // "Unknown" δ֪; "Normal" ƺ; "Yellow" ; "DoubleYellow" ˫β
                                                            // "Police" ; "Armed" 侯; "Military" Ӻ; "DoubleMilitary" ˫
                                                            // "SAR" ۰; "Trainning" ; "Personal" Ժ; "Agri" ũ
                                                            // "Embassy" ʹݺ; "Moto" Ħг; "Tractor" ; "Other" 
    char                szPlateColor[16];                   // ɫ:"Blue","Yellow", "White","Black"
    char                szVehicleColor[16];                 // ɫ:"White", "Black", "Red", "Yellow", "Gray", "Blue","Green"
    int                 nSpeed;                             // ,λKm/H
    int                 nEventsNum;                         // ¼
    int                 nEvents[32];                        // ¼б,ֵʾӦ¼"ܷ¼"        
    DWORD               dwBreakingRule;                     // Υ,һλ:; ڶλ:涨ʻ;
                                                            // λ:; λΥµͷ;ĬΪ:ͨ·¼
    char                szVehicleSize[16];                  // С:"Light-duty":Сͳ;"Medium":ͳ; "Oversize":ͳ
    char                szChannelName[DH_CHAN_NAME_LEN];    // ػԶ̵ͨ
    char                szMachineName[DH_MAX_NAME_LEN];     // ػԶ豸

    int                 nSpeedUpperLimit;                   // ٶ λ: km/h
    int                 nSpeedLowerLimit;                   // ٶ λ: km/h    
    int                 nGroupID;                           // ¼
    BYTE                byCountInGroup;                     // һ¼ڵץ
    BYTE                byIndexInGroup;                     // һ¼ڵץ
    BYTE                byLane;                             // ,μMEDIA_QUERY_TRAFFICCAR_PARAM
    BYTE                bReserved1[21];                     // 
    NET_TIME            stSnapTime;                          // ץʱ
    int                 nDirection;                         // ,μMEDIA_QUERY_TRAFFICCAR_PARAM
    char                szMachineAddress[MAX_PATH];         // ص
} MEDIAFILE_TRAFFICCAR_INFO, *LPMEDIAFILE_TRAFFICCAR_INFO;

// DH_MEDIA_QUERY_TRAFFICCAR_EXӦĲѯ
typedef struct tagMEDIA_QUERY_TRAFFICCAR_PARAM_EX
{
    DWORD               dwSize;
    MEDIA_QUERY_TRAFFICCAR_PARAM stuParam;                  // ѯ
} MEDIA_QUERY_TRAFFICCAR_PARAM_EX;

// DH_MEDIA_QUERY_TRAFFICCAR_EXѯļϢ
typedef struct tagMEDIAFILE_TRAFFICCAR_INFO_EX
{
    DWORD               dwSize;
    MEDIAFILE_TRAFFICCAR_INFO stuInfo;                          // Ϣ
    char                szDeviceAddr[DH_COMMON_STRING_256];     // 豸ַ
    char                szVehicleSign[DH_COMMON_STRING_32];     // ʶ,  "Unknown"-δ֪, "Audi"-µ, "Honda"-...
} MEDIAFILE_TRAFFICCAR_INFO_EX;

// FINDNEXTѯ
typedef struct __NET_FINDNEXT_RESERVED
{
    DWORD               dwSize;                         // ṹС
    
    unsigned int        nBeginNumber;                   // ѯʼţʾbeginNumber¼ʼ 0<=beginNumber<= totalCount-1
}NET_FINDNEXT_RESERVED;

// ѯת
typedef struct __NET_FINDING_JUMP_OPTION_INFO
{
    DWORD           dwSize;
    int             nOffset;                            // ѯƫ, ڵǰѯĵһѯλƫ
}NET_FINDING_JUMP_OPTION_INFO;

// DH_FILE_QUERY_FACEӦʶѯ
typedef struct __MEDIAFILE_FACERECOGNITION_PARAM
{
    DWORD               dwSize;                         // ṹС

    // ѯ
    NET_TIME            stStartTime;                    // ʼʱ
    NET_TIME            stEndTime;                      // ʱ
    char                szMachineAddress[MAX_PATH];     // ص㣬֧ģƥ     
    int                 nAlarmType;                     // ѯͣ EM_FACERECOGNITION_ALARM_TYPE
    BOOL                abPersonInfo;                   // ԱϢǷЧ
    FACERECOGNITION_PERSON_INFO stPersonInfo;           // ԱϢ
    int                 nChannelId;                     // ͨ  
    int                 nGroupIdNum;                    // Ա   
    char                szGroupId[MAX_GOURP_NUM][DH_COMMON_STRING_64]; // ԱID 
}MEDIAFILE_FACERECOGNITION_PARAM;

typedef struct  tagDH_PIC_INFO_EX
{
    DWORD                dwSize;                        // ṹС
    DWORD                dwFileLenth;                   // ļС, λ:ֽ
    char                 szFilePath[MAX_PATH];          // ļ·          
}DH_PIC_INFO_EX;

typedef struct __NET_CANDIDAT_PIC_PATHS
{
    DWORD                dwSize;                        // ṹС
    int                  nFileCount;                    // ʵļ
    DH_PIC_INFO_EX       stFiles[DH_MAX_PERSON_IMAGE_NUM];//ļϢ
}NET_CANDIDAT_PIC_PATHS;

// DH_FILE_QUERY_FACEӦʶFINDNEXTѯز
typedef struct __MEDIAFILE_FACERECOGNITION_INFO
{
    DWORD                   dwSize;                                 // ṹС
    BOOL                    bGlobalScenePic;                        // ȫͼǷ
    DH_PIC_INFO_EX          stGlobalScenePic;                       // ȫͼƬļ·
    DH_MSG_OBJECT           stuObject;                              // ĿϢ
    DH_PIC_INFO_EX          stObjectPic;                            // Ŀļ·
    int                     nCandidateNum;                          // ǰƥ䵽ĺѡ
    CANDIDATE_INFO          stuCandidates[DH_MAX_CANDIDATE_NUM];    // ǰƥ䵽ĺѡϢ
    NET_CANDIDAT_PIC_PATHS  stuCandidatesPic[DH_MAX_CANDIDATE_NUM]; // ǰƥ䵽ĺѡͼƬļ·
    NET_TIME                stTime;                                 // ʱ  
    char                    szAddress[MAX_PATH];                    // ص
    int                     nChannelId;                             // ͨ   
}MEDIAFILE_FACERECOGNITION_INFO;

typedef enum __EM_FACEPIC_TYPE
{
    NET_FACEPIC_TYPE_UNKOWN,            // δ֪
    NET_FACEPIC_TYPE_GLOBAL_SENCE,      // ȫͼ
    NET_FACEPIC_TYPE_SMALL,             // Сͼ
}EM_FACEPIC_TYPE;

#define  NET_MAX_FRAMESEQUENCE_NUM     2
#define  NET_MAX_TIMESTAMP_NUM         2

typedef struct __MEDIAFILE_FACE_DETECTION_DETAIL_PARAM
{
    DWORD               dwSize;
    DWORD               dwObjectId;                     // ID
    DWORD               dwFrameSequence;                // ֡
    NET_TIME_EX         stTime;                         // ʱ
}MEDIAFILE_FACE_DETECTION_DETAIL_PARAM;
 
// DH_FILE_QUERY_FACE_DETECTION Ӧʶѯ
typedef struct __MEDIAFILE_FACE_DETECTION_PARAM
{
    DWORD               dwSize;                         // ṹС
    
    // ѯ
    int                 nChannelID;                     // ͨ
    NET_TIME            stuStartTime;                   // ʼʱ
    NET_TIME            stuEndTime;                     // ʱ
    EM_FACEPIC_TYPE     emPicType;                      // ͼƬͣ EM_FACEPIC_TYPE
    BOOL                bDetailEnable;                  // ǷϸϢ
    MEDIAFILE_FACE_DETECTION_DETAIL_PARAM stuDetail;    // ϸϢ

}MEDIAFILE_FACE_DETECTION_PARAM;

// DH_FILE_QUERY_FACE_DETECTIONӦʶFINDNEXTѯز
typedef struct __MEDIAFILE_FACE_DETECTION_INFO
{
    DWORD               dwSize;                                     // ṹС

    unsigned int        ch;                                         // ͨ
    char                szFilePath[128];                            // ļ·
    unsigned int        size;                                       // ļ
    NET_TIME            starttime;                                  // ʼʱ
    NET_TIME            endtime;                                    // ʱ
    unsigned int        nWorkDirSN;                                 // Ŀ¼                                    
    BYTE                nFileType;                                  // ļ  1jpgͼƬ
    BYTE                bHint;                                      // ļλ
    BYTE                bDriveNo;                                   // ̺
    BYTE                byPictureType;                              // ͼƬ, 0-ͨ, 1-ϳ, 2-ͼ
    unsigned int        nCluster;                                   // غ
    
    EM_FACEPIC_TYPE     emPicType;                                  // ͼƬͣEM_FACE_PIC_TYPE
    DWORD               dwObjectId;                                 // ID
    DWORD               dwFrameSequence[NET_MAX_FRAMESEQUENCE_NUM]; // ֡,2ԪʱһʾСͼڶʾͼ
    int                 nFrameSequenceNum;                          // ֡Ÿ 
    NET_TIME_EX         stTimes[NET_MAX_TIMESTAMP_NUM];             // ʱ䣬2ԪʱһʾСͼڶʾͼ
    int                 nTimeStampNum;
}MEDIAFILE_FACE_DETECTION_INFO;

// ƵŨļѯ
typedef struct __MEDIA_QUERY_VIDEOSYNOPSIS_PARAM
{
    DWORD               dwSize;
    NET_TIME            StartTime;                          // ʼʱ    
    NET_TIME            EndTime;                            // ʱ
    int                 nMediaType;                         // ļͣ0:ѯ,1:ͼƬ,2:¼
    int                 nQueryType;                         // ѯͣ1:ԭʼƵļ 2:ŨƵļ
}MEDIA_QUERY_VIDEOSYNOPSIS_PARAM;

typedef struct __MEDIAFILE_VIDEOSYNOPSIS_INFO
{
    char                szFilePath[128];                    // ļ·
    unsigned int        size;                               // ļ
    NET_TIME            starttime;                          // ʼʱ
    NET_TIME            endtime;                            // ʱ
    unsigned int        nWorkDirSN;                         // Ŀ¼                                    
    BYTE                nFileType;                          // ļ  1jpgͼƬ
    BYTE                bHint;                              // ļλ
    BYTE                bDriveNo;                           // ̺
    BYTE                bReserved2;
    unsigned int        nCluster;                           // غ
    BYTE                byPictureType;                      // ͼƬ, 0-ͨ, 1-ϳ, 2-ͼ
    BYTE                bReserved[3];                       // ֶ

    // ƵԴļϢ
    int                 nTaskID;                            // ID
    char                szCurrentState[DH_MAX_SYNOPSIS_STATE_NAME]; // ƵŨ״̬
    int                 nProgress;                          // ӦŨ״̬
    int                 nObjectNum;                         // Ũõ

    // ŨƵļϢ
    int                 nDurationTime;                      // ʱ,λs
}MEDIAFILE_VIDEOSYNOPSIS_INFO;

// ṹ(NET_IN_SNAPSHOT)Ա صƵڿ     һ飬ÿԪضӦһ
typedef struct __NET_FLASHCONTROL
{
    DWORD               dwSize;                             // ˽ṹС
    int                 nMode;                              // ģʽ    0-ֹ⣬1-ʼ⣬2-Զ
}NET_FLASHCONTROL;

// ץĿͻ
typedef enum tagSNAP_CLIENT_TYPE
{
    SNAP_CLIENT_TYPE_COMMON,                // Ӧ"Common", Ĭ
    SNAP_CLIENT_TYPE_PARKINGSPACE,          // Ӧ"ParkingSpace", ͣ
}SNAP_CLIENT_TYPE;

#define DH_MAX_USER_DEFINE_INFO        1024

// nTriggerType==2ʱ ͻ˴ץĲ
typedef struct _NET_CLIENT_SNAP_INFO
{
    DWORD               dwSize;                                         // ˽ṹС
    unsigned int        nFrameSequence;                                 // ֡
    double              PTS;                                            // ʱ,64λʱ
    char                szUserDefinedInfo[DH_MAX_USER_DEFINE_INFO];     // ַͻԶ,"\0"β
    SNAP_CLIENT_TYPE    emSNAP_CLIENT_TYPE;                             // ͻ
    DWORD               dwRetCardNumber;                                // Ƭ
    EVENT_CARD_INFO     stuCardInfo[DH_EVENT_MAX_CARD_NUM];             // ƬϢ     
}NET_CLIENT_SNAP_INFO;

// ӿ(CLIENT_TrafficSnapByNetwork)
typedef struct __NET_IN_SNAPSHOT
{
    DWORD                   dwSize;                     // ˽ṹС
    int                     nTriggerType;               //     0-δ֪    1-紥 2-ͻ˴ʱֻҪдstClientInfo
    int                     nLaneID;                    // 
    int                     nGroupID;                   // 
    int                     nGrabTimes;                 // ץͼƬ
    int                     nStartPicNum;               // һͼƬʼ
    int                     nDirection;                 // 򣨳ķ    0- 1- 2- 3- 4- 5- 6- 7- 8-δ֪
    //NET_GRAB_WAITTIME     stGrabWaitTime;             // ͼƬ֮ץļ
    int                     nGrabWaitTime;              // pGrabWaitTimeԱ
    DWORD*                  pGrabWaitTime;              // ͼƬ֮ץļ
    int                     nLowerSpeedLimit;           // ٶޣλkm/h
    int                     nUpperSpeedLimit;           // ٶޣλkm/h
    int                     nSpeed;                     // ٣λkm/h
    int                     nViolationNo;               // Υ    0-δΥ
                                                        // 1-
                                                        // 2-ٲ50% 
                                                        // 3-50%100%֮
                                                        // 4-ٳ100%
                                                        // 5-
                                                        // 6-
                                                        // 7-
                                                        // 8-Уʻ
    int                     nRedLightTime;              // ʱ䣬Ƶʱ󴥷ץģλ
    //NET_FLASHCONTROL      stFlashControl;             // صƵڿ
    int                     nFlashControl;              // pFlashControl
    NET_FLASHCONTROL*       pFlashControl;              // صƵڿ
    DWORD                   dwUser;                     // û NSP
    NET_CLIENT_SNAP_INFO    stClientInfo;               // ͻ˴ʱץĲ
}NET_IN_SNAPSHOT;

// ӿ(CLIENT_TrafficSnapByNetwork)
typedef struct __NET_OUT_SNAPSHOT
{
    DWORD                dwSize;                    // ˽ṹС
}NET_OUT_SNAPSHOT;

// ӿ(CLIENT_TrafficForceLightState)
typedef struct __NET_IN_FORCELIGHTSTATE
{
    DWORD               dwSize;                     // ˽ṹС
    unsigned int        nDirection;                 // λʾ0λ"Straight",1λ"TurnLeft",2λ"TurnRight",3λ"U-Turn"
}NET_IN_FORCELIGHTSTATE;

// ӿ(CLIENT_TrafficForceLightState)
typedef struct __NET_OUT_FORCELIGHTSTATE
{
    DWORD                dwSize;                    // ˽ṹС
}NET_OUT_FORCELIGHTSTATE;

// ӿ(CLIENT_StartTrafficFluxStat)ص
typedef int  (CALLBACK *fFluxStatDataCallBack)(LLONG lFluxStatHandle, DWORD dwEventType, void* pEventInfo, BYTE *pBuffer, DWORD dwBufSize, LDWORD dwUser, int nSequence, void *reserved);

// ӿ(CLIENT_StartTrafficFluxStat)
typedef struct __NET_IN_TRAFFICFLUXSTAT
{
    DWORD                   dwSize;                 // ˽ṹС
    fFluxStatDataCallBack   cbData;                 // صָ
    LDWORD                  dwUser;                 // û
}NET_IN_TRAFFICFLUXSTAT;

// ӿ(CLIENT_StartTrafficFluxStat)
typedef struct __NET_OUT_TRAFFICFLUXSTAT
{
    DWORD                dwSize;                    // ˽ṹС    
}NET_OUT_TRAFFICFLUXSTAT;

// ӿ(CLIENT_StartFindFluxStat)
typedef struct __NET_IN_TRAFFICSTARTFINDSTAT
{
    DWORD               dwSize;                     // ˽ṹС
    NET_TIME            stStartTime;                // ʼʱ ʱȷСʱ
    NET_TIME            stEndTime;                  // ʱ ʱȷСʱ
    int                 nWaittime;                  // ȴݵĳʱʱ
}NET_IN_TRAFFICSTARTFINDSTAT;

// ӿ(CLIENT_StartFindFluxStat)
typedef struct __NET_OUT_TRAFFICSTARTFINDSTAT
{
    DWORD               dwSize;                     // ˽ṹС
    DWORD               dwTotalCount;               // ϴ˴βѯĽ                 
}NET_OUT_TRAFFICSTARTFINDSTAT;

// ӿ(CLIENT_DoFindFluxStat)
typedef struct __NET_IN_TRAFFICDOFINDSTAT
{
    DWORD               dwSize;                     // ˽ṹС
    unsigned int        nCount;                     // ÿβѯͳ
    int                 nWaittime;                  // ȴݵĳʱʱ
}NET_IN_TRAFFICDOFINDSTAT;

typedef struct
{
    DWORD               dwSize;                     // ˽ṹС
    int                 nStatInfo;                  // ͳϢ
    DH_TRAFFICFLOWSTAT  *pStatInfo;                 // ͳϢָ
}DH_TRAFFICFLOWSTAT_OUT;

// ӿ(CLIENT_DoFindFluxStat)
typedef struct __NET_OUT_TRAFFICDOFINDSTAT
{
    DWORD                   dwSize;                 // ˽ṹС
    DH_TRAFFICFLOWSTAT_OUT  stStatInfo;             // ͳϢָ
}NET_OUT_TRAFFICDOFINDSTAT;

// ӿ(CLIENT_StartFindNumberStat)
typedef struct __NET_IN_FINDNUMBERSTAT
{
    DWORD               dwSize;                     // ˽ṹС
    int                 nChannelID;                 // Ҫвѯͨ
    NET_TIME            stStartTime;                // ʼʱ ʱȷСʱ
    NET_TIME            stEndTime;                  // ʱ ʱȷСʱ
    int                 nGranularityType;           // ѯ0:ӣ1:Сʱ,2:,3:,4:,5:,6:
    int                 nWaittime;                  // ȴݵĳʱʱ
}NET_IN_FINDNUMBERSTAT;

// ӿ(CLIENT_StartFindNumberStat)
typedef struct __NET_OUT_FINDNUMBERSTAT
{
    DWORD               dwSize;                     // ˽ṹС
    DWORD               dwTotalCount;               // ϴ˴βѯĽ
}NET_OUT_FINDNUMBERSTAT;

// ӿ(CLIENT_DoFindNumberStat)
typedef struct __NET_IN_DOFINDNUMBERSTAT
{
    DWORD               dwSize;                     // ˽ṹС
    unsigned int        nBeginNumber;               // [0, totalCount-1], ѯʼţʾbeginNumber¼ʼȡcount¼; 
    unsigned int        nCount;                     // ÿβѯͳ
    int                 nWaittime;                  // ȴݵĳʱʱ            
}NET_IN_DOFINDNUMBERSTAT;

typedef struct __DH_NUMBERSTAT
{
    DWORD    dwSize;
    int      nChannelID;                           //ͳͨ
    char     szRuleName[DH_CHAN_NAME_LEN];         //
    NET_TIME stuStartTime;                         //ʼʱ
    NET_TIME stuEndTime;                           //ʱ
    int      nEnteredSubTotal;                     //С
    int      nExitedSubtotal;                      //ȥС
    int      nAvgInside;                           //ƽ(ȥֵ)
    int      nMaxInside;                           //
    int      nEnteredWithHelmet;                   //ȫñС
    int      nEnteredWithoutHelmet;                //ȫñС
    int      nExitedWithHelmet;                    //ȫñȥС
    int      nExitedWithoutHelmet;                 //ȫñȥС
}DH_NUMBERSTAT;

// ӿ(CLIENT_DoFindNumberStat)
typedef struct __NET_OUT_DOFINDNUMBERSTAT
{
    DWORD               dwSize;                          // ˽ṹС
    int                 nCount;                          // ѯͳϢ
    DH_NUMBERSTAT       *pstuNumberStat;                 // ͳϢ
    int                 nBufferLen;                      // ûڴС,DH_NUMBERSTATеdwsizeСΪλ
}NET_OUT_DOFINDNUMBERSTAT;

//// ܽͨؽӿڲ

// ӿ CLIENT_GetParkingSpaceStatus 
typedef struct tagNET_IN_GET_PARKINGSPACE_STATUS
{
    DWORD                dwSize;                         // ˽ṹС
    DWORD                dwWaitTime;                     // ӿڳʱȴʱ
    int                  nChannelID;                     // ͨ
    int *                pLaneID;                        // ȡֵΧ[0,255], pLaneID==NULLʾгλ,λͬDH_PRODUCTION_DEFNITION.nMaxRoadWays
    int                  nLaneCount;                     // ڴΪsizeof(int)*nLaneCount
} NET_IN_GET_PARKINGSPACE_STATUS;

typedef struct tagNET_LANE_PARKINGSPACE_STATUS
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nLaneID;                        // λ
    unsigned int         nPictureId;                     // ͼƬID,ڻȡͼƬ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;      // ͨϢ
} NET_LANE_PARKINGSPACE_STATUS;

// ӿ CLIENT_GetParkingSpaceStatus 
typedef struct tagNET_OUT_GET_PARKINGSPACE_STATUS
{
    DWORD                dwSize;                         // ˽ṹС
    NET_LANE_PARKINGSPACE_STATUS* pStatus;               // صĳλ״̬
    int                  nMaxStatus;                     // ҪڴΪsizeof(NET_LANE_PARKINGSPACE_STATUS)*nMaxStatusnMaxStatus == DH_PRODUCTION_DEFNITION.nMaxRoadWays
    int                  nRetStatus;                     // ʵʷصĳλ״̬
} NET_OUT_GET_PARKINGSPACE_STATUS;

// ӿ CLIENT_AttachParkingSpaceData 
typedef struct tagNET_CB_PARKINGSPACE_DATA
{
    DWORD                dwSize;                         // ˽ṹС
    void*                pPicBuffer;                     // ͼƬ
    unsigned int         nPicLength;                     // ͼƬܳ
} NET_CB_PARKINGSPACE_DATA;

// ӿ CLIENT_AttachParkingSpaceData صpBufjsonͼƬݣnBufLenpBufӦȣת
typedef int (CALLBACK *fNotifySnapData)(LLONG lParkingHandle, NET_CB_PARKINGSPACE_DATA* pDiagnosisInfo, void* pBuf, int nBufLen, LDWORD dwUser);

// ӿ CLIENT_AttachParkingSpaceData 
typedef struct tagNET_IN_ATTACH_PARKINGSPACE
{
    DWORD                dwSize;                         // ˽ṹС
    DWORD                dwWaitTime;                     // ӿڳʱȴʱ
    int                  nChannelID;                     // ͨ
    unsigned int         nPictureId;                     // ͼƬID,NET_LANE_PARKINGSPACE_STATUS.nPictureId
    
    fNotifySnapData      cbNotifySnapData;               // ص
    LDWORD               dwUser;                         // ûԶ
} NET_IN_ATTACH_PARKINGSPACE;

// ӿ CLIENT_AttachParkingSpaceData 
typedef struct tagNET_OUT_ATTACH_PARKINGSPACE
{
    DWORD                dwSize;                         // ˽ṹС
} NET_OUT_ATTACH_PARKINGSPACE;

// ӿ CLIENT_DetachParkingSpaceData 
typedef struct tagNET_IN_DETACH_PARKINGSPACE
{
    DWORD                dwSize;                         // ˽ṹС
    DWORD                dwWaitTime;                     // ӿڳʱȴʱ
    LLONG                lParkingHandle;                 // CLIENT_AttachParkingSpaceDataصľ
} NET_IN_DETACH_PARKINGSPACE;
// ӿ CLIENT_DetachParkingSpaceData 
typedef struct tagNET_OUT_DETACH_PARKINGSPACE
{
    DWORD                dwSize;                         // ˽ṹС
} NET_OUT_DETACH_PARKINGSPACE;

// ļ

// ؽȻصԭͣ nErrorʾعֵ̳Ĵ1-治㣬2-ԷݵУ3-صǰļʧܣ4-Ӧļʧ
typedef void (CALLBACK *fMultiFileDownLoadPosCB)(LLONG lDownLoadHandle, DWORD dwFileID, DWORD dwFileTotalSize, DWORD dwDownLoadSize, int nError, LDWORD dwUser, void* pReserved);

// CLIENT_DownLoadMultiFile ӿڲ
typedef struct tagNET_DOWNLOADFILE_INFO
{
    DWORD               dwSize;
    DWORD               dwFileID;                       // ļID, ûԼ
    int                 nFileSize;                      // ѯļС
    char                szSourceFilePath[MAX_PATH];     // ѯļ·
    char                szSavedFileName[MAX_PATH];      // ļ·
}NET_DOWNLOADFILE_INFO;

typedef struct tagNET_IN_DOWNLOAD_MULTI_FILE
{
    DWORD                   dwSize;
    int                     nFileCount;                 // ļ
    NET_DOWNLOADFILE_INFO*  pFileInfos;                 // ļϢ
    fMultiFileDownLoadPosCB cbPosCallBack;              // Ȼص
    LDWORD                  dwUserData;                 // û
}NET_IN_DOWNLOAD_MULTI_FILE;

typedef struct tagNET_OUT_DOWNLOAD_MULTI_FILE
{
    DWORD               dwSize;
    LLONG               lDownLoadHandle;                // ؾ
}NET_OUT_DOWNLOAD_MULTI_FILE;

typedef struct __NET_VIDEOANALYSE_STATE
{
    DWORD            dwSize;
    DWORD            dwProgress;                        // ȣ0-100
    char             szState[DH_COMMON_STRING_64];      // ͨ״̬,Running"У"Stop"ֹͣ"NoStart"δ"Failed"ʧܣ"Successed"ɹ
    char             szFailedCode[DH_COMMON_STRING_64]; // 
}NET_VIDEOANALYSE_STATE;

//Ƶ״̬ʵʱص
typedef int (CALLBACK *fVideoAnalyseState)(LLONG lAttachHandle, NET_VIDEOANALYSE_STATE* pAnalyseStateInfos, LDWORD dwUser, void* pReserved);

// CLIENT_AttachVideoAnalyseStateӿ
typedef struct __NET_IN_ATTACH_VIDEOANALYSE_STATE 
{
    DWORD              dwSize;
    int                nChannleId;            // ͨ
    fVideoAnalyseState cbVideoAnalyseState;   // Ƶ״̬ص
    LDWORD             dwUser;                // ûϢ 
}NET_IN_ATTACH_VIDEOANALYSE_STATE;

// CLIENT_AttachVideoAnalyseStateӿ
typedef struct __NET_OUT_ATTACH_VIDEOANALYSE_STATE 
{
    DWORD              dwSize;
    LLONG              lAttachHandle;         // ȾΨһʶĳһͨķ
}NET_OUT_ATTACH_VIDEOANALYSE_STATE;

///////////////////////////////// IVS Ƶģ /////////////////////////////////
// ƵϱͶ
#define NET_DIAGNOSIS_DITHER                    "VideoDitherDetection"                       // Ƶ Ӧṹ(NET_VIDEO_DITHER_DETECTIONRESULT)
#define NET_DIAGNOSIS_STRIATION                 "VideoStriationDetection"                    // ƵƼ Ӧṹ(NET_VIDEO_STRIATION_DETECTIONRESULT)
#define NET_DIAGNOSIS_LOSS                      "VideoLossDetection"                         // Ƶʧ Ӧṹ(NET_VIDEO_LOSS_DETECTIONRESULT)
#define NET_DIAGNOSIS_COVER                     "VideoCoverDetection"                        // Ƶڵ Ӧṹ(NET_VIDEO_COVER_DETECTIONRESULT)
#define NET_DIAGNOSIS_FROZEN                    "VideoFrozenDetection"                       // Ƶ Ӧṹ(NET_VIDEO_FROZEN_DETECTIONRESULT)
#define NET_DIAGNOSIS_BRIGHTNESS                "VideoBrightnessDetection"                   // Ƶ쳣 Ӧṹ(NET_VIDEO_BRIGHTNESS_DETECTIONRESULT)
#define NET_DIAGNOSIS_CONTRAST                  "VideoContrastDetection"                     // ƵԱȶ쳣 Ӧṹ(NET_VIDEO_CONTRAST_DETECTIONRESULT)
#define NET_DIAGNOSIS_UNBALANCE                 "VideoUnbalanceDetection"                    // Ƶƫɫ Ӧṹ(NET_VIDEO_UNBALANCE_DETECTIONRESULT)
#define NET_DIAGNOSIS_NOISE                     "VideoNoiseDetection"                        // Ƶ Ӧṹ(NET_VIDEO_NOISE_DETECTIONRESULT)
#define NET_DIAGNOSIS_BLUR                      "VideoBlurDetection"                         // Ƶģ Ӧṹ(NET_VIDEO_BLUR_DETECTIONRESULT)
#define NET_DIAGNOSIS_SCENECHANGE               "VideoSceneChangeDetection"                  // Ƶ仯 Ӧṹ(NET_VIDEO_SCENECHANGE_DETECTIONRESULT)

typedef enum tagNET_STATE_TYPE
{
    NET_EM_STATE_ERR,        // 
    NET_EM_STATE_NORMAL,     // "Normal"  
    NET_EM_STATE_WARNING,    // "Warning" 
    NET_EM_STATE_ABNORMAL,   // "Abnormal" 쳣
}NET_STATE_TYPE;
// Ƶ
typedef enum tagNET_STREAM_TYPE
{
    NET_EM_STREAM_ERR,                      // 
    NET_EM_STREAM_MAIN,                     // "Main"-
    NET_EM_STREAM_EXTRA_1,                  // "Extra1"-1
    NET_EM_STREAM_EXTRA_2,                  // "Extra2"-2
    NET_EM_STREAM_EXTRA_3,                  // "Extra3"-3
    NET_EM_STREAM_SNAPSHOT,                 // "Snapshot"-ץͼ
    NET_EM_STREAM_OBJECT,                   // "Object"-
    NET_EM_STREAM_AUTO,                     // "Auto"-Զѡ
    NET_EM_STREAM_PREVIEW,                  // "Preview"-Ԥ
    NET_EM_STREAM_NONE,                     // Ƶ(Ƶ)
}NET_STREAM_TYPE;
// ƵϽ
typedef enum tagNET_VIDEODIAGNOSIS_RESULT_TYPE
{
    NET_EM_ROTATION,                        // "Rotation"    -ƵѲ
    NET_EM_REAL,                            // "Real" -ʵʱƵ
    NET_EM_NR_UNKNOW,                       // δ
}NET_VIDEODIAGNOSIS_RESULT_TYPE;
//Ƶϴԭ
typedef enum tagNET_VIDEODIAGNOSIS_FAIL_TYPE
{
    NET_EM_NO_ERROR,                        // ϳɹ
    NET_EM_DISCONNECT,                      // "Disconnect" - ĩ豸
    NET_EM_CH_NOT_EXIST,                    // "ChannelNotExist" - ͨ
    NET_EM_LOGIN_OVER_TIME,                 // "LoginOverTime" - ¼ʱ
    NET_EM_NO_VIDEO,                        // "NoVideo" - ¼ɹƵ
    NET_EM_NO_RIGHT,                        // "NoRight" - ޲Ȩ
    NET_EM_PLATFROM_LOGIN_FAILED,           // "PlatformLoginFailed" - ƽ̨ʧ
    NET_EM_PLATFROM_DISCONNECT,             // "PlatformDisconnect" - ƽ̨Ͽ
    NET_EM_GET_STREAM_OVER_TIME,            // "GetStreamOverTime" - ȡʱ
    NET_EM_NF_UNKNOW,                       //  ԭṹʧԭ
}NET_VIDEODIAGNOSIS_FAIL_TYPE;

// ͨñ䳤ַԡ\0
typedef struct tagNET_ARRAY
{
    DWORD          dwSize;                  // ˽ṹС
    char*          pArray;                  //  ĿǰС260ֽڣڴ ݱ֤'\0'
    DWORD          dwArrayLen;              // ռ䳤
}NET_ARRAY;

// ƵϽϱͨ
typedef struct tagNET_VIDEODIAGNOSIS_COMMON_INFO
{
    DWORD                           dwSize;                                 // ˽ṹС
    int                             nDiagnosisID;                           // ͨ
    NET_ARRAY                       stProject;                              // ƻ
    NET_ARRAY                       stTask;                                 // 
    NET_ARRAY                       stProfile;                              // 
    NET_ARRAY                       stDeviceID;                             // 豸Ψһ־
    NET_TIME                        stStartTime;                            // ʼʱ
    NET_TIME                        stEndTime;                              // ʱ
    int                             nVideoChannelID;                        // Ƶͨ ǰ豸DVR,IPCͨ
    NET_STREAM_TYPE                 emVideoStream;                          // Ƶ
    NET_VIDEODIAGNOSIS_RESULT_TYPE  emResultType;                           // Ͻ 
    BOOL                            bCollectivityState;                     // Ͻ
    NET_VIDEODIAGNOSIS_FAIL_TYPE    emFailedCause;                          // ʧԭ
    char                            szFailedCode[DH_COMMON_STRING_64];      // ʧԭ
    char                            szResultAddress[DH_COMMON_STRING_128];  // Ͻŵַ
}NET_VIDEODIAGNOSIS_COMMON_INFO;

// Ӧ(NET_DIAGNOSIS_DITHER) Ƶ -- 仯 紵ζת̨ת
typedef struct tagNET_VIDEO_DITHER_DETECTIONRESULT
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nValue;                         // ֵ
    NET_STATE_TYPE       emState;                        // ״̬  һС쳣мǾ
    int                  nDuration;                      // ״̬ʱ  ʱ ʱ
}NET_VIDEO_DITHER_DETECTIONRESULT;
// Ӧ(NET_DIAGNOSIS_STRIATION)ƵƼ -- ܵų쳣
typedef struct tagNET_VIDEO_STRIATION_DETECTIONRESULT
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nValue;                         // ֵ
    NET_STATE_TYPE       emState;                        // ״̬
    int                  nDuration;                      // ״̬ʱ
}NET_VIDEO_STRIATION_DETECTIONRESULT;
// Ӧ(NET_DIAGNOSIS_LOSS)Ƶʧ -- ϵ ߵɵ
typedef struct tagNET_VIDEO_LOSS_DETECTIONRESULT
{
    DWORD                dwSize;                         // ˽ṹС
    NET_STATE_TYPE       emState;                        // ״̬
    int                  nDuration;                      // ״̬ʱ
}NET_VIDEO_LOSS_DETECTIONRESULT;
// Ӧ(NET_DIAGNOSIS_COVER)Ƶڵ -- ڵ
typedef struct tagNET_VIDEO_COVER_DETECTIONRESULT
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nValue;                         // ֵ
    NET_STATE_TYPE       emState;                        // ״̬
    int                  nDuration;                      // ״̬ʱ
}NET_VIDEO_COVER_DETECTIONRESULT;
// Ӧ(NET_DIAGNOSIS_FROZEN)Ƶ -- 治Ϊ
typedef struct tagNET_VIDEO_FROZEN_DETECTIONRESULT
{
    DWORD                dwSize;                         // ˽ṹС
    NET_STATE_TYPE       emState;                        // ״̬
    int                  nDuration;                      // ״̬ʱ
}NET_VIDEO_FROZEN_DETECTIONRESULT;
// Ӧ(NET_DIAGNOSIS_BRIGHTNESS)Ƶ쳣 --òȷһЩ
typedef struct tagNET_VIDEO_BRIGHTNESS_DETECTIONRESULT
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nValue;                         // ֵ
    NET_STATE_TYPE       emState;                        // ״̬
    int                  nDuration;                      // ״̬ʱ
}NET_VIDEO_BRIGHTNESS_DETECTIONRESULT;
// Ӧ(NET_DIAGNOSIS_CONTRAST)ƵԱȶ쳣
typedef struct tagNET_VIDEO_CONTRAST_DETECTIONRESULT
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nValue;                         // ֵ
    NET_STATE_TYPE       emState;                        // ״̬
    int                  nDuration;                      // ״̬ʱ
}NET_VIDEO_CONTRAST_DETECTIONRESULT;
// Ӧ(NET_DIAGNOSIS_UNBALANCE)Ƶƫɫ쳣
typedef struct tagNET_VIDEO_UNBALANCE_DETECTIONRESULT
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nValue;                         // ֵ
    NET_STATE_TYPE       emState;                        // ״̬
    int                  nDuration;                      // ״̬ʱ
}NET_VIDEO_UNBALANCE_DETECTIONRESULT;
// Ӧ(NET_DIAGNOSIS_NOISE)Ƶ쳣
typedef struct tagNET_VIDEO_NOISE_DETECTIONRESULT
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nValue;                         // ֵ
    NET_STATE_TYPE       emState;                        // ״̬
    int                  nDuration;                      // ״̬ʱ
}NET_VIDEO_NOISE_DETECTIONRESULT;
// Ӧ(NET_DIAGNOSIS_BLUR)Ƶģ쳣
typedef struct tagNET_VIDEO_BLUR_DETECTIONRESULT
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nValue;                         // ֵ
    NET_STATE_TYPE       emState;                        // ״̬
    int                  nDuration;                      // ״̬ʱ
}NET_VIDEO_BLUR_DETECTIONRESULT;
// Ӧ(NET_DIAGNOSIS_SCENECHANGE)Ƶ仯
typedef struct tagNET_VIDEO_SCENECHANGE_DETECTIONRESULT
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nValue;                         // ֵ
    NET_STATE_TYPE       emState;                        // ״̬
    int                  nDuration;                      // ״̬ʱ
}NET_VIDEO_SCENECHANGE_DETECTIONRESULT;

typedef struct tagNET_DIAGNOSIS_RESULT_HEADER
{
    DWORD                dwSize;                         // ˽ṹС

    char                 szDiagnosisType[MAX_PATH];      // ͣdhnetsdk.h"ƵϱͶ" NET_DIAGNOSIS_DITHER
    int                  nDiagnosisTypeLen;              // ͽṹС
}NET_DIAGNOSIS_RESULT_HEADER;

// cbVideoDiagnosis ص
typedef struct tagNET_REAL_DIAGNOSIS_RESULT
{
    DWORD                dwSize;                         // ˽ṹС
    NET_VIDEODIAGNOSIS_COMMON_INFO* pstDiagnosisCommonInfo;  //ƵͨϢ
    int                  nTypeCount;                     // Ͻ͸
    void*                pDiagnosisResult;               // һϽݣʽNET_DIAGNOSIS_RESULT_HEADER+1+NET_DIAGNOSIS_RESULT_HEADER+2+...
    DWORD                dwBufSize;                      // 峤
}NET_REAL_DIAGNOSIS_RESULT;

//ƵϽϱص
typedef int (CALLBACK *fRealVideoDiagnosis)(LLONG lDiagnosisHandle, NET_REAL_DIAGNOSIS_RESULT* pDiagnosisInfo, void* pBuf, int nBufLen, LDWORD dwUser);

// ӿ CLIENT_StartVideoDiagnosis 
typedef struct tagNET_IN_VIDEODIAGNOSIS
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nDiagnosisID;                   // ƵID0ʼ
    DWORD                dwWaitTime;                     // ӿڳʱȴʱ
    fRealVideoDiagnosis  cbVideoDiagnosis;               // ƵϽص
    LDWORD               dwUser;                         // ûԶ
}NET_IN_VIDEODIAGNOSIS;

// ӿ CLIENT_StartVideoDiagnosis 
typedef struct tagNET_OUT_ATTACH_REALDIAGNOSIS
{
    DWORD                dwSize;                         // ˽ṹС
    LLONG                lDiagnosisHandle;               // ľ
}NET_OUT_VIDEODIAGNOSIS;

// ӿ CLIENT_StartFindDiagnosisResult 
typedef struct tagNET_IN_FIND_DIAGNOSIS
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nDiagnosisID;                   // ƵID0ʼ
    DWORD                dwWaitTime;                     // ӿڳʱȴʱ
    NET_ARRAY            stuDeviceID;                    // 豸Ψһ־,pArray:NULLʾʹ豸IDѯ
    NET_TIME             stuStartTime;                   // ʼʱ
    NET_TIME             stuEndTime;                     // ʱ
    int                  nVideoChannel;                  // Ƶͨ,-1:ͨ
    int                  nTypeCount;                     // ͸,0:ʹͲѯ
    NET_ARRAY*           pstDiagnosisTypes;              // 飬ʾҪѯ
    char                 szProjectName[MAX_PATH];        // ƻ
} NET_IN_FIND_DIAGNOSIS;

// ӿ CLIENT_StartFindDiagnosisResult 
typedef struct tagNET_OUT_FIND_DIAGNOSIS
{
    DWORD                dwSize;                         // ˽ṹС
    LLONG                lFindHandle;                    // ѯ
    DWORD                dwTotalCount;                   // ܸ
}NET_OUT_FIND_DIAGNOSIS;

// ӿ CLIENT_DoFindDiagnosisResult 
typedef struct tagNET_IN_DIAGNOSIS_INFO
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nDiagnosisID;                   // ƵID0ʼ
    DWORD                dwWaitTime;                     // ӿڳʱȴʱ
    int                  nFindCount;                     // ÿβѯƵϽ
    int                  nBeginNumber;                   // ѯʼ 0<=beginNumber<= totalCount-1
}NET_IN_DIAGNOSIS_INFO;

// CLIENT_StartRealTimeProject ӿ
typedef struct tagNET_IN_START_RT_PROJECT_INFO
{
    DWORD                dwSize;                         // ˽ṹС
    char*                pszProjectInfo;                 // ʵʱƻϢͨdhconfigsdk.dllнӿCLIENT_PacketDataװõ
                                                         // ӦķװΪ CFG_CMD_VIDEODIAGNOSIS_REALPROJECT                      
}NET_IN_START_RT_PROJECT_INFO;

// CLIENT_StartRealTimeProject ӿ
typedef struct tagNET_OUT_START_RT_PROJECT_INFO
{
    DWORD                dwSize;                         // ˽ṹС
}NET_OUT_START_RT_PROJECT_INFO;

// CLIENT_StopRealTimeProject ӿ
typedef struct tagNET_IN_STOP_RT_PROJECT_INFO
{
    DWORD                dwSize;                         // ˽ṹС
    char*                pszProjectNames;                // ƻƣ&&ΪֵķָʾProject1&&Project2   
}NET_IN_STOP_RT_PROJECT_INFO; 

// CLIENT_StopRealTimeProject ӿ
typedef struct tagNET_OUT_STOP_RT_PROJECT_INFO
{
    DWORD                dwSize;                         // ˽ṹС
}NET_OUT_STOP_RT_PROJECT_INFO;

// λϢ
typedef struct tagNET_CARPORTLIGHT_INFO
{
    DWORD               dwSize;  
    NET_CARPORTLIGHT_TYPE emType;                        // λ
    NET_CARPORTLIGHT_MODE emMode;                        // λƷʽ
}NET_CARPORTLIGHT_INFO;

// λ״̬
typedef struct tagNET_CARPORTLIGHT_STATUS
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nLightNum;                      // λ 
    NET_CARPORTLIGHT_INFO stuLights[DH_MAX_CARPORTLIGHT_NUM]; // λϢ,emTypeظһƺһ̵
    int                  nFiringTime;                    // ״̬ʱ,λ
    int                  nHoldTime;                      // ״̬ʱ,λ룬-1ʾޱ֣0ʾп
}NET_CARPORTLIGHT_STATUS;

// ӿCLIENT_GetCarPortLightStatus
typedef struct tagNET_IN_GET_CARPORTLIGHT_STATUS
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nChannelId;                     // ͨ
}NET_IN_GET_CARPORTLIGHT_STATUS;

// ӿCLIENT_GetCarPortLightStatus
typedef struct tagNET_OUT_GET_CARPORTLIGHT_STATUS
{
    DWORD                   dwSize;                      // ˽ṹС
    NET_CARPORTLIGHT_STATUS stuLightStatus;              // λ״̬
}NET_OUT_GET_CARPORTLIGHT_STATUS;

// ӿ CLIENT_SetCarPortLightStatus 
typedef struct tagNET_IN_SET_CARPORTLIGHT_STATUS
{
    DWORD                   dwSize;                      // ˽ṹС
    int                     nChannelId;
    NET_CARPORTLIGHT_STATUS stuLightStatus;              // λ״̬
}NET_IN_SET_CARPORTLIGHT_STATUS;

// ӿ CLIENT_SetCarPortLightStatus 
typedef struct tagNET_OUT_SET_CARPORTLIGHT_STATUS
{
    DWORD                dwSize;                         // ˽ṹС
    
}NET_OUT_SET_CARPORTLIGHT_STATUS;


typedef struct tagNET_DEV_VIDEODIAGNOSIS_MULTI_INFO
{
    DWORD                dwSize;                                // ˽ṹС

    NET_VIDEODIAGNOSIS_COMMON_INFO*       pstDiagnosisCommonInfo;//ƵͨϢ  ½ṹָҪ߷
    BOOL                 abDither;                              // ڱʾ˴νǷЧ
    NET_VIDEO_DITHER_DETECTIONRESULT*     pstDither;            // Ƶ    
    BOOL                 abStration;
    NET_VIDEO_STRIATION_DETECTIONRESULT*  pstStration;          // ƵƼ    
    BOOL                 abLoss;
    NET_VIDEO_LOSS_DETECTIONRESULT*       pstLoss;              // Ƶʧ    
    BOOL                 abCover;
    NET_VIDEO_COVER_DETECTIONRESULT*      pstCover;             // Ƶڵ    
    BOOL                 abFrozen;
    NET_VIDEO_FROZEN_DETECTIONRESULT*     pstFrozen;            // Ƶ   
    BOOL                 abBrightness;
    NET_VIDEO_BRIGHTNESS_DETECTIONRESULT* pstBrightness;        // Ƶ쳣    
    BOOL                 abContrast;
    NET_VIDEO_CONTRAST_DETECTIONRESULT*   pstContrast;          // ƵԱȶ쳣   
    BOOL                 abUnbalance;
    NET_VIDEO_UNBALANCE_DETECTIONRESULT*  pstUnbalance;         // Ƶƫɫ    
    BOOL                 abNoise;
    NET_VIDEO_NOISE_DETECTIONRESULT*      pstNoise;             // Ƶ    
    BOOL                 abBlur;
    NET_VIDEO_BLUR_DETECTIONRESULT*       pstBlur;              // Ƶģ    
    BOOL                 abSceneChange;
    NET_VIDEO_SCENECHANGE_DETECTIONRESULT* pstSceneChange;      // Ƶ仯
}NET_VIDEODIAGNOSIS_RESULT_INFO;

// ӿ CLIENT_DoFindDiagnosisResult 
typedef struct tagNET_OUT_DIAGNOSIS_INFO
{
    DWORD                dwSize;                         // ˽ṹС

    int                  nInputNum;                      // ûNET_DEV_RESULT_VIDEODIAGNOSIS_INFO
    int                  nReturnNum;                     // ؽ
    NET_VIDEODIAGNOSIS_RESULT_INFO*  pstDiagnosisResult; //   ṹָҪ߷
}NET_OUT_DIAGNOSIS_INFO;

///////////////////////////////// ʽ豸ģ //////////////////////////////////////////////////////
///////////////////////////////// CLIENT_OperateMasterSlaveDeviceӿڲ /////////////////////////////////
#define        MASTERSLAVE_CMD_START                   "masterSlaveTracker.start"                   // ʽ
#define        MASTERSLAVE_CMD_STOP                    "masterSlaveTracker.stop"                    // ֹͣʽ
#define        MASTERSLAVE_CMD_MANUALTRACK             "masterSlaveTracker.manualSelectObjectTrack" // ֶѡĿ
#define        MASTERSLAVE_CMD_POINTTRACK              "masterSlaveTracker.selectPointTrack"        // 
#define        MASTERSLAVE_CMD_GETCALIBPOINTS          "masterSlaveTracker.getCalibratePoints"      // õб궨
#define        MASTERSLAVE_CMD_CALIBRATE               "masterSlaveTracker.calibrate"               // 궨
#define        MASTERSLAVE_CMD_ADDCALIBPOINT           "masterSlaveTracker.addCalibratePoint"       // ӱ궨
#define        MASTERSLAVE_CMD_REMOVECALIBPOINT        "masterSlaveTracker.removeCalibratePoint"    // ɾ궨
#define        MASTERSLAVE_CMD_MARKMAXZOOM             "masterSlaveTracker.markSceneMaxZoom"        // 궨ٱ, ѵǰΪ

// ʽ豸
typedef struct __NET_MS_PAIRPOINTS
{
    int                nStructSize;
    DH_POINT           stMasterPoint;    // 궨㣬һ[0,8192]
    DH_POINT           stSlavePoint;     // 궨㣬һ[0,8192]
}NET_MS_PAIRPOINTS;
//MASTERSLAVE_CMD_STARTṹ
typedef struct __NET_IN_MS_START
{
    int                nStructSize;
}NET_IN_MS_START;

//MASTERSLAVE_CMD_STARTṹ
typedef struct __NET_OUT_MS_START
{
    int                nStructSize;
}NET_OUT_MS_START;

//MASTERSLAVE_CMD_STOPṹ
typedef struct __NET_IN_MS_STOP
{
    int                nStructSize;
}NET_IN_MS_STOP;

//MASTERSLAVE_CMD_STOPṹ
typedef struct __NET_OUT_MS_STOP
{
    int                nStructSize;
}NET_OUT_MS_STOP;

//MASTERSLAVE_CMD_MANUALTRACKṹ
typedef struct __NET_IN_MS_MANUALTRACK
{
    int                nStructSize;
    DWORD              dwObject;          // -1 ʾλ, >=0ʾָ壨Դ豸֡õ
}NET_IN_MS_MANUALTRACK;

//MASTERSLAVE_CMD_MANUALTRACKṹ
typedef struct __NET_OUT_MS_MANUALTRACK
{
    int                nStructSize;
}NET_OUT_MS_MANUALTRACK;

//MASTERSLAVE_CMD_POINTTRACKṹ
typedef struct __NET_IN_MS_POINTTRACK
{
    int                nStructSize;
    DH_POINT           stTrackerPoint;    // ٵ㣬һ[0,8192] 
}NET_IN_MS_POINTTRACK;

//MASTERSLAVE_CMD_POINTTRACKṹ
typedef struct __NET_OUT_MS_POINTTRACK
{
    int                nStructSize;
}NET_OUT_MS_POINTTRACK;

//MASTERSLAVE_CMD_GETCALIBPOINTSṹ
typedef struct __NET_IN_MS_GETCALIBPOINTS
{
    int                nStructSize;
}NET_IN_MS_GETCALIBPOINTS;

//MASTERSLAVE_CMD_GETCALIBPOINTSṹ
typedef struct __NET_OUT_MS_GETCALIBPOINTS
{
    int                        nStructSize;
    int                        nPointsNum;                           // ʵʱ궨
    NET_MS_PAIRPOINTS          stPairPoints[MAX_CALIBPOINTS_NUM];    // 궨
}NET_OUT_MS_GETCALIBPOINTS;

//MASTERSLAVE_CMD_CALIBRATEṹ
typedef struct __NET_IN_MS_CALIBRATE
{
    int                nStructSize;
}NET_IN_MS_CALIBRATE;

//MASTERSLAVE_CMD_CALIBRATEṹ
typedef struct __NET_OUT_MS_CALIBRATE
{
    int                nStructSize;      
}NET_OUT_MS_CALIBRATE;

//MASTERSLAVE_CMD_ADDCALIBPOINTṹ
typedef struct __NET_IN_MS_ADDCALIBPOINT
{
    int                        nStructSize;
    BOOL                       bSlavePointEn;        // 궨ʹλ, TUREô궨ЧFASLEЧ, 豸ԼȡǰĴ궨㡣
    NET_MS_PAIRPOINTS          stPairPoints;         // 
}NET_IN_MS_ADDCALIBPOINT;

//MASTERSLAVE_CMD_ADDCALIBPOINTṹ
typedef struct __NET_OUT_MS_ADDCALIBPOINT
{
    int                nStructSize;
    DH_POINT           stPoint;      // ӱ궨
}NET_OUT_MS_ADDCALIBPOINT;


//MASTERSLAVE_CMD_REMOVECALIBPOINTṹ
typedef struct __NET_IN_MS_REMOVECALIBPOINT
{
    int                nStructSize;
    DH_POINT           stPoint;      // 궨
}NET_IN_MS_REMOVECALIBPOINT;

//MASTERSLAVE_CMD_REMOVECALIBPOINTṹ
typedef struct __NET_OUT_MS_REMOVECALIBPOINT
{
    int                nStructSize;      
}NET_OUT_MS_REMOVECALIBPOINT;

//MASTERSLAVE_CMD_MARKMAXZOOMṹ
typedef struct __NET_IN_MS_MARKMAXZOOM
{
    int                nStructSize; 
}NET_IN_MS_MARKMAXZOOM;

//MASTERSLAVE_CMD_MARKMAXZOOMṹ
typedef struct __NET_OUT_MS_MARKMAXZOOM
{
    int                nStructSize; 
}NET_OUT_MS_MARKMAXZOOM;

///////////////////////////////// CLIENT_OperateCommDevice ӿڲ /////////////////////////////////
#define        COMMDEV_GET_EXTERNLDATA                            "devComm.getExternalData"        //ȡ    ڵͨ

#define        MAX_EXTERN_DATA_LEN                2048

//COMMDEV_GET_EXTERNLDATA 
typedef struct __COMMDEV_IN_GET_EXTERNDATA
{
    DWORD        dwSize;

}COMMDEV_IN_GET_EXTERNDATA;

//COMMDEV_GET_EXTERNLDATA 
typedef struct __COMMDEV_OUT_GET_EXTERNDATA
{
    DWORD        dwSize;
    char         szGetData[MAX_EXTERN_DATA_LEN];                //豸ɼ(ݸʽĿԶ)
}COMMDEV_OUT_GET_EXTERNDATA;


///////////////////////////////// CLIENT_OperateVideoAnalyseDevice ӿڲ /////////////////////////////////
#define     NET_SET_MODULESTATE                         "devVideoAnalyse.setModuleState"                        // ģ״̬
#define     NET_TEST_WITH_SCREENPOINTS                  "devVideoAnalyse.testCalibrateWithScreenPoints"            // ĻԾõ֮ʵʾ롣ڲ֮ǰҪɲá
#define     NET_TEST_WITH_METRICLENGTH                  "devVideoAnalyse.testCalibrateWithMetricLength"            // ʵʳȡʼ㼰꣬Ծ
#define     NET_GET_INTERNALOPTIONS                     "devVideoAnalyse.getInternalOptions"                    // ȡڲѡ
#define     NET_TUNE_INTERNALOPTIONS                    "devVideoAnalyse.tuneInternalOptions"                    // ڲѡ
#define     NET_RESET_INTERNALOPTIONS                   "devVideoAnalyse.resetInternalOptions"                    // λеڲѡ
#define     NET_SET_PTZ_PRESET_STATUS                   "devVideoAnalyse.setPtzPresetStatus"                    // ȡԤõϢ

// ߶
typedef enum tagNET_EM_LINETYPE
{
    NET_EM_HORIZONTAL,
    NET_EM_VERTICAL,
}NET_EM_LINETYPE;

//̨λϢ
typedef struct
{
    int     nChannelID;                 // ͨ 
    int     nPTZPan;                    // ̨ˮƽ˶λãЧΧ[0,3600]
    int     nPTZTilt;                   // ֱ̨˶λãЧΧ[-1800,1800]
    int     nPTZZoom;                   // ̨Ȧ䶯λãЧΧ[0,128]
    BYTE    bState;                     // ̨˶״̬, 0-δ֪ 1-˶ 2- 
    BYTE    bAction;                    // ̨0-Ԥõ㣬1-ɨ2-Ѳ3-Ѳ4-ˮƽת
    BYTE    bFocusState;                // ̨۽״̬, 0-δ֪, 1-˶״̬, 2-
    BYTE    bEffectiveInTimeSection;    //ʱԤõ״̬ǷЧ
                                        //ǰϱԤõʱڵԤõ㣬Ϊ1Ϊ0
    int     nPtzActionID;               // ѲID
    DWORD   dwPresetID;                 // ̨Ԥõ
    float   fFocusPosition;             // ۽λ
    BYTE    bZoomState;                 // ̨ZOOM״̬0-δ֪1-ZOOM2-
    BYTE    bReserved[3];               // 
    DWORD   dwSequence;                 // ţУǷ񶪰
    DWORD   dwUTC;                      // ӦUTC(1970-1-1 00:00:00)
    int     reserved[249];              // ֶ
}DH_PTZ_LOCATION_INFO;

// NET_SET_PTZ_PRESET_STATUS
typedef struct __NET_IN_PTZ_PRESET_STATUS
{
    DWORD                    dwSize;
    DH_PTZ_LOCATION_INFO     stPTZStatus;
}NET_IN_PTZ_PRESET_STATUS;

typedef struct __NET_OUT_PTZ_PRESET_STATUS
{
    DWORD    dwSize;
}NET_OUT_PTZ_PRESET_STATUS;


// NET_TEST_WITH_SCREENPOINTS
typedef struct __NET_IN_CALIBRATE_BY_POINTS
{
    DWORD               dwSize;                 // ˽ṹС

    DH_POINT            stStartPoint;           // ߶    һ[0,8191]䡣
    DH_POINT            stEndPoint;             // ֹ    һ[0,8191]䡣    
    NET_EM_LINETYPE     emType;                 // ߶    em_Horizontal("Horizontal") ˮƽ߶ em_Vertical("Vertical")ֱ߶
}NET_IN_CALIBRATE_BY_POINTS;
typedef struct __NET_OUT_CALIBRATE_BY_POINTS
{
    DWORD               dwSize;                 // ˽ṹС

    double              dlength;                // ֮ʵʳ    λΪ
}NET_OUT_CALIBRATE_BY_POINTS;

// NET_TEST_WITH_METRICLENGTH
typedef struct __NET_IN_CALIBRATE_BY_LENGTH
{
    DWORD               dwSize;                 // ˽ṹС

    double              nLength;                // ֮ʵʳ,Ϊλ
    DH_POINT            stStartPoint;           // ߶,һ[0,8191]䡣
    DH_POINT            stDirection;            // ߶η,ֻԴֱ߶Чһ[0,8191]䡣
    NET_EM_LINETYPE     emType;                 // ߶,em_Horizontal("Horizontal") ˮƽ߶ em_Vertical("Vertical")ֱ߶                
}NET_IN_CALIBRATE_BY_LENGTH;

typedef struct __NET_OUT_CALIBRATE_BY_LENGTH
{
    DWORD               dwSize;                 // ˽ṹС
    
    DH_POINT            stEndPoint;             // ߶յĻ    һ[0,8191]䡣    
}NET_OUT_CALIBRATE_BY_LENGTH;

typedef struct __NET_INTERNAL_OPTION
{
    DWORD               dwSize;                 // ˽ṹС

    int                 nIndex;                 // ѡ
    NET_ARRAY           stKey;                  // ѡƣ\0256ֽ,
    int                 nValue;                 // ѡȡֵ
    int                 nMinValue;              // Сֵ
    int                 nMaxValue;              // ֵ
}NET_INTERNAL_OPTION;

// ڲѡ NET_GET_INTERNALOPTIONS
typedef struct __NET_IN_GETINTERNAL_OPTIONS
{
    DWORD               dwSize;                 // ˽ṹС
}NET_IN_GETINTERNAL_OPTIONS;

typedef struct __NET_OUT_GETINTERNAL_OPTIONS
{
    DWORD                dwSize;                // ˽ṹС

    int                  nTotalOptionNum;       // ѡ ֵѯ
    int                  nReturnOptionNum;      // صʵѡ
    NET_INTERNAL_OPTION* pstInternalOption;     // ѡб ߷ַ
}NET_OUT_GETINTERNAL_OPTIONS;

// NET_TUNE_INTERNALOPTIONS
typedef struct __NET_IN_TUNEINTERNAL_OPTION
{
    DWORD                dwSize;                // ˽ṹС
    int                  nOptionCount;          // ѡ
    NET_INTERNAL_OPTION* pstInternalOption;     // ѡб ָ
}NET_IN_TUNEINTERNAL_OPTION;
typedef struct __NET_OUT_TUNEINTERNAL_OPTION
{
    DWORD               dwSize;                 // ˽ṹС
}NET_OUT_TUNEINTERNAL_OPTION;

// NET_RESET_INTERNALOPTIONS
typedef struct __NET_IN_RESETINTERNAL_OPTION
{
    DWORD               dwSize;                 // ˽ṹС
}NET_IN_RESETINTERNAL_OPTION;
typedef struct __NET_OUT_RESETINTERNAL_OPTION
{
    DWORD               dwSize;                 // ˽ṹС
}NET_OUT_RESETINTERNAL_OPTION;

// NET_SET_MODULESTATE
typedef enum tagNET_EM_MODULESTATE
{
    NET_EM_MODULESTATE_OK,
    NET_EM_MODULESTATE_PAUSE,
}NET_EM_MODULESTATE;
typedef struct __NET_IN_SETMODULESTATE
{
    DWORD               dwSize;                 // ˽ṹС
    NET_EM_MODULESTATE  emState;                // 0-1-ͣٴлѾ仯Ҫؽ
    int                 nIndex;                 // ģ    -1ָģ
}NET_IN_SETMODULESTATE;
typedef struct __NET_OUT_SETMODULESTATE
{
    DWORD               dwSize;                 // ˽ṹС
}NET_OUT_SETMODULESTATE;

/////////////////////////////////CLIENT_DeleteDevConfig ӿڲ/////////////////////////////////
/*
 * CLIENT_DeleteDevConfig 
 */

typedef enum tagNET_EM_CONFIGOPTION
{
    NET_EM_CONFIGOPTION_OK,
    NET_EM_CONFIGOPTION_NEEDRESTART,
    NET_EM_CONFIGOPTION_NEEDREBOOT=2,
    NET_EM_CONFIGOPTION_WRITEFILEERROR=4,
    NET_EM_CONFIGOPTION_CAPSNOTSUPPORT=8,
    NET_EM_CONFIGOPTION_VALIDATEFAILED=16,
}NET_EM_CONFIGOPTION;

typedef struct tagNET_IN_DELETECFG
{
    DWORD         dwSize;                       // ṹС
    char*         szCommand;                    // 
}NET_IN_DELETECFG;
typedef struct tagNET_OUT_DELETECFG
{
    DWORD         dwSize;                       // ṹС
    int           nError;                       // 豸صĴ
    int           nRestart;                     // 豸Ƿ
    DWORD         dwOptionMask;                 // ѡ öNET_EM_CONFIGOPTION
}NET_OUT_DELETECFG;

/////////////////////////////////CLIENT_GetMemberNames ӿڲ/////////////////////////////////
/*
 * CLIENT_GetMemberNames 
 */
typedef struct tagNET_IN_MEMBERNAME
{
    DWORD         dwSize;                       // ṹС
    char*         szCommand;                    // 
}NET_IN_MEMBERNAME;
typedef struct tagNET_OUT_MEMBERNAME
{
    DWORD         dwSize;                       // ṹС
    int           nError;                       // 豸صĴ
    int           nRestart;                     // 豸Ƿ
    int           nTotalNameCount;              // Ƹ ͨõд
    int           nRetNameCount;                // صʵƸ
    NET_ARRAY*    pstNames;                     //  ڴ棬nTotalNameCount
}NET_OUT_MEMBERNAME;

////////////////////////////////////ƵŨؽṹ//////////////////////////////////////
// 
typedef enum tagNET_EM_STAFF_TYPE
{
    NET_EM_STAFF_TYPE_ERR,
    NET_EM_STAFF_TYPE_HORIZONTAL,               // "Horizontal" ˮƽ߶
    NET_EM_STAFF_TYPE_VERTICAL,                 // "Vertical" ֱ߶
    NET_EM_STAFF_TYPE_ANY,                      // "Any" ߶
    NET_EM_STAFF_TYPE_CROSS,                    // "Cross" ֱ潻߶
}NET_EM_STAFF_TYPE;

// 
typedef enum tagNET_EM_CALIBRATEAREA_TYPE
{
    NET_EM_CALIBRATEAREA_TYPE_ERR,
    NET_EM_CALIBRATEAREA_TYPE_GROUD,            // "Groud" : 棬ҪNֱ߶+Mˮƽ߶ΣN=3M=1N=2M=2չ
    NET_EM_CALIBRATEAREA_TYPE_HORIZONTAL,       // "Horizontal"  : ˮƽ棬Ҫˮƽһ㵽ͶӰֱ߶Ρ        
    NET_EM_CALIBRATEAREA_TYPE_VERTICAL,         // "Vertical" : ֱ棬ҪֱĽߡ
    NET_EM_CALIBRATEAREA_TYPE_ANY,              // "Any" ƽ棬Nֱ߶ΣÿȣN=3չ
}NET_EM_CALIBRATEAREA_TYPE;

// Ũ
typedef enum tagNET_EM_OUTPUT_SUB_TYPE
{
    NET_EM_OUTPUT_SUB_TYPE_ERR,
    NET_EM_OUTPUT_SUB_TYPE_NORMAL,              // ͨٶȣΪŨƵʱЧ
    NET_EM_OUTPUT_SUB_TYPE_SYNOPSIS,            // ŨĲٶȣΪŨƵʱЧûʱţʱٶȲ
}NET_EM_OUTPUT_SUB_TYPE;

// Ϣ
typedef struct tagNET_STAFF_INFO
{
    DH_POINT            stuStartLocation;       // ʼ
    DH_POINT            stuEndLocation;         // ֹ
    float               nLenth;                 // ʵʳ,λ
    NET_EM_STAFF_TYPE   emType;                 // 
}NET_STAFF_INFO;

// 궨,ͨʹ
typedef struct tagNET_CALIBRATEAREA_INFO
{
    int                     nLinePoint;                         // ˮƽ߶
    DH_POINT                stuLine[DH_MAX_POLYLINE_NUM];       // ˮƽ
    float                   fLenth;                             // ʵʳ
    DH_POLY_POINTS          stuArea;                            // 
    int                     nStaffNum;                          // ֱ
    NET_STAFF_INFO          stuStaffs[DH_MAX_STAFF_NUM];        // ֱ         
    NET_EM_CALIBRATEAREA_TYPE emType;                           // 
}NET_CALIBRATEAREA_INFO;

typedef struct tagNET_LOCALFILE_INFO
{
    DWORD               dwSize;
    char                szFilePath[MAX_PATH];               // ļ·
}NET_LOCALFILE_INFO;

typedef struct tagNET_REMOTEFILE_INFO
{
    DWORD               dwSize;
    char                szIP[MAX_PATH];                     // Զ豸IP
    unsigned int        nPort;                              // Զ豸˿
    char                szName[DH_MAX_NAME_LEN];            // ½Զ豸û
    char                szPassword[DH_MAX_NAME_LEN];        // ½Զ豸
    BYTE                byProtocolType;                     // Զ豸ʹõЭͣ2-˽ж3-˽
    BYTE                byReserved[3];                      // ֽڶ
    char                szFilePath[MAX_PATH];               // ļ·byProtocolTypeΪ3ʱЧ
    int                 nStartCluster;                      // ʼغţbyProtocolTypeΪ2ʱЧ
    int                 nDriverNo;                          // ̺ţbyProtocolTypeΪ2ʱЧ
}NET_REMOTEFILE_INFO;

// ļλϢ
typedef struct tagNET_FILEPATH_INFO
{
    DWORD               dwSize;
    BOOL                bFileType;                          // TRUE: ļ; FALSE: Զ豸ļ
    NET_LOCALFILE_INFO  stuLocalFile;                       // ļϢ, bFileType==TRUEЧ
    NET_REMOTEFILE_INFO stuRemoteFile;                      // ԶļϢ, bFileType==FALSEЧ
}NET_FILEPATH_INFO;

// ȫֲ
typedef struct tagNET_GLOBAL_INFO
{
    DWORD                   dwSize;
    char                    szSceneType[DH_MAX_NAME_LEN];           // Ӧóֻ֧"Normal"
    int                     nStaffNum;                              // 
    NET_STAFF_INFO          stuStaffs[DH_MAX_STAFF_NUM];            //     
    int                     nCalibrateAreaNum;                      // 궨
    NET_CALIBRATEAREA_INFO  stuCalibrateArea[DH_MAX_CALIBRATEBOX_NUM]; // 궨(ֶβڣΪ궨)
    int                     nJitter;                                //  : ʣȡֵ0-100Ӧ̶ֹȣԽֵԽ
    BOOL                    bDejitter;                              // Ƿȥģ
}NET_GLOBAL_INFO;

// ģ
typedef struct tagNET_MODULE_INFO
{
    DWORD               dwSize;                                     // ýṹС
    BYTE                bSensitivity;                               // ,ȡֵ1-10ֵԽСԽ
    BYTE                bReserved[3];
    int                 nDetectRegionPoint;                         // 򶥵
    DH_POINT            stuDetectRegion[DH_MAX_POLYGON_NUM];        // 
    int                 nExcludeRegionNum;                          // ų
    DH_POLY_POINTS      stuExcludeRegion[DH_MAX_EXCLUDEREGION_NUM]; // ų
}NET_MODULE_INFO;

// Ϣ
typedef struct tagNET_OBJFILTER_INFO
{
    DWORD               dwSize;                             // ýṹС
    NET_TIME            stuStartTime;                       // ʼʱ
    NET_TIME            stuEndTime;                         // ʱ
    char                szObjectType[DH_MAX_NAME_LEN];      // ,֧:
                                                            //"Unknown", "Human", "Vehicle",
                                                            //"Fire", "Smoke", "Plate", "HumanFace", "Container", "Animal", "TrafficLight", "PastePaper", "HumanHead", "Entity"
    char                szObjectSubType[64];                // 𣬸ݲͬͣȡͣ
                                                            // Vehicle Category:"Unknown"  δ֪,"Motor" ,"Non-Motor":ǻ,"Bus": ,"Bicycle" г,"Motorcycle":Ħг
                                                            // Plate Category"Unknown" δ֪,"Normal" ƺ,"Yellow" ,"DoubleYellow" ˫β,"Police" "Armed" 侯,
                                                            // "Military" Ӻ,"DoubleMilitary" ˫,"SAR" ۰,"Trainning" 
                                                            // "Personal" Ժ,"Agri" ũ,"Embassy" ʹݺ,"Moto" Ħг,"Tractor" ,"Other" 
                                                            // HumanFace Category:"Normal" ͨ,"HideEye" ۲ڵ,"HideNose" ڵ,"HideMouth" 첿ڵ
    DWORD               dwRGBMainColor[DH_MAX_COLOR_NUM];   // ҪɫΪʱʾϰɫֽڱʾֱΪ졢̡͸,:RGBֵΪ(0,255,0),͸Ϊ0ʱ, ֵΪ0x00ff0000
    DWORD               dwLowerBodyColor[DH_MAX_COLOR_NUM]; // Ϊʱʾ°ɫֽڱʾֱΪ졢̡͸,:RGBֵΪ(0,255,0),͸Ϊ0ʱ, ֵΪ0x00ff0000
    int                 nMinSize;                           // Сߴ, m
    int                 nMaxSize;                           // ߴ, m
    int                 nMinSpeed;                          // Сٶ, km/h
    int                 nMaxSpeed;                          // ٶ, km/h
    DWORD               dwRGBMainColorNum;                  // Ϊˣ־dwRGBMainColorЧɫ
    DWORD               dwLowerBodyColorNum;                // ΪbRGBMainColor==true־°Чɫ
    BOOL                bRGBMainColor;                      // true-dwRGBMainColorʾϰɫ,dwLowerBodyColorʾ°ɫ; false-dwRGBMainColorʾҪɫ,dwLowerBodyColorЧ
}NET_OBJFILTER_INFO;

// 
typedef struct tagNET_VIDEOSYNOPSISRULE_INFO
{
    DWORD               dwSize;                             // ýṹС
    BYTE                byOutputType;                       // Ũϵ,1-Ƶ(һ);2-ŨƵ;3-пƵ
    BYTE                byDensity;                          // ܶ, 1-10, ֵԽ, ŨܶԽ
    bool                bShowTime;                          // ŨǷʾʱ
    bool                bShowBox;                           // ŨǷʾ
    bool                bEnableRecordResult;                // ŨǷ¼ݿ
    BYTE                byReserved[3];
    NET_OBJFILTER_INFO  stuFilter[MAX_OBJFILTER_NUM];       // Ϣ
    DWORD               dwObjFilterNum;                     // ϢĿ

    // NET_OUT_QUERY_VIDEOSYNOPSISУCFG_CMD_ANALYSERULEdhconfigsdk.dllнӿCLIENT_ParseDataõӦĽṹ壬ʱҪȷ㹻ڴ
    // NET_IN_ADD_VIDEOSYNOPSISУCFG_CMD_ANALYSERULEdhconfigsdk.dllнӿCLIENT_PacketDataװõϢ
    char*               szAnalyseRuleInfo;                  // JSONװϢ
    int                 nBufferLen;                         // NET_OUT_QUERY_VIDEOSYNOPSISʱszAnalyseRuleInfo
    BOOL                bCustomResolution;                  // Զֱʹ, TRUE-ֱemResolutionȷ, FALSE-ԭʼƵֱŨƵ
    CAPTURE_SIZE        emResolution;                       // ֱ, bCustomResolutionΪTRUEЧ
    BOOL                bEnableMaxUsedCPU;                  // ǷռCPUԴ
    BOOL                bEnableSmoothBorder;                // ǷƽĿ߿
    NET_EM_OUTPUT_SUB_TYPE emOutputSubType;                 // ŨϵͣNET_EM_OUTPUT_SUB_TYPE
    int                 nExtractFrameRate;                  // ŨƵĳ֡    1-32ֵԽ󣬳֡Խߣͻ˳ֵĲٶԽ
                                                            // ֶνŨ(emOutputSubType)NET_EM_OUTPUT_SUB_TYPE_SYNOPSISЧ 
}NET_VIDEOSYNOPSISRULE_INFO;

// ŨƵ
typedef struct tagNET_IN_ADD_VIDEOSYNOPSIS
{
    DWORD                   dwSize;                         // ýṹС
    NET_FILEPATH_INFO*      pFilePathInfo;                  // ļλϢûռ
    DWORD                   dwFileCount;                    // Чļ
    NET_GLOBAL_INFO         stuGlobalInfo;                  // ȫϢ
    NET_MODULE_INFO         stuModuleInfo;                  // ģϢ
    NET_VIDEOSYNOPSISRULE_INFO stuRuleInfo;                 // Ϣ
    unsigned int        nWaitTime;                          // ȴʱʱ䣬λms
}NET_IN_ADD_VIDEOSYNOPSIS;

// ŨƵ
typedef struct tagNET_OUT_ADD_VIDEOSYNOPSIS
{
    DWORD               dwSize;                             // ýṹС
    DWORD*              pnTaskID;                           // TaskID飬ûռ.˳һһӦļ;0ʾӦʧ
    DWORD               nTaskIDCount;                       // TaskID
}NET_OUT_ADD_VIDEOSYNOPSIS;

// ͣƵŨ
typedef struct tagNET_IN_PAUSE_VIDEOSYNOPSIS
{
    DWORD               dwSize;                             // ýṹС
    BOOL                bPause;                             // TRUE-ʾͣ   FALSE-ʾָ 
    DWORD*              pnTaskID;                           // TaskID飬ûռ
    DWORD               nTaskIDCount;                       // TaskID
    DWORD               nWaitTime;                          // ȴʱʱ䣬λms
}NET_IN_PAUSE_VIDEOSYNOPSIS;

// ƳƵŨ
typedef struct tagNET_IN_REMOVE_VIDEOSYNOPSIS
{
    DWORD                dwSize;                            // ýṹС
    DWORD*               pnTaskID;                          // TaskID飬ûռ
    DWORD                nTaskIDCount;                      // TaskID
    DWORD                nWaitTime;                         // ȴʱʱ䣬λms
}NET_IN_REMOVE_VIDEOSYNOPSIS;

// ƵŨصϢ
typedef struct tagNET_REAL_SYNOPSIS_OBJECT_INFO
{
    DWORD               dwSize;
    
    DWORD               dwTaskID;                       // ǰӦID
    DH_MSG_OBJECT       stuObjectInfo;                  // Ϣ
}NET_REAL_SYNOPSIS_OBJECT_INFO;

typedef struct tagNET_REAL_SYNOPSIS_STATE_INFO
{
    DWORD           dwSize;
    
    DWORD           dwTaskID;                           // ID   
    int             nObjectNum;                         // ĿǰŨѷֵ
    int             nTaolProgress;                      // ǰŨԴ̵ģء׼Ũɽ,0~100
    char            szState[DH_MAX_SYNOPSIS_STATE_NAME];// ӦƵŨ״̬,"Downloading"-","Synopsising"-Ũ",
                                                        // "DownloadFailed"-ʧ","DownloadSucceeded"-سɹ
                                                        // "SynopsisFailed"-Ũʧ","Succeeded"-Ũɹ
                                                        // "DownloadPause"-ͣ,"SynopsisPause"-Ũͣ
    int             nProgressOfCurrentState;            // ǰŨӦɽȣ0~100
    char            szFailedCode[DH_MAX_STRING_LEN];    // ʧ룬szState="SynopsisFailed"Ч
                                                        // "OutOfMemory" ڴ治;
                                                        // "TooMany_TargetInVideo"  ƵĿ;
                                                        // "InvalidFilePointer" ļָЧ;
                                                        // "InvalidFilePath" ļ·Ч;
                                                        // "CreateDirectoryFailed"  ļ·ʧ;
                                                        // "WriteDataFailed" дTubeмļʧ
                                                        // "DataSizeTooLarge" Tubeļ̫
                                                        // "Detect_Nothing" ˶Ŀ
                                                        // "OpenDataFailed" мļʧ
                                                        // "InvalidSynopsisBackgroud" ŨЧ
                                                        // "ColorRetrieval" ɫ
                                                        // "UnsupportRuleType" ֵ֧Ĺ
                                                        // "RuleNumberExceedLimit" 
                                                        // "NoFunctionCfgInfo" ָӦܵûϢ
                                                        // "FunctionNumberExceedLimit" ÿĹĿ
                                                        // "PointsExceedLimit" ߻ĵ
                                                        // "BadFunctionType" Ĺ
                                                        // "RulePointNumber" 
                                                        // "MaskRegionNumberExceedLimit" 
                                                        // "CameraSceneSwitch" л
                                                        // "TooManyTargeInFrame" ֡Ŀ
                                                        // "InalidSynopsisDesity" ŨܶЧ
                                                        // "ExtrackColorFeatureFailed" ȡɫʧ
                                                        // "JpegEncodeFrameFailed" Jpegʧ
                                                        // "JpegParamRestFailed" Jpegñʧ
                                                        // "JpegDecodeFrameFailed" Jpegʧ
                                                        // "RetrieveObjectIdInvalid" ĿIDЧ
                                                        // "RetrieveImageInvalid" ͼЧ
                                                        // "NetworkAnomaly" ӳ쳣
                                                        // "ObjectNumberLimit" ĿĿ
                                                        // "CreateChannelFailed" ͨʧ
                                                        // "ReadUGFileFailed" ȡUGļʧ
                                                        // "GetSynopsisInfoFailed" ȡŨƵϢʧ
                                                        // "ObjectNumberExceedLimit" ĿĿ
                                                        // "RebuildBackgroudFailed" ؽʧ
                                                        // "NotExistMiddleFile" мļ
                                                        // "NotExistSourceFile" ԭʼļ
                                                        // "NotDog" ûмܹ
                                                        // "NotEnoughFreeDisk" ̿ռ䲻
                                                        // "StartDecodeFail" ʼʧ
                                                        // "DecodeTimeOut" ȴʱ
                                                        // "EncodeTimeOut" ȴʱ
                                                        // "ExactTimeOut" ȡյȴʱ
                                                        // "ReadMidlleFileFail" ȡмļʧ
                                                        // "ExactPictureFail" ȡͼƬʧ
}NET_REAL_SYNOPSIS_STATE_INFO;

//ƵŨϢʵʱص
typedef int (CALLBACK *fVideoSynopsisObjData)(LLONG lRealLoadHandle, NET_REAL_SYNOPSIS_OBJECT_INFO* pSynopsisObjectInfo, void* pBuf, int nBufLen, LDWORD dwUser, void* pReserved);

//ƵŨ״̬ʵʱص
typedef int (CALLBACK *fVideoSynopsisState)(LLONG lRealLoadHandle, NET_REAL_SYNOPSIS_STATE_INFO* pSynopsisStateInfos, int nInfoCount, LDWORD dwUser, void* pReserved);

// CLIENT_RealLoadObjectDataӿڲ
typedef struct tagNET_IN_REALLOAD_OBJECTDATA
{
    DWORD               dwSize;                         // ṹС   
    int                 nTaskIDNum;                     // ID
    DWORD               *pTaskIDs;                      // ID
    BOOL                bNeedPicFile;                   // ǷضӦͼƬļ 
    int                 nWaitTime;                      // ȴʱ䣬λms
    fVideoSynopsisObjData cbVideoSynopsisObjData;       // ƵŨϢʵʱصָ
    LDWORD         dwUser;
}NET_IN_REALLOAD_OBJECTDATA;

typedef struct tagNET_OUT_REALLOAD_OBJECTDATA
{
    DWORD               dwSize;                         // ṹС
    LLONG               lRealLoadHandle;                // ӿڷصĶľΨһʶĳ
}NET_OUT_REALLOAD_OBJECTDATA;

// CLIENT_StopLoadObjectDataӿڲ
typedef struct tagNET_IN_STOPLOAD_OBJECTDATA
{
    DWORD               dwSize;
    int                 nTackIDNum;                     // ID
    DWORD               *pTaskIDs;                      // ID  
}NET_IN_STOPLOAD_OBJECTDATA;

// CLIENT_RealLoadSynopsisStateӿڲ
typedef struct tagNET_IN_REALLAOD_SYNOPSISSTATE
{
    DWORD               dwSize;                         // ṹС  
    int                 nTaskIDNum;                     // ID
    DWORD               *pTaskIDs;                      // ID
    int                 nWaitTime;                      // ȴʱ䣬λms
    fVideoSynopsisState cbVideoSynopsisState;           // ƵŨϢʵʱصָ
    LDWORD         dwUser;
}NET_IN_REALLAOD_SYNOPSISSTATE;

typedef struct tagNET_OUT_REALLOAD_SYNOPSISSTATE
{
    DWORD               dwSize;                         // ṹС    
    LLONG               lRealLoadHandle;                // ӿڷصؾΨһʶĳ
}NET_OUT_REALLOAD_SYNOPSISSTATE;

// CLIENT_StopLoadSynopsisStateӿڲ
typedef struct tagNET_IN_STOPLOAD_SYNOPSISSTATE
{
    DWORD               dwSize;   
    int                 nTackIDNum;                     // ID
    DWORD               *pTaskIDs;                      // ID  
}NET_IN_STOPLOAD_SYNOPSISSTATE;

// ŨƵϢĲ
typedef enum tagEM_VIDEOSYNOPSIS_QUERY_TYPE
{
    EM_VIDEOSYNOPSIS_TASK,                              // Ϣ
    EM_VIDEOSYNOPSIS_OBJ,                               // ӦĿ
}EM_VIDEOSYNOPSIS_QUERY_TYPE;

// ѯŨƵϢ
typedef struct tagNET_QUERY_VSTASK_INFO
{
    DWORD                dwSize;                        // ýṹС
    DWORD                dwTaskID;                      // IDΪ0ʱʾѯ
}NET_QUERY_VSTASK_INFO;

// ѯŨƵϢ
typedef struct tagNET_QUERY_VSOBJECT_INFO
{
    DWORD                dwSize;                         // ýṹС
    DWORD*               pdwTaskID;                      // IDΪ-1ʾѯ
    DWORD                dwTaskIDCount;                  // ЧĿ
    DH_MSG_OBJECT        stuObjInfo;                     // ϢobjectIDΪ0ʱʾѯ
}NET_QUERY_VSOBJECT_INFO;

//--CLIENT_QueryVideoSynopsisInfoӿ
typedef struct tagNET_IN_QUERY_VIDEOSYNOPSIS
{
    DWORD                dwSize;                         // ýṹС
    EM_VIDEOSYNOPSIS_QUERY_TYPE emQueryType;             // 
    DWORD                dwCount;                        // ѯ
    DWORD                dwBeginNumber;                  // ѯʼ    
    void*                pQueryInfo;                     // ѯϢûռ䣻
                                                         // emQueryType==EM_VIDEOSYNOPSIS_TASKӦNET_QUERY_VSTASK_INFO
                                                         // emQueryType==EM_VIDEOSYNOPSIS_OBJӦNET_QUERY_VSOBJECT_INFO

    DWORD                dwWaitTime;                     // ȴʱʱ䣬λms
}NET_IN_QUERY_VIDEOSYNOPSIS;

// ѯÿŨƵϢ
typedef struct tagNET_VSTASK_INFO
{
    DWORD                       dwSize;                             // ýṹС
    DWORD                       dwTaskID;                           // ID
    NET_MODULE_INFO             stuModuleInfo;                      // ģϢ
    NET_VIDEOSYNOPSISRULE_INFO  stuRuleInfo;                        // ĹϢ
    NET_GLOBAL_INFO             stuGlobalInfo;                      // ȫֲ
    NET_TIME                    stuCreateTime;                      // Ĵʱ
    char                        szCurrState[DH_MAX_SYNOPSIS_STATE_NAME];  // ǰƵŨ״̬,"Downloading"-","Synopsising"-Ũ",
                                                                    // "DownloadFailed"-ʧ","DownloadSucceeded"-سɹ
                                                                    // "SynopsisFailed"-Ũʧ","Succeeded"-Ũɹ
                                                                    // "DownloadPause"-ͣ,"SynopsisPause"-Ũͣ
    char                        szCreateUser[DH_MAX_NAME_LEN];      // û
    int                         nProgressOfCurrentState;            // ǰŨӦɽȣ0~100
    char                        szLocalFilePath[MAX_PATH];          // ļ·ԶƵԴļغڱص·
    int                         nObjectNum;                         // ĿǰŨѷֵ
    NET_FILEPATH_INFO           stuVideoSourceFilePath;             // ԴƵļ·
    NET_FILEPATH_INFO           stuSynopsisVideoFilePath;           // ŨƵļ·
    char                        szFailedCode[DH_MAX_STRING_LEN];    // ŨƵʧܴ룬szCurrStateΪ"SynopsisFailed"ʱЧ
                                                                    // "OutOfMemory" ڴ治;
                                                                    // "TooMany_TargetInVideo"  ƵĿ;
                                                                    // "InvalidFilePointer" ļָЧ;
                                                                    // "InvalidFilePath" ļ·Ч;
                                                                    // "CreateDirectoryFailed"  ļ·ʧ;
                                                                    // "WriteDataFailed" дTubeмļʧ
                                                                    // "DataSizeTooLarge" Tubeļ̫
                                                                    // "Detect_Nothing" ˶Ŀ
                                                                    // "OpenDataFailed" мļʧ
                                                                    // "InvalidSynopsisBackgroud" ŨЧ
                                                                    // "ColorRetrieval" ɫ
                                                                    // "UnsupportRuleType" ֵ֧Ĺ
                                                                    // "RuleNumberExceedLimit" 
                                                                    // "NoFunctionCfgInfo" ָӦܵûϢ
                                                                    // "FunctionNumberExceedLimit" ÿĹĿ
                                                                    // "PointsExceedLimit" ߻ĵ
                                                                    // "BadFunctionType" Ĺ
                                                                    // "RulePointNumber" 
                                                                    // "MaskRegionNumberExceedLimit" 
                                                                    // "CameraSceneSwitch" л
                                                                    // "TooManyTargeInFrame" ֡Ŀ
                                                                    // "InalidSynopsisDesity" ŨܶЧ
                                                                    // "ExtrackColorFeatureFailed" ȡɫʧ
                                                                    // "JpegEncodeFrameFailed" Jpegʧ
                                                                    // "JpegParamRestFailed" Jpegñʧ
                                                                    // "JpegDecodeFrameFailed" Jpegʧ
                                                                    // "RetrieveObjectIdInvalid" ĿIDЧ
                                                                    // "RetrieveImageInvalid" ͼЧ
                                                                    // "NetworkAnomaly" ӳ쳣
                                                                    // "ObjectNumberLimit" ĿĿ
                                                                    // "CreateChannelFailed" ͨʧ
                                                                    // "ReadUGFileFailed" ȡUGļʧ
                                                                    // "GetSynopsisInfoFailed" ȡŨƵϢʧ
                                                                    // "ObjectNumberExceedLimit" ĿĿ
                                                                    // "RebuildBackgroudFailed" ؽʧ
                                                                    // "NotExistMiddleFile" мļ
                                                                    // "NotExistSourceFile" ԭʼļ
                                                                    // "NotDog" ûмܹ
                                                                    // "NotEnoughFreeDisk" ̿ռ䲻
                                                                    // "StartDecodeFail" ʼʧ
                                                                    // "DecodeTimeOut" ȴʱ
                                                                    // "EncodeTimeOut" ȴʱ
                                                                    // "ExactTimeOut" ȡյȴʱ
                                                                    // "ReadMidlleFileFail" ȡмļʧ
                                                                    // "ExactPictureFail" ȡͼƬʧ
}NET_VSTASK_INFO;

// ŨƵÿϢ
typedef struct tagNET_VSOBJECT_INFO
{
    DWORD                dwSize;                        // ýṹС
    DWORD                dwTaskID;                      // ӦID
    DH_MSG_OBJECT        stuObjInfo;                    // Ϣ
    NET_FILEPATH_INFO    stuFilePathInfo;               // ӦļϢ
    DWORD                dwFileLength;                  // ļֽС
}NET_VSOBJECT_INFO;

//--CLIENT_QueryVideoSynopsisInfoӿ
typedef struct tagNET_OUT_QUERY_VIDEOSYNOPSIS
{
    DWORD                dwSize;                        // ýṹС
    DWORD                dwTotalCount;                  // ϴ˴βѯĽ
    DWORD                dwFoundCount;                  // βѯص
    void*                pResult;                       // صϢûռ
                                                        // emQueryType==EM_VIDEOSYNOPSIS_TASKӦNET_VSTASK_INFO
                                                        // emQueryType==EM_VIDEOSYNOPSIS_OBJӦNET_VSOBJECT_INFO
    DWORD                dwMaxCount;                    // ûϣĽĸ
}NET_OUT_QUERY_VIDEOSYNOPSIS;

// CLIENT_FindSynopsisFileӿڲ 
// Ũļѯ
typedef enum tagNET_EM_QUERY_SYNOPSIS_FILE
{
    DH_FILE_QUERY_VIDEO,                                // ͨ¼ļϢӦѯṹ:NET_SYNOPSIS_QUERY_VIDEO_PARAM, ؽṹ:NET_SYNOPSISFILE_VIDEO_INFO
    DH_FILE_QUERY_SYNOPSISVIDEO,                        // ŨƵϢ, Ӧѯṹ:NET_QUERY_SYNOPSISVIDEO_PARAM,ؽṹ:NET_QUERY_SYNOPSISVIDEO_INFO
}NET_EM_QUERY_SYNOPSIS_FILE;

typedef struct __NET_SYNOPSIS_QUERY_VIDEO_PARAM
{
    DWORD               dwSize;
    DWORD               dwQueryMask;                    // ѯ, մӵ͵λһλʱΡڶλļ· 
    NET_TIME            stuStartTime;                   // ʼʱ    
    NET_TIME            stuEndTime;                     // ʱ
    char                szFilePath[DH_MAX_SYNOPSIS_QUERY_FILE_COUNT][MAX_PATH];    // ѯļľ·
    DWORD               dwFileCount;                    // ѯļĸ
}NET_SYNOPSIS_QUERY_VIDEO_PARAM;

typedef struct  
{
    DWORD               dwSize;
    int                 nTaskId;                        // ID
    DWORD               dwOutPutTypeMask;               // ǰͣ1λ.Ƶ(һ);2λŨƵ    
    char                szCurrentState[DH_MAX_SYNOPSIS_STATE_NAME]; // ǰŨ״̬
}NET_VIDEOSYNOPSIS_TASK_INFO;

// DH_FILE_QUERY_VIDEO ص¼ļϢ
typedef struct
{
    DWORD               dwSize;
    unsigned int        nchannelId;                     // ͨ
    char                szFilePath[MAX_PATH];           // ļ·
    unsigned int        nFileLenth;                     // ļȣֽΪλ
    NET_TIME            stuStarttime;                   // ʼʱ
    NET_TIME            stuEndtime;                     // ʱ
    unsigned int        nWorkDirSN;                     // Ŀ¼    
    unsigned int        nCluster;                       // غ                        
    BYTE                bHint;                          // ļλ
    BYTE                bDriveNo;                       // ̺
    BYTE                bReserved[18];                  // ֶ
    int                 nTaskInfoNum;                   // ¼ļӦŨ
    NET_VIDEOSYNOPSIS_TASK_INFO stuTaskInfo[16];        // ŨϢ
}NET_SYNOPSISFILE_VIDEO_INFO;

// DH_FILE_QUERY_SYNOPSISVIDEO ŨƵļѯ
typedef struct __NET_QUERY_SYNOPSISVIDEO_PARAM
{
    DWORD               dwSize;
    int                 nTaskID;                        // ID
}NET_QUERY_SYNOPSISVIDEO_PARAM;

// DH_FILE_QUERY_SYNOPSISVIDEOŨƵѯ
typedef struct __NET_QUERY_SYNOPSISVIDEO_INFO
{
    DWORD               dwSize;
    char                szFilePath[MAX_PATH];           // ļ·
    unsigned int        nFileLenth;                     // ļ
    int                 nDurationTime;                  // ʱ,λs
}NET_QUERY_SYNOPSISVIDEO_INFO;

// CLIENT_FindSynopsisFile ӿڲ
typedef struct tagNET_IN_FIND_SYNOPSISFILE
{
    DWORD               dwSize;                          
    NET_EM_QUERY_SYNOPSIS_FILE emQueryType;             // ѯ
    void*               pQueryCondition;                // ѯ 
    int                 nWaitTime;                      // ȴʱʱ䣬λms
}NET_IN_FIND_SYNOPSISFILE;

typedef struct tagNET_OUT_FIND_SYNOPSISFILE
{
    DWORD               dwSize;
    LLONG               lFindHandle;                    // ѯ         
}NET_OUT_FIND_SYNOPSISFILE;

// CLIENT_FindNextSynopsisFile ӿڲ
typedef struct tagNET_IN_FINDNEXT_SYNOPSISFILE
{
    DWORD               dwSize;
    int                 nFileCount;                     // ѯļ
    NET_EM_QUERY_SYNOPSIS_FILE emQueryType;             // ѯ
    void*               pSynopsisFileInfo;              // ļϢŻ 
    int                 nMaxlen;                        // С
    int                 nWaitTime;                      // ȴʱʱ䣬λms
}NET_IN_FINDNEXT_SYNOPSISFILE;

typedef struct tagNET_OUT_FINDNEXT_SYNOPSISFILE
{
    DWORD               dwSize;
    int                 nRetFileCount;                  // ӿʵʷصϢֵ<nFileCount()Ӧʱڵļѯ
}NET_OUT_FINDNEXT_SYNOPSISFILE;

// ؽȻصԭ, nErrorʾعֵ̳Ĵ1-治㣬2-ԷݵУ3-صǰļʧܣ4-Ӧļʧ
typedef void (CALLBACK *fSynopsisFileDownLoadPosCB)(LLONG lDownLoadHandle, DWORD dwFileID, DWORD dwFileTotalSize, DWORD dwDownLoadSize, int nError, LDWORD dwUser, void* pReserved);

// CLIENT_DownLoadSynosisFile ӿڲ
#define NET_SYNOPSIS_DOWNLOADFILE_INFO NET_DOWNLOADFILE_INFO

typedef struct tagNET_IN_DOWNLOAD_SYNOPSISFILE
{
    DWORD               dwSize;
    int                 nFileCount;                     // ļ
    NET_SYNOPSIS_DOWNLOADFILE_INFO* pFileInfos;         // ļϢ
    fSynopsisFileDownLoadPosCB cbPosCallBack;           // Ȼص
    LDWORD              dwUserData;                     // û
    int                 nWaitTime;                      // ȴʱʱ䣬λms
}NET_IN_DOWNLOAD_SYNOPSISFILE;

typedef struct tagNET_OUT_DOWNLOAD_SYNOPSISFILE
{
    DWORD               dwSize;
    LLONG               lDownLoadHandle;                // ؾ
}NET_OUT_DOWNLOAD_SYNOPSISFILE;

// ļ()·Ϣ
typedef struct    tagNET_SET_FILEPATH_INFO
{
    DWORD               dwSize;
    char                szFilePath[MAX_PATH];           // ļ·Ҳļ·ĿǰŨƵֻ֧davʽļ
}NET_SET_FILEPATH_INFO;

// CLIENT_SetFilePathInfo()ӿ
typedef struct tagNET_IN_SET_FILEPATHINFO
{
    DWORD                dwSize;
    DWORD                dwCount;                       // ӵļ·Ϣ
    void*                pFilePathInfo;                 // ָļ·ϢNET_SET_FILEPATH_INFO
    DWORD                dwWaitTime;                    // ȴʱʱ䣬λms
}NET_IN_SET_FILEPATHINFO;


// fAddFileStateCB 
typedef struct tagNET_CB_ADDFILESTATE
{
    DWORD               dwSize;
    const char*         szFileName;                     // ļ
    const char*         szState;                        // ļ״̬, "Successed",ɹ; "Failed"ʧܣ
}NET_CB_ADDFILESTATE;

// ¼豸صԭ, ÿ1pBuf->dwSize == nBufLen
typedef void (CALLBACK *fAddFileStateCB) (LLONG lLoginID, LLONG lAttachHandle, NET_CB_ADDFILESTATE* pBuf,  int nBufLen, LDWORD dwUser);

// CLIENT_AttacAddFileState()ӿ
typedef struct tagNET_IN_ADDFILE_STATE
{
    DWORD               dwSize;
    fAddFileStateCB     cbAttachState;                 // ļ״̬ص
    LDWORD              dwUser;                        // û
}NET_IN_ADDFILE_STATE;
typedef struct tagNET_OUT_ADDFILE_STATE
{
    DWORD                dwSize;
}NET_OUT_ADDFILE_STATE;

///////////////////////////////////ʶģؽṹ///////////////////////////////////////

// CLIENT_OperateFaceRecognitionDBӿ
typedef struct __NET_IN_OPERATE_FACERECONGNITIONDB
{
    DWORD             dwSize;
    EM_OPERATE_FACERECONGNITIONDB_TYPE emOperateType;  // 
    FACERECOGNITION_PERSON_INFO        stPersonInfo;   // ԱϢ 
    
    // ͼƬ
    char              *pBuffer;                        // ַ
    int               nBufferLen;                      // ݳ
}NET_IN_OPERATE_FACERECONGNITIONDB;

// CLIENT_OperateFaceRecognitionDBӿ
typedef struct __NET_OUT_OPERATE_FACERECONGNITIONDB
{
    DWORD               dwSize;
}NET_OUT_OPERATE_FACERECONGNITIONDB;

typedef struct __NET_FACE_MATCH_OPTIONS
{
    DWORD               dwSize;
    unsigned int        nMatchImportant;               // ԱҪȼ    1~10ֵԽԽҪ,(ѯҪȼڵڴ˵ȼԱ)
    EM_FACE_COMPARE_MODE emMode;                       // ȶģʽ,EM_FACE_COMPARE_MODE
    int                 nAreaNum;                      // 
    EM_FACE_AREA_TYPE   szAreas[MAX_FACE_AREA_NUM];    // ,emModeΪNET_FACE_COMPARE_MODE_AREAʱЧ
    int                 nAccuracy;                     // ʶ𾫶(ȡֵ1~10ֵ󣬼⾫ߣٶ½СֵΪ1 ʾٶȣֵΪ10ʾ⾫ȡ ʱֻЧ)
    int                 nSimilarity;                   // ƶ(ڸʶȲű;ٷֱȱʾ1~100)
    int                 nMaxCandidate;                 // ѡ(ƶȽȡƶĺѡ)
    
}NET_FACE_MATCH_OPTIONS;

typedef struct __NET_FACE_FILTER_CONDTION
{
    DWORD               dwSize;
    NET_TIME            stStartTime;                   // ʼʱ
    NET_TIME            stEndTime;                     // ʱ
    char                szMachineAddress[MAX_PATH];    // ص㣬֧ģƥ    
    int                 nRangeNum;                     // ʵݿ     
    BYTE                szRange[MAX_FACE_DB_NUM];      // ѯݿͣEM_FACE_DB_TYPE
    EM_FACERECOGNITION_FACE_TYPE emFaceType;           // ѯͣ EM_FACERECOGNITION
    int                 nGroupIdNum;                    // Ա   
    char                szGroupId[MAX_GOURP_NUM][DH_COMMON_STRING_64]; // ԱID 
}NET_FACE_FILTER_CONDTION;

// CLIENT_StartFindFaceRecognitionӿ
typedef struct __NET_IN_STARTFIND_FACERECONGNITION
{
    DWORD               dwSize;
    BOOL                bPersonEnable;                 // ԱϢѯǷЧ
    FACERECOGNITION_PERSON_INFO stPerson;              // ԱϢѯ
    NET_FACE_MATCH_OPTIONS stMatchOptions;             // ƥѡ
    NET_FACE_FILTER_CONDTION stFilterInfo;             // ѯ
  
    // ͼƬ
    char                *pBuffer;                      // ַ
    int                 nBufferLen;                    // ݳ

    int                 nChannelID;                    // ͨ         
}NET_IN_STARTFIND_FACERECONGNITION;

// CLIENT_StartFindFaceRecognitionӿ
typedef struct __NET_OUT_STARTFIND_FACERECONGNITION
{
    DWORD               dwSize;
    int                 nTotalCount;                   // صķϲѯļ¼ 
    LLONG               lFindHandle;                   // ѯ
}NET_OUT_STARTFIND_FACERECONGNITION;

#define MAX_FIND_COUNT  20

// CLIENT_DoFindFaceRecognition ӿ
typedef struct __NET_IN_DOFIND_FACERECONGNITION
{
    DWORD               dwSize;
    LLONG               lFindHandle;                   // ѯ
    int                 nBeginNum;                     // ѯʼ
    int                 nCount;                        // ǰѯļ¼ 
}NET_IN_DOFIND_FACERECONGNITION;

// CLIENT_DoFindFaceRecognitionӿ
typedef struct __NET_OUT_FINDNEXT_FACERECONGNITION
{
    DWORD               dwSize;
    int                 nCadidateNum;                  // ʵʷصĺѡϢṹ
    CANDIDATE_INFO      stCadidateInfo[MAX_FIND_COUNT];// ѡϢ
    
    // ͼƬ
    char                *pBuffer;                      // ַ
    int                 nBufferLen;                    // ݳ
}NET_OUT_DOFIND_FACERECONGNITION;

// CLIENT_DetectFaceӿ
typedef struct __NET_IN_DETECT_FACE
{
    DWORD               dwSize; 
    DH_PIC_INFO         stPicInfo;                     // ͼϢ

    // ͼƬ
    char                *pBuffer;                      // ַ
    int                 nBufferLen;                    // ݳ
}NET_IN_DETECT_FACE;

// CLIENT_DetectFaceӿ
typedef struct __NET_OUT_DETECT_FACE
{
    DWORD               dwSize; 
    DH_PIC_INFO         *pPicInfo;                     // ͼƬϢûռ
    int                 nMaxPicNum;                    // ͼƬϢ
    int                 nRetPicNum;                    // ʵʷصͼƬ 
    
    // ͼƬ
    char                *pBuffer;                      // ַ,ûռ䣬żͼƬ
    int                 nBufferLen;                    // ݳ
}NET_OUT_DETECT_FACE;

// Աö
typedef enum tagEM_OPERATE_FACERECONGNITION_GROUP_TYPE
{
    NET_FACERECONGNITION_GROUP_UNKOWN,
    NET_FACERECONGNITION_GROUP_ADD,                     // ԱϢ
    NET_FACERECONGNITION_GROUP_MODIFY,                  // ޸ԱϢ  
    NET_FACERECONGNITION_GROUP_DELETE,                  // ɾԱϢ
}EM_OPERATE_FACERECONGNITION_GROUP_TYPE;

// ԱϢ
typedef struct tagNET_FACERECONGNITION_GROUP_INFO
{
    DWORD               dwSize;
    EM_FACE_DB_TYPE     emFaceDBType;                  // Աͣ EM_FACE_DB_TYPE
    char                szGroupId[DH_COMMON_STRING_64];// ԱIDΨһʶһԱ(޸,ӲʱЧ)
    char                szGroupName[DH_COMMON_STRING_128]; // Ա 
    char                szGroupRemarks[DH_COMMON_STRING_256]; // Ա鱸עϢ
    int                 nGroupSize;                    // ǰԱ
}NET_FACERECONGNITION_GROUP_INFO;

// ԱϢ
typedef struct tagNET_ADD_FACERECONGNITION_GROUP_INFO
{
    DWORD               dwSize;
    NET_FACERECONGNITION_GROUP_INFO stuGroupInfo;      // ԱϢ 
}NET_ADD_FACERECONGNITION_GROUP_INFO;

// ɾԱϢ
typedef struct tagNET_DELETE_FACERECONGNITION_GROUP_INFO
{
    DWORD               dwSize;
    char                szGroupId[DH_COMMON_STRING_64];// ԱIDΨһʶһԱ
}NET_DELETE_FACERECONGNITION_GROUP_INFO;

// ޸ԱϢ
typedef struct tagNET_MODIFY_FACERECONGNITION_GROUP_INFO
{
    DWORD               dwSize;
    NET_FACERECONGNITION_GROUP_INFO stuGroupInfo;      // ԱϢ 
}NET_MODIFY_FACERECONGNITION_GROUP_INFO;

// CLIENT_OperateFaceRecognitionGroupӿ
typedef struct tagNET_IN_OPERATE_FACERECONGNITION_GROUP
{
    DWORD               dwSize;
    EM_OPERATE_FACERECONGNITION_GROUP_TYPE emOperateType; // 
    void                *pOPerateInfo;                 // زϢ
}NET_IN_OPERATE_FACERECONGNITION_GROUP;   

// CLIENT_OperateFaceRecognitionGroupӿ
typedef struct tagNET_OUT_OPERATE_FACERECONGNITION_GROUP
{
    DWORD               dwSize;
    char                szGroupId[DH_COMMON_STRING_64]; // ¼ԱIDΨһʶһԱ
}NET_OUT_OPERATE_FACERECONGNITION_GROUP;   

// CLIENT_FindGroupInfoӿ
typedef struct tagNET_IN_FIND_GROUP_INFO   
{
    DWORD               dwSize;
    char                szGroupId[DH_COMMON_STRING_64];// ԱIDΨһʶһԱ,ΪձʾѯȫԱϢ
}NET_IN_FIND_GROUP_INFO;

// CLIENT_FindGroupInfoӿ
typedef struct tagNET_OUT_FIND_GROUP_INFO   
{
    DWORD               dwSize;
    NET_FACERECONGNITION_GROUP_INFO *pGroupInfos;      // ԱϢûռ
    int                 nMaxGroupNum;                  // ǰС
    int                 nRetGroupNum;                  // 豸صԱ
}NET_OUT_FIND_GROUP_INFO;


// CLIENT_SetGroupInfoForChannelӿ
typedef struct tagNET_IN_SET_GROUPINFO_FOR_CHANNEL
{
    DWORD               dwSize;
    int                 nChannelID;                    // ͨ
    int                 nGroupIdNum;                   // Ա   
    char                szGroupId[MAX_GOURP_NUM][DH_COMMON_STRING_64]; // ԱID 
}NET_IN_SET_GROUPINFO_FOR_CHANNEL;
// CLIENT_SetGroupInfoForChannelӿ
typedef struct tagNET_OUT_SET_GROUPINFO_FOR_CHANNEL
{
    DWORD                dwSize;
}NET_OUT_SET_GROUPINFO_FOR_CHANNEL;

///////////////////////////////// ¼ϴ /////////////////////////////////

// fBurnCheckCallBack 
typedef struct tagNET_CB_BURN_CHECK_STATE
{
    DWORD               dwSize;
    const char*         szType;                         // Ϣ
                                                        // "Checking": У
                                                        // "CheckResult": У    
    BOOL                bCheckResult;                   // У, "CheckResult", TRUE-ɹ, FALSE-ʧ
    BYTE                byProgress;                     // У, "Checking", ٷֱ, 0~100
    BYTE                reserved[3];
} NET_CB_BURN_CHECK_STATE;

// ¼Уصԭ, lAttachHandleCLIENT_AttachBurnCheckStateķֵ
typedef void (CALLBACK *fBurnCheckCallBack)(LLONG lLoginID, LLONG lAttachHandle, NET_CB_BURN_CHECK_STATE* pstState, void* reserved, LDWORD dwUser);

// CLIENT_AttachBurnCheckState ӿڵ(¼У״̬)
typedef struct tagNET_IN_ATTACH_BURN_CHECK 
{
    DWORD               dwSize;
    fBurnCheckCallBack  cbBurnCheck;                    // ¼Уص
    LDWORD              dwUser;                         // û
} NET_IN_ATTACH_BURN_CHECK;

// CLIENT_AttachBurnCheckState ӿڵ(¼У״̬)
typedef struct tagNET_OUT_ATTACH_BURN_CHECK
{
    DWORD            dwSize;
} NET_OUT_ATTACH_BURN_CHECK;

///////////////////////////////// ߼豸 /////////////////////////////////

typedef struct tagNET_CB_CAMERASTATE
{
    DWORD               dwSize;
    int                 nChannel;             // ͨ
    CONNECT_STATE       emConnectState;       // ״̬
}NET_CB_CAMERASTATE;

// CLIENT_AttachCameraState()صԭ, ÿ1pBuf->dwSize == nBufLen
typedef void (CALLBACK *fCameraStateCallBack) (LLONG lLoginID, LLONG lAttachHandle, const NET_CB_CAMERASTATE *pBuf, int nBufLen, LDWORD dwUser);

// CLIENT_AttachCameraState()
typedef struct tagNET_IN_CAMERASTATE
{
    DWORD                   dwSize;
    int *                   pChannels;              // ۲ͨ,ԪУһ-1۲ͨ
    int                     nChannels;              // pChannelsָ볤
    fCameraStateCallBack    cbCamera;               // ״̬ص
    LDWORD                  dwUser;                 // û
}NET_IN_CAMERASTATE;

typedef struct tagNET_OUT_CAMERASTATE
{
    DWORD                dwSize;
}NET_OUT_CAMERASTATE;

/////////////////////////////////汾/////////////////////////////////

// 豸ץͼӿϢ
typedef struct __NET_SNAP_COMMANDINFO 
{
    char                szCardInfo[16];             // Ϣ
    char                reserved[64];               // 
} NET_SNAP_COMMANDINFO, LPNET_SNAP_COMMANDINFO;

typedef struct
{
    int                 nChannelNum;                // ͨ
    char                szUseType[32];              // ͨ;
    DWORD               dwStreamSize;               // С(λkb/s)
    char                reserved[32];               // 
} DHDEV_USE_CHANNEL_STATE;

typedef struct 
{
    char                szUserName[32];                     // û
    char                szUserGroup[32];                    // û
    NET_TIME            time;                               // ʱ
    int                 nOpenedChannelNum;                  // ͨ
    DHDEV_USE_CHANNEL_STATE    channelInfo[DH_MAX_CHANNUM];
    char                szIpAddress[DH_MAX_IPADDR_LEN_EX];  // ipַ
    char                reserved[24];
} DHDEV_USER_NET_INFO;

// ״̬Ϣ
typedef    struct 
{
    int                 nUserCount;                      // û
    DHDEV_USER_NET_INFO stuUserInfo[32];
    char                reserved[256];
}DHDEV_TOTAL_NET_STATE;

typedef struct
{
    char                szIpAddress[DH_MAX_IPADDR_LEN];  // ipַ
    char                szUserGroup[32];                 // û
    char                szUserName[32];                  // û
    char                reserved[64];
}DHDEV_USER_REJECT_INFO;

// ޳û
typedef struct
{ 
    int                       nUserCount;                // û
    DHDEV_USER_REJECT_INFO    stuUserInfo[10];     
    char                      reserved[256];
}DHDEV_REJECT_USER;

typedef struct
{
    char                szIpAddress[DH_MAX_IPADDR_LEN];  // ipַ
    char                szUserGroup[32];                 // û
    char                szUserName[32];                  // û
    int                 nForbiddenTime;                  // ʱ
    char                reserved[64];
}DHDEV_USER_SHIELD_INFO;

// û
typedef struct
{ 
    int                       nUserCount;                // û
    DHDEV_USER_SHIELD_INFO    stuUserInfo[10];     
    char                      reserved[256];
}DHDEV_SHIELD_USER;

// γ
typedef struct
{//  ǰάں
    char                chPreLogi;        // ǰñ־NSWEֱʾϡ
    char                chPreLati;        // γǰñ־NSWEֱʾϡ
    BYTE                reserved[6];      // ֽ,
    double              dbLongitude;      // 
    double              dbLatitude;       // γ
}DHDEV_LONGI_LATI;
// ϢͶϢ
typedef struct
{
    char                szPhoneNum[DH_MAX_PHONE_NO_LEN];    // 绰
    NET_TIME            stMsgTime;                          // Ϣʱ
    char                szMsgType[DH_MAX_MSGTYPE_LEN];      // ϢͣϢ-Navigation Ϣ--SMS
    char                szSmsContext[DH_MAX_MSG_LEN];       // ͵Ϣ
    DHDEV_LONGI_LATI    stLogiLati;                         // ʼγ
    unsigned int        uFlag;                              // 01־ʵγ
    char                szNavigationType[16];               // TNC,ΪµͼĵʽTXZ,Ϊߵͼĵʽ
    char                szAddress[32];                      // صϢ
    char                szNavigationMode[32];               // ģʽ RecommendƼEconomicalͣFastest 죻Shortest ̣
    DHDEV_LONGI_LATI    stPassLogiLati[5];                  // ɵ
    DHDEV_LONGI_LATI    stNoPassLogiLati[5];                // ɵ
    BYTE                reserved[256];
}DHDEV_NAVIGATION_SMSS;

// ͼˮӡ
typedef struct __DHDEV_WATERMAKE_CFG 
{
    DWORD               dwSize;
    int                 nEnable;                                // ʹ
    int                 nStream;                                // (1n)0-
    int                 nKey;                                   // (1-֣2-ͼƬ)
    char                szLetterData[DH_MAX_WATERMAKE_LETTER];  //    
    char                szData[DH_MAX_WATERMAKE_DATA];          // ͼƬ
    BYTE                bReserved[512];                         // 
} DHDEV_WATERMAKE_CFG;

// 洢λýṹ壬ÿͨ,ÿͨѡִ洢, Ŀǰ, ƶ, Զ̴洢.
typedef struct 
{
    DWORD               dwSize;
    DWORD               dwLocalMask;                            // ش洢룻λʾ
                                                                // һλϵͳԤ¼ڶλʱ¼񣬵λ¼
                                                                // λ¼񣬵λ¼񣬵λֶ¼
    DWORD               dwMobileMask;                           // ƶ洢 洢籾ش洢
    int                 RemoteType;                             // Զ̴洢 0: Ftp  1: Smb 
    DWORD               dwRemoteMask;                           // Զ̴洢 洢籾ش洢
    DWORD               dwRemoteSecondSelLocal;                 // Զ쳣ʱش洢
    DWORD               dwRemoteSecondSelMobile;                // Զ쳣ʱƶ洢
    char                SubRemotePath[MAX_PATH_STOR];           // ԶĿ¼, гΪ240
    DWORD               dwFunctionMask;                         // λλʾbit0 = 1:ץͼ¼洢λù
    DWORD               dwAutoSyncMask;                         // Ƿͬ;Զ̴洢ϻָԶش洢ͬԶ̴洢
    BYTE                bAutoSyncRange;                         // ָʱ̿ʼҪǰͬʱ䷶ΧСʱΪλ0:ͬ  1:1Сʱڵ n:nСʱڵ
    char                reserved[119];
} DH_STORAGE_STATION_CFG;

#define MAX_ALARM_DECODER_NUM 16
typedef struct  
{
    DWORD               dwAlarmDecoder;             // ֧8ڣ8λԺչ
    BYTE                bDecoderIndex;              // ʾڼ
    BYTE                bReserved[3];
} ALARM_DECODER;

// 
typedef struct
{
    int                 nAlarmDecoderNum;
    ALARM_DECODER       stuAlarmDecoder[MAX_ALARM_DECODER_NUM];
    BYTE                bReserved[32];
} ALARM_DECODER_ALARM;

//DSP
typedef struct  
{
    BOOL                bError;             //0,DSP 1,DSP쳣
    DWORD               dwErrorMask;        //λʾ0ʾд˴0ʾûС(ĿǰÿαֻһλЧ)
                                            //bit DSP
                                            // 1  DSPʧ 
                                            // 2  DSP
                                            // 3  ʽ 
                                            // 4  ֱʲ֧
                                            // 5  ݸʽ֧
                                            // 6  ҲI֡
    DWORD               dwDecChnnelMask;    //λʾĽͨţdwErrorMaskΪDSPʽԣֱʲ֧֣ݸʽ֧ʱЧ
    DWORD               dwDecChnnelMask1;   //λʾ,33-64ͨıĽͨ, dwErrorMaskΪDSPʽԣֱʲ֧֣ݸʽ֧ʱЧ
    BYTE                bReserved[24];
}DSP_ALARM;

// ˱
typedef struct  
{
    int         nFDDINum;
    BYTE        bAlarm[256];
} ALARM_FDDI_ALARM;

#define ALARM_PTZ_LOCATION_INFO DH_PTZ_LOCATION_INFO

// Ƶⱨ
typedef struct
{
    BOOL                bEnable;                    // ʹ
    int                 Volume_min;                 // Сֵ
    int                 Volume_max;                 // ֵ
    char                reserved[128];    
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT];    
    DH_MSG_HANDLE       struHandle;                 // ʽ
} DH_AUDIO_DETECT_INFO;

typedef struct  
{
    DWORD                   dwSize;
    int                     AlarmNum;
    DH_AUDIO_DETECT_INFO    AudioDetectAlarm[DH_MAX_AUDIO_IN_NUM];
    char                    reserved[256];
} DH_AUDIO_DETECT_CFG;

typedef struct
{
    BOOL                bTourEnable;                // Ѳʹ
    int                 nTourPeriod;                // Ѳλ, 5-300 
    DWORD               dwChannelMask;              // Ѳͨʽʾ
    char                reserved[64];
}DH_VIDEOGROUP_CFG;

// Ʋ
typedef struct
{
    DWORD               dwSize;
    int                 nMatrixNum;                 // (ע޸)
    DH_VIDEOGROUP_CFG   struVideoGroup[DH_MATRIX_MAXOUT];
    char                reserved[32];
} DHDEV_VIDEO_MATRIX_CFG;   

// WEB·
typedef struct 
{
    DWORD               dwSize;
    BOOL                bSnapEnable;                    // Ƿץͼ
    int                 iSnapInterval;                  // ץͼ
    char                szHostIp[DH_MAX_IPADDR_LEN];    // HTTPIP
    WORD                wHostPort;
    int                 iMsgInterval;                   // ״̬Ϣͼ
    char                szUrlState[DH_MAX_URL_LEN];     // ״̬ϢϴURL
    char                szUrlImage[DH_MAX_URL_LEN];     // ͼƬϴUrl
    char                szDevId[DH_MAX_DEV_ID_LEN];     // web
    BYTE                byReserved[2];
} DHDEV_URL_CFG;

// OEMѯ
typedef struct  
{
    char                szVendor[DH_MAX_STRING_LEN];
    char                szType[DH_MAX_STRING_LEN];
    char                reserved[128];
} DHDEV_OEM_INFO;


//ƵOSD
typedef struct 
{ 
    DWORD   rgbaFrontground;            // ǰֽڱʾֱΪ졢̡͸
    DWORD   rgbaBackground;             // ıֽڱʾֱΪ졢̡͸    
    RECT    rcRelativePos;              // λ,߾ı*8191    
    BOOL    bPreviewBlend;              // Ԥʹ    
    BOOL    bEncodeBlend;               // ʹ
    BYTE    bReserved[4];               // 
} DH_DVR_VIDEO_WIDGET;

typedef struct 
{
    DH_DVR_VIDEO_WIDGET     StOSD_POS;                                 // OSDӵλúͱɫ
    char                    SzOSD_Name[DH_VIDEO_OSD_NAME_NUM];         // OSDӵ
}DH_DVR_VIDEOITEM;
 
// ÿͨOSDϢ
typedef struct 
{
    DWORD                   dwSize;
    DH_DVR_VIDEOITEM        StOSDTitleOpt [DH_VIDEO_CUSTOM_OSD_NUM];    // ÿͨOSDϢ
    BYTE                    bReserved[16];                              // 
} DH_DVR_VIDEOOSD_CFG;

// CDMA/GPRSϢ
// ʱνṹ                                                                
typedef struct 
{
    BYTE                bEnable;                  // ʱʹܣ1ʾʱЧ0ʾʱЧ
    BYTE                bBeginHour;
    BYTE                bBeginMin;
    BYTE                bBeginSec;
    BYTE                bEndHour;
    BYTE                bEndMin;
    BYTE                bEndSec;
    BYTE                bReserved;                //
} DH_3G_TIMESECT, *LPDH_3G_TIMESECT;

typedef struct 
{
    DWORD               dwSize;
    BOOL                bEnable;                        // ģʹܱ־
    DWORD               dwTypeMask;                     // 豸֧;λʾ,һλ;Զѡ;
                                                        // ڶλTD-SCDMA磻λWCDMA;
                                                        // λCDMA 1.x;λCDMA2000;λGPRS;
                                                        // λEVDO;ڰλWIFI
    DWORD               dwNetType;                      // ǰͣΪEM_GPRSCDMA_NETWORK_TYPEֵ
    char                szAPN[128];                     // 
    char                szDialNum[128];                 // ź
    char                szUserName[128];                // û
    char                szPWD[128];                     // 
    
    /* 豸ֻ */
    BOOL                iAccessStat;                    // ע״̬
    char                szDevIP[16];                    // ǰ豸IPַ, '\0'16byte  
    char                szSubNetMask [16];              // ǰ豸룬ַ, '\0'16byte 
    char                szGateWay[16];                  // ǰ豸أַ, '\0'16byte 
    /* 豸ֻ */
    int                 iKeepLive;                      // ʱ
    DH_3G_TIMESECT      stSect[DH_N_WEEKS][DH_N_TSECT]; // 3GʱΣЧʱ֮ڣţЧʱ֮⣬رղš
    BYTE                byActivate;                     // ǷҪż

    BYTE                bySimStat;                      // SIM(UIM)״̬:1,0  (ֻ) ռReserved1ֽ
    char                szIdentify[128];                // Ȩʽ
    bool                bPPPEnable;                     // PPP,0-Ͽpppӣ1-ppp
    BYTE                bPPPState;                      // PPP״̬(ֻ)庬EM_MOBILE_PPP_STATE
    BYTE                bNetCardState;                  // ״̬(ֻ)庬EM_3GMOBILE_STATE
    char                szPhyCardNo[32];                // 
    char                Reserved[4];                    // ֽڣչ
    BYTE                byPinShow;                      // PINǷʾ(ֻ), 0-֧, 1-ʾ, 2-ʾ
    BYTE                byPinEnable;                    // PINʹ(ֻ), 0-ʹ, 1-ʹ
    BYTE                byPinCount;                     // PINʣô(ֻ), 0~3
    //-------------------------------ֶdwSizeЧ------------------------------------
    char                szPinNo[16];                    // PINֵ, ĸֵ
} DHDEV_CDMAGPRS_CFG;

// ¼
typedef struct  
{
    DWORD               dwSize;
    int                 nType;                          // 0:ʱ䣬1С
    int                 nValue;                         // nType = 0ʱ:λӣnType = 1ʱ:λKB
    char                Reserved[128];                  // ֽڣչ
} DHDEV_RECORD_PACKET_CFG;

// ()עϢ
typedef struct __DEV_AUTOREGISTER_INFO 
{
    LONG            lConnectionID;                      // ID
    char            szServerIp[DH_MAX_IPADDR_LEN];      // עIP
    int             nPort;                              // ע˿0- 65535
    int             nState;                             // ״̬0עʧܣ1-עɹ; 2-ʧ
    char            reserved[16];
} DEV_AUTOREGISTER_INFO;

typedef struct __DEV_SERVER_AUTOREGISTER 
{
    DWORD                    dwSize;
    int                      nRegisterSeverCount;                                            // ע
    DEV_AUTOREGISTER_INFO    stuDevRegisterSeverInfo[DH_CONTROL_AUTO_REGISTER_NUM];            // עϢ
    char                     reserved[256];
} DEV_SERVER_AUTOREGISTER, *LPDEV_SERVER_AUTOREGISTER;

// ¼ϴ
typedef struct
{
    DWORD               dwSize;        
    char                szSourFile[MAX_PATH_STOR];    // Դļ·
    int                 nFileSize;                    // ԴļССڵ0sdkмļС.
    char                szBurnFile[MAX_PATH_STOR];    // ¼ļ
    BYTE                bReserved[64];
} DHDEV_BURNFILE_TRANS_CFG;

// ļϴ
typedef struct
{
    char                 szFile[MAX_PATH_STOR];      // ļ·
    int                  nFileSize;                  // ļС 
    BYTE                 byChannelId;                // ͨ
    BYTE                 byManufactryType;           // ͣEM_IPC_TYPE
    BYTE                 byReserved[126];            //       
}DHDEV_UPGRADE_FILE_INFO;

// ڰϴ
typedef struct  
{
    char                 szFile[MAX_PATH_STOR];     // ڰļ·
    int                  nFileSize;                 // ļС
    BYTE                 byFileType;                // ǰļͣ0-1- 
    BYTE                 byAction;                  // 0-ǣ1-׷
    BYTE                 byReserved[126];           // 
}DHDEV_BLACKWHITE_LIST_INFO;

// ڰ
typedef struct
{
    char                 szFile[MAX_PATH_STOR];     // ڰļ·
    BYTE                 byFileType;                // ǰļͣ0-1-
    BYTE                 byReserved[127];           // 
}DHDEV_LOAD_BLACKWHITE_LIST_INFO;

// ֣ķEC_UƵݵʹ
typedef struct 
{
    BOOL                bEnable;                    // ʹ
    int                 nPort;                      // ˿
    BYTE                bReserved[64];
} DHDEV_OSD_ENABLE_CFG;

// :ʹ
typedef struct    
{
    BOOL                bAutoBootEnable;                //Զʹ
    DWORD               dwAutoBootTime;                 //ÿԶʱ, λ,0.[0,82800]
    BOOL                bAutoShutDownEnable;            //Զػʹ
    DWORD               dwAutoShutDownTime;             //ÿԶػʱ, λ,0.[0,82800]
    DWORD               dwShutDownDelayTime;            //ʱػʱ,λ.
    BYTE                bEventNoDisk;                   //1,(Ignore:); 2,(Reboot:ϵͳ)
    BYTE                bWifiEnable;                    //Ƿֳ֧ģ.
    BYTE                bUpperSpeedEnable;              //Ƿʹóж
    BYTE                bLowerSpeedEnable;              //Ƿʹõж
    DWORD               dwUpperSpeedValue;              //ֵ(1,1000)./Сʱ
    DWORD               dwLowerSpeedValue;              //ֵ(1,1000)./Сʱ
    DWORD               dwUpperSpeedDelayTime;          //óٳֵ
    DWORD               dwLowerSpeedDelayTime;          //õٳֵ
    DWORD               dwAlarmMaskEnable;              //ѯ/õӱϢʹ,0:ر,1:, ÿһλӵ͵߱ʾⲿͨ0-Nʹ
    BOOL                bSpeedOverAlarmRecordEnable;    // ٱ¼ʹ
    BOOL                bSpeedLowAlarmRecordEnable;     // ٱ¼ʹ 
    BYTE                bReserved[480];                 //reserved byte.
} DHDEV_ABOUT_VEHICLE_CFG;

// atm:ѯϢ
typedef struct  
{
    DWORD               dwDataSource;                   //λ, λ0:Net(), λ1:Com(), λ2:Com422(422)
    char                szProtocol[32][33];             //Э,󳤶32(һ).
    BYTE                bReserved[256];
} DHDEV_ATM_OVERLAY_GENERAL;
 
// atm:õ
typedef struct 
{
    DWORD               dwDataSource;                   // 1:Net(), 2:Com(), 3:Com422(422)
    char                szProtocol[33];                 // Э֣DHDEV_ATM_OVERLAY_GENERAL
    BYTE                bReserved_1[3];
    DWORD               dwChannelMask;                  // ӵͨţʾ
    BYTE                bMode;                          // 1:Preview(Ԥ), 2:Encode(), 3:Preview&Encode(Ԥͱ)
    BYTE                bLocation;                      // 1:LeftTop(), 2:LeftBottom(), 3:RightTop(), 4:RightBottom()
    BYTE                bReserved_3[2];           
    int                 nLatchTime;                     // ʾӳʱ,¼ʱرʱ,0~65535s
    BYTE                bReserved_4[3];
    BYTE                bRecordSrcKeyNum;               // ؼָ  
    int                 nRecordSrcKey[32];              // ƵͨӦԴؼ(ͬͨԶӦͬԴ)  
    BYTE                bReserved_2[120];
} DHDEV_ATM_OVERLAY_CONFIG;


// atm:õ
typedef struct 
{
    DWORD               dwSize;                         // ṹС
    DWORD               dwDataSource;                   // 1:Net(), 2:Com(), 3:Com422(422)
    char                szProtocol[33];                 // Э֣
    BYTE                bReserved_1[3];
    DWORD               dwChannelMask[8];               // ӵͨţʾ, dwChannelMask[0]ʾ0-31ͨơ
    BYTE                bMode;                          // 1:Preview(Ԥ), 2:Encode(), 3:Preview&Encode(Ԥͱ)
    BYTE                bLocation;                      // 1:LeftTop(), 2:LeftBottom(), 3:RightTop(), 4:RightBottom()
    BYTE                bReserved_3[2];           
    int                 nLatchTime;                     // ʾӳʱ,¼ʱرʱ,0~65535s
    BYTE                bReserved_4[3];
    BYTE                bRecordSrcKeyNum;               // ؼָ  
    int                 nRecordSrcKey[256];             // ƵͨӦԴؼ(ͬͨԶӦͬԴ)  
} DHDEV_ATM_OVERLAY_CONFIG_EX;

#define DH_MAX_BACKUPDEV_NUM            16
#define DH_MAX_BACKUP_NAME              32

// 豸б
typedef struct 
{
    int                 nBackupDevNum;                                // ʵʵı豸
    char                szBackupDevNames[DH_MAX_BACKUPDEV_NUM][DH_MAX_BACKUP_NAME]; // 豸
} DHDEV_BACKUP_LIST, *LPDHDEV_BACKUP_LIST;

// 豸
typedef enum __BACKUP_TYPE
{
    BT_DHFS = 0,                            // ˽ļϵͳ
    BT_DISK,                                // ƶӲ
    BT_CDRW                                 // ̿¼
} DHDEV_BACKUP_TYPE;    

// 豸ӿ
typedef enum __BACKUP_BUS
{
    BB_USB = 0,                             // usbӿ
    BB_1394,                                // 1394ӿ
    BB_IDE,                                 // ideӿ
    BB_ESATA,                               // esataӿ
} DHDEV_BACKUP_BUS;    

typedef struct 
{
    char                szName[32];                     // 豸 
    BYTE                byType;                         // 豸Ľ öֵBACKUP_TYPE
    BYTE                byBus;                          // 豸Ľӿ öֵBACKUP_BUS
    UINT                nCapability;                    // , kBytesΪλ
    UINT                nRemain;                        // ʣ,kBytesΪλ
    char                szDirectory[128];               // Զ̱ݵĿ¼
} DHDEV_BACKUP_INFO, *LPDHDEV_BACKUP_INFO;

typedef struct 
{
    char                szName[32];                     // 豸 
    UINT                nCapability;                    // , kBytesΪλ
    UINT                nRemain;                        // ǰʣ,kBytesΪλ
} DHDEV_BACKUP_FEEDBACK, *LPDHDEV_BACKUP_FEEDBACK;

#define  DH_MAX_BACKUPRECORD_NUM 1024

typedef struct  
{
    char                szDeviceName[DH_MAX_BACKUP_NAME];            //豸
    int                 nRecordNum;                                  //ݼ¼
    NET_RECORDFILE_INFO stuRecordInfo[DH_MAX_BACKUPRECORD_NUM];      //ݼ¼Ϣ
} BACKUP_RECORD, *LPBACKUP_RECORD;

// ͨƵ
typedef struct
{
    int                 iChannelID;      // ͨ
    DH_RealPlayType     realplayType;    // Ƶ
    char                reserve[32];
}DHDEV_IN_MULTIPLAY_PARAM;

// ͨƵ
typedef struct
{
    int                 iChannelID;      // ͨ
    LLONG               lRealHandle;     // ʵʱӾ
    char                reserve[32];
}DHDEV_OUT_MULTIPLAY_PARAM;


/////////////////////////////////ƽ̨/////////////////////////////////

// ƽ̨  Uͨ
typedef struct
{
    BOOL                bChnEn;
    char                szChnId[DH_INTERVIDEO_UCOM_CHANID];
} DH_INTERVIDEO_UCOM_CHN_CFG;

typedef struct
{
    DWORD               dwSize;
    BOOL                bFuncEnable;                            // 빦ʹ
    BOOL                bAliveEnable;                           // ʹ
    DWORD               dwAlivePeriod;                          // ڣλ룬0-3600
    char                szServerIp[DH_MAX_IPADDR_LEN];          // CMSIP
    WORD                wServerPort;                            // CMSPort
    char                szRegPwd[DH_INTERVIDEO_UCOM_REGPSW];    // ע
    char                szDeviceId[DH_INTERVIDEO_UCOM_DEVID];   // 豸id
    char                szUserName[DH_INTERVIDEO_UCOM_USERNAME];
    char                szPassWord[DH_INTERVIDEO_UCOM_USERPSW];
    DH_INTERVIDEO_UCOM_CHN_CFG  struChnInfo[DH_MAX_CHANNUM];    // ͨid,en
} DHDEV_INTERVIDEO_UCOM_CFG;

// ƽ̨  
typedef struct
{
    DWORD               dwSize;
    unsigned short      usCompanyID[2];             // ˾IDֵͬĵ˾4ֽڶ룬Ŀǰֻһ
    char                szDeviceNO[32];             // ǰ豸кţַ'\0'32byte
    char                szVSName[32];               // ǰ豸ƣַ'\0'16byte
    char                szVapPath[32];              // VAP·
    unsigned short      usTcpPort;                  // TCP˿ڣֵֵ 1~65535 
    unsigned short      usUdpPort;                  // UDP˿ڣֵֵ 1~65535
    bool                bCsEnable[4];               // ķʹܱ־ֵtrueʹܣfalseʹܣ4ֽڶ룬Ŀǰֻһ
    char                szCsIP[16];                 // ķIPַַ'\0'16byte
    unsigned short      usCsPort[2];                // ķ˿ڣֵֵ 1~655354ֽڶ룬Ŀǰֻһ
    bool                bHsEnable[4];               // ʹܱ־ֵtrueʹܣfalseʹܣ4ֽڶ룬Ŀǰֻһ
    char                szHsIP[16];                 // IPַַ'\0'16byte
    unsigned short      usHsPort[2];                // ˿ڣֵֵ 1~655354ֽڶ룬Ŀǰֻһ
    int                 iHsIntervalTime;            // ڣֵ(λ:)
    bool                bRsEnable[4];               // עʹܱ־ֵtrueʹܣfalseʹܣ4ֽڶ룬Ŀǰֻһ
    char                szRsIP[16];                 // עIPַַ'\0'16byte
    unsigned short      usRsPort[2];                // ע˿ڣֵֵ 1~655354ֽڶ룬Ŀǰֻһ
    int                 iRsAgedTime;                // עЧʱ䣬ֵ(λ:Сʱ)
    char                szAuthorizeServerIp[16];    // ȨIP
    unsigned short      usAuthorizePort[2];         // Ȩ˿ڣ4ֽڶ룬Ŀǰֻһ
    char                szAuthorizeUsername[32];    // Ȩʺ
    char                szAuthorizePassword[36];    // Ȩ
    
    char                szIpACS[16];                // ACS(Զע) IP
    unsigned short      usPortACS[2];               // ACS Port4ֽڶ룬Ŀǰֻһ
    char                szUsernameACS[32];          // ACSû
    char                szPasswordACS[36];          // ACS
    bool                bVideoMonitorEnabled[4];    // DVSǷϱǰƵźżϢֵtrueʹܣfalseʹ
    int                 iVideoMonitorInterval;      // ϱ()
    
    char                szCoordinateGPS[64];        // GPS
    char                szPosition[32];             // 豸λ
    char                szConnPass[36];             // 豸
} DHDEV_INTERVIDEO_BELL_CFG;

// ƽ̨  ά
typedef struct  
{
    DWORD               dwSize;
    unsigned short      nSevPort;                               // ˿ڣֵֵ1~65535
    char                szSevIp[DH_INTERVIDEO_NSS_IP];          // IPַַ'\0'32byte
    char                szDevSerial[DH_INTERVIDEO_NSS_SERIAL];  // ǰ豸кţַ'\0'32byte
    char                szUserName[DH_INTERVIDEO_NSS_USER];
    char                szPwd[DH_INTERVIDEO_NSS_PWD];
} DHDEV_INTERVIDEO_NSS_CFG;

// ƽ̨  
typedef struct  
{
    char               szDevSerial[DH_INTERVIDEO_AMP_DEVICESERIAL];                  //ǰ豸к,к,òֻ
    char               szDevName[DH_INTERVIDEO_AMP_DEVICENAME];                      //ǰ豸,,òֻ
    char               szRegUserName[DH_INTERVIDEO_AMP_USER];                        //עû
    char               szRegPwd[DH_INTERVIDEO_AMP_PWD];                              //ע
    BYTE               bReserved[128];
} DHDEV_INTERVIDEO_AMP_CFG;  
////////////////////////////////HDVRר//////////////////////////////////
// չṹ
typedef struct 
{
    /* Ϣʽͬʱִʽ
     * 0x00000001 - ϴ
     * 0x00000002 - ¼
     * 0x00000004 - ̨
     * 0x00000008 - ʼ
     * 0x00000010 - Ѳ
     * 0x00000020 - ʾ
     * 0x00000040 - 
     * 0x00000080 - Ftpϴ
     * 0x00000100 - 
     * 0x00000200 - ʾ
     * 0x00000400 - ץͼ
    */

    /* ǰֵ֧Ĵʽλʾ */
    DWORD               dwActionMask;

    /* λʾ嶯ҪĲڸԵ */
    DWORD               dwActionFlag;
    
    /* ͨΪ1ʾ */ 
    BYTE                byRelAlarmOut[DH_MAX_ALARMOUT_NUM_EX];
    DWORD               dwDuration;                                 /* ʱ */

    /* ¼ */
    BYTE                byRecordChannel[DH_MAX_VIDEO_IN_NUM_EX];    /* ¼ͨΪ1ʾͨ */
    DWORD               dwRecLatch;                                 /* ¼ʱ */

    /* ץͼͨ */
    BYTE                bySnap[DH_MAX_VIDEO_IN_NUM_EX];
    /* Ѳͨ */
    BYTE                byTour[DH_MAX_VIDEO_IN_NUM_EX];             /* Ѳͨ 0-31·*/

    /* ̨ */
    DH_PTZ_LINK         struPtzLink[DH_MAX_VIDEO_IN_NUM_EX];
    DWORD               dwEventLatch;                               /* ʼʱʱ䣬sΪλΧ0~15Ĭֵ0 */
    /* ͨΪ1ʾ */ 
    BYTE                byRelWIAlarmOut[DH_MAX_ALARMOUT_NUM_EX];
    BYTE                bMessageToNet;
    BYTE                bMMSEn;                                     /*űʹ*/
    BYTE                bySnapshotTimes;                            /*ŷץͼ */
    BYTE                bMatrixEn;                                  /*!< ʹ */
    DWORD               dwMatrix;                                   /*!<  */            
    BYTE                bLog;                                       /*!< ־ʹܣĿǰֻWTN̬ʹ */
    BYTE                bSnapshotPeriod;                            /*!<ץͼ֡ÿ֡ץһͼƬһʱץĵץͼ֡йء0ʾ֡ץġ*/
    BYTE                byTour2[DH_MAX_VIDEO_IN_NUM_EX];            /* Ѳͨ 32-63·*/
    BYTE                byEmailType;                                /*<0ͼƬ1¼񸽼>*/
    BYTE                byEmailMaxLength;                           /*<¼ʱ󳤶ȣλMB>*/
    BYTE                byEmailMaxTime;                             /*<¼ʱʱ䳤ȣλ>*/
    BYTE                byReserved[475];   
} DH_MSG_HANDLE_EX;

// ⲿչ
typedef struct
{
    BYTE                byAlarmType;                        // ͣ0գ1
    BYTE                byAlarmEn;                          // ʹ
    BYTE                byReserved[2];                        
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT]; //NSP
    DH_MSG_HANDLE_EX    struHandle;                         // ʽ
} DH_ALARMIN_CFG_EX, *LPDHDEV_ALARMIN_CFG_EX; 

// ̬ⱨ
typedef struct 
{
    BYTE                byMotionEn;                         // ̬ⱨʹ
    BYTE                byReserved;
    WORD                wSenseLevel;                        // 
    WORD                wMotionRow;                         // ̬
    WORD                wMotionCol;                         // ̬
    BYTE                byDetected[DH_MOTION_ROW][DH_MOTION_COL]; // 32*32
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT]; //NSP
    DH_MSG_HANDLE_EX        struHandle;                     //ʽ
} DH_MOTION_DETECT_CFG_EX;


// 𾯱
typedef struct
{
    BOOL                byFireEn;              // 𾯱ʱܣ
    DH_MSG_HANDLE_EX    struHandle;            // ʽ
    BYTE                byReserved[128];
}DHDEV_FIRE_ALARM_CFG;

// ̬ⱨ 
typedef struct 
{
    BYTE                byStaticEn;                         // ̬ⱨʹ
    BYTE                byLatch;                            // ʱ(Χ0-127ΧnLatch)    
    WORD                wSenseLevel;                        // 
    WORD                wStaticRow;                         // ̬
    WORD                wStaticCol;                         // ̬
    BYTE                byDetected[DH_STATIC_ROW][DH_STATIC_COL]; // 32*32
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT]; // NSP
    DH_MSG_HANDLE_EX    struHandle;                         // ʽ
    int                 nLatch;                             // ʱ
    BYTE                bReserved[64];                      // ֶ
} DH_STATIC_DETECT_CFG_EX;

// ACC߱¼
typedef struct _DHDEV_ACC_POWEROFF_CFG
{
    BOOL                bEnable;               // ACC߱ʹ
    int                 nDelayTime;            // ACC߱ʱʱ,λ
    DH_MSG_HANDLE_EX    struHandle;            // ʽ
    BYTE                Reserved[128];         // ֶ
}DHDEV_ACC_POWEROFF_CFG;

// б¼
typedef struct _DHDEV_EXPLOSION_PROOF_CFG
{
    BOOL                bEnable;               // бʹ
    DH_MSG_HANDLE_EX    struHandle;            // ʽ
    BYTE                Reserved[128];         // ֶ
}DHDEV_EXPLOSION_PROOF_CFG;

// Raid¼
typedef struct _DHDEV_RAID_EVENT_CFG
{
    BOOL                bEnable;               // Raid¼ʹ
    DH_MSG_HANDLE_EX    struHandle;            // ʽ
    BYTE                Reserved[128];         // ֶ
}DHDEV_RAID_EVENT_CFG;

// Ƶʧ
typedef struct
{
    BYTE                byAlarmEn;                          // Ƶʧʹ
    BYTE                byReserved[3];
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT]; // NSP
    DH_MSG_HANDLE_EX    struHandle;                         // ʽ
} DH_VIDEO_LOST_CFG_EX;

// ͼڵ
typedef struct
{
    BYTE                byBlindEnable;                      // ʹ
    BYTE                byBlindLevel;                       // 1-6
    BYTE                byReserved[2];
    DH_TSECT            stSect[DH_N_WEEKS][DH_N_REC_TSECT]; // NSP
    DH_MSG_HANDLE_EX    struHandle;                         // ʽ
} DH_BLIND_CFG_EX;

// ӲϢ(ڲ)
typedef struct 
{
    BYTE                byNoDiskEn;                         // Ӳʱ
    BYTE                byReserved_1[3];
    DH_TSECT            stNDSect[DH_N_WEEKS][DH_N_REC_TSECT]; //NSP
    DH_MSG_HANDLE_EX    struNDHandle;                       // ʽ
    BYTE                byLowCapEn;                         // Ӳ̵ʱ
    BYTE                byLowerLimit;                       // ֵ0-99
    BYTE                byReserved_2[2];
    DH_TSECT            stLCSect[DH_N_WEEKS][DH_N_REC_TSECT]; //NSP
    DH_MSG_HANDLE_EX    struLCHandle;                       // ʽ
    BYTE                byDiskErrEn;                        // Ӳ̹ϱ
    BYTE                bDiskNum;
    BYTE                byReserved_3[2];
    DH_TSECT            stEDSect[DH_N_WEEKS][DH_N_REC_TSECT]; //NSP
    DH_MSG_HANDLE_EX    struEDHandle;                       // ʽ
} DH_DISK_ALARM_CFG_EX;

typedef struct
{
    BYTE                byEnable;
    BYTE                byReserved[3];
    DH_MSG_HANDLE_EX    struHandle;
} DH_NETBROKEN_ALARM_CFG_EX;

// ǰ˽òϢ
typedef struct __DEV_ENCODER_CFG 
{
    int                 nChannels;                  // ͨ
    DEV_ENCODER_INFO    stuDevInfo[32];             // ͨǰ˱Ϣ
    BYTE                byHDAbility;                // ָ֧ͨƵ(Ϊ0ʾָ֧)
                                                    // עָ֧ãͨΪ0~N-1N֮ͨΪ壬пܱ治ɹ
    BYTE                bTVAdjust;                  // 豸Ƿ֧TV, 0:֧ 1:֧.
    BYTE                bDecodeTour;                // 豸Ƿֽ֧Ѳ, 0:֧ 0:ʾǰ֧Ѳ豸.
    BYTE                bRemotePTZCtl;              // ָʾǷ֧Զ̨ơ

    char                reserved[12];
} DEV_ENCODER_CFG, *LPDEV_ENCODER_CFG;

// ǰ˽òϢչ
typedef struct __DEV_ENCODER_CFG_EX 
{
    int                 nChannels;                  // ͨ
    DEV_ENCODER_INFO    stuDevInfo[128];            // ͨǰ˱Ϣ
    BYTE                byHDAbility;                // ָ֧ͨƵ(Ϊ0ʾָ֧)
    // עָ֧ãͨΪ0~N-1N֮ͨΪ壬пܱ治ɹ
    BYTE                bTVAdjust;                  // 豸Ƿ֧TV, 0:֧ 1:֧.
    BYTE                bDecodeTour;                // 豸Ƿֽ֧Ѳ, 0:֧ 0:ʾǰ֧Ѳ豸.
    BYTE                bRemotePTZCtl;              // ָʾǷ֧Զ̨ơ
    char                reserved[256];
} DEV_ENCODER_CFG_EX, *LPDEV_ENCODER_CFG_EX;

// struct 
typedef struct tagDHCONFIG_CONTROLER{
    DH_COMM_PROP        struComm;                        // 
    BYTE                bLightGroup[DH_MAX_LIGHT_NUM];   // ܿص飨Ŵ1ʼ[1,3,8,00]ʾΪ1,3,8ĵ
    BYTE                bDeviceAddr;                     // ַ
    BYTE                bComPortType;                    //  0:485, 1:232
    BYTE                bReserved[6];                    // 
} DH_CONFIG_CONTROLER;

// ƹ
typedef struct __DHDEV_LIGHTCONTROL_CFG
{
    DH_CONFIG_CONTROLER    struControlers[DH_MAX_CONTROLER_NUM];  // 
    BYTE                   bControlerNum;                         // ЧĿ
    BYTE                   bReserved[1023];                       // 
} DHDEV_LIGHTCONTROL_CFG, *LPDHDEV_LIGHTCONTROL_CFG;

// 3GϢ
typedef struct
{
    int                 nStrategy;       //ʹò, 0: 1:ʱ
    int                 nUpLimit;        //ʹ, : λMB ʱ: λСʱ
    int                 nreserved[22];   //ֽ
}DHDEV_3GFLOW_INFO_CFG;

// IPv6
typedef struct 
{
    char               szLinkAddr[44];      // ·ַ: ַ, Ϊ44;(ÿ̨ӵΨһ·ַֻ)
    char               szHostIP[40];        // IP
    DWORD              dwPreFix;            // ǰ׺Χ1-128ɶд
    char               szGateWay[40];       // Ĭ
    BOOL               bAutoGet;            // Զȡʹ
    char               szPrimaryDns[40];    // ѡDNS
    char               szSecondDns[40];     // ѡDNS
    char               cReserved[256];      // ֶ
}DHDEV_IPV6_CFG;

//洢
typedef struct __DEV_URGENCY_RECORD_CFG
{
    DWORD   dwSize;             // ṹС
    BOOL    bEnable;            // Ƿʹܣ1ʹܣ0ʹ
    UINT    nMaxRecordTime;     // ¼ʱ䣬λ
}DHDEV_URGENCY_RECORD_CFG;

// в
typedef struct __DEV_ELEVATOR_ATTRI_CFG
{
    DWORD   dwSize;             // ṹС
    UINT    nMAXFloorNum;       //¥ С2
    UINT    nFloorDelayTime;    //ͣжʱ,5-60ִʱ䳤Ϊǵͣ¥㡣
    UINT    nIntervalTime;      //лоһʱ䣬ʱ䣬Ϊݹϣֹ֮ͣ䡣
}DHDEV_ELEVATOR_ATTRI_CFG;

// ͷ״̬ѯ
typedef struct tagDHDEV_VIRTUALCAMERA_STATE_INFO
{
    DWORD              nStructSize;                  // ṹС
    int                nChannelID;                   // ͨ
    CONNECT_STATE      emConnectState;               // ״̬
    UINT               uiPOEPort;                    // ͷӵPOE˿ںţ0ʾPOE 
    char               szDeviceName[64];             // 豸
    char               szDeviceType[128];            // 豸
    char               szSystemType[128];            // ϵͳ汾
    char               szSerialNo[DH_SERIALNO_LEN];  // к
    int                nVideoInput;                  // Ƶ
    int                nAudioInput;                  // Ƶ
    int                nAlarmOutput;                 // ⲿ
}DHDEV_VIRTUALCAMERA_STATE_INFO;

// 豸Ƶ/Ȧģʽ״̬Ϣѯ
typedef struct tagDHDEV_TRAFFICWORKSTATE_INFO
{
    DWORD                nStructSize;      // ṹС
    int                  nChannelID;       // ͨ
    DH_TRAFFIC_SNAP_MODE emSnapMode;       // ץģʽ
}DHDEV_TRAFFICWORKSTATE_INFO;

/////////////////////////////////ܽͨͼƬĽӿڲ/////////////////////////////////
typedef struct RESERVED_DATA_INTEL_BOX
{
    DWORD  dwEventCount;        //¼
    DWORD* dwPtrEventType;      //ָ¼͵ֵռûԼ롣
    DWORD  dwInternalTime;      // ͼƬϴʱ䣬λs
    BYTE   bReserved[1020];     //ֽ
}ReservedDataIntelBox;

#define RESERVED_TYPE_FOR_INTEL_BOX 0x00000001
typedef struct RESERVED_PARA
{
    DWORD   dwType;         //pData
                            //[dwType]ΪRESERVED_TYPE_FOR_INTEL_BOX ʱpData ӦΪṹReservedDataIntelBoxĵַ                    
                            //[dwType]Ϊ...ʱ[pData]Ӧ...
    void*   pData;          //
}ReservedPara;

#define RESERVED_TYPE_FOR_COMMON   0x00000010
typedef struct tagNET_RESERVED_COMMON
{
    DWORD                   dwStructSize;
    ReservedDataIntelBox*   pIntelBox;          // RESERVED_TYPE_FOR_INTEL_BOX
    DWORD                   dwSnapFlagMask;     // ץͼ־(λ)0λ:"*",1λ:"Timing",2λ:"Manual",3λ:"Marked",4λ:"Event",5λ:"Mosaic",6λ:"Cutout"
}NET_RESERVED_COMMON;

/////////////////////////////////ƽӿڲ/////////////////////////////////
// ṹϢ
typedef struct 
{
    DWORD       dwSize;
    int         nScene;     //
}DHDEV_INTELLI_SCENE_INFO;
// ߽λϢ
typedef struct 
{
    DWORD       dwSize;
    int         nScene;     //
    int         nType;      //0:ϱ߽λ1:±߽λ2:߽磬3:ұ߽
}DHDEV_INTELLI_SCENELIMIT_INFO;
// ֶĿṹϢ
typedef struct
{
    DWORD       dwSize;
    int         nObjectID;   // ID-1 ʾwebϿѡ֡ϴλ壬>=0ʾѡ֡ϴ
    RECT        stuBound;    // ηΧһ[0,8192]
}DHDEV_INTELLI_TRACKOBJECT_INFO;

typedef enum __TRACKCONTROL_TYPE
{
        DH_TRACK_MARKSCENE,        // 궨, ӦDHDEV_INTELLI_SCENE_INFOṹ
        DH_TRACK_GOTOSCENE,        // ת,ӦDHDEV_INTELLI_SCENE_INFOṹ
        DH_TRACK_MARKSCENELIMIT,   // 궨߽λ,ӦDHDEV_INTELLI_SCENELIMIT_INFOṹ
        DH_TRACK_GOTOSCENELIMIT,   // ת߽λ,ӦDHDEV_INTELLI_SCENELIMIT_INFOṹ
        DH_TRACK_MARKSCENEMAXZOOM, // 궨ٱ, ӦDHDEV_INTELLI_SCENE_INFOṹ
        DH_TRACK_OBJECT,           // ѡгеĸĿ,ӦDHDEV_INTELLI_TRACKOBJECT_INFO
        DH_TRACK_START,            // ʼܸ٣ָϢ
        DH_TRACK_STOP,             // ֹܸͣ٣ָϢ
        DH_TRACK_TYPE_NUM,
}DH_TRACKCONTROL_TYPE;
//
typedef struct tagNET_IN_CONTROL_INTELLITRACKER
{
    DWORD       dwSize;
    int         nChannelID;            // ͨID
    DH_TRACKCONTROL_TYPE emCtrlType;   // 
    void*       pCtrlInfo;             // ͶӦϢṹָ룬μDH_TRACKCONTROL_TYPE塣
    int         nMaxLen;               // ϢṹС
    int         nWaittime;             // ȴʱʱ
}NET_IN_CONTROL_INTELLITRACKER;
//
typedef struct tagNET_OUT_CONTROL_INTELLITRACKER
{
    DWORD       dwSize;
}NET_OUT_CONTROL_INTELLITRACKER;

/////////////////////////////////̭/////////////////////////////////

// ѯ豸״̬ͨϢؽӿ̭벻Ҫʹ
typedef struct
{
    BYTE                byRecordStatic;             // ͨǷ¼0¼1ֶ¼2Զ¼
    BYTE                bySignalStatic;             // ӵź״̬01źŶʧ
    BYTE                byHardwareStatic;           // ͨӲ״̬01쳣DSP
    char                reserve;
    DWORD               dwBitRate;                  // ʵ
    DWORD               dwLinkNum;                  // ͻӵĸ
    DWORD               dwClientIP[DH_MAX_LINK];    // ͻ˵IPַ
} NET_DEV_CHANNELSTATE, *LPNET_DEV_CHANNELSTATE;

// ѯ豸״̬ؽӿ̭벻Ҫʹ
typedef struct
{
    DWORD                dwDeviceStatic;                    // 豸״̬0x000x01CPUռùߣ0x02Ӳ
    NET_DEV_DISKSTATE    stHardDiskStatic[DH_MAX_DISKNUM]; 
    NET_DEV_CHANNELSTATE stChanStatic[DH_MAX_CHANNUM];      //ͨ״̬
    BYTE                 byAlarmInStatic[DH_MAX_ALARMIN];   //˿ڵ״̬0ûб1б
    BYTE                 byAlarmOutStatic[DH_MAX_ALARMOUT]; //˿ڵ״̬0û1б
    DWORD                dwLocalDisplay;                    // ʾ״̬01
} NET_DEV_WORKSTATE, *LPNET_DEV_WORKSTATE;

// ЭϢ
typedef struct 
{
    char                 protocolname[12];        // Э
    unsigned int         baudbase;                // 
    unsigned char        databits;                // λ
    unsigned char        stopbits;                // ֹͣλ
    unsigned char        parity;                  // Уλ
    unsigned char        reserve;
} PROTOCOL_INFO, *LPPROTOCOL_INFO;

// Խ
typedef struct 
{
    // Ƶ
    BYTE                byInFormatTag;            // ͣPCM
    BYTE                byInChannels;             // 
    WORD                wInBitsPerSample;         //                     
    DWORD               dwInSamplesPerSec;        // 

    // Ƶ
    BYTE                byOutFormatTag;           // ͣPCM
    BYTE                byOutChannels;            // 
    WORD                wOutBitsPerSample;        //                 
    DWORD               dwOutSamplesPerSec;       // 
} DHDEV_TALK_CFG, *LPDHDEV_TALK_CFG;


///////////////////////////////////  ///////////////////////////////////////

#define DH_MATRIX_INTERFACE_LEN         16          // źŽӿƳ
#define DH_MATRIX_MAX_CARDS             128         // ӿ
#define DH_SPLIT_PIP_BASE               1000        // ָģʽлĻֵ
#define DH_MAX_SPLIT_MODE_NUM           64          // ָģʽ
#define DH_MATRIX_MAX_CHANNEL_IN        1500        // ͨ
#define DH_MATRIX_MAX_CHANNEL_OUT       256         // ͨ
#define DH_DEVICE_NAME_LEN              64          // 豸Ƴ
#define DH_MAX_CPU_NUM                  16          // CPU
#define DH_MAX_FAN_NUM                  16          // 
#define DH_MAX_POWER_NUM                16          // Դ
#define DH_MAX_BATTERY_NUM              16          // 
#define DH_MAX_TEMPERATURE_NUM          32          // ¶ȴ
#define DH_MAX_ISCSI_NAME_LEN           128         // ISCSIƳ
#define DH_VERSION_LEN                  64          // 汾Ϣ
#define DH_MAX_STORAGE_PARTITION_NUM    32          // 洢
#define DH_STORAGE_MOUNT_LEN            64          // ص㳤
#define DH_STORAGE_FILE_SYSTEM_LEN      16          // ļϵͳƳ
#define DH_MAX_MEMBER_PER_RAID          32          // RAIDԱ
#define DH_DEV_ID_LEN_EX                128         // 豸ID󳤶
#define DH_MAX_BLOCK_NUM                32          // 
#define DH_MAX_SPLIT_WINDOW             128         // ָ
#define DH_FILE_TYPE_LEN                64          // ļͳ
#define DH_DEV_ID_LEN                   128         // 豸ID󳤶
#define DH_DEV_NAME_LEN                 128         // 豸󳤶
#define DH_TSCHE_DAY_NUM                8           // ʱһάС, ʾ
#define DH_TSCHE_SEC_NUM                6           // ʱڶάС, ʾʱ
#define DH_SPLIT_INPUT_NUM              256         // ˾豸лʱһsplitֵ֧ͨ

#define DH_DEVICE_ID_LOCAL              "Local"     // 豸ID
#define DH_DEVICE_ID_REMOTE             "Remote"    // Զ豸ID
#define DH_DEVICE_ID_UNIQUE             "Unique"    // 豸ͳһ

// ָģʽ
typedef enum tagDH_SPLIT_MODE
{
    DH_SPLIT_1 = 1,                                 // 1
    DH_SPLIT_2 = 2,                                 // 2
    DH_SPLIT_4 = 4,                                 // 4
    DH_SPLIT_6 = 6,                                 // 6
    DH_SPLIT_8 = 8,                                 // 8
    DH_SPLIT_9 = 9,                                 // 9
    DH_SPLIT_12 = 12,                               // 12
    DH_SPLIT_16 = 16,                               // 16
    DH_SPLIT_20 = 20,                               // 20
    DH_SPLIT_25 = 25,                               // 25
    DH_SPLIT_36 = 36,                               // 36
    DH_SPLIT_64 = 64,                               // 64
    DH_SPLIT_144 = 144,                             // 144
    DH_PIP_1 = DH_SPLIT_PIP_BASE + 1,               // лģʽ, 1ȫ+1С洰
    DH_PIP_3 = DH_SPLIT_PIP_BASE + 3,               // лģʽ, 1ȫ+3С洰
    DH_SPLIT_FREE = DH_SPLIT_PIP_BASE * 2,          // ɿģʽɴرմڣôλúZ
    DH_COMPOSITE_SPLIT_1 = DH_SPLIT_PIP_BASE * 3 + 1,    // ںԱ1ָ
    DH_COMPOSITE_SPLIT_4 = DH_SPLIT_PIP_BASE * 3 + 4,    // ںԱ4ָ
} DH_SPLIT_MODE;

#define DH_PROTOCOL_DAHUA2 DH_PROTOCOL_PRIVATE2
#define DH_PROTOCOL_DAHUA3 DH_PROTOCOL_PRIVATE3

// 豸Э
typedef enum tagDH_DEVICE_PROTOCOL
{
    DH_PROTOCOL_PRIVATE2,                   // ˽2Э
    DH_PROTOCOL_PRIVATE3,                   // ˽3Э
    DH_PROTOCOL_ONVIF,                      // Onvif    
    DH_PROTOCOL_VNC,                        // 
    DH_PROTOCOL_TS,                         // ׼TS
    
    DH_PROTOCOL_PRIVATE = 100,              // ˽Э        
    DH_PROTOCOL_AEBELL,                     // 籴        
    DH_PROTOCOL_PANASONIC,                  //         
    DH_PROTOCOL_SONY,                       //         
    DH_PROTOCOL_DYNACOLOR,                  // Dynacolor        
    DH_PROTOCOL_TCWS,                       //         
    DH_PROTOCOL_SAMSUNG,                    //         
    DH_PROTOCOL_YOKO,                       // YOKO        
    DH_PROTOCOL_AXIS,                       // Ѷ        
    DH_PROTOCOL_SANYO,                      //                
    DH_PROTOCOL_BOSH,                       // Bosch        
    DH_PROTOCOL_PECLO,                      // Peclo        
    DH_PROTOCOL_PROVIDEO,                   // Provideo        
    DH_PROTOCOL_ACTI,                       // ACTi        
    DH_PROTOCOL_VIVOTEK,                    // Vivotek        
    DH_PROTOCOL_ARECONT,                    // Arecont        
    DH_PROTOCOL_PRIVATEEH,                  // PrivateEH            
    DH_PROTOCOL_IMATEK,                     // IMatek        
    DH_PROTOCOL_SHANY,                      // Shany        
    DH_PROTOCOL_VIDEOTREC,                  // ӯ        
    DH_PROTOCOL_URA,                        // Ura        
    DH_PROTOCOL_BITICINO,                   // Bticino         
    DH_PROTOCOL_ONVIF2,                     // OnvifЭ, ͬDH_PROTOCOL_ONVIF    
    DH_PROTOCOL_SHEPHERD,                   // Ӱ        
    DH_PROTOCOL_YAAN,                       // ǰ        
    DH_PROTOCOL_AIRPOINT,                   // Airpop        
    DH_PROTOCOL_TYCO,                       // TYCO        
    DH_PROTOCOL_XUNMEI,                     // Ѷ        
    DH_PROTOCOL_HIKVISION,                  //         
    DH_PROTOCOL_LG,                         // LG        
    DH_PROTOCOL_AOQIMAN,                    //         
    DH_PROTOCOL_BAOKANG,                    //             
    DH_PROTOCOL_WATCHNET,                   // Watchnet        
    DH_PROTOCOL_XVISION,                    // Xvision        
    DH_PROTOCOL_FUSITSU,                    // ʿͨ        
    DH_PROTOCOL_CANON,                      // Canon        
    DH_PROTOCOL_GE,                         // GE        
    DH_PROTOCOL_Basler,                     // ˹        
    DH_PROTOCOL_Patro,                      //         
    DH_PROTOCOL_CPKNC,                      // CPPLUS Kϵ        
    DH_PROTOCOL_CPRNC,                      // CPPLUS Rϵ        
    DH_PROTOCOL_CPUNC,                      // CPPLUS Uϵ        
    DH_PROTOCOL_CPPLUS,                     // CPPLUS IPC    
    DH_PROTOCOL_XunmeiS,                    // Ѷs,ʵЭΪOnvif        
    DH_PROTOCOL_GDDW,                       // 㶫        
    DH_PROTOCOL_PSIA,                       // PSIA        
    DH_PROTOCOL_GB2818,                     // GB2818            
    DH_PROTOCOL_GDYX,                       // GDYX        
    DH_PROTOCOL_OTHER,                      // ûԶ   
} DH_DEVICE_PROTOCOL;

// һĻķָģʽϢ
typedef struct tagDH_SPLIT_MODE_INFO
{
    DWORD               dwSize;
    DH_SPLIT_MODE       emSplitMode;            // ָģʽ
    int                 nGroupID;               // 
    DWORD               dwDisplayType;          // ʾͣDH_SPLIT_DISPLAY_TYPEע͸ģʽʾ"PicInPic", ģʽʾݰNVDйDisChnֶξݣûһʱĬΪͨʾ,"General"
} DH_SPLIT_MODE_INFO;

// ָ
typedef struct tagDH_SPLIT_CAPS 
{
    DWORD               dwSize;
    int                 nModeCount;                             // ֵ֧ķָģʽ
    DH_SPLIT_MODE       emSplitMode[DH_MAX_SPLIT_MODE_NUM];     // ֵ֧ķָģʽ
    int                 nMaxSourceCount;                        // ʾԴ
    int                 nFreeWindowCount;                       // ֵ֧ɿĿ
    BOOL                bCollectionSupported;                   // Ƿ֧ղ
    DWORD               dwDisplayType;                          // ʾʾͣDH_SPLIT_DISPLAY_TYPEע͸ģʽʾ"PicInPic", ģʽʾݰNVDйDisChnֶξݣûһʱĬΪͨʾ,"General"
    int                 nPIPModeCount;                          // лֵ֧ķָģʽ
    DH_SPLIT_MODE       emPIPSplitMode[DH_MAX_SPLIT_MODE_NUM];  // лֵ֧ķָģʽ
    int                 nInputChannels[DH_SPLIT_INPUT_NUM];     // ֵ֧ͨ
    int                 nInputChannelCount;                     // ֵ֧ͨ, 0ʾûͨ
    int                 nBootModeCount;                         // ָģʽ
    DH_SPLIT_MODE       emBootMode[DH_MAX_SPLIT_MODE_NUM];      // ֵ֧Ĭϻָģʽ
} DH_SPLIT_CAPS;

// Ȩ֤Ϣ
typedef struct tagDH_CASCADE_AUTHENTICATOR
{
    DWORD               dwSize;
    char                szUser[DH_NEW_USER_NAME_LENGTH];        // û
    char                szPwd[DH_NEW_USER_PSW_LENGTH];          // 
    char                szSerialNo[DH_SERIALNO_LEN];            // 豸к
} DH_CASCADE_AUTHENTICATOR;

// ʾԴ
typedef struct tagDH_SPLIT_SOURCE
{
    DWORD               dwSize;
    BOOL                bEnable;                                // ʹ
    char                szIp[DH_MAX_IPADDR_LEN];                // IP, ձʾû
    char                szUser[DH_USER_NAME_LENGTH];            // û
    char                szPwd[DH_USER_PSW_LENGTH];              // 
    int                 nPort;                                  // ˿
    int                 nChannelID;                             // ͨ
    int                 nStreamType;                            // Ƶ, -1-Զ, 0-, 1-1, 2-2, 3-3, 4-snap, 5-Ԥ
    int                 nDefinition;                            // , 0-, 1-
    DH_DEVICE_PROTOCOL  emProtocol;                             // Э
    char                szDevName[DH_DEVICE_NAME_LEN];          // 豸
    int                 nVideoChannel;                          // Ƶͨ
    int                 nAudioChannel;                          // Ƶͨ
    //--------------------------------------------------------------------------------------
    // ֻԽЧ
    BOOL                bDecoder;                               // Ƿǽ
    BYTE                byConnType;                             // -1: auto, 0TCP1UDP2鲥
    BYTE                byWorkMode;                             // 0ֱ1ת
    WORD                wListenPort;                            // ָʾĶ˿ڣתʱЧ; byConnTypeΪ鲥ʱΪಥ˿
    char                szDevIpEx[DH_MAX_IPADDR_OR_DOMAIN_LEN]; // szDevIpչǰDVRIPַ()
    BYTE                bySnapMode;                             // ץͼģʽ(nStreamType==4ʱЧ) 0ʾһ֡,1ʾʱ
    BYTE                byManuFactory;                          // Ŀ豸, οEM_IPC_TYPE
    BYTE                byDeviceType;                           // Ŀ豸豸, 0:IPC
    BYTE                byDecodePolicy;                         // Ŀ豸Ľ, 0:ǰ
                                                                // 1:ʵʱȼ 2:ʵʱȼ
                                                                // 3:ʵʱȼ 4:Ĭϵȼ
                                                                // 5:ȼ 6:ȼ
                                                                // 7:ȼ
    //--------------------------------------------------------------------------------------
    DWORD               dwHttpPort;                             // Http˿ں, 0-65535
    DWORD               dwRtspPort;                             // Rtsp˿ں, 0-65535
    char                szChnName[DH_DEVICE_NAME_LEN];          // Զͨ, ֻжȡƲΪʱſ޸ĸͨ
    char                szMcastIP[DH_MAX_IPADDR_LEN];           // ಥIPַ, byConnTypeΪ鲥ʱЧ
    char                szDeviceID[DH_DEV_ID_LEN_EX];           // 豸ID, ""-null, "Local"-ͨ, "Remote"-Զͨ, RemoteDeviceе豸ID
    BOOL                bRemoteChannel;                         // ǷԶͨ(ֻ)
    unsigned int        nRemoteChannelID;                       // ԶͨID(ֻ), bRemoteChannel=TRUEʱЧ
    char                szDevClass[DH_DEV_TYPE_LEN];            // 豸, IPC, DVR, NVR
    char                szDevType[DH_DEV_TYPE_LEN];             // 豸ͺ, IPC-HF3300
    char                szMainStreamUrl[MAX_PATH];              // urlַ, byManuFactoryΪDH_IPC_OTHERʱЧ
    char                szExtraStreamUrl[MAX_PATH];             // urlַ, byManuFactoryΪDH_IPC_OTHERʱЧ
    int                 nUniqueChannel;                         // 豸ͳһŵΨһͨ, ֻ
    DH_CASCADE_AUTHENTICATOR stuCascadeAuth;                    // ֤Ϣ, 豸IDΪ"Local/Cascade/SerialNo"ʱЧ, SerialNo豸к
    int                 nHint;                                  // 0-ͨƵԴ, 1-ƵԴ
    int                 nOptionalMainUrlCount;                  // ַ
    char                szOptionalMainUrls[DH_MAX_OPTIONAL_URL_NUM][MAX_PATH];  // ַб
    int                 nOptionalExtraUrlCount;                 // øַ
    char                szOptionalExtraUrls[DH_MAX_OPTIONAL_URL_NUM][MAX_PATH]; // øַб
    //--------------------------------------------------------------------------------------
    //Эֶ
    int                 nInterval;                              // Ѳʱ	λ
} DH_SPLIT_SOURCE;

// Ƶ
typedef struct tagDH_VIDEO_OUT_CAPS 
{
    DWORD               dwSize;
    BOOL                bColor;                                 // Ƿ֧ɫ
    BOOL                bMargin;                                // Ƿֱ֧߽
    int                 nLayers;                                // ֧ͬʱʾͼ
    BOOL                bPowerMode;                             // Ƿֵ֧Դ
    int                 bSplitMode;                             // ֵ֧Ļָģʽ, 0-, 1-'#'ģʽ(), 2-ģʽ
    unsigned int        nBackground;                            // ֵ֧ıʽ, λʾ, 0-ɫ, 1-ͼƬ
    BOOL                bBindOutput;                            // Ƿֱ֧ʰ
} DH_VIDEO_OUT_CAPS;

// ɫBCSH
typedef struct tagDH_COLOR_BCSH 
{
    int                 nBirghtness;                // 
    int                 nContrast;                  // Աȶ
    int                 nSaturation;                // Ͷ
    int                 nHue;                       // ɫ
} DH_COLOR_BCSH;

// ߴ
typedef struct tagDH_SIZE 
{
    int                 nWidth;                     // 
    int                 nHeight;                    // ߶
} DH_SIZE;

// Ȱβģʽ
typedef struct tagDH_HOT_PLUG_MODE
{
    DWORD               dwSize;
    int                 nMode;                      // Ȱβģʽ, 0-Ȳģʽ, 1-ǿģʽ
} DH_HOT_PLUG_MODE;

// Ƶѡ
typedef struct tagDH_VIDEO_OUT_OPT
{
    DWORD               dwSize;
    DH_RECT*            pstuMargin;                 // ߽緶Χ
    DH_COLOR_BCSH*      pstuColor;                  // ɫ
    DH_COLOR_RGBA*      pstuBackground;             // ɫ
    DH_SIZE*            pstuSize;                   // ߴ
    DH_HOT_PLUG_MODE*   pstuHotPlugMode;            // Ȱβģʽ
} DH_VIDEO_OUT_OPT;

// Ʒ
typedef struct tagDH_PRODUCTION_DEFNITION
{
    DWORD               dwSize;
    int                 nVideoInChannel;                        // Ƶͨ
    int                 nVideoOutChannel;                       // Ƶͨ
    int                 nRemoteDecChannel;                      // Զ̽ͨ
    char                szDevType[DH_DEV_TYPE_LEN];             // 豸
    char                szVendor[DH_MAX_NAME_LEN];              // OEMͻ
    int                 nOEMVersion;                            // OEM汾
    int                 nMajorVerion;                           // 汾
    int                 nMinorVersion;                          // ΰ汾
    int                 nRevision;                              // ޶汾
    char                szWebVerion[DH_MAX_NAME_LEN];           // Web汾
    char                szDefLanguage[DH_MAX_NAME_LEN];         // Ĭ
    NET_TIME            stuBuildDateTime;                       // ʱ, ȷ
    int                 nAudioInChannel;                        // Ƶͨ
    int                 nAudioOutChannel;                       // Ƶͨ
    BOOL                bGeneralRecord;                         // Ƿֶ֧ʱ洢
    BOOL                bLocalStore;                            // Ƿֱ֧ش洢
    BOOL                bRemoteStore;                           // Ƿ֧洢
    BOOL                bLocalurgentStore;                      // Ƿֽ֧洢
    BOOL                bRealtimeCompress;                      // Ƿ֧ʵʱѹ洢
    DWORD               dwVideoStandards;                       // ֵ֧Ƶʽб, bit0-PAL, bit1-NTSC
    int                 nDefVideoStandard;                      // ĬƵʽ, 0-PAL, 1-NTSC
    int                 nMaxExtraStream;                        // ·
    int                 nRemoteRecordChannel;                   // Զ¼ͨ
    int                 nRemoteSnapChannel;                     // Զץͼͨ
    int                 nRemoteVideoAnalyseChannel;             // ԶƵͨ
    int                 nRemoteTransmitChannel;                 // Զʵʱתͨ
    int                 nRemoteTransmitFileChannel;             // Զļͨͨ
    int                 nStreamTransmitChannel;                 // 紫ͨ
    int                 nStreamReadChannel;                     // ļͨ
    int                 nMaxStreamSendBitrate;                  // 緢, kbps
    int                 nMaxStreamRecvBitrate;                  // ӿ, kbps
    BOOL                bCompressOldFile;                       // Ƿѹļ, ȥP֡, I֡
    BOOL                bRaid;                                  // Ƿ֧RAID
    int                 nMaxPreRecordTime;                      // Ԥ¼ʱ, s
    BOOL                bPtzAlarm;                              // Ƿ̨֧
    BOOL                bPtz;                                   // Ƿ̨֧
    BOOL                bATM;                                   // ǷʾATMع
    BOOL                b3G;                                    // Ƿ֧3Gģ
    BOOL                bNumericKey;                            // Ƿּ
    BOOL                bShiftKey;                              // ǷShift
    BOOL                bCorrectKeyMap;                         // ĸӳǷȷ
    BOOL                bNewATM;                                // µĶATMǰ
    BOOL                bDecoder;                               // Ƿǽ
    DEV_DECODER_INFO    stuDecoderInfo;                         // Ϣ, bDecoder=trueʱЧ
    int                 nVideoOutputCompositeChannels;          // ںͨ
    BOOL                bSupportedWPS;                          // Ƿ֧WPS
    int                 nVGAVideoOutputChannels;                // VGAƵͨ
    int                 nTVVideoOutputChannels;                 // TVƵͨ
    int                 nMaxRemoteInputChannels;                // Զͨ
    int                 nMaxMatrixInputChannels;                // ͨ
    int                 nMaxRoadWays;                           // ܽͨ󳵵 1~6
    int                 nMaxParkingSpaceScreen;                 // Խֵ֧ 0~20

    int                 nPtzHorizontalAngleMin;                 // ̨ˮƽСǶ, [0-360]
    int                 nPtzHorizontalAngleMax;                 // ̨ˮƽǶ, [0-360]
    int                 nPtzVerticalAngleMin;                   // ֱ̨СǶ, [-90,90]
    int                 nPtzVerticalAngleMax;                   // ֱ̨Ƕ, [-90,90]
    BOOL                bPtzFunctionMenu;                       // Ƿ̨֧ܲ˵
    BOOL                bLightingControl;                       // Ƿֵ֧ƹ
    DWORD               dwLightingControlMode;                  // ֶƹģʽ, λ, NET_LIGHTING_CTRL_ON_OFF
    int                 nNearLightNumber;                       // , 0ʾ֧
    int                 nFarLightNumber;                        // Զ, 0ʾ֧
    BOOL                bFocus;                                 // Ƿֿ֧ƾ۽
    BOOL                bIris;                                  // Ƿֿ֧ƹȦ
    char                szPtzProtocolList[DH_COMMON_STRING_1024];// ֵ̨֧Эб, Ƕ, ÿ';'ָ
    BOOL                bRainBrushControl;                      // Ƿ֧ˢ
    int                 nBrushNumber;                           // ˢ, Ϊ0ʱʾ֧
    int                 nLowerMatrixInputChannels[DH_MAX_LOWER_MITRIX_NUM]; // λƵͨ, ±Ӧ
    int                 nLowerMatrixOutputChannels[DH_MAX_LOWER_MITRIX_NUM];// λƵͨ, ±Ӧ
    BOOL                bSupportVideoAnalyse;                   // Ƿ֧ܷ
    BOOL                bSupportIntelliTracker;                 // Ƿ֧ܸ

    DWORD               nSupportBreaking;                       //豸ֵ֧Υ(λȡ)
                                                                //0- 1-ѹ 2- 3-Ƿ 4- 5-гռ 6-ռ 7-Υʻתתͷ
                                                                //8-Υ½ 9-Υͣ 10-ͨӵ 11-ʻ 12-Υ± 13-ѹ 14-·ʻ
                                                                //15-ֶץ 16-Υ 17- 18- 19-С 20-Υռ 21-Υµ
                                                                //22-ѹֹͣ 23-Ƶ 24-ͣ 25-λг 26-λ޳ 27-λгѹ 28-޳
                                                                //29- 30-ϵȫ 31-ʻԱ
    DWORD               nSupportBreaking1;                      //0-ʻԱ绰
} DH_PRODUCTION_DEFNITION;

// ֶƹģʽ
#define NET_LIGHTING_CTRL_ON_OFF                0x01            // ֱӿģʽ
#define NET_LIGHTING_CTRL_ADJUST_BRIGHTNESS     0x02            // ֶģʽ
#define NET_LIGHTING_CTRL_ZOOM_PRIO             0x04            // 


// ӿ, Ϳ
#define DH_MATRIX_CARD_MAIN                 0x10000000          // 
#define DH_MATRIX_CARD_INPUT                0x00000001          // 뿨
#define DH_MATRIX_CARD_OUTPUT               0x00000002          // 
#define DH_MATRIX_CARD_ENCODE               0x00000004          // 뿨
#define DH_MATRIX_CARD_DECODE               0x00000008          // 뿨
#define DH_MATRIX_CARD_CASCADE              0x00000010          // 
#define DH_MATRIX_CARD_INTELLIGENT          0x00000020          // ܿ
#define DH_MATRIX_CARD_ALARM                0x00000040          // 
#define DH_MATRIX_CARD_RAID                 0x00000080          // ӲRaid

// ӿϢ
typedef struct tagDH_MATRIX_CARD
{
    DWORD               dwSize;
    BOOL                bEnable;                                // ǷЧ
    DWORD               dwCardType;                             // ӿ
    char                szInterface[DH_MATRIX_INTERFACE_LEN];   // źŽӿ, "CVBS", "VGA", "DVI"...
    char                szAddress[DH_MAX_IPADDR_OR_DOMAIN_LEN]; // 豸ip, ӿڵӿΪ
    int                 nPort;                                  // ˿ں, ӿڵӿΪ0
    int                 nDefinition;                            // , 0=, 1=
    int                 nVideoInChn;                            // Ƶͨ
    int                 nAudioInChn;                            // Ƶͨ
    int                 nVideoOutChn;                           // Ƶͨ
    int                 nAudioOutChn;                           // Ƶͨ
    int                 nVideoEncChn;                           // Ƶͨ
    int                 nAudioEncChn;                           // Ƶͨ
    int                 nVideoDecChn;                           // Ƶͨ
    int                 nAudioDecChn;                           // Ƶͨ
    int                 nStauts;                                // ״̬: -1-δ֪, 0-, 1-Ӧ, 2-, 3-ͻ, 4-, 5-·״̬쳣, 6-Ӱ屳δ, 7-汾
    int                 nCommPorts;                             // 
    int                 nVideoInChnMin;                         // ƵͨСֵ
    int                 nVideoInChnMax;                         // Ƶֵͨ
    int                 nAudioInChnMin;                         // ƵͨСֵ
    int                 nAudioInChnMax;                         // Ƶֵͨ
    int                 nVideoOutChnMin;                        // ƵͨСֵ
    int                 nVideoOutChnMax;                        // Ƶֵͨ
    int                 nAudioOutChnMin;                        // ƵͨСֵ
    int                 nAudioOutChnMax;                        // Ƶֵͨ    
    int                 nVideoEncChnMin;                        // ƵͨСֵ
    int                 nVideoEncChnMax;                        // Ƶֵͨ
    int                 nAudioEncChnMin;                        // ƵͨСֵ
    int                 nAudioEncChnMax;                        // Ƶֵͨ
    int                 nVideoDecChnMin;                        // ƵͨСֵ
    int                 nVideoDecChnMax;                        // Ƶֵͨ
    int                 nAudioDecChnMin;                        // ƵͨСֵ
    int                 nAudioDecChnMax;                        // Ƶֵͨ
    int                 nCascadeChannels;                       // ͨ
    int                 nCascadeChannelBitrate;                 // ͨ, λMbps
    int                 nAlarmInChnCount;                       // ͨ
    int                 nAlarmInChnMin;                         // ͨСֵ
    int                 nAlarmInChnMax;                         // ֵͨ
    int                 nAlarmOutChnCount;                      // ͨ
    int                 nAlarmOutChnMin;                        // ͨСֵ
    int                 nAlarmOutChnMax;                        // ֵͨ
    int                 nVideoAnalyseChnCount;                  // ܷͨ
    int                 nVideoAnalyseChnMin;                    // ܷͨСֵ
    int                 nVideoAnalyseChnMax;                    // ֵܷͨ
    int                 nCommPortMin;                           // ںСֵ
    int                 nCommPortMax;                           // ںֵ
    char                szVersion[DH_COMMON_STRING_32];         // 汾Ϣ
    NET_TIME            stuBuildTime;                           // ʱ
} DH_MATRIX_CARD;

// ӿб
typedef struct tagDH_MATRIX_CARD_LIST 
{
    DWORD               dwSize;
    int                 nCount;                                 // ӿ
    DH_MATRIX_CARD      stuCards[DH_MATRIX_MAX_CARDS];          // ӿб
} DH_MATRIX_CARD_LIST;

// Ƶ
typedef struct tagDH_VIDEO_OUT_WINDOW
{
    DWORD               dwSize;
    int                 nBackboardID;               // 
    int                 nScreenID;                  // Ļ
    int                 nWindowID;                  // ں
} DH_VIDEO_OUT_WINDOW;

// CLIENT_GetISCSITargetsӿ
typedef struct tagDH_IN_ISCSI_TARGETS
{
    DWORD               dwSize;
    const char*         pszAddress;                 // ַ
    int                 nPort;                      // ˿
    const char*         pszUser;                    // û
    const char*         pszPwd;                     // 
} DH_IN_ISCSI_TARGETS;

// ISCSI TargetϢ
typedef struct tagDH_ISCSI_TARGET 
{
    DWORD               dwSize;
    char                szName[DH_MAX_ISCSI_NAME_LEN];              // 
    char                szAddress[DH_MAX_IPADDR_OR_DOMAIN_LEN];     // ַ
    char                szUser[DH_NEW_USER_NAME_LENGTH];            // û
    int                 nPort;                                      // ˿
    UINT                nStatus;                                    // ״̬, 0-δ֪, 1-, 2-δ, 3-ʧ, 4-֤ʧ, 5-ӳʱ, 6-    
} DH_ISCSI_TARGET;

// CLIENT_GetISCSITargetsӿ
typedef struct tagDH_OUT_ISCSI_TARGETS
{
    DWORD               dwSize;
    DH_ISCSI_TARGET*    pstuTargets;                // iscsi
    int                 nMaxCount;                  // iscsiС
    int                 nRetCount;                  // ȡiscsiϢ
} DH_OUT_ISCSI_TARGETS;

typedef enum tagDH_BITMAP_ACCURACY
{
    BA_DAY ,            // 
    BA_HOUR ,           //Сʱ
    BA_5MIN ,           //5
}DH_BITMAP_ACCURACY;

#define DH_MAX_BITMAPS        256                        // λͼֽDH_MAX_BITMAPS*8λ
#define DH_MAX_CHN_NUM        256                        // ͨ
//CLIENT_GetBitmapӿ
typedef struct tagDH_IN_BITMAP
{
    DWORD               dwSize;
    NET_TIME            stuStartTime;                   // ʼʱ, ȷ
    NET_TIME            stuEndTime;                     // ʱ, ȷ
    int                 nChnList[DH_MAX_CHN_NUM];       // [1, , 10]    ͨб,-1ʾȫͨ,0ʾб
    DH_BITMAP_ACCURACY  emAccuracy;                     // λͼ    
}DH_IN_BITMAP;

typedef struct tagDH_BITMAP_INFO
{
    DWORD               dwSize;
    int                 nChnID;                         //ͨţͨλ0ʾб
    BYTE                bBitmap[DH_MAX_BITMAPS];        //λͼ(ÿһλʾһѯ̶ȣɵλλ)
                                                        //֧DH_MAX_BITMAPS * 8̶
    int                 nBitNum;                        //ȡλͼλ
}DH_BITMAP_INFO;

//CLIENT_GetBitmapӿ
typedef struct tagDH_OUT_BITMAP
{
    DWORD               dwSize;
    DH_BITMAP_INFO      *pstBitmapInfos;
    int                 nGetBitmapInfo;
    int                 nMaxBitmapInfo;    
}DH_OUT_BITMAP;

// 洢豸
typedef struct tagDH_STORAGE_DEVICE_NAME 
{
    DWORD               dwSize;
    char                szName[DH_STORAGE_NAME_LEN];
} DH_STORAGE_DEVICE_NAME;

// RAID״̬
#define DH_RAID_STATE_ACTIVE            0x00000001
#define DH_RAID_STATE_INACTIVE          0x00000002
#define DH_RAID_STATE_CLEAN             0x00000004
#define DH_RAID_STATE_FAILED            0x00000008
#define DH_RAID_STATE_DEGRADED          0x00000010
#define DH_RAID_STATE_RECOVERING        0x00000020
#define DH_RAID_STATE_RESYNCING         0x00000040
#define DH_RAID_STATE_RESHAPING         0x00000080
#define DH_RAID_STATE_CHECKING          0x00000100
#define DH_RAID_STATE_NOTSTARTED        0x00000200

// RAIDԱϢ
typedef struct tagNET_RAID_MEMBER_INFO 
{
    DWORD               dwSize;
    DWORD               dwID;                                       // ̺, ڴŹĲλ
    BOOL                bSpare;                                     // Ƿֲȱ, true-ֲȱ, false-RAID
} NET_RAID_MEMBER_INFO;

// RAIDϢ
typedef struct tagDH_STORAGE_RAID
{
    DWORD               dwSize;
    int                 nLevel;                                     // ȼ    
    int                 nState;                                     // RAID״̬, DH_RAID_STATE_ACTIVE | DH_RAID_STATE_DEGRADED
    int                 nMemberNum;                                 // Ա
    char                szMembers[DH_MAX_MEMBER_PER_RAID][DH_STORAGE_NAME_LEN];    // RAIDԱ
    float               fRecoverPercent;                            // ͬٷֱ, 0~100, RAID״̬"Recovering""Resyncing"ʱЧ
    float               fRecoverMBps;                               // ͬٶ, λMBps, RAID״̬"Recovering""Resyncing"ʱЧ
    float               fRecoverTimeRemain;                         // ͬʣʱ, λ, RAID״̬"Recovering""Resyncing"ʱЧ
    NET_RAID_MEMBER_INFO stuMemberInfos[DH_MAX_MEMBER_PER_RAID];    // RAIDԱϢ
} DH_STORAGE_RAID;

// 洢Ϣ
typedef struct tagDH_STORAGE_PARTITION
{
    DWORD               dwSize;
    char                szName[DH_STORAGE_NAME_LEN];                // 
    INT64               nTotalSpace;                                // ܿռ, byte
    INT64               nFreeSpace;                                 // ʣռ, byte
    char                szMountOn[DH_STORAGE_MOUNT_LEN];            // ص
    char                szFileSystem[DH_STORAGE_FILE_SYSTEM_LEN];   // ļϵͳ
    int                 nStatus;                                    // ״̬, 0-LV, 1-LV
} DH_STORAGE_PARTITION;

// չϢ
typedef struct tagDH_STORAGE_TANK 
{
    DWORD               dwSize;
    int                 nLevel;                                     // , ǵ0
    int                 nTankNo;                                    // ͬһչڵչڱ, 0ʼ
    int                 nSlot;                                      // Ӧϵİ忨, 0ʼ
} DH_STORAGE_TANK;

// 洢豸״̬
#define NET_STORAGE_DEV_OFFLINE                 0                   // Ӳѻ״̬
#define NET_STORAGE_DEV_RUNNING                 1                   // Ӳ״̬
#define NET_STORAGE_DEV_ACTIVE                  2                   // RAID
#define NET_STORAGE_DEV_SYNC                    3                   // RAIDͬ
#define NET_STORAGE_DEV_SPARE                   4                   // RAIDȱ(ֲ)
#define NET_STORAGE_DEV_FAULTY                  5                   // RAIDʧЧ
#define NET_STORAGE_DEV_REBUILDING              6                   // RAIDؽ
#define NET_STORAGE_DEV_REMOVED                 7                   // RAIDƳ
#define NET_STORAGE_DEV_WRITE_ERROR             8                   // RAIDд
#define NET_STORAGE_DEV_WANT_REPLACEMENT        9                   // RAIDҪ滻
#define NET_STORAGE_DEV_REPLACEMENT             10                  // RAID豸
#define NET_STORAGE_DEV_GLOBAL_SPARE            11                  // ȫȱ
#define NET_STORAGE_DEV_ERROR                   12                  // , ַ
#define NET_STORAGE_DEV_RAIDSUB                 13                  // Ŀǰǵ, ԭǿRaid, пԶRaid

// 洢豸Ϣ
typedef struct tagDH_STORAGE_DEVICE 
{
    DWORD               dwSize;
    char                szName[DH_STORAGE_NAME_LEN];                    // 
    INT64               nTotalSpace;                                    // ܿռ, byte
    INT64               nFreeSpace;                                     // ʣռ, byte
    BYTE                byMedia;                                        // , 0-DISK, 1-CDROM, 2-FLASH
    BYTE                byBUS;                                          // , 0-ATA, 1-SATA, 2-USB, 3-SDIO, 4-SCSI
    BYTE                byVolume;                                       // , 0-, 1-Raid, 2-VG, 3-ISCSI
    BYTE                byState;                                        // Ӳ״̬, ȡֵΪNET_STORAGE_DEV_OFFLINENET_STORAGE_DEV_RUNNING
    int                 nPhysicNo;                                      // ͬ豸洢ӿڵ
    int                 nLogicNo;                                       // ͬ豸洢ӿڵ߼
    char                szParent[DH_STORAGE_NAME_LEN];                  // ϼ洢
    char                szModule[DH_STORAGE_NAME_LEN];                  // 豸ģ
    char                szSerial[DH_SERIALNO_LEN];                      // 豸к
    char                szFirmware[DH_VERSION_LEN];                     // ̼汾
    int                 nPartitionNum;                                  // 
    DH_STORAGE_PARTITION stuPartitions[DH_MAX_STORAGE_PARTITION_NUM];   // Ϣ
    DH_STORAGE_RAID     stuRaid;                                        // RAIDϢ, ֻRAIDЧ(byVolume == 1)
    DH_ISCSI_TARGET     stuISCSI;                                       // ISCSIϢ, ֻISCSIЧ(byVolume == 3)
    BOOL                abTank;                                         // չʹ
    DH_STORAGE_TANK     stuTank;                                        // ӲչϢ, abTankΪTRUEʱЧ
} DH_STORAGE_DEVICE;

// ָOSDϢ
typedef struct tagNET_SPLIT_OSD 
{
    DWORD               dwSize;
    BOOL                bEnable;                    // ʹ
    DH_COLOR_RGBA       stuFrontColor;              // ǰɫ
    DH_COLOR_RGBA       stuBackColor;               // ɫ
    DH_RECT             stuFrontRect;               // ǰ
    DH_RECT             stuBackRect;                // 
    BOOL                bRoll;                      // Ƿʾ, ֻıЧ
    BYTE                byRollMode;                 // ģʽ, ֻıЧ, 0-, 1-
    BYTE                byRoolSpeed;                // , ֻıЧ, 0~4, ֵԽԽ
    BYTE                byFontSize;                 // С, ֻıЧ
    BYTE                byTextAlign;                // 뷽ʽ, 0-, 1-, 2-
    BYTE                byType;                     // OSD, 0-ı, 1-ͼ
    BYTE                Reserved[3];                // ֽ
    char                szContent[MAX_PATH];        // OSD, Ϊͼ, Ϊͼ
    float               fPitch;                     // ַ, 0.0 ~ 5.0
    char                szFontType[DH_COMMON_STRING_64]; // 
} NET_SPLIT_OSD;

// CLIENT_GetSplitOSD ӿ(ȡ봰OSDϢ)
typedef struct tagDH_IN_SPLIT_GET_OSD
{
    DWORD               dwSize;
    int                 nChannel;                   // ͨ
    int                 nWindow;                    // ں
} DH_IN_SPLIT_GET_OSD;

// CLIENT_GetSplitOSD ӿ(ȡ봰OSDϢ)
typedef struct tagDH_OUT_SPLIT_GET_OSD
{
    DWORD               dwSize;
    int                 nOSDNum;                            // OSD
    NET_SPLIT_OSD       stuOSD[DH_VIDEO_CUSTOM_OSD_NUM];    // OSDϢ
} DH_OUT_SPLIT_GET_OSD;

// CLIENT_SetSplitOSD ӿ(ý봰OSDϢ)
typedef struct tagDH_IN_SPLIT_SET_OSD
{
    DWORD               dwSize;
    int                 nChannel;                           // ͨ
    int                 nWindow;                            // ں
    int                 nOSDNum;                            // OSD
    NET_SPLIT_OSD       stuOSD[DH_VIDEO_CUSTOM_OSD_NUM];    // OSDϢ
} DH_IN_SPLIT_SET_OSD;

// CLIENT_SetSplitOSD ӿ(ý봰OSDϢ)
typedef struct tagDH_OUT_SPLIT_SET_OSD
{
    DWORD               dwSize;
} DH_OUT_SPLIT_SET_OSD;

// ƵƷʽ
typedef enum
{
    EM_VIDEO_OUT_CTRL_CHANNEL,              // ߼ͨſƷʽ, ƴЧ
    EM_VIDEO_OUT_CTRL_COMPOSITE_ID,         // ƴIDƷʽ, ֻƴЧ
} EM_VIDEO_OUT_CTRL_TYPE;

// CLIENT_SetSplitSourceEx ӿڵ
typedef struct tagNET_IN_SET_SPLIT_SOURCE 
{
    DWORD                   dwSize;
    EM_VIDEO_OUT_CTRL_TYPE  emCtrlType;         // ƵƷʽ
    int                     nChannel;           // Ƶ߼ͨ, emCtrlTypeΪEM_VIDEO_OUT_CTRL_CHANNELʱЧ
    const char*             pszCompositeID;     // ƴID, emCtrlTypeΪEM_VIDEO_OUT_CTRL_COMPOSITE_IDʱЧ
    int                     nWindow;            // ں, -1ʾǰָģʽµд
    DH_SPLIT_SOURCE*        pstuSources;        // ƵԴϢ, nWindow=-1ʱ, ƵԴǸ, 봰һ
    int                     nSourceCount;       // ƵԴ
} NET_IN_SET_SPLIT_SOURCE;

// ƵԴķؽ
typedef struct tagNET_SET_SPLIT_SOURCE_RESULT 
{
    DWORD                   dwSize;
    int                     nPushPort;          // ģʽ豸˼˿ں
} NET_SET_SPLIT_SOURCE_RESULT;

// CLIENT_SetSplitSourceEx ӿڵ
typedef struct tagNET_OUT_SET_SPLIT_SOURCE
{
    DWORD                   dwSize;
    NET_SET_SPLIT_SOURCE_RESULT* pstuResults;   // óɹķֵ, ӦNET_IN_SET_SPLIT_SOURCEеĴ, ûڴ, ҪΪNULL
    int                     nMaxResultCount;    // pstuResultsĴС
    int                     nRetCount;          // ص
} NET_OUT_SET_SPLIT_SOURCE;

//ö
typedef enum tagNET_VOLUME_TYPE
{
    VOLUME_TYPE_ALL = 0      ,      //о
    VOLUME_TYPE_PHYSICAL     ,      //
    VOLUME_TYPE_RAID         ,      //Raid
    VOLUME_TYPE_VOLUME_GROUP ,      //VG
    VOLUME_TYPE_ISCSI        ,      //iSCSI
    VOLUME_TYPE_INVIDUAL_PHY ,      //̣ûм뵽 RAIDȵУ
    VOLUME_TYPE_GLOBAL_SPARE ,      //ȫȱ
    VOLUME_TYPE_MAX          ,
}NET_VOLUME_TYPE;


#define    MAX_DEVICE_VOLUME_NUMS        128                //͵

//CLIENT_QueryDevInfo , NET_QUERY_DEV_STORAGE_NAMESͽӿ
typedef struct tagNET_IN_STORAGE_DEV_NAMES
{
    DWORD               dwSize;
    NET_VOLUME_TYPE     emVolumeType;       //Ҫȡľ
} NET_IN_STORAGE_DEV_NAMES;

//CLIENT_QueryDevInfo , NET_QUERY_DEV_STORAGE_NAMESͽӿ
typedef struct tagNET_OUT_STORAGE_DEV_NAMES
{
    DWORD               dwSize;
    int                 nDevNamesNum;                       //ȡ豸Ĵ洢ģ
    char                szStoregeDevNames[MAX_DEVICE_VOLUME_NUMS][DH_STORAGE_NAME_LEN]; //豸б
}NET_OUT_STORAGE_DEV_NAMES;

//CLIENT_QueryDevInfo , NET_QUERY_DEV_STORAGE_INFOSӿ
typedef struct tagNET_IN_STORAGE_DEV_INFOS
{
    DWORD               dwSize;
    NET_VOLUME_TYPE     emVolumeType;       //Ҫȡľ
} NET_IN_STORAGE_DEV_INFOS;

//CLIENT_QueryDevInfo , NET_QUERY_DEV_STORAGE_INFOSӿ
typedef struct tagNET_OUT_STORAGE_DEV_INFOS
{
    DWORD               dwSize;
    int                 nDevInfosNum;                      //ȡ豸Ĵ洢ģϢб
    DH_STORAGE_DEVICE   stuStoregeDevInfos[MAX_DEVICE_VOLUME_NUMS]; //豸Ϣб,DH_STORAGE_DEVICEdwsize踳ֵ
} NET_OUT_STORAGE_DEV_INFOS;

typedef enum tagNET_RECENCY_CAR_INFO
{
    RECENCY_CAR_INFO_UNKNOW = 0 ,
    RECENCY_CAR_INFOO_NEWEST    ,      //
    RECENCY_CAR_INFO_ODLEST     ,      //
    RECENCY_CAR_INFO_MAX        ,
}NET_RECENCY_CAR_INFO;

//CLIENT_QueryDevInfo , NET_QUERY_RECENCY_JNNCTION_CAR_INFOӿ
typedef struct tagNET_IN_GET_RECENCY_JUNCTION_CAR_INFO
{
    DWORD                   dwSize;
    int                     nChannel;       //ץͨ
    NET_RECENCY_CAR_INFO    emRecencyType;  //ȡϢͣµĻɵ
    DWORD                   nIndex;         //ڼϢ,1ʼΪ0Ҳʾ1
}NET_IN_GET_RECENCY_JUNCTION_CAR_INFO;

//CLIENT_QueryDevInfo , NET_QUERY_RECENCY_JNNCTION_CAR_INFOӿ
typedef struct tagNET_OUT_GET_RECENCY_JUNCTION_CAR_INFO
{
    DWORD           dwSize;
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stTrafficCar;        // ͨϢ
}NET_OUT_GET_RECENCY_JUNCTION_CAR_INFO;

// 
#define NET_MAX_FISHEYE_WINDOW_NUM               8         // ۴

// λϢ
typedef struct tagNET_FISHEYE_WINDOW_INFO
{
    DWORD             dwSize;
    DWORD             dwWindowID;                        // ID
    int               nFocusX;                           // EPtz̨Ľ
    int               nFocusY;                           // EPtz (̨Ľ   
    int               nHorizontalAngle;                  // EPtzˮƽǶ
    int               nVerticalAngle;                    // EPtzĴֱǶ
}NET_FISHEYE_WINDOW_INFO;

// ӦCLIENT_QueryDevInfoӿڣNET_QUERY_DEV_FISHEYE_WININFOѯ۴Ϣ
typedef struct tagNET_IN_FISHEYE_WININFO
{
    DWORD               dwSize;
    int                 nChannelId;                      // ͨ
    int                 nWindowNum;                      // ѯĴ
    int                 nWindows[NET_MAX_FISHEYE_WINDOW_NUM]; // idظ
}NET_IN_FISHEYE_WININFO;

// ӦCLIENT_QueryDevInfoӿڣNET_QUERY_DEV_FISHEYE_WININFOѯ۴Ϣ
typedef struct tagNET_OUT_FISHEYE_WININFO
{
    DWORD               dwSize;
    int                 nWindowNum;                      //Ĵ
    NET_FISHEYE_WINDOW_INFO stuWindows[NET_MAX_FISHEYE_WINDOW_NUM]; // ھϢ
}NET_OUT_FISHEYE_WININFO;

//CLIENT_QueryDevInfo , NET_QUERY_LANES_STATEӿ
typedef struct tagNET_IN_GET_LANES_STATE
{
    DWORD                   dwSize;
    int                     nLaneNumber; //-1ѯг,>=0ʱʾѯָ
}NET_IN_GET_LANES_STATE;

//źŵָʾ״̬
typedef enum tagNET_TRAFFIC_LIGHT_STATUS
{
    LIGHT_STATUS_UNKNOWN  = 0   ,    //δ֪
    LIGHT_STATUS_RED            ,    //
    LIGHT_STATUS_GREEN          ,    //̵
    LIGHT_STATUS_YELLOW         ,    //Ƶ
}NET_TRAFFIC_LIGHT_STATUS;

//źŵָʾϢ
typedef struct tatNET_TRAFFIC_LIGHT_INFO
{
    DWORD                       dwSize;
    NET_TRAFFIC_LIGHT_STATUS    emStraightLightInfo;    //ֱźŵ״̬
    NET_TRAFFIC_LIGHT_STATUS    emLeftLightInfo;        //תźŵ״̬
    NET_TRAFFIC_LIGHT_STATUS    emRightLightInfo;       //תźŵ״̬
    NET_TRAFFIC_LIGHT_STATUS    emUTurnLightInfo;       //ͷźŵ״̬
}NET_TRAFFIC_LIGHT_INFO;

//
typedef enum tagNET_TRAFFIC_DIRECTION
{
    DIRECTION_UNKNOW    = 0 ,   //δ֪
    DIRECTION_STRAIGHT      ,   //ֱ
    DIRECTION_LEFT          ,   //ת
    DIRECTION_RIGHT         ,   //ת
    DIRECTION_UTURN         ,   //ͷ
}NET_TRAFFIC_DIRECTION;

//Ϣ
typedef struct tagNET_TRAFFIC_LANE_INFO
{
    DWORD                   dwSize;
    UINT                    nLaneNumber;                                    //,0ʼ
    UINT                    nSupportDirectionNum;                           //ʹķ
    NET_TRAFFIC_DIRECTION   emTrafficDirections[MAX_LANE_DIRECTION_NUM];    //,ʾ˳ʹз
    NET_TRAFFIC_JAM_STATUS  emJamState;                                     //·ӵ״
    //Ϣ
    UINT                    nLargeVehicleNum;                               //ͳ
    UINT                    nMediumVehicleNum;                              //ͳ
    UINT                    nSmallVehicleNum;                               //Сͳ
    UINT                    nMotoNum;                                       //Ħг
}NET_TRAFFIC_LANE_INFO;

//CLIENT_QueryDevInfo , NET_QUERY_LANES_STATEӿ
typedef struct tagNET_OUT_GET_LANES_STATE
{
    DWORD                   dwSize;
    int                     nGetLaneInfoNum;                    //ȡĳϢ
    NET_TRAFFIC_LANE_INFO   stLaneInfos[MAX_LANE_INFO_NUM];     //ȡĳϢ
    NET_TRAFFIC_LIGHT_INFO  stLightInfo;                        //źŵָʾ״̬
}NET_OUT_GET_LANES_STATE;


// ӿ CLIENT_AttachLanesState 
typedef NET_OUT_GET_LANES_STATE NET_CB_LANES_STATE;

// ӿ CLIENT_AttachLanesState ص
typedef void (CALLBACK *fNotifyLanesState)(LLONG lLanesStateHandle, NET_CB_LANES_STATE* pLanesStateInfo, LDWORD dwUser, void *reserved);

// ӿ CLIENT_AttachLanesState 
typedef struct tagNET_IN_ATTACH_LANES_STATE
{
    DWORD                dwSize;                         // ˽ṹС
    int                  nChannelID;                     // ͨ
    int                  nLaneNumber;                    // -1г>=0ʱʾָ
    
    fNotifyLanesState    cbNotifyLanesState;             // ص
    LDWORD               dwUser;                         // ûԶ
} NET_IN_ATTACH_LANES_STATE;

// ӿ CLIENT_AttachLanesState 
typedef struct tagNET_OUT_ATTACH_LANES_STATE
{
    DWORD                dwSize;                         // ˽ṹС
} NET_OUT_ATTACH_LANES_STATE;

// CLIENT_MatrixSwitch 
typedef struct tagNET_IN_MATRIX_SWITCH
{
    DWORD           dwSize;
    DH_SPLIT_MODE   emSplitMode;                // ָģʽ
    int*            pnOutputChannels;           // ͨ, ͬʱָͨһл, һ
    int             nOutputChannelCount;        // ͨ
    int*            pnInputChannels;            // ͨ, ÿָһӦһͨ
    int             nInputChannelCount;         // ͨ
} NET_IN_MATRIX_SWITCH;

// CLIENT_MatrixSwitch 
typedef struct tagNET_OUT_MATRIX_SWITCH 
{
    DWORD            dwSize;
} NET_OUT_MATRIX_SWITCH;

// CLIENT_SplitSetMultiSource ӿڵ
typedef struct tagNET_IN_SPLIT_SET_MULTI_SOURCE 
{
    DWORD                   dwSize;
    EM_VIDEO_OUT_CTRL_TYPE  emCtrlType;         // ƵƷʽ
    int                     nChannel;           // Ƶ߼ͨ, emCtrlTypeΪEM_VIDEO_OUT_CTRL_CHANNELʱЧ
    const char*             pszCompositeID;     // ƴID, emCtrlTypeΪEM_VIDEO_OUT_CTRL_COMPOSITE_IDʱЧ
    BOOL                    bSplitModeEnable;   // Ƿıָģʽ
    DH_SPLIT_MODE           emSplitMode;        // ָģʽ, bSplitModeEnable=TRUEʱЧ
    int                     nGroupID;           // ָ, bSplitModeEnable=TRUEʱЧ
    int*                    pnWindows;          // ں
    int                     nWindowCount;       // 
    DH_SPLIT_SOURCE*        pstuSources;        // ƵԴϢ, ֱӦÿ, ͬ
} NET_IN_SPLIT_SET_MULTI_SOURCE;

// CLIENT_SplitSetMultiSource ӿڵ
typedef struct tagNET_OUT_SPLIT_SET_MULTI_SOURCE 
{
    DWORD                   dwSize;
} NET_OUT_SPLIT_SET_MULTI_SOURCE;

// Ƶָ
typedef enum tagNET_SPLIT_OPERATE_TYPE
{
    NET_SPLIT_OPERATE_SET_BACKGROUND,           // ñͼƬ, Ӧ NET_IN_SPLIT_SET_BACKGROUND  NET_OUT_SPLIT_SET_BACKBROUND
    NET_SPLIT_OPERATE_GET_BACKGROUND,           // ȡͼƬ, Ӧ NET_IN_SPLIT_GET_BACKGROUND  NET_OUT_SPLIT_GET_BACKGROUND
    NET_SPLIT_OPERATE_SET_PREPULLSRC,           // ԤԴ, Ӧ NET_IN_SPLIT_SET_PREPULLSRC  NET_OUT_SPLIT_SET_PREPULLSRC
    NET_SPLIT_OPERATE_SET_HIGHLIGHT,            // Դ߿ʹܿ, Ӧ NET_IN_SPLIT_SET_HIGHLIGHT  NET_OUT_SPLIT_SET_HIGHLIGHT
    NET_SPLIT_OPERATE_SET_ZORDER,               // Z, Ӧ NET_IN_SPLIT_SET_ZORDER  NET_OUT_SPLIT_SET_ZORDER
    NET_SPLIT_OPERATE_SET_TOUR,                 // Ѳ, Ӧ NET_IN_SPLIT_SET_TOUR  NET_OUT_SPLIT_SET_TOUR
    NET_SPLIT_OPERATE_GET_TOUR_STATUS,          // ȡѲ״̬, Ӧ NET_IN_SPLIT_GET_TOUR_STATUS  NET_OUT_SPLIT_GET_TOUR_STATUS
    NET_SPLIT_OPERATE_GET_SCENE,                // ȡڴϢ, Ӧ NET_IN_SPLIT_GET_SCENE  NET_OUT_SPLIT_GET_SCENE
    NET_SPLIT_OPERATE_OPEN_WINDOWS,             // , Ӧ NET_IN_SPLIT_OPEN_WINDOWS  NET_OUT_SPLIT_OPEN_WINDOWS
    NET_SPLIT_OPERATE_SET_WORK_MODE,            // ùģʽ, Ӧ NET_IN_SPLIT_SET_WORK_MODE  NET_OUT_SPLIT_SET_WORK_MODE
    NET_SPLIT_OPERATE_GET_PLAYER,               // ȡʵӦ NET_IN_SPLIT_GET_PLAYER  NET_OUT_SPLIT_GET_PLAYER
    NET_WM_OPERATE_SET_WORK_MODE,               // ôڹģʽӦ NET_IN_WM_SET_WORK_MODE  NET_OUT_WM_SET_WORK_MODE
    NET_WM_OPERATE_GET_WORK_MODE,               // ȡڹģʽӦ NET_IN_WM_GET_WORK_MODE  NET_OUT_WM_GET_WORK_MODE
} NET_SPLIT_OPERATE_TYPE;

// Դ߿ʹܿ
typedef struct tagNET_IN_SPLIT_SET_HIGHLIGHT
{
    DWORD           dwSize; 
    int             nChannel;                   // Ƶͨ
    int             nWindow;                    // ں
    BOOL            bHighLightEn;               // ߿ʹ,TRUE-ʾ
    DH_COLOR_RGBA   stuColor;                   // ߿ɫ 
}NET_IN_SPLIT_SET_HIGHLIGHT;

// Դ߿ʹܿ
typedef struct tagNET_OUT_SPLIT_SET_HIGHLIGHT
{
    DWORD           dwSize;
}NET_OUT_SPLIT_SET_HIGHLIGHT;

// ԤԴ
typedef struct tagNET_IN_SPLIT_SET_PREPULLSRC 
{
    DWORD           dwSize;
    int             nChannel;                   // Ƶͨ
    int             nWindow;                    // ں
    int             nSrcCount;                  // ԤԴ
    DH_SPLIT_SOURCE* pSources;                  // ԤԴϢ
} NET_IN_SPLIT_SET_PREPULLSRC;

// ԤԴķؽ
typedef struct tagNET_SPLIT_SET_PREPULLSRC_RESULT 
{
    DWORD           dwSize;
    BOOL            bResult;                    // ý, TRUE-ɹ, FALSE-ʧ
    DWORD           dwErrorCode;                // ʧܴ
} NET_SPLIT_SET_PREPULLSRC_RESULT;

// ԤԴ
typedef struct tagNET_OUT_SPLIT_SET_PREPULLSRC 
{
    DWORD           dwSize;
    int             nResultCount;               // , ԤԴͬ
    NET_SPLIT_SET_PREPULLSRC_RESULT* pResults;  // 
} NET_OUT_SPLIT_SET_PREPULLSRC;

// Ƶͼ
typedef struct tagNET_IN_SPLIT_SET_BACKGROUND
{
    DWORD            dwSize;
    int              nChannel;                   // Ƶͨ
    BOOL             bEnable;                    // ʹ
    const char*      pszFileName;                // ͼ
} NET_IN_SPLIT_SET_BACKGROUND;

// Ƶͼ
typedef struct tagNET_OUT_SPLIT_SET_BACKGROUND 
{
    DWORD            dwSize;
} NET_OUT_SPLIT_SET_BACKGROUND;

// ȡƵͼ
typedef struct tagNET_IN_SPLIT_GET_BACKGROUND 
{
    DWORD            dwSize;
    int              nChannel;                   // Ƶͨ
} NET_IN_SPLIT_GET_BACKGROUND;

// ȡƵͼ
typedef struct tagNET_OUT_SPLIT_GET_BACKGROUND 
{
    DWORD            dwSize;
    BOOL             bEnable;                            // ʹ
    char             szFileName[DH_COMMON_STRING_256];   // ͼ
} NET_OUT_SPLIT_GET_BACKGROUND;

// Z
typedef enum tagNET_WINDOW_ZORDER
{
    NET_WINDOW_ZORDER_TOP,                              // 
    NET_WINDOW_ZORDER_BOTTOM,                           // ײ
    NET_WINDOW_ZORDER_UP,                               // һ
    NET_WINDOW_ZORDER_DOWN,                             // һ
} NET_WINDOW_ZORDER;

// ڲ
typedef struct tagDH_WND_ZORDER
{
    DWORD               dwSize;
    unsigned int        nWindowID;                      // 
    unsigned int        nZOrder;                        // Z
} DH_WND_ZORDER;

// ôZ
typedef struct tagNET_IN_SPLIT_SET_ZORDER 
{
    DWORD               dwSize;
    int                 nChannel;                       // ͨŻںͨ, pszCompositeIDΪNULLʱЧ
    const char*         pszCompositeID;                 // ںID
    int                 nWindow;                        // ں
    NET_WINDOW_ZORDER   emZOrder;                       // Z
} NET_IN_SPLIT_SET_ZORDER;

// ôZ, һڵZӰд, صдڵZ
typedef struct tagNET_OUT_SPLIT_SET_ZORDER
{
    DWORD               dwSize;
    DH_WND_ZORDER*      pZOders;                        // ڴ, ûڴ
    int                 nMaxWndCount;                   // ڴС
    int                 nWndCount;                      // صĴ
} NET_OUT_SPLIT_SET_ZORDER;

// Ѳ
typedef enum tagEM_NET_WINDOW_TOUR_ACTION 
{
    EM_NET_WND_TOUR_ACTION_START,                       // ʼ
    EM_NET_WND_TOUR_ACTION_STOP,                        // ֹͣ
} EM_NET_WINDOW_TOUR_ACTION;

// Ѳ, ӦNET_SPLIT_OPERATE_SET_TOUR
typedef struct tagNET_IN_SPLIT_SET_TOUR 
{
    DWORD               dwSize;
    int                 nChannel;                       // ͨŻںͨ, pszCompositeIDΪNULLʱЧ
    const char*         pszCompositeID;                 // ںID
    int                 nWindow;                        // ں
    EM_NET_WINDOW_TOUR_ACTION emAction;                 // Ѳ
} NET_IN_SPLIT_SET_TOUR;

// Ѳ, ӦNET_SPLIT_OPERATE_SET_TOUR
typedef struct tagNET_OUT_SPLIT_SET_TOUR 
{
    DWORD               dwSize;
} NET_OUT_SPLIT_SET_TOUR;

// ȡѲ״̬, ӦNET_SPLIT_OPERATE_GET_TOUR_STATUS
typedef struct tagNET_IN_SPLIT_GET_TOUR_STATUS
{
    DWORD               dwSize;
    int                 nChannel;                       // ͨŻںͨ, pszCompositeIDΪNULLʱЧ
    const char*         pszCompositeID;                 // ںID
    int                 nWindow;                        // ں, -1ʾд
} NET_IN_SPLIT_GET_TOUR_STATUS;

// Ѳ״̬
typedef enum tagNET_TOUR_STATUS
{
    NET_TOUR_UNKNOWN,                               // δ֪
    NET_TOUR_START,                                 // Ѳ
    NET_TOUR_STOP,                                  // Ѳֹͣ
}NET_TOUR_STATUS;

// Ѳ״̬Ϣ
typedef struct tagNET_WINDOW_TOUR_STATUS_INFO 
{
    DWORD               dwSize;
    int                 nWindow;                        // ں
    NET_TOUR_STATUS     emStatus;                       // ״̬
} NET_WINDOW_TOUR_STATUS_INFO;

// ȡѲ״̬, ӦNET_SPLIT_OPERATE_GET_TOUR_STATUS
typedef struct tagNET_OUT_SPLIT_GET_TOUR_STATUS
{
    DWORD               dwSize;
    NET_WINDOW_TOUR_STATUS_INFO* pstuStatus;            // ״̬Ϣָ,  ûڴ. ѯںΪ-1ʱʾڵϢ.
    int                 nMaxStatusCount;                // ״̬Ϣ, û
    int                 nRetStatusCount;                // ״̬Ϣʵ, ѯõ
} NET_OUT_SPLIT_GET_TOUR_STATUS;

// , ӦNET_SPLIT_OPERATE_OPEN_WINDOWS
typedef struct tagNET_IN_SPLIT_OPEN_WINDOWS 
{
    DWORD               dwSize;
    int                 nChannel;                       // ͨŻںͨ, pszCompositeIDΪNULLʱЧ
    const char*         pszCompositeID;                 // ںid
    int                 nWindowNum;                     // 
    NET_RECT*           pstuWindowRects;                // 
    BOOL                bDirectable;                    // ֱͨ
} NET_IN_SPLIT_OPEN_WINDOWS;

// Ϣ
typedef struct tagNET_SPLIT_WINDOW_INFO
{
    DWORD               dwSize;
    int                 nWindowID;                      // ں
    int                 nZOrder;                        // Z
    char                szControlID[DH_DEV_ID_LEN];     // Ʊ
} NET_SPLIT_WINDOW_INFO;

// , ӦNET_SPLIT_OPERATE_OPEN_WINDOWS
typedef struct tagNET_OUT_SPLIT_OPEN_WINDOWS 
{
    DWORD               dwSize;
    NET_SPLIT_WINDOW_INFO*  pstuWindows;                // Ϣ, ûڴ
    int                 nMaxWindowCount;                // Ϣ, û
    int                 nRetWindowCount;                // 
} NET_OUT_SPLIT_OPEN_WINDOWS;

// ָģʽ
typedef enum tagNET_SPLIT_WORK_MODE
{
    NET_SPLIT_WORK_MODE_UNKNOWN,                        // δ֪
    NET_SPLIT_WORK_MODE_LOCAL,                          // ͨģʽ
    NET_SPLIT_WORK_MODE_REPLAY,                         // طģʽ
}NET_SPLIT_WORK_MODE;

// ùģʽ, Ӧ NET_SPLIT_OPERATE_SET_WORK_MODE
typedef struct tagNET_IN_SPLIT_SET_WORK_MODE 
{
    DWORD               dwSize;
    int                 nChannel;                       // ͨŻںͨ, pszCompositeIDΪNULLʱЧ
    const char*         pszCompositeID;                 // ںID
    NET_SPLIT_WORK_MODE emMode;                         // ģʽ
}NET_IN_SPLIT_SET_WORK_MODE;

// ùģʽ, Ӧ NET_SPLIT_OPERATE_SET_WORK_MODE
typedef struct tagNET_OUT_SPLIT_SET_WORK_MODE 
{
    DWORD               dwSize;
}NET_OUT_SPLIT_SET_WORK_MODE;

// 
typedef enum tagNET_SPLIT_PLAYER_TYPE
{
    NET_SPLIT_PLAYER_TYPE_UNKNOWN,                       // δ֪
    NET_SPLIT_PLAYER_TYPE_FILE_LIST,                     // ļб
    NET_SPLIT_PLAYER_TYPE_FILE,                          // ļ
}NET_SPLIT_PLAYER_TYPE;

// ȡʵ, Ӧ NET_SPLIT_OPERATE_GET_PLAYER
typedef struct tagNET_IN_SPLIT_GET_PLAYER
{
    DWORD                 dwSize;
    int                   nChannel;                       // ͨŻںͨ, pszCompositeIDΪNULLʱЧ
    const char*           pszCompositeID;                 // ںID
    NET_SPLIT_PLAYER_TYPE emType;                         // 
    int                   nWindow;                        // ڵĴں
}NET_IN_SPLIT_GET_PLAYER;

// ȡʵ, Ӧ NET_SPLIT_OPERATE_GET_PLAYER
typedef struct tagNET_OUT_SPLIT_GET_PLAYER
{
    DWORD                 dwSize;
    LLONG                 lPlayerID;                      // ʵID
}NET_OUT_SPLIT_GET_PLAYER;

// ڹģʽ
typedef enum tagNET_WM_WORK_MODE
{
    NET_WM_WORK_MODE_UNKNOWN,                             // δ֪
    NET_WM_WORK_MODE_DISPLAY,                             // Ԥģʽ
    NET_WM_WORK_MODE_REPLAY,                              // طģʽ  
}NET_WM_WORK_MODE;

// ôڹģʽ, Ӧ NET_WM_OPERATE_SET_WORK_MODE
typedef struct tagNET_IN_WM_SET_WORK_MODE
{
    DWORD                 dwSize;
    int                   nChannel;                       // ͨŻںͨ, pszCompositeIDΪNULLʱЧ
    const char*           pszCompositeID;                 // ںID
    int                   nWindow;                        // ں
    NET_WM_WORK_MODE      emMode;                         // ڹģʽ
}NET_IN_WM_SET_WORK_MODE;

//ôڹģʽ, Ӧ NET_WM_OPERATE_SET_WORK_MODE
typedef struct tagNET_OUT_WM_SET_WORK_MODE
{
    DWORD                 dwSize;
}NET_OUT_WM_SET_WORK_MODE;

// ȡڹģʽ, Ӧ NET_WM_OPERATE_GET_WORK_MODE
typedef struct tagNET_IN_WM_GET_WORK_MODE
{
    DWORD                 dwSize;
    int                   nChannel;                       // ͨŻںͨ, pszCompositeIDΪNULLʱЧ
    const char*           pszCompositeID;                 // ںID
    int                   nWindow;                        // ں
}NET_IN_WM_GET_WORK_MODE;

//ȡڹģʽ, Ӧ NET_WM_OPERATE_GET_WORK_MODE
typedef struct tagNET_OUT_WM_GET_WORK_MODE
{
    DWORD                 dwSize;
    NET_WM_WORK_MODE      emMode;                         // ڹģʽ
}NET_OUT_WM_GET_WORK_MODE;

////////////////////////////////// ϵͳ״̬ ////////////////////////////////////////

// CPUϢ
typedef struct tagDH_CPU_INFO
{
    DWORD               dwSize;
    int                 nUsage;                         // CPU
} DH_CPU_INFO;

// CPU״̬
typedef struct tagDH_CPU_STATUS
{
    DWORD               dwSize;
    BOOL                bEnable;                        // ѯǷɹ
    int                 nCount;                         // CPU
    DH_CPU_INFO         stuCPUs[DH_MAX_CPU_NUM];        // CPUϢ
} DH_CPU_STATUS;

// ڴϢ
typedef struct tagDH_MEMORY_INFO
{
    DWORD               dwSize;
    DWORD               dwTotal;                        // ڴ, M
    DWORD               dwFree;                         // ʣڴ, M
} DH_MEMORY_INFO;

// ڴ״̬
typedef struct tagDH_MEMORY_STATUS 
{
    DWORD               dwSize;
    BOOL                bEnable;                        // ѯǷɹ
    DH_MEMORY_INFO      stuMemory;                      // ڴϢ
} DH_MEMORY_STATUS;

// Ϣ
typedef struct tagDH_FAN_INFO
{
    DWORD               dwSize;
    char                szName[DH_DEVICE_NAME_LEN];     // 
    DWORD               nSpeed;                         // ٶ
} DH_FAN_INFO;

// ״̬
typedef struct tagDH_FAN_STATUS
{
    DWORD               dwSize;
    BOOL                bEnable;                        // ѯǷɹ
    int                 nCount;                         // 
    DH_FAN_INFO         stuFans[DH_MAX_FAN_NUM];        // ״̬
} DH_FAN_STATUS;

// Դ״̬
typedef enum __EM_CURRENT_STATE_TYPE
{
    EM_CURRENT_STATE_UNKNOWN = 0,
    EM_CURRENT_STATE_OVER_CURRENT,                      // 
    EM_CURRENT_STATE_NORMAL,                            // 
    EM_CURRENT_STATE_UNDER_CURRENT,                     // ԴǷ
}EM_CURRENT_STATE_TYPE;

// ԴϢ
typedef struct tagDH_POWER_INFO
{
    DWORD               dwSize;
    BOOL                bPowerOn;                       // Դ״̬, 0-ر, 1-, 2-򿪵й
    EM_CURRENT_STATE_TYPE emCurrentState;               // Դ״̬
} DH_POWER_INFO;


// λ״̬
typedef enum __EM_BATTERY_EXIST_STATE
{
    EM_BATTERY_EXIST_STATE_UNKNOWN = 0,
    EM_BATTERY_EXIST_STATE_EXIST,                       // λ
    EM_BATTERY_EXIST_STATE_MISSING,                     // ضʧ
}EM_BATTERY_EXIST_STATE;

// ص״̬
typedef enum __EM_BATTERY_STATE
{
	EM_BATTERY_STATE_UNKNOWN = 0,
	EM_BATTERY_STATE_NORMAL,							// 
	EM_BATTERY_STATE_LOW,								// 
}EM_BATTERY_STATE;

// Ϣ, CLIENT_QueryDevStateӿڵ DH_DEVSTATE_POWER_STATE 
typedef struct tagDH_BATTERY_INFO
{
    DWORD               dwSize;
    int                 nPercent;                       // ٷֱ
    BOOL                bCharging;                      // Ƿ
    EM_BATTERY_EXIST_STATE emExistState;                // λ״̬
	EM_BATTERY_STATE	emState;						// ص״̬
} DH_BATTERY_INFO;

// Դ״̬
typedef struct tagDH_POWER_STATUS
{
    DWORD               dwSize;
    BOOL                bEnable;                            // ѯǷɹ
    int                 nCount;                             // Դ
    DH_POWER_INFO       stuPowers[DH_MAX_POWER_NUM];        // Դ״̬
    int                 nBatteryNum;                        // 
    DH_BATTERY_INFO     stuBatteries[DH_MAX_BATTERY_NUM];   // ״̬
} DH_POWER_STATUS;

// ¶Ϣ
typedef struct tagDH_TEMPERATURE_INFO
{
    DWORD               dwSize;
    char                szName[DH_DEVICE_NAME_LEN];         // 
    float               fTemperature;                       // ¶
} DH_TEMPERATURE_INFO;

// ¶״̬
typedef struct tagDH_TEMPERATURE_STATUS
{
    DWORD               dwSize;
    BOOL                bEnable;                            // ѯǷɹ
    int                 nCount;                             // ¶
    DH_TEMPERATURE_INFO stuTemps[DH_MAX_TEMPERATURE_NUM];   // ¶Ϣ 
} DH_TEMPERATURE_STATUS;

// ϵͳ״̬
typedef struct tagDH_SYSTEM_STATUS
{
    DWORD                   dwSize;
    DH_CPU_STATUS*          pstuCPU;                        // CPU״̬
    DH_MEMORY_STATUS*       pstuMemory;                     // ڴ״̬
    DH_FAN_STATUS*          pstuFan;                        // ״̬
    DH_POWER_STATUS*        pstuPower;                      // Դ״̬
    DH_TEMPERATURE_STATUS*  pstuTemp;                       // ¶״̬
} DH_SYSTEM_STATUS;

// ӦCLIENT_QueryDevState()ӿڵ DH_DEVSTATE_ALL_ALARM_CHANNELS_STATE
// ȡͨ״̬
typedef enum tagNET_ALARM_CHANNEL_TYPE
{
    NET_ALARM_CHANNEL_TYPE_ALL,                             // ͨУ
    NET_ALARM_CHANNEL_TYPE_ALARMIN,                         // ͨ
    NET_ALARM_CHANNEL_TYPE_ALARMOUT,                        // ͨ
    NET_ALARM_CHANNEL_TYPE_ALARMBELL,                       // ͨ
    NET_ALARM_CHANNEL_TYPE_EXALARMIN,                       // չģ鱨ͨ
    NET_ALARM_CHANNEL_TYPE_EXALARMOUT,                      // չģ鱨ͨ
}NET_ALARM_CHANNEL_TYPE;

typedef struct tagNET_CLIENT_ALARM_CHANNELS_STATE
{
    DWORD                       dwSize;
    NET_ALARM_CHANNEL_TYPE      emType;                     // ѯͨ                                                                                                                                
    int                         nAlarmInCount;              // ûָ
    int                         nAlarmInRetCount;           // 뷵ظ
    BOOL*                       pbAlarmInState;             // ״̬飬ûڴ棬ÿԪرʾһͨ״̬,TRUEΪ,FALSEΪ
    int                         nAlarmOutCount;             // ûָ
    int                         nAlarmOutRetCount;          // 
    BOOL*                       pbAlarmOutState;            // ״̬飬ûڴ棬ÿԪرʾһͨ״̬,TRUEΪ,FALSEΪ
    int                         nAlarmBellCount;            // Ÿûָ
    int                         nAlarmBellRetCount;         // ŷظ
    BOOL*                       pbAlarmBellState;           // ״̬飬ûڴ棬ÿԪرʾһͨ״̬,TRUEΪ,FALSEΪ
    int                         nExAlarmInCount;            // չģ鱨ûָ
    int                         nExAlarmInRetCount;         // չģ鱨뷵ظ
    BOOL*                       pbExAlarmInState;           // չģ鱨״̬飬ûڴ棬ÿԪرʾһͨ״̬,TRUEΪ,FALSEΪ
    int*                        pnExAlarmInDestionation;    // չģ鱨Чͨλ
    int                         nExAlarmOutCount;           // չģ鱨ûָ
    int                         nExAlarmOutRetCount;        // չģ鱨
    BOOL*                       pbExAlarmOutState;          // չģ鱨״̬飬ûڴ棬ÿԪرʾһͨ״̬,TRUEΪ,FALSEΪ
    int*                        pnExAlarmOutDestionation;   // չģ鱨Чͨλ
}NET_CLIENT_ALARM_CHANNELS_STATE;


// ӵı
typedef struct tagNET_ALARMKEYBOARD_COUNT
{
    DWORD               dwSize;
    int                 nAlarmKeyboardCount;        // ŵıĿ
}NET_ALARMKEYBOARD_COUNT;

//////////////////////////////////  ////////////////////////////////////////
// CLIENT_OpenSplitWindowӿ()
typedef struct tagDH_IN_SPLIT_OPEN_WINDOW
{
    DWORD               dwSize;
    int                 nChannel;                   // ͨ()
    DH_RECT             stuRect;                    // λ, 0~8192
    BOOL                bDirectable;                // Ƿֱͨ, ֱָͨƴʽ£˴Ϊ
} DH_IN_SPLIT_OPEN_WINDOW;

// CLIENT_OpenSplitWindowӿ()
typedef struct tagDH_OUT_SPLIT_OPEN_WINDOW
{
    DWORD               dwSize;
    unsigned int        nWindowID;                  // 
    unsigned int        nZOrder;                    // ڴ        
} DH_OUT_SPLIT_OPEN_WINDOW;

// CLIENT_CloseSplitWindowӿ(ش)
typedef struct tagDH_IN_SPLIT_CLOSE_WINDOW
{
    DWORD               dwSize;
    int                 nChannel;                   // ͨ()
    UINT                nWindowID;                  // 
} DH_IN_SPLIT_CLOSE_WINDOW;

// CLIENT_CloseSplitWindowӿ(ش)
typedef struct tagDH_OUT_SPLIT_CLOSE_WINDOW
{
    DWORD               dwSize;
} DH_OUT_SPLIT_CLOSE_WINDOW;

// CLIENT_SetSplitWindowRect(ôλ)
typedef struct tagDH_IN_SPLIT_SET_RECT
{
    DWORD               dwSize;
    int                 nChannel;                   // ͨ()
    UINT                nWindowID;                  // 
    DH_RECT             stuRect;                    // λ, 0~8192
    BOOL                bDirectable;                // Ƿֱͨ, ֱָͨƴʽ£˴Ϊ
} DH_IN_SPLIT_SET_RECT;

// CLIENT_SetSplitWindowRectӿ(ôλ)
typedef struct tagDH_OUT_SPLIT_SET_RECT
{
    DWORD               dwSize;
} DH_OUT_SPLIT_SET_RECT;

// CLIENT_GetSplitWindowRectӿ(ȡλ)
typedef struct tagDH_IN_SPLIT_GET_RECT
{
    DWORD               dwSize;
    int                 nChannel;                  // ͨ()
    UINT                nWindowID;                 // 
} DH_IN_SPLIT_GET_RECT;

// CLIENT_GetSplitWindowRectӿ(ȡλ)
typedef struct tagDH_OUT_SPLIT_GET_RECT
{
    DWORD               dwSize;    
    DH_RECT             stuRect;                   // λ, 0~8192
} DH_OUT_SPLIT_GET_RECT;

// CLIENT_SetSplitWindowLevelsӿ(ôڴ)
typedef struct tagDH_IN_SPLIT_SET_TOP_WINDOW
{
    DWORD               dwSize;
    int                 nChannel;                  // ͨ()
    int                 nWindowID;                 // 
} DH_IN_SPLIT_SET_TOP_WINDOW;

// CLIENT_SetSplitWindowLevelsӿ(ôڴ)
typedef struct tagDH_OUT_SPLIT_SET_TOP_WINDOW
{
    DWORD               dwSize;
    DH_WND_ZORDER*      pZOders;                   // ڴ
    int                 nMaxWndCount;              // ڴС
    int                 nWndCount;                 // صĴ
} DH_OUT_SPLIT_SET_TOP_WINDOW;

// CLIENT_SetDisplayModeӿ(ǽʾģʽ)
typedef struct tagDH_IN_WM_SET_DISPLAY_MODE 
{
    DWORD               dwSize;
    int                 nMonitorWallID;             // ǽ
    const char*         pszBlockID;                 // ID, NULL/""-
    int                 nTVID;                      // ʾԪ, -1ʾʾԪ
    UINT                nDisplayMode;               // ʾģʽ, 0-׼, 1-, 2-
} DH_IN_WM_SET_DISPLAY_MODE;

// CLIENT_SetDisplayModeӿ(ǽʾģʽ)
typedef struct tagDH_OUT_WM_SET_DISPLAY_MODE
{
    DWORD               dwSize;
} DH_OUT_WM_SET_DISPLAY_MODE;

// ʾԪʾģʽ
typedef struct tagDH_BLOCK_DISPLAY_MODE
{
    DWORD               dwSize;
    int*                pTVModes;                   // TVʾģʽ
    int                 nMaxTVCount;                // TVʾģʽС
    int                 nRetTVCount;                // ʵTV
} DH_BLOCK_DISPLAY_MODE;

// CLIENT_GetDisplayModeӿڵ(ȡǽʾģʽ)
typedef struct tagDH_IN_WM_GET_DISPLAY_MODE 
{
    DWORD               dwSize;
    int                 nMonitorWallID;             // ǽ
    const char*         pszBlockID;                 // ID, NULL/""-
    int                 nTVID;                      // ʾԪ, -1ʾʾԪ
} DH_IN_WM_GET_DISPLAY_MODE;

// CLIENT_GetDisplayModeӿڵ(ȡǽʾģʽ)
typedef struct tagDH_OUT_WM_GET_DISPLAY_MODE
{
    DWORD                   dwSize;
    DH_BLOCK_DISPLAY_MODE*  pBlockModes;            // ʾģʽ
    int                     nMaxBlockCount;         // ʾģʽС
    int                     nRetBlockCount;         // ʵ
} DH_OUT_WM_GET_DISPLAY_MODE;

// CLIENT_PowerControlӿ(ǽԴ)
typedef struct tagDH_IN_WM_POWER_CTRL 
{
    DWORD               dwSize;
    int                 nMonitorWallID;             // ǽ
    const char*         pszBlockID;                 // ID, NULL/""-
    int                 nTVID;                      // ʾԪ, -1ʾʾԪ
    BOOL                bPowerOn;                   // Ƿ򿪵Դ
} DH_IN_WM_POWER_CTRL;

// CLIENT_PowerControlӿ(ǽԴ)
typedef struct tagDH_OUT_WM_POWER_CTRL
{
    DWORD               dwSize;
} DH_OUT_WM_POWER_CTRL;

// CLIENT_LoadMonitorWallCollectionӿ(ǽԤ)
typedef struct tagDH_IN_WM_LOAD_COLLECTION 
{
    DWORD               dwSize;
    int                 nMonitorWallID;             // ǽ
    const char*         pszName;                    // Ԥ
} DH_IN_WM_LOAD_COLLECTION;

// CLIENT_LoadMonitorWallCollectionӿ(ǽԤ)
typedef struct tagDH_OUT_WM_LOAD_COLLECTION 
{
    DWORD               dwSize;
} DH_OUT_WM_LOAD_COLLECTION;

// CLIENT_SaveMonitorWallCollectionӿ(ǽԤ)
typedef struct tagDH_IN_WM_SAVE_COLLECTION 
{
    DWORD               dwSize;
    int                 nMonitorWallID;             // ǽ
    const char*         pszName;                    // Ԥ
} DH_IN_WM_SAVE_COLLECTION;

// CLIENT_SaveMonitorWallCollectionӿ(ǽԤ)
typedef struct tagDH_OUT_WM_SAVE_COLLECTION 
{
    DWORD               dwSize;
} DH_OUT_WM_SAVE_COLLECTION;

// CLIENT_RenameMonitorWallCollectionӿ(Ԥ)
typedef struct tagDH_IN_WM_RENAME_COLLECTION 
{
    DWORD               dwSize;
    int                 nMonitorWallID;                // ǽ
    const char*         pszOldName;                    // ԭ
    const char*         pszNewName;                    // 
} DH_IN_WM_RENAME_COLLECTION;

// CLIENT_RenameMonitorWallCollectionӿ(Ԥ)
typedef struct tagDH_OUT_WM_RENAME_COLLECTION
{
    DWORD                dwSize;
} DH_OUT_WM_RENAME_COLLECTION;

// 鴰Ϣ
typedef struct tagDH_WINDOW_COLLECTION
{
    DWORD               dwSize;
    int                 nWindowID;                      // ID
    BOOL                bWndEnable;                     // ǷЧ
    DH_RECT             stuRect;                        // , ɷָģʽЧ
    BOOL                bDirectable;                    // Ƿֱͨ
    int                 nZOrder;                        // Z
    BOOL                bSrcEnable;                     // ʾԴǷЧ
    char                szDeviceID[DH_DEV_ID_LEN_EX];   // 豸ID
    int                 nVideoChannel;                  // Ƶͨ
    int                 nVideoStream;                   // Ƶ
    int                 nAudioChannel;                  // Ƶͨ
    int                 nAudioStream;                   // Ƶ
    int                 nUniqueChannel;                 // 豸ͳһŵΨһͨ
} DH_WINDOW_COLLECTION;

// ղ
typedef struct tagDH_BLOCK_COLLECTION 
{
    DWORD                dwSize;
    DH_SPLIT_MODE        emSplitMode;                   // ָģʽ
    DH_WINDOW_COLLECTION stuWnds[DH_MAX_SPLIT_WINDOW];  // Ϣ
    int                  nWndsCount;                    // 
    char                 szName[DH_DEVICE_NAME_LEN];    // ղؼ
    int                  nScreen;                       // ͨ, ƴ
    char                 szCompositeID[DH_DEV_ID_LEN_EX]; // ƴID    
    DH_WINDOW_COLLECTION* pstuWndsEx;                   // Ϣָ, ûڴ. stuWndsСʱʹ
    int                  nMaxWndsCountEx;               // 󴰿, ûд. pstuWndsExԪظ
    int                  nRetWndsCountEx;               // ش
} DH_BLOCK_COLLECTION;

// ǽʾԪ
typedef struct tagDH_MONITORWALL_OUTPUT 
{
    DWORD               dwSize;
    char                szDeviceID[DH_DEV_ID_LEN];          // 豸ID, ʱΪ""
    int                 nChannel;                           // ͨ
    char                szName[DH_DEV_NAME_LEN];            // Ļ
} DH_MONITORWALL_OUTPUT;

// ǽʾ
typedef struct tagDH_MONITORWALL_BLOCK
{
    DWORD                   dwSize;
    char                    szName[DH_DEV_NAME_LEN];        // 
    char                    szCompositeID[DH_DEV_ID_LEN];   // ƴID
    char                    szControlID[DH_DEV_ID_LEN];     // ID
    int                     nSingleOutputWidth;             // ʾԪռ
    int                     nSingleOutputHeight;            // ʾԪռ
    DH_RECT                 stuRect;                        // 
    DH_TSECT                stuPowerSchedule[DH_TSCHE_DAY_NUM][DH_TSCHE_SEC_NUM]; // ʱ, һάԪرʾ~ͽڼ
    DH_MONITORWALL_OUTPUT*  pstuOutputs;                    // ʾԪ, ûڴ
    int                     nMaxOutputCount;                // ʾԪС, ûд
    int                     nRetOutputCount;                // صʾԪ
} DH_MONITORWALL_BLOCK;

// ǽ
typedef struct tagDH_MONITORWALL 
{
    DWORD                   dwSize;
    char                    szName[DH_DEV_NAME_LEN];        // 
    int                     nGridLine;                      // 
    int                     nGridColume;                    // 
    DH_MONITORWALL_BLOCK*   pstuBlocks;                     // ʾ, ûڴ
    int                     nMaxBlockCount;                 // ʾС, ûд
    int                     nRetBlockCount;                 // صʾ
    BOOL                    bDisable;                       // Ƿ, 0-õǽЧ, 1-õǽЧ
    char                    szDesc[DH_COMMON_STRING_256];   // ǽϢ
} DH_MONITORWALL;

// ǽԤ
typedef struct tagDH_MONITORWALL_COLLECTION 
{
    DWORD                dwSize;
    char                 szName[DH_DEVICE_NAME_LEN];    // ǽԤ
    DH_BLOCK_COLLECTION  stuBlocks[DH_MAX_BLOCK_NUM];   // 
    int                  nBlocksCount;                  // 
    char                 szControlID[DH_DEV_ID_LEN_EX]; // ID
    DH_MONITORWALL       stuMonitorWall;                // ǽ
} DH_MONITORWALL_COLLECTION;

// CLIENT_GetMonitorWallCollectionsӿ(ȡǽԤϢ)
typedef struct tagDH_IN_WM_GET_COLLECTIONS 
{
    DWORD                dwSize;
    int                  nMonitorWallID;                // ǽID
} DH_IN_WM_GET_COLLECTIONS;

// CLIENT_GetMonitorWallCollectionsӿ(ȡǽԤϢ)
typedef struct tagDH_OUT_WM_GET_COLLECTIONS 
{
    DWORD                       dwSize;    
    DH_MONITORWALL_COLLECTION*  pCollections;           // ǽԤ
    int                         nMaxCollectionsCount;   // ǽԤС
    int                         nCollectionsCount;      // ǽԤ
} DH_OUT_WM_GET_COLLECTIONS;

// CLIENT_GetSplitWindowsInfoӿ
typedef struct tagDH_IN_SPLIT_GET_WINDOWS 
{
    DWORD              dwSize;
    int                nChannel;                        // ͨ
} DH_IN_SPLIT_GET_WINDOWS;

// CLIENT_GetSplitWindowsInfoӿ
typedef struct tagDH_OUT_SPLIT_GET_WINDOWS 
{
    DWORD                   dwSize;
    DH_BLOCK_COLLECTION     stuWindows;                 // Ϣ
} DH_OUT_SPLIT_GET_WINDOWS;

// CLIENT_LoadSplitCollectionӿ(ղ)
typedef struct tagDH_IN_SPLIT_LOAD_COLLECTION 
{
    DWORD             dwSize;
    int               nChannel;                 // ͨ
    const char*       pszName;                  // ղؼ
} DH_IN_SPLIT_LOAD_COLLECTION;

// CLIENT_LoadSplitCollectionӿ(ղ)
typedef struct tagDH_OUT_SPLIT_LOAD_COLLECTION 
{
    DWORD             dwSize;
} DH_OUT_SPLIT_LOAD_COLLECTION;

// CLIENT_SaveSplitCollectionӿ(ղ)
typedef struct tagDH_IN_SPLIT_SAVE_COLLECTION 
{
    DWORD             dwSize;
    int               nChannel;                 // ͨ
    const char*       pszName;                  // ղؼ
} DH_IN_SPLIT_SAVE_COLLECTION;

// CLIENT_SaveSplitCollectionӿ(ղ)
typedef struct tagDH_OUT_SPLIT_SAVE_COLLECTION 
{
    DWORD             dwSize;
} DH_OUT_SPLIT_SAVE_COLLECTION;

// CLIENT_RenameSplitCollectionӿ(ղ)
typedef struct tagDH_IN_SPLIT_RENAME_COLLECTION 
{
    DWORD             dwSize;
    int               nChannel;                 // ͨ
    const char*       pszOldName;               // ԭ
    const char*       pszNewName;               // 
} DH_IN_SPLIT_RENAME_COLLECTION;

// CLIENT_RenameSplitCollectionӿ(ղ)
typedef struct tagDH_OUT_SPLIT_RENAME_COLLECTION
{
    DWORD             dwSize;
} DH_OUT_SPLIT_RENAME_COLLECTION;

// CLIENT_GetSplitCollectionsӿ(ȡղؼϢ)
typedef struct tagDH_IN_SPLIT_GET_COLLECTIONS 
{
    DWORD             dwSize;
    int               nChannel;                // ͨ
} DH_IN_SPLIT_GET_COLLECTIONS;

// CLIENT_GetSplitCollectionsӿ(ȡղؼϢ)
typedef struct tagDH_OUT_SPLIT_GET_COLLECTIONS 
{
    DWORD                dwSize;    
    DH_BLOCK_COLLECTION* pCollections;                  // ղؼ
    int                  nMaxCollectionsCount;          // ղؼС
    int                  nCollectionsCount;             // صղؼ
} DH_OUT_SPLIT_GET_COLLECTIONS;

// CLIENT_DeleteSplitCollectionӿڵ(ɾղؼ)
typedef struct tagDH_IN_SPLIT_DELETE_COLLECTION 
{
    DWORD                dwSize;
    int                  nChannel;                      // ͨ
    const char**         ppszNames;                     // ղؼ
    int                  nNameCount;                    // ղؼС
} DH_IN_SPLIT_DELETE_COLLECTION;

// CLIENT_DeleteSplitCollectionӿڵ(ɾղؼ)
typedef struct tagDH_OUT_SPLIT_DELETE_COLLECTION 
{
    DWORD                dwSize;
} DH_OUT_SPLIT_DELETE_COLLECTION;

// ںͨϢ
typedef struct tagDH_COMPOSITE_CHANNEL
{
    DWORD               dwSize;
    char                szMonitorWallName[DH_DEVICE_NAME_LEN];  // ǽ
    char                szCompositeID[DH_DEV_ID_LEN_EX];        // ںID
    int                 nVirtualChannel;                        // ͨ
} DH_COMPOSITE_CHANNEL;

// Ѳʹ
typedef struct tagDHDEV_TOUR_ENABLE
{
    DWORD               dwSize;
    BOOL                bEnable;                    // Ѳʹ
    BOOL                bStart;                     // ǷѲ(ֻ). Ѳʹܴ򿪵ûѲԴʱ, bStart=FALSE
} DHDEV_TOUR_ENABLE_CFG;

// CLIENT_SetDecodePolicyӿ(ý)
typedef struct tagDH_IN_SET_DEC_POLICY 
{
    DWORD               dwSize;
    int                 nChannel;               // ͨ
    int                 nWindow;                // ں, -1ʾͨд
    int                 nPolicyLevel;           // Եȼ, 5(-2, -1, 0, 1, 2), ֵԽԽӳԽ
                                                // -2ʾʵʱ, 2ʾ, 0Ĭ
} DH_IN_SET_DEC_POLICY;

// CLIENT_SetDecodePolicyӿ(ý)
typedef struct tagDH_OUT_SET_DEC_POLICY 
{
    DWORD                dwSize;
} DH_OUT_SET_DEC_POLICY;

// CLIENT_GetDecodePolicyӿ(ȡ)
typedef struct tagDH_IN_GET_DEC_POLICY 
{
    DWORD                dwSize;
    int                  nChannel;              // ͨ
    int                  nWindow;               // ں, -1ʾͨд
} DH_IN_GET_DEC_POLICY;

// CLIENT_GetDecodePolicyӿ(ȡ)
typedef struct tagDH_OUT_GET_DEC_POLICY 
{
    DWORD                dwSize;
    int                  nPolicyLevel;          // Եȼ, 5(-2, -1, 0, 1, 2), ֵԽԽӳԽ
                                                // -2ʾʵʱ, 2ʾ, 0Ĭ
} DH_OUT_GET_DEC_POLICY;

// Ƶģʽ
typedef enum
{
    DH_AUDIO_AUTO,                              // ԶлƵ
    DH_AUDIO_DISABLE,                           // ֹƵ 
    DH_AUDIO_FORCE,                             // ǿûָĳڵƵ
} DH_AUDIO_OUTPUT_MODE;

// CLIENT_SetSplitAudioOuputӿ(Ƶģʽ)
typedef struct tagDH_IN_SET_AUDIO_OUTPUT 
{
    DWORD                dwSize;
    int                  nChannel;              // ͨ
    DH_AUDIO_OUTPUT_MODE emMode;                // Ƶģʽ
    int                  nWindow;               // ں, emModeΪDH_AUDIO_FORCEʱЧ
} DH_IN_SET_AUDIO_OUTPUT;

// CLIENT_SetSplitAudioOuputӿ(Ƶģʽ)
typedef struct tagDH_OUT_SET_AUDIO_OUTPUT
{
    DWORD                dwSize;
} DH_OUT_SET_AUDIO_OUTPUT;

// CLIENT_GetSplitAudioOuputӿ(ȡƵģʽ)
typedef struct tagDH_IN_GET_AUDIO_OUTPUT
{
    DWORD                dwSize;
    int                  nChannel;              // ͨ
} DH_IN_GET_AUDIO_OUTPUT;

// CLIENT_GetSplitAudioOuputӿ(ȡƵģʽ)
typedef struct tagDH_OUT_GET_AUDIO_OUTPUT
{
    DWORD                dwSize;
    DH_AUDIO_OUTPUT_MODE emMode;                // Ƶģʽ
    int                  nWindow;               // ں, emModeΪDH_AUDIO_FORCEʱЧ
} DH_OUT_GET_AUDIO_OUTPUT;

// CLIENT_GetEncodePlan ӿ(ȡ¼ʱʹõı)
typedef struct tagDH_IN_GET_ENCODE_PLAN
{
    DWORD               dwSize;
    unsigned int        nChannel;               // ָҪȡıͨ
    unsigned int        nExpectTime;            // ҵԤʱ     ,λ
    unsigned int        nCapacity;              // õ豸,,λ:M
}DH_IN_GET_ENCODE_PLAN;
// CLIENT_GetEncodePlan ӿ(ȡ¼ʱʹõı)
typedef struct tagDH_OUT_GET_ENCODE_PLAN
{
    DWORD               dwSize;
    int                 nResolutionType;        // emResolutionTypesԱ 
    CAPTURE_SIZE        emResolutionTypes[DH_MAX_CAPTURE_SIZE_NUM];// ƵֱʷΧ
    CAPTURE_SIZE        emResolution;           // ƼƵֱ
    unsigned int        nBitRate;               // Ƶ̶ֵ
}DH_OUT_GET_ENCODE_PLAN;

// ֯Ŀ¼߼
typedef struct tagDH_ORGANIZATION_NODE_LOGIC_OBJECT 
{
    DWORD               dwSize;
    char                szName[DH_NODE_NAME_LEN];       // 
    char                szType[DH_DEV_TYPE_LEN];        // 
    char                szDevID[DH_DEV_ID_LEN_EX];      // 豸ID
    char                szControlID[DH_DEV_ID_LEN_EX];  // ID, ֻ
    int                 nChannel;                       // ͨ
} DH_ORGANIZATION_NODE_LOGIC_OBJECT;

// ֯Ŀ¼
typedef struct tagDH_ORGANIZATION_NODE_DIRECTORY
{
    DWORD               dwSize;
    char                szName[DH_NODE_NAME_LEN];       // 
    char                szControlID[DH_DEV_ID_LEN_EX];  // ID
} DH_ORGANIZATION_NODE_DIRECTORY;

// ֯Ŀ¼ڵϢ
typedef struct tagDH_ORGANIZATION_NODE 
{
    DWORD               dwSize;
    int                 nNodeType;                        // ڵ, 0-߼, 1-Ŀ¼
    DH_ORGANIZATION_NODE_LOGIC_OBJECT    stuLogicObject;  // ߼, nNodeType==0ʱЧ
    DH_ORGANIZATION_NODE_DIRECTORY       stuDirectory;    // Ŀ¼, nNodeType==1ʱЧ        
} DH_ORGANIZATION_NODE;

// ӽڵ
typedef struct tagDH_ORGANIZATION_ADD_NODE_PARAM
{
    DWORD                dwSize;
    int                  nPosition;                     // λ, -1-ʼ, -2-ĩβ, 0~n
    DH_ORGANIZATION_NODE stuNode;                       // ڵϢ
} DH_ORGANIZATION_ADD_NODE_PARAM;

// CLIENT_OrganizationAddNodesӿڵ(ӽڵ)
typedef struct tagDH_IN_ORGANIZATION_ADD_NODES
{
    DWORD                dwSize;
    char*                pszPath;                       // ·
    DH_ORGANIZATION_ADD_NODE_PARAM* pstuNodes;          // ڵϢָ
    int                  nNodeCount;                    // ڵ
} DH_IN_ORGANIZATION_ADD_NODES;

// ӽڵĽ
typedef struct tagDH_ORGANIZATION_ADD_NODE_RESULT
{
    DWORD               dwSize;
    BOOL                bResult;                        // 
    char                szPath[MAX_PATH];               // ·, ɹnode·ʧܷnodeʱ·
} DH_ORGANIZATION_ADD_NODE_RESULT;

// CLIENT_OrganizationAddNodesӿڵ(ӽڵ)
typedef struct tagDH_OUT_ORGANIZATION_ADD_NODES
{
    DWORD               dwSize;
    DH_ORGANIZATION_ADD_NODE_RESULT* pstuResults;       // ָ
    int                 nMaxResultCount;                // С
    int                 nRetResultCount;                // صĽ
} DH_OUT_ORGANIZATION_ADD_NODES;

// ڵ·
typedef struct tagDH_ORGANIZATION_NODE_PATH 
{
    DWORD               dwSize;
    char                szPath[MAX_PATH];               // ·
} DH_ORGANIZATION_NODE_PATH;

// CLIENT_OrganizationDeleteNodesӿڵ(ɾڵ)
typedef struct tagDH_IN_ORGANIZATION_DELETE_NODES
{
    DWORD               dwSize;
    DH_ORGANIZATION_NODE_PATH*  pstuPath;               // ڵ·
    int                 nPathCount;                     // ڵ
} DH_IN_ORGANIZATION_DELETE_NODES;

// CLIENT_OrganizationDeleteNodesӿڵ(ɾڵ)
typedef struct tagDH_OUT_ORGANIZATION_DELETE_NODES 
{
    DWORD               dwSize;
} DH_OUT_ORGANIZATION_DELETE_NODES;

// CLIENT_OrganizationGetNodesӿڵ(ȡڵϢ)
typedef struct tagDH_IN_ORGANIZATION_GET_NODES 
{
    DWORD               dwSize;
    char*               pszPath;                        // ·
    int                 nLevel;                         // , 0-, 1-һ
} DH_IN_ORGANIZATION_GET_NODES;

// CLIENT_OrganizationGetNodesӿڵ(ȡڵϢ)
typedef struct tagDH_OUT_ORGANIZATION_GET_NODES 
{
    DWORD                   dwSize;
    DH_ORGANIZATION_NODE*   pstuNodes;                  // ڵ, ûڴ
    int                     nMaxNodeCount;              // ڵС
    int                     nRetNodeCount;              // صĽڵ
} DH_OUT_ORGANIZATION_GET_NODES;

// CLIENT_OrganizationSetNodeӿڵ(ýڵ)
typedef struct tagDH_IN_ORGANIZATION_SET_NODE 
{
    DWORD                dwSize;
    char*                pszPath;                    // ·
    DH_ORGANIZATION_NODE stuNode;                    // ڵϢ
} DH_IN_ORGANIZATION_SET_NODE;

// CLIENT_OrganizationSetNodeӿڵ(ýڵ)
typedef struct tagDH_OUT_ORGANIZATION_SET_NODE 
{
    DWORD               dwSize;
} DH_OUT_ORGANIZATION_SET_NODE;

// ƵͨϢ
typedef struct tagDH_VIDEO_INPUTS
{
    DWORD               dwSize;
    char                szChnName[DH_DEVICE_NAME_LEN];      // ͨ
    BOOL                bEnable;                            // ʹ
    char                szControlID[DH_DEV_ID_LEN_EX];      // ID
    char                szMainStreamUrl[MAX_PATH];          // urlַ 
    char                szExtraStreamUrl[MAX_PATH];         // urlַ
    int                 nOptionalMainUrlCount;              // ַ
    char                szOptionalMainUrls[DH_MAX_OPTIONAL_URL_NUM][MAX_PATH];  // ַб
    int                 nOptionalExtraUrlCount;             // øַ
    char                szOptionalExtraUrls[DH_MAX_OPTIONAL_URL_NUM][MAX_PATH]; // øַб
} DH_VIDEO_INPUTS;

typedef struct tagDH_REMOTE_DEVICE 
{
    DWORD               dwSize;
    BOOL                bEnable;                            // ʹ
    char                szIp[DH_MAX_IPADDR_LEN];            // IP
    char                szUser[DH_USER_NAME_LENGTH];        // û
    char                szPwd[DH_USER_PSW_LENGTH];          // 
    int                 nPort;                              // ˿
    int                 nDefinition;                        // , 0-, 1-
    DH_DEVICE_PROTOCOL  emProtocol;                         // Э
    char                szDevName[DH_DEVICE_NAME_LEN];      // 豸
    int                 nVideoInputChannels;                // Ƶͨ
    int                 nAudioInputChannels;                // Ƶͨ
    char                szDevClass[DH_DEV_TYPE_LEN];        // 豸, IPC, DVR, NVR
    char                szDevType[DH_DEV_TYPE_LEN];         // 豸ͺ, IPC-HF3300
    int                 nHttpPort;                          // Http˿
    int                 nMaxVideoInputCount;                // Ƶͨ
    int                 nRetVideoInputCount;                // ʵͨ
    DH_VIDEO_INPUTS*    pstuVideoInputs;                    // ƵͨϢ
    char                szMachineAddress[DH_MAX_CARD_INFO_LEN]; // 豸
    char                szSerialNo[DH_SERIALNO_LEN];        // 豸к
    int                 nRtspPort;                          // Rtsp˿
} DH_REMOTE_DEVICE;

typedef enum tagNET_LOGIC_CHANNEL_TYPE
{
    LOGIC_CHN_UNKNOWN,              // δ֪
    LOGIC_CHN_LOCAL,                // ͨ
    LOGIC_CHN_REMOTE,               // Զͨ
    LOGIC_CHN_COMPOSE,              // ϳͨ, ͥ豸лͨͻͨ
    LOGIC_CHN_MATRIX,               // ģͨ
    LOGIC_CHN_CASCADE,              // ͨ
} NET_LOGIC_CHN_TYPE;

// õʾԴϢ
typedef struct tagDH_MATRIX_CAMERA_INFO
{
    DWORD               dwSize;
    char                szName[DH_DEV_ID_LEN_EX];           // 
    char                szDevID[DH_DEV_ID_LEN_EX];          // 豸ID
    char                szControlID[DH_DEV_ID_LEN_EX];      // ID
    int                 nChannelID;                         // ͨ, DeviceID豸Ψһ
    int                 nUniqueChannel;                     // 豸ͳһŵΨһͨ
    BOOL                bRemoteDevice;                      // ǷԶ豸
    DH_REMOTE_DEVICE    stuRemoteDevice;                    // Զ豸Ϣ
    NET_STREAM_TYPE     emStreamType;                       // Ƶ
    NET_LOGIC_CHN_TYPE  emChannelType;                      // ͨ
} DH_MATRIX_CAMERA_INFO;

// CLIENT_MatrixGetCamerasӿڵ
typedef struct tagDH_IN_MATRIX_GET_CAMERAS 
{
    DWORD               dwSize;
} DH_IN_MATRIX_GET_CAMERAS;

// CLIENT_MatrixGetCamerasӿڵ
typedef struct tagDH_OUT_MATRIX_GET_CAMERAS 
{
    DWORD                   dwSize;
    DH_MATRIX_CAMERA_INFO*  pstuCameras;                    // ʾԴϢ, ûڴ
    int                     nMaxCameraCount;                // ʾԴС
    int                     nRetCameraCount;                // صʾԴ
} DH_OUT_MATRIX_GET_CAMERAS;

// CLIENT_MatrixSetCamerasӿڵ
typedef struct tagDH_IN_MATRIX_SET_CAMERAS 
{
    DWORD                   dwSize;
    DH_MATRIX_CAMERA_INFO*  pstuCameras;                    // ʾԴϢ, ûڴ
    int                     nCameraCount;                   // ʾԴС
} DH_IN_MATRIX_SET_CAMERAS;

// CLIENT_MatrixSetCamerasӿڵ
typedef struct tagDH_OUT_MATRIX_SET_CAMERAS 
{
    DWORD                   dwSize;
} DH_OUT_MATRIX_SET_CAMERAS;

// ʾԴϢ
typedef struct tagDH_SPLIT_WND_SOURCE 
{
    DWORD                   dwSize;
    BOOL                    bEnable;                        // ʾԴǷЧ
    char                    szDeviceID[DH_DEV_ID_LEN];      // 豸ID
    char                    szControlID[DH_DEV_ID_LEN];     // ID
    int                     nVideoChannel;                  // Ƶͨ
    int                     nVideoStream;                   // Ƶ
    int                     nAudioChannel;                  // Ƶͨ
    int                     nAudioStream;                   // Ƶ
    int                     nUniqueChannel;                 // 豸ͳһŵΨһͨ, ֻ
    BOOL                    bRemoteDevice;                  // ǷԶ豸
    DH_REMOTE_DEVICE        stuRemoteDevice;                // Զ豸Ϣ
} DH_SPLIT_WND_SOURCE;

// ָϢ
typedef struct tagDH_SPLIT_WINDOW 
{
    DWORD                   dwSize;
    BOOL                    bEnable;                        // ǷƵԴ
    int                     nWindowID;                      // ID
    char                    szControlID[DH_DEV_ID_LEN];     // ID
    DH_RECT                 stuRect;                        // , ɷָģʽЧ
    BOOL                    bDirectable;                    // Ƿֱͨ
    int                     nZOrder;                        // Z
    DH_SPLIT_WND_SOURCE     stuSource;                      // ʾϢ
} DH_SPLIT_WINDOW;

// ƴ
typedef struct tagDH_SPLIT_SCENE 
{
    DWORD                   dwSize;
    char                    szCompositeID[DH_DEV_ID_LEN];   // ƴID
    char                    szControlID[DH_DEV_ID_LEN];     // ID
    DH_SPLIT_MODE           emSplitMode;                    // ָģʽ
    DH_SPLIT_WINDOW*        pstuWnds;                       // Ϣ, ûڴ
    int                     nMaxWndCount;                   // ϢС, ûд
    int                     nRetWndCount;                   // صĴ
} DH_SPLIT_SCENE;

// ǽ
typedef struct tagDH_MONITORWALL_SCENE
{
    DWORD                   dwSize;
    char                    szName[DH_DEV_NAME_LEN];        // ǰԤ
    char                    szControlID[DH_DEV_ID_LEN];     // ID
    DH_MONITORWALL          stuMonitorWall;                 // ǽ    
    DH_SPLIT_SCENE*         pstuSplitScene;                 // ƴϢ, ûڴ
    int                     nMaxSplitSceneCount;            // ƴС, ûд
    int                     nRetSplitSceneCount;            // صƴ
} DH_MONITORWALL_SCENE;

// CLIENT_MonitorWallGetSceneӿ(ȡǽ)
typedef struct tagDH_IN_MONITORWALL_GET_SCENE 
{
    DWORD                   dwSize;
    int                     nMonitorWallID;                 // ǽ
} DH_IN_MONITORWALL_GET_SCENE;

// CLIENT_MonitorWallGetSceneӿ(ȡǽ)
typedef struct tagDH_OUT_MONITORWALL_GET_SCENE 
{
    DWORD                   dwSize;
    char                    szName[DH_DEV_NAME_LEN];        // ǰԤ, Ϊ
    DH_MONITORWALL_SCENE    stuScene;                       // ǽ
} DH_OUT_MONITORWALL_GET_SCENE;

// CLIENT_MonitorWallSetSceneӿ(õǽ)
typedef struct tagDH_IN_MONITORWALL_SET_SCENE 
{
    DWORD                   dwSize;
    int                     nMonitorWallID;                 // ǽ
    DH_MONITORWALL_SCENE    stuScene;                       // ǽ
} DH_IN_MONITORWALL_SET_SCENE;

// CLIENT_MonitorWallSetSceneӿ(õǽ)
typedef struct tagDH_OUT_MONITORWALL_SET_SCENE 
{
    DWORD                   dwSize;
} DH_OUT_MONITORWALL_SET_SCENE;

//CLIENT_QueryNetStatӿ,ѯΪNET_APP_DATA_STATʱ(ȡЭջͳ)
typedef struct tagNET_IN_NETAPP_NET_DATA_STAT
{
    DWORD       dwSize;    
    char        szEthName[DH_MAX_ETH_NAME];                //
}NET_IN_NETAPP_NET_DATA_STAT;

//ͳ,ifconfigͬ
typedef struct tagNET_NETAPP_RECEIVE_STAT
{
    DWORD        dwSize;
    DWORD        dwPackets;
    DWORD        dwBytes;
    DWORD        dwErrors;
    DWORD        dwDroped;
    DWORD        dwOverruns;
    DWORD        dwFrame;
}NET_NETAPP_RECEIVE_STAT;

//ͳ,ifconfigͬ
typedef struct tagNET_NETAPP_TRANSMIT_STAT
{
    DWORD        dwSize;
    DWORD        dwPackets;
    DWORD        dwBytes;
    DWORD        dwErrors;
    DWORD        dwDroped;
    DWORD        dwOverruns;
    DWORD        dwCarrier;
    DWORD        dwCollisions;
    DWORD        dwTxQueue;
}NET_NETAPP_TRANSMIT_STAT;

//CLIENT_QueryNetStatӿ,ѯΪNET_APP_DATA_STATʱ(ȡЭջͳ)
typedef struct tagNET_OUT_NETAPP_NET_DATA_STAT
{                    
    DWORD                        dwSize;
    NET_NETAPP_RECEIVE_STAT      stuReceiveStat;        // ͳݣifconfigͬ
    NET_NETAPP_TRANSMIT_STAT     stuTransmitStat;       // ͳݣifconfigͬ
    int                          nSpeed;                // ٶȣλMbps
}NET_OUT_NETAPP_NET_DATA_STAT;

//CLIENT_QueryNetStatӿ,ѯΪNET_APP_LINK_STAT ʱ(ȡ·״̬)
typedef struct tagNET_IN_NETAPP_LINK_STATUS
{
    DWORD       dwSize;
    char        szEthName[DH_MAX_ETH_NAME];             //
}NET_IN_NETAPP_LINK_STATUS;

//CLIENT_QueryNetStatӿ,ѯΪNET_APP_LINK_STAT ʱ(ȡ·״̬)
typedef struct tagNET_OUT_NETAPP_LINK_STATUS
{
    DWORD       dwSize;
    BOOL        bWorking;               // Ƿڹ 
    BOOL        bIPConflict;            // IPǷͻ
}NET_OUT_NETAPP_LINK_STATUS;

// ź
#define DH_VIDEO_SIGNAL_CVBS        0x0001
#define DH_VIDEO_SIGNAL_SDI         0x0002
#define DH_VIDEO_SIGNAL_VGA         0x0004 
#define DH_VIDEO_SIGNAL_DVI         0x0008
#define DH_VIDEO_SIGNAL_HDMI        0x0010 
#define DH_VIDEO_SIGNAL_YPBPR       0x0020 
#define DH_VIDEO_SIGNAL_SFP         0x0040 
#define DH_VIDEO_SIGNAL_HDCVI       0x0080 
#define DH_VIDEO_SIGNAL_DUAL_LINK   0x0100 

// Ƶ
typedef struct tagDH_VIDEO_IN_CAPS 
{
    DWORD            dwSize;
    DWORD            dwSignalType;                  // ź
    BOOL             bAutoFocusPeak;                // Ƿ֧־۽ֵ
    BOOL             bElectricFocus;                // Ƿֵ֧綯
    BOOL             bSyncFocus;                    // Ƿ֧ͬԽ
    BOOL             bSetColor;                     // Ƿ֧Ƶɫ
    BOOL             bGain;                         // Ƿ֧
    BOOL             bPhase;                        // Ƿ֧λ
} DH_VIDEO_IN_CAPS;

// CLIENT_GetVideoInCapsӿ
typedef struct tagDH_IN_GET_VIDEO_IN_CAPS 
{
    DWORD            dwSize;
    int              nChannel;                      // Ƶͨ
} DH_IN_GET_VIDEO_IN_CAPS;

// CLIENT_GetVideoInCapsӿ
typedef struct tagDH_OUT_GET_VIDEO_IN_CAPS 
{
    DWORD            dwSize;
    DH_VIDEO_IN_CAPS stuCaps;                       // 
} DH_OUT_GET_VIDEO_IN_CAPS;

// Ƶģʽ
typedef struct tagDH_VIDEO_OUT_MODE 
{
    DWORD            dwSize;
    int              nWidth;                        // ˮƽֱ
    int              nHeight;                       // ֱֱ
    int              nBPP;                          // ɫ
    int              nFormat;                       // źģʽ, 0-Auto, 1-TV, 2-VGA, 3-DVI
    int              nRefreshRate;                  // ˢƵ
    int              nPhysicalPort;                 // , VGA, TV, DVIԶ, Դ0ʼ
    int              nScanFormat;                   // ɨģʽ, 0-, 1-
} DH_VIDEO_OUT_MODE;

// CLIENT_EnumVideoOutModesӿ
typedef struct tagDH_IN_ENUM_VIDEO_OUT_MODES 
{
    DWORD            dwSize;
    int              nChannel;
} DH_IN_ENUM_VIDEO_OUT_MODES;

// CLIENT_EnumVideoOutModesӿ
typedef struct tagDH_OUT_ENUM_VIDEO_OUT_MODES 
{
    DWORD               dwSize;
    DH_VIDEO_OUT_MODE*  pstuModes;                  // ģʽ, ûڴ
    int                 nMaxModeCount;              // ģʽС, ûд
    int                 nRetModeCount;              // صģʽ
} DH_OUT_ENUM_VIDEO_OUT_MODES;

// ǽĻ
typedef enum tagDH_OUTPUT_ATTRIBUTE_TYPE
{
    DH_OUTPUT_ATTRIBUTE_VIDEO, 
    DH_OUTPUT_ATTRIBUTE_YPBPR, 
    DH_OUTPUT_ATTRIBUTE_VGA, 
    DH_OUTPUT_ATTRIBUTE_DVI, 
    DH_OUTPUT_ATTRIBUTE_MENU, 
} DH_OUTPUT_ATTRIBUTE_TYPE;

// ǽʾԪĻ(DH_OUTPUT_ATTRIBUTE_CAPS) Video
#define    DH_ATTR_VIDEO_BRIGHTNESS     0X00000001
#define    DH_ATTR_VIDEO_CONTRAST       0X00000002
#define    DH_ATTR_VIDEO_SATURATION     0X00000004
#define    DH_ATTR_VIDEO_SHAPENESS      0X00000008
#define    DH_ATTR_VIDEO_DENOISE        0X00000010

// ǽʾԪĻ(DH_OUTPUT_ATTRIBUTE_CAPS) YPbPr
#define    DH_ATTR_YPBPR_BRIGHTNESS     0X00000001
#define    DH_ATTR_YPBPR_CONTRAST       0X00000002
#define    DH_ATTR_YPBPR_SATURATION     0X00000004
#define    DH_ATTR_YPBPR_SHAPENESS      0X00000008
#define    DH_ATTR_YPBPR_DENOISE        0X00000010

// ǽʾԪĻ(DH_OUTPUT_ATTRIBUTE_CAPS) VGA
#define    DH_ATTR_VGA_BRIGHTNESS       0X00000001
#define    DH_ATTR_VGA_CONTRAST         0X00000002
#define    DH_ATTR_VGA_HORPOSITION      0X00000004
#define    DH_ATTR_VGA_VERPOSITION      0X00000008
#define    DH_ATTR_VGA_CLOCK            0X00000010

// ǽʾԪĻ(DH_OUTPUT_ATTRIBUTE_CAPS) DVI
#define    DH_ATTR_DVI_BRIGHTNESS       0X00000001
#define    DH_ATTR_DVI_CONTRAST         0X00000002
#define    DH_ATTR_DVI_HORPOSITION      0X00000004
#define    DH_ATTR_DVI_VERPOSITION      0X00000008
#define    DH_ATTR_DVI_CLOCK            0X00000010

// ǽʾԪĻ(DH_OUTPUT_ATTRIBUTE_CAPS) Menu
#define    DH_ATTR_MENU_MENU            0X00000001
#define    DH_ATTR_MENU_UP              0X00000002
#define    DH_ATTR_MENU_DOWN            0X00000004
#define    DH_ATTR_MENU_LEFT            0X00000008
#define    DH_ATTR_MENU_RIGHT           0X00000010
#define    DH_ATTR_MENU_FACTORYMENU     0X00000020

// ǽʾԪĻ
typedef struct tagDH_OUTPUT_ATTRIBUTE_CAPS
{
    DWORD           dwSize;
    BOOL            abVideo;                // VideoǷЧ
    DWORD           dwVideo;                // Video, λʾ, DH_ATTR_VIDEO_BRIGHTNESS
    BOOL            abYPbPr;                // YPbPrǷЧ
    DWORD           dwYPbPr;                // YPbPr, λʾ, DH_ATTR_VGA_BRIGHTNESS
    BOOL            abVGA;                  // VGAǷЧ
    DWORD           dwVGA;                  // VGA, λʾ, DH_ATTR_VGA_BRIGHTNESS
    BOOL            abDVI;                  // DVIǷЧ
    DWORD           dwDVI;                  // DVI, λʾ, DH_ATTR_DVI_BRIGHTNESS
    BOOL            abMenu;                 // MenuǷЧ
    DWORD           dwMemu;                 // Menu, λʾ, DH_ATTR_MENU_MENU
} DH_OUTPUT_ATTRIBUTE_CAPS;

// CLIENT_MonitorWallGetAttributeCaps ӿ
typedef struct tagDH_IN_MONITORWALL_GET_ARRT_CAPS
{
    DWORD               dwSize;
    int                 nMonitorWallID;             // ǽ
    const char*         pszCompositeID;             // ƴID
    int                 nOutputID;                  // ʾԪ
} DH_IN_MONITORWALL_GET_ARRT_CAPS;

// CLIENT_MonitorWallGetAttributeCaps ӿ
typedef struct tagDH_OUT_MONITORWALL_GET_ARRT_CAPS
{
    DWORD                       dwSize;
    DH_OUTPUT_ATTRIBUTE_CAPS    stuCaps;            // 
} DH_OUT_MONITORWALL_GET_ARRT_CAPS;


// CLIENT_MonitorWallAutoAdjust ӿ
typedef struct tagDH_IN_MONITORWALL_AUTO_ADJUST
{
    DWORD           dwSize;
    int             nMonitorWallID;                 // ǽ
    const char*     pszCompositeID;                 // ƴID
    int*            pOutputs;                       // ʾԪָ, ԪʾԪID, ûڴ
    int             nOutputCount;                   // ʾԪ, pOutputsԪ
} DH_IN_MONITORWALL_AUTO_ADJUST;

// CLIENT_MonitorWallAutoAdjust ӿ
typedef struct tagDH_OUT_MONITORWALL_AUTO_ADJUST
{
    DWORD           dwSize;
} DH_OUT_MONITORWALL_AUTO_ADJUST;

// ʾԪԼֵ
typedef struct tagDH_ATTR_PAIR
{
    DWORD       dwKey;                      // Լ
                                            // ΪDH_OUTPUT_ATTRIBUTE_VIDEOʱ, ʹúDH_ATTR_VIDEO_BRIGHTNESS
                                            // ΪDH_OUTPUT_ATTRIBUTE_YPBPRʱ, ʹúDH_ATTR_YPBPR_BRIGHTNESS
                                            // Դ
    int         nValue;                     // ֵ, 0- 1-, 2-
} DH_ATTR_PAIR;

// CLIENT_MonitorWallSetAttribute ӿ
typedef struct tagDH_IN_MONITORWALL_SET_ATTR
{
    DWORD                    dwSize;
    int                      nMonitorWallID;                    // ǽ
    const char*              pszCompositeID;                    // ƴID
    int                      nOutputID;                         // ʾԪ
    DH_OUTPUT_ATTRIBUTE_TYPE emAttrType;                        // , Ͳͬʱ, Ӧ(stuAttrs)Ҳͬ
    DH_ATTR_PAIR             stuAttrs[DH_MAX_ATTR_NUM];         // ֵ
} DH_IN_MONITORWALL_SET_ATTR;

// CLIENT_MonitorWallSetAttribute ӿ
typedef struct tagDH_OUT_MONITORWALL_SET_ATTR
{
    DWORD            dwSize;
} DH_OUT_MONITORWALL_SET_ATTR;

// CLIENT_MonitorWallSetBackLight ӿ
typedef struct tagDH_IN_MONITORWALL_SET_BACK_LIGHT
{
    DWORD               dwSize;
    int                 nMonitorWallID;                     // ǽ
    const char*         pszCompositeID;                     // ƴID
    int                 nOutputID;                          // ʾԪ
    int                 nMode;                              // ģʽ, 0-ѭñģʽ1-ѭģʽ
} DH_IN_MONITORWALL_SET_BACK_LIGHT;

// CLIENT_MonitorWallSetBackLight ӿ
typedef struct tagDH_OUT_MONITORWALL_SET_BACK_LIGHT
{
    DWORD               dwSize;
} DH_OUT_MONITORWALL_SET_BACK_LIGHT;


// CLIENT_MonitorWallGetPowerSchedule ӿ
typedef struct tagNET_IN_WM_GET_POWER_SCHEDULE
{
    DWORD               dwSize;
    int                 nMonitorWallID;                     // ǽ
    const char*         pszCompositeID;                     // ƴID
} NET_IN_MW_GET_POWER_SCHEDULE;

// CLIENT_MonitorWallGetPowerSchedule ӿ
typedef struct tagNET_OUT_MW_GET_POWER_SCHEDULE
{
    DWORD               dwSize;
    DH_TSECT            stuPowerSchedule[DH_TSCHE_DAY_NUM][DH_TSCHE_SEC_NUM];    // ʱ, һάԪرʾ~ͽڼ
} NET_OUT_MW_GET_POWER_SCHEDULE;

// CLIENT_MonitorWallSetPowerSchedule ӿ
typedef struct tagNET_IN_MW_SET_POWER_SCHEDULE
{
    DWORD               dwSize;
    int                 nMonitorWallID;                     // ǽ
    const char*         pszCompositeID;                     // ƴID, NULLʾ
    DH_TSECT            stuPowerSchedule[DH_TSCHE_DAY_NUM][DH_TSCHE_SEC_NUM];    // ʱ, һάԪرʾ~ͽڼ
} NET_IN_MW_SET_POWER_SCHEDULE;

// CLIENT_MonitorWallSetPowerSchedule ӿ
typedef struct tagNET_OUT_MW_SET_POWER_SCHEDULE
{
    DWORD               dwSize;
} NET_OUT_MW_SET_POWER_SCHEDULE;

// CLIENT_MonitorWallGetScrnCtrlParam ӿ
typedef struct tagNET_IN_MW_GET_SCRN_CTRL_PARAM
{
    DWORD               dwSize;
    int                 nMonitorWallID;                     // ǽ
    const char*         pszCompositeID;                     // ƴID
} NET_IN_MW_GET_SCRN_CTRL_PARAM;

#define DH_MAX_SCREEN_PORT_NUM        16                    // Ļ˿
#define DH_MAX_COMPSITE_SCREEN_NUM    256                   // ƴ

// Ļ˿Ϣ
typedef struct tagNET_SCREEN_PORT_INFO
{
    DWORD               dwSize;
    char                szType[DH_COMMON_STRING_16];        // ˿, "DVI", "VGA", "HDMI", ͬ͵Ķ˿
    char                szAddress[DH_COMMON_STRING_16];     // ˿ڵַ
    char                szDeviceID[DH_DEV_ID_LEN_EX];       // 󶨵Ƶ豸
    int                 nOutputChannel;                     // Ƶͨ
} NET_SCREEN_PORT_INFO;


typedef struct tagNET_SCREEN_PORT_GROUP 
{
    DWORD                dwSize;
    int                  nPortNum;                          // ˿
    NET_SCREEN_PORT_INFO stuPorts[DH_MAX_SCREEN_PORT_NUM];  // ˿Ϣ
} NET_SCREEN_PORT_GROUP;

// ǽĻƲ
typedef struct tagNET_WM_SCRN_CTRL_PARAM
{
    DWORD                   dwSize;
    int                     nCommPort;                                  // ں
    DH_COMM_PROP            stuCommProp;                                // 
    char                    szProtocol[DH_COMMON_STRING_32];            // Э
    int                     nResolutionNum;                             // ֱ
    CAPTURE_SIZE            emResolutions[DH_MAX_CAPTURE_SIZE_NUM];     // Ƶֱб
    int                     nScreenCodeNum;                             // Ļ
    char                    szScreenCode[DH_MAX_COMPSITE_SCREEN_NUM][DH_COMMON_STRING_16];    // Ļ, Ѱַ, ñû, ͬ
    int                     nScreenPortsNum;                            // Ļ˿Ϣ
    NET_SCREEN_PORT_GROUP   stuScreenPorts[DH_MAX_COMPSITE_SCREEN_NUM]; // Ļ˿Ϣ    
} NET_WM_SCRN_CTRL_PARAM;

// CLIENT_MonitorWallGetScrnCtrlParam ӿ
typedef struct tagNET_OUT_MW_GET_SCRN_CTRL_PARAM
{
    DWORD                   dwSize;
    NET_WM_SCRN_CTRL_PARAM  stuScrnCtrlParam;           // ĻƲ
} NET_OUT_MW_GET_SCRN_CTRL_PARAM;

// CLIENT_MonitorWallSetScrnCtrlParam ӿ
typedef struct tagNET_IN_MW_SET_SCRN_CTRL_PARAM
{
    DWORD                   dwSize;
    int                     nMonitorWallID;             // ǽ
    const char*             pszCompositeID;             // ƴID
    NET_WM_SCRN_CTRL_PARAM  stuScrnCtrlParam;           // ĻƲ
} NET_IN_MW_SET_SCRN_CTRL_PARAM;

// CLIENT_MonitorWallSetScrnCtrlParam ӿ
typedef struct tagNET_OUT_MW_SET_SCRN_CTRL_PARAM
{
    DWORD           dwSize;
} NET_OUT_MW_SET_SCRN_CTRL_PARAM;

// CLIENT_MonitorWallGetBackgroudColor ӿ
typedef struct tagNET_IN_MW_GET_BACKGROUDND_COLOR
{
    DWORD           dwSize;
    int             nMonitorWallID;             // ǽ
} NET_IN_MW_GET_BACKGROUDND_COLOR;

// CLIENT_MonitorWallGetBackgroudColor ӿ
typedef struct tagNET_OUT_MW_GET_BACKGROUDND_COLOR
{
    DWORD           dwSize;
    DH_COLOR_RGBA   stuScreenColor;             // Ļɫ
    DH_COLOR_RGBA   stuWindowColor;             // ڱɫ
} NET_OUT_MW_GET_BACKGROUDND_COLOR;

// CLIENT_MonitorWallSetBackgroudColor ӿ
typedef struct tagNET_IN_MW_SET_BACKGROUD_COLOR 
{
    DWORD           dwSize;
    int             nMonitorWallID;             // ǽ
    DH_COLOR_RGBA   stuScreenColor;             // Ļɫ
    DH_COLOR_RGBA   stuWindowColor;             // ڱɫ
} NET_IN_MW_SET_BACKGROUD_COLOR;

// CLIENT_MonitorWallSetBackgroudColor ӿ
typedef struct tagNET_OUT_MW_SET_BACKGROUD_COLOR 
{
    DWORD           dwSize;
} NET_OUT_MW_SET_BACKGROUD_COLOR;

//////////////////////////////////////////////////////////////////////////
// CLIENT_OperateMonitorWallӿڲ
//////////////////////////////////////////////////////////////////////////

// ǽ
typedef enum tagNET_MONITORWALL_OPERATE_TYPE
{
    NET_MONITORWALL_OPERATE_ADD,            // ӵǽ, Ӧ NET_IN_MONITORWALL_ADD  NET_OUT_MONITORWALL_ADD
    NET_MONITORWALL_OPERATE_CTRL_TOUR,      // ԤѲ, Ӧ NET_IN_CTRL_COLLECTIONTOUR  NET_OUT_CTRL_COLLECTIONTOUR
    NET_MONITORWALL_OPERATE_GET_STATUS,     // ȡǰ״̬, Ӧ NET_IN_MONITORWALL_GET_STATUS  NET_OUT_MONITORWALL_GET_STATUS
    NET_MONITORWALL_OPERATE_SET_COLL_SCHD,  // Ԥʱ, Ӧ NET_IN_MONITORWALL_SET_COLL_SCHD  NET_OUT_MONITORWALL_SET_COLL_SCHD
    NET_MONITORWALL_OPERATE_GET_COLL_SCHD,  // ȡԤʱ, Ӧ NET_IN_MONITORWALL_GET_COLL_SCHD  NET_OUT_MONITORWALL_GET_COLL_SCHD
    NET_MONITORWALL_OPERATE_REMOVE,         // ɾǽ, Ӧ NET_IN_MONITORWALL_REMOVE  NET_OUT_MONITORWALL_REMOVE
    NET_MONITORWALL_OPERATE_SET_ENABLE,     // ʹ, Ӧ NET_IN_MONITORWALL_SET_ENABLE  NET_OUT_MONITORWALL_SET_ENABLE
    NET_MONITORWALL_OPERATE_GET_ENABLE,     // ȡʹ, Ӧ NET_IN_MONITORWALL_GET_ENABLE  NET_OUT_MONITORWALL_GET_ENABLE
    NET_MONITORWALL_OPERATE_NAME_EXIST,     // ǽǷ, Ӧ NET_IN_MONITORWALL_NAME_EXIST  NET_OUT_MONITORWALL_NAME_EXIST
} NET_MONITORWALL_OPERATE_TYPE;

// ӵǽ
typedef struct tagNET_IN_MONITORWALL_ADD
{
    DWORD dwSize;
    DH_MONITORWALL stuMonitorWall; // ǽϢ
} NET_IN_MONITORWALL_ADD;

// ӵǽ
typedef struct tagNET_OUT_MONITORWALL_ADD
{
    DWORD dwSize;
    unsigned int nMonitorWallID; // ǽID
} NET_OUT_MONITORWALL_ADD;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_CTRL_TOUR
typedef struct tagNET_IN_CTRL_COLLECTIONTOUR 
{
    DWORD              dwSize;
    int                nChannel;                       // ͨ
    int                nAction;                        // Ѳ, 0:, 1:ʼ
} NET_IN_CTRL_COLLECTIONTOUR;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_CTRL_TOUR
typedef struct tagNET_OUT_CTRL_COLLECTIONTOUR 
{
    DWORD                   dwSize;
} NET_OUT_CTRL_COLLECTIONTOUR;

// ״̬
typedef enum tagNET_MATRIX_STATUS
{
    MATRIX_STATUS_UNKNOWN,              // δ֪
    MATRIX_STATUS_TOUR,                 // ԤѲ
    MATRIX_STATUS_NORMAL,               // ͨԤ
} NET_MATRIX_STATUS;

#define DH_MAX_COLLECTION_NUM   64      // Ԥ
// ״̬Ϣ
typedef struct tagNET_MONITORWALL_STATUS_INFO
{
    DWORD       dwSize;
    int         nInterval;                      // Ѳʱ
    int         nCollectionNum;                 // ԤѲ
    char        szCollections[DH_MAX_COLLECTION_NUM][DH_DEVICE_NAME_LEN];         // ԤѲ
    char        szName[DH_DEVICE_NAME_LEN];     // ǰʾԤ
} NET_MONITORWALL_STATUS_INFO;

// // CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_GET_STATUS
typedef struct tagNET_IN_MONITORWALL_GET_STATUS 
{
    DWORD              dwSize;
    int                nChannel;                        // ͨ
} NET_IN_MONITORWALL_GET_STATUS;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_GET_STATUS
typedef struct tagNET_OUT_MONITORWALL_GET_STATUS
{
    DWORD                           dwSize;
    NET_MATRIX_STATUS               emMatrixStatus;     // ״̬
    NET_MONITORWALL_STATUS_INFO     stuStatusInfo;      // ״̬Ϣ
} NET_OUT_MONITORWALL_GET_STATUS;

// ǽԤʱ
typedef struct tagMONITORWALL_COLLECTION_SCHEDULE
{
    DWORD               dwSize;
    char                szName[DH_DEVICE_NAME_LEN];     // Ԥ
    DH_TSECT            stuSchedule[DH_TSCHE_DAY_NUM][DH_TSCHE_SEC_NUM];   // ʱ, һάԪرʾ~ͽڼ
} MONITORWALL_COLLECTION_SCHEDULE;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_SET_COLL_SCHD
typedef struct tagNET_IN_MONITORWALL_SET_COLL_SCHD 
{
    DWORD               dwSize;
    int                 nCollectionNum;                 // Ԥ
    MONITORWALL_COLLECTION_SCHEDULE stuCollShedule[DH_MAX_COLLECTION_NUM];  // Ԥʱ
    int                 nMonitorWallID;                 // ǽID
} NET_IN_MONITORWALL_SET_COLL_SCHD;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_SET_COLL_SCHD
typedef struct tagNET_OUT_MONITORWALL_SET_COLL_SCHD 
{
    DWORD               dwSize;
} NET_OUT_MONITORWALL_SET_COLL_SCHD;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_GET_COLL_SCHD
typedef struct tagNET_IN_MONITORWALL_GET_COLL_SCHD 
{
    DWORD               dwSize;
    BOOL                bAllCollections;                // TRUE-ѯԤ, ҪָԤ. FALSE-ѯӦԤ
    int                 nCollectionNum;                 // Ԥ, bAllCollectionsΪFALSEʱЧ
    char                szCollections[DH_MAX_COLLECTION_NUM][DH_DEVICE_NAME_LEN];   // Ԥ
    int                 nMonitorWallID;                 // ǽID
} NET_IN_MONITORWALL_GET_COLL_SCHD;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_GET_COLL_SCHD
typedef struct tagNET_OUT_MONITORWALL_GET_COLL_SCHD 
{
    DWORD               dwSize;
    int                 nCollectionNum;                 // Ԥ
    MONITORWALL_COLLECTION_SCHEDULE stuCollShedule[DH_MAX_COLLECTION_NUM];  // Ԥʱ
} NET_OUT_MONITORWALL_GET_COLL_SCHD;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_REMOVE
typedef struct tagNET_IN_MONITORWALL_REMOVE 
{
    DWORD               dwSize;
    int                 nMonitorWallNum;                // Ҫɾĵǽ
    char                szNames[DH_MAX_MONITORWALL_NUM][DH_COMMON_STRING_128];  // ǽ
} NET_IN_MONITORWALL_REMOVE;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_REMOVE
typedef struct tagNET_OUT_MONITORWALL_REMOVE 
{
    DWORD               dwSize;
} NET_OUT_MONITORWALL_REMOVE;

// ǽʹϢ
typedef struct tagNET_MONITORWALL_ENABLE_INFO
{
    DWORD               dwSize;
    BOOL                bEanble;                        // ʹ
    char                szName[DH_COMMON_STRING_128];   // ǽ
} NET_MONITORWALL_ENABLE_INFO;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_SET_ENABLE
typedef struct tagNET_IN_MONITORWALL_SET_ENABLE
{
    DWORD               dwSize;
    int                 nMonitorWallNum;                // Ҫõĵǽ
    NET_MONITORWALL_ENABLE_INFO stuEnable[DH_MAX_MONITORWALL_NUM];  // ǽʹ
} NET_IN_MONITORWALL_SET_ENABLE;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_SET_ENABLE
typedef struct tagNET_OUT_MONITORWALL_SET_ENABLE
{
    DWORD               dwSize;
} NET_OUT_MONITORWALL_SET_ENABLE;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_GET_ENABLE
typedef struct tagNET_IN_MONITORWALL_GET_ENABLE
{
    DWORD               dwSize;
    int                 nMonitorWallNum;                // Ҫѯĵǽ, -1ʾѯеǽ
    char                szNames[DH_MAX_MONITORWALL_NUM][DH_COMMON_STRING_128];  // ǽ, nMonitorWallNum>0ʱЧ
} NET_IN_MONITORWALL_GET_ENABLE;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_SET_ENABLE
typedef struct tagNET_OUT_MONITORWALL_GET_ENABLE
{
    DWORD               dwSize;
    int                 nMonitorWallNum;                // ǽ
    NET_MONITORWALL_ENABLE_INFO stuEnable[DH_MAX_MONITORWALL_NUM];  // ǽʹ
} NET_OUT_MONITORWALL_GET_ENABLE;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_NAME_EXIST
typedef struct tagNET_IN_MONITORWALL_NAME_EXIST 
{
    DWORD               dwSize;
    const char*         pszName;                        // ǽ
} NET_IN_MONITORWALL_NAME_EXIST;

// CLIENT_OperateMonitorWallӿ=>NET_MONITORWALL_OPERATE_NAME_EXIST
typedef struct tagNET_OUT_MONITORWALL_NAME_EXIST 
{
    DWORD               dwSize;
    BOOL                bExist;                        // ǽǷѴ
} NET_OUT_MONITORWALL_NAME_EXIST;

/************************************************************************/
/*  							Uץ									*/
/************************************************************************/

// CLIENT_StartSniffer ӿ
typedef struct tagDH_IN_START_SNIFFER 
{
    DWORD           dwSize;
    const char*     pszNetInterface;            // 
    const char*     pszPath;                    // ץ洢ļ, ձʾ浽Ĭ·
    int             nSaveType;                  // ļ, 0-Wireshark/Tcpdump
    const char*     pszFilter;                  // , "host 172.9.88.200 and port 8080 and tcp"
} DH_IN_START_SNIFFER;

// CLIENT_StartSniffer ӿ
typedef struct tagDH_OUT_START_SNIFFER 
{
    DWORD           dwSize;
} DH_OUT_START_SNIFFER;

// ץϢ
typedef struct tagDH_SNIFFER_INFO
{
    DWORD           dwSize;
    DWORD           nSnifferID;                 // ץID
} DH_SNIFFER_INFO;

// CLIENT_GetSnifferInfo ӿ
typedef struct tagDH_IN_GET_SNIFFER_INFO
{
    DWORD           dwSize;
    const char*     pszNetInterface;
} DH_IN_GET_SNIFFER_INFO;

// CLIENT_GetSnifferInfo ӿ
typedef struct tagDH_OUT_GET_SNIFFER_INFO
{
    DWORD               dwSize;
    DH_SNIFFER_INFO*    pstuSniffers;           // ץϢ, ûڴ
    int                 nMaxSnifferCount;       // ץϢС, ûд
    int                 nRetSnifferCount;       // صץϢ
} DH_OUT_GET_SNIFFER_INFO;

/************************************************************************/
/*  							ļ								*/
/************************************************************************/

// ʽϢ
typedef struct tagDH_FORMAT_PATITION 
{
    DWORD               dwSize;
    const char*         pszStorageName;         // 洢豸
    const char*         pszPatitionName;        // 
} DH_FORMAT_PATITION;

// CLIENT_CreateRemoteFile ӿ
typedef struct tagDH_IN_CREATE_REMOTE_FILE
{
    DWORD               dwSize;
    const char*         pszPath;                // ļ
    BOOL                bDirectory;             // Ƿļ
} DH_IN_CREATE_REMOTE_FILE;

// CLIENT_CreateRemoteFile ӿ
typedef struct tagDH_OUT_CREATE_REMOTE_FILE 
{
    DWORD               dwSize;
} DH_OUT_CREATE_REMOTE_FILE;

// CLIENT_RemoveRemoteFiles ӿ
typedef struct tagDH_IN_REMOVE_REMOTE_FILES
{
    DWORD               dwSize;
    const char**        pszPath;                // ļ·ָ
    int                 nFileCount;             // ļ·
} DH_IN_REMOVE_REMOTE_FILES;

// CLIENT_RemoveRemoteFiles ӿ
typedef struct tagDH_OUT_REMOVE_REMOTE_FILES 
{
    DWORD               dwSize;
} DH_OUT_REMOVE_REMOTE_FILES;

// CLIENT_RenameRemoteFile ӿ
typedef struct tagDH_IN_RENAME_REMOTE_FILE
{
    DWORD               dwSize;
    const char*         pszOldPath;             // ļ
    const char*         pszNewPath;             // ļ
} DH_IN_RENAME_REMOTE_FILE;

// CLIENT_RenameRemoteFile ӿ
typedef struct tagDH_OUT_RENAME_REMOTE_FILE 
{
    DWORD               dwSize;
} DH_OUT_RENAME_REMOTE_FILE;

// ļ/Ŀ¼Ϣ
typedef struct tagDH_REMOTE_FILE_INFO 
{
    DWORD               dwSize;
    BOOL                bDirectory;                     // Ƿļ
    char                szPath[MAX_PATH];               // ·
    NET_TIME            stuCreateTime;                  // ʱ
    NET_TIME            stuModifyTime;                  // ޸ʱ
    INT64               nFileSize;                      // ļС
    char                szFileType[DH_FILE_TYPE_LEN];   // ļ
} DH_REMOTE_FILE_INFO;

// CLIENT_ListRemoteFile ӿ
typedef struct tagDH_IN_LIST_REMOTE_FILE
{
    DWORD               dwSize;
    const char*         pszPath;                        // ·
    BOOL                bFileNameOnly;                  // ֻȡļ, ļϢ, ļϢֻļЧ
} DH_IN_LIST_REMOTE_FILE;

// CLIENT_ListRemoteFile ӿ
typedef struct tagDH_OUT_LIST_REMOTE_FILE 
{
    DWORD                   dwSize;
    DH_REMOTE_FILE_INFO*    pstuFiles;                  // ļϢ, ûڴ
    int                     nMaxFileCount;              // ļϢС, ûд
    int                     nRetFileCount;              // صļ
} DH_OUT_LIST_REMOTE_FILE;

// ļԡ
typedef enum tagNET_SET_FILEATTR_ACTION
{
    EM_SET_FILEATTR_ACTION_UNKNOWN = 0,                 // δ֪
    EM_SET_FILEATTR_ACTION_MARK,                        // ļ
} NET_SET_FILEATTR_ACTION;

// CLIENT_SetFileAttribute ӿ
typedef struct tagDH_IN_SET_FILEATTRIBUTE
{
    DWORD                   dwSize;
    unsigned int            nDriveNo;                       // ̺
    unsigned int            nPartition;                     // 
    unsigned int            nCluster;                       // غ
    NET_SET_FILEATTR_ACTION emAction;                       // ÿԶӦһkey,ֵvalue
                                                            // key:Mark ļ,Ӧvalue,ӳʱ(λ:)
    char                    szValue[DH_COMMON_STRING_64];   // ֵ
} DH_IN_SET_FILEATTRIBUTE;

// CLIENT_SetFileAttribute ӿ
typedef struct tagDH_OUT_SET_FILEATTRIBUTE
{
    DWORD                   dwSize;
} DH_OUT_SET_FILEATTRIBUTE;

// ֶ洢豸
typedef struct tagDH_EJECT_STORAGE_DEVICE
{
    DWORD               dwSize;    
    const char*         pszStorageName;                 // 洢豸
} DH_EJECT_STORAGE_DEVICE;

// ֶװش洢豸
typedef struct tagDH_LOAD_STORAGE_DEVICE 
{
    DWORD               dwSize;
    const char*         pszStorageName;                 // 洢豸
} DH_LOAD_STORAGE_DEVICE;

// CLIENT_UploadRemoteFile ӿ(ϴļ豸)
typedef struct tagDH_IN_UPLOAD_REMOTE_FILE
{
    DWORD               dwSize;
    const char*         pszFileSrc;                     // Դļ·
    const char*         pszFileDst;                     // Ŀļ·
	const char*			pszFolderDst;					// Ŀļ·ΪNULL, NULLʱ豸ʹĬ·
    unsigned int        nPacketLen;                     // ļְС(ֽ): 0ʾְ
} DH_IN_UPLOAD_REMOTE_FILE;

// CLIENT_UploadRemoteFile ӿ(ϴļ豸)
typedef struct tagDH_OUT_UPLOAD_REMOTE_FILE
{
    DWORD               dwSize;
} DH_OUT_UPLOAD_REMOTE_FILE;

// CLIENT_DownloadRemoteFile ӿ(ļ)
typedef struct tagDH_IN_DOWNLOAD_REMOTE_FILE
{
    DWORD               dwSize;
    const char*         pszFileName;                    // Ҫصļ
    const char*         pszFileDst;                     // ļ·
} DH_IN_DOWNLOAD_REMOTE_FILE;

// CLIENT_DownloadRemoteFile ӿ(ļ)
typedef struct tagDH_OUT_DOWNLOAD_REMOTE_FILE
{
    DWORD               dwSize;
} DH_OUT_DOWNLOAD_REMOTE_FILE;

/************************************************************************/
/* 								豸								*/
/************************************************************************/
// 豸
typedef struct tagDH_IN_SEARCH_CONDITON
{
    DWORD               dwSize;
    const char*         pMachineName;                   // 豸ƻ
    const char*         pMachineAddr;                   // 豸ص(磺.ϴ.ΰҵ·)
    const char*         pSerialNo;                      // 豸к
    const char*         pChannelName;                   // Ƶͨ
} DH_MATRIX_SEARCH_CONDITON;

// CLIENT_MatrixSearch ӿ(豸)
typedef struct tagDH_IN_MATIRX_SEARCH
{
    DWORD                       dwSize;
    const char*                 pSerialNo;              // 豸к,"Local"-豸"Root"-豸豸豸кűʾ
    DH_MATRIX_SEARCH_CONDITON   stuCondition;           // , Ϊһ
} DH_IN_MATRIX_SEARCH;

// CLIENT_MatrixSearch ӿ(豸)
typedef struct tagDH_OUT_MATRIX_SEARCH
{
    DWORD               dwSize;
    DH_REMOTE_DEVICE*   pstuRemoteDevices;              // 豸б, ûڴ
    int                 nMaxDeviceCount;                // 豸бֵ, ûд
    int                 nRetDeviceCount;                // ʵʷ豸
} DH_OUT_MATRIX_SEARCH;

// CLIENT_GetMatrixTree ӿ
typedef struct tagDH_IN_GET_MATRIX_TREE
{
    DWORD               dwSize;
    const char*         pSerialNo;                      // 豸к,"Local"-豸"Root"-豸豸豸кűʾ
    int                 nLevel;                         // ü豸Ϣ0-豸1-豸2-豸+豸һ豸
                                                        // 3-豸+豸һ豸+һ豸һ豸
} DH_IN_GET_MATRIX_TREE;

// 豸Ϣ
typedef struct tagDH_CASCADE_DEVICE_INFO
{
    DWORD               dwSize;
    int                 nLevel;                         // ǰ豸
    char                szPath[MAX_PATH];               // 豸·ʽname1.name2.name3...
    DH_REMOTE_DEVICE    stuDeviceInfo;                  // 豸ϸϢ
} DH_CASCADE_DEVICE_INFO;

// CLIENT_GetMatrixTree ӿ
typedef struct tagDH_OUT_GET_MATRIX_TREE
{
    DWORD                   dwSize;
    DH_CASCADE_DEVICE_INFO* pstuRemoteDevices;          // 豸Ϣ
    int                     nMaxDeviceCount;            // 豸Ϣֵ
    int                     nRetDeviceCount;            // صʵ豸
} DH_OUT_GET_MATRIX_TREE;

// CLIENT_GetSuperiorMatrixList ӿ
typedef struct tagDH_IN_GET_SUPERIOR_MATRIX_LIST
{
    DWORD                   dwSize;
} DH_IN_GET_SUPERIOR_MATRIX_LIST;

// CLIENT_GetSuperiorMatrixList ӿ
typedef struct tagDH_OUT_GET_SUPERIOR_MATRIX_LIST
{
    DWORD                   dwSize;
    DH_REMOTE_DEVICE*       pstuRemoteDevices;          // 豸б, ûڴ
    int                     nMaxDeviceCount;            // 豸бֵ, ûд
    int                     nRetDeviceCount;            // ʵʷ豸
} DH_OUT_GET_SUPERIOR_MATRIX_LIST;

////////////////////////////////////¼񱸷ݻָ//////////////////////////////////////

// ¼񱸷ݻָϢ
typedef struct tagDH_RECORD_BACKUP_RESTORE_TASK
{
    DWORD               dwSize;
    unsigned int        nTaskID;                        // ID
    char                szDeviceID[DH_DEV_ID_LEN_EX];   // 豸ID
    int                 nChannelID;                     // ͨ
    NET_TIME            stuStartTime;                   // ʼʱ
    NET_TIME            stuEndTime;                     // ʱ
    int                 nState;                         // ǰ״̬, 0-ȴ, 1-, 2-, 3-ʧ
} DH_REC_BAK_RST_TASK;

// CLIENT_AddRecordBackupRestoreTaskӿ
typedef struct tagDH_IN_ADD_RECORD_BACKUP_RESTORE_TASK
{
    DWORD               dwSize;
    const char*         pszDeviceID;                    // 豸ID
    int*                pnChannels;                     // ͨ
    int                 nChannelCount;                  // ͨС
    NET_TIME            stuStartTime;                   // ʼʱ
    NET_TIME            stuEndTime;                     // ʱ
} DH_IN_ADD_REC_BAK_RST_TASK;

// CLIENT_RemoveRecordBackupRestoreTaskӿ
typedef struct tagDH_IN_REMOVE_RECORD_BACKUP_RESTORE_TASK
{
    DWORD               dwSize;
    unsigned int*       pnTaskIDs;                      // ID
    int                 nTaskCount;                     // 
} DH_IN_REMOVE_REC_BAK_RST_TASK;

// CLIENT_QueryRecordBackupRestoreTaskӿ
typedef struct tagDH_IN_QUERY_RECORD_BACKUP_RESTORE_TASK
{
    DWORD               dwSize;
} DH_IN_QUERY_REC_BAK_RST_TASK;

// CLIENT_QueryRecordBackupRestoreTaskӿ
typedef struct tagDH_OUT_QUERY_RECORD_BACKUP_RESTORE_TASK
{
    DWORD                   dwSize;
    DH_REC_BAK_RST_TASK*    pTasks;                     // 
    int                     nMaxCount;                  // С
    int                     nReturnCount;               // ص
} DH_OUT_QUERY_REC_BAK_RST_TASK;

typedef struct tagDH_LOGIC_DEVICE_ADD_CAMERA_PARAM
{
    DWORD                   dwSize;
    const char*             pszDeviceID;                // 豸ID
    int                     nChannel;                   // ͨ
} DH_LOGIC_DEVICE_ADD_CAMERA_PARAM;

typedef struct tagDH_LOGIC_DEVICE_ADD_CAMERA_RESULT
{
    DWORD                   dwSize;
    char                    szDeviceID[DH_DEV_ID_LEN];  // 豸ID
    int                     nChannel;                   // ͨ
    int                     nUniqueChannel;             // ͳһ
    int                     nFailedCode;                // ʧ, 0-ɹ1-Uniqueַռ 2-Ѿ
} DH_LOGIC_DEVICE_ADD_CAMERA_RESULT;

// CLIENT_AddLogicDeviceCamera ӿ
typedef struct tagDH_IN_ADD_LOGIC_DEVICE_CAMERA
{
    DWORD                   dwSize;
    DH_LOGIC_DEVICE_ADD_CAMERA_PARAM* pCameras;         // ƵԴϢ
    int                     nCameraCount;               // ƵԴϢ
} DH_IN_ADD_LOGIC_DEVICE_CAMERA;

// CLIENT_AddLogicDeviceCamera ӿ
typedef struct tagDH_OUT_ADD_LOGIC_DEVICE_CAMERA 
{
    DWORD                   dwSize;
    DH_LOGIC_DEVICE_ADD_CAMERA_RESULT* pResults;        // ƵԴ, ûڴ
    int                     nMaxResultCount;            // С, ûд
    int                     nRetResultCount;            // ʵʽ
} DH_OUT_ADD_LOGIC_DEVICE_CAMERA;

/************************************************************************/
/*                         ݿ¼                               */
/************************************************************************/
typedef struct tagNET_AUTHORITY_TYPE
{
  DWORD                       dwSize; 
  EM_NET_AUTHORITY_TYPE       emAuthorityType;                          //Ȩ
  BOOL                        bAuthorityEnable;                         //Ȩʹ
}NET_AUTHORITY_TYPE;

// ͨڰ¼Ϣ
typedef struct tagNET_TRAFFIC_LIST_RECORD
{
  DWORD                      dwSize; 
  int                        nRecordNo;                                 // ֮ǰѯļ¼
  char                       szMasterOfCar[DH_MAX_NAME_LEN];            // 
  char                       szPlateNumber[DH_MAX_PLATE_NUMBER_LEN];    // ƺ 
  EM_NET_PLATE_TYPE          emPlateType;                               // 
  EM_NET_PLATE_COLOR_TYPE    emPlateColor;                              // ɫ 
  EM_NET_VEHICLE_TYPE        emVehicleType;                             //  
  EM_NET_VEHICLE_COLOR_TYPE  emVehicleColor;                            // ɫ
  NET_TIME                   stBeginTime;                               // ʼʱ
  NET_TIME                   stCancelTime;                              // ʱ
  int                        nAuthrityNum;                              // Ȩ޸
  NET_AUTHORITY_TYPE         stAuthrityTypes[DH_MAX_AUTHORITY_LIST_NUM];// Ȩб , 
  EM_NET_TRAFFIC_CAR_CONTROL_TYPE emControlType;                        //  
}NET_TRAFFIC_LIST_RECORD;

// ͨڰ˻¼ѯ
typedef struct
{
    DWORD                    dwSize;
    char                     szPlateNumber[DH_MAX_PLATE_NUMBER_LEN];      // ƺ
    char                     szPlateNumberVague[DH_MAX_PLATE_NUMBER_LEN]; // ƺģѯ
    int                      nQueryResultBegin;                           // һؽڲѯеƫ 
    BOOL                     bRapidQuery;                                 // Ƿٲѯ, TRUE:Ϊ٣ٲѯʱȴɾĲɡĬΪǿٲѯ
}FIND_RECORD_TRAFFICREDLIST_CONDITION;

// ¼¼ѯ
typedef struct
{
    DWORD                    dwSize;
    NET_TIME                 stuStartTime;                      // ʼʱ
    NET_TIME                 stuEndTime;                        // ʱ
}FIND_RECORD_BURN_CASE_CONDITION;


// Ž¼ѯ
typedef struct tagFIND_RECORD_ACCESSCTLCARD_CONDITION
{
    DWORD                    dwSize;
    char                     szCardNo[DH_MAX_CARDNO_LEN];      // 
    char                     szUserID[DH_MAX_USERID_LEN];      // ûID
    BOOL                     bIsValid;                         // ǷЧ, TRUE:Ч,FALSE:Ч
}FIND_RECORD_ACCESSCTLCARD_CONDITION;

// Ž¼ѯ
typedef struct tagFIND_RECORD_ACCESSCTLPWD_CONDITION
{
    DWORD                     dwSize;
    char                      szUserID[DH_MAX_USERID_LEN];      // ûID
}FIND_RECORD_ACCESSCTLPWD_CONDITION;

// Ž¼ѯ
typedef struct tagFIND_RECORD_ACCESSCTLCARDREC_CONDITION
{
    DWORD                     dwSize;
    char                      szCardNo[DH_MAX_CARDNO_LEN];      // 
    NET_TIME                  stStartTime;                      // ʼʱ
    NET_TIME                  stEndTime;                        // ʱ
}FIND_RECORD_ACCESSCTLCARDREC_CONDITION;

// ռ¼ѯ
typedef struct tagFIND_RECORD_ACCESSCTLHOLIDAY_CONDITION
{
    DWORD                     dwSize;
}FIND_RECORD_ACCESSCTLHOLIDAY_CONDITION;

// ͨ¼ѯ
typedef struct tagFIND_RECORD_TRAFFICFLOW_CONDITION
{
    DWORD                     dwSize;
    BOOL                      abChannelId;                      // ͨŲѯǷЧ     
    int                       nChannelId;                       // ͨ
    BOOL                      abLane;                           // ŲѯǷЧ
    int                       nLane;                            // 
    BOOL                      abStartTime;                      // ʼʱѯǷЧ   
    NET_TIME                  stStartTime;                      // ʼʱ
     BOOL                     abEndTime;                        // ʱѯǷЧ
    NET_TIME                  stEndTime;                        // ʱ 
}FIND_RECORD_TRAFFICFLOW_CONDITION;

#define DH_MAX_CALLTYPE_LIST_NUM                16                  // Ͳѯб
#define DH_MAX_ENDSTATE_LIST_NUM                16                  // ״̬ѯб

// ͨ¼ѯ
typedef struct tagFIND_RECORD_VIDEO_TALK_LOG_CONDITION
{
    DWORD                           dwSize;
    BOOL                            bCallTypeEnable;                            // ͲѯǷЧ
    int                             nCallTypeListNum;                           // Ӧ emCallTypeList Чöٸ
    EM_VIDEO_TALK_LOG_CALLTYPE      emCallTypeList[DH_MAX_CALLTYPE_LIST_NUM];   // ʹб
    BOOL                            bEndStateEnable;                            // ״̬ѯǷЧ
    int                             nEndStateListNum;                           // Ӧ emEndStateList Чöٸ
    EM_VIDEO_TALK_LOG_ENDSTATE      emEndStateList[DH_MAX_ENDSTATE_LIST_NUM];   // ״̬ʹб
}FIND_RECORD_VIDEO_TALK_LOG_CONDITION;

// ״̬¼ѯ
typedef struct tagFIND_RECORD_REGISTER_USER_STATE_CONDITION
{
    DWORD                           dwSize;
    BOOL                            bUserIDEnable;                                  // ûIDѯǷЧ
    char                            szUserID[DH_MAX_USERID_LEN];                    // ûID
    BOOL                            bOnlineEnable;                                  // Ƿ߲ѯǷЧ
    BOOL                            bOnline;                                        // Ƿ
    BOOL                            bVideoTalkingEnable;                            // Խ״̬ѯǷЧ
    EM_REGISTER_USER_STATE          emVideoTalking;                             // Խ״̬
}FIND_RECORD_REGISTER_USER_STATE_CONDITION;

// ϵ˼¼ѯ
typedef struct tagFIND_RECORD_VIDEO_TALK_CONTACT_CONDITION
{
    DWORD                           dwSize;
    BOOL                            bVTShortNumberEnable;                                   // ӶԽ̺ŲѯǷЧ
    char                            szVTShortNumber[DH_COMMON_STRING_32];                   // ӶԽ̺
}FIND_RECORD_VIDEO_TALK_CONTACT_CONDITION;

// ͨ¼
typedef struct tagNET_RECORD_TRAFFIC_FLOW_STATE 
{
    DWORD                           dwSize;
    int                             nRecordNum;                 // ¼
    int                             nChannel;                   // ͨ   
    int                             nLane;                      // 
    int                             nVehicles;                  // ͨ
    float                           fAverageSpeed;              // ƽ٣λkm/h
    float                           fTimeOccupyRatio;           // ʱռʣλʱͨĳʱܺռλʱı
    float                           fSpaceOccupyRatio;          // ռռʣٷʼĳܺͳʱڳƽʻ
    float                           fSpaceHeadway;              // ͷ࣬ڳ֮ľ룬λ/
    float                           fTimeHeadway;               // ͷʱ࣬λ/
    int                             nLargeVehicles;             // 󳵽ͨ(9<<12)/λʱ
    int                             nMediumVehicles;            // ͳͨ(6<<9)/λʱ
    int                             nSmallVehicles;             // Сͨ(4<<6)/λʱ䣬
    float                           fBackOfQueue;               // Ŷӳȣλ, źŽͣߵŶӳĩ֮ľ
}NET_RECORD_TRAFFIC_FLOW_STATE;

// CLIENT_FindRecordӿ
typedef struct _NET_IN_FIND_RECORD_PARAM
{
    DWORD                     dwSize;          // ṹС
    EM_NET_RECORD_TYPE        emType;          // ѯ¼
    void*                     pQueryCondition; // ѯͶӦĲѯ 
}NET_IN_FIND_RECORD_PARAM;

// CLIENT_FindRecordӿ
typedef struct _NET_OUT_FIND_RECORD_PARAM
{
    DWORD                     dwSize;          // ṹС
    LLONG                     lFindeHandle;    // ѯ¼Ψһʶĳβѯ
}NET_OUT_FIND_RECORD_PARAM;

// CLIENT_FindNextRecordӿ
typedef struct _NET_IN_FIND_NEXT_RECORD_PARAM
{
    DWORD                     dwSize;          // ṹС
    LLONG                     lFindeHandle;    // ѯ
    int                       nFileCount;      // ǰѯļ¼
}NET_IN_FIND_NEXT_RECORD_PARAM;

// CLIENT_FindNextRecordӿ
typedef struct _NET_OUT_FIND_NEXT_RECORD_PARAM
{
    DWORD                     dwSize;          // ṹС
    void*                     pRecordList;     // ¼бûڴ
    int                       nMaxRecordNum;   // б¼
    int                       nRetRecordNum;   // ѯļ¼ѯСѯʱѯ
}NET_OUT_FIND_NEXT_RECORD_PARAM;

typedef struct tagNET_INSERT_RECORD_INFO
{
    DWORD                     dwSize;
    NET_TRAFFIC_LIST_RECORD   *pRecordInfo;    // ¼Ϣ                
}NET_INSERT_RECORD_INFO;

typedef struct tagNET_UPDATE_RECORD_INFO
{
    DWORD                     dwSize;
    NET_TRAFFIC_LIST_RECORD   *pRecordInfo;    // ¼Ϣ                
}NET_UPDATE_RECORD_INFO;

typedef struct tagNET_REMOVE_RECORD_INFO
{
    DWORD                     dwSize;
    int                       nRecordNo;       // ֮ǰѯļ¼    
}NET_REMOVE_RECORD_INFO;

typedef struct tagNET_IN_OPERATE_TRAFFIC_LIST_RECORD
{
    DWORD                     dwSize;
    
    EM_RECORD_OPERATE_TYPE    emOperateType;
    EM_NET_RECORD_TYPE        emRecordType;    // Ҫļ¼
    void                      *pstOpreateInfo;
    
}NET_IN_OPERATE_TRAFFIC_LIST_RECORD;

//ֽ׶ʵֵĲӿУֻзnRecordNoĲstRetRecordʱ
typedef struct tagNET_OUT_OPERATE_TRAFFIC_LIST_RECORD
{
    DWORD                     dwSize;
    int                       nRecordNo;        //¼    
}NET_OUT_OPERATE_TRAFFIC_LIST_RECORD;

//̨굥Ԫ
typedef struct tagPTZ_SPEED_UNIT
{
    float                  fPositionX;           //̨ˮƽʣһ-1~1
    float                  fPositionY;           //ֱ̨ʣһ-1~1
    float                  fZoom;                //̨ȦŴʣһ 0~1
    char                   szReserve[32];        //Ԥ32ֽ
}PTZ_SPEED_UNIT;

//̨굥Ԫ
typedef struct tagPTZ_SPACE_UNIT
{
    int                    nPositionX;           //̨ˮƽ˶λãЧΧ[0,3600]
    int                    nPositionY;           //ֱ̨˶λãЧΧ[-1800,1800]
    int                    nZoom;                //̨Ȧ䶯λãЧΧ[0,128]
    char                   szReserve[32];        //Ԥ32ֽ
}PTZ_SPACE_UNIT;

//̨Ӧṹ
typedef struct tagPTZ_Control_Continuously
{
    PTZ_SPEED_UNIT         stuSpeed;              //̨ٶ
    int                    nTimeOut;              //ƶʱʱ䣬λΪ
    char                   szReserve[64];         //Ԥ64ֽ
}PTZ_CONTROL_CONTINUOUSLY;

//Կ̨Ӧṹ
typedef struct tagPTZ_Control_Absolutely
{
    PTZ_SPACE_UNIT         stuPosition;           //̨ƶλ
    PTZ_SPEED_UNIT         stuSpeed;              //̨ٶ
    char                   szReserve[64];         //Ԥ64ֽ
}PTZ_CONTROL_ABSOLUTELY;

// ͨϢ
typedef struct tagNET_ALARM_IN_CHANNEL
{
    DWORD                   dwSize;
    BOOL                    bValid;                             // ǷЧ, FALSEʾñͨûʹ
    int                     nChannel;                           // ͨ
    char                    szDeviceID[DH_DEV_ID_LEN];          // 豸ID, رͨ: "Local", Զ豸: ʹuuidʾ
    char                    szName[DH_DEV_NAME_LEN];            // ͨ
}NET_ALARM_IN_CHANNEL;

// ͨ
typedef struct tagNET_ALARM_CHANNEL_COUNT 
{
    DWORD                   dwSize;
    int                     nLocalAlarmIn;                      // رͨ
    int                     nLocalAlarmOut;                     // رͨ
    int                     nRemoteAlarmIn;                     // Զ̱ͨ
    int                     nRemoteAlarmOut;                    // Զ̱ͨ
}NET_ALARM_CHANNEL_COUNT;

//ٶתԤλ̨ƶӦṹ
typedef struct tagPTZ_Control_GotoPreset
{
    int                     nPresetIndex;           //Ԥλ
    PTZ_SPEED_UNIT          stuSpeed;               //̨ٶ
    char                    szReserve[64];          //Ԥ64ֽ
}PTZ_CONTROL_GOTOPRESET;

// CLIENT_SetTourSource ӿ(ôѲʾԴ)
typedef struct tagNET_IN_SET_TOUR_SOURCE 
{
    DWORD                   dwSize;
    int                     nChannel;               // ͨ
    int                     nWindow;                // ں
    DH_SPLIT_SOURCE*        pstuSrcs;               // ʾԴ, ɽдѲ
    int                     nSrcCount;              // ʾԴ
} NET_IN_SET_TOUR_SOURCE;

// CLIENT_SetTourSource ӿ(ôѲʾԴ)
typedef struct tagNET_OUT_SET_TOUR_SOURCE
{
    DWORD                   dwSize;
} NET_OUT_SET_TOUR_SOURCE;

// CLIENT_GetTourSource ӿ
typedef struct tagNET_IN_GET_TOUR_SOURCE 
{
    DWORD                   dwSize;
    int                     nChannel;               // ͨ, pszCompsiteIDΪNULLʱЧ
    const char*             pszCompositeID;         // ƴID
    int                     nWindow;                // ں, -1ʾд
} NET_IN_GET_TOUR_SOURCE;

// ѲʾԴϢ
typedef struct tagNET_SPLIT_TOUR_SOURCE 
{
    DWORD                   dwSize;
    DH_SPLIT_SOURCE*        pstuSrcs;               // ʾԴ, ûڴ
    int                     nMaxSrcCount;           // ʾԴ
    int                     nRetSrcCount;           // صʾԴ
} NET_SPLIT_TOUR_SOURCE;

// CLIENT_GetTourSource ӿ
typedef struct tagNET_OUT_GET_TOUR_SOURCE
{
    DWORD                   dwSize;    
    NET_SPLIT_TOUR_SOURCE*  pstuWndSrcs;            // ѲϢ, ûڴ
    int                     nMaxWndCount;           // , ûд
    int                     nRetWndCount;           // صĴ
} NET_OUT_GET_TOUR_SOURCE;

// ָѲ״̬Ϣ
typedef struct tagNET_SPLIT_TOUR_STATUS_INFO
{
    DWORD               dwSize;
    int                 nWindow;                    // ں
    NET_TOUR_STATUS     emStatus;                   // ״̬
    DH_SPLIT_WND_SOURCE stuSource;                  // ǰʾԴϢ
}NET_SPLIT_TOUR_STATUS_INFO;

// Ѳ״̬صԭ, lAttachHandleCLIENT_AttachSplitTourķֵ
typedef void (CALLBACK *fTourStatusCallBack)(LLONG lLoginID, LLONG lAttachHandle, NET_SPLIT_TOUR_STATUS_INFO* pstStatus, void* reserved, LDWORD dwUser);

// CLIENT_AttachSplitTourӿ
typedef struct tagNET_IN_ATTACH_SPLIT_TOUR
{
    DWORD               dwSize;
    int                 nChannel;                   // ͨ, pszCompsiteIDΪNULLʱЧ
    const char*         pszCompositeID;             // ƴID
    fTourStatusCallBack cbStatus;                   // Ѳ״̬ص
    LDWORD              dwUser;                     // Ѳ״̬ص
}NET_IN_ATTACH_SPLIT_TOUR;

// CLIENT_AttachSplitTourӿ
typedef struct tagNET_OUT_ATTACH_SPLIT_TOUR 
{
    DWORD               dwSize;
}NET_OUT_ATTACH_SPLIT_TOUR;

// fAttachRecordInfoCB , ϱ¼ļϢ
typedef struct tagNET_CB_RECORD_INFO
{
    DWORD                   dwSize;
    int                     nChannel;               // ͨ
    char                    szFileName[MAX_PATH];   // ¼
    DWORD                   dwType;                 // ¼, λ£
                                                    // Bit0-ʱ¼
                                                    // Bit1-̬¼
                                                    // Bit2-¼
                                                    // Bit3-¼
    DWORD                   dwState;                // ¼״̬, 0-, 1-ɾ
} NET_CB_RECORD_INFO;

// ¼»صԭΣlAttachHandleCLIENT_AttachRecordInfoķֵ, ÿnpBuf->dwSize * n == nBufLen
typedef void (CALLBACK *fAttachRecordInfoCB)(LLONG lLoginID, LLONG lAttachHandle, NET_CB_RECORD_INFO* pBuf, int nBufLen, LDWORD dwUser);

// CLIENT_AttachRecordInfo 
typedef struct tagNET_IN_ATTACH_RECORD_INFO
{
    DWORD                   dwSize;
    int                     nInterval;              // ʱ, 豸ÿnInterval, ¼Ϣ
    int                     nDelay;                 // ϱʱ, 豸1nDelayֵѡӳϱ¼״̬, nDelayСnInterval
    fAttachRecordInfoCB     cbAttachRecordInfo;     // ¼»ص
    LDWORD                  dwUser;                 // û
} NET_IN_ATTACH_RECORD_INFO;

typedef struct tagNET_OUT_ATTACH_RECORD_INFO
{
    DWORD                   dwSize;
} NET_OUT_ATTACH_RECORD_INFO;


//̨Ԫݽӿڻصԭ
//pBuf ֽ׶ҪΪ DH_PTZ_LOCATION_INFO 
typedef void (CALLBACK *fPTZStatusProcCallBack)(LLONG lLoginID, LLONG lAttachHandle, void* pBuf, int nBufLen, LDWORD dwUser);

// ̨Ԫݽӿ
typedef struct tagNET_IN_PTZ_STATUS_PROC
{
    DWORD                   dwSize;
    int                     nChannel;              // ̨ͨ
    fPTZStatusProcCallBack  cbPTZStatusProc;       // ״̬ص
    LDWORD                  dwUser;                // û
}NET_IN_PTZ_STATUS_PROC;

// ̨Ԫݽӿ
typedef struct tagNET_OUT_PTZ_STATUS_PROC
{
    DWORD                   dwSize;
}NET_OUT_PTZ_STATUS_PROC;

// ̨״̬ṹ
typedef struct tagDH_OUT_PTZ_VIEW_RANGE_STATUS
{
    DWORD      dwSize;
    double     dbDistance;                         // Ӿ, λ:
    int        nAngelH;                            // ˮƽӽǶ, 0~1800, λ:
    int        nAzimuthH;                          // ˮƽλǶ, 0~3600, λ:
    int        nInclinationH;                      // ˮƽбǶ, -900~900, λ:
}DH_OUT_PTZ_VIEW_RANGE_STATUS;

//̨صԭ
typedef void (CALLBACK *fViewRangeStateCallBack)(LLONG lLoginID, LLONG lAttachHandle, DH_OUT_PTZ_VIEW_RANGE_STATUS* pBuf, int nBufLen, LDWORD dwUser);

// Ŀ
typedef struct tagNET_IN_VIEW_RANGE_STATE
{
    DWORD                   dwSize;
    int                     nChannel;              // ̨ͨ
    fViewRangeStateCallBack cbViewRange;           // ״̬ص
    LDWORD                  dwUser;                // û
}NET_IN_VIEW_RANGE_STATE;

// Ŀ
typedef struct tagNET_OUT_VIEW_RANGE_STATE
{
    DWORD                   dwSize;
}NET_OUT_VIEW_RANGE_STATE;

//̨Ϣ
typedef struct tagPTZ_VIEW_RANGE_INFO
{
    int                     nStructSize;
    int                     nAzimuthH;              // ˮƽλǶ, 0~3600, λ:
}PTZ_VIEW_RANGE_INFO;

// ͨϢ
typedef struct tagNET_CHN_COUNT_INFO
{
    DWORD                   dwSize;
    int                     nMaxTotal;              // 豸ͨ(Ч֮ͨ)
    int                     nCurTotal;              // õͨ
    int                     nMaxLocal;              // 󱾵ͨ, Ϳɲӿͨ
    int                     nCurLocal;              // ñͨ
    int                     nMaxRemote;             // Զͨ
    int                     nCurRemote;             // Զͨ
} NET_CHN_COUNT_INFO;

// 豸ͨϢ
typedef struct tagNET_DEV_CHN_COUNT_INFO
{
    DWORD                   dwSize;
    NET_CHN_COUNT_INFO      stuVideoIn;             // Ƶͨ
    NET_CHN_COUNT_INFO      stuVideoOut;            // Ƶͨ
} NET_DEV_CHN_COUNT_INFO;

// ¼״̬ϸϢ
typedef struct tagNET_RECORD_STATE_DETAIL 
{
    DWORD                   dwSize;
    BOOL                    bMainStream;            // , TRUE-¼, FALSE-û¼
    BOOL                    bExtraStream1;          // 1, TRUE-¼, FALSE-û¼
    BOOL                    bExtraStream2;          // 2, TRUE-¼, FALSE-û¼
    BOOL                    bExtraStream3;          // 3, TRUE-¼, FALSE-û¼
} NET_RECORD_STATE_DETAIL;

// OSNӿڷ״̬
typedef enum{
    EM_OSN_OK,                                      // ɹ
    EM_OSN_OK_P2P,                                  // ɹ,ӳP2P
    EM_OSN_OK_RELAYED,                              // ɹ,ӳRALAYED
    EM_OSN_ERROR_API_NOT_INITIALIZED,               // ʼʧ
    EM_OSN_ERROR_NO_NETWORK,                        // ޿
    EM_OSN_ERROR_CANNOT_CONNECT_TO_AGENT,           // ޷ӵָ
    EM_OSN_ERROR_LOCAL_PORT_ALREADY_USED,           // ض˿ʹ
    EM_OSN_ERROR_AGENT_RESOURCES_LIMIT_REACHED,     // ޷ӣﵽ
    EM_OSN_ERROR_INVALID_DEVICE_ID,                 // 豸IDǷ
    EM_OSN_ERROR_INVALID_SERVICE_PORT,              // ˿ڷǷ
    EM_OSN_ERROR_INVALID_LOCAL_PORT,                // ض˿ڷǷ
    EM_OSN_ERROR_INVALID_TUNNEL,                    // ӳϢǷ(ɾӳʱ)
    EM_OSN_ERROR                                    // δ֪
}EM_OSN_STATUS;

// ӳ
typedef struct {
    unsigned int             servicePort;           // ˿ (, 80,9000,1025  23)
    unsigned int             localPort;             // ض˿ 1024 - 655360ʾԶ
    const char*              pdeviceId;             // 豸ID
    BYTE                     Reserved[64];          // 
}OSN_IN_CREATE_TUNNEL_PARAM, *LOSN_IN_CREATE_TUNNEL_PARAM;

// ӳ
typedef struct {
    unsigned int             servicePort;           // ˿ (, 80,9000,1025  23)
    unsigned int             localPort;             // ض˿ 1024 - 655360ʾԶ
    EM_OSN_STATUS            tunnelStatus;
    const char*              pdeviceId;             // 豸ID
    BYTE                     Reserved[64];          // 
}OSN_OUT_CREATE_TUNNEL_PARAM, *LOSN_OUT_CREATE_TUNNEL_PARAM;

// ɾӳ
typedef struct {
    unsigned int             servicePort;           // ˿ (, 80,9000,1025  23)
    unsigned int             localPort;             // ض˿ 1024 - 655360ʾԶ
    EM_OSN_STATUS            tunnelStatus;
    const char*              pdeviceId;             // 豸ID
    BYTE                     Reserved[64];          // 
}OSN_IN_DESTROY_TUNNEL_PARAM, *LOSN_IN_DESTROY_TUNNEL_PARAM;

//̨Ծ۽Ӧṹ
typedef struct tagPTZ_Focus_Absolutely
{
    DWORD                    dwValue;               //̨۽λ,ȡֵΧ(0~8191)
    DWORD                    dwSpeed;               //̨۽ٶ,ȡֵΧ(0~7)
    char                     szReserve[64];         //Ԥ64ֽ
}PTZ_FOCUS_ABSOLUTELY;

// CLIENT_PlayAudioFile ӿ
typedef struct tagNET_IN_PLAY_AUDIO_FILE
{
    DWORD                   dwSize;
    const char*             pszFilePath;            // ļ·
    DWORD                   dwOutput;               // ;, Ƕ, λʾ, bit0-mic, bit1-speaker
} NET_IN_PLAY_AUDIO_FILE;

// CLIENT_PlayAudioFile ӿ
typedef struct tagNET_OUT_PLAY_FILE_STREAM
{
    DWORD                   dwSize;
} NET_OUT_PLAY_AUDIO_FILE;

// RTSP URLϢбṹ
typedef struct tagNET_DEV_RTSPURL_LIST
{
    DWORD                   dwSize;
    int                     nChannelID;                                 // ͨ(û)
    int                     nUrlNum;                                    // Urlַ
    char                    szURLList[DH_MAX_URL_NUM][DH_MAX_URL_LEN];  // Urlַб
}NET_DEV_RTSPURL_LIST;

// ̨-ɨӦṹ
typedef struct tagPTZ_Control_SectorScan
{
    int             nBeginAngle;                    //ʼǶ,Χ:[-180,180]
    int             nEndAngle;                      //Ƕ,Χ:[-180,180]
    int             nSpeed;                         //ٶ,Χ:[0,255]
    char            szReserve[64];                  //Ԥ64ֽ
}PTZ_CONTROL_SECTORSCAN;

// ۵̨Ϣ
typedef struct tagPTZ_CONTROL_SET_FISHEYE_EPTZ
{
    DWORD           dwSize;                         // ṹС
    DWORD           dwWindowID;                     // EPtzƵĴڱ
    DWORD           dwCommand;                      // ̨
    DWORD           dwParam1;                       // Ӧ1
    DWORD           dwParam2;                       // Ӧ2
    DWORD           dwParam3;                       // Ӧ3
    DWORD           dwParam4;                       // Ӧ4
}PTZ_CONTROL_SET_FISHEYE_EPTZ;

// CLIENT_TransmitInfoForWeb ӿչ
typedef struct tagNET_TRANSMIT_EXT_INFO
{
    DWORD           dwSize;
    unsigned char*  pInBinBuf;                      // ݻ
    DWORD           dwInBinBufSize;                 // ݳ
} NET_TRANSMIT_EXT_INFO;

// CAN
// fAttachProxyCB 
typedef struct tagNET_CB_CANDATA
{
    DWORD           dwSize;
    int             nDataLength;                    // ͨݳ
    unsigned char*  pDataContent;                   // ͨ
}NET_CB_CANDATA;

// CANݻصԭΣlAttachHandleCLIENT_AttachCANֵ
typedef void (CALLBACK *fAttachCANCB) (LLONG lLoginID, LLONG lAttachHandle, NET_CB_CANDATA* pBuf, LDWORD dwUser);

// CLIENT_AttachCAN()
typedef struct tagNET_IN_ATTACH_CAN
{
    DWORD          dwSize;
    int            nChannel;                        // CANͨ
    fAttachCANCB   cbAttachCAN;                     // עƵ绰״̬仯ص
    LDWORD         dwUser;                          // û
}NET_IN_ATTACH_CAN;

// CLIENT_AttachCAN()
typedef struct tagNET_OUT_ATTACH_CAN
{
    DWORD          dwSize;
}NET_OUT_ATTACH_CAN;

// CLIENT_SendCAN()
typedef struct tagNET_IN_SEND_CAN
{
    DWORD          dwSize;
    int            nChannel;                       // CANͨ
	int            nSendDataLength;                // ݳ
    unsigned char* pSendData;                      // 
}NET_IN_SEND_CAN;

// CLIENT_SendCAN()
typedef struct tagNET_OUT_SEND_CAN
{
    DWORD          dwSize;
}NET_OUT_SEND_CAN;

// ͸ݻصfAttachDevCommCB 
typedef struct tagNET_CB_DEVCOMMDATA
{
    DWORD           dwSize;
    int             nDataLength;                    // ͨݳ
    unsigned char*  pDataContent;                   // ͨ
}NET_CB_DEVCOMMDATA;

// ͸ݻصԭΣlAttachHandleCLIENT_AttachDevCommֵ
typedef void (CALLBACK *fAttachDevCommCB) (LLONG lLoginID, LLONG lAttachHandle, NET_CB_DEVCOMMDATA* pBuf, LDWORD dwUser);

// CLIENT_AttachDevComm()
typedef struct tagNET_IN_ATTACH_DEVCOMM
{
    DWORD               dwSize;
    int                 nChannel;                        // ͸ں
    fAttachDevCommCB    cbAttachDevComm;                 // ע͸ݻص
    LDWORD              dwUser;                          // û
}NET_IN_ATTACH_DEVCOMM;

// CLIENT_AttachDevComm()
typedef struct tagNET_OUT_ATTACH_DEVCOMM
{
    DWORD          dwSize;
}NET_OUT_ATTACH_DEVCOMM;

// ȡǰ豸ڸӦCLIENT_QueryDevState()ӿڵ DH_DEVSTATE_GET_COMM_COUNT 
typedef struct tagNET_GET_COMM_COUNT
{
    DWORD          dwSize;
    int            nChannelCout;                    // ȡĴ
}NET_GET_COMM_COUNT;

// CLIENT_ExChangeData ӿṹ
typedef struct tagNET_IN_EXCHANGEDATA
{
    DWORD           dwSize;
    int             nChannel;                       // ں
    BOOL            bFlag;                          // TRUE ΪݲȴظFALSE ֻǲɼ
    int             nCollectTime;                   // ڲɼʱ(λ)
    int             nSendDataLength;                // ݳȣbFlag = TRUE Ч
    unsigned char*  pSendData;                      // ݣbFlag = TRUE Ч
}NET_IN_EXCHANGEDATA;

// CLIENT_ExChangeData ӿṹ
typedef struct tagNET_OUT_EXCHANGEDATA
{
    DWORD           dwSize;
}NET_OUT_EXCHANGEDATA;

// ̨Ԥõ
typedef struct tagNET_PTZ_PRESET 
{
    int                     nIndex;                         // 
    char                    szName[PTZ_PRESET_NAME_LEN];    // 
    char                    szReserve[64];                  // Ԥ64ֽ
} NET_PTZ_PRESET;

// ̨Ԥõб
typedef struct tagNET_PTZ_PRESET_LIST 
{
    DWORD                   dwSize;
    DWORD                   dwMaxPresetNum;                 // Ԥõ
    DWORD                   dwRetPresetNum;                 // Ԥõ
    NET_PTZ_PRESET          *pstuPtzPorsetList;             // Ԥõб(Ҫڴ)
} NET_PTZ_PRESET_LIST;

// ¼ EVENT_IVS_TRAFFIC_RESTRICTED_PLATE (޳¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_RESTRICTED_PLATE
{
    int                     nChannelID;                     // ͨ
    char                    szName[DH_EVENT_NAME_LEN];      // ¼
    int                     nTriggerType;                   // TriggerType:ͣ01״2Ƶ
    DWORD                   PTS;                            // ʱ(λǺ)
    NET_TIME_EX             UTC;                            // ¼ʱ
    int                     nEventID;                       // ¼ID
    int                     nSequence;                      // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    BYTE                    byEventAction;                  // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                    byImageIndex;                   // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    BYTE                    byReserved1[2];
    int                     nLane;                          // Ӧ
    DH_MSG_OBJECT           stuObject;                      // ⵽
    DH_MSG_OBJECT           stuVehicle;                     // Ϣ
    DH_EVENT_FILE_INFO      stuFileInfo;                    // ¼ӦļϢ
    int                     nMark;                          // ײĴץ֡
    int                     nFrameSequence;                 // Ƶ֡
    int                     nSource;                        // ƵԴַ
    DWORD                   dwSnapFlagMask;                 // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO      stuResolution;                  // ӦͼƬķֱ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stuTrafficCar;        // ͨϢ
    BYTE                    byReserved[1024];               // ֽ
    EVENT_COMM_INFO         stCommInfo;                     // Ϣ
}DEV_EVENT_TRAFFIC_RESTRICTED_PLATE;

// ¼ EVENT_IVS_TRAFFIC_OVERSTOPLINE (ѹͣ¼)ӦݿϢ
typedef struct tagDEV_EVENT_TRAFFIC_OVERSTOPLINE
{
    int                     nChannelID;                     // ͨ
    char                    szName[DH_EVENT_NAME_LEN];      // ¼
    int                     nTriggerType;                   // TriggerType:ͣ01״2Ƶ
    DWORD                   PTS;                            // ʱ(λǺ)
    NET_TIME_EX             UTC;                            // ¼ʱ
    int                     nEventID;                       // ¼ID
    int                     nSequence;                      // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    BYTE                    byEventAction;                  // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                    byImageIndex;                   // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    BYTE                    byReserved1[2];
    int                     nLane;                          // Ӧ
    DH_MSG_OBJECT           stuObject;                      // ⵽
    DH_MSG_OBJECT           stuVehicle;                     // Ϣ
    DH_EVENT_FILE_INFO      stuFileInfo;                    // ¼ӦļϢ
    int                     nMark;                          // ײĴץ֡
    int                     nFrameSequence;                 // Ƶ֡
    int                     nSource;                        // ƵԴַ
    DWORD                   dwSnapFlagMask;                 // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO      stuResolution;                  // ӦͼƬķֱ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stuTrafficCar;        // ͨϢ
    int                     nSpeed;                         // ʵٶ,Km/h
    BYTE                    byReserved[1024];               // ֽ
    EVENT_COMM_INFO         stCommInfo;                     // Ϣ

}DEV_EVENT_TRAFFIC_OVERSTOPLINE;


typedef enum tagNET_SAFEBELT_STATE
{
    SS_NUKNOW   = 0 ,       //δ֪
    SS_WITH_SAFE_BELT ,     //ϵȫ  
    SS_WITHOUT_SAFE_BELT ,  //δϵȫ
}NET_SAFEBELT_STATE;

// ¼EVENT_IVS_TRAFFIC_WITHOUT_SAFEBELT(ͨδϵȫ¼¼)ӦݿϢ
typedef struct  tagDEV_EVENT_TRAFFIC_WITHOUT_SAFEBELT
{
    int                     nChannelID;                     // ͨ
    char                    szName[DH_EVENT_NAME_LEN];      // ¼
    int                     nTriggerType;                   // TriggerType:ͣ01״2Ƶ
    DWORD                   PTS;                            // ʱ(λǺ)
    NET_TIME_EX             UTC;                            // ¼ʱ
    int                     nEventID;                       // ¼ID
    int                     nSequence;                      // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    BYTE                    byEventAction;                  // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;    BYTE                    byReserved1[2];
    BYTE                    byImageIndex;                   // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    BYTE                    byReserved1[2];
    DH_EVENT_FILE_INFO      stuFileInfo;                    // ¼ӦļϢ
    int                     nLane;                          // Ӧ
    int                     nMark;                          // ײĴץ֡
    int                     nFrameSequence;                 // Ƶ֡
    int                     nSource;                        // ƵԴַ
    DH_MSG_OBJECT           stuObject;                      // ⵽
    DH_MSG_OBJECT           stuVehicle;                     // Ϣ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stuTrafficCar;        // ͨϢ
    int                     nSpeed;                         // ʵٶ,Km/h
    NET_SAFEBELT_STATE      emMainSeat;                     // ʻλȫ״̬
    NET_SAFEBELT_STATE      emSlaveSeat;                    // ʻλȫ״̬
    DWORD                   dwSnapFlagMask;                 // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO      stuResolution;                  // ӦͼƬķֱ
    BYTE                    byReserved[1024];               // ֽ
    EVENT_COMM_INFO         stCommInfo;                     // Ϣ

}DEV_EVENT_TRAFFIC_WITHOUT_SAFEBELT;

// ¼EVENT_IVS_TRAFFIC_DRIVER_SMOKING (ʻԱ¼)ӦݿϢ
typedef struct  tagDEV_EVENT_TRAFFIC_DRIVER_SMOKING
{
    int                     nChannelID;                     // ͨ
    char                    szName[DH_EVENT_NAME_LEN];      // ¼
    int                     nTriggerType;                   // TriggerType:ͣ01״2Ƶ
    DWORD                   PTS;                            // ʱ(λǺ)
    NET_TIME_EX             UTC;                            // ¼ʱ
    int                     nEventID;                       // ¼ID
    int                     nSequence;                      // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    BYTE                    byEventAction;                  // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;    BYTE                    byReserved1[2];
    BYTE                    byImageIndex;                   // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    BYTE                    byReserved1[2];
    DH_EVENT_FILE_INFO      stuFileInfo;                    // ¼ӦļϢ
    int                     nLane;                          // Ӧ
    int                     nMark;                          // ײĴץ֡
    int                     nFrameSequence;                 // Ƶ֡
    int                     nSource;                        // ƵԴַ
    DH_MSG_OBJECT           stuObject;                      // ⵽
    DH_MSG_OBJECT           stuVehicle;                     // Ϣ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stuTrafficCar;        // ͨϢ
    int                     nSpeed;                         // ʵٶ,Km/h
    DWORD                   dwSnapFlagMask;                 // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO      stuResolution;                  // ӦͼƬķֱ
    EVENT_COMM_INFO         stCommInfo;                     // Ϣ
    BYTE                    byReserved[1024];               // ֽ
}DEV_EVENT_TRAFFIC_DRIVER_SMOKING;

// ¼EVENT_IVS_TRAFFIC_DRIVER_CALLING(ʻԱ绰¼)ӦݿϢ
typedef struct  tagDEV_EVENT_TRAFFIC_DRIVER_CALLING
{
    int                     nChannelID;                     // ͨ
    char                    szName[DH_EVENT_NAME_LEN];      // ¼
    int                     nTriggerType;                   // TriggerType:ͣ01״2Ƶ
    DWORD                   PTS;                            // ʱ(λǺ)
    NET_TIME_EX             UTC;                            // ¼ʱ
    int                     nEventID;                       // ¼ID
    int                     nSequence;                      // ʾץţ3,2,1,1ʾץĽ,0ʾ쳣
    BYTE                    byEventAction;                  // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;    BYTE                    byReserved1[2];
    BYTE                    byImageIndex;                   // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    BYTE                    byReserved1[2];
    DH_EVENT_FILE_INFO      stuFileInfo;                    // ¼ӦļϢ
    int                     nLane;                          // Ӧ
    int                     nMark;                          // ײĴץ֡
    int                     nFrameSequence;                 // Ƶ֡
    int                     nSource;                        // ƵԴַ
    DH_MSG_OBJECT           stuObject;                      // ⵽
    DH_MSG_OBJECT           stuVehicle;                     // Ϣ
    DEV_EVENT_TRAFFIC_TRAFFICCAR_INFO stuTrafficCar;        // ͨϢ
    int                     nSpeed;                         // ʵٶ,Km/h
    DWORD                   dwSnapFlagMask;                 // ץͼ־(λ)NET_RESERVED_COMMON    
    DH_RESOLUTION_INFO      stuResolution;                  // ӦͼƬķֱ
    EVENT_COMM_INFO         stCommInfo;                     // Ϣ
    BYTE                    byReserved[1024];               // ֽ
}DEV_EVENT_TRAFFIC_DRIVER_CALLING;

// ¼EVENT_IVS_OBJECT_DETECTION(¼)ӦݿϢ
typedef struct  tagDEV_EVENT_TRAFFIC_OBJECT_DETECTION
{
    int                 nChannelID;                         // ͨ
    char                szName[128];                        // ¼
    char                bReserved1[4];                      // ֽڶ
    double              PTS;                                // ʱ(λǺ)
    NET_TIME_EX         UTC;                                // ¼ʱ
    int                 nEventID;                           // ¼ID
    DH_EVENT_FILE_INFO  stuFileInfo;                        // ¼ӦļϢ
    BYTE                bEventAction;                       // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byReserved[2];                      // ֽ
    BYTE                byImageIndex;                       // ͼƬ, ͬһʱ(ȷ)жͼƬ, 0ʼ
    DWORD               dwSnapFlagMask;                     // ץͼ־(λ)NET_RESERVED_COMMON    
    int                 nSourceIndex;                       // ¼Դ豸ϵindex,-1ʾЧ
    char                szSourceDevice[MAX_PATH];           // ¼Դ豸Ψһʶ,ֶβڻΪձʾ豸
    unsigned int        nOccurrenceCount;                   // ¼ۼƴ

    int                 nObjectNum;          //Ϣ
    DH_MSG_OBJECT_EX   *pstObjectInfo;       //Ϣ  
    BYTE                byReserved2[1024];   //ֽ
}DEV_EVENT_TRAFFIC_OBJECT_DETECTION;

// Դ쳣
typedef struct tagALARM_POWER_ABNORMAL_INFO
{
    DWORD                   dwSize;
    int                     nChannelID;                     // ͨ
    NET_TIME                stuTime;                        // ʱ
    DWORD                   dwAction;                       // ¼, 0:Start, 1:Stop
}ALARM_POWER_ABNORMAL_INFO;

// ̬ʹ
typedef enum tagNET_THREE_STATE_ENABLE
{
    EM_STATE_ENABLE_INVALID = 0,            // Ч
    EM_STATE_ENABLE_OFF,                    // 
    EM_STATE_ENABLE_ON,                     // 
} NET_THREE_STATE_ENABLE;

// ʹܸıϱ¼
typedef struct tagCONFIG_ENABLE_CHANGE_INFO
{
    DWORD                   dwSize;
    int                     nChannelID;                     // ͨ, 0ʼ
    NET_THREE_STATE_ENABLE  emMotionDetect;                 // ʹ,     0:Ч, 1:ʹܹر, 2:ʹܴ
    NET_THREE_STATE_ENABLE  emLossDetect;                   // Ƶʧʹ, 0:Ч, 1:ʹܹر, 2:ʹܴ
    NET_THREE_STATE_ENABLE  emBlindDetect;                  // Ƶڵʹ, 0:Ч, 1:ʹܹر, 2:ʹܴ
    NET_THREE_STATE_ENABLE  emAlarmLocal;                   // ⲿʹ, 0:Ч, 1:ʹܹر, 2:ʹܴ
}ALARM_CONFIG_ENABLE_CHANGE_INFO;

#define UPDATE_VERSION_LEN        64

// ȡ豸״̬Ӧṹ
typedef struct tagDHDEV_UPGRADE_STATE_INFO
{
    int                  nState;                            // 0:None-ûм⵽, Ĭ״̬; 1:Regular-һ; 
                                                            // 2:Emergency-ǿ; 3:Upgrading-
    
    char                szOldVersion[UPDATE_VERSION_LEN];   // ɰ汾
    char                szNewVersion[UPDATE_VERSION_LEN];   // °汾
    DWORD               dwProgress;                         // 
    int                 reserved[256];                      // ֶ
}DHDEV_UPGRADE_STATE_INFO;


///////////////////////////////// ¼Ự /////////////////////////////////////////

// CLIENT_StartBurnSession ӿ
typedef struct tagNET_IN_START_BURN_SESSION 
{
    DWORD               dwSize;
    unsigned int        nSessionID;                         // ỰID
} NET_IN_START_BURN_SESSION;

typedef struct tagNET_OUT_START_BURN_SESSION 
{
    DWORD               dwSize;
} NET_OUT_START_BURN_SESSION;

// ¼ģʽ
typedef enum tagNET_BURN_MODE
{
    BURN_MODE_SYNC,                     // ͬ
    BURN_MODE_TURN,                     // 
    BURN_MODE_CYCLE,                    // ѭ
} NET_BURN_MODE;

// ¼ʽ
typedef enum tagNET_BURN_RECORD_PACK
{
    BURN_PACK_DHAV,                     // DHAV
    BURN_PACK_PS,                       // PS
    BURN_PACK_ASF,                      // ASF
    BURN_PACK_MP4,                      // MP4
    BURN_PACK_TS,                       // TS
} NET_BURN_RECORD_PACK;

// CLIENT_StartBurn ӿ
typedef struct tagNET_IN_START_BURN 
{
    DWORD                dwSize;
    DWORD                dwDevMask;                             // ¼豸, λʾ¼豸
    int                  nChannels[DH_MAX_BURN_CHANNEL_NUM];    // ¼ͨ
    int                  nChannelCount;                         // ¼ͨ
    NET_BURN_MODE        emMode;                                // ¼ģʽ
    NET_BURN_RECORD_PACK emPack;                                // ¼ʽ
} NET_IN_START_BURN;

// CLIENT_StartBurn ӿ
typedef struct tagNET_OUT_START_BURN 
{
    DWORD               dwSize;
} NET_OUT_START_BURN;

// CLIENT_BurnMarkTag ӿ
typedef struct tagNET_IN_BURN_MAAK_TAG
{
    DWORD               dwSize;
    const char*         pszDescInfo;                            // Ϣ
} NET_IN_BURN_MARK_TAG;

// CLIENT_BurnMarkTag ӿ
typedef struct tagNET_OUT_BURN_MAAK_TAG
{
    DWORD               dwSize;
} NET_OUT_BURN_MARK_TAG;

// CLIENT_BurnChangeDisk ӿ
typedef struct tagNET_IN_BURN_CHANGE_DISK
{
    DWORD               dwSize;
    BOOL                nAction;                                // ̶, 0-ʼ, 1-
} NET_IN_BURN_CHANGE_DISK;

// CLIENT_BurnChangeDisk ӿ
typedef struct tagNET_OUT_BURN_CHANGE_DISK
{
    DWORD               dwSize;
} NET_OUT_BURN_CHANGE_DISK;

// ¼״̬
typedef enum tagNET_BURN_STATE
{
    BURN_STATE_STOP,                    // ֹͣ
    BURN_STATE_STOPING,                 // ֹͣ
    BURN_STATE_INIT,                    // ʼ
    BURN_STATE_BURNING,                 // ¼
    BURN_STATE_PAUSE,                   // ͣ
    BURN_STATE_CHANGE_DISK,             // 
    BURN_STATE_PREPARE_EXTRA_FILE,      // ʼ
    BURN_STATE_WAIT_EXTRA_FILE,         // ȴ¼
    BURN_STATE_UPLOAD_FILE_START,       // ¼
    BURN_STATE_CHECKING_DISK,           // 
    BURN_STATE_DISK_READY,              // ׼
} NET_BURN_STATE;

// ¼
typedef enum tagNET_BURN_ERROR_CODE
{
    BURN_CODE_NORMAL,                   // 
    BURN_CODE_UNKNOWN_ERROR,            // δ֪
    BURN_CODE_SPACE_FULL,               // ¼
    BURN_CODE_START_ERROR,              // ʼ¼
    BURN_CODE_STOP_ERROR,               // 
    BURN_CODE_WRITE_ERROR,              // ¼
} NET_BURN_ERROR_CODE;

// CLIENT_BurnGetState ӿ
typedef struct tagNET_IN_BURN_GET_STATE
{
    DWORD                dwSize;
} NET_IN_BURN_GET_STATE;

// ¼豸״̬
typedef struct tagNET_BURN_DEV_STATE 
{
    DWORD                dwSize;
    int                  nDeviceID;                             // 豸ID
    char                 szDevName[DH_BURNING_DEV_NAMELEN];     // 豸
    DWORD                dwTotalSpace;                          // , λKB
    DWORD                dwRemainSpace;                         // ʣ, λKB
} NET_BURN_DEV_STATE;

// CLIENT_BurnGetState ӿ
typedef struct tagNET_OUT_BURN_GET_STATE
{
    DWORD                dwSize;
    NET_BURN_STATE       emState;                               // ¼״̬
    NET_BURN_ERROR_CODE  emErrorCode;                           // 
    DWORD                dwDevMask;                             // ¼豸, λʾ¼豸
    int                  nChannels[DH_MAX_BURN_CHANNEL_NUM];    // ¼ͨ
    int                  nChannelCount;                         // ¼ͨ
    NET_BURN_MODE        emMode;                                // ¼ģʽ
    NET_BURN_RECORD_PACK emPack;                                // ¼ʽ
    int                  nFileIndex;                            // ǰ¼ļ
    NET_TIME             stuStartTime;                          // ¼ʼʱ
    NET_BURN_DEV_STATE   stuDevState[DH_MAX_BURNING_DEV_NUM];   // ¼豸״̬
} NET_OUT_BURN_GET_STATE;

// fAttachBurnStateCB 
typedef struct tagNET_CB_BURNSTATE
{
    DWORD               dwSize;
    const char*         szState;                        // Ϣ
                                                        //"UploadFileStart"Կʼϴ
                                                        //"InitBurnDevice":ʼ¼豸
                                                        //"Burning":¼
                                                        //"BurnExtraFileStop"¼ֹͣ
                                                        //"BurnFilePause":¼ͣ
                                                        //"SpaceFull":¼ռ
                                                        //"BurnFileError":¼    
    const char*         szFileName;                     // ǰ¼ļ,"UploadFileStart"ʼϴϢ
    unsigned int        dwTotalSpace;                   // ,λKB"Burning"¼Уʾ
    unsigned int        dwRemainSpace;                  // ʣ,λKB"Burning"¼
    const char*         szDeviceName;                   // ¼豸,ֲͬĿ¼豸
}NET_CB_BURNSTATE;

// ¼豸صԭΣlAttachHandleCLIENT_AttachBurnStateֵ, ÿ1pBuf->dwSize == nBufLen
typedef void (CALLBACK *fAttachBurnStateCB) (LLONG lLoginID, LLONG lAttachHandle, NET_CB_BURNSTATE* pBuf, int nBufLen, LDWORD dwUser);

// ¼豸صչԭ
typedef void (CALLBACK *fAttachBurnStateCBEx)(LLONG lLoginID, LLONG lAttachHandle, NET_OUT_BURN_GET_STATE* pBuf, int nBufLen, LDWORD dwUser);

// CLIENT_AttachBurnState()
typedef struct tagNET_IN_ATTACH_STATE
{
    DWORD                   dwSize;
    const char*             szDeviceName;                   // ƣ"/dev/sda"
    fAttachBurnStateCB      cbAttachState;                  // ¼ص
    LDWORD                  dwUser;                         // û
    LLONG                   lBurnSession;                   // ¼Ự, CLIENT_StartBurnSessionķֵ. ֵΪ0ʱ, szDeviceNameЧ, ʱ¼豸Ŀ¼״̬
    fAttachBurnStateCBEx    cbAttachStateEx;                // չ¼ص
    LDWORD                  dwUserEx;                       // չ¼صû
}NET_IN_ATTACH_STATE;

// CLIENT_AttachBurnState 
typedef struct tagNET_OUT_ATTACH_STATE
{
    DWORD                   dwSize;
}NET_OUT_ATTACH_STATE;

// ¼豸صԭΣlUploadHandleCLIENT_StartUploadFileBurnedֵ
typedef void (CALLBACK *fBurnFileCallBack) (LLONG lLoginID, LLONG lUploadHandle, int nTotalSize, int nSendSize, LDWORD dwUser);

// CLIENT_StartUploadFileBurned()
typedef struct tagNET_IN_FILEBURNED_START
{
    DWORD                   dwSize;
    const char*             szMode;                         // ļϴʽ
                                                            // "append", ׷ģʽ,ʱ¼ļ̶Ϊ" FILE.zip ",filename
                                                            // "evidence", ֤ݵȴ󸽼, Ҫ󵥶¼Ĺ
    const char*             szDeviceName;                   // ƣ硰/dev/sda
    const char*             szFilename;                     // ļ
    fBurnFileCallBack       cbBurnPos;                      // ¼Ȼص
    LDWORD                  dwUser;                         // û
    LLONG                   lBurnSession;                   // ¼, CLIENT_StartBurnSessionķֵ. ֵΪ0ʱ, szDeviceNameЧ, ʱ¼豸Ŀ¼״̬
}NET_IN_FILEBURNED_START;

// CLIENT_StartUploadFileBurned 
typedef struct tagNET_OUT_FILEBURNED_START
{
    DWORD                   dwSize;
    char                    szState[DH_MAX_NAME_LEN];      // "start"ϵͳ׼,Կʼϴ; "busy"ϵͳæ,Ժԡ"error"ϵͳδڿ¼,س,ʧ
}NET_OUT_FILEBURNED_START;

// ¼Ϣ
typedef struct tagNET_BURN_CASE_INFO
{
    DWORD       dwSize;
    int         nChannel;                                   // ͨ
    NET_TIME    stuStartTime;                               // ¼ʼʱ
    NET_TIME    stuEndTime;                                 // ¼ʱ
    int         nIndex;                                     // 
    int         nCode;                                      // 
    int         nDiscNum;                                   // ̱        
    char        szName[DH_COMMON_STRING_128];               // 
    char        szPlace[DH_COMMON_STRING_128];              // 참ص
    char        szInvestigator[DH_MAX_CASE_PERSON_NUM][DH_COMMON_STRING_32]; // 참Ա
    char        szSuspects[DH_MAX_CASE_PERSON_NUM][DH_COMMON_STRING_32];     // 永Ա
    char        szMemo[DH_COMMON_STRING_256];               // ע
    char        szVideoName[DH_COMMON_STRING_128];          // ¼
    char        szRecorder[DH_COMMON_STRING_32];            // ¼
} NET_BURN_CASE_INFO;

// ¼豸صԭΣlAttachHandleCLIENT_AttachBurnCaseֵ
typedef void (CALLBACK *fBurnCaseCallBack) (LLONG lAttachHandle, NET_BURN_CASE_INFO* pBuf, DWORD dwBufLen, void* pReserved, LDWORD dwUser);

// CLIENT_AttachBurnCase ӿ
typedef struct tagNET_IN_ATTACH_BURN_CASE
{
    DWORD                dwSize;
    fBurnCaseCallBack    cbBurnCase;                        // Ϣص
    LDWORD               dwUser;                            // û
} NET_IN_ATTACH_BURN_CASE;

// CLIENT_AttachBurnCase ӿ
typedef struct tagNET_OUT_ATTACH_BURN_CASE
{
    DWORD                dwSize;
} NET_OUT_ATTACH_BURN_CASE;

/////////////////////////////////// Storage ///////////////////////////////////////

// Զ̴洢д
typedef enum tagNET_STORAGE_WRITE_STATE
{
    NS_WRITE_UNKNOWN,                                   // δ֪
    NS_WRITE_OK,                                        // ɹ
    NS_WRITE_DISK_IO_ERROR,                             // IO
    NS_WRITE_DISK_NOT_READY,                            // δ׼
    NS_WRITE_DISK_FAULT,                                // ̹
    NS_WRITE_STREAM_NOT_EXIST,                          // ID
    NS_WRITE_MOUNT_DISK_ERROR,                          // ̹ش
} NET_STORAGE_WRITE_STATE;

// ԶϢ
typedef struct tagNET_STORAGE_BLOCK 
{
    DWORD                   dwSize;
    unsigned int            nID;                        // CQFSID
    unsigned int            nStreamID;                  // Ψһʶ
    unsigned int            nRecycleTimestamp;          // CQFSʱ
    unsigned int            nBeginTimestamp;            // ݿʼʱ
    unsigned int            nEndTimestamp;              // ݽʱ
    unsigned int            nLockCount;                 // ֵ, 0ʾδ
    char                    szDiskUUID[DH_COMMON_STRING_64]; // UUID
} NET_STORAGE_BLOCK;

// Զ̴洢Ϣ״̬
typedef struct tagNET_STORAGE_WRITE_INFO
{
    DWORD                    dwSize;
    NET_STORAGE_WRITE_STATE  emState;                   // д
    int                      nBlockCount;               // 
    NET_STORAGE_BLOCK        stuBlocks[DH_MAX_NET_STRORAGE_BLOCK_NUM]; // Ϣ
} NET_STORAGE_WRITE_INFO;

//////////////////////////////////////////////////////////////////////////
/// \fn дԶ̴洢Ϣ״̬ص
/// \brief 
/// \author yang_xiuqing
/// \param  LLONG lAttachHandle [OUT] ľ, CLIENT_NetStorageAttachWriteInfoķֵ 
/// \param  NET_STORAGE_WRITE_INFO * pBuf [OUT] Զ̴洢Ϣ״̬
/// \param  int nBufLen [OUT] ״̬Ϣ
/// \param  LDWORD dwUser û
/// \return 
///////////////////////////////////////////////////////////////////////////
typedef void (CALLBACK *fNetStorageAttachWriteInfoCB)(LLONG lAttachHandle, NET_STORAGE_WRITE_INFO* pBuf, int nBufLen, LDWORD dwUser);

// CLIENT_NetStorageAttachWriteInfo ӿ
typedef struct tagNET_IN_STORAGE_ATTACH_WRITE_INFO
{
    DWORD                           dwSize;
    const char*                     pszName;                // Զ̴洢, ֵNASлȡ
    fNetStorageAttachWriteInfoCB    cbISCSIBlcok;           // ص
    LDWORD                          dwUser;                 // û
} NET_IN_STORAGE_ATTACH_WRITE_INFO;

// CLIENT_NetStorageAttachWriteInfo ӿ
typedef struct tagNET_OUT_STORAGE_ATTACH_WRITE_INFO
{
    DWORD                       dwSize;
} NET_OUT_STORAGE_ATTACH_WRITE_INFO;

// CLIENT_NetStorageGetWriteInfo ӿ
typedef struct tagNET_IN_STORAGE_GET_WRITE_INFO 
{
    DWORD                       dwSize;
    const char*                 pszName;                    // Զ̴洢
} NET_IN_STORAGE_GET_WRITE_INFO;

// CLIENT_NetStorageGetWriteInfo ӿ
typedef struct tagNET_OUT_STORAGE_GET_WRITE_INFO 
{
    DWORD                       dwSize;    
    int                         nBlockCount;                // 
    NET_STORAGE_BLOCK           stuBlocks[DH_MAX_NET_STRORAGE_BLOCK_NUM]; // Ϣ
} NET_OUT_STORAGE_GET_WRITE_INFO;

// RAID
typedef enum tagNET_RAID_OPERATE_TYPE
{
    NET_RAID_OPERATE_ADD,                    // RAID, Ӧṹ NET_IN_RAID_ADD  NET_OUT_RAID_ADD
    NET_RAID_OPERATE_REMOVE,                 // ɾRAID, Ӧṹ NET_IN_RAID_REMOVE  NET_OUT_RAID_REMOVE
    NET_RAID_OPERATE_GET_SUBDEVICE,          // ȡRAID豸Ϣ, Ӧṹ NET_IN_RAID_GET_SUBDEVICE  NET_OUT_RAID_GET_SUBDEVICE
    NET_RAID_OPERATE_GET_SUBSMART,           // ȡRAID豸SMARTϢ, Ӧṹ NET_IN_RAID_GET_SUBSMART  NET_OUT_RAID_GET_SUBSMART
    NET_RAID_OPERATE_MODIFY,                 // ޸RAID, Ӧṹ NET_IN_RAID_MODIFY  NET_OUT_RAID_MODIFY
} NET_RAID_OPERATE_TYPE;

// RAIDϢ
typedef struct tagNET_RAID_INFO 
{
    DWORD                dwSize;
    char                 szName[DH_COMMON_STRING_64];     // , Ϊʱ豸
    char                 szLevel[DH_COMMON_STRING_16];    // ȼ, "RAID0", "RAID5"
    int                  nMemberNum;                      // Ա
    char                 szMembers[DH_MAX_MEMBER_PER_RAID][DH_COMMON_STRING_64]; // ԱϢ
} NET_RAID_INFO;

// RAIDķؽ
typedef struct tagNET_RAID_ADD_RESULT 
{
    DWORD                dwSize;
    BOOL                 bResult;
    DWORD                dwErrorCode;                    // ʧܴ
    char                 szName[DH_COMMON_STRING_64];    // 
} NET_RAID_ADD_RESULT;

// RAID
typedef struct tagNET_IN_RAID_ADD 
{
    DWORD                dwSize;
    int                  nRaidNun;                          // RAID
    NET_RAID_INFO        stuRaids[DH_MAX_RAID_NUM];         // RAIDϢ
} NET_IN_RAID_ADD;

// RAID
typedef struct tagNET_OUT_RAID_ADD 
{
    DWORD                dwSize;
    int                  nResultNum;                        // 
    NET_RAID_ADD_RESULT  stuResults[DH_MAX_RAID_NUM];       // RAIDĽ
} NET_OUT_RAID_ADD;

// ɾRAIDķؽ
typedef struct tagNET_RAID_REMOVE_RESULT 
{
    DWORD                dwSize;
    BOOL                 bResult;
    DWORD                dwErrorCode;                       // ʧܴ
} NET_RAID_REMOVE_RESULT;

// ɾRAID
typedef struct tagNET_IN_RAID_REMOVE 
{
    DWORD                dwSize;
    int                  nRaidNum;                         // RAID
    char                 szRaids[DH_MAX_RAID_NUM][DH_COMMON_STRING_64];    // RAID
} NET_IN_RAID_REMOVE;

// ɾRAID
typedef struct tagNET_OUT_RAID_REMOVE
{
    DWORD                dwSize;
    int                  nResultNum;                       // 
    NET_RAID_REMOVE_RESULT stuResults[DH_MAX_RAID_NUM];    // RAIDĽ
} NET_OUT_RAID_REMOVE;

// ȡRAID豸Ϣ
typedef struct tagNET_IN_RAID_GET_SUBDEVICE 
{
    DWORD                dwSize;
    const char*          pszRaidName;                    // RAID
} NET_IN_RAID_GET_SUBDEVICE;

// ȡRAID豸Ϣ
typedef struct tagNET_OUT_RAID_GET_SUBDEVICE 
{
    DWORD                dwSize;
    int                  nSubDeviceNum;                  // 豸
    DH_STORAGE_DEVICE    stuSubDevices[DH_MAX_MEMBER_PER_RAID]; // 豸Ϣ
} NET_OUT_RAID_GET_SUBDEVICE;

// RAID豸SMARTϢ
typedef struct tagNET_RAID_SMART_INFO 
{
    DWORD                dwSize;
    unsigned int         nID;                            // ID
    char                 szName[DH_COMMON_STRING_64];    // 
    int                  nCurrent;                       // ֵ
    int                  nWorst;                         // ֵ
    int                  nThreshold;                     // ֵ
    int                  nPredict;                       // ״̬
    char                 szRaw[DH_COMMON_STRING_16];     // ʵֵ
} NET_RAID_SMART_INFO;

// ȡRAID豸SMARTϢ
typedef struct tagNET_IN_RAID_GET_SUBSMART
{
    DWORD                dwSize;
    const char*          pszSubDevName;                  // RAID豸
} NET_IN_RAID_GET_SUBSMART;

// ȡRAID豸SMARTϢ
typedef struct tagNET_OUT_RAID_GET_SUBSMART
{
    DWORD                dwSize;
    int                  nSmartNum;                          // SMARTϢ
    NET_RAID_SMART_INFO  stuSmartInfos[MAX_SMART_VALUE_NUM]; // SMARTϢ
} NET_OUT_RAID_GET_SUBSMART;

// ޸RAIDķؽ
typedef struct tagNET_RAID_MODIFY_RESULT 
{
    DWORD                dwSize;
    BOOL                 bResult;
    DWORD                dwErrorCode;                       // ʧܴ
} NET_RAID_MODIFY_RESULT;

// ޸RAID
typedef struct tagNET_IN_RAID_MODIFY
{
    DWORD                dwSize;
    int                  nRaidNun;                          // RAID
    NET_RAID_INFO        stuRaids[DH_MAX_RAID_NUM];         // RAIDϢ
} NET_IN_RAID_MODIFY;

// ޸RAID
typedef struct tagNET_OUT_RAID_MODIFY 
{
    DWORD                dwSize;
    int                  nResultNum;                        // 
    NET_RAID_MODIFY_RESULT stuResults[DH_MAX_RAID_NUM];     // RAIDĽ
} NET_OUT_RAID_MODIFY;


//////////////////////////////// ⲿ豸 //////////////////////////////////////////

// 豸
typedef enum tagNET_EXT_DEV_TYPE
{
    EXT_DEV_UNKNOWN,                    // δ֪
    EXT_DEV_PROJECTOR,                  // ͶӰ
    EXT_DEV_SEQUENCE_POWER,            // Դ
} NET_EXT_DEV_TYPE;

// 豸Ϣ
typedef struct tagNET_EXTERNAL_DEVICE 
{
    DWORD               dwSize;
    NET_EXT_DEV_TYPE    emType;                             // 豸
    char                szDevID[DH_DEV_ID_LEN_EX];          // 豸ID, Ψһ
    char                szDevName[DH_DEV_ID_LEN_EX];        // 豸
} NET_EXTERNAL_DEVICE;

// ԴʱƲ
typedef struct tagNET_CTRL_SEQPOWER_PARAM
{
    DWORD               dwSize;
    const char*         pszDeviceID;                        // 豸ID
    int                 nChannel;                           // ڻ
} NET_CTRL_SEQPOWER_PARAM;

// ͶӰǿƲ
typedef struct tagNET_CTRL_PROJECTOR_PARAM 
{
    DWORD               dwSize;
    const char*         pszDeviceID;                        // 豸ID
} NET_CTRL_PROJECTOR_PARAM;

// ⰴ
typedef struct tagNET_CTRL_INFRARED_KEY_PARAM 
{
    DWORD               dwSize;
    int                 nChannel;                           // ͨ
    unsigned int        nKey;                               // ⰴID
} NET_CTRL_INFRARED_KEY_PARAM;

// Ӳ̱
typedef struct tagALARM_NO_DISK_INFO
{
    DWORD               dwSize;
    NET_TIME            stuTime;                            // ʱ
    DWORD               dwAction;                           // ¼, 0:Start, 1:Stop
}ALARM_NO_DISK_INFO;
//״̬ö
typedef enum __EM_CAPSULE_STATE
{
    CAPSULE_STATE_UNKNOW ,      //δ
    CAPSULE_STATE_NORMAL ,      //
    CAPSULE_STATE_TIME_OUT ,    //ʱ
    CAPSULE_STATE_EMERGENCY_CALL,   //
}EM_CAPSULE_STATE;

//¼
typedef struct tagALARM_PROTECTIVE_CAPSULE_INFO
{
    DWORD               dwSize;
    EM_CAPSULE_STATE    emCapsuleState; //״̬
    DWORD               nLock;          //0:δ1:; emCapsuleStateΪCAPSULE_STATE_NORMALʱЧ
    DWORD               nInfrared;      //0:(),1:();emCapsuleStateΪCAPSULE_STATE_NORMALʱЧ
}ALARM_PROTECTIVE_CAPSULE_INFO;

// ȡ
typedef struct tagNET_IN_VIDEOIN_FISHEYE_CAPS
{
    DWORD                dwSize; 
    int                  nChannel;  //ͨ
}NET_IN_VIDEOIN_FISHEYE_CAPS;

// ȡ
typedef struct tagNET_OUT_VIDEOIN_FISHEYE_CAPS
{
    DWORD                       dwSize; 
    int                         nMountModeNum;                     // ֵ֧İװģʽ         
    NET_FISHEYE_MOUNT_MODE      emMountModes[NET_MAX_FISHEYE_MOUNTMODE_NUM]; // ֵ֧İװģʽб
    int                         nCalibrateModeNum;                 // ֵ֧۽ģʽ  
    NET_FISHEYE_CALIBRATE_MODE  emCalibrateModes[NET_MAX_FISHEYE_CALIBRATEMODE_NUM]; // ֵ֧۽ģʽб
    int                         nEPtzCmdNum;                       // ֵ֧۵̨ 
    NET_FISHEYE_EPTZ_CMD        emEPtzCmds[NET_MAX_FISHEYE_EPTZCMD_NUM]; // ֵ֧۵̨б
    NET_FISHEYE_TYPE            emType;                                 //
}NET_OUT_VIDEOIN_FISHEYE_CAPS;

// ȡԴʱ
typedef struct tagNET_IN_CAP_SEQPOWER 
{
    DWORD                dwSize;
    const char*          pszDeviceID;                       // 豸ID
} NET_IN_CAP_SEQPOWER;

// ȡԴʱ
typedef struct tagNET_OUT_CAP_SEQPOWER
{
    DWORD                dwSize;
    int                  nChannelNum;                       // ͨ
} NET_OUT_CAP_SEQPOWER;

// ȡ豸öӦ
typedef struct tagNET_IN_ENCODE_CFG_CAPS
{
    DWORD               dwSize;           
    int                 nChannelId;                         // ͨ    
    int                 nStreamType;                        // ͣ01122334ץͼ
    char*               pchEncodeJson;                      // Encodeãͨdhconfigsdk.dllнӿCLIENT_PacketDataװõ
                                                            // ӦķװΪ CFG_CMD_ENCODE                 
}NET_IN_ENCODE_CFG_CAPS;

// öӦ
typedef struct tagNET_STREAM_CFG_CAPS
{
    DWORD               dwSize;
    int                 nAudioCompressionTypes[DH_MAX_AUDIO_ENCODE_TYPE]; // ֵ֧ƵͣDH_TALK_CODING_TYPE
    int                 nAudioCompressionTypeNum;                   // Ƶѹʽ
    int                 dwEncodeModeMask;                           // Ƶģʽ룬"ģʽ"
    DH_RESOLUTION_INFO  stuResolutionTypes[DH_MAX_CAPTURE_SIZE_NUM];// ֵ֧Ƶֱ, 
    int                 nResolutionFPSMax[DH_MAX_CAPTURE_SIZE_NUM]; // ֱֵͬ֡±nResolutionTypesӦ 
    int                 nResolutionTypeNum;                         // Ƶֱʸ
    int                 nMaxBitRateOptions;                         // Ƶ(kbps) 
    int                 nMinBitRateOptions;                         // СƵ(kbps)
    BYTE                bH264ProfileRank[DH_PROFILE_HIGH];          // ֵ֧H.264 Profileȼö EM_H264_PROFILE_RANK;  
    int                 nH264ProfileRankNum;                        // ֵ֧H.264 Profileȼ
    int                 nCifPFrameMaxSize;                          // ֱΪcifʱp֡(Kbps)
    int                 nCifPFrameMinSize;                          // ֱΪcifʱСp֡(Kbps)
    int                 nFPSMax;                                    // Ƶֵ֡Ϊ0ʱnResolutionFPSMaxΪ׼
    DH_RESOLUTION_INFO  stuIndivResolutionTypes[DH_MAX_COMPRESSION_TYPES_NUM][DH_MAX_CAPTURE_SIZE_NUM];// ֵ֧Ƶֱ
}NET_STREAM_CFG_CAPS;

// ȡ豸öӦ
typedef struct tagNET_OUT_ENCODE_CFG_CAPS
{
    DWORD               dwSize;
    NET_STREAM_CFG_CAPS stuMainFormatCaps[DH_REC_TYPE_NUM];         // öӦ
    NET_STREAM_CFG_CAPS stuExtraFormatCaps[DH_N_ENCODE_AUX];        // öӦ
    NET_STREAM_CFG_CAPS stuSnapFormatCaps[SNAP_TYP_NUM];            // öӦ
}NET_OUT_ENCODE_CFG_CAPS;

// ¼
typedef struct tagALARM_FALLING_INFO
{
    DWORD               dwStructSize;                               // ṹС
    BYTE                bEventAction;                               // ¼0ʾ¼,1ʾ¼ʼ,2ʾ¼;
    BYTE                byRserved[3];                               //                                                                                                                                                                                                                                                                         
}ALARM_FALLING_INFO;

//Bus״̬صԭ
typedef void (CALLBACK *fBusStateCallBack)(LLONG lAttachHandle, LONG lCommand, char *pBuf, DWORD dwBufLen, LDWORD dwUser);

// ˢ
typedef enum tagNET_DRIVER_CHECK_TYPE
{
    NET_DRIVER_CHECK_TYPE_UNKNOWN,                                  // δ֪
    NET_DRIVER_CHECK_TYPE_SIGNIN,                                   // ǩ
    NET_DRIVER_CHECK_TYPE_SIGNOUT,                                  // ǩ
} NET_DRIVER_CHECK_TYPE;

// ˢʽ
typedef enum tagNET_DRIVER_CHECK_METHOD
{
    NET_DRIVER_CHECK_METHOD_UNKNOWN,                                // δ֪
    NET_DRIVER_CHECK_METHOD_POS,                                    // POS
    NET_DRIVER_CHECK_METHOD_HAND,                                   // ֶ
} NET_DRIVER_CHECK_METHOD;

// ¼DH_ALARM_BUS_DRIVER_CHECK( ˾ʶ𿨼¼)ӦϢ
typedef struct tagALARM_BUS_DRIVER_CHECK_INFO
{
    DWORD                   dwSize;
    char                    szCarNo[DH_MAX_PLATE_NUMBER_LEN];       // 
    char                    szDriverName[DH_COMMON_STRING_16];      // ˾
    char                    szDriverID[DH_MAX_PERSON_ID_LEN];       // 
    char                    szOrganize[DH_COMMON_STRING_128];       // ʻ֤֤
    NET_TIME_EX             stUsefulLife;                           // ֤Ч
    NET_GPS_STATUS_INFO     stGPSStatusInfo;                        // GPSϢ
    NET_TIME_EX             stCheckTime;                            // ʱ
    NET_DRIVER_CHECK_METHOD emCheckMethod;                          // 򿨷ʽ
    NET_DRIVER_CHECK_TYPE   emCheckType;                            // 
}ALARM_BUS_DRIVER_CHECK_INFO;

// ¼DH_ALARM_DEVICE_MSG_NOTIFY(豸ƽ̨֪ͨ¼)ӦϢ
typedef struct tagALARM_DEVICE_MSG_NOTIFY_INFO
{
    DWORD                   dwSize;
    char                    szMsg[DH_COMMON_STRING_256];            // Ϣ
    NET_GPS_STATUS_INFO     stuGPSStatusInfo;                       // GPSϢ
} ALARM_DEVICE_MSG_NOTIFY_INFO;

// ¼DH_ALARM_VEHICLE_STANDING_OVER_TIME(ͣʱ)ӦϢ
typedef struct tagALARM_VEHICLE_STANDING_OVER_TIME_INFO
{
    DWORD                   dwSize;
    NET_GPS_STATUS_INFO     stuGPSStatusInfo;                       // GPSϢ
    NET_TIME_EX             stuTime;                                // һηʱ
} ALARM_VEHICLE_STANDING_OVER_TIME_INFO;

// ·
typedef enum tagNET_LINE_DIRECTION
{
    NET_LINE_DIRECTION_UNKNOWN,                                     // δ֪
    NET_LINE_DIRECTION_POSTIVE,                                     // 
    NET_LINE_DIRECTION_NEGATIVE,                                    // 
    NET_LINE_DIRECTION_AROUND,                                      // 
    NET_LINE_DIRECTION_DISPERSE,                                    // ɢ
} NET_LINE_DIRECTION;

// վվ״̬
typedef enum tagNET_BUS_STATE
{
    NET_BUS_STATE_UNKNOWN,                                         // δ֪
    NET_BUS_STATE_ILLEGAL,                                         // Ƿ
    NET_BUS_STATE_LEGAL,                                           // Ϸ
} NET_BUS_STATE;

// վʽ
typedef enum tagNET_PORT_TYPE
{
    NET_PORT_TYPE_UNKOWN,                                           // δ֪
    NET_PORT_TYPE_MANUAL,                                           // ֶվ
    NET_PORT_TYPE_GPS,                                              // GPSվ
} NET_PORT_TYPE;

// ؿ¼
typedef enum tagEM_VEHICLE_DATA_TYPE
{
    EM_VEHICLE_DOOR_OPEN_DATA_UNKNOWN = 0,
    EM_VEHICLE_DOOR_OPEN_DATA_REALTIME,                             // ʵʱ
    EM_VEHICLE_DOOR_OPEN_DATA_HISTORY,                              // ط
}EM_VEHICLE_DATA_TYPE;

// ¼DH_ALARM_BUS_IMPORT_SITE(վ¼)ӦϢ
typedef struct tagALARM_BUS_IMPORT_SITE_INFO
{
    DWORD                   dwSize;
    char                    szSiteID[DH_COMMON_STRING_64];          // վʶ
    DWORD                   dwSiteNum;                              // վ
    NET_LINE_DIRECTION      emDirection;                            // ·
    char                    szLineID[DH_COMMON_STRING_64];          // ·ʶ
    NET_TIME_EX             stuTime;                                // վվʱ
    int                     nTime;                                  // ȷ¼õʱ, UTC, λΪ
    NET_BUS_STATE           emState;                                // Ƿ񰴹涨ʱվ
    NET_PORT_TYPE           emType;                                 // վʽ
    NET_GPS_STATUS_INFO     stuGPSStatusInfo;                       // GPSϢ
    DWORD                   dwSiteCount;                            // վ
    char                    szSiteName[DH_COMMON_STRING_64];        // վ
    char                    szDesignation[DH_COMMON_STRING_64];     // ·
    EM_VEHICLE_DATA_TYPE    emDataType;                             // ¼ݵ
    BOOL                    bNeedConfirm;                           // ǷҪȷ, ͨCLIENT_BusConfirmEventӿȷ
} ALARM_BUS_IMPORT_SITE_INFO;

// ¼DH_ALARM_BUS_EXPORT_SITE(վ¼)ӦϢ
typedef struct tagALARM_BUS_EXPORT_SITE_INFO
{
    DWORD                   dwSize;
    char                    szSiteID[DH_COMMON_STRING_64];          // վʶ
    DWORD                   dwSiteNum;                              // վ
    NET_LINE_DIRECTION      emDirection;                            // ·
    char                    szLineID[DH_COMMON_STRING_64];          // ·ʶ
    NET_TIME_EX             stuTime;                                // վվʱ
    int                     nTime;                                  // ȷ¼õʱ, UTC, λΪ
    NET_BUS_STATE           emState;                                // Ƿ񰴹涨ʱվ
    NET_PORT_TYPE           emType;                                 // վʽ
    NET_GPS_STATUS_INFO     stuGPSStatusInfo;                       // GPSϢ
    DWORD                   dwSiteCount;                            // վ
    char                    szSiteName[DH_COMMON_STRING_64];        // վ
    char                    szDesignation[DH_COMMON_STRING_64];     // ·
    EM_VEHICLE_DATA_TYPE    emDataType;                             // ¼ݵ
    BOOL                    bNeedConfirm;                           // ǷҪȷ, ͨCLIENT_BusConfirmEventӿȷ
} ALARM_BUS_EXPORT_SITE_INFO;

// 쳣¼
typedef enum tagEM_ALARM_BUS_ABNORMAL_EVENT_TYPE
{
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_UNKNOWN,           // δ֪
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_RUNNING,           // ָӪˣ"Running"
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_MEAL,              // Է"Meal"
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_BLOCK,             // ·£"Block"
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_CALL,              // ͨ"Call"
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_BREAKDOWN,         // "Breakdown"
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_DISCONTINUED,      // ֹͣӪˣ"Discontinued"
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_ROBING,            // "Robing"
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_OVERLOAD,          // أ"Overload"
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_DISPUTE,           // ף"Dispute"
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_ACCIDENT,          // ¹ʣ"Accident"
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_OVERSPEED,         // ٣"OverSpeed"
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_RENTAL,            // "Rental"
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_MAINTENANCE,       // "Maintenance"
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE_CLOSURE,           // ѱͣˣ"Closure"
}EM_ALARM_BUS_ABNORMAL_EVENT_TYPE;

// ¼DH_ALARM_BUS_ABNORMAL(쳣¼)ӦϢ
typedef struct tagALARM_BUS_ABNORMAL_INFO
{
    DWORD                                   dwSize;
    EM_ALARM_BUS_ABNORMAL_EVENT_TYPE        emEventType;                            // 쳣¼
    char                                    szCarNo[DH_MAX_PLATE_NUMBER_LEN];       // 
    char                                    szLineID[DH_COMMON_STRING_64];          // ·ʶ
    NET_LINE_DIRECTION                      emLineDirection;                        // ·
    NET_TIME_EX                             stuTime;                                // ʱ
    NET_GPS_STATUS_INFO                     stuGPSStatusInfo;                       // GPSϢ
} ALARM_BUS_ABNORMAL_INFO;

// ¼DH_ALARM_ENCLOSURE_ALARM(Χ¼)ӦϢ
typedef struct tagALARM_ENCLOSURE_ALARM_INFO
{
    DWORD                   dwSize;
    DWORD                   dwAlarmType;                            // , λֱʾ
                                                                    // 0:LimitSpeed, 1:DriveAllow, 2:ForbidDrive, 3:LoadGoods, 4:UploadGoods
    DWORD                   dwAlarmDetail;                          // , λֱʾ,
                                                                    // 0:DriveIn, 1:DriveOut, 2:Overspeed, 3:SpeedClear
    NET_BUS_STATE           emState;                                // Ƿ񰴹涨ʱ䴥¼
    DWORD                   dwDriverNo;                             // ˾
    DWORD                   dwEnclosureID;                          // ΧID
    DWORD                   dwLimitSpeed;                           // 
    DWORD                   dwCurrentSpeed;                         // ǰٶ
    NET_TIME_EX             stuTime;                                // ǰʱ
    NET_GPS_STATUS_INFO     stuGPSStatusInfo;                       // GPSϢ
} ALARM_ENCLOSURE_ALARM_INFO;

// صŵ״̬
typedef NET_ACCESS_CTL_STATUS_TYPE NET_VEHICLE_DOOR_STATUS;

// ؿ¼, Ӧ¼ DH_VEHICLE_DOOR_OPEN
typedef struct tagALARM_VEHICLE_DOOR_OPEN_INFO 
{
    DWORD                       dwSize;
    NET_VEHICLE_DOOR_STATUS     emStatus;               // ״̬
    int                         nDoor;                  // , 1:ǰ,2:,3:
    NET_TIME                    stuTime;                // ¼ʱ, UTC
    int                         nTime;                  // ȷ¼õʱ, UTC, λΪ
    NET_GPS_STATUS_INFO         stuGPSStatusInfo;       // GPSϢ
    EM_VEHICLE_DATA_TYPE        emDataType;             // ¼ݵ
    BOOL                        bNeedConfirm;           // ǷҪȷ, ͨCLIENT_BusConfirmEventӿȷ
}ALARM_VEHICLE_DOOR_OPEN_INFO;

// ǰ¼, Ӧ¼ DH_ALARM_BUS_CUR_MILEAGE
typedef struct tagALARM_BUS_CUR_MILEAGE_INFO 
{
    DWORD                       dwSize;
    BOOL                        bNeedConfirm;           // ǷҪȷ, ͨCLIENT_BusConfirmEventӿȷ
    int                         nTime;                  // ȷ¼õʱ, UTC, λΪ
    EM_VEHICLE_DATA_TYPE        emDataType;             // ¼ݵ
    NET_TIME                    stuTime;                // ¼ʱ, UTC
    NET_GPS_STATUS_INFO         stuGPSStatusInfo;       // GPSϢ, ֻоγȡٶȡֶЧ
    NET_TIME                    stuStartTime;           // ǰʱεĿʼʱ, UTC
    NET_GPS_STATUS_INFO         stuStartGPSStatusInfo;  // ǰʱεĿʼʱʱGPSϢ, ֻоγȡٶȡֶЧ
    unsigned int                nMileage;               // ǰʱε, λ:0.1km
}ALARM_BUS_CUR_MILEAGE_INFO;

// ǰͺ¼, Ӧ¼ DH_ALARM_BUS_CUR_OIL
typedef struct tagALARM_BUS_CUR_OIL_INFO 
{
    DWORD                       dwSize;
    BOOL                        bNeedConfirm;           // ǷҪȷ, ͨCLIENT_BusConfirmEventӿȷ
    int                         nTime;                  // ȷ¼õʱ, UTC, λΪ
    EM_VEHICLE_DATA_TYPE        emDataType;             // ¼ݵ
    NET_TIME                    stuTime;                // ¼ʱ, UTC
    NET_GPS_STATUS_INFO         stuGPSStatusInfo;       // GPSϢ, ֻоγȡٶȡֶЧ
    NET_TIME                    stuStartTime;           // ǰʱεĿʼʱ, UTC
    NET_GPS_STATUS_INFO         stuStartGPSStatusInfo;  // ǰʱεĿʼʱʱGPSϢ, ֻоγȡٶȡֶЧ
    unsigned int                nCurOil;                // ǰ, λ: 0.1L
    unsigned int                nOilTankage;            // ݻ, λ: 0.1L
    int                         nOilChange;             // ǰʱ仯, λ: 0.1L, ʾ, ʾ
}ALARM_BUS_CUR_OIL_INFO;

// ¼, Ӧ¼ DH_ALARM_BUS_LOW_OIL
typedef struct tagALARM_BUS_LOW_OIL_INFO 
{
    DWORD                       dwSize;
    BOOL                        bNeedConfirm;           // ǷҪȷ, ͨCLIENT_BusConfirmEventӿȷ
    int                         nTime;                  // ȷ¼õʱ, UTC, λΪ
    EM_VEHICLE_DATA_TYPE        emDataType;             // ¼ݵ
    NET_TIME                    stuTime;                // ¼ʱ, UTC
    NET_GPS_STATUS_INFO         stuGPSStatusInfo;       // GPSϢ, ֻоγȡٶȡֶЧ
    unsigned int                nCurOil;                // ǰ, λ: 0.1L
    unsigned int                nOilLine;               // ֵ, λ: 0.1L
    unsigned int                nOilTankage;            // ݻ, λ: 0.1L
}ALARM_BUS_LOW_OIL_INFO;

// Bus״̬νṹ
typedef struct tagNET_IN_BUS_ATTACH
{
    DWORD                   dwSize;
    fBusStateCallBack       cbBusState;                             // ״̬ص
    LDWORD                  dwUser;                                 // û
}NET_IN_BUS_ATTACH;

// Bus״̬νṹ
typedef struct tagNET_OUT_BUS_ATTACH
{
    DWORD                dwSize;
}NET_OUT_BUS_ATTACH;

// չģ鱨ͨϢ
typedef struct tagNET_EXALARMCHANNELS_INFO
{
    DWORD           dwSize;
    int             nExAlarmBoxNum;                                 // չͨ
    int             nChannelNum;                                    // ͨչϵͨ
    char            szChannelName[DH_MAX_EXALARMCHANNEL_NAME_LEN];  // ͨ
} NET_EXALARMCHANNELS_INFO;

// CLIENT_QueryDevState ӿ
typedef struct tagNET_EXALARMCHANNELS
{
    DWORD                       dwSize;
    int                         nExAlarmInCount;                    // չģ鱨ͨûָѯ
    int                         nRetExAlarmInCount;                 // չģ鱨ͨظ
    NET_EXALARMCHANNELS_INFO*   pstuExAlarmInInfo;                  // չģ鱨ͨϢ

    int                         nExAlarmOutCount;                   // չģ鱨ͨûָѯ
    int                         nRetExAlarmOutCount;                // չģ鱨ͨظ
    NET_EXALARMCHANNELS_INFO*   pstuExAlarmOutInfo;                 // չģ鱨ͨϢ
} NET_EXALARMCHANNELS;

// ķϢ
typedef struct tagNET_ACTIVATEDDEFENCEAREA_INFO
{
    DWORD                       dwSize;
    int                         nChannel;                           // ͨ
    NET_TIME                    stuActivationTime;                  // ʱ 
}NET_ACTIVATEDDEFENCEAREA_INFO;
// CLIENT_QueryDevState ӿ
typedef struct tagNET_ACTIVATEDEFENCEAREA
{
    DWORD                       dwSize;
    int                         nAlarmInCount;                      // ѯرͨûָ
    int                         nRetAlarmInCount;                   // رͨʵʼ
    NET_ACTIVATEDDEFENCEAREA_INFO* pstuAlarmInDefenceAreaInfo;      // رͨϢ

    int                         nExAlarmInCount;                    // ѯչģ鱨ͨûָ
    int                         nRetExAlarmInCount;                 // չģ鱨ͨʵʼ
    NET_ACTIVATEDDEFENCEAREA_INFO* pstuExAlarmInDefenceAreaInfo;    // չģ鱨ͨϢ
}NET_ACTIVATEDDEFENCEAREA;

// Ž״̬
typedef enum tagEM_NET_DOOR_STATUS_TYPE
{
    EM_NET_DOOR_STATUS_UNKNOWN,
    EM_NET_DOOR_STATUS_OPEN,                            // Ŵ
    EM_NET_DOOR_STATUS_CLOSE,                           // Źر
    EM_NET_DOOR_STATUS_BREAK,                           // 쳣
}EM_NET_DOOR_STATUS_TYPE;

// Ž״̬Ϣ(CLIENT_QueryDevState ӿ)
typedef struct tagNET_DOOR_STATUS_INFO
{
    DWORD                       dwSize;
    int                         nChannel;               // Žͨ
    EM_NET_DOOR_STATUS_TYPE     emStateType;            // Ž״̬Ϣ
}NET_DOOR_STATUS_INFO;

// CLIENT_QueryRecordCountӿ
typedef struct _NET_IN_QUEYT_RECORD_COUNT_PARAM
{
    DWORD                       dwSize;                 // ṹС
    LLONG                       lFindeHandle;           // ѯ
}NET_IN_QUEYT_RECORD_COUNT_PARAM;

// CLIENT_QueryRecordCountӿ
typedef struct _NET_OUT_QUEYT_RECORD_COUNT_PARAM
{
    DWORD                       dwSize;                 // ṹС
    int                         nRecordCount;           // 豸صļ¼
}NET_OUT_QUEYT_RECORD_COUNT_PARAM;

// ģͨϢ
typedef struct tagNET_ANALOGALARM_CHANNELS_INFO 
{
    DWORD               dwSize;
    int                 nSlot;                          // ַ, 0ʾͨ, 1ʾڵһϵչͨ, 23...Դ
    int                 nLevel1;                        // һַ, ʾڵnSlotϵĵnLevel1̽, 0ʼ
    int                 nLevel2;                        // ڶַ, ʾڵnLevel1ڵϵĵnLevel2̽,0ʼ,-1ʾڸýڵ,
    char                szName[DH_COMMON_STRING_128];   // ͨ
}NET_ANALOGALARM_CHANNELS_INFO;

// ģͨӳϵ(ӦDH_DEVSTATE_ANALOGALARM_CHANNELS)
typedef struct tagNET_ANALOGALARM_CHANNELS 
{
    DWORD                          dwSize;
    int                            nMaxAnalogAlarmChannels; // ͨ
    int                            nRetAnalogAlarmChannels; // صͨ
    NET_ANALOGALARM_CHANNELS_INFO* pstuChannelInfo;         // ͨϢûڴ
}NET_ANALOGALARM_CHANNELS;

// Ϣ
typedef struct tagNET_ANALOGALARM_SENSE_INFO 
{
    DWORD                   dwSize;
    int                     nChannelID;                     // ͨ(0ʼ)
    NET_SENSE_METHOD        emSense;                        // 
    float                   fData;                          // ֵ
    NET_TIME                stuTime;                        // ɼʱ
    int                     nStatus;                        // ״̬, -1:δ֪,0:,1:Ч(),
                                                            // 2:ֵ1,3:ֵ2,4:ֵ3,5:ֵ4,
                                                            // 6:ֵ1,7:ֵ2,8:ֵ3,9:ֵ4
    NET_GPS_STATUS_INFO     stuGpsSatus;                    // GPS״̬ 
}NET_ANALOGALARM_SENSE_INFO;

//ģͨݻصԭ
typedef void (CALLBACK *fAnalogAlarmDataCallBack)(LLONG lLoginID, LLONG lAttachHandle, NET_ANALOGALARM_SENSE_INFO* pInfo, int nBufLen, LDWORD dwUser);

// CLIENT_AttachAnalogAlarmData()ӿ
typedef struct tagNET_IN_ANALOGALARM_DATA 
{
    DWORD                       dwSize;
    int                         nChannelId;                 // 0ʼ, -1ʾȫͨ
    fAnalogAlarmDataCallBack    cbCallBack;                 // ݻص
    LDWORD                      dwUser;                     // û
}NET_IN_ANALOGALARM_DATA;

// CLIENT_AttachAnalogAlarmData()ӿ
typedef struct tagNET_OUT_ANALOGALARM_DATA 
{
    DWORD    dwSize;
}NET_OUT_ANALOGALARM_DATA;

// ļ¼ӿض
#define DH_MAX_RECORD_INSERT_NUM                            128
#define DH_MAX_RECORD_DELETE_NUM                            128
#define DH_MAX_RECORD_UPDATE_NUM                            128

typedef struct tagNET_RECORDUPDATER_INFO
{
    DWORD                       dwSize;
    int                         nInsertNum;                                     // ¼ϢУļ¼
    int                         nInsertNumberList[DH_MAX_RECORD_INSERT_NUM];    // ʾļ¼            
    int                         nDeleteNum;                                     // ¼ϢУɾļ¼
    int                         nDeleteNumberList[DH_MAX_RECORD_DELETE_NUM];    // ʾɾļ¼ţ-1ʾɾм¼         
    int                         nUpdateNum;                                     // ¼ϢУµļ¼
    int                         nUpdateNumberList[DH_MAX_RECORD_UPDATE_NUM];    // ʾµļ¼          
}NET_RECORDUPDATER_INFO;

//ļ¼ӿ
typedef void (CALLBACK *fRecordUpdaterCallBack)(LLONG lLoginID, LLONG lAttachHandle, NET_RECORDUPDATER_INFO* pInfo, int nBufLen, LDWORD dwUser);

// CLIENT_AttachRecordUpdater()ӿ
typedef struct tagNET_IN_RECORDUPDATER_DATA
{
    DWORD                       dwSize;
    EM_NET_RECORD_TYPE          emType;                     // ¼Ϣ
    fRecordUpdaterCallBack      cbRecordUpdater;                 // ¼»ص
    LDWORD                      dwUser;                     // û
}NET_IN_RECORDUPDATER_DATA;

// CLIENT_AttachRecordUpdater()ӿ
typedef struct tagNET_OUT_RECORDUPDATER_DATA
{
    DWORD                       dwSize;
}NET_OUT_RECORDUPDATER_DATA;

// ѯ豸ֵ֧Ĵ豸 
// CLIENT_QueryDevStateӿڵ DH_DEVSTATE_GET_SENSORLIST  
#define MAX_SUPPORT_SENSORTYPE_NUM    128                   // ִ֧豸͸

typedef struct tagNET_SENSOR_LIST 
{
    DWORD       dwSize;
    int         nSupportSensorNum;                          // ִ֧豸͸
    char        szSensorList[MAX_SUPPORT_SENSORTYPE_NUM][DH_COMMON_STRING_64];
}NET_SENSOR_LIST;

// CLIENT_QueryDevLogCountȡ־
typedef struct tagNET_IN_GETCOUNT_LOG_PARAM
{
    DWORD                       dwSize;
    QUERY_DEVICE_LOG_PARAM      stuQueryCondition;          // ѯ¼
} NET_IN_GETCOUNT_LOG_PARAM;

// CLIENT_QueryDevLogCountȡ־
typedef struct tagNET_OUT_GETCOUNT_LOG_PARAM
{
    DWORD                       dwSize;
    int                         nLogCount;                  // ־(豸)
} NET_OUT_GETCOUNT_LOG_PARAM;


// SDKȫ־ӡϢ
typedef struct tagLogSetPrintInfo
{
    DWORD           dwSize;
    BOOL            bSetFilePath;                           // Ƿ־·
    char            szLogFilePath[MAX_LOG_PATH_LEN];        // ־·(Ĭ"./sdk_log/sdk_log.log")
    BOOL            bSetFileSize;                           // Ƿ־ļС
    unsigned int    nFileSize;                              // ÿ־ļĴС(ĬϴС10240), λ:
    BOOL            bSetFileNum;                            // Ƿ־ļ
    unsigned int    nFileNum;                               // ƽ־ļ(ĬϴС10)
    BOOL            bSetPrintStrategy;                      // Ƿ־ӡ
    unsigned int    nPrintStrategy;                         // ־, 0:ļ(Ĭ); 1:
}LOG_SET_PRINT_INFO;

//////////////////////////////////////////////////////////////////////////
//       Low Rate Wireless Personal Area Network ˽ begin
//////////////////////////////////////////////////////////////////////////

// 豸
typedef enum tagNET_WIRELESS_DEVICE_TYPE
{
	NET_WIRELESS_DEVICE_TYPE_UNKNOWN = 0,				
	NET_WIRELESS_DEVICE_TYPE_KEYBOARD,			// ߼
	NET_WIRELESS_DEVICE_TYPE_DEFENCE,			// ߷ 
	NET_WIRELESS_DEVICE_TYPE_REMOTECONTROL,		// ң 
	NET_WIRELESS_DEVICE_TYPE_MAGNETOMER,		// Ŵ 
} NET_WIRELESS_DEVICE_TYPE;

// Ϣ
typedef struct tagNET_CODEID_INFO
{
	DWORD						dwSize;
	unsigned int				nWirelessId;					// ID
	NET_WIRELESS_DEVICE_TYPE	emType;							// 豸
	char						szName[DH_USER_NAME_LENGTH];	// û
	BOOL						bEnable;						// Ƿ˴豸
}NET_CODEID_INFO;

// 
typedef enum tagNET_CODEID_ERROR_TYPE
{	
	NET_CODEID_ERROR_TYPE_RIGHT = 0,			// ȷ
	NET_CODEID_ERROR_TYPE_ALREADYEXIST,			// Ѿ
	NET_CODEID_ERROR_TYPE_OTHER,				// 
} NET_CODEID_ERROR_TYPE;

// ߶ϢصԭΣlAttachHandleCLIENT_AttachLowRateWPANֵ
typedef void (CALLBACK *fAttachLowRateWPANCB) (LLONG lLoginID, LLONG lAttachHandle, NET_CODEID_INFO* stuBuf, NET_CODEID_ERROR_TYPE emError, LDWORD dwUser);

// CLIENT_AttachLowRateWPAN()
typedef struct tagNET_IN_ATTACH_LOWRATEWPAN
{
	DWORD					dwSize;
	fAttachLowRateWPANCB	cbAttachLowRateWPANCB;         // ݻص
	LDWORD					dwUser;                        // û
}NET_IN_ATTACH_LOWRATEWPAN;

// CLIENT_AttachLowRateWPAN()
typedef struct tagNET_OUT_ATTACH_LOWRATEWPAN
{
	DWORD		        dwSize;
}NET_OUT_ATTACH_LOWRATEWPAN;

// ɾָ豸
// CLIENT_ControlDeviceӿڵ DH_CTRL_LOWRATEWPAN_REMOVE
typedef struct tagNET_CTRL_LOWRATEWPAN_REMOVE
{
	DWORD					dwSize;
	unsigned int			nWirelessId;				// 豸ID	
}NET_CTRL_LOWRATEWPAN_REMOVE;

// ɾȫ豸
// CLIENT_ControlDeviceӿڵ DH_CTRL_LOWRATEWPAN_REMOVEALL
typedef struct tagNET_CTRL_LOWRATEWPAN_REMOVEALL
{
	DWORD					dwSize;
}NET_CTRL_LOWRATEWPAN_REMOVEALL;

// ޸豸Ϣ
// CLIENT_ControlDeviceӿڵ DH_CTRL_LOWRATEWPAN_MODIFY
typedef struct tagNET_CTRL_LOWRATEWPAN_MODIFY
{
	DWORD					dwSize;
	NET_CODEID_INFO			stuCodeIDInfo;			// CodeIDInfoеCodeID޸UserEnableϢ޸
}NET_CTRL_LOWRATEWPAN_MODIFY;

// ȡɹ
typedef struct tagNET_GET_CODEID_COUNT
{
	DWORD				dwSize;
	int					nCodeIDCount;		// ɹ
}NET_GET_CODEID_COUNT;

// ȡϢ
typedef struct tagNET_GET_CODEID_LIST
{
	DWORD				dwSize;
	int					nStartIndex;			// ʼţʼһβѯΪ0
	int					nQueryNum;				// λȡĶֵСڵnMaxPageSizeֶεֵ
	int					nRetCodeIDNum;			// ʵʷصĶ
	NET_CODEID_INFO*	pstuCodeIDInfo;			// ȡݣڴû䣬СnQueryNum*sizeof(NET_CODEID_INFO)
}NET_GET_CODEID_LIST;

// ģͨݲѯ(Ӧ DH_DEVSTATE_ANALOGALARM_DATA )
typedef struct tagNET_GET_ANALOGALARM_DATA 
{
    DWORD                       dwSize;
    int                         nChannelID;     // ѯģͨ(0ʼ)
    NET_ANALOGALARM_SENSE_INFO  stuInfo;        // õģͨ
}NET_GET_ANALOGALARM_DATA;

//////////////////////////////////////////////////////////////////////////
//       Low Rate Wireless Personal Area Network ˽ end
//////////////////////////////////////////////////////////////////////////

// ȡǰϵͳ״̬(ӦDH_DEVSTATE_GET_ALARM_SUBSYSTEM_ACTIVATESTATUS)
typedef struct tagNET_GET_ALARM_SUBSYSTEM_ACTIVATE_STATUES
{
    DWORD               dwSize;
    int                 nChannelId;                         // ϵͳ
    BOOL                bActive;                            // ϵͳ״̬, TRUE ʾ,FALSEʾ
}NET_GET_ALARM_SUBSYSTEM_ACTIVATE_STATUES;

// ϵͳò(ӦDH_CTRL_ALARM_SUBSYSTEM_ACTIVE_SET)
typedef struct tagNET_CTRL_ALARM_SUBSYSTEM_SETACTIVE 
{
    DWORD               dwSize;
    int                 nChannelId;                         // ϵͳ
    BOOL                bActive;                            // ϵͳ״̬,TRUE ʾ,FALSEʾ
}NET_CTRL_ALARM_SUBSYSTEM_SETACTIVE;

// ֹբ(Ӧ DH_CTRL_FORBID_OPEN_STROBE)
typedef struct tagNET_CTRL_FORBID_OPEN_STROBE
{
    DWORD               dwSize;             
    int                 nChannelID;                         // ͨ    
    int                 nTime;                              // ֹբĳʱ䣬λ:sڴ˲֮ĶӦʱڲ豸բ 
}NET_CTRL_FORBID_OPEN_STROBE;

#define MAX_PLATENUMBER_LEN    64                           // ƺ볤
// բ(ӦDH_CTRL_OPEN_STROBE)
typedef struct tagNET_CTRL_OPEN_STROBE
{
    DWORD               dwSize;
    int                 nChannelId;                         // ͨ
    char                szPlateNumber[MAX_PLATENUMBER_LEN]; // ƺ
}NET_CTRL_OPEN_STROBE;

// رյբ(ӦDH_CTRL_CLOSE_STROBE)
typedef struct tagNET_CTRL_CLOSE_STROBE
{
    DWORD               dwSize;
    int                 nChannelId;                         // ͨ
}NET_CTRL_CLOSE_STROBE;

// طžܾ(ӦDH_CTRL_TALKING_REFUSE)
typedef struct tagNET_CTRL_TALKING_REFUSE 
{
    DWORD           dwSize;
    int             nChannelID;                             // Խͨ
}NET_CTRL_TALKING_REFUSE;

// λԤ״̬
typedef enum tagEM_NET_ORDER_STATE
{
    EM_NET_ORDER_STATE_UNKNOWN,
    EM_NET_ORDER_STATE_FREE,                            // Free
    EM_NET_ORDER_STATE_ORDERED,                         // ԤOrdered
}EM_NET_ORDER_STATE;

// λԤ״̬Ϣ
typedef struct tagNET_ORDER_STATE_INFO
{
    DWORD               dwSize;
    unsigned int        nLane;                          // λ
    EM_NET_ORDER_STATE  emOrderState;                   // Ԥ
}NET_ORDER_STATE_INFO;

// óλԤ״̬(ӦDH_CTRL_SET_ORDER_STATE)
typedef struct tagNET_CTRL_SET_ORDER_STATE
{
    DWORD                   dwSize;
    NET_ORDER_STATE_INFO*   pOrderStateInfo;              // λԤϢ,ûռ
    unsigned int            nStateCount;                  // ЧԤ
}NET_CTRL_SET_ORDER_STATE;

// ͣڿLEDĻĻٶ
typedef enum tagNET_ECK_LED_SPEED_TYPE 
{
    NET_ECK_LED_SPEED_UNKNOWN = 0,
    NET_ECK_LED_SPEED_LOW,                              // 
    NET_ECK_LED_SPEED_NORMAL,                           // 
    NET_ECK_LED_SPEED_HIGH,                             // 
}NET_ECK_LED_SPEED_TYPE;

// ͣڿLED DH_CTRL_ECK_LED_SET
typedef struct tagNET_CTRL_ECK_LED_SET_PARAM 
{
    DWORD                   dwSize;
    NET_ECK_LED_SPEED_TYPE  emLEDSpeed;                 // Ļٶ
    int                     nCount;                     // Чʾ, Χ0-255, 0ʾ
    char                    szCustomData[DH_COMMON_STRING_512];// LEDʼԶַ, 0-256ֽ
}NET_CTRL_ECK_LED_SET_PARAM;


// ͣϵͳڻICû
typedef enum tagNET_ECK_IC_CARD_USER_TYPE
{
    NET_ECK_IC_CARD_USER_TEMP = 0,                      // ʱû
    NET_ECK_IC_CARD_USER_LONG,                          // û
}NET_ECK_IC_CARD_USER_TYPE;

// ͣϵͳڻ쳣¼
typedef enum tagNET_ECK_CAR_PASS_FLAG
{
    NET_ECK_CAR_PASS_FLAG_NORMAL = 0,                   // 
    NET_ECK_CAR_PASS_FLAG_ABNORMAL = 1,                 // 쳣
    NET_ECK_CAR_PASS_FLAG_ALL,                          // ȫ
} NET_ECK_CAR_PASS_FLAG;

// ͣϵͳڻICϢ
typedef struct tagNET_ECK_IC_CARD 
{
    DWORD                   dwSize;
    DWORD                   dwCard;                     // 
    NET_ECK_IC_CARD_USER_TYPE emUserType;               // û
}NET_ECK_IC_CARD;

#define NET_MAX_ECK_IC_CARD_IMPORT_NUM      50          // ͣϵͳڻɵICĿ

// ͣϵͳڻICϢ DH_CTRL_ECK_IC_CARD_IMPORT
typedef struct tagNET_CTRL_ECK_IC_CARD_IMPORT_PARAM
{
    DWORD               dwSize;
    int                 nCardNum;                       // IC
    NET_ECK_IC_CARD     stuCardInfo[NET_MAX_ECK_IC_CARD_IMPORT_NUM];// ICϢ
}NET_CTRL_ECK_IC_CARD_IMPORT_PARAM;

// ͣϵͳڻICϢָͬ  DH_CTRL_ECK_SYNC_IC_CARD
typedef struct tagNET_CTRL_ECK_SYNC_IC_CARD_PARAM
{
    DWORD               dwSize;
    int                 nCount;                         // ͻICϢ
}NET_CTRL_ECK_SYNC_IC_CARD_PARAM;

// ָƲɼ(ӦDH_CTRL_CAPTURE_FINGER_PRINT)
typedef struct tagNET_CTRL_CAPTURE_FINGER_PRINT 
{
    DWORD           dwSize;
    int             nChannelID;                             // Ž(0ʼ)
    char            szReaderID[DH_COMMON_STRING_32];        // ID
}NET_CTRL_CAPTURE_FINGER_PRINT;

////////////////////////////////ϵͳ//////////////////////////////////////////
// ״̬
typedef struct __NET_PARTITION_STATE
{
    DWORD             dwSize;
    int               nStatus;                  // ״̬0-1- 
    double            dbTotalSize;              // ֽΪλ
    double            dbRemainSize;             // ʣֽΪλ
    
}NET_PARTITION_STATE;

// Ӳ״̬
typedef struct __NET_HDD_STATE
{
    DWORD             dwSize; 
    int               nState;                   // Ӳ״̬0-1-   
    double            dbTotalSize;              // ӲֽΪλ
    NET_PARTITION_STATE stuPartitions[DH_MAX_STORAGE_PARTITION_NUM]; // ״̬
    int               nPartitionNum;              // 
}NET_HDD_STATE;

// ͨ״̬
typedef struct __NET_CHANNLE_STATE
{
    DWORD             dwSize;
    BYTE              byRecState;               // ¼״̬1-¼0-ر
    BYTE              byVideoInState;           // Ƶ״̬1-Ƶ룬0-Ƶ  
    BYTE              byReserved[2];            // ֽڶ
}NET_CHANNLE_STATE;

// 豸ԼϢ
typedef struct __NET_SELFCHECK_INFO
{
    DWORD             dwSize;
    int               nAlarmIn;                 // ͨ
    int               nAlarmOut;                // ͨ  
    NET_TIME          stuTime;                  // ϱʱ
    char              szPlateNo[DH_MAX_PLATE_NUMBER_LEN]; // 
    char              szICCID[DH_MAX_SIM_LEN];  // SIM
    BYTE              byOrientation;            // λ״̬0-δλ1-λ 
    BYTE              byACCState;               // ACC ״̬0-رգ1-
    BYTE              byConstantElecState;      // ״̬0-ӣ1-Ͽ2-Ƿѹ3-ѹ
    BYTE              byAntennaState;           // ͨź״̬0-1-δ֪ϣ2-δӣ3-·
    
    // ⲿ豸״̬
    BYTE              byReportStation;          // վ״̬0-δӣ1-2-쳣
    BYTE              byControlScreen;          // ״̬0-δӣ1-2-쳣
    BYTE              byPOS;                    // POS״̬0-δӣ1-2-쳣
    BYTE              byCoinBox;                // Ͷ״̬0-δӣ1-2-쳣
    
    // 
    BOOL              bTimerSnap;               // ʱץͼTRUE-֧֣FALSE-֧
    BOOL              bElectronEnclosure;       // ΧTRUE-֧֣FALSE-֧
    BOOL              bTeleUpgrade;             // ԶTRUE-֧֣FALSE-֧   
    
    NET_HDD_STATE     stuHddStates[DH_MAX_DISKNUM]; // Ӳ״̬
    int               nHddNum;                  // Ӳ̸
    
    NET_CHANNLE_STATE* pChannleState;           // ͨ״̬һ飬 ڴsdkڲ룬ͷҲsdkڲͷ
    int               nChannleNum;              // ͨ
}NET_SELFCHECK_INFO;

typedef void (CALLBACK *fMissionInfoCallBack)(LLONG lAttachHandle, DWORD dwType, void* pMissionInfo, void* pReserved, LDWORD dwUserData);

typedef enum EM_MISSION_TYPE
{
    NET_MISSION_TYPE_UNKOWN,                    // δ֪
        NET_MISSION_TYPE_SELFCHECK,                 // 豸Լ죬Ӧṹ NET_SELFCHECK_INFO
}EM_MISSION_TYPE;

//CLIENT_AttachMissionӿ
typedef struct __NET_IN_ATTACH_MISSION_PARAM
{
    DWORD             dwSize;
    EM_MISSION_TYPE   emMissionType;            // 
    fMissionInfoCallBack cbMissionInfofunc;     // Ϣص
    LDWORD            dwUser;                   // û 
}NET_IN_ATTACH_MISSION_PARAM;

// CLIENT_DetachMissionӿ
typedef struct NET_OUT_ATTACH_MISSION_PARAM
{
    DWORD             dwSize;
    LLONG             lAttachHandle;           // ľ
}NET_OUT_ATTACH_MISSION_PARAM;

#define MAX_EVENT_TO_CONFIRM_NUM        8       // ȷϵ¼ĸ

// ȷϵ¼Ϣ
typedef struct tagNET_EVENT_INFO_TO_CONFIRM 
{
    DWORD               dwSize;
    DWORD               dwEventType;            // ¼, ӦCLIENT_AttachBusStateӿڵ¼
    NET_TIME            stuTime;                // ¼ʱ, UTC
    LONG                lTime;                  // ¼ʱ, UTC, λ
}NET_EVENT_INFO_TO_CONFIRM;

// ȷ 
typedef struct tagNET_IN_BUS_CONFIRM_EVENT 
{
    DWORD                       dwSize;
    int                         nEvent;         // ȷ¼ЧĿ
    NET_EVENT_INFO_TO_CONFIRM   stuEventInfo[MAX_EVENT_TO_CONFIRM_NUM];// ȷ¼Ϣ
}NET_IN_BUS_CONFIRM_EVENT;

// ȷ 
typedef struct tagNET_OUT_BUS_CONFIRM_EVENT 
{
    DWORD                       dwSize;
}NET_OUT_BUS_CONFIRM_EVENT;

// CLIENT_StartQueryLog 
typedef struct tagNET_IN_START_QUERYLOG
{
    DWORD               dwSize;
} NET_IN_START_QUERYLOG;

// CLIENT_StartQueryLog 
typedef struct tagNET_OUT_START_QUERYLOG
{
    DWORD               dwSize;
}NET_OUT_START_QUERYLOG;

// ־ϸϢ
typedef struct tagNET_LOG_MESSAGE
{
    DWORD               dwSize;
    char                szLogMessage[DH_COMMON_STRING_1024];    // ־
} NET_LOG_MESSAGE;

// ־Ϣ
typedef struct tagNET_LOG_INFO
{
    DWORD               dwSize;
    NET_TIME            stuTime;                        // ʱ 
    char                szUserName[DH_COMMON_STRING_32];// 
    char                szLogType[DH_COMMON_STRING_128];// 
    NET_LOG_MESSAGE     stuLogMsg;                      // ־Ϣ
} NET_LOG_INFO;

// CLIENT_QueryNextLog 
typedef struct tagNET_IN_QUERYNEXTLOG
{
    DWORD               dwSize;
    int                 nGetCount;      // Ҫѯ־
}NET_IN_QUERYNEXTLOG;

// CLIENT_QueryNextLog 
typedef struct tagNET_OUT_QUERYNEXTLOG
{
    DWORD               dwSize;
    int                 nMaxCount;      // ûָṹڵNET_IN_GETNEXTLOGnGetCount
    NET_LOG_INFO*       pstuLogInfo;    // ־Ϣ,Сûָ,СΪnMaxCount*sizeof(NET_LOG_INFO)
    int                 nRetCount;      // ʵʷ־
}NET_OUT_QUERYNEXTLOG;

// 첽ע豸صԭ(nError11ʱֶreservedΪintͲڵCLIENT_StartLoginEx½ʱĶ˿ں)
typedef void (CALLBACK *fHaveLogin)(LLONG lLoginID, char *pchDVRIP, LONG nDVRPort, BOOL bOnline, NET_DEVICEINFO_Ex stuDeviceInfo, int nError, LDWORD dwUser, void *reserved);

// CLIENT_StartLoginEx 
typedef struct tagNET_IN_STARTLOGINEX 
{
    DWORD               dwSize;
    const char*         szIp;           // 豸ip
    DWORD               dwPort;         // ½˿
    const char*         szName;         // û
    const char*         szPwd;          // 
    fHaveLogin          cbLogin;        // ½ص
    LDWORD              dwUser;         // صû
}NET_IN_STARTLOGINEX;

// CLIENT_StartLoginEx 
typedef struct tagNET_OUT_STARTLOGINEX 
{
    DWORD       dwSize;
}NET_OUT_STARTLOGINEX;

// ƵƴӲ
typedef enum tagNET_VIDEOJOIN_OPERATE_TYPE
{
    NET_VIDEOJOIN_GET_STATUS,                   // ȡƴ״̬, Ӧ NET_IN_VIDEOJOIN_GET_STATUS  NET_OUT_VIDEOJOIN_GET_STATUS
        NET_VIDEOJOIN_GET_CALIBRATE_POINTS,     // ȡ, Ӧ tagNET_IN_VIDEOJOIN_GET_CALIBRATE_POINTS  tagNET_OUT_VIDEOJOIN_GET_CALIBRATE_POINTS
        NET_VIDEOJOIN_CALIBRATE,                // 궨,  Ӧ NET_IN_VIDEOJOIN_CALIBRATE  NET_OUT_VIDEOJOIN_CALIBRATE
}NET_VIDEOJOIN_OPERATE_TYPE;

// Ƶƴ״̬
typedef enum tagNET_VIDEOJOIN_STATUS
{
    NET_VIDEOJOIN_STATUS_UNKNOWN,               // δ֪
    NET_VIDEOJOIN_STATUS_NOTSTART,              // δʼ
    NET_VIDEOJOIN_STATUS_DOING,                 // 
    NET_VIDEOJOIN_STATUS_FINISH,                // 
}NET_VIDEOJOIN_STATUS;

// Ƶƴӱ궨ģʽ
typedef enum tagNET_VIDEOJOIN_MODE
{
    NET_VIDEOJOIN_MODE_UNKNOWN,                 // δ֪
    NET_VIDEOJOIN_MODE_AUTO,                    // Զ
    NET_VIDEOJOIN_MODE_MANUAL,                  // ֶ
}NET_VIDEOJOIN_MODE;

// CLIENT_OperateVideoJoin , ӦNET_VIDEOJOIN_GET_STATUS
typedef struct tagNET_IN_VIDEOJOIN_GET_STATUS
{
    DWORD           dwSize;
}NET_IN_VIDEOJOIN_GET_STATUS;

// CLIENT_OperateVideoJoin , ӦNET_VIDEOJOIN_GET_STATUS
typedef struct tagNET_OUT_VIDEOJOIN_GET_STATUS
{
    DWORD           dwSize;
    NET_VIDEOJOIN_STATUS emStatus;              // ƴ״̬
}NET_OUT_VIDEOJOIN_GET_STATUS;

// 궨, ʾһ
typedef struct tagNET_POINT_PAIR 
{
    DH_POINT        stuPoints[POINT_NUM_IN_PAIR];           // 궨
}NET_POINT_PAIR;

// Ƶƴӱ궨, ÿһʾͨͶ궨
typedef struct tagNET_VIDEOJOIN_POINT_GROUP
{
    DWORD           dwSize;
    int             nPointPairNum;                          // 궨
    NET_POINT_PAIR  stuPointPairs[MAX_POINT_PAIR_NUM];      // 궨
    int             nChannels[CHANNEL_NUM_IN_POINT_GROUP];  // Ƶͨ, ͨ±Ӧ±0ͨӦNET_POINT_PAIR±0ĵ
}NET_VIDEOJOIN_POINT_GROUP;

// CLIENT_OperateVideoJoin , ӦNET_VIDEOJOIN_GET_CALIBRATE_POINTS
typedef struct tagNET_IN_VIDEOJOIN_GET_CALIBRATE_POINTS
{
    DWORD           dwSize;
}NET_IN_VIDEOJOIN_GET_CALIBRATE_POINTS;

// CLIENT_OperateVideoJoin , ӦNET_VIDEOJOIN_GET_CALIBRATE_POINTS
typedef struct tagNET_OUT_VIDEOJOIN_GET_CALIBRATE_POINTS
{
    DWORD               dwSize;
    NET_VIDEOJOIN_MODE  emMode;                                 // 궨ģʽ
    int                 nPointGroupNum;                         // 궨
    NET_VIDEOJOIN_POINT_GROUP stuPointGroups[MAX_POINT_GROUP_NUM]; // 궨, ֶģʽЧ
}NET_OUT_VIDEOJOIN_GET_CALIBRATE_POINTS;

// CLIENT_OperateVideoJoin , ӦNET_VIDEOJOIN_CALIBRATE
typedef struct tagNET_IN_VIDEOJOIN_CALIBRATE
{
    DWORD               dwSize;
    NET_VIDEOJOIN_MODE  emMode;                                 // 궨ģʽ
    int                 nPointGroupNum;                         // 궨
    NET_VIDEOJOIN_POINT_GROUP stuPointGroups[MAX_POINT_GROUP_NUM]; // 궨, ֶģʽЧ
}NET_IN_VIDEOJOIN_CALIBRATE;

// CLIENT_OperateVideoJoin , ӦNET_VIDEOJOIN_CALIBRATE
typedef struct tagNET_OUT_VIDEOJOIN_CALIBRATE
{
    DWORD           dwSize;
}NET_OUT_VIDEOJOIN_CALIBRATE;

// ȡڴϢ, ӦNET_SPLIT_OPERATE_GET_SCENE
typedef struct tagNET_IN_SPLIT_GET_SCENE 
{
    DWORD               dwSize;
    int                 nChannel;                       // ͨŻںͨ, pszCompositeIDΪNULLʱЧ
    const char*         pszCompositeID;                 // ںID
}NET_IN_SPLIT_GET_SCENE;

// ȡڴϢ, ӦNET_SPLIT_OPERATE_GET_SCENE
typedef struct tagNET_OUT_SPLIT_GET_SCENE 
{
    DWORD               dwSize;
    DH_SPLIT_SCENE      stuScene;                       // Ϣ
}NET_OUT_SPLIT_GET_SCENE;

// ǽѲ״̬
typedef enum tagEM_NET_WM_TOUR_STATUS
{
    EM_NET_WM_TOUR_STATUS_UNKNOWN,              // δ֪
        EM_NET_WM_TOUR_STATUS_START,                // Ѳ
        EM_NET_WM_TOUR_STATUS_STOP,                 // Ѳֹͣ
} EM_NET_WM_TOUR_STATUS;

// ǽԤѲ״̬Ϣ
typedef struct tagNET_WM_TOUR_STATUS_INFO 
{
    DWORD                   dwSize;
    EM_NET_WM_TOUR_STATUS   emStatus;           // Ѳ״̬
    DH_MONITORWALL_SCENE    stuScene;           // ԤϢ
} NET_WM_TOUR_STATUS_INFO;

// ǽԤѲ״̬صԭ, lAttachHandleCLIENT_MonitorWallAttachTourķֵ
typedef void (CALLBACK *fMonitorWallTourStatusCallBack)(LLONG lLoginID, LLONG lAttachHandle, NET_WM_TOUR_STATUS_INFO* pstStatus, void* reserved, LDWORD dwUser);

// CLIENT_MonitorWallAttachTour ӿ
typedef struct tagNET_IN_WM_ATTACH_TOUR 
{
    DWORD           dwSize;
    int             nMonitorWallID;             // ǽID
    fMonitorWallTourStatusCallBack cbStatus;    // Ѳ״̬ص
    LDWORD          dwUser;                     // Ѳ״̬ص
} NET_IN_WM_ATTACH_TOUR;

// CLIENT_MonitorWallAttachTour ӿ
typedef struct tagNET_OUT_WM_ATTACH_TOUR 
{
    DWORD           dwSize;
} NET_OUT_WM_ATTACH_TOUR;

// CLIENT_SnapManagerConfirmUpload ӿ
typedef struct tagNET_IN_SNAP_MANAGER_CONFIRM_UPLOAD
{
    DWORD           dwSize;
    char            szFilePath[DH_COMMON_STRING_256];       // ļ·ΨһʶһͼƬ
    BOOL            bResult;                                // ͼƬǷϴ
}NET_IN_SNAP_MANAGER_CONFIRM_UPLOAD;

// CLIENT_SnapManagerConfirmUpload ӿ
typedef struct tagNET_OUT_SNAP_MANAGER_CONFIRM_UPLOAD
{
    DWORD           dwSize;
}NET_OUT_SNAP_MANAGER_CONFIRM_UPLOAD;

//////////////////////////////////////////////////////////////////////////
// Ϣ
//////////////////////////////////////////////////////////////////////////

//////////////////////////////////////////////////////////////////////////
//	ѯ
typedef enum
{
	ABILITY_DYNAMIC_CONNECT = 1,        // ѯ̬
	ABILITY_WATERMARK_CFG = 17,			// ˮӡ
	ABILITY_WIRELESS_CFG = 18,			// wireless
	ABILITY_DEVALL_INFO = 26,			// 豸б
	ABILITY_CARD_QUERY = 0x0100,		// Ųѯ
	ABILITY_MULTIPLAY = 0x0101,			// ໭Ԥ
	ABILITY_QUICK_QUERY_CFG = 0x0102,	// ٲѯ
	ABILITY_INFRARED = 0x0121,			// ߱
	ABILITY_TRIGGER_MODE = 0x0131,		// ʽ
	ABILITY_DISK_SUBAREA = 0x0141,		// Ӳ̷
	ABILITY_DSP_CFG = 0x0151,			// ѯDSP
	ABILITY_STREAM_MEDIA = 0x0161,		// ѯSIP,RTSP
	ABILITY_INTELLI_TRACKER = 0x0171,   // ѯܸ
} DH_SYS_ABILITY;

//////////////////////////////////////////////////////////////////////////
//	豸ֹ֧б
enum 
{
	EN_FTP = 0,							// FTP λ1¼ļ 2ץͼļ
	EN_SMTP,							// SMTP λ1ıʼ 2ͼƬ 3:ֽ֧ʼ
	EN_NTP,								// NTP	λ1ϵͳʱ
	EN_AUTO_MAINTAIN,					// Զά λ1 2ر 3:ɾļ
	EN_VIDEO_COVER,						// ڵ λ1ڵ
	EN_AUTO_REGISTER,					// ע	λ1עsdk½
	EN_DHCP,							// DHCP	λ1DHCP
	EN_UPNP,							// UPNP	λ1UPNP
	EN_COMM_SNIFFER,					// ץ λ1:CommATM
	EN_NET_SNIFFER,						// ץ λ 1NetSniffer
	EN_BURN,							// ¼ λ1ѯ¼״̬
	EN_VIDEO_MATRIX,					// Ƶ λ1Ƿ֧Ƶ 2:Ƿ֧SPOTƵ 3:Ƿ֧HDMIƵ
	EN_AUDIO_DETECT,					// Ƶ λ1Ƿ֧Ƶ
	EN_STORAGE_STATION,					// 洢λ λ1Ftp(Ips) 2SMB 3NFS 4ISCSI 16DISK 17U
	EN_IPSSEARCH,						// IPS洢ѯ λ1IPS洢ѯ	
	EN_SNAP,							// ץͼ  λ1ֱ2֡3ץͼʽ4ץͼļʽ5ͼ
	EN_DEFAULTNIC,						// ֧Ĭѯ λ 1֧
	EN_SHOWQUALITY,						// CBRģʽʾ λ 1:֧
	EN_CONFIG_IMEXPORT,					// õ뵼 λ 1:֧
	EN_LOG,								// Ƿַ֧ҳʽ־ѯ λ 1֧
	EN_SCHEDULE,						// ¼õһЩ λ 1: 2:Ԥ¼ 3:¼ʱ
	EN_NETWORK_TYPE,					// Ͱλʾ 1:̬ 2:߾ 3:CDMA/GPRS 4:CDMA/GPRS
	EN_MARK_IMPORTANTRECORD,			// ʶҪ¼ λ:1Ҫ¼ʶ
	EN_ACFCONTROL,						// ֡ʿ λ1ֻ֧֡ʿ, 2:ֶ֧ʱͻ֡ʿ(ֶ֧),ACF
	EN_MULTIASSIOPTION,					// · λ1֧·, 2:ָ֧ѹʽ
	EN_DAVINCIMODULE,					// ģ λ1ʱֿ 2:׼I֡
	EN_GPS,                             // GPS λ1Gpsλ
	EN_MULTIETHERNET,					// ֶ֧ѯ λ 1֧
	EN_LOGIN_ATTRIBUTE,                 // Login λ1֧LoginԲѯ
	EN_RECORD_GENERAL,					// ¼ λ1ͨ¼2¼3̬¼4ش洢5Զ̴洢6洢7ؽ洢8֧Զ̴洢
	EN_JSON_CONFIG,						// Jsonʽ:λ1֧Jsonʽ, 2: ʹF6NAS, 3: ʹF6Raid, 4ʹF6MotionDetect, 5֧(V3)ͨF6
	EN_HIDE_FUNCTION,					// ιܣλ1PTZ̨, 2: 3Gıʱι
	EN_DISK_DAMAGE,                     // Ӳ̻Ϣ֧: λ1Ӳ̻Ϣѯ֧
	EN_PLAYBACK_SPEED_CTRL,				// ֻ֧طٶȿ:λ:1ֻ֧طż
	EN_HOLIDAYSCHEDULE,					// ּ֧ʱ:λ:1ּ֧ʱ
	EN_FETCH_MONEY_TIMEOUT,				// ATMȡǮʱ
	EN_BACKUP_VIDEO_FORMAT,				// ֵ֧ĸʽλ1:DAV, 2:ASF
	EN_QUERY_DISK_TYPE,                 // ֧ӲͲѯ
	EN_CONFIG_DISPLAY_OUTPUT,           // ֧豸ʾVGAȣ,λ: 1:ָѲ
	EN_SUBBITRATE_RECORD_CTRL,          // ֧չ¼, λ1-¼
	EN_IPV6,                            // ֧IPV6, λ1-IPV6
	EN_SNMP,                            // SNMPЭ飩
	EN_QUERY_URL,                       // ֻ֧ȡ豸URLַ, λ: 1-ѯURLַ
	EN_ISCSI,							// ISCSIInternetСͼϵͳӿã
	EN_RAID,							// ֧Raid
	EN_HARDDISK_INFO,					// ִ֧ϢF5ѯ
	EN_PICINPIC,                        // ֻ֧л λ:1,л; 2,лԤ¼洢ѯ;3,ֻ֧лãͬʱֻ֧лͨѯ
	EN_PLAYBACK_SPEED_CTRL_SUPPORT,     // ͬ EN_PLAYBACK_SPEED_CTRL ֻΪ˼Э
	EN_LF_XDEV,							// ֧243264·LF-XϵУע豸ı㷽ʽ
	EN_DSP_ENCODE_CAP,					// F5 DSPѯ
	EN_MULTICAST,                       // 鲥ѯ
	EM_NET_LIMIT,                       // ѯλ1-緢С                          
	EM_COM422,                          // 422
	EM_PROTOCAL_FRAMEWORK,				// Ƿ֧ЭܣҪʵlistMethod(),listService()ͨF6
	EM_WRITE_DISK_OSD,					// ¼OSD, λ, 1-¼OSD
	EM_DYNAMIC_MULTI_CONNECT,			// ̬, λ, 1-ƵӦ
	EM_CLOUDSERVICE,                    // Ʒ,λ1-֧˽Ʒ
	EM_RECORD_INFO,						// ¼Ϣϱ, λ, 1-¼Ϣϱ, 2-֧¼֡ѯ
	EN_DYNAMIC_REG,                     // עλ1-ֶ֧̬ע
	EM_MULTI_PLAYBACK,                  // ͨԤطţΪ,1-ֶ֧ͨԤط
	EN_ENCODE_CHN,						// ͨ, λ, 1-ִ֧Ƶͨ
    EN_SEARCH_RECORD,                   // ¼ѯ, λ, 1-֧첽ѯ¼, 2-֧Эѯ¼
};

typedef struct 
{
	DWORD IsFucEnable[512];				// б,±Ӧöֵ,λʾӹ
} DH_DEV_ENABLE_INFO;

//////////////////////////////////////////////////////////////////////////
//	Ųѯṹ
typedef struct 
{
	char		IsCardQueryEnable;
	char		iRev[3];
} DH_CARD_QUERY_EN;

//////////////////////////////////////////////////////////////////////////
//	wirelessṹ
typedef struct 
{
	char		IsWirelessEnable;
	char		iRev[3];
} DH_WIRELESS_EN;

//////////////////////////////////////////////////////////////////////////
//	ͼˮӡṹ
typedef struct 
{
	char		isSupportWM;			// 1 ֧֣0 ֧
	char		supportWhat;			// 0ˮӡ1ͼƬˮӡ2ͬʱ֧ˮӡͼƬˮӡ
	char		reserved[2];
} DH_WATERMAKE_EN;

//////////////////////////////////////////////////////////////////////////
//	໭Ԥṹ
typedef struct  
{
	int			nEnable;				// 1 ֧֣0 ֧
	DWORD		dwMultiPlayMask;		// ໭Ԥ
	char		reserved[4];			// 
} DH_MULTIPLAY_EN;

//////////////////////////////////////////////////////////////////////////
//	߱ṹ
typedef struct  
{
	BOOL		bSupport;				// Ƿ֧
	int			nAlarmInCount;			// 
	int			nAlarmOutCount;			// 
	int			nRemoteAddrCount;		// ң
	BYTE		reserved[32];
} DH_WIRELESS_ALARM_INFO;

//////////////////////////////////////////////////////////////////////////
//	Ӳ̷ṹ
typedef struct 
{
	BOOL		bSupported;				// Ƿ֧Ӳ̷
	int			nSupportNum;			// ַ֧Ŀ
	BYTE		bReserved[32];			// ֽ
} DH_DISK_SUBAREA_EN;

//	DSPѯDSP㷨ʶΪ2ʱʹá
typedef struct  
{
	BYTE		bMainFrame[32];			// Էֱöֵ(CAPTURE_SIZE)Ϊ,ֱʶӦֵ֧֡,ִ֧˷ֱ,ֵΪ0.
	BYTE		bExtraFrame_1[32];		// 1,ʹͬbMainFrame
	BYTE		bReserved[128];			// Ԥ23.		
} DH_DSP_CFG_ITEM;

typedef struct  
{
	int			nItemNum;				// DH_DSP_CFG_ITEMЧ,ͨ
	DH_DSP_CFG_ITEM	stuDspCfgItem[32];	// Ϣ
	BYTE		bReserved[128];			// 
} DH_DSP_CFG; 

//////////////////////////////////////////////////////////////////////////
//	ٲѯṹ
typedef struct 
{
	char		IsQuickQueryEnable;		// 1豸֧ٷأʱ㹻Ա֤խõȡ60S
	char		iRev[3];
} DH_QUICK_QUERY_CFG_EN;

typedef struct  
{
	int			nStreamType;			// 0, 1,SIP 2,RTSP
	BYTE		bReserved[16];			// 
} DH_STREAM_MEDIA_EN;

//ѯ
typedef struct
{
	char		IsIntelliTrackerEnable;		// 0ʾ
	BYTE		bReserved[3];
}DH_INTELLI_TRACKER_EN;

//////////////////////////////////////////////////////////////////////////
// RPC
//////////////////////////////////////////////////////////////////////////

#define RPC_METHOD_MONITORWALL_ADD      "monitorWallManager.addMonitorWall"     // ӵǽ


/***********************************************************************
 ** ص
 ***********************************************************************/

// ӶϿصԭ
typedef void (CALLBACK *fDisConnect)(LLONG lLoginID, char *pchDVRIP, LONG nDVRPort, LDWORD dwUser);

// ӻָصԭ
typedef void (CALLBACK *fHaveReConnect)(LLONG lLoginID, char *pchDVRIP, LONG nDVRPort, LDWORD dwUser);

// ̬ӶϿصԭ
typedef void (CALLBACK *fSubDisConnect)(EM_INTERFACE_TYPE emInterfaceType, BOOL bOnline, LLONG lOperateHandle, LLONG lLoginID, LDWORD dwUser);

// ƵӶϿصԭ, 
typedef void (CALLBACK *fRealPlayDisConnect)(LLONG lOperateHandle, EM_REALPLAY_DISCONNECT_EVENT_TYPE dwEventType, void* param, LDWORD dwUser);

// ʵʱݻصԭ
typedef void (CALLBACK *fRealDataCallBack)(LLONG lRealHandle, DWORD dwDataType, BYTE *pBuffer, DWORD dwBufSize, LDWORD dwUser);

// ʵʱݻصԭ--չ
typedef void (CALLBACK *fRealDataCallBackEx)(LLONG lRealHandle, DWORD dwDataType, BYTE *pBuffer, DWORD dwBufSize, LONG param, LDWORD dwUser);

// Ļӻصԭ
typedef void (CALLBACK *fDrawCallBack)(LLONG lLoginID, LLONG lPlayHandle, HDC hDC, LDWORD dwUser);

// طŽȻصԭ
typedef void (CALLBACK *fDownLoadPosCallBack)(LLONG lPlayHandle, DWORD dwTotalSize, DWORD dwDownLoadSize, LDWORD dwUser);

// ʱطŽȻصԭ
typedef void (CALLBACK *fTimeDownLoadPosCallBack) (LLONG lPlayHandle, DWORD dwTotalSize, DWORD dwDownLoadSize, int index, NET_RECORDFILE_INFO recordfileinfo, LDWORD dwUser);

// Ϣصԭ
typedef BOOL (CALLBACK *fMessCallBack)(LONG lCommand, LLONG lLoginID, char *pBuf, DWORD dwBufLen, char *pchDVRIP, LONG nDVRPort, LDWORD dwUser);

// صԭ
typedef int (CALLBACK *fServiceCallBack)(LLONG lHandle, char *pIp, WORD wPort, LONG lCommand, void *pParam, DWORD dwParamLen, LDWORD dwUserData);

// ԽƵݻصԭ
typedef void (CALLBACK *pfAudioDataCallBack)(LLONG lTalkHandle, char *pDataBuf, DWORD dwBufSize, BYTE byAudioFlag, LDWORD dwUser);

// 豸صԭ
typedef void (CALLBACK *fUpgradeCallBack) (LLONG lLoginID, LLONG lUpgradechannel, int nTotalSize, int nSendSize, LDWORD dwUser);

// ͸ڻصԭ
typedef void (CALLBACK *fTransComCallBack) (LLONG lLoginID, LLONG lTransComChannel, char *pBuffer, DWORD dwBufSize, LDWORD dwUser);

// ѯ豸־ݻصԭ
typedef void (CALLBACK *fLogDataCallBack)(LLONG lLoginID, char *pBuffer, DWORD dwBufSize, DWORD nTotalSize, BOOL bEnd, LDWORD dwUser);

// ץͼصԭ
typedef void (CALLBACK *fSnapRev)(LLONG lLoginID, BYTE *pBuf, UINT RevLen, UINT EncodeType, DWORD CmdSerial, LDWORD dwUser);

// GPSϢĻص
typedef void (CALLBACK *fGPSRev)(LLONG lLoginID, GPS_Info GpsInfo, LDWORD dwUserData);

// GPSϢĻص--չ
typedef void (CALLBACK *fGPSRevEx)(LLONG lLoginID, GPS_Info GpsInfo, ALARM_STATE_INFO stAlarmInfo, LDWORD dwUserData, void *reserved);

// GPSʪϢĻص
typedef void (CALLBACK *fGPSTempHumidityRev)(LLONG lLoginID, GPS_TEMP_HUMIDITY_INFO GpsTHInfo, LDWORD dwUserData);

// 첽ݻص
typedef void (CALLBACK *fMessDataCallBack)(LLONG lCommand, LPNET_CALLBACK_DATA lpData, LDWORD dwUser);

// ļص
typedef void (CALLBACK *fTransFileCallBack)(LLONG lHandle, int nTransType, int nState, int nSendSize, int nTotalSize, LDWORD dwUser);

// ܷݻص;nSequenceʾϴͬͼƬΪ0ʱʾǵһγ֣Ϊ2ʾһγֻһΣΪ1ʾ˴֮
// int nState = (int*) reserved ʾǰصݵ״̬, Ϊ0ʾǰΪʵʱݣΪ1ʾǰصݣΪ2ʱʾݴͽ
typedef int  (CALLBACK *fAnalyzerDataCallBack)(LLONG lAnalyzerHandle, DWORD dwAlarmType, void* pAlarmInfo, BYTE *pBuffer, DWORD dwBufSize, LDWORD dwUser, int nSequence, void *reserved);

// 첽豸ص
typedef void (CALLBACK *fSearchDevicesCB)(DEVICE_NET_INFO_EX *pDevNetInfo, void* pUserData);

// 첽ע豸صԭ
// typedef void (CALLBACK *fHaveLogin)(LLONG lLoginID, char *pchDVRIP, LONG nDVRPort, BOOL bOnline, NET_DEVICEINFO_Ex stuDeviceInfo, int nError, LDWORD dwUser, void *reserved);

// طYUVݻص
typedef void (CALLBACK *fYUVDataCallBack)(LLONG lPlaybackHandle, BYTE *pBuffer, DWORD dwBufSize, LONG param, LDWORD dwUser, void *reserved);

/************************************************************************
 ** ӿڶ
 ***********************************************************************/

// SDKʼ
CLIENT_API BOOL CALL_METHOD CLIENT_Init(fDisConnect cbDisConnect, LDWORD dwUser);

// SDK˳
CLIENT_API void CALL_METHOD CLIENT_Cleanup();

//------------------------------------------------------------------------

// öɹصúSDKڲԶ
CLIENT_API void CALL_METHOD CLIENT_SetAutoReconnect(fHaveReConnect cbAutoConnect, LDWORD dwUser);

// ö̬Ӷ߻صĿǰSVR豸ļӺͻطǶӵġ
CLIENT_API void CALL_METHOD CLIENT_SetSubconnCallBack(fSubDisConnect cbSubDisConnect, LDWORD dwUser);

// غִʧܴ
CLIENT_API DWORD CALL_METHOD CLIENT_GetLastError(void);

// 豸ʱʱͳԴ
CLIENT_API void CALL_METHOD CLIENT_SetConnectTime(int nWaitTime, int nTryTimes);

// õ½绷
CLIENT_API void CALL_METHOD CLIENT_SetNetworkParam(NET_PARAM *pNetParam);

// ȡSDKİ汾Ϣ
CLIENT_API DWORD CALL_METHOD CLIENT_GetSDKVersion();

//------------------------------------------------------------------------

// 豸ע
CLIENT_API LLONG CALL_METHOD CLIENT_Login(char *pchDVRIP, WORD wDVRPort, char *pchUserName, char *pchPassword, LPNET_DEVICEINFO lpDeviceInfo, int *error = 0);

// չӿڣnSpecCap = 0ΪTCPʽµĵ룬nSpecCap = 2Ϊעĵ룬nSpecCap = 3Ϊ鲥ʽµĵ룬
//             nSpecCap = 4ΪUDPʽµĵ룬nSpecCap = 6Ϊֻµĵ룬nSpecCap = 7ΪSSL
//             nSpecCap = 8Ϊɶѷ½
//             nSpecCap = 9Ϊ¼Զ豸ʱvoid* pCapParamԶ豸ֵַ
//           nSpecCap = 12ΪLDAPʽ¼
//           nSpecCap = 13ΪADʽ¼
//           nSpecCap = 14ΪRadius¼ʽ 
//             nSpecCap = 15ΪSocks5½ʽʱvoid* pCapParamSocks5IP&&port&&ServerName&&ServerPasswordַ
//             nSpecCap = 16Ϊ½ʽʱvoid* pCapParamSOCKETֵ
//             nSpecCap = 19ΪP2P½ʽ
//             nSpecCap = 20Ϊֻͻ˵
CLIENT_API LLONG CALL_METHOD CLIENT_LoginEx(char *pchDVRIP, WORD wDVRPort, char *pchUserName, char *pchPassword, int nSpecCap, void* pCapParam, LPNET_DEVICEINFO lpDeviceInfo, int *error = 0);

// չӿ
CLIENT_API LLONG CALL_METHOD CLIENT_LoginEx2(char *pchDVRIP, WORD wDVRPort, char *pchUserName, char *pchPassword, EM_LOGIN_SPAC_CAP_TYPE emSpecCap, void* pCapParam, LPNET_DEVICEINFO_Ex lpDeviceInfo, int *error = 0);

// 첽豸ע 
// nSpecCap = 0ΪTCPʽµĵ,nSpecCap = 6Ϊֻµĵ
// nSpecCap = 19ΪP2P¼
CLIENT_API LLONG CALL_METHOD CLIENT_StartLogin(char *pchDVRIP, WORD wDVRPort, char *pchUserName, char *pchPassword, int nSpecCap, void* pCapParam, fHaveLogin cbLogin, LDWORD dwUser);

// ֻеCLIENT_StartLogin()ĻصΪ11ʱʹøýӿڼ첽½
CLIENT_API LLONG CALL_METHOD CLIENT_StartLoginEx(NET_IN_STARTLOGINEX* pInParam, NET_OUT_STARTLOGINEX* pOutParam);

// ֹͣ豸ע
CLIENT_API BOOL CALL_METHOD CLIENT_StopLogin(LLONG lLoginID);

CLIENT_API BOOL CALL_METHOD CLIENT_StopLoginEx(LLONG lLoginID);

// 豸ע
CLIENT_API BOOL CALL_METHOD CLIENT_Logout(LLONG lLoginID);


//------------------------------------------------------------------------

// ʼʵʱ
CLIENT_API LLONG CALL_METHOD CLIENT_RealPlay(LLONG lLoginID, int nChannelID, HWND hWnd);

// ʼʵʱ--չ
// ໭ԤʱnChannelID NVR豸Ƶͨ
CLIENT_API LLONG CALL_METHOD CLIENT_RealPlayEx(LLONG lLoginID, int nChannelID, HWND hWnd, DH_RealPlayType rType = DH_RType_Realplay);

//ʵʱӣ0ʾʧ
CLIENT_API LLONG CALL_METHOD CLIENT_StartRealPlay(LLONG lLoginID, int nChannelID, HWND hWnd, DH_RealPlayType rType, fRealDataCallBackEx cbRealData, fRealPlayDisConnect cbDisconnect, LDWORD dwUser, DWORD dwWaitTime = 10000);

// ໭ʵʱԤ
CLIENT_API LLONG CALL_METHOD CLIENT_MultiPlay(LLONG lLoginID, HWND hWnd);

// ֹͣ໭ʵʱԤ
CLIENT_API BOOL CALL_METHOD CLIENT_StopMultiPlay(LLONG lMultiHandle);

// ץͼhPlayHandleΪӻطž
CLIENT_API BOOL CALL_METHOD CLIENT_CapturePicture(LLONG hPlayHandle, const char *pchPicFileName);
CLIENT_API BOOL CALL_METHOD CLIENT_CapturePictureEx(LLONG hPlayHandle, const char *pchPicFileName, NET_CAPTURE_FORMATS eFormat);

// ʵʱݻص
CLIENT_API BOOL CALL_METHOD CLIENT_SetRealDataCallBack(LLONG lRealHandle, fRealDataCallBack cbRealData, LDWORD dwUser);

// ʵʱݻص--չ
CLIENT_API BOOL CALL_METHOD CLIENT_SetRealDataCallBackEx(LLONG lRealHandle, fRealDataCallBackEx cbRealData, LDWORD dwUser, DWORD dwFlag);

// ͼ
CLIENT_API BOOL    CALL_METHOD CLIENT_AdjustFluency(LLONG lRealHandle, int nLevel);

// Ϊļ
CLIENT_API BOOL CALL_METHOD CLIENT_SaveRealData(LLONG lRealHandle, const char *pchFileName);

// Ϊļ
CLIENT_API BOOL CALL_METHOD CLIENT_StopSaveRealData(LLONG lRealHandle);

// ͼ
CLIENT_API BOOL CALL_METHOD CLIENT_ClientSetVideoEffect(LLONG lPlayHandle, unsigned char nBrightness, unsigned char nContrast, unsigned char nHue, unsigned char nSaturation);

// ȡͼ
CLIENT_API BOOL CALL_METHOD CLIENT_ClientGetVideoEffect(LLONG lPlayHandle, unsigned char *nBrightness, unsigned char *nContrast, unsigned char *nHue, unsigned char *nSaturation);

// Ļӻص
CLIENT_API void CALL_METHOD CLIENT_RigisterDrawFun(fDrawCallBack cbDraw, LDWORD dwUser);

// 
CLIENT_API BOOL CALL_METHOD CLIENT_OpenSound(LLONG hPlayHandle);

// lPlayHandleΪӻطž
CLIENT_API BOOL CALL_METHOD CLIENT_SetVolume(LLONG lPlayHandle, int nVolume);

// ǷøͼڲԣĬáòʱڿ4ʱֻI֡ʱÿ֡
CLIENT_API BOOL CALL_METHOD CLIENT_PlayEnableLargePicAdjustment(LLONG lPlayHandle, BOOL bEnable);

// ر
CLIENT_API BOOL CALL_METHOD CLIENT_CloseSound();

// ֹͣʵʱԤ
CLIENT_API BOOL CALL_METHOD CLIENT_StopRealPlay(LLONG lRealHandle);

// ֹͣʵʱԤ--չ
CLIENT_API BOOL CALL_METHOD CLIENT_StopRealPlayEx(LLONG lRealHandle);

//------------------------------------------------------------------------

// ̨ͨ
CLIENT_API BOOL CALL_METHOD CLIENT_PTZControl(LLONG lLoginID, int nChannelID, DWORD dwPTZCommand, DWORD dwStep, BOOL dwStop);

// ˽̨
CLIENT_API BOOL CALL_METHOD CLIENT_DHPTZControl(LLONG lLoginID, int nChannelID, DWORD dwPTZCommand, unsigned char param1, unsigned char param2, unsigned char param3, BOOL dwStop,void* param4=NULL);

// ˽̨չӿڣ֧άٶλ
CLIENT_API BOOL CALL_METHOD CLIENT_DHPTZControlEx(LLONG lLoginID, int nChannelID, DWORD dwPTZCommand, LONG lParam1, LONG lParam2, LONG lParam3, BOOL dwStop );

// ˽̨չӿڣ֧άٶλ,
CLIENT_API BOOL CALL_METHOD CLIENT_DHPTZControlEx2(LLONG lLoginID, int nChannelID, DWORD dwPTZCommand, LONG lParam1, LONG lParam2, LONG lParam3, BOOL dwStop , void* param4 = NULL);

//------------------------------------------------------------------------
// ѯĳµĸǷ¼ļ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryRecordStatus(LLONG lLoginID, int nChannelId, int nRecordFileType, LPNET_TIME tmMonth, char* pchCardid, LPNET_RECORD_STATUS pRecordStatus, int waittime=1000);
// ѯʱǷ¼ļ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryRecordTime(LLONG lLoginID, int nChannelId, int nRecordFileType, LPNET_TIME tmStart, LPNET_TIME tmEnd, char* pchCardid, BOOL *bResult, int waittime=1000);
// ѯʱڵ¼ļ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryRecordFile(LLONG lLoginID, int nChannelId, int nRecordFileType, LPNET_TIME tmStart, LPNET_TIME tmEnd, char* pchCardid, LPNET_RECORDFILE_INFO nriFileinfo, int maxlen, int *filecount, int waittime=1000, BOOL bTime = FALSE);

// 첽ѯʱڵ¼ļ
CLIENT_API BOOL CALL_METHOD CLIENT_StartQueryRecordFile(LLONG lLoginID, NET_IN_START_QUERY_RECORDFILE *pInParam, NET_OUT_START_QUERY_RECORDFILE *pOutParam);

// ٲѯʱڵ¼ļʱ¼񳬹16ʱֻʱ16¼
CLIENT_API BOOL CALL_METHOD CLIENT_QuickQueryRecordFile(LLONG lLoginID, int nChannelId, int nRecordFileType, LPNET_TIME tmStart, LPNET_TIME tmEnd, char* pchCardid, LPNET_RECORDFILE_INFO nriFileinfo, int maxlen, int *filecount, int waittime=1000, BOOL bTime = FALSE);

// ѯ¼ʱ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryFurthestRecordTime(LLONG lLoginID, int nRecordFileType, char *pchCardid, NET_FURTHEST_RECORD_TIME* pFurthrestTime, int nWaitTime);

// ʼ¼ļ
CLIENT_API LLONG    CALL_METHOD CLIENT_FindFile(LLONG lLoginID, int nChannelId, int nRecordFileType, char* cardid, LPNET_TIME time_start, LPNET_TIME time_end, BOOL bTime, int waittime);

// ¼ļ
CLIENT_API int    CALL_METHOD CLIENT_FindNextFile(LLONG lFindHandle,LPNET_RECORDFILE_INFO lpFindData);

// ¼ļ
CLIENT_API BOOL CALL_METHOD CLIENT_FindClose(LLONG lFindHandle);

// ļʽط
CLIENT_API LLONG CALL_METHOD CLIENT_PlayBackByRecordFile(LLONG lLoginID, LPNET_RECORDFILE_INFO lpRecordFile, HWND hWnd, fDownLoadPosCallBack cbDownLoadPos, LDWORD dwUserData);

// ļʽط--չ
CLIENT_API LLONG CALL_METHOD CLIENT_PlayBackByRecordFileEx(LLONG lLoginID, LPNET_RECORDFILE_INFO lpRecordFile, HWND hWnd, fDownLoadPosCallBack cbDownLoadPos, LDWORD dwPosUser, fDataCallBack fDownLoadDataCallBack, LDWORD dwDataUser);

// ļʽط--صطж¼
CLIENT_API LLONG CALL_METHOD CLIENT_StartPlayBackByRecordFile(LLONG lLoginID,  LPNET_RECORDFILE_INFO lpRecordFile, HWND hWnd, 
                                                             fDownLoadPosCallBack cbDownLoadPos, LDWORD dwPosUser, 
                                                             fDataCallBack fDownLoadDataCallBack, LDWORD dwDataUser, 
                                                             fRealPlayDisConnect fDisConnectCallBack, LDWORD dwDisUser, DWORD dwWaitTime = 10000);

//ļʽط--֡(ʱʹ)
CLIENT_API LLONG CALL_METHOD CLIENT_FramCotrolPlayBackByRecordFile(LLONG lLoginID, LPNET_RECORDFILE_INFO lpRecordFile, HWND hWnd, 
                                                                   fDownLoadPosCallBack cbDownLoadPos, LDWORD dwPosUser, 
                                                                   fDataCallBack fDownLoadDataCallBack, LDWORD dwDataUser, unsigned int nCutFrameRate);

// ʱ䷽ʽط
CLIENT_API LLONG CALL_METHOD CLIENT_PlayBackByTime(LLONG lLoginID, int nChannelID, LPNET_TIME lpStartTime, LPNET_TIME lpStopTime, HWND hWnd, fDownLoadPosCallBack cbDownLoadPos, LDWORD dwPosUser);

// ʱ䷽ʽط--չ
CLIENT_API LLONG CALL_METHOD CLIENT_PlayBackByTimeEx(LLONG lLoginID, int nChannelID, LPNET_TIME lpStartTime, LPNET_TIME lpStopTime, HWND hWnd, 
                                                     fDownLoadPosCallBack cbDownLoadPos, LDWORD dwPosUser, 
                                                     fDataCallBack fDownLoadDataCallBack, LDWORD dwDataUser);

// ʱ䷽ʽط--صطж¼
CLIENT_API LLONG CALL_METHOD CLIENT_StartPlayBackByTime(LLONG lLoginID, int nChannelID, 
                                                       LPNET_TIME lpStartTime, LPNET_TIME lpStopTime, HWND hWnd, 
                                                       fDownLoadPosCallBack cbDownLoadPos, LDWORD dwPosUser,
                                                       fDataCallBack fDownLoadDataCallBack, LDWORD dwDataUser, 
                                                       fRealPlayDisConnect fDisConnectCallBack, LDWORD dwDisUser, DWORD dwWaitTime = 10000);

//ʱ䷽ʽط--֡(ʱʹ)
CLIENT_API LLONG CALL_METHOD CLIENT_FramCotrolPlayBackByTime(LLONG lLoginID, int nChannelID, LPNET_TIME lpStartTime, LPNET_TIME lpStopTime, HWND hWnd, 
                                                             fDownLoadPosCallBack cbDownLoadPos, LDWORD dwPosUser, 
                                                             fDataCallBack fDownLoadDataCallBack, LDWORD dwDataUser, unsigned int nCutFrameRate);

//ƵŨļط
CLIENT_API LLONG CALL_METHOD CLIENT_PlayBackBySynopsisFile(LLONG lLoginID, 
                                                            LPNET_SYNOPSISFILE_INFO lpRecordFile, 
                                                            HWND hWnd, 
                                                            fDownLoadPosCallBack cbDownLoadPos,
                                                            LDWORD dwPosUser, 
                                                            fDataCallBack fDownLoadDataCallBack,
                                                            LDWORD dwDataUser,
                                                            LDWORD dwUser);
                                                            
// ͨԤط
CLIENT_API LLONG CALL_METHOD CLIENT_MultiPlayBack(LLONG lLoginID, NET_MULTI_PLAYBACK_PARAM *pParam);

// λ¼طʼ
CLIENT_API BOOL CALL_METHOD CLIENT_SeekPlayBack(LLONG lPlayHandle, unsigned int offsettime, unsigned int offsetbyte);

// ָͣ¼ط
CLIENT_API BOOL CALL_METHOD CLIENT_PausePlayBack(LLONG lPlayHandle, BOOL bPause);

// ¼ط
CLIENT_API BOOL CALL_METHOD CLIENT_FastPlayBack(LLONG lPlayHandle);

// ¼ط
CLIENT_API BOOL CALL_METHOD CLIENT_SlowPlayBack(LLONG lPlayHandle);

// ¼ط
CLIENT_API BOOL CALL_METHOD CLIENT_StepPlayBack(LLONG lPlayHandle, BOOL bStop);

// Ʋŷ--Żߵ
// bBackward FLASE ţTRUE 
CLIENT_API BOOL CALL_METHOD CLIENT_PlayBackControlDirection(LLONG lPlayHandle, BOOL bBackward);

// ûط֡
CLIENT_API BOOL CALL_METHOD CLIENT_SetFramePlayBack(LLONG lPlayHandle, int framerate);

// ȡط֡
CLIENT_API BOOL CALL_METHOD CLIENT_GetFramePlayBack(LLONG lPlayHandle, int *fileframerate, int *playframerate);

// ָطٶ
CLIENT_API BOOL CALL_METHOD CLIENT_NormalPlayBack(LLONG lPlayHandle);

// ܼط
CLIENT_API BOOL CALL_METHOD CLIENT_SmartSearchPlayBack(LLONG lPlayHandle, LPIntelligentSearchPlay lpPlayBackParam);

// ȡطOSDʱ
CLIENT_API BOOL CALL_METHOD CLIENT_GetPlayBackOsdTime(LLONG lPlayHandle, LPNET_TIME lpOsdTime, LPNET_TIME lpStartTime, LPNET_TIME lpEndTime);

// ֹͣ¼ط
CLIENT_API BOOL CALL_METHOD CLIENT_StopPlayBack(LLONG lPlayHandle);

// ¼ļ
CLIENT_API LLONG CALL_METHOD CLIENT_DownloadByRecordFile(LLONG lLoginID,LPNET_RECORDFILE_INFO lpRecordFile, char *sSavedFileName, fDownLoadPosCallBack cbDownLoadPos, LDWORD dwUserData);

// ͨʱ¼
CLIENT_API LLONG CALL_METHOD CLIENT_DownloadByTime(LLONG lLoginID, int nChannelId, int nRecordFileType, LPNET_TIME tmStart, LPNET_TIME tmEnd, char *sSavedFileName, fTimeDownLoadPosCallBack cbTimeDownLoadPos, LDWORD dwUserData);

// ѯ¼ؽ
CLIENT_API BOOL CALL_METHOD CLIENT_GetDownloadPos(LLONG lFileHandle, int *nTotalSize, int *nDownLoadSize);

// ֹͣ¼
CLIENT_API BOOL CALL_METHOD CLIENT_StopDownload(LLONG lFileHandle);

//ֲŴ
CLIENT_API BOOL CALL_METHOD CLIENT_SetDisplayRegion(LLONG lPlayHandle,DWORD nRegionNum, DH_DISPLAYRREGION *pSrcRect, HWND hDestWnd, BOOL bEnable);

// ʼ¼ļ֡Ϣ
CLIENT_API BOOL    CALL_METHOD CLIENT_FindFrameInfo(LLONG lLoginID, NET_IN_FIND_FRAMEINFO_PRAM *pInParam, NET_OUT_FIND_FRAMEINFO_PRAM* pOutParam, int nWaitTime);

// ¼ļ֡ϢָϢѯ
CLIENT_API BOOL    CALL_METHOD CLIENT_FindNextFrameInfo(LLONG lFindHandle, NET_IN_FINDNEXT_FRAMEINFO_PRAM *pInParam, NET_OUT_FINDNEXT_FRAMEINFO_PRAM* pOutParam, int nWaitTime);

// ¼ļ
CLIENT_API BOOL CALL_METHOD CLIENT_FindFrameInfoClose(LLONG lFindHandle);

//------------------------------------------------------------------------

// ñص
CLIENT_API void CALL_METHOD CLIENT_SetDVRMessCallBack(fMessCallBack cbMessage,LDWORD dwUser);

// 豸ı
CLIENT_API BOOL CALL_METHOD CLIENT_StartListen(LLONG lLoginID);

// 豸ı--չ
CLIENT_API BOOL CALL_METHOD CLIENT_StartListenEx(LLONG lLoginID);

// ֹͣı
CLIENT_API BOOL CALL_METHOD CLIENT_StopListen(LLONG lLoginID);

// λ
CLIENT_API BOOL CALL_METHOD CLIENT_AlarmReset(LLONG lLoginID, DWORD dwAlarmType, int nChannel, void* pReserved = NULL, int nWaitTime = 1000);

//------------------------------------------------------------------------
 
// עṦܣnTimeoutЧ
CLIENT_API LLONG CALL_METHOD CLIENT_ListenServer(char* ip, WORD port, int nTimeout, fServiceCallBack cbListen, LDWORD dwUserData);

// ֹͣ
CLIENT_API BOOL CALL_METHOD CLIENT_StopListenServer(LLONG lServerHandle);

// Ӧ豸ע
CLIENT_API BOOL CALL_METHOD CLIENT_ResponseDevReg(char *devSerial, char* ip, WORD port, BOOL bAccept);

//------------------------------------------------------------------------

// ϴܣdwTimeOutЧ
CLIENT_API LLONG CALL_METHOD CLIENT_StartService(WORD wPort, char *pIp = NULL, fServiceCallBack pfscb = NULL, DWORD dwTimeOut = 0xffffffff, LDWORD dwUserData = 0);

// ֹͣ
CLIENT_API BOOL CALL_METHOD CLIENT_StopService(LLONG lHandle);

//------------------------------------------------------------------------

// Խģʽͻ˷ʽǷʽ
CLIENT_API BOOL CALL_METHOD CLIENT_SetDeviceMode(LLONG lLoginID, EM_USEDEV_MODE emType, void* pValue);

// Խ
CLIENT_API LLONG CALL_METHOD CLIENT_StartTalkEx(LLONG lLoginID, pfAudioDataCallBack pfcb, LDWORD dwUser);

// ʼPC¼
CLIENT_API BOOL CALL_METHOD CLIENT_RecordStart();

// PC¼
CLIENT_API BOOL CALL_METHOD CLIENT_RecordStop();


// ʼPC¼(CLIENT_RecordStart()չ)
CLIENT_API BOOL CALL_METHOD CLIENT_RecordStartEx(LLONG lLoginID);

// PC¼(CLIENT_RecordStop()չ)
CLIENT_API BOOL CALL_METHOD CLIENT_RecordStopEx(LLONG lLoginID);


// ݵ豸
CLIENT_API LONG  CALL_METHOD CLIENT_TalkSendData(LLONG lTalkHandle, char *pSendBuf, DWORD dwBufSize);

// Ƶ
CLIENT_API void CALL_METHOD CLIENT_AudioDec(char *pAudioDataBuf, DWORD dwBufSize);
CLIENT_API BOOL CALL_METHOD CLIENT_AudioDecEx(LLONG lTalkHandle, char *pAudioDataBuf, DWORD dwBufSize);

// Խ
CLIENT_API BOOL CALL_METHOD CLIENT_SetAudioClientVolume(LLONG lTalkHandle, WORD wVolume);

// ֹͣԽ
CLIENT_API BOOL CALL_METHOD CLIENT_StopTalkEx(LLONG lTalkHandle);

// 豸㲥
CLIENT_API BOOL CALL_METHOD CLIENT_AudioBroadcastAddDev(LLONG lLoginID);

// ӹ㲥ɾ豸
CLIENT_API BOOL CALL_METHOD CLIENT_AudioBroadcastDelDev(LLONG lLoginID);

// Ƶ--ʼ(ض׼ʽ->˽иʽ)
CLIENT_API int  CALL_METHOD CLIENT_InitAudioEncode(DH_AUDIO_FORMAT aft);

// Ƶ--ݱ
CLIENT_API int    CALL_METHOD    CLIENT_AudioEncode(LLONG lTalkHandle, BYTE *lpInBuf, DWORD *lpInLen, BYTE *lpOutBuf, DWORD *lpOutLen);

// Ƶ--˳
CLIENT_API int    CALL_METHOD    CLIENT_ReleaseAudioEncode();

//------------------------------------------------------------------------

// ѯ豸־
CLIENT_API BOOL CALL_METHOD CLIENT_QueryLog(LLONG lLoginID, char *pLogBuffer, int maxlen, int *nLogBufferlen, int waittime=3000);

// ѯ豸־Էҳʽѯ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryDeviceLog(LLONG lLoginID, QUERY_DEVICE_LOG_PARAM *pQueryParam, char *pLogBuffer, int nLogBufferLen, int *pRecLogNum, int waittime=3000);

// ѯ豸־
CLIENT_API BOOL CALL_METHOD CLIENT_QueryDevLogCount(LLONG lLoginID, NET_IN_GETCOUNT_LOG_PARAM *pInParam, NET_OUT_GETCOUNT_LOG_PARAM* pOutParam , int waittime=3000);

// ͨ¼״̬
CLIENT_API BOOL CALL_METHOD CLIENT_QueryRecordState(LLONG lLoginID, char *pRSBuffer, int maxlen, int *nRSBufferlen, int waittime=1000);

// ͨ¼״ֽ̬ͨӦ, ÿֽڱʾӦͨĸ¼״̬0-ر,1-ֶ,2-Զ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryExtraRecordState(LLONG lLoginID, char *pRSBuffer, int maxlen, int *nRSBufferlen, void *pReserved, int waittime=1000);

// ѯ豸״̬
CLIENT_API BOOL CALL_METHOD CLIENT_QueryDevState(LLONG lLoginID, int nType, char *pBuf, int nBufLen, int *pRetLen, int waittime=1000);

// ѯԶ豸״̬,nTypeΪDH_DEVSTATE_ALARM_FRONTDISCONNECTʱͨŴ1ʼ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryRemotDevState(LLONG lLoginID, int nType, int nChannelID, char *pBuf, int nBufLen, int *pRetLen, int waittime=1000);

// ѯϵͳϢ
CLIENT_API BOOL CALL_METHOD CLIENT_QuerySystemInfo(LLONG lLoginID, int nSystemType, char *pSysInfoBuffer, int maxlen, int *nSysInfolen, int waittime=1000);

// ϵͳѯӿڣѯϵͳϢ(JsonʽSDK)
CLIENT_API BOOL CALL_METHOD CLIENT_QueryNewSystemInfo(LLONG lLoginID, char* szCommand, int nChannelID, char* szOutBuffer, DWORD dwOutBufferSize, int *error, int waittime=1000);

// ȡͨ
CLIENT_API LONG  CALL_METHOD CLIENT_GetStatiscFlux(LLONG lLoginID, LLONG  lPlayHandle);

// ȡ̨Ϣ
CLIENT_API BOOL  CALL_METHOD CLIENT_GetPtzOptAttr(LLONG lLoginID,DWORD dwProtocolIndex,LPVOID lpOutBuffer,DWORD dwBufLen,DWORD *lpBytesReturned,int waittime=500);

// 豸, ӦCLIENT_GetDevCapsӿ
#define NET_DEV_CAP_SEQPOWER            0x01                // Դʱ, pInBuf=NET_IN_CAP_SEQPOWER*, pOutBuf=NET_OUT_CAP_SEQPOWER*
#define NET_ENCODE_CFG_CAPS             0x02                // 豸öӦ, pInBuf=NET_IN_ENCODE_CFG_CAPS*, pOutBuf= NET_OUT_ENCODE_CFG_CAPS*
#define NET_VIDEOIN_FISHEYE_CAPS        0x03                // , pInBuf=NET_IN_VIDEOIN_FISHEYE_CAPS*, pOutBuf=NET_OUT_VIDEOIN_FISHEYE_CAPS*

// ȡ豸
CLIENT_API BOOL  CALL_METHOD CLIENT_GetDevCaps(LLONG lLoginID, int nType, void* pInBuf, void* pOutBuf, int nWaitTime);

// 豸ϢͣӦCLIENT_QueryDevInfoӿ
#define NET_QUERY_DEV_STORAGE_NAMES            0x01                // ѯ豸Ĵ洢ģб , pInBuf=NET_IN_STORAGE_DEV_NAMES *, pOutBuf=NET_OUT_STORAGE_DEV_NAMES *
#define NET_QUERY_DEV_STORAGE_INFOS            0x02                // ѯ豸Ĵ洢ģϢб, pInBuf=NET_IN_STORAGE_DEV_INFOS*, pOutBuf= NET_OUT_STORAGE_DEV_INFOS *
#define NET_QUERY_RECENCY_JNNCTION_CAR_INFO    0x03                // ѯĿڳϢӿ, pInBuf=NET_IN_GET_RECENCY_JUNCTION_CAR_INFO*, pOutBuf=NET_OUT_GET_RECENCY_JUNCTION_CAR_INFO*
#define NET_QUERY_LANES_STATE                  0x04             // ѯϢ,pInBuf = NET_IN_GET_LANES_STATE , pOutBuf = NET_OUT_GET_LANES_STATE
#define NET_QUERY_DEV_FISHEYE_WININFO          0x05                // ѯ۴Ϣ , pInBuf= NET_IN_FISHEYE_WININFO*, pOutBuf=NET_OUT_FISHEYE_WININFO *

// ѯ豸Ϣ
CLIENT_API BOOL  CALL_METHOD CLIENT_QueryDevInfo(LLONG lLoginID, int nQueryType, void* pInBuf, void* pOutBuf, void *pReserved = NULL , int nWaitTime = 1000);
//------------------------------------------------------------------------

// 豸
CLIENT_API BOOL CALL_METHOD CLIENT_RebootDev(LLONG lLoginID);

// ر豸
CLIENT_API BOOL CALL_METHOD CLIENT_ShutDownDev(LLONG lLoginID);

// 豸
CLIENT_API BOOL CALL_METHOD CLIENT_ControlDevice(LLONG lLoginID, CtrlType type, void *param, int waittime = 1000);

// ͨ¼״̬
CLIENT_API BOOL CALL_METHOD CLIENT_SetupRecordState(LLONG lLoginID, char *pRSBuffer, int nRSBufferlen);

// ͨ¼״̬
CLIENT_API BOOL CALL_METHOD CLIENT_SetupExtraRecordState(LLONG lLoginID, char *pRSBuffer, int nRSBufferlen, void* pReserved);

// ѯIO״̬
CLIENT_API BOOL CALL_METHOD CLIENT_QueryIOControlState(LLONG lLoginID, DH_IOTYPE emType, 
                                           void *pState, int maxlen, int *nIOCount, int waittime=1000);

// IO
CLIENT_API BOOL CALL_METHOD CLIENT_IOControl(LLONG lLoginID, DH_IOTYPE emType, void *pState, int maxlen);

// ǿI֡nChannelIDͨţnSubChannel(011)
CLIENT_API BOOL CALL_METHOD CLIENT_MakeKeyFrame(LLONG lLoginID, int nChannelID, int nSubChannel=0);

// ע
typedef void (CALLBACK *fConnectMessCallBack)(LLONG lConnectHandle, NET_CLOUDSERVICE_CONNECT_RESULT* pConnectResult, void* pReserved, LDWORD dwUser);

CLIENT_API LLONG CALL_METHOD CLIENT_ConnectCloudService(LLONG lLoginID, NET_CLOUDSERVICE_CONNECT_PARAM* pConnectParm, fConnectMessCallBack pConnectMessCB, LDWORD dwUser, void* pReserved);
//------------------------------------------------------------------------

// ѯûϢ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryUserInfo(LLONG lLoginID, USER_MANAGE_INFO *info, int waittime=1000);

// ѯûϢ--չ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryUserInfoEx(LLONG lLoginID, USER_MANAGE_INFO_EX *info, int waittime=1000);

// ѯûϢ--֧64ͨ豸
CLIENT_API BOOL CALL_METHOD CLIENT_QueryUserInfoNew(LLONG lLoginID, USER_MANAGE_INFO_NEW *info, void* pReserved, int waittime = 1000);

// 豸û
CLIENT_API BOOL CALL_METHOD CLIENT_OperateUserInfo(LLONG lLoginID, int nOperateType, void *opParam, void *subParam, int waittime=1000);

// 豸û--չ
CLIENT_API BOOL CALL_METHOD CLIENT_OperateUserInfoEx(LLONG lLoginID, int nOperateType, void *opParam, void *subParam, int waittime=1000);

// 豸û--֧64ͨ豸
CLIENT_API BOOL CALL_METHOD CLIENT_OperateUserInfoNew(LLONG lLoginID, int nOperateType, void *opParam, void *subParam, void* pReserved, int waittime = 1000);

//------------------------------------------------------------------------

// ͸ͨ,TransComType2ֽڱʾţ2ֽڱʾͣĿǰ֧0ڣ1:485
CLIENT_API LLONG CALL_METHOD CLIENT_CreateTransComChannel(LLONG lLoginID, int TransComType, unsigned int baudrate, unsigned int databits, unsigned int stopbits, unsigned int parity, fTransComCallBack cbTransCom, LDWORD dwUser);

// ͸ڷ
CLIENT_API BOOL CALL_METHOD CLIENT_SendTransComData(LLONG lTransComChannel, char *pBuffer, DWORD dwBufSize);

// ͷͨͨ
CLIENT_API BOOL CALL_METHOD CLIENT_DestroyTransComChannel(LLONG lTransComChannel);

// ѯ͸״̬
CLIENT_API BOOL   CALL_METHOD CLIENT_QueryTransComParams(LLONG lLoginID, int TransComType, DH_COMM_STATE* pCommState, int nWaitTime = 500);

//------------------------------------------------------------------------

// ʼ豸
CLIENT_API LLONG CALL_METHOD CLIENT_StartUpgrade(LLONG lLoginID, char *pchFileName, fUpgradeCallBack cbUpgrade, LDWORD dwUser);

// ʼ豸--չ
CLIENT_API LLONG CALL_METHOD CLIENT_StartUpgradeEx(LLONG lLoginID, EM_UPGRADE_TYPE emType, char *pchFileName, fUpgradeCallBack cbUpgrade, LDWORD dwUser);

// 
CLIENT_API BOOL CALL_METHOD CLIENT_SendUpgrade(LLONG lUpgradeID);

// 豸
CLIENT_API BOOL CALL_METHOD CLIENT_StopUpgrade(LLONG lUpgradeID);

//------------------------------------------------------------------------

// ѯϢ
CLIENT_API BOOL  CALL_METHOD CLIENT_GetDevConfig(LLONG lLoginID, DWORD dwCommand, LONG lChannel, LPVOID lpOutBuffer, DWORD dwOutBufferSize, LPDWORD lpBytesReturned,int waittime=500);

// Ϣ
CLIENT_API BOOL  CALL_METHOD CLIENT_SetDevConfig(LLONG lLoginID, DWORD dwCommand, LONG lChannel, LPVOID lpInBuffer, DWORD dwInBufferSize, int waittime=500);

// ýӿڣѯϢ(JsonʽSDK)
CLIENT_API BOOL CALL_METHOD CLIENT_GetNewDevConfig(LLONG lLoginID, char* szCommand, int nChannelID, char* szOutBuffer, DWORD dwOutBufferSize, int *error, int waittime=500);

// ýӿڣϢ(JsonʽSDK)
CLIENT_API BOOL CALL_METHOD CLIENT_SetNewDevConfig(LLONG lLoginID, char* szCommand, int nChannelID, char* szInBuffer, DWORD dwInBufferSize, int *error, int *restart, int waittime=500);

// ɾýӿ(Jsonʽ)
CLIENT_API BOOL CALL_METHOD CLIENT_DeleteDevConfig(LLONG lLoginID, NET_IN_DELETECFG* pInParam, NET_OUT_DELETECFG* pOutParam, int waittime=500);

// ȡóԱƽӿ(Jsonʽ)
CLIENT_API BOOL CALL_METHOD CLIENT_GetMemberNames(LLONG lLoginID, NET_IN_MEMBERNAME* pInParam, NET_OUT_MEMBERNAME* pOutParam, int waittime=500);

// ȡϢ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryNetStat(LLONG lLoginID , EM_NET_QUERY_TYPE emType , void *lpInParam , int nInParamLen , void *lpOutParam , int nOutParamLen , int *pError = NULL , int nWaitTime=1000);

//------------------------------------------------------------------------

// ѯ豸ͨ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryChannelName(LLONG lLoginID, char *pChannelName, int maxlen, int *nChannelCount, int waittime=1000);

// 豸ͨ
CLIENT_API BOOL  CALL_METHOD CLIENT_SetupChannelName(LLONG lLoginID,char *pbuf, int nbuflen);

// 豸ַͨ
CLIENT_API BOOL  CALL_METHOD CLIENT_SetupChannelOsdString(LLONG lLoginID, int nChannelNo, DH_CHANNEL_OSDSTRING* struOsdString, int nbuflen);

// ѯ豸ǰʱ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryDeviceTime(LLONG lLoginID, LPNET_TIME pDeviceTime, int waittime=1000);

// 豸ǰʱ
CLIENT_API BOOL CALL_METHOD CLIENT_SetupDeviceTime(LLONG lLoginID, LPNET_TIME pDeviceTime);

// 豸
CLIENT_API BOOL CALL_METHOD CLIENT_SetMaxFlux(LLONG lLoginID, WORD wFlux);

//------------------------------------------------------------------------

// ļ
CLIENT_API LLONG CALL_METHOD CLIENT_ImportConfigFile(LLONG lLoginID, char *szFileName, fDownLoadPosCallBack cbUploadPos, LDWORD dwUserData, DWORD param=0);

// ֹͣļ
CLIENT_API BOOL CALL_METHOD CLIENT_StopImportCfgFile(LLONG lImportHandle);

// ļ
CLIENT_API LLONG CALL_METHOD CLIENT_ExportConfigFile(LLONG lLoginID, DH_CONFIG_FILE_TYPE emConfigFileType, char *szSavedFilePath, fDownLoadPosCallBack cbDownLoadPos, LDWORD dwUserData);

// ֹͣļ
CLIENT_API BOOL CALL_METHOD CLIENT_StopExportCfgFile(LLONG lExportHandle);

//------------------------------------------------------------------------

// ͨ豸ֻ豸кDDNSѯ豸IP
CLIENT_API BOOL CALL_METHOD CLIENT_GetDVRIPByResolveSvr(char *pchDVRIP, WORD wDVRPort, BYTE *sDVRName, WORD wDVRNameLen, BYTE *sDVRSerialNumber, WORD wDVRSerialLen, char* sGetIP);

// IPCNVS豸
CLIENT_API BOOL CALL_METHOD CLIENT_SearchDevices(char* szBuf, int nBufLen, int* pRetLen, DWORD dwSearchTime, char* szLocalIp=NULL);

// 첽IPCNVS豸
CLIENT_API LLONG CALL_METHOD CLIENT_StartSearchDevices(fSearchDevicesCB cbSearchDevices, void* pUserData, char* szLocalIp=NULL);

// ֹͣ첽IPCNVS豸
CLIENT_API BOOL CALL_METHOD CLIENT_StopSearchDevices(LLONG lSearchHandle);

// ޸豸IP
CLIENT_API BOOL CALL_METHOD CLIENT_ModifyDevice(DEVICE_NET_INFO_EX *pDevNetInfo, DWORD dwWaitTime, int *iError = NULL, char* szLocalIp = NULL, void *reserved = NULL);

// 豸IP
CLIENT_API BOOL CALL_METHOD CLIENT_SearchDevicesByIPs(DEVICE_IP_SEARCH_INFO* pIpSearchInfo, fSearchDevicesCB cbSearchDevices, LDWORD dwUserData, char* szLocalIp, DWORD dwWaitTime);
//------------------------------------------------------------------------

// ƽ̨ӿ
CLIENT_API BOOL CALL_METHOD CLIENT_GetPlatFormInfo(LLONG lLoginID, DWORD dwCommand, int nSubCommand, int nParam, LPVOID lpOutBuffer, DWORD dwOutBufferSize, LPDWORD lpBytesReturned,int waittime=500);
CLIENT_API BOOL CALL_METHOD CLIENT_SetPlatFormInfo(LLONG lLoginID, DWORD dwCommand, int nSubCommand, int nParam, LPVOID lpInBuffer, DWORD dwInBufferSize, int waittime=500);

// ͷ۽
//    dwFocusCommand = 0Ϊ۽
//    dwFocusCommand = 1Ϊ۽
//    dwFocusCommand = 2ΪԶ۽ڣڽλánFocusnZoomЧ
CLIENT_API BOOL CALL_METHOD CLIENT_FocusControl(LLONG lLoginID, int nChannelID, DWORD dwFocusCommand, double nFocus, double nZoom, void *reserved = NULL, int waittime=500);

///////////////////////////////豸ӿ///////////////////////////////

// ץͼص
CLIENT_API void CALL_METHOD CLIENT_SetSnapRevCallBack(fSnapRev OnSnapRevMessage, LDWORD dwUser);

// ץͼ
CLIENT_API BOOL CALL_METHOD CLIENT_SnapPicture(LLONG lLoginID, SNAP_PARAMS par);

// ץͼչӿ
CLIENT_API BOOL CALL_METHOD CLIENT_SnapPictureEx(LLONG lLoginID, SNAP_PARAMS *par, int *reserved = 0);

// GPSĻص
CLIENT_API void CALL_METHOD CLIENT_SetSubcribeGPSCallBack(fGPSRev OnGPSMessage, LDWORD dwUser);

// GPSĻص--չ
CLIENT_API void CALL_METHOD CLIENT_SetSubcribeGPSCallBackEX(fGPSRevEx OnGPSMessage, LDWORD dwUser);

// GPSϢ
CLIENT_API BOOL CALL_METHOD CLIENT_SubcribeGPS (LLONG lLoginID, BOOL bStart, LONG KeepTime, LONG InterTime);

// GPSʪȶĻص
CLIENT_API void CALL_METHOD CLIENT_SetSubcribeGPSTHCallBack(fGPSTempHumidityRev OnGPSMessage, LDWORD dwUser);

// GPSʪϢ
CLIENT_API BOOL CALL_METHOD CLIENT_SubcribeGPSTempHumidity (LLONG lLoginID, BOOL bStart,    int InterTime, void* Reserved);

//GPS־Ϣѯ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryGPSLog(LLONG lLoginID,QUERY_GPS_LOG_PARAM *pQueryParam, char *pLogBuffer, int nLogBufferLen, int *pRecLogNum, BOOL *bContinue, int waittime);

// 
CLIENT_API BOOL CALL_METHOD CLIENT_AttachMission(LLONG lLoginID, NET_IN_ATTACH_MISSION_PARAM *pInParam, NET_OUT_ATTACH_MISSION_PARAM *pOutParam, int nWaitTime);

// ȡ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachMission(LLONG lAttachHandle);

// ȷ
CLIENT_API BOOL CALL_METHOD CLIENT_BusConfirmEvent(LLONG lLoginID, const NET_IN_BUS_CONFIRM_EVENT* pInParam, NET_OUT_BUS_CONFIRM_EVENT* pOutParam, int nWaitTime = 3000);

//////////////////////////////豸ӿ//////////////////////////////

// ѯϢ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryDecoderInfo(LLONG lLoginID, LPDEV_DECODER_INFO lpDecInfo, int waittime=1000);

// ѯǰTVϢ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryDecoderTVInfo(LLONG lLoginID, int nMonitorID, LPDEV_DECODER_TV lpMonitorInfo, int waittime=1000);

// ѯͨϢ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryDecEncoderInfo(LLONG lLoginID, int nDecoderID, LPDEV_ENCODER_INFO lpEncoderInfo, int waittime=1000);

// ýTVʹ
CLIENT_API BOOL CALL_METHOD CLIENT_SetDecTVOutEnable(LLONG lLoginID, BYTE *pDecTVOutEnable, int nBufLen, int waittime=1000);

// ýʾϢʹܣͨŴ0ʼ
CLIENT_API BOOL CALL_METHOD CLIENT_SetDecLayOutEnable(LLONG lLoginID, BYTE bDecLayOutEnable, int nChannel, int waittime=1000);
// ȡʾϢʹܣͨŴ0ʼ
CLIENT_API BOOL CALL_METHOD CLIENT_GetDecLayOutEnable(LLONG lLoginID, BYTE *pDecLayOutEnable, int nChannel, int waittime=1000);
//------------------------------------------------------------------------

// 첽ص
CLIENT_API BOOL CALL_METHOD CLIENT_SetOperateCallBack(LLONG lLoginID, fMessDataCallBack cbMessData, LDWORD dwUser);

// ƽTVָӿΪ첽ʽ nSplitType=-1ʱpEncoderChannelΪṹDH_CTRL_DECTV_SCREENָ
CLIENT_API LLONG CALL_METHOD CLIENT_CtrlDecTVScreen(LLONG lLoginID, int nMonitorID, BOOL bEnable, int nSplitType, BYTE *pEncoderChannel, int nBufLen, void* userdata=NULL);

// TVлӿΪ첽ʽ
//   
CLIENT_API LLONG CALL_METHOD CLIENT_SwitchDecTVEncoder(LLONG lLoginID, int nDecoderID, LPDEV_ENCODER_INFO lpEncoderInfo, void* userdata=NULL);

//------------------------------------------------------------------------

// ӻ
CLIENT_API int CALL_METHOD CLIENT_AddTourCombin(LLONG lLoginID, int nMonitorID, int nSplitType, BYTE *pEncoderChannnel, int nBufLen, int waittime=1000);

// ɾ
CLIENT_API BOOL CALL_METHOD CLIENT_DelTourCombin(LLONG lLoginID, int nMonitorID, int nCombinID, int waittime=1000);

// ޸Ļ
CLIENT_API BOOL CALL_METHOD CLIENT_SetTourCombin(LLONG lLoginID, int nMonitorID, int nCombinID, int nSplitType, BYTE *pEncoderChannel, int nBufLen, int waittime=1000);

// ѯϣnCombinIDΧ032
CLIENT_API BOOL CALL_METHOD CLIENT_QueryTourCombin(LLONG lLoginID, int nMonitorID, int nCombinID, LPDEC_COMBIN_INFO lpDecCombinInfo, int waittime=1000);

// Ѳ
CLIENT_API BOOL CALL_METHOD CLIENT_SetDecoderTour(LLONG lLoginID, int nMonitorID, LPDEC_TOUR_COMBIN lpDecTourInfo, int waittime=1000);

// ѯѲ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryDecoderTour(LLONG lLoginID, int nMonitorID, LPDEC_TOUR_COMBIN lpDecTourInfo, int waittime=1000);

// ѯǰͨϢ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryDecChannelFlux(LLONG lLoginID, int nDecoderID, LPDEV_DECCHANNEL_STATE lpChannelStateInfo, int waittime=1000);

// Ѳ
CLIENT_API BOOL CALL_METHOD CLIENT_CtrlDecoderTour(LLONG lLoginID, int nMonitorID, DEC_CTRL_TOUR_TYPE emActionParam, int waittime = 1000);
//------------------------------------------------------------------------

typedef void (CALLBACK *fDecPlayBackPosCallBack)(LLONG lLoginID, int nEncoderID, DWORD dwTotalSize, DWORD dwPlaySize, LDWORD dwUser);

// ûطŽȻص
CLIENT_API BOOL CALL_METHOD CLIENT_SetDecPlaybackPos(LLONG lLoginID, fDecPlayBackPosCallBack cbPlaybackPos, LDWORD dwUser);

// TVطţӿΪ첽ʽ
CLIENT_API LLONG CALL_METHOD CLIENT_DecTVPlayback(LLONG lLoginID, int nDecoderID, DEC_PLAYBACK_MODE emPlaybackMode, LPVOID lpInBuffer, DWORD dwInBufferSize, void* userdata=NULL);

// TVطſ
CLIENT_API BOOL CALL_METHOD CLIENT_CtrlDecPlayback(LLONG lLoginID, int nDecoderID, DEC_CTRL_PLAYBACK_TYPE emCtrlType, int nValue, int waittime=1000);

///////////////////////////////豸ӿ///////////////////////////////

// ʵʱϴܷݣͼƬ
CLIENT_API LLONG CALL_METHOD CLIENT_RealLoadPicture(LLONG lLoginID, int nChannelID, DWORD dwAlarmType, fAnalyzerDataCallBack cbAnalyzerData, LDWORD dwUser);

// ʵʱϴܷݣͼƬ(չӿڣbNeedPicFileʾǷͼƬļ,ReservedΪRESERVED_PARA) 
CLIENT_API LLONG CALL_METHOD CLIENT_RealLoadPictureEx(LLONG lLoginID, int nChannelID, 
                                                     DWORD dwAlarmType, 
                                                     BOOL bNeedPicFile, 
                                                     fAnalyzerDataCallBack cbAnalyzerData, 
                                                     LDWORD dwUser, 
                                                     void* Reserved);

// ֹͣϴܷݣͼƬ
CLIENT_API BOOL CALL_METHOD CLIENT_StopLoadPic(LLONG lAnalyzerHandle);

// ȷϴͼƬǷɣͼƬ
// ýӿڲ CLIENT_RealLoadPictureEx/CLIENT_RealLoadPicture Ļصͬһ̣߳߳е
CLIENT_API BOOL CALL_METHOD CLIENT_SnapManagerConfirmUpload(LLONG lLoginID, const NET_IN_SNAP_MANAGER_CONFIRM_UPLOAD* pstInParam, NET_OUT_SNAP_MANAGER_CONFIRM_UPLOAD* pstOutParam, int waittime=1000);

// ѯѯļ
CLIENT_API LLONG    CALL_METHOD CLIENT_FindFileEx(LLONG lLoginID, EM_FILE_QUERY_TYPE emType, void* pQueryCondition, void *reserved, int waittime=1000);    

// ļ:nFilecount:Ҫѯ, ֵΪýļ ֵ<nFilecountӦʱڵļѯ
CLIENT_API int    CALL_METHOD CLIENT_FindNextFileEx(LLONG lFindHandle, int nFilecount, void* pMediaFileInfo, int maxlen, void *reserved, int waittime=1000);

// ¼ļ
CLIENT_API BOOL CALL_METHOD CLIENT_FindCloseEx(LLONG lFindHandle);

// ȡϲѯļ
CLIENT_API BOOL CALL_METHOD CLIENT_GetTotalFileCount(LLONG lFindHandle, int* pTotalCount, void *reserved, int waittime=1000);

// òѯת
CLIENT_API BOOL CALL_METHOD CLIENT_SetFindingJumpOption(LLONG lFindHandle, NET_FINDING_JUMP_OPTION_INFO* pOption, void *reserved, int waittime=1000);

// ָܷ - ͼƬ
CLIENT_API LLONG CALL_METHOD CLIENT_DownloadMediaFile(LLONG lLoginID,EM_FILE_QUERY_TYPE emType, void* lpMediaFileInfo, char *sSavedFileName, fDownLoadPosCallBack cbDownLoadPos, LDWORD dwUserData,  void *reserved);

// ֹͣ
CLIENT_API BOOL CALL_METHOD CLIENT_StopDownloadMediaFile(LLONG lFileHandle);

// ļ
CLIENT_API BOOL CALL_METHOD CLIENT_DownLoadMultiFile(LLONG lLoginID, NET_IN_DOWNLOAD_MULTI_FILE *pstInParam, NET_OUT_DOWNLOAD_MULTI_FILE *pstOutParam, int waittime=1000);

// ֹͣ
CLIENT_API BOOL CALL_METHOD CLIENT_StopLoadMultiFile(LLONG lDownLoadHandle);

// ܷݣͼƬ
CLIENT_API LLONG CALL_METHOD CLIENT_LoadOffLineFile(LLONG lLoginID, int nChannelID, DWORD dwAlarmType, LPNET_TIME_EX lpStartTime, LPNET_TIME_EX lpEndTime, fAnalyzerDataCallBack cbAnalyzerData, LDWORD dwUser);

//ܷͣ(bPause=TRUE ʾͣ, bPause=FALSE ʾָ)
CLIENT_API BOOL CALL_METHOD CLIENT_PauseLoadPic(LLONG lLoadHadle, BOOL bPause);

// ͨץ--紥ʽ
CLIENT_API BOOL CALL_METHOD CLIENT_TrafficSnapByNetwork(LLONG lLoginID, int nChannelID, NET_IN_SNAPSHOT* pstInParam, NET_OUT_SNAPSHOT* pstOutParam);

// ͨ--ǿƺ
CLIENT_API BOOL CALL_METHOD CLIENT_TrafficForceLightState(LLONG lLoginID, int nChannelID, NET_IN_FORCELIGHTSTATE* pstInParamg, NET_OUT_FORCELIGHTSTATE* pstOutParam, int waittime=1000);

//  ڰ
CLIENT_API BOOL CALL_METHOD CLIENT_OperateTrafficList(LLONG lLoginID ,  NET_IN_OPERATE_TRAFFIC_LIST_RECORD* pstInParam , NET_OUT_OPERATE_TRAFFIC_LIST_RECORD *pstOutParam = NULL ,  int waittime = 1000);

// ͨͳ
CLIENT_API LLONG CALL_METHOD CLIENT_StartTrafficFluxStat(LLONG lLoginID, NET_IN_TRAFFICFLUXSTAT* pstInParam,NET_OUT_TRAFFICFLUXSTAT* pstOutParam);

// ͳ
CLIENT_API BOOL CALL_METHOD CLIENT_StopTrafficFluxStat(LLONG lFluxStatHandle);

// ȡͳϢ
CLIENT_API LLONG CALL_METHOD CLIENT_StartFindFluxStat(LLONG lLoginID, NET_IN_TRAFFICSTARTFINDSTAT* pstInParam, NET_OUT_TRAFFICSTARTFINDSTAT* pstOutParam);

// ѯͳ
CLIENT_API int    CALL_METHOD CLIENT_DoFindFluxStat(LLONG lFindHandle, NET_IN_TRAFFICDOFINDSTAT* pstInParam,NET_OUT_TRAFFICDOFINDSTAT* pstOutParam);

// ѯͳ
CLIENT_API BOOL CALL_METHOD CLIENT_StopFindFluxStat(LLONG lFindHandle);

// ȡͳϢ
CLIENT_API LLONG CALL_METHOD CLIENT_StartFindNumberStat(LLONG lLoginID, NET_IN_FINDNUMBERSTAT* pstInParam, NET_OUT_FINDNUMBERSTAT* pstOutParam);

// ѯͳ
CLIENT_API int    CALL_METHOD CLIENT_DoFindNumberStat(LLONG lFindHandle, NET_IN_DOFINDNUMBERSTAT* pstInParam, NET_OUT_DOFINDNUMBERSTAT* pstOutParam);

// ѯͳ
CLIENT_API BOOL CALL_METHOD CLIENT_StopFindNumberStat(LLONG lFindHandle);
// Ƶ豸ķ
CLIENT_API BOOL CALL_METHOD CLIENT_OperateVideoAnalyseDevice(LLONG lLoginID, int nChannelID, char* szCmd, void *pstInParam, void *pstOutParam, int waittime=1000);

// 豸ķ
CLIENT_API BOOL CALL_METHOD CLIENT_OperateCommDevice(LLONG lLoginID, int nChannelID, char* szCmd, void *pstInParam, void *pstOutParam, int waittime=1000);

// ܸƽӿ
CLIENT_API BOOL CALL_METHOD CLIENT_ControlIntelliTracker(LLONG lLoginID, NET_IN_CONTROL_INTELLITRACKER* pstInParam, NET_OUT_CONTROL_INTELLITRACKER* pstOutParam);

// ʽ豸ķ,μ涨CLIENT_OperateMasterSlaveDeviceӿڲ
CLIENT_API BOOL CALL_METHOD CLIENT_OperateMasterSlaveDevice(LLONG lLoginID, int nChannelID, char* szCmd, void *pstInParam, void *pstOutParam, int waittime=1000);

// Ƶƴӷ
CLIENT_API BOOL CALL_METHOD CLIENT_OperateVideoJoin(LLONG lLoginID, NET_VIDEOJOIN_OPERATE_TYPE emType, void* pstInParam, void* pstOutParam, int nWaitTime);

////  Ƶ

// ʵʱȡƵϽ
CLIENT_API BOOL CALL_METHOD CLIENT_StartVideoDiagnosis(LLONG lLoginID, NET_IN_VIDEODIAGNOSIS *pstInParam, NET_OUT_VIDEODIAGNOSIS *pstOutParam);

// ֹͣƵϽϱ
CLIENT_API BOOL CALL_METHOD CLIENT_StopVideoDiagnosis(LLONG hDiagnosisHandle);

// ʼƵϽѯ
CLIENT_API BOOL CALL_METHOD CLIENT_StartFindDiagnosisResult(LLONG lLoginID, NET_IN_FIND_DIAGNOSIS* pstInParam, NET_OUT_FIND_DIAGNOSIS* pstOutParam);

// ȡƵϽϢ
CLIENT_API BOOL CALL_METHOD CLIENT_DoFindDiagnosisResult(LLONG hFindHandle,NET_IN_DIAGNOSIS_INFO* pstInParam, NET_OUT_DIAGNOSIS_INFO* pstOutParam);

// ƵϽѯ
CLIENT_API BOOL CALL_METHOD CLIENT_StopFindDiagnosis(LLONG hFindHandle);

// ʵʱϼƻ
CLIENT_API BOOL CALL_METHOD CLIENT_StartRealTimeProject(LLONG lLoginID,NET_IN_START_RT_PROJECT_INFO* pstInParam, NET_OUT_START_RT_PROJECT_INFO* pstOutParam, int nWaitTime);

// ֹͣʵʱϼƻ
CLIENT_API BOOL CALL_METHOD CLIENT_StopRealTimeProject(LLONG lLoginID,NET_IN_STOP_RT_PROJECT_INFO* pstInParam, NET_OUT_STOP_RT_PROJECT_INFO* pstOutParam, int nWaitTime);

// ȡܽͨλ״̬
CLIENT_API BOOL CALL_METHOD CLIENT_GetParkingSpaceStatus(LLONG lLoginID, NET_IN_GET_PARKINGSPACE_STATUS* pstInParam, NET_OUT_GET_PARKINGSPACE_STATUS* pstOutParam);

// ָĳλͼƬϢ
CLIENT_API LLONG CALL_METHOD CLIENT_AttachParkingSpaceData(LLONG lLoginID, NET_IN_ATTACH_PARKINGSPACE* pstInParam, NET_OUT_ATTACH_PARKINGSPACE* pstOutParam);

// ȡָĳλͼƬϢ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachParkingSpaceData(NET_IN_DETACH_PARKINGSPACE* pstInParam, NET_OUT_DETACH_PARKINGSPACE* pstOutParam);

// ָϢ
CLIENT_API LLONG CALL_METHOD CLIENT_AttachLanesState(LLONG lLoginID, NET_IN_ATTACH_LANES_STATE* pstInParam, NET_OUT_ATTACH_LANES_STATE* pstOutParam, int nWaitTime);

// ȡָϢ lLanesStateHandleΪCLIENT_AttachLanesStateصľ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachLanesState(LLONG lLanesStateHandle);

// ȡλ״̬
CLIENT_API BOOL CALL_METHOD CLIENT_GetCarPortLightStatus(LLONG lLoginID, NET_IN_GET_CARPORTLIGHT_STATUS* pstInParam, NET_OUT_GET_CARPORTLIGHT_STATUS* pstOutParam, int waittime=1000);

// óλ״̬
CLIENT_API BOOL CALL_METHOD CLIENT_SetCarPortLightStatus(LLONG lLoginID, NET_IN_SET_CARPORTLIGHT_STATUS* pstInParam, NET_OUT_SET_CARPORTLIGHT_STATUS* pstOutParam, int waittime=1000);

// ܷȣƵԴΪ¼ļʱ
CLIENT_API BOOL CALL_METHOD CLIENT_AttachVideoAnalyseState(LLONG lLoginID, NET_IN_ATTACH_VIDEOANALYSE_STATE* pstInParam, NET_OUT_ATTACH_VIDEOANALYSE_STATE* pstOutParam, int nWaittime=1000);

// ֹͣ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachVideoAnalyseState(LLONG lAttachHandle);

////////////////////////////////ƵŨӿ////////////////////////////////

// ƵŨ
CLIENT_API BOOL CALL_METHOD CLIENT_AddVideoSynopsisTask(LLONG lLoginID,    NET_IN_ADD_VIDEOSYNOPSIS* pstInParam, NET_OUT_ADD_VIDEOSYNOPSIS* pstOutParam);

// ͣƵŨ
CLIENT_API BOOL CALL_METHOD CLIENT_PauseVideoSynopsisTask(LLONG lLoginID, NET_IN_PAUSE_VIDEOSYNOPSIS* pstInParam);

// ƳƵŨ
CLIENT_API BOOL CALL_METHOD CLIENT_RemoveVideoSynopsisTask(LLONG lLoginID, NET_IN_REMOVE_VIDEOSYNOPSIS* pstInParam);

// ʵʱŨƵϢ
CLIENT_API BOOL CALL_METHOD CLIENT_RealLoadObjectData(LLONG lLoginID, NET_IN_REALLOAD_OBJECTDATA* pstInParam, NET_OUT_REALLOAD_OBJECTDATA* pstOutParam);

// ֹͣʵʱŨƵϢ
CLIENT_API BOOL CALL_METHOD CLIENT_StopLoadObjectData(LLONG lRealLoadHandle, NET_IN_STOPLOAD_OBJECTDATA* pstInParam);

// ʵʱŨƵϢ
CLIENT_API BOOL CALL_METHOD CLIENT_RealLoadSynopsisState(LLONG lLoginID, NET_IN_REALLAOD_SYNOPSISSTATE* pstInParam, NET_OUT_REALLOAD_SYNOPSISSTATE* pstOutParam);

// ֹͣʵʱŨƵϢ
CLIENT_API BOOL CALL_METHOD CLIENT_StopLoadSynopsisState(LLONG lRealLoadHandle, NET_IN_STOPLOAD_SYNOPSISSTATE* pstInParam);

// ѯŨƵϢӿ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryVideoSynopsisInfo(LLONG lLoginID, NET_IN_QUERY_VIDEOSYNOPSIS* pstInParam, NET_OUT_QUERY_VIDEOSYNOPSIS* pstuOutParam);

// ѯѯƵŨļ
CLIENT_API BOOL    CALL_METHOD CLIENT_FindSynopsisFile(LLONG lLoginID, NET_IN_FIND_SYNOPSISFILE *pstInParam, NET_OUT_FIND_SYNOPSISFILE *pstOutParam);    

// ƵŨļ
CLIENT_API BOOL    CALL_METHOD CLIENT_FindNextSynopsisFile(LLONG lFindHandle, NET_IN_FINDNEXT_SYNOPSISFILE *pstInParam, NET_OUT_FINDNEXT_SYNOPSISFILE *pstOutParam);

// ƵŨļ
CLIENT_API BOOL CALL_METHOD CLIENT_SynopsisFindClose(LLONG lFindHandle);

// ƵŨļ
CLIENT_API BOOL CALL_METHOD CLIENT_DownLoadSynosisFile(LLONG lLoginID, NET_IN_DOWNLOAD_SYNOPSISFILE *pstInParam, NET_OUT_DOWNLOAD_SYNOPSISFILE *pstOutParam);

// ֹͣ
CLIENT_API BOOL CALL_METHOD CLIENT_StopLoadSynosisFile(LLONG lDownLoadHandle);

// ŨƵļ()·ļϢ
CLIENT_API BOOL    CALL_METHOD    CLIENT_SetFilePathInfo(LLONG lLoginID, NET_IN_SET_FILEPATHINFO* pstInParam);

// ļϢ״̬
CLIENT_API LLONG CALL_METHOD CLIENT_AttachAddFileState(LLONG lLoginID, const NET_IN_ADDFILE_STATE* pstInParam, NET_OUT_ADDFILE_STATE *pstOutParam, int nWaitTime = 1000);

// ȡļϢ״, lAttachHandleCLIENT_AttacAddFileStateֵ
CLIENT_API LLONG CALL_METHOD CLIENT_DetachAddFileState(LLONG lAttachHandle);

/////////////////////////////////ʶӿ/////////////////////////////////////////
// ʶݿϢӺɾ
CLIENT_API BOOL CALL_METHOD CLIENT_OperateFaceRecognitionDB(LLONG lLoginID, const NET_IN_OPERATE_FACERECONGNITIONDB* pstInParam, NET_OUT_OPERATE_FACERECONGNITIONDB *pstOutParam, int nWaitTime = 1000);

// ѯʶ 
CLIENT_API BOOL CALL_METHOD CLIENT_StartFindFaceRecognition(LLONG lLoginID, const NET_IN_STARTFIND_FACERECONGNITION* pstInParam, NET_OUT_STARTFIND_FACERECONGNITION *pstOutParam, int nWaitTime = 1000);

// ʶ:nFilecount:Ҫѯ, ֵΪýļ ֵ<nFilecountӦʱڵļѯ(ÿֻܲѯ20¼)
CLIENT_API BOOL CALL_METHOD CLIENT_DoFindFaceRecognition(const NET_IN_DOFIND_FACERECONGNITION* pstInParam, NET_OUT_DOFIND_FACERECONGNITION *pstOutParam, int nWaitTime = 1000);

// ѯ
CLIENT_API BOOL CALL_METHOD CLIENT_StopFindFaceRecognition(LLONG lFindHandle);

// (һŴͼͼбͼƬ)
CLIENT_API BOOL CALL_METHOD CLIENT_DetectFace(LLONG lLoginID, const NET_IN_DETECT_FACE* pstInParam, NET_OUT_DETECT_FACE *pstOutParam, int nWaitTime = 1000);

// ʶԱӣ޸ĺɾ
CLIENT_API BOOL CALL_METHOD CLIENT_OperateFaceRecognitionGroup(LLONG lLoginID, const NET_IN_OPERATE_FACERECONGNITION_GROUP* pstInParam, NET_OUT_OPERATE_FACERECONGNITION_GROUP *pstOutParam, int nWaitTime = 1000);

// ѯʶԱϢ
CLIENT_API BOOL CALL_METHOD CLIENT_FindGroupInfo(LLONG lLoginID, const NET_IN_FIND_GROUP_INFO* pstInParam, NET_OUT_FIND_GROUP_INFO *pstOutParam, int nWaitTime = 1000);

// ͨԱϢ
CLIENT_API BOOL CALL_METHOD CLIENT_SetGroupInfoForChannel(LLONG lLoginID, const NET_IN_SET_GROUPINFO_FOR_CHANNEL* pstInParam, NET_OUT_SET_GROUPINFO_FOR_CHANNEL *pstOutParam, int nWaitTime = 1000);

//////////////////////////////// ¼ϴӿ /////////////////////////////////

// 򿪿¼Ự, ؿ¼Ự
CLIENT_API LLONG CALL_METHOD CLIENT_StartBurnSession(LLONG lLoginID, const NET_IN_START_BURN_SESSION* pstInParam, NET_OUT_START_BURN_SESSION *pstOutParam, int nWaitTime);

// رտ¼Ự
CLIENT_API BOOL CALL_METHOD CLIENT_StopBurnSession(LLONG lBurnSession);

// ʼ¼
CLIENT_API BOOL CALL_METHOD CLIENT_StartBurn(LLONG lBurnSession, const NET_IN_START_BURN* pstInParam, NET_OUT_START_BURN *pstOutParam, int nWaitTime);

// ֹͣ¼
CLIENT_API BOOL CALL_METHOD CLIENT_StopBurn(LLONG lBurnSession);

// ͣ/ָ¼
CLIENT_API BOOL CALL_METHOD CLIENT_PauseBurn(LLONG lBurnSession, BOOL bPause);

// ص
CLIENT_API BOOL CALL_METHOD CLIENT_BurnMarkTag(LLONG lBurnSession, const NET_IN_BURN_MARK_TAG* pstInParam, NET_OUT_BURN_MARK_TAG *pstOutParam, int nWaitTime);

// 
CLIENT_API BOOL CALL_METHOD CLIENT_BurnChangeDisk(LLONG lBurnSession, const NET_IN_BURN_CHANGE_DISK* pstInParam, NET_OUT_BURN_CHANGE_DISK *pstOutParam, int nWaitTime);

// ȡ¼״̬
CLIENT_API BOOL CALL_METHOD CLIENT_BurnGetState(LLONG lBurnSession, const NET_IN_BURN_GET_STATE* pstInParam, NET_OUT_BURN_GET_STATE *pstOutParam, int nWaitTime);

// ¼״̬
CLIENT_API LLONG CALL_METHOD CLIENT_AttachBurnState(LLONG lLoginID, const NET_IN_ATTACH_STATE* pstInParam, NET_OUT_ATTACH_STATE *pstOutParam, int nWaitTime = 1000);

// ȡ¼״̬lAttachHandleCLIENT_AttachBurnStateֵ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachBurnState(LLONG lAttachHandle);

// ¼ϴʼ ش˴ϴ, ע½ӿڲfAttachBurnStateCBص
CLIENT_API LLONG CALL_METHOD CLIENT_StartUploadFileBurned(LLONG lLoginID, const NET_IN_FILEBURNED_START* pstInParam, NET_OUT_FILEBURNED_START *pstOutParam, int nWaitTime = 1000);

// ¼ϴļlUploadHandleCLIENT_StartUploadFileBurnedֵ
CLIENT_API BOOL CALL_METHOD CLIENT_SendFileBurned(LLONG lUploadHandle);

// ¼ϴֹͣlUploadHandleCLIENT_StartUploadFileBurnedֵ,˽ӿڲfBurnFileCallBackصе
CLIENT_API BOOL CALL_METHOD CLIENT_StopUploadFileBurned(LLONG lUploadHandle);

// ¼У״̬
CLIENT_API LLONG CALL_METHOD CLIENT_AttachBurnCheckState(LLONG lLoginID, const NET_IN_ATTACH_BURN_CHECK* pstInParam, NET_OUT_ATTACH_BURN_CHECK* pstOutParam, int nWaitTime = 1000);

// ȡ¼У״̬lAttachHandleCLIENT_AttachBurnCheckStateֵ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachBurnCheckState(LLONG lAttachHandle);

// Ŀ¼Ϣ
CLIENT_API LLONG CALL_METHOD CLIENT_AttachBurnCase(LLONG lLoginID, const NET_IN_ATTACH_BURN_CASE* pInParam, NET_OUT_ATTACH_BURN_CASE* pOutParam, int nWaitTime);

// ȡĿ¼ϢlAttachHandleCLIENT_AttachBurnCaseֵ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachBurnCase(LLONG lAttachHandle);

//////////////////////////////// ߼豸 /////////////////////////////////////////

// ͷ״̬
CLIENT_API LLONG CALL_METHOD CLIENT_AttachCameraState(LLONG lLoginID, const NET_IN_CAMERASTATE* pstInParam, NET_OUT_CAMERASTATE *pstOutParam, int nWaitTime = 3000);

// ֹͣͷ״̬lAttachHandleCLIENT_AttachCameraStateֵ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachCameraState(LLONG lAttachHandle);

// ȡЧʾԴ
CLIENT_API BOOL CALL_METHOD CLIENT_MatrixGetCameras(LLONG lLoginID, const DH_IN_MATRIX_GET_CAMERAS* pInParam, DH_OUT_MATRIX_GET_CAMERAS* pOutParam, int nWaitTime = 1000);

// ߼豸
CLIENT_API BOOL CALL_METHOD CLIENT_MatrixAddCameras(LLONG lLoginID, const DH_IN_ADD_LOGIC_DEVICE_CAMERA* pInParam, DH_OUT_ADD_LOGIC_DEVICE_CAMERA* pOutParam, int nWaitTime = 1000);

//////////////////////////////// ӿ /////////////////////////////////

// ѯƷ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryProductionDefinition(LLONG lLoginID, DH_PRODUCTION_DEFNITION* pstuProdDef, int nWaitTime = 1000);

// ѯӿϢ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryMatrixCardInfo(LLONG lLoginID, DH_MATRIX_CARD_LIST* pstuCardList, int nWaitTime = 1000);

// ѯϵͳ״̬
CLIENT_API BOOL CALL_METHOD CLIENT_QuerySystemStatus(LLONG lLoginID, DH_SYSTEM_STATUS* pstuStatus, int nWaitTime = 1000);

// ѯָ
CLIENT_API BOOL CALL_METHOD CLIENT_GetSplitCaps(LLONG lLoginID, int nChannel, DH_SPLIT_CAPS* pstuCaps, int nWaitTime = 1000);

// ѯ/ʾԴ
CLIENT_API BOOL CALL_METHOD CLIENT_GetSplitSource(LLONG lLoginID, int nChannel, int nWindow, DH_SPLIT_SOURCE* pstuSplitSrc, int nMaxCount, int* pnRetCount, int nWaitTime = 1000);
CLIENT_API BOOL CALL_METHOD CLIENT_SetSplitSource(LLONG lLoginID, int nChannel, int nWindow, const DH_SPLIT_SOURCE* pstuSplitSrc, int nSrcCount, int nWaitTime = 1000);
// ʾԴ, ֧
CLIENT_API BOOL CALL_METHOD CLIENT_SetSplitSourceEx(LLONG lLoginID, const NET_IN_SET_SPLIT_SOURCE* pInparam, NET_OUT_SET_SPLIT_SOURCE* pOutParam, int nWaitTime = 1000);

// ѯ/÷ָģʽ
CLIENT_API BOOL CALL_METHOD CLIENT_GetSplitMode(LLONG lLoginID, int nChannel, DH_SPLIT_MODE_INFO* pstuSplitInfo, int nWaitTime = 1000);
CLIENT_API BOOL CALL_METHOD CLIENT_SetSplitMode(LLONG lLoginID, int nChannel, const DH_SPLIT_MODE_INFO* pstuSplitInfo, int nWaitTime = 1000);

// ѯָ
CLIENT_API BOOL CALL_METHOD CLIENT_GetSplitGroupCount(LLONG lLoginID, int nChannel, DH_SPLIT_MODE emSplitMode, int* pnGroupCount, int nWaitTime = 1000);

// ѯƵ
CLIENT_API BOOL CALL_METHOD CLIENT_GetVideoOutCaps(LLONG lLoginID, int nChannel, DH_VIDEO_OUT_CAPS* pstuCaps, int nWaitTime = 1000);

// Ƶѡ
CLIENT_API BOOL CALL_METHOD CLIENT_SetVideoOutOption(LLONG lLoginID, int nChannel, const DH_VIDEO_OUT_OPT* pstuVideoOut, int nWaitTime = 1000);

// ѯƵͨĿǰĸʾ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryVideoOutWindows(LLONG lLoginID, int nChannel, DH_VIDEO_OUT_WINDOW* pstuWnds, int nMaxWndCount, int* pnRetWndCount, int nWaitTime = 1000);

// ôλ
CLIENT_API BOOL CALL_METHOD CLIENT_SetSplitWindowRect(LLONG lLoginID, const DH_IN_SPLIT_SET_RECT* pInParam, DH_OUT_SPLIT_SET_RECT* pOutParam, int nWaitTime = 1000);
CLIENT_API BOOL CALL_METHOD CLIENT_GetSplitWindowRect(LLONG lLoginID, const DH_IN_SPLIT_GET_RECT* pInParam, DH_OUT_SPLIT_GET_RECT* pOutParam, int nWaitTime = 1000);

// /ش
CLIENT_API BOOL CALL_METHOD CLIENT_OpenSplitWindow(LLONG lLoginID, const DH_IN_SPLIT_OPEN_WINDOW* pInParam, DH_OUT_SPLIT_OPEN_WINDOW* pOutParam, int nWaitTime = 1000);
CLIENT_API BOOL CALL_METHOD CLIENT_CloseSplitWindow(LLONG lLoginID, const DH_IN_SPLIT_CLOSE_WINDOW* pInParam, DH_OUT_SPLIT_CLOSE_WINDOW* pOutParam, int nWaitTime = 1000);

// ôڴ
CLIENT_API BOOL CALL_METHOD CLIENT_SetSplitTopWindow(LLONG lLoginID, const DH_IN_SPLIT_SET_TOP_WINDOW* pInParam, DH_OUT_SPLIT_SET_TOP_WINDOW* pOutParam, int nWaitTime = 1000);

// ȡǰʾĴϢ
CLIENT_API BOOL CALL_METHOD CLIENT_GetSplitWindowsInfo(LLONG lLoginID, const DH_IN_SPLIT_GET_WINDOWS* pInParam, DH_OUT_SPLIT_GET_WINDOWS* pOutParam, int nWaitTime = 1000);

// /ղؼ
CLIENT_API BOOL CALL_METHOD CLIENT_LoadSplitCollection(LLONG lLoginID, const DH_IN_SPLIT_LOAD_COLLECTION* pInParam, DH_OUT_SPLIT_LOAD_COLLECTION* pOutParam, int nWaitTime = 1000);
CLIENT_API BOOL CALL_METHOD CLIENT_SaveSplitCollection(LLONG lLoginID, const DH_IN_SPLIT_SAVE_COLLECTION* pInParam, DH_OUT_SPLIT_SAVE_COLLECTION* pOutParam, int nWaitTime = 1000);

// ȡղؼϢ
CLIENT_API BOOL CALL_METHOD CLIENT_GetSplitCollections(LLONG lLoginID, const DH_IN_SPLIT_GET_COLLECTIONS* pInParam, DH_OUT_SPLIT_GET_COLLECTIONS* pOutParam, int nWaitTime = 1000);

// ղؼ
CLIENT_API BOOL CALL_METHOD CLIENT_RenameSplitCollection(LLONG lLoginID, const DH_IN_SPLIT_RENAME_COLLECTION* pInParam, DH_OUT_SPLIT_RENAME_COLLECTION* pOutParam, int nWaitTime = 1000);

// ɾղؼ
CLIENT_API BOOL CALL_METHOD CLIENT_DeleteSplitCollection(LLONG lLoginID, const DH_IN_SPLIT_DELETE_COLLECTION* pInParam, DH_OUT_SPLIT_DELETE_COLLECTION* pOutParam, int nWaitTime = 1000);

// 
CLIENT_API BOOL CALL_METHOD CLIENT_SetDecodePolicy(LLONG lLoginID, const DH_IN_SET_DEC_POLICY* pInParam, DH_OUT_SET_DEC_POLICY* pOutParam, int nWaitTime = 1000);
CLIENT_API BOOL CALL_METHOD CLIENT_GetDecodePolicy(LLONG lLoginID, const DH_IN_GET_DEC_POLICY* pInParam, DH_OUT_GET_DEC_POLICY* pOutParam, int nWaitTime = 1000);

// Ƶģʽ
CLIENT_API BOOL CALL_METHOD CLIENT_SetSplitAudioOuput(LLONG lLoginID, const DH_IN_SET_AUDIO_OUTPUT* pInParam, DH_OUT_SET_AUDIO_OUTPUT* pOutParam, int nWaitTime = 1000);
CLIENT_API BOOL CALL_METHOD CLIENT_GetSplitAudioOuput(LLONG lLoginID, const DH_IN_GET_AUDIO_OUTPUT* pInParam, DH_OUT_GET_AUDIO_OUTPUT* pOutParam, int nWaitTime = 1000);

// ʾԴ
CLIENT_API BOOL CALL_METHOD CLIENT_MatrixSetCameras(LLONG lLoginID, const DH_IN_MATRIX_SET_CAMERAS* pInParam, DH_OUT_MATRIX_SET_CAMERAS* pOutParam, int nWaitTime = 1000);

// ȡƵ
CLIENT_API BOOL CALL_METHOD CLIENT_GetVideoInCaps(LLONG lLoginID, const DH_IN_GET_VIDEO_IN_CAPS* pInParam, DH_OUT_GET_VIDEO_IN_CAPS* pOutParam, int nWaitTime = 1000);

// ȡƵģʽ
CLIENT_API BOOL CALL_METHOD CLIENT_EnumVideoOutModes(LLONG lLoginID, const DH_IN_ENUM_VIDEO_OUT_MODES* pInParam, DH_OUT_ENUM_VIDEO_OUT_MODES* pOutParam, int nWaitTime = 1000);

// ȡ/ý봰OSDϢ
CLIENT_API BOOL CALL_METHOD CLIENT_GetSplitOSD(LLONG lLoginID, const DH_IN_SPLIT_GET_OSD* pInParam, DH_OUT_SPLIT_GET_OSD* pOutParam, int nWaitTime = 1000);
CLIENT_API BOOL CALL_METHOD CLIENT_SetSplitOSD(LLONG lLoginID, const DH_IN_SPLIT_SET_OSD* pInParam, DH_OUT_SPLIT_SET_OSD* pOutParam, int nWaitTime = 1000);

// ôѲʾԴ
CLIENT_API BOOL CALL_METHOD CLIENT_SetTourSource(LLONG lLoginID, const NET_IN_SET_TOUR_SOURCE* pInParam, NET_OUT_SET_TOUR_SOURCE* pOutParam, int nWaitTime = 1000);
CLIENT_API BOOL CALL_METHOD CLIENT_GetTourSource(LLONG lLoginID, const NET_IN_GET_TOUR_SOURCE* pInParam, NET_OUT_GET_TOUR_SOURCE* pOutParam, int nWaitTime);

// Ѳ״̬
CLIENT_API LLONG CALL_METHOD CLIENT_AttachSplitTour(LLONG lLoginID, const NET_IN_ATTACH_SPLIT_TOUR* pInParam, NET_OUT_ATTACH_SPLIT_TOUR* pOutParam, int nWaitTime);
CLIENT_API BOOL CALL_METHOD CLIENT_DetachSplitTour(LLONG lAttachHandle);

// λл
CLIENT_API BOOL CALL_METHOD CLIENT_MatrixSwitch(LLONG lLoginID, const NET_IN_MATRIX_SWITCH* pInParam, NET_OUT_MATRIX_SWITCH* pOutParam, int nWaitTime);

// ʾԴ, ֧ͬʱö
CLIENT_API BOOL CALL_METHOD CLIENT_SplitSetMultiSource(LLONG lLoginID, const NET_IN_SPLIT_SET_MULTI_SOURCE* pInParam, NET_OUT_SPLIT_SET_MULTI_SOURCE* pOutParam, int nWaitTime);

// Ƶָ
CLIENT_API BOOL CALL_METHOD CLIENT_OperateSplit(LLONG lLoginID, NET_SPLIT_OPERATE_TYPE emType, void* pInParam, void* pOutParam, int nWaitTime);

// ָڲŲ
typedef enum tagNET_PLAYER_OPERATE_TYPE
{
    NET_PLAYER_OPERATE_OPEN,                // 򿪲
    NET_PLAYER_OPERATE_CLOSE,               // رղ
    NET_PLAYER_OPERATE_START,               // ʼ
    NET_PLAYER_OPERATE_STOP,                // ֹͣ
    NET_PLAYER_OPERATE_PAUSE,               // ͣ/ָ
    NET_PLAYER_OPERATE_SEEK_TIME,           // תָʱ䲥
    NET_PLAYER_OPERATE_STEP_FRAME,          // ֡ط, Ҫͣʹ
    NET_PLAYER_OPERATE_GET_STATE,           // ȡǰط״̬
    NET_PLAYER_OPERATE_GET_TIME,            // ȡǰطʱ
    NET_PLAYER_OPERATE_GET_SPEED,           // ȡٶ
    NET_PLAYER_OPERATE_SET_SPEED,           // òٶ
    NET_PLAYER_OPERATE_GET_VOLUME,          // ȡ
    NET_PLAYER_OPERATE_SET_VOLUME,          // 
    NET_PLAYER_OPERATE_GET_PLAYLIST,        // ȡļб
    NET_PLAYER_OPERATE_GET_PLAYLIST_TS,     // ȡǰļбȫʱϢ
}NET_PLAYER_OPERATE_TYPE;

// 
typedef struct tagNET_PLAYER_OPEN_CONDITION 
{
    DWORD               dwSize;
    char                szDevice[DH_DEV_ID_LEN];        // ָԶ˵豸
    int                 nChannel;                       // ͨ
    NET_TIME            stuStartTime;                   // ʼʱ
    NET_TIME            stuEndTime;                     // ʱ
    NET_STREAM_TYPE     emStreamType;                   // 
    int                 nEventNum;                      // ¼͸
    int                 nEvent[MAX_IVS_EVENT_NUM];      // ¼
}NET_PLAYER_OPEN_CONDITION;

// 򿪲, Ӧ NET_PLAYER_OPERATE_OPEN
typedef struct tagNET_IN_PLAYER_OPEN 
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
    const char*         pszDevice;                      // ָӱػԶȡ¼, Ϊnullӱȡ¼
                                                        // ǴԶ豸ȡҪNET_PLAYER_OPEN_CONDITIONszDeviceһ
    NET_PLAYER_OPEN_CONDITION stuCondition;             // ѯ
}NET_IN_PLAYER_OPEN;

// 򿪲, Ӧ NET_PLAYER_OPERATE_OPEN
typedef struct tagNET_OUT_PLAYER_OPEN 
{
    DWORD               dwSize;
}NET_OUT_PLAYER_OPEN;

// رղ, Ӧ NET_PLAYER_OPERATE_CLOSE
typedef struct tagNET_IN_PLAYER_CLOSE
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
}NET_IN_PLAYER_CLOSE;

// رղ, Ӧ NET_PLAYER_OPERATE_CLOSE
typedef struct tagNET_OUT_PLAYER_CLOSE
{
    DWORD               dwSize;
}NET_OUT_PLAYER_CLOSE;

// ʼ, Ӧ NET_PLAYER_OPERATE_START
typedef struct tagNET_IN_PLAYER_START
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
}NET_IN_PLAYER_START;

// ʼ, Ӧ NET_PLAYER_OPERATE_START
typedef struct tagNET_OUT_PLAYER_START
{
    DWORD               dwSize;
}NET_OUT_PLAYER_START;

// ֹͣ, Ӧ NET_PLAYER_OPERATE_STOP
typedef struct tagNET_IN_PLAYER_STOP
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
}NET_IN_PLAYER_STOP;

// ֹͣ, Ӧ NET_PLAYER_OPERATE_STOP
typedef struct tagNET_OUT_PLAYER_STOP
{
    DWORD               dwSize;
}NET_OUT_PLAYER_STOP;

// ͣ/ָ, Ӧ NET_PLAYER_OPERATE_PAUSE
typedef struct tagNET_IN_PLAYER_PAUSE
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
    BOOL                bPause;                         // Ƿͣ, TRUE-ͣ, FALSE-ָ
}NET_IN_PLAYER_PAUSE;

// ͣ/ָ, Ӧ NET_PLAYER_OPERATE_PAUSE
typedef struct tagNET_OUT_PLAYER_PAUSE
{
    DWORD               dwSize;
}NET_OUT_PLAYER_PAUSE;

// תָʱ䲥, Ӧ NET_PLAYER_OPERATE_SEEK_TIME
typedef struct tagNET_IN_PLAYER_SEEK_TIME
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
    NET_TIME            stuTime;                        // תʱ
}NET_IN_PLAYER_SEEK_TIME;

// תָʱ䲥, Ӧ NET_PLAYER_OPERATE_SEEK_TIME
typedef struct tagNET_OUT_PLAYER_SEEK_TIME
{
    DWORD               dwSize;
}NET_OUT_PLAYER_SEEK_TIME;

// ֡, Ӧ NET_PLAYER_OPERATE_STEP_FRAME
typedef struct tagNET_IN_PLAYER_STEP_FRAME
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
    BOOL                bForward;                       // Ƿ, TRUE-, FALSE-
}NET_IN_PLAYER_STEP_FRAME;

// ֡, Ӧ NET_PLAYER_OPERATE_STEP_FRAME
typedef struct tagNET_OUT_PLAYER_STEP_FRAME
{
    DWORD               dwSize;
}NET_OUT_PLAYER_STEP_FRAME;

// ״̬
typedef enum tagNET_PLAYER_STATE 
{
    NET_PLAYER_STATE_UNKNOWN,               // δ֪
    NET_PLAYER_STATE_ERROR,                 // д
    NET_PLAYER_STATE_READING,               // , Կط
    NET_PLAYER_STATE_STANDBY,               // ǰļطֹͣ, ֻܴͷʼ»ط
    NET_PLAYER_STATE_RUNNING,               // 
    NET_PLAYER_STATE_PAUSED,                // ͣ, Դͣط
    NET_PLAYER_STATE_CLOSED,                // ѹر, ޷, openReading״̬ܻط
}NET_PLAYER_STATE;

// ѯ״̬, Ӧ NET_PLAYER_OPERATE_GET_STATE
typedef struct tagNET_IN_PLAYER_GET_STATE
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
}NET_IN_PLAYER_GET_STATE;

// ѯ״̬, Ӧ NET_PLAYER_OPERATE_GET_STATE
typedef struct tagNET_OUT_PLAYER_GET_STATE
{
    DWORD               dwSize;
    NET_PLAYER_STATE    emState;                        // ״̬
}NET_OUT_PLAYER_GET_STATE;

// ȡǰطʱ, Ӧ NET_PLAYER_OPERATE_GET_TIME
typedef struct tagNET_IN_PLAYER_GET_TIME
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
}NET_IN_PLAYER_GET_TIME;

// ȡǰطʱ, Ӧ NET_PLAYER_OPERATE_GET_TIME
typedef struct tagNET_OUT_PLAYER_GET_TIME
{
    DWORD               dwSize;
    NET_TIME            stuTime;                        // ǰʱ
}NET_OUT_PLAYER_GET_TIME;

// ȡٶ, Ӧ NET_PLAYER_OPERATE_GET_SPEED
typedef struct tagNET_IN_PLAYER_GET_SPEED
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
}NET_IN_PLAYER_GET_SPEED;

// ȡٶ, Ӧ NET_PLAYER_OPERATE_GET_SPEED
typedef struct tagNET_OUT_PLAYER_GET_SPEED
{
    DWORD               dwSize;
    float               fSpeed;                         // ٶ, >0򲥷, <0򲥷
                                                        // ֵʾٶ, =1ٶ, >1, <1
}NET_OUT_PLAYER_GET_SPEED;

// òٶ, Ӧ NET_PLAYER_OPERATE_SET_SPEED
typedef struct tagNET_IN_PLAYER_SET_SPEED
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
    float               fSpeed;                         // ٶ, >0򲥷, <0򲥷
                                                        // ֵʾٶ, =1ٶ, >1, <1
}NET_IN_PLAYER_SET_SPEED;

// òٶ, Ӧ NET_PLAYER_OPERATE_SET_SPEED
typedef struct tagNET_OUT_PLAYER_SET_SPPED
{
    DWORD               dwSize;
}NET_OUT_PLAYER_SET_SPEED;

// ȡ, Ӧ NET_PLAYER_OPERATE_GET_VOLUME
typedef struct tagNET_IN_PLAYER_GET_VOLUME
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
}NET_IN_PLAYER_GET_VOLUME;

// ȡ, Ӧ NET_PLAYER_OPERATE_GET_VOLUME
typedef struct tagNET_OUT_PLAYER_GET_VOLUME
{
    DWORD               dwSize;
    int                 nVolume;                        // , 0~100
}NET_OUT_PLAYER_GET_VOLUME;

// ò, Ӧ NET_PLAYER_OPERATE_SET_VOLUME
typedef struct tagNET_IN_PLAYER_SET_VOLUME
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
    int                 nVolume;                        // , 0~100
}NET_IN_PLAYER_SET_VOLUME;

// ò, Ӧ NET_PLAYER_OPERATE_SET_VOLUME
typedef struct tagNET_OUT_PLAYER_SET_VOLUME
{
    DWORD               dwSize;
}NET_OUT_PLAYER_SET_VOLUME;

// бϢ
typedef struct tagNET_PLAYER_PLAYLIST
{
    DWORD               dwSize;
    char                szFilePath[MAX_PATH];           // ļ·, Urlѡһ
    char                szUrl[MAX_PATH];                // URL, FilePathѡһ
    DH_DEVICE_PROTOCOL  emUrlProtocol;                  // URLЭ
    NET_TIME            stuStartTime;                   // ʼʱ
    NET_TIME            stuEndTime;                     // ʱ
}NET_PLAYER_PLAYLIST;

// ȡǰб, Ӧ NET_PLAYER_OPERATE_GET_PLAYLIST
typedef struct tagNET_IN_PLAYER_GET_PLAYLIST
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
    NET_TIME            stuStartTime;                   // ʼʱ
    NET_TIME            stuEndTime;                     // ʱ
    int                 nLimit;                         // ѯļ, 0ʾ
}NET_IN_PLAYER_GET_PLAYLIST;

// ȡǰб, Ӧ NET_PLAYER_OPERATE_GET_PLAYLIST
typedef struct tagNET_OUT_PLAYER_GET_PLAYLIST
{
    DWORD               dwSize;
    NET_PLAYER_PLAYLIST* pstuPlayLists;                 // б, ûڴ
    int                 nMaxPlayListCount;              // 󲥷б, ûд
    int                 nRetPlayListCount;              // زб
}NET_OUT_PLAYER_GET_PLAYLIST;

// ȡǰļбȫʱϢ, Ӧ NET_PLAYER_OPERATE_GET_PLAYLIST_TS
typedef struct tagNET_IN_PLAYER_GET_PLAYLIST_TS
{
    DWORD               dwSize;
    LLONG               lPlayerID;                      // ʵID
}NET_IN_PLAYER_GET_PLAYLIST_TS;

typedef struct tagNET_PLAYLIST_TIMESECTION
{
    DWORD               dwSize;
    int                 nEvent;                         // ¼¼, Ŀǰ
                                                        // EVENT_ALARM_COMMON, EVENT_ALARM_VIDEOBLIND, EVENT_ALARM_VIDEOLOSS, 
                                                        // EVENT_ALARM_MOTIONDETECT, EVENT_ALARM_LOCALALARM
    LPDH_TSECT          pstuTSs;                        // ʱϢ
    DWORD               unMaxTS;                        // ʱ
    DWORD               unRetTS;                        // ʵʷصʱθ
}NET_PLAYLIST_TIMESECTION;

// ȡǰļбȫʱϢ, Ӧ NET_PLAYER_OPERATE_GET_PLAYLIST_TS
typedef struct tagNET_OUT_PLAYER_GET_PLAYLIST_TS
{
    DWORD                    dwSize;
    DWORD                    dwEventNum;                // ¼
    NET_PLAYLIST_TIMESECTION stuTS[MAX_IVS_EVENT_NUM];  // ǰطбʱϢ
}NET_OUT_PLAYER_GET_PLAYLIST_TS;

// ָڲŲ
CLIENT_API BOOL CALL_METHOD CLIENT_OperateSplitPlayer(LLONG lLoginID, NET_PLAYER_OPERATE_TYPE emType, void* pInParam, void* pOutParam, int nWaitTime);

//////////////////////////////////// ǽ //////////////////////////////////////

// Դ
CLIENT_API BOOL CALL_METHOD CLIENT_PowerControl(LLONG lLoginID, const DH_IN_WM_POWER_CTRL* pInParam, DH_OUT_WM_POWER_CTRL* pOutParam, int nWaitTime = 1000);

// ȡ/ʾģʽ
CLIENT_API BOOL CALL_METHOD CLIENT_SetDisplayMode(LLONG lLoginID, const DH_IN_WM_SET_DISPLAY_MODE* pInParam, DH_OUT_WM_SET_DISPLAY_MODE* pOutParam, int nWaitTime = 1000);
CLIENT_API BOOL CALL_METHOD CLIENT_GetDisplayMode(LLONG lLoginID, const DH_IN_WM_GET_DISPLAY_MODE* pInParam, DH_OUT_WM_GET_DISPLAY_MODE* pOutParam, int nWaitTime = 1000);

// /Ԥ
CLIENT_API BOOL CALL_METHOD CLIENT_LoadMonitorWallCollection(LLONG lLoginID, const DH_IN_WM_LOAD_COLLECTION* pInParam, DH_OUT_WM_LOAD_COLLECTION* pOutParam, int nWaitTime = 1000);
CLIENT_API BOOL CALL_METHOD CLIENT_SaveMonitorWallCollection(LLONG lLoginID, const DH_IN_WM_SAVE_COLLECTION* pInParam, DH_OUT_WM_SAVE_COLLECTION* pOutParam, int nWaitTime = 1000);

// ȡǽԤ
CLIENT_API BOOL CALL_METHOD CLIENT_GetMonitorWallCollections(LLONG lLoginID, const DH_IN_WM_GET_COLLECTIONS* pInParam, DH_OUT_WM_GET_COLLECTIONS* pOutParam, int nWaitTime = 1000);

// ǽԤ
CLIENT_API BOOL CALL_METHOD CLIENT_RenameMonitorWallCollection(LLONG lLoginID, const DH_IN_WM_RENAME_COLLECTION* pInParam, DH_OUT_WM_RENAME_COLLECTION* pOutParam, int nWaitTime = 1000);

// ȡ/õǽ
CLIENT_API BOOL CALL_METHOD CLIENT_MonitorWallGetScene(LLONG lLoginID, const DH_IN_MONITORWALL_GET_SCENE* pInParam, DH_OUT_MONITORWALL_GET_SCENE* pOutParam, int nWaitTime = 1000);
CLIENT_API BOOL CALL_METHOD CLIENT_MonitorWallSetScene(LLONG lLoginID, const DH_IN_MONITORWALL_SET_SCENE* pInParam, DH_OUT_MONITORWALL_SET_SCENE* pOutParam, int nWaitTime = 1000);

// ȡǽʾԪ
CLIENT_API BOOL CALL_METHOD CLIENT_MonitorWallGetAttributeCaps(LLONG lLoginID, const DH_IN_MONITORWALL_GET_ARRT_CAPS* pInParam, DH_OUT_MONITORWALL_GET_ARRT_CAPS* pOutParam, int nWaitTime = 1000);

// ǽʾԪԶ
CLIENT_API BOOL CALL_METHOD CLIENT_MonitorWallAutoAdjust(LLONG lLoginID, const DH_IN_MONITORWALL_AUTO_ADJUST* pInParam, DH_OUT_MONITORWALL_AUTO_ADJUST* pOutParam, int nWaitTime = 1000);

// õǽʾԪ
CLIENT_API BOOL CALL_METHOD CLIENT_MonitorWallSetAttribute(LLONG lLoginID, const DH_IN_MONITORWALL_SET_ATTR* pInParam, DH_OUT_MONITORWALL_SET_ATTR* pOutParam, int nWaitTime = 1000);

// ñģʽ
CLIENT_API BOOL CALL_METHOD CLIENT_MonitorWallSetBackLight(LLONG lLoginID, const DH_IN_MONITORWALL_SET_BACK_LIGHT* pInParam, DH_OUT_MONITORWALL_SET_BACK_LIGHT* pOutParam, int nWaitTime = 1000);

// ѯ/Ļؼƻ
CLIENT_API BOOL CALL_METHOD CLIENT_MonitorWallGetPowerSchedule(LLONG lLoginID, const NET_IN_MW_GET_POWER_SCHEDULE* pInParam, NET_OUT_MW_GET_POWER_SCHEDULE* pOutParam, int nWaitTime);
CLIENT_API BOOL CALL_METHOD CLIENT_MonitorWallSetPowerSchedule(LLONG lLoginID, const NET_IN_MW_SET_POWER_SCHEDULE* pInParam, NET_OUT_MW_SET_POWER_SCHEDULE* pOutParam, int nWaitTime);

// ѯ/ĻƲ
CLIENT_API BOOL CALL_METHOD CLIENT_MonitorWallGetScrnCtrlParam(LLONG lLoginID, const NET_IN_MW_GET_SCRN_CTRL_PARAM* pInParam, NET_OUT_MW_GET_SCRN_CTRL_PARAM* pOutParam, int nWaitTime);
CLIENT_API BOOL CALL_METHOD CLIENT_MonitorWallSetScrnCtrlParam(LLONG lLoginID, const NET_IN_MW_SET_SCRN_CTRL_PARAM* pInParam, NET_OUT_MW_SET_SCRN_CTRL_PARAM* pOutParam, int nWaitTime);

// ѯ/Ļʹڱɫ
CLIENT_API BOOL CALL_METHOD CLIENT_MonitorWallGetBackgroudColor(LLONG lLoginID, const NET_IN_MW_GET_BACKGROUDND_COLOR* pInParam, NET_OUT_MW_GET_BACKGROUDND_COLOR* pOutParam, int nWaitTime);
CLIENT_API BOOL CALL_METHOD CLIENT_MonitorWallSetBackgroudColor(LLONG lLoginID, const NET_IN_MW_SET_BACKGROUD_COLOR* pInParam, NET_OUT_MW_SET_BACKGROUD_COLOR* pOutParam, int nWaitTime);

// ԤѲ״̬
CLIENT_API LLONG CALL_METHOD CLIENT_MonitorWallAttachTour(LLONG lLoginID, const NET_IN_WM_ATTACH_TOUR* pInParam, NET_OUT_WM_ATTACH_TOUR* pOutParam, int nWaitTime);
CLIENT_API BOOL CALL_METHOD CLIENT_MonitorWallDetachTour(LLONG lAttachHandle);

// ǽ
CLIENT_API BOOL CALL_METHOD CLIENT_OperateMonitorWall(LLONG lLoginID, NET_MONITORWALL_OPERATE_TYPE emType, void* pInParam, void* pOutParam, int nWaitTime);

///////////////////////////////// ֯Ŀ¼ /////////////////////////////////////////

// ֯Ŀ¼-ӽڵ
CLIENT_API BOOL CALL_METHOD CLIENT_OrganizationAddNodes(LLONG lLoginID, const DH_IN_ORGANIZATION_ADD_NODES* pInParam, DH_OUT_ORGANIZATION_ADD_NODES* pOutParam, int nWaitTime = 1000);

// ֯Ŀ¼-ɾڵ
CLIENT_API BOOL CALL_METHOD CLIENT_OrganizationDeleteNodes(LLONG lLoginID, const DH_IN_ORGANIZATION_DELETE_NODES* pInParam, DH_OUT_ORGANIZATION_DELETE_NODES* pOutParam, int nWaitTime = 1000);

// ֯Ŀ¼-ȡڵϢ
CLIENT_API BOOL CALL_METHOD CLIENT_OrganizationGetNodes(LLONG lLoginID, const DH_IN_ORGANIZATION_GET_NODES* pInParam, DH_OUT_ORGANIZATION_GET_NODES* pOutParam, int nWaitTime = 1000);

// ֯Ŀ¼-ýڵ
CLIENT_API BOOL CALL_METHOD CLIENT_OrganizationSetNode(LLONG lLoginID, const DH_IN_ORGANIZATION_SET_NODE* pInParam, DH_OUT_ORGANIZATION_SET_NODE* pOutParam, int nWaitTime = 1000);


//////////////////////////////// ץ /////////////////////////////////

// ʼץ
CLIENT_API LLONG CALL_METHOD CLIENT_StartSniffer(LLONG lLoginID, const DH_IN_START_SNIFFER* pInParam, DH_OUT_START_SNIFFER* pOutParam, int nWaitTime = 1000);

// ֹͣץ
CLIENT_API BOOL CALL_METHOD CLIENT_StopSniffer(LLONG lLoginID, LLONG lSnifferID);

// ȡץ״̬
CLIENT_API BOOL CALL_METHOD CLIENT_GetSnifferInfo(LLONG lLoginID, const DH_IN_GET_SNIFFER_INFO* pInParam, DH_OUT_GET_SNIFFER_INFO* pOutParam, int nWaitTime = 1000);

//////////////////////////////// ſؽӿ /////////////////////////////////

//ץȡJPEGͼ
CLIENT_API BOOL CALL_METHOD  CLIENT_GetPicJPEG(LLONG lPlayHandle, BYTE* pJpegBuf, DWORD dwBufSize,DWORD *pJpegSize,int quality);


//////////////////////////////// Զļ /////////////////////////////////

// ½ļ
CLIENT_API BOOL CALL_METHOD CLIENT_CreateRemoteFile(LLONG lLoginID, const DH_IN_CREATE_REMOTE_FILE* pInParam, DH_OUT_CREATE_REMOTE_FILE* pOutParam, int nWaitTime = 1000);

// ɾļĿ¼
CLIENT_API BOOL CALL_METHOD CLIENT_RemoveRemoteFiles(LLONG lLoginID, const DH_IN_REMOVE_REMOTE_FILES* pInParam, DH_OUT_REMOVE_REMOTE_FILES* pOutParam, int nWaitTime = 1000);

// 
CLIENT_API BOOL CALL_METHOD CLIENT_RenameRemoteFile(LLONG lLoginID, const DH_IN_RENAME_REMOTE_FILE* pInParam, DH_OUT_RENAME_REMOTE_FILE* pOutParam, int nWaitTime = 1000);

// ʾĿ¼ļĿ¼
CLIENT_API BOOL CALL_METHOD CLIENT_ListRemoteFile(LLONG lLoginID, const DH_IN_LIST_REMOTE_FILE* pInParam, DH_OUT_LIST_REMOTE_FILE* pOutParam, int nWaitTime = 1000);

// ͬļϴ, ֻСļ
CLIENT_API BOOL CALL_METHOD CLIENT_UploadRemoteFile(LLONG lLoginID, const DH_IN_UPLOAD_REMOTE_FILE* pInParam, DH_OUT_UPLOAD_REMOTE_FILE* pOutParam, int nWaitTime = 1000);

// ԶͶ, 豸˲Ƶļ
CLIENT_API BOOL CALL_METHOD CLIENT_PlayAudioFile(LLONG lLoginID, const NET_IN_PLAY_AUDIO_FILE* pInParam, NET_OUT_PLAY_AUDIO_FILE* pOutParam, int nWaitTime = 1000);

// ļ, ֻСļ
CLIENT_API BOOL CALL_METHOD CLIENT_DownloadRemoteFile(LLONG lLoginID, const DH_IN_DOWNLOAD_REMOTE_FILE* pInParam, DH_OUT_DOWNLOAD_REMOTE_FILE* pOutParam, int nWaitTime = 1000);

// ָļ
CLIENT_API BOOL CALL_METHOD CLIENT_SetFileAttribute(LLONG lLoginID, const DH_IN_SET_FILEATTRIBUTE* pInParam, DH_OUT_SET_FILEATTRIBUTE* pOutParam, int nWaitTime = 1000);

////////////////////////////////// 洢豸 ////////////////////////////////////////

// ȡISCSI Targetб, pInParam == NULLȡtargets
CLIENT_API BOOL CALL_METHOD    CLIENT_GetISCSITargets(LLONG lLoginID, const DH_IN_ISCSI_TARGETS* pInParam, DH_OUT_ISCSI_TARGETS* pOutParam, int nWaitTime = 1000);

CLIENT_API BOOL CALL_METHOD CLIENT_GetBitmap(LLONG lLoginID , const DH_IN_BITMAP* pInParam, DH_OUT_BITMAP* pOutParam, int nWaitTime = 1000);

// ȡ洢豸б
CLIENT_API BOOL CALL_METHOD    CLIENT_GetStorageDeviceNames(LLONG lLoginID, DH_STORAGE_DEVICE_NAME* pstuNames, int nMaxCount, int* pnRetCount, int nWaitTime = 1000);

// ȡ洢豸Ϣ
CLIENT_API BOOL CALL_METHOD    CLIENT_GetStorageDeviceInfo(LLONG lLoginID, const char* pszDevName, DH_STORAGE_DEVICE* pDevice, int nWaitTime = 1000);

// ¼ļϢ
CLIENT_API LLONG CALL_METHOD CLIENT_AttachRecordInfo(LLONG lLoginID, const NET_IN_ATTACH_RECORD_INFO* pInParam, NET_OUT_ATTACH_RECORD_INFO* pOutParam, int nWaitTime = 1000);

// ȡ¼ļϢlAttachHandleCLIENT_AttachRecordInfoķֵ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachRecordInfo(LLONG lAttachHandle);

// дԶ̴洢Ϣ״̬
CLIENT_API LLONG CALL_METHOD CLIENT_NetStorageAttachWriteInfo(LLONG lLoginID, const NET_IN_STORAGE_ATTACH_WRITE_INFO* pInParam, NET_OUT_STORAGE_ATTACH_WRITE_INFO* pOutParam, int nWaitTime);

// ȡдԶ豸ϢlAttachHandleCLIENT_NetStorageAttachWriteInfoķֵ
CLIENT_API BOOL CALL_METHOD CLIENT_NetStorageDetachWriteInfo(LLONG lAttachHandle);

// ѯԶ̴洢дϢ״̬
CLIENT_API BOOL CALL_METHOD CLIENT_NetStorageGetWriteInfo(LLONG lLoginID, const NET_IN_STORAGE_GET_WRITE_INFO* pInParam, NET_OUT_STORAGE_GET_WRITE_INFO* pOutParam, int nWaitTime);

// RAID, ͬͶӦͬĽṹ
CLIENT_API BOOL CALL_METHOD CLIENT_OperateRaid(LLONG lLoginID, NET_RAID_OPERATE_TYPE emType, void* pInBuf, void* pOutBuf, int nWaitTime);

/////////////////////////////////// 豸 ///////////////////////////////////////

// ƵԴ
CLIENT_API BOOL CALL_METHOD CLIENT_MatrixSearch(LLONG lLoginID, const DH_IN_MATRIX_SEARCH* pInParam, DH_OUT_MATRIX_SEARCH* pOutParam, int nWaitTime = 1000);

// ȡб
CLIENT_API BOOL CALL_METHOD CLIENT_GetMatrixTree(LLONG lLoginID, const DH_IN_GET_MATRIX_TREE* pInParam, DH_OUT_GET_MATRIX_TREE* pOutParam, int nWaitTime = 1000);

// ȡϼ豸бϢ
CLIENT_API BOOL CALL_METHOD CLIENT_GetSuperiorMatrixList(LLONG lLoginID, const DH_IN_GET_SUPERIOR_MATRIX_LIST* pInParam, DH_OUT_GET_SUPERIOR_MATRIX_LIST* pOutParam, int nWaitTime = 1000);

/************************************************************************/
/*                            ¼񱸷ݻش								*/
/************************************************************************/

// ʼ¼񱸷ݻָ
CLIENT_API LLONG CALL_METHOD CLIENT_StartRecordBackupRestore(LLONG lLoginID);

// ֹͣ¼񱸷ݻָ
CLIENT_API void CALL_METHOD CLIENT_StopRecordBackupRestore(LLONG lRestoreID);

// ¼񱸷ݻָ
CLIENT_API BOOL CALL_METHOD CLIENT_AddRecordBackupRestoreTask(LLONG lRestoreID, const DH_IN_ADD_REC_BAK_RST_TASK* pInParam, int nWaitTime = 1000);

// ɾ¼񱸷ݻָ
CLIENT_API BOOL CALL_METHOD CLIENT_RemoveRecordBackupRestoreTask(LLONG lRestoreID, const DH_IN_REMOVE_REC_BAK_RST_TASK* pInParam, int nWaitTime = 1000);

// ȡ¼񱸷ݻָϢ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryRecordBackupRestoreTask(LLONG lRestoreID, const DH_IN_QUERY_REC_BAK_RST_TASK* pInParam, DH_OUT_QUERY_REC_BAK_RST_TASK* pOutParam, int nWaitTime = 1000);

//////////////////////////////// Encode Manager  ////////////////////////////////
// ˾¼лȡƻ
CLIENT_API BOOL CALL_METHOD CLIENT_GetEncodePlan(LLONG lLoginID, const DH_IN_GET_ENCODE_PLAN* pInParam, DH_OUT_GET_ENCODE_PLAN* pOutParam, int nWaitTime = 1000);

/************************************************************************/
/*                           ݿ¼ز                         */
/************************************************************************/
// ѯѯ¼
CLIENT_API BOOL CALL_METHOD CLIENT_FindRecord(LLONG lLoginID, NET_IN_FIND_RECORD_PARAM* pInParam, NET_OUT_FIND_RECORD_PARAM* pOutParam, int waittime=1000);    

// Ҽ¼:nFilecount:Ҫѯ, ֵΪýļ ֵ<nFilecountӦʱڵļѯ
CLIENT_API int CALL_METHOD CLIENT_FindNextRecord(NET_IN_FIND_NEXT_RECORD_PARAM* pInParam, NET_OUT_FIND_NEXT_RECORD_PARAM* pOutParam, int waittime=1000);

// Ҽ¼
CLIENT_API BOOL CALL_METHOD CLIENT_QueryRecordCount(NET_IN_QUEYT_RECORD_COUNT_PARAM* pInParam, NET_OUT_QUEYT_RECORD_COUNT_PARAM* pOutParam, int waittime=1000);

// ¼
CLIENT_API BOOL CALL_METHOD CLIENT_FindRecordClose(LLONG lFindHandle);

/************************************************************************/
/*                            ̨Ԫݽӿڶ						    */
/************************************************************************/
// ̨Ԫݽӿ
CLIENT_API LLONG CALL_METHOD CLIENT_AttachPTZStatusProc(LLONG lLoginID, NET_IN_PTZ_STATUS_PROC *pstuInPtzStatusProc,  NET_OUT_PTZ_STATUS_PROC *pstuOutPtzStatusProc, int nWaitTime = 3000);

// ֹ̨ͣԪݽӿڣlAttachHandleCLIENT_AttachPTZStatusProcֵ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachPTZStatusProc(LLONG lAttachHandle);

/************************************************************************/
/*                            ̨							    */
/************************************************************************/
// ̨
CLIENT_API LLONG CALL_METHOD CLIENT_AttachViewRangeState(LLONG lLoginID, NET_IN_VIEW_RANGE_STATE *pstuInViewRange, NET_OUT_VIEW_RANGE_STATE *pstuOutViewRange, int nWaitTime = 3000);

// ֹ̨ͣlAttachHandleCLIENT_AttachViewRangeStateֵ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachViewRangeState(LLONG lAttachHandle);

/************************************************************************/
/*                            BUS                                   */
/************************************************************************/
// Bus״̬
CLIENT_API LLONG CALL_METHOD CLIENT_AttachBusState(LLONG lLoginID, NET_IN_BUS_ATTACH *pstuInBus, NET_OUT_BUS_ATTACH *pstuOutBus, int nWaitTime = 3000);

// ֹͣBus״̬lAttachHandleCLIENT_AttachBusStateֵ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachBusState(LLONG lAttachHandle);

/************************************************************************/
/*                            ģͨݶ					    */
/************************************************************************/

// ģͨ
CLIENT_API LLONG CALL_METHOD CLIENT_AttachAnalogAlarmData(LLONG lLoginID, const NET_IN_ANALOGALARM_DATA* pInParam, NET_OUT_ANALOGALARM_DATA* pOutParam, int nWaitTime);

// ֹͣģͨ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachAnalogAlarmData(LLONG lAttachHandle);

/************************************************************************/
/*                            ¼ӿڶ                           */
/************************************************************************/

// ļ¼ӿ
CLIENT_API LLONG CALL_METHOD CLIENT_AttachRecordUpdater(LLONG lLoginID, const NET_IN_RECORDUPDATER_DATA* pInParam, NET_OUT_RECORDUPDATER_DATA* pOutParam, int nWaitTime);

// ֹͣļ¼ӿ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachRecordUpdater(LLONG lAttachHandle);

///////////////////////////////汾ӿ///////////////////////////////
// ־
CLIENT_API BOOL CALL_METHOD CLIENT_LogOpen(LOG_SET_PRINT_INFO *pstLogPrintInfo);

// ر־
CLIENT_API BOOL CALL_METHOD CLIENT_LogClose();

// ѯ豸־--չ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryLogEx(LLONG lLoginID, DH_LOG_QUERY_TYPE logType, char *pLogBuffer, int maxlen, int *nLogBufferlen, void* reserved, int waittime=3000);

// ʼѯ־(Ŀǰֻ֧ŽBSCϵ)
CLIENT_API LLONG CALL_METHOD CLIENT_StartQueryLog(LLONG lLoginID, const NET_IN_START_QUERYLOG* pInParam, NET_OUT_START_QUERYLOG* pOutParam, int nWaitTime);

// ȡ־(Ŀǰֻ֧ŽBSCϵ)
CLIENT_API BOOL CALL_METHOD CLIENT_QueryNextLog(LLONG lLogID, NET_IN_QUERYNEXTLOG* pInParam, NET_OUT_QUERYNEXTLOG* pOutParam, int nWaitTime);

// ѯ־(Ŀǰֻ֧ŽBSCϵ)
CLIENT_API BOOL CALL_METHOD CLIENT_StopQueryLog(LLONG lLogID);

// עضܣ
CLIENT_API LONG CALL_METHOD CLIENT_ControlConnectServer(LLONG lLoginID, char* RegServerIP, WORD RegServerPort, int TimeOut=3000);

// ע
CLIENT_API BOOL CALL_METHOD CLIENT_ControlRegisterServer(LLONG lLoginID, LONG ConnectionID, int waittime=1000);

// Ͽ
CLIENT_API BOOL CALL_METHOD CLIENT_ControlDisconnectRegServer(LLONG lLoginID, LONG ConnectionID);

// ѯ豸עϢ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryControlRegServerInfo(LLONG lLoginID, LPDEV_SERVER_AUTOREGISTER lpRegServerInfo, int waittime=2000);

// ļϴӿ
CLIENT_API LLONG CALL_METHOD CLIENT_FileTransmit(LLONG lLoginID, int nTransType, char* szInBuf, int nInBufLen, fTransFileCallBack cbTransFile, LDWORD dwUserData, int waittime);

// webϢϴӿ
CLIENT_API BOOL  CALL_METHOD CLIENT_TransmitInfoForWeb(LLONG lLoginID, char* szInBuffer, DWORD dwInBufferSize, char* szOutBuffer, DWORD dwOutBufferSize, void* pExtData, int waittime=500);

// ˮӡ, *nResult = 0-ʾǰͼƬδ޸ *nResult = 1-ʾǰͼƬѱ޸
CLIENT_API BOOL  CALL_METHOD CLIENT_WatermarkVerifyForPicture(char* szFilePath, int* nResult, void* pReserved);

// ͨϴ򿪼
CLIENT_API BOOL  CALL_METHOD CLIENT_MultiRealPlay(LLONG lLoginID, DHDEV_IN_MULTIPLAY_PARAM* pInBuf, int nInBufLen, DHDEV_OUT_MULTIPLAY_PARAM* pOutBuf, int nOutBufLen, int* pRetLen);
 
// ֹͨͣ
CLIENT_API BOOL  CALL_METHOD CLIENT_StopMultiRealPlay(LLONG* lRealHandles, int nNumOfHandles);

// ûطŵYUVݻصӿڣhwndΪʱЧ
CLIENT_API BOOL CALL_METHOD CLIENT_SetPlaybackYUVCallBack(LLONG lPlayHandle, fYUVDataCallBack cYUVData, LDWORD dwUser);

// webȡ
CLIENT_API BOOL CALL_METHOD CLIENT_GetNewDevConfigForWeb(LLONG lLoginID, char* szCommand, int nChannelID, char* szOutBuffer, DWORD dwOutBufferSize, int *error, int waittime=500);

// web
CLIENT_API BOOL CALL_METHOD CLIENT_SetNewDevConfigForWeb(LLONG lLoginID, char* szCommand, int nChannelID, char* szInBuffer, DWORD dwInBufferSize, int *error, int *restart, int waittime=500);

// ˿ӳ
CLIENT_API int CALL_METHOD CLIENT_CreateOneTunnel(LOSN_IN_CREATE_TUNNEL_PARAM pInParam, LOSN_OUT_CREATE_TUNNEL_PARAM pOutParam, int waittime=1000);

// ɾ˿ӳ
CLIENT_API int CALL_METHOD CLIENT_DestroyOneTunnel(LOSN_IN_DESTROY_TUNNEL_PARAM pInParam);

// òŲԲֻʵʱЧ
CLIENT_API BOOL CALL_METHOD CLIENT_SetPlayMethod(LLONG lRealHandle, int nStartTime, int nSlowTime, int nFastTime, int nFailedTime);

// ر豸ע
CLIENT_API BOOL CALL_METHOD CLIENT_CloseRegConnect(LLONG lHandle, char *pIp, WORD wPort, void *pParam);

// ļط-ʹ
typedef struct tagNET_IN_PLAYBACK_BYFILE_PROXY 
{
    DWORD                   dwSize;
    LPNET_RECORDFILE_INFO   lpRecordFile;                   // ¼ļϢ
    HWND                    hWnd;                           // ھ
    fDownLoadPosCallBack    cbDownLoadPos;                  // طŽȻص
    LDWORD                  dwPosUser;                      // Ȼصû
    fDataCallBack           fDownLoadDataCallBack;          // طݻص
    LDWORD                  dwDataUser;                     // ݻصû
    char                    szDstIP[DH_COMMON_STRING_128];  // 豸IP
}NET_IN_PLAYBACK_BYFILE_PROXY;

// ļط-ʹ
typedef struct tagNET_OUT_PLAYBACK_BYFILE_PROXY 
{
    DWORD                   dwSize;
}NET_OUT_PLAYBACK_BYFILE_PROXY;

// ʱط-ʹ
typedef struct tagNET_IN_PLAYBACK_BYTIME_PROXY 
{
    DWORD                   dwSize;
    int                     nChannelID;                     // ͨ
    LPNET_TIME              lpStartTime;                    // ʼʱ
    LPNET_TIME              lpStopTime;                     // ʱ
    HWND                    hWnd;                           // ھ
    fDownLoadPosCallBack    cbDownLoadPos;                  // طŽȻص
    LDWORD                  dwPosUser;                      // Ȼصû
    fDataCallBack           fDownLoadDataCallBack;          // طݻص
    LDWORD                  dwDataUser;                     // ݻصû
    char                    szDstIP[DH_COMMON_STRING_128];  // 豸IP
}NET_IN_PLAYBACK_BYTIME_PROXY;

// ʱط-ʹ
typedef struct tagNET_OUT_PLAYBACK_BYTIME_PROXY 
{
    DWORD                   dwSize;
}NET_OUT_PLAYBACK_BYTIME_PROXY;

// ļʽط--豸IP,ʹ
CLIENT_API LLONG CALL_METHOD CLIENT_PlayBackByRecordFileProxy(LLONG lLoginID, NET_IN_PLAYBACK_BYFILE_PROXY* pInParam, NET_OUT_PLAYBACK_BYFILE_PROXY* pOutParam);

// ʱ䷽ʽط--豸IP,ʹ
CLIENT_API LLONG CALL_METHOD CLIENT_PlayBackByTimeProxy(LLONG lLoginID, NET_IN_PLAYBACK_BYTIME_PROXY* pInParam, NET_OUT_PLAYBACK_BYTIME_PROXY* pOutParam);

//////ϺBUS//////

#ifdef SHANGHAIBUS
// ݽӿ,첽ȡ
CLIENT_API LLONG CALL_METHOD CLIENT_ExChangeData(LLONG lLoginId, NET_IN_EXCHANGEDATA* pInParam, NET_OUT_EXCHANGEDATA* pOutParam, int nWaittime = 5000);

// CAN
CLIENT_API LLONG CALL_METHOD CLIENT_AttachCAN(LLONG lLoginID, const NET_IN_ATTACH_CAN* pstInParam, NET_OUT_ATTACH_CAN* pstOutParam, int nWaitTime = 3000);

// ȡCANݣlAttachHandleCLIENT_AttachCANֵ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachCAN(LLONG lAttachHandle);

// CAN
CLIENT_API BOOL CALL_METHOD CLIENT_SendCAN(LLONG lLoginID, const NET_IN_SEND_CAN* pstInParam, NET_OUT_SEND_CAN* pstOutParam, int nWaitTime = 3000);

// ͸
CLIENT_API LLONG CALL_METHOD CLIENT_AttachDevComm(LLONG lLoginID, const NET_IN_ATTACH_DEVCOMM* pstInParam, NET_OUT_ATTACH_DEVCOMM* pstOutParam, int nWaitTime = 3000);

// ȡ͸ݣlAttachHandleCLIENT_AttachDevCommֵ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachDevComm(LLONG lAttachHandle);

#endif

// RPCѯ
CLIENT_API BOOL CALL_METHOD CLIENT_QueryRpcMethod(LLONG lLoginID, const char* pszMethod, BOOL* pResult, int nWaitTime);

// 鹫·CLIENT_CheckBusLine()
typedef struct tagNET_IN_CHECK_BUS_LINE 
{
    DWORD           dwSize;
    char            szLineID[DH_COMMON_STRING_32];          // ·ʾ
    char            szDesignation[DH_COMMON_STRING_32];     // ·
    NET_LINE_DIRECTION  emDirection;                        // ·
    int             nSiteCount;                             // ·վ
    char            szDirectionName[DH_COMMON_STRING_32];   // ·
    char            szVersion[DH_COMMON_STRING_32];         // ·汾
}NET_IN_CHECK_BUS_LINE;


// ·ǷҪ״̬
typedef enum tagNET_BUS_LINE_UPDATE_TYPE
{
    NET_BUS_LINE_UPDATE_UNKNOWN = 0,
    NET_BUS_LINE_UPDATE_UPDATED,                            // Ҫ
    NET_BUS_LINE_UPDATE_NOT_UPDATED,                        // Ҫ
}NET_BUS_LINE_UPDATE_TYPE;

// 鹫·CLIENT_CheckBusLine()
typedef struct tagNET_OUT_CHECK_BUS_LINE
{
    DWORD           dwSize;
    char            szDeviceID[DH_COMMON_STRING_32];        // 豸ID
    char            szLineID[DH_COMMON_STRING_32];          // ·ʾ
    NET_BUS_LINE_UPDATE_TYPE emUpdate;                      // ǷҪ״ָ̬ʾ
}NET_OUT_CHECK_BUS_LINE;

// 鹫·
CLIENT_API BOOL CALL_METHOD CLIENT_CheckBusLine(LLONG lLoginID, const NET_IN_CHECK_BUS_LINE* pstInParam, NET_OUT_CHECK_BUS_LINE* pstOutParam, int nWaitTime = 5000);

//////////////////////////////////////////////////////////////////////////

#define MAX_SITE_GPS_POINT_NUM                      64      // һվGPS

// վ״
typedef enum tagNET_SITE_AREA_TYPE
{
    NET_SITE_AREA_ENCLOSURE = 0,                            // Χ
    NET_SITE_AREA_CIRCLE,                                   // Բ
}NET_SITE_AREA_TYPE;

// վϢ
typedef struct tagNET_BUS_SITE_INFO
{
    DWORD           dwSize;
    char            szLineID[DH_COMMON_STRING_32];          // ·ʾ
    int             nSiteCount;                             // ·վ
    NET_LINE_DIRECTION  emDirection;                        // ·
    int             nStopSequence;                          // վ
    char            szSiteID[DH_COMMON_STRING_32];          // վID
    char            szSiteName[DH_COMMON_STRING_32];        // վ
    NET_SITE_AREA_TYPE emAreaType;                          // վ
    int             nGPSPointNum;                           // ЧGPS
    GPS_POINT       stuPoint[MAX_SITE_GPS_POINT_NUM];       // վGPSϢ
    int             nRadius;                                // վ뾶, λ: , ԲվЧ
    int             nSpeedLimit;                            // վ, λ: km/H
    int             nDriveTime;                             // վվʱ, λ:
    int             nTicketPrice;                           // Ʊ
    DH_TSECT        stuPowerSchedule[DH_TSCHE_DAY_NUM][DH_TSCHE_SEC_NUM]; // ʱ, һάԪرʾ~ͽڼ
    char            szDesignation[DH_COMMON_STRING_64];     // ·
    char            szDirectionName[DH_COMMON_STRING_64];   // ·
    char            szVersion[DH_COMMON_STRING_32];
}NET_BUS_SITE_INFO;

#define MAX_BUS_STOP_NUM                            32      // һ·վĿ

// ··CLIENT_DispatchBusLineInfo()ӿ
typedef struct tagNET_IN_DISPATCH_BUS_LINE_INFO 
{
    DWORD           dwSize;
    int             nBusStopNum;                            // ·վ
    NET_BUS_SITE_INFO   stuStopInfo[MAX_BUS_STOP_NUM];      // ·Ϣ
}NET_IN_DISPATCH_BUS_LINE_INFO;

// ··CLIENT_DispatchBusLineInfo()ӿ
typedef struct tagNET_OUT_DISPATCH_BUS_LINE_INFO 
{
    DWORD           dwSize;
}NET_OUT_DISPATCH_BUS_LINE_INFO;

// ··Ϣ
CLIENT_API BOOL CALL_METHOD CLIENT_DispatchBusLineInfo(LLONG lLoginID, const NET_IN_DISPATCH_BUS_LINE_INFO* pstInParam, NET_OUT_DISPATCH_BUS_LINE_INFO* pstOutParam, int nWaitTime = 5000);


//////////////////////////////////////////////////////////////////////////

// ӪCLIENT_BusSchedule()ӿ
typedef struct tagNET_IN_BUS_SCHEDULE_INFO 
{
    DWORD               dwSize;
    char                szLineID[DH_COMMON_STRING_64];      // Ӫ·ʶ
    NET_LINE_DIRECTION  emDirection;                        // Ӫ·
    NET_TIME_EX         stuStartTime;                       // ʱ
}NET_IN_BUS_SCHEDULE_INFO;

// ӪCLIENT_BusSchedule()ӿ
typedef struct tagNET_OUT_BUS_SCHEDULE_INFO 
{
    DWORD           dwSize;
}NET_OUT_BUS_SCHEDULE_INFO;

// Ӫ
CLIENT_API BOOL CALL_METHOD CLIENT_BusSchedule(LLONG lLoginID, const NET_IN_BUS_SCHEDULE_INFO* pstInParam, NET_OUT_BUS_SCHEDULE_INFO* pstOutParam, int nWaitTime = 5000);

//////////////////////////////////////////////////////////////////////////

// ķ
typedef enum tagNET_MISSION_FEEDBACK_TYPE
{
    NET_MISSION_FEEDBACK_NO = 0,                        // Ҫ
    NET_MISSION_FEEDBACK_YES,                           // ҪԷ ԷӦظDH_ALARM_MISSION_CONFIRMȷ¼
}NET_MISSION_FEEDBACK_TYPE;

// Ϣ()
typedef enum tagNET_MISSION_MESSAGE_TYPE
{
    NET_MISSION_MESSAGE_TEXT = 0 ,      //ıϢ 
    NET_MISSION_MESSAGE_AD ,            //Ϣ
    NET_MISSION_MESSAGE_BROAD ,         //㲥Ϣ
    NET_MISSION_MESSAGE_DRIVER ,        //˾Ϣ
    NET_MISSION_MESSAGE_DISPATCH ,      //ָ
    NET_MISSION_MESSAGE_TRANSPARENT ,   //͸      
    NET_MISSION_MESSAGE_MAX  ,
}NET_MISSION_MESSAGE_TYPE;

// CLIENT_AddMission()ӿ
typedef struct tagNET_IN_ADD_MISSION 
{
    DWORD           dwSize;
    char            szTitle[DH_COMMON_STRING_256];      // 
    char            szMissionID[DH_COMMON_STRING_256];  // ID
    char            szComment[DH_COMMON_STRING_256];    // ظ
    NET_MISSION_FEEDBACK_TYPE   emFeedBack;             // Ӻ
    NET_MISSION_MESSAGE_TYPE    emMessageType;          // Ϣ
}NET_IN_ADD_MISSION;

// CLIENT_AddMission()ӿ
typedef struct tagNET_OUT_ADD_MISSION 
{
    DWORD           dwSize;
}NET_OUT_ADD_MISSION;

CLIENT_API BOOL CALL_METHOD CLIENT_AddMission(LLONG lLoginID, const NET_IN_ADD_MISSION* pstInParam, NET_OUT_ADD_MISSION* pstOutParam, int nWaitTime = 3000);

// CLIENT_ParkingControlStartFindӿ
typedef struct tagNET_IN_PARKING_CONTROL_START_FIND_PARAM
{
    DWORD                     dwSize;          // ṹС
    BOOL                      bSearchCount;    // ѯ¼ǷЧ
    DWORD                     dwSearchCount;   // ѯ¼, ֵΧ1~100
    BOOL                      bBegin;          // ѯʼʱǷЧ
    NET_TIME                  stuBegin;        // ѯʼʱ
    BOOL                      bEnd;            // ѯʱǷЧ
    NET_TIME                  stuEnd;          // ѯʱ
    BOOL                      bCardType;       // ǷЧ
    NET_ECK_IC_CARD_USER_TYPE emCardType;      // 
    BOOL                      bFlag;           // ǷЧ
    NET_ECK_CAR_PASS_FLAG     emFlag;          // 
} NET_IN_PARKING_CONTROL_START_FIND_PARAM;

// CLIENT_ParkingControlStartFindӿ
typedef struct tagNET_OUT_PARKING_CONTROL_START_FIND_PARAM
{
    DWORD                     dwSize;          // ṹС
    DWORD                     dwTotalCount;    // ϴ˴βѯĽ
} NET_OUT_PARKING_CONTROL_START_FIND_PARAM;

// CLIENT_ParkingControlDoFindӿ
typedef struct tagNET_IN_PARKING_CONTROL_DO_FIND_PARAM
{
    DWORD                     dwSize;          // ṹС
    DWORD                     dwFileCount;     // ǰѯļ¼
} NET_IN_PARKING_CONTROL_DO_FIND_PARAM;

// ¼Ϣ
typedef struct tagNET_CAR_PASS_ITEM
{
    DWORD                      dwSize; 
    NET_TIME                   stuTime;          // ʱ
    DWORD                      dwCardNo;         // 
    NET_ECK_IC_CARD_USER_TYPE  emCardType;       // 
    NET_ECK_CAR_PASS_FLAG      emFlag;           // ¼
} NET_CAR_PASS_ITEM;

// CLIENT_ParkingControlDoFindӿ
typedef struct tagNET_OUT_PARKING_CONTROL_DO_FIND_PARAM
{
    DWORD                     dwSize;          // ṹС
    NET_CAR_PASS_ITEM        *pstuRecordList;  // ¼бûڴ
    int                       nMaxRecordNum;   // б¼
    int                       nRetRecordNum;   // ѯļ¼ѯСѯʱѯ
} NET_OUT_PARKING_CONTROL_DO_FIND_PARAM;

// ʼ¼ѯ
CLIENT_API LLONG CALL_METHOD CLIENT_ParkingControlStartFind(LLONG lLoginID, NET_IN_PARKING_CONTROL_START_FIND_PARAM* pInParam, NET_OUT_PARKING_CONTROL_START_FIND_PARAM* pOutParam, int waittime);

// ȡ¼
CLIENT_API BOOL CALL_METHOD CLIENT_ParkingControlDoFind(LLONG lFindeHandle, NET_IN_PARKING_CONTROL_DO_FIND_PARAM* pInParam, NET_OUT_PARKING_CONTROL_DO_FIND_PARAM* pOutParam, int waittime);

// ¼ѯ
CLIENT_API BOOL CALL_METHOD CLIENT_ParkingControlStopFind(LLONG lFindHandle);

// Ĺ¼ݻصԭ
typedef void (CALLBACK *fParkingControlRecordCallBack)(LLONG lLoginID, LLONG lAttachHandle, NET_CAR_PASS_ITEM *pInfo, int nBufLen, LDWORD dwUser);

// CLIENT_ParkingControlAttachRecord()ӿ
typedef struct tagNET_IN_PARKING_CONTROL_PARAM
{
    DWORD                           dwSize;
    fParkingControlRecordCallBack   cbCallBack;                 // ݻص
    LDWORD                          dwUser;                     // û
} NET_IN_PARKING_CONTROL_PARAM;

// CLIENT_ParkingControlDetachRecord()ӿ
typedef struct tagNET_OUT_PARKING_CONTROL_PARAM
{
    DWORD    dwSize;
} NET_OUT_PARKING_CONTROL_PARAM;

// ¼
CLIENT_API LLONG CALL_METHOD CLIENT_ParkingControlAttachRecord(LLONG lLoginID, const NET_IN_PARKING_CONTROL_PARAM* pInParam, NET_OUT_PARKING_CONTROL_PARAM* pOutParam, int nWaitTime);

// ȡ¼
CLIENT_API BOOL CALL_METHOD CLIENT_ParkingControlDetachRecord(LLONG lAttachHandle);

// ״̬
typedef enum tagNET_CAR_DETECTOR_STATE
{
    NET_CAR_DETECTOR_STATE_UNKNOWN = -1,
    NET_CAR_DETECTOR_STATE_OFFLINE = 0,                   // 
    NET_CAR_DETECTOR_STATE_ONLINE,                        // 
    NET_CAR_DETECTOR_STATE_LOOPOFFLINE,                   // ظȦ
} NET_CAR_DETECTOR_STATE;

// 豸ͨ״̬
typedef enum tagNET_AUXILIARY_DEV_STATE
{
    NET_AUXILIARY_DEV_STATE_UNKNOWN = -1,
    NET_AUXILIARY_DEV_STATE_OFFLINE = 0,                   // 
    NET_AUXILIARY_DEV_STATE_ONLINE,                        // 
} NET_AUXILIARY_DEV_STATE;

// IC
typedef enum tagNET_IC_CARD_STATUS
{
    NET_IC_CARD_STATUS_UNKNOWN = -1,
    NET_IC_CARD_STATUS_NORMAL = 0,                         // 
    NET_IC_CARD_STATUS_NOCARD,                             // ޿
    NET_IC_CARD_STATUS_LOWCARD,                            // ٿ
    NET_IC_CARD_STATUS_FULLCARDS,                          // տ
} NET_IC_CARD_STATUS;

// ¼DH_ALARM_AUXILIARY_DEV_STATE(豸״̬¼)ӦϢ
typedef struct tagALARM_AUXILIARY_DEV_STATE
{
    DWORD                   dwSize;
    NET_CAR_DETECTOR_STATE  emDetector;                   // ״̬
    NET_AUXILIARY_DEV_STATE emLed;                        // LED״̬״̬
    NET_AUXILIARY_DEV_STATE emICDetectBoard;              // ˢ
    NET_AUXILIARY_DEV_STATE emICSenderBoard;              // ˢ
    NET_IC_CARD_STATUS      emICCardStatus;               // IC
} ALARM_AUXILIARY_DEV_STATE;

// ͣˢ
typedef enum tagNET_PARKING_CARD_TYPE
{
    NET_PARKING_CARD_TYPE_UNKNOWN,
    NET_PARKING_CARD_TYPE_SEND,                             // 
    NET_PARKING_CARD_TYPE_DETECT,                           // ˢ
} NET_PARKING_CARD_TYPE;

// ¼DH_ALARM_PARKING_CARD(ͣˢ¼)ӦϢ
typedef struct tagALARM_PARKING_CARD
{
    DWORD                   dwSize;
    NET_PARKING_CARD_TYPE   emType;                       // 
    DWORD                   dwCardNo;                     // 
    char                    szPlate[DH_COMMON_STRING_16]; // 
} ALARM_PARKING_CARD;

// Դ豸
typedef enum tagEM_ALARM_TRANSMIT_DEV_SRC_TYPE
{
    EM_ALARM_TRANSMIT_DEV_SRC_TYPE_UNKNOWN,             // δ֪
    EM_ALARM_TRANSMIT_DEV_SRC_TYPE_DIGIT,               // Digit   
    EM_ALARM_TRANSMIT_DEV_SRC_TYPE_ANALOG,              // Analog ģ
}EM_ALARM_TRANSMIT_DEV_SRC_TYPE;

// ¼(ӦṹALARM_PROFILE_ALARM_TRANSMIT_INFO)
typedef struct tagALARM_PROFILE_ALARM_TRANSMIT_INFO
{
    DWORD                           dwSize;
    int					            nChannelID;								// ͨ
    int					            nAction;								// 0:ʼ 1:ֹͣ
    NET_TIME                        stuTime;                                // ¼ʱ
    NET_SENSE_METHOD                emSenseMethod;                          // 
    char                            szUserID[DH_COMMON_STRING_128];         // û
    EM_ALARM_TRANSMIT_DEV_SRC_TYPE  emDevSrcType;                           // Դ豸 
}ALARM_PROFILE_ALARM_TRANSMIT_INFO;

// λϢ
typedef struct tagNET_SCADA_NOTIFY_POINT_INFO
{
    DWORD                      dwSize; 
    char                       szDevName[DH_COMMON_STRING_64];    // 豸ƣgetInfoȡһ
    EM_NET_SCADA_POINT_TYPE    emPointType;                       // λ
    char                       szPointName[DH_COMMON_STRING_64];  // λλȡֵһ
    float                      fValue;                            // TypeΪYCʱΪ
    int                        nValue;                            // TypeΪYXʱΪ
} NET_SCADA_NOTIFY_POINT_INFO;

// λϢб
typedef struct tagNET_SCADA_NOTIFY_POINT_INFO_LIST
{
    DWORD                           dwSize;
    int                             nList;                        // λϢ
    NET_SCADA_NOTIFY_POINT_INFO     stuList[MAX_SCADA_POINT_LIST_INFO_NUM]; // λϢ
} NET_SCADA_NOTIFY_POINT_INFO_LIST;

// ļλϢصԭ
typedef void (CALLBACK *fSCADAAttachInfoCallBack)(LLONG lLoginID, LLONG lAttachHandle, NET_SCADA_NOTIFY_POINT_INFO_LIST *pInfo, int nBufLen, LDWORD dwUser);

// CLIENT_SCADAAttachInfo()ӿ
typedef struct tagNET_IN_SCADA_ATTACH_INFO
{
    DWORD                           dwSize;
    fSCADAAttachInfoCallBack        cbCallBack;                 // ݻص
    EM_NET_SCADA_POINT_TYPE         emPointType;                // λ
    LDWORD                          dwUser;                     // û
} NET_IN_SCADA_ATTACH_INFO;

// CLIENT_SCADAAttachInfo()ӿ
typedef struct tagNET_OUT_SCADA_ATTACH_INFO
{
    DWORD    dwSize;
} NET_OUT_SCADA_ATTACH_INFO;

// ļλϢ
CLIENT_API LLONG CALL_METHOD CLIENT_SCADAAttachInfo(LLONG lLoginID, const NET_IN_SCADA_ATTACH_INFO* pInParam, NET_OUT_SCADA_ATTACH_INFO* pOutParam, int nWaitTime);

// ȡλϢ
CLIENT_API BOOL CALL_METHOD CLIENT_SCADADetachInfo(LLONG lAttachHandle);

// ߶Ϣӿ
CLIENT_API LLONG CALL_METHOD CLIENT_AttachLowRateWPAN(LLONG lLoginID, const NET_IN_ATTACH_LOWRATEWPAN* pstInParam, NET_OUT_ATTACH_LOWRATEWPAN* pstOutParam, int nWaitTime = 3000);

// ȡ߶ϢӿڣlAttachHandleCLIENT_AttachLowRateWPANֵ
CLIENT_API BOOL CALL_METHOD CLIENT_DetachLowRateWPAN(LLONG lAttachHandle);

//ȡԤʱʾĲſ˿,ԻȡĶ˿رԴ͵Ĳ,Ӱܵʹ
CLIENT_API LONG CALL_METHOD CLIENT_GetRealPlayPort(LLONG lRealPlayHandle);

//ȡطʱʾĲſ˿,,ԻȡĶ˿رԴ͵Ĳ,Ӱܵʹ
CLIENT_API LONG CALL_METHOD  CLIENT_GetPlayBackPort(LLONG lPlayBackHandle);

/////////////////////////////////̭ӿ/////////////////////////////////

// ѯϵͳãýӿ̭ʹCLIENT_GetDevConfig
CLIENT_API BOOL CALL_METHOD CLIENT_QueryConfig(LLONG lLoginID, int nConfigType, char *pConfigbuf, int maxlen, int *nConfigbuflen, int waittime=1000);

// ϵͳãýӿ̭ʹCLIENT_SetDevConfig
CLIENT_API BOOL CALL_METHOD CLIENT_SetupConfig(LLONG lLoginID, int nConfigType, char *pConfigbuf, int nConfigbuflen, int waittime=1000);

// ýӿ̭벻Ҫʹ
CLIENT_API BOOL CALL_METHOD CLIENT_Reset(LLONG lLoginID, BOOL bReset);

// ѯЭ  ýӿ̭ʹCLIENT_GetDevConfig
CLIENT_API BOOL CALL_METHOD CLIENT_QueryComProtocol(LLONG lLoginID, int nProtocolType, char *pProtocolBuffer, int maxlen, int *nProtocollen, int waittime=1000);

// ʼԽýӿ̭ʹCLIENT_StartTalkEx
CLIENT_API BOOL CALL_METHOD CLIENT_StartTalk(LLONG lRealHandle, BOOL bCustomSend=false);

// Խýӿ̭ʹCLIENT_StopTalkEx
CLIENT_API BOOL CALL_METHOD CLIENT_StopTalk(LLONG lRealHandle);

// ԶԽݣýӿ̭ʹCLIENT_TalkSendData
CLIENT_API BOOL CALL_METHOD CLIENT_SendTalkData_Custom(LLONG lRealHandle, char *pBuffer, DWORD dwBufSize);

// ʵʱԤС
CLIENT_API BOOL CALL_METHOD CLIENT_SetPlayerBufNumber(LLONG lRealHandle, DWORD dwBufNum);

// ͨʱļ
CLIENT_API BOOL CALL_METHOD CLIENT_GetFileByTime(LLONG lLoginID, int nChannelID, LPNET_TIME lpStartTime, LPNET_TIME lpStopTime, char *sSavedFileName);

// طſ
CLIENT_API BOOL CALL_METHOD CLIENT_PlayBackControl(LLONG lPlayHandle, DWORD dwControlCode, DWORD dwInValue, DWORD *lpOutValue);

// ѯ豸״̬ ýӿ̭ʹCLIENT_QueryDevState
CLIENT_API BOOL CALL_METHOD CLIENT_GetDEVWorkState(LLONG lLoginID, LPNET_DEV_WORKSTATE lpWorkState, int waittime=1000);

// 첽ѯ豸־
CLIENT_API BOOL CALL_METHOD CLIENT_QueryLogCallback(LLONG lLoginID, fLogDataCallBack cbLogData, LDWORD dwUser);


#ifdef __cplusplus
}
#endif
#endif // DHNETSDK_H





